 /*$Log: arth.c,v $
  *Revision 1.7  1997/05/21 13:55:31  yawei
  *added WIN32 binary fopen()
  *
  *Revision 1.6  1997/04/15 00:13:13  yawei
  *changed prototype
  *
  *Revision 1.5  1997/03/08 17:05:16  yawei
  *Swaped CVIP_YES and CVIP_NO
  *
  *Revision 1.4  1997/03/08 00:57:13  yawei
  *Name Changes:
  *	BOOLEAN ==> CVIP_BOOLEAN
  *	FALSE ==> CVIP_NO
  *	TRUE ==> CVIP_YES
  *	BYTE ==> CVIP_BYTE
  *	SHORT ==> CVIP_SHORT
  *	INTEGER ==> CVIP_INTEGER
  *	FLOAT ==> CVIP_FLOAT
  *	DOUBLE ==> CVIP_DOUBLE
  *	TYPE ==> CVIP_TYPE
  *
  *Revision 1.3  1997/01/15 17:16:03  yawei
  *Global Change:  IMAGE ==> Image
  *
 * Revision 1.2  1995/12/07  22:52:45  kluo
 * this file contain unsuccessful implementation of arthmetic compression. The main problem is that this algorithm doesn't write
 * every information to disk file. So next time a restarted executable
 * cannot decode the file. Even in the same executable, it cannot
 * do it all right, leaving only a few lines decoded, the rest blank.
 * We decide to not to use this implementation.
 **/ 

   
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>   
#include "CVIParith.h"				/* for image format struct definitions 
						   CVIP functions */

 /* start of function declaration */

void  Image_encode();
void  Image_decode();
void  comp_ratio();
void  build_model( FILE *input, FILE *output );
void  scale_counts( unsigned long counts[], unsigned char scaled_counts[] );
void  build_totals( unsigned char scaled_counts[] );
void  count_bytes( FILE *input, unsigned long counts[] );
void  output_counts( FILE *output, unsigned char scaled_counts[] );
void  input_counts( FILE *stream );
void  convert_int_to_symbol( int symbol, SYMBOL *s );
void  get_symbol_scale( SYMBOL *s );
int   convert_symbol_to_int( int count, SYMBOL *s );
void  initialize_arithmetic_encoder( void );
void  encode_symbol( BIT_FILE *stream, SYMBOL *s );
void  flush_arithmetic_encoder( BIT_FILE *stream );
short int get_current_count( SYMBOL *s );
void  initialize_arithmetic_decoder( BIT_FILE *stream ); void  remove_symbol_from_stream( BIT_FILE *stream, SYMBOL *s );
void  CompressFile( FILE *input, BIT_FILE *output);
void  ExpandFile( BIT_FILE *input, FILE *output);

 /* end of function declaration */

  
void ArithCode_Setup() 
{
    int option;

    while(CVIP_YES)						/* start of while - loop */
    {  
       printf("\n\t\t\t  ARITHMETIC COMPRESSION\n\n");
       printf("\t\t\t1.   Arithmetic Encoding\n");
       printf("\t\t\t2.   Arithmetic Decoding\n");
       printf("\t\t\t3.   Compute Compression Ratio\n");
       printf("\t\t\tYour Option please : ");
       scanf("%d",&option);
       switch(option)
       {  
           case 1 :  Image_encode();			
	    	     return;
           case 2 :  Image_decode();		
       		     return;
           case 3 :  comp_ratio();			
       	             return;
           default:  printf("Invalid Option.\n");
		     break;
       }
    }							/* end of while - loop */
}	/* end of main */




/*
  This routine requests the operator for the Image file name to be compressed and
  finds the number of rows, columns and bands of the input image. The outine displays
  the input image by invoking "xv". Calls the Compressfile to compress the original
  image and stores the compressed image in a new file which has the original file 
  name with a ".c" extension. Calcultes the time taken for compressing (though it also 
  depends on the processor speed & machine load) and displays the compression time.  
*/

void Image_encode()
{ 
  BIT_FILE  *out_f;
  FILE      *in_f, *temp;
  char      infile[MAXSIZE];
  int       x, y, i, j, bands;
  time_t    s_time, e_time;    
  
  printf("\nEnter the Image File Name to be Compressed : ");
  fflush(stdin); 
  scanf("%s",infile);
  printf("\n");
  format = CVIPgetformat(infile);
  input_Image = CVIPreadimage(infile, format, 1);	/* for processing */
  in_Image = CVIPreadimage(infile, format, 1);		/* for displaying */
  CVIPwriteimage(in_Image, infile, CVIP_NO, CVIP_NO, format, 1);
  cvip_display( infile, format );  			/* display the input image */
  image_free(in_Image);     
  rows = input_Image->image_ptr[0]->rows;		/* calculate the no. of rows */
  cols = input_Image->image_ptr[0]->cols; 		/* calculate the no. of columns */
  bands = getNoOfBands_Image(input_Image);		/* calculate the no. of bands */
  image_array = (byte**) input_Image->image_ptr[0]->rptr;  
  temp = fopen("temporary","w+b");			/* open a file with write+binary */
  for(y = 0; y<rows; y++)
    for(x = 0; x<cols; x++)
      putc(image_array[y][x], temp);
  fclose(temp);
  in_f = fopen("temporary", "rb");
  if(in_f == NULL)
    exit(0);  
  strcat(infile, ".c\0"); 				/* to store the compressed file */
  printf("\nThe COMPRESSED Image will be stored in the File : %s\n\n ",infile);    
  out_f = OpenOutputBitFile(infile);
  if(out_f == NULL)
     exit(1);
  puts("\n\t\tPlease Wait, Compressing !!! \n");
  s_time = time(NULL); 					/* start time of compression */
  CompressFile(in_f, out_f);			        /* calls the File compression fn */
  e_time = time(NULL);					/* end time of compression */
  printf("\n\n\t\tEncoding time is : %.2f Seconds\n", difftime(e_time,s_time));  
  CloseOutputBitFile(out_f);
  fclose(in_f);
  remove("temporary");
}	/* end of Image_encode */


/*
  This routine calls the Expandfile to decode the compressed image file and stores the 
  decompressed image in a new file which has the original file name with a ".d" 
  extension. Displays the decompressed file, calcultes the time taken for decompressing 
  (though it depends on the processor speed of the machine) and displays it.  
*/

void Image_decode()
{  
  BIT_FILE  *input; 
  FILE      *output; 
  char      infile[MAXSIZE];
  char      rename[MAXSIZE];
  int       x, y;
  time_t    s_time, e_time;    
  
  printf("\nEnter the ORIGINAL Image File name (i.e., without  \".c\" extension): ");
  fflush(stdin); 
  scanf("%s", infile);
  strcpy(rename, infile);
  strcat(infile,".c\0");				/* for the compressed file name */
  printf("\n\t\tReading the COMPRESSED Image File %s  \n\n",infile);
  input = OpenInputBitFile(infile);
  if(input == NULL)
    exit(0); 
  strcat(rename,".d\0");				/* decompressed file name .d ext.*/
  printf("The DECOMPRESSED Image will be Stored in the File : %s\n\n",rename);
  output = fopen(rename, "wb");
  if(output == NULL)
    exit(1);
  printf("\n\t\tPlease Wait, Decompressing  !!!\n");
  s_time = time(NULL); 					/* start time - decompression */ 
  ExpandFile(input, output);				/* decompress the compressed file */
  e_time = time(NULL);					/* end time - decompression */
  printf("\n\n\t\tDecoding time is : %.2f Seconds\n\n",difftime(e_time,s_time));  
  CloseInputBitFile(input);
  fclose(output);
  output = fopen(rename, "rb");
  if(output == NULL)
    exit(1);
  for(y = 0; y < rows; y++)
    for(x = 0; x < cols; x++)
      image_array[y][x] = getc(output);
  CVIPwriteimage(input_Image, rename, CVIP_NO, CVIP_NO, format, 1);
  cvip_display( rename, format );			/* display the decompressed file */
  image_free(input_Image);  

}	/* end of Image_decode */


/*
  This routine calculates the compression ratio. Requests the operator for the 
  original image file name. For the compressed file appends the .c extension. 
  Calcultes the no. of bytes in both the original and the compressed file and
  finds the ratio. 
*/
void comp_ratio()
{
  FILE  *fptr1,  *fptr2;           /* pointers to the original and compressed images */
  int   count1 = 0, count2 = 0;    /* initialize the counter to 0 */
  
  char filename1[80];		   /* char array to store the original file name */
  printf("\nEnter the name of original image : ");
  scanf("%s", filename1);
 
  #ifndef WIN32
  if((fptr1 = fopen(filename1,"r")) == NULL) /* open the original file for reading */
  #else
  if((fptr1 = fopen(filename1,"rb")) == NULL) /* open the original file for reading */
  #endif
  {
     printf("Can't open file %s.",filename1); 
     exit(1);
  }
  while(getc(fptr1) != EOF)
     count1++;                    /* count the number of bytes in the original file */
  fclose(fptr1);
  printf("\nFile %s contains %d characters.\n", filename1, count1);
  
  strcat(filename1,".c");
  #ifndef WIN32
  if((fptr2 = fopen(filename1,"r")) == NULL)   /* open the compressed file for reading */
  #else
  if((fptr2 = fopen(filename1,"rb")) == NULL)   /* open the compressed file for reading */
  #endif
   {
     printf("Can't open file %s.",filename1); 
     exit(2);
  }
  while(getc(fptr2) != EOF)
     count2++;                   /* count the number of bytes in the compressed file */
  fclose(fptr2);
  printf("File %s contains %d characters.\n", filename1, count2);
  printf("\n\t\tCOMPRESSION RATIO  =  %.4f\n",(float) count1/ (float)count2);
}	/* end of comp_ratio */



/*
  The CompressFile function first gathers statistics, and initializes the arithmetic
  encoder.  It then encodes all the characters in the file, followed by the EOF character. 
  The output stream is then flushed. Note that an extra two bytes are output.  While 
  decoding an arithmetic stream extra bits are read. The decoding process takes
  place in the msb of the low and high range ints, so while decoding the last bit 
  at least 15 junk bits loaded into the registers.  The extra two bytes account for that.
*/
  
void CompressFile( input, output )
FILE     *input;
BIT_FILE *output;
{
    int    c;
    SYMBOL s;

    build_model( input, output->file );			/* initialize the model */
    initialize_arithmetic_encoder();			/* initialize the encoder */	
    while ((c = getc(input)) != EOF )			/* encode the image */
    {   
	convert_int_to_symbol( c, &s );
	encode_symbol( output, &s );
    }
    convert_int_to_symbol( END_OF_STREAM, &s );		/* mark of EOF */
    encode_symbol( output, &s );
    flush_arithmetic_encoder( output );			/* flushing */
    OutputBits( output, 0L, 16 );
}	/* end of CompressFile */


/*
  The ExpandFile routine initializes the decoder, then enters into a loop to read
  the characters. When END_OF_STREAM is detected this routine closes the file and
  exits. Decoding a single character is a three step process:  First the scale for 
  the current symbol is obtained, then the current input values is checked to find 
  whether it falls in that range and finally for a match the total array is checked. 
*/

void ExpandFile( input, output )
BIT_FILE *input;
FILE     *output;
{
    SYMBOL s;
    int    c, count;

    input_counts( input->file );
    initialize_arithmetic_decoder( input );		/* intialize the decoder */
    for ( ; ; )
    {
	get_symbol_scale( &s );				/* scale for the current symbol */
	count = get_current_count( &s );
	c = convert_symbol_to_int( count, &s );
 	if ( c == END_OF_STREAM )			/* check for END_OF_STREAM */
            break;
	remove_symbol_from_stream( input, &s );		/* remove the symbol from decoder */
        putc( (char) c, output );
    }
}	/* end of ExpandFile */


/* 
  The build_model calls four sub-routines 1. scans the input file, 2. scale the counts,
  3. build the totals array, then 4. output the scaled counts to the output file.
*/

void build_model( input, output )
FILE *input, *output;
{
    unsigned long counts[ 256 ];
    unsigned char scaled_counts[ 256 ];

    count_bytes( input, counts );
    scale_counts( counts, scaled_counts );
    output_counts( output, scaled_counts );
    build_totals( scaled_counts );
}	/* end of build_model */


/* 
  This routine runs through the file and counts the appearances of each character.
*/
  
#ifndef SEEK_SET
#define SEEK_SET 0
#endif

void count_bytes( input, counts )
FILE *input;
unsigned long counts[];
{
    long input_marker;
    int i, c;
 
    for ( i = 0 ; i < 256 ; i++ )
        counts[ i ] = 0;
    input_marker = ftell( input );
    while (( c = getc( input )) != EOF)
	counts[ c ]++;
    fseek( input, input_marker, SEEK_SET );
}	/* end of count_bytes */


/*
  This routine is called to scale the counts down.  There are two types of scaling 
  that must be done.  First, the counts need to be scaled down so that the individual
  counts fit into a single unsigned char. Then, the counts need to be rescaled so 
  that the total of all counts is less than 16384.
*/
  
void scale_counts( counts, scaled_counts )
unsigned long counts[];
unsigned char scaled_counts[];
{
    int i;
    unsigned long max_count, scale;
    unsigned int total;
 

    /* The first section of code makes sure each count fits into a single byte. */
 
    max_count = 0;
    for ( i = 0 ; i < 256 ; i++ )
       if ( counts[ i ] > max_count )
	   max_count = counts[ i ];
    scale = max_count / 256;
    scale = scale + 1;
    for ( i = 0 ; i < 256 ; i++ )
    {
        scaled_counts[ i ] = (unsigned char ) ( counts[ i ] / scale );
        if ( scaled_counts[ i ] == 0 && counts[ i ] != 0 )
            scaled_counts[ i ] = 1;
    }

   /* This next section makes sure the total is less than 16384.  I initialize
      the total to 1 instead of 0 because there will be an additional 1 added
      in for the END_OF_STREAM symbol.*/
  
    total = 1;
    for ( i = 0 ; i < 256 ; i++ )
        total += scaled_counts[ i ];
    if ( total > ( 32767 - 256 ) )
        scale = 4;
    else if ( total > 16383 )
        scale = 2;
    else
        return;
    for ( i = 0 ; i < 256 ; i++ )
        scaled_counts[ i ] /= scale;
}	/* end of scaled_counts */


/* 
  This routine builds the table of cumulative totals. Which is used by both the 
  encoder and decoder. The counts for the characters in the file are in the counts array. 
*/
  
void build_totals( scaled_counts )
unsigned char scaled_counts[];
{
    int i;
    totals[ 0 ] = 0;				/* initialize */
    for ( i = 0 ; i < END_OF_STREAM ; i++ )
       totals[ i + 1 ] = totals[ i ] + scaled_counts[ i ];
    totals[ TOTAL_CHARS  ] = totals[ END_OF_STREAM ] + 1;
}	/* end of build_totals */

/* 
  In order for the compressor to build the same model, the symbol counts are stored
  in the compressed file so that the expander can read them in.   
 
  For efficient memory usage, symbols are stored conditionally, i.e in a specified 
  format. But this results in a complicated routine in the whole program. A routine
  that just writes out 256 values without attempting to optimize would be much
  simpler, but would hurt compression quite a bit on small files.
*/
  
void output_counts( output, scaled_counts )
FILE *output;
unsigned char scaled_counts[];
{

  unsigned char temp[259];
  int           i, j, k, l, count, q, z, count2 = 0;
  int           flag = 1;

  for(z = 255; scaled_counts[z] == 0; z--)
     count2++;
     count2 = 255 - count2;
  for(j = 0; j <= 258; j++)
     temp[j] = 0;
  j = 0;
 
 count = 0;

  for(i = 0; i <= count2; i++)
  {
    if (scaled_counts[i] != 0 && i ==0)
    {
      temp[j] = scaled_counts[i];
      while(scaled_counts[i+1] != 0 )
      { 
         i = i+1; j = j+1;
         temp[j] =scaled_counts[i] ;
      }
    }
    else 
    {   /*start1*/
      if(scaled_counts[i] == 0)
      {
	 if((scaled_counts[i-1] != 0) && (flag ==1) && (scaled_counts[0] != 0))
         {
	    flag = 0 ; j = j+1;
         }
	 temp[j] = 0;
         count++;
	 temp[j+1] = count;
      }
      else
      {
         if(scaled_counts[i])
	 {
            j = j+1;
	    temp[j+1] = scaled_counts[i];
	    j = j+1;
	    count =0;
	    while(scaled_counts[i+1] != 0)
	    {   
               i = i+1; j = j+1;
               temp[j] = scaled_counts[i];
	    }
	    j = j+1;
	 }
      }
    }    /*end1*/
 }  
 for(l=0; l < j; l++)
    putc(temp[l], output);
 putc(0,output);
 putc(0,output);  
} 	/* end of output_counts */



/* 
  This routine is called during. While expanding, the same set of counts is read. 
  This is quite a bit easier that the process of writing them out, since no decision 
  making needs to be done.   
*/

void input_counts( input )
FILE *input;
{
  unsigned char scaled_counts[256];
  int           i, n = 0, p, number, zeroes;
   
  for(p=0; p<256; p++)
  scaled_counts[p]= 0; 
  for(; ;)
  {
    number = getc(input);
    if(number == 0 && ((zeroes = getc(input)) == 0))
       break ;
    else if(number == 0)
    {
      for(zeroes; zeroes > 0; zeroes--)
      {
         scaled_counts[n] = 0;
         n++;
      }
    }
    else if(number > 0 )
    {
 	scaled_counts[n] = number;
 	n++;
    }	 
  }
  build_totals(scaled_counts);
}	/* end of input_counts */

/* 
  Everything down from here defines the arithmetic coder section of the program.
*/


/* 
  These four variables define the current state of the arithmetic
  coder/decoder.  They are assumed to be 16 bits long. 
*/
  
static unsigned short int code;      /* The present input code value  */
static unsigned short int low;       /*Start of the current code range */   
static unsigned short int left_pt ;
static unsigned short int high;      /*End of the current code range */     
static unsigned short int right_pt ;
long   width;

long underflow_bits;                 /* Number of underflow bits pending   */


 
/* 
  This routine is called to initialize the encoding process. The high register is 
  initialized to all 1s, and it is assumed that it has an infinite string of 1s to
  be shifted into the lower bit positions when needed.
*/
  
void initialize_arithmetic_encoder()
{
    low = 0;
    left_pt = 0;
    high = 0xffff;
    right_pt = 0xffff ;
    width = 0xffff + 1;
    underflow_bits = 0;
}	/* end of initialize_arithmetic_encoder */


 
/* 
  This routine flushes the encoder. At the end of the encoding process, there are still 
  significant bits left in the high and low registers.  This routine output two bits,
  plus as many underflow bits as are necessary.
*/
  
void flush_arithmetic_encoder( stream )
BIT_FILE *stream;
{
    OutputBit( stream, low & 0x4000 );
    underflow_bits++;
    while ( underflow_bits-- > 0 )
        OutputBit( stream, ~low & 0x4000 );
}	/* end of flush_arithmetic_encoder */


/*
  This routine converts int to symbol. Finding the low count, high count, and scale 
  for a symbol is really easy, because of the way the totals are stored.  
*/
  
void convert_int_to_symbol( c, s )
int    c;
SYMBOL *s;
{
     s->scale = totals[ TOTAL_CHARS ];
     s->low_count = totals[ c ];
     s->high_count = totals[ c + 1 ];
 
}	/* end of convert_int_to_symbol */


/* 
  This routine gets the scale for the current context.
*/
 
void get_symbol_scale( s )
SYMBOL *s;
{
    s->scale = totals[ TOTAL_CHARS ];
}	/* end of get_symbol_scale */


/* 
  This routine does the reverse of convert_int_to_symbol. During decompression, until
  the "count" parameter is encountered, search through the table is done. When it is 
  found, it is returned. The reason for also setting the high count and low count is
  so that symbol can be properly removed from the arithmetic coded input.
*/
  
int convert_symbol_to_int( count, s)
int    count;
SYMBOL *s;
{
    int c;

    for (c = END_OF_STREAM ; count < totals[ c ] ; c--)
	;
    s->high_count = totals[ c + 1 ];
    s->low_count = totals[ c ];
    return(c);
}	/* end of convert_symbol_to_int */


/* 
  The encode_symbol routine is called to encode a symbol.  The symbol is passed
  in the SYMBOL structure as a low count, a high count, and a range, instead of the 
  more conventional probability ranges.  The encoding process takes two steps. 
  First, the values of high and low are updated to take into account the range 
  restriction created by the new symbol.  Then, as many bits as possible are shifted 
  out to the output stream.  Finally, high and low are stable again and the routine
  returns.
*/
  
void encode_symbol( stream, s )
BIT_FILE *stream;
SYMBOL   *s;
{   
   unsigned short int a,b;
    
   /* These three lines rescale high and low for the new symbol.*/

   width = (long) (right_pt - left_pt) + 1;
   left_pt = left_pt + (unsigned short int ) (width * (long)s->low_count/ (long) s-> scale);
   width = width * ( (long)s->high_count - (long)s-> low_count)/(long)s->scale; 
   right_pt = (left_pt + (unsigned short int) width) - 1;
 

  /* This loop turns out new bits until high and low are far enough
     apart to have stabilized.*/
   
   for ( ; ; )
   {
      /* If this test passes, it means that the MSDigits match, and can
         be sent to the output stream.*/	
      a = right_pt & 0x8000;
      b = left_pt & 0x8000;

      if (a == b) 
      {
         OutputBit( stream, a );
         while ( underflow_bits > 0 ) 
         {
            OutputBit( stream, ~right_pt & 0x8000 );
            underflow_bits--;
         }
      }

      /* If this test passes, the numbers are in danger of underflow, because
         the MSDigits don't match, and the 2nd digits are just one apart.*/
        
      else if ( (left_pt & 0x4000 ) && !(right_pt & 0x4000) )
      {
         underflow_bits += 1;
         left_pt &= 0x3fff;
         right_pt |= 0x4000;
      }
      else
         return ;
      left_pt <<= 1;
      right_pt <<= 1;
      right_pt |= 1;         
   }
}	/* end of encode_symbol */


/*
  This routine is called while decoding, to figure out which symbol is presently 
  waiting to be decoded.  This routine expects to get the current model scale in
  the s->scale parameter, and it returns a count that corresponds to the present 
  floating point code: code = count / s->scale
*/
  
short int get_current_count( s )
SYMBOL    *s;
{
    long      width;
    short int count;

    width = (long) (right_pt - left_pt) + 1;
    count = (short int) ((long) (((code - left_pt) + 1) * s->scale-1) / width);
    return( count );
}	/* end of get_current_count */


/* 
  This routine is called to initialize the state of the arithmetic decoder. This 
  involves initializing the high and low registers to their conventional starting
  values, plus reading the first 16 bits from the input stream into the code value.
*/
  
void initialize_arithmetic_decoder( stream )
BIT_FILE *stream;
{
    int  i;
    long width;

    code = 0;
    for ( i = 0 ; i < 16 ; i++ )
    {
        code <<= 1;
        code += InputBit( stream );
    }
    left_pt = 0;
    right_pt = 0xffff;
    width = 0xffff + 1;
}	/* end of initialize_arithmetic_decoder */


/* 
  This routine is called to remove the character, once it is decoded. 
*/
  
void remove_symbol_from_stream( stream, s )
BIT_FILE *stream;
SYMBOL   *s;
{
    unsigned short int a, b; 
 
    /* First, the range is expanded to account for the symbol removal. */
    width = (long)(right_pt - left_pt) + 1;	
    left_pt = left_pt + (unsigned short int )(width * (long)s->low_count/(long)s->scale);	         
    width = width * ((long)s->high_count - (long)s->low_count)/(long)s->scale;
    right_pt = (left_pt + (unsigned short int) width) - 1;
 
    for ( ; ; ) 
    {

    /* If the MSDigits match, the bits will be shifted out. */
	 a = right_pt & 0x8000;
	 b = left_pt & 0x8000; 	
         if (a == b) 
         {
         }

    /* Else, shift out the 2nd MSDigit.*/
 
        else if ((left_pt & 0x4000)  && !(right_pt & 0x4000) ) 
        {
            code ^= 0x4000;
            left_pt   &= 0x3fff;
            right_pt  |= 0x4000;
        }
        else
 
    /* Otherwise, nothing can be shifted out, return.*/
        return;
        left_pt <<= 1;
        right_pt <<= 1;
        right_pt |= 1;
        code <<= 1;
        code += InputBit( stream );
    }
}	/* end of remove_symbol_from_stream */



/* end of arith.c */






#define PACIFIER_COUNT 2047
/*#define DEBUG*/

BIT_FILE *OpenOutputBitFile( name )
char *name;
{
    BIT_FILE *bit_file;

    bit_file = (BIT_FILE *) calloc( 1, sizeof( BIT_FILE ) );
    if ( bit_file == NULL )
        return( bit_file );
    bit_file->file = fopen( name, "wb" );
    bit_file->rack = 0;
    bit_file->mask = 0x80;
    bit_file->pacifier_counter = 0;
    return( bit_file );
}

BIT_FILE *OpenInputBitFile( name )
char *name;
{
    BIT_FILE *bit_file;

    bit_file = (BIT_FILE *) calloc( 1, sizeof( BIT_FILE ) );
    if ( bit_file == NULL )
	return( bit_file );
    bit_file->file = fopen( name, "rb" );
    bit_file->rack = 0;
    bit_file->mask = 0x80;
    bit_file->pacifier_counter = 0;
    return( bit_file );
}

void CloseOutputBitFile( bit_file )
BIT_FILE *bit_file;
{
    if ( bit_file->mask != 0x80 )
        if ( putc( bit_file->rack, bit_file->file ) != bit_file->rack )
            printf("Fatal error in CloseBitFile!\n" );
    fclose( bit_file->file );
    free( (char *) bit_file );
}

void CloseInputBitFile( bit_file )
BIT_FILE *bit_file;
{
    fclose( bit_file->file );
    free( (char *) bit_file );
}

void OutputBit(BIT_FILE * bit_file, int bit )
{
	{
	#ifdef DEBUG
		printf("buffer is %d \t mask is %d\n",bit_file->rack,(int)bit_file->mask);
    		printf("bit is %d\n",bit);
	#endif
	}
    if ( bit ){
    	{
	#ifdef DEBUG
    		printf("If bit ...\n");
	#endif
	}
        bit_file->rack |= bit_file->mask;
	{
	#ifdef DEBUG
		printf("buffer is %d \n",bit_file->rack);
	#endif
	}
	
	}
    {
    #ifdef DEBUG
    	printf("Shifting mask\n");
    #endif
    }
    bit_file->mask >>= 1;
    {
    #ifdef DEBUG
    	printf("mask is %d\n",(int)bit_file->mask);
    #endif
    }
	

  
    if ( bit_file->mask == 0 ) {
	if ( putc( bit_file->rack, bit_file->file ) != bit_file->rack )
	    printf( "Fatal error in OutputBit!\n" );
	else
        if ( ( bit_file->pacifier_counter++ & PACIFIER_COUNT ) == 0 )
		putc( '.', stdout );
	bit_file->rack = 0;
	bit_file->mask = 0x80;
    }
}

void OutputBits( bit_file, code, count )
BIT_FILE *bit_file;
unsigned long code;
int count;
{
    unsigned long mask;

    mask = 1L << ( count - 1 );
    while ( mask != 0) {
        if ( mask & code )
            bit_file->rack |= bit_file->mask;
        bit_file->mask >>= 1;
        if ( bit_file->mask == 0 ) {
	    if ( putc( bit_file->rack, bit_file->file ) != bit_file->rack )
		printf( "Fatal error in OutputBit!\n" );
        else if ( ( bit_file->pacifier_counter++ & PACIFIER_COUNT ) == 0 )
		putc( '.', stdout );
	    bit_file->rack = 0;
            bit_file->mask = 0x80;
        }
        mask >>= 1;
    }
}

int InputBit( bit_file )
BIT_FILE *bit_file;
{
    int value;

    if ( bit_file->mask == 0x80 ) {
        bit_file->rack = getc( bit_file->file );
        if ( bit_file->rack == EOF )
            printf( "Fatal error in InputBit!\n" );
    if ( ( bit_file->pacifier_counter++ & PACIFIER_COUNT ) == 0 )
	    putc( '.', stdout );
    }
    value = bit_file->rack & bit_file->mask;
    bit_file->mask >>= 1;
    if ( bit_file->mask == 0 )
	bit_file->mask = 0x80;
    return( value ? 1 : 0 );
}

unsigned long InputBits( bit_file, bit_count )
BIT_FILE *bit_file;
int bit_count;
{
    unsigned long mask;
    unsigned long return_value;

    mask = 1L << ( bit_count - 1 );
    return_value = 0;
    while ( mask != 0) {
	if ( bit_file->mask == 0x80 ) {
	    bit_file->rack = getc( bit_file->file );
	    if ( bit_file->rack == EOF )
		printf( "Fatal error in InputBit!\n" );
        if ( ( bit_file->pacifier_counter++ & PACIFIER_COUNT ) == 0 )
		putc( '.', stdout );
	}
	if ( bit_file->rack & bit_file->mask )
            return_value |= mask;
        mask >>= 1;
        bit_file->mask >>= 1;
        if ( bit_file->mask == 0 )
            bit_file->mask = 0x80;
    }
    return( return_value );
}

void FilePrintBinary( file, code, bits )
FILE *file;
unsigned int code;
int bits;
{
    unsigned int mask;

    mask = 1 << ( bits - 1 );
    while ( mask != 0 ) {
        if ( code & mask )
            fputc( '1', file );
        else
            fputc( '0', file );
        mask >>= 1;
    }
}

/*************************** End of BITIO.C **************************/


