/***************************************************************************
* ======================================================================
* Computer Vision/Image Processing Tool Project - Dr. Scott Umbaugh SIUE
* ======================================================================
*
*             File Name: converter.c
*           Description: this program is used to test out CVIPtools
*			 file conversion utilities
*         Related Files: Imakefile, libconverter.a
*   Initial Coding Date: Sun May 30 22:58:29 CDT 1993
*           Portability: Standard (ANSI) C
*             Credit(s): Gregory Hance
*                        Southern Illinois University @ Edwardsville
*
** Copyright (C) 1993 SIUE - by Gregory Hance.
**
** Permission to use, copy, modify, and distribute this software and its
** documentation for any purpose and without fee is hereby granted, provided
** that the above copyright notice appear in all copies and that both that
** copyright notice and this permission notice appear in supporting
** documentation.  This software is provided "as is" without express or
** implied warranty.
**
* RCS (Revision Control System) Information
* ...Added automatically by RCS 
*
** $Log: converter.c,v $
** Revision 1.6  1997/03/08 17:00:22  yawei
** Swaped CVIP_YES and CVIP_NO
**
** Revision 1.5  1997/03/08 00:43:06  yawei
** Name Changes:
** 	BOOLEAN ==> CVIP_BOOLEAN
** 	FALSE ==> CVIP_YES
** 	TRUE ==> CVIP_NO
** 	BYTE ==> CVIP_BYTE
** 	SHORT ==> CVIP_SHORT
** 	INTEGER ==> CVIP_INTEGER
** 	FLOAT ==> CVIP_FLOAT
** 	DOUBLE ==> CVIP_DOUBLE
** 	TYPE ==> CVIP_TYPE
**
** Revision 1.4  1997/01/16 20:48:13  yawei
** Global Change:  Image_FORMAT ==> IMAGE_FORMAT
**
 * Revision 1.3  1997/01/15  17:07:22  yawei
 * Global Change:  IMAGE ==> Image
 *
 * Revision 1.2  1997/01/15  16:06:49  yawei
 * updated changes
 *
 * Revision 1.1  1993/05/31  07:10:10  hanceg
 * Initial revision
 *
*
****************************************************************************/

 
/* Define Preprocessor statements */
#include "CVIPtoolkit.h"
#include "CVIPconvert.h"

main(argc,argv)
int argc;
char *argv[];
{
/* Declare variables local to main() */
Image *cvipImage;
IMAGE_FORMAT format, newformat;
char command[50], inputfile[50], outputfile[50];
FILE *fd;
const char *usage = "-ccc | -eps | -gif | -itex | -pbm | -pgm | -ppm \n | -ras -tiff | -bin | -vip [infile] [outfile]";

cvip_init( &argc, argv );

if( argc < 2)
   cvip_usage( argv[0], usage );

if ( cvip_keymatch( argv[1], "-ccc", 2 ) )
   newformat = CCC;
else if ( cvip_keymatch( argv[1], "-eps", 2 ) )
   newformat = EPS;
else if ( cvip_keymatch( argv[1], "-gif", 2 ) )
   newformat = GIF;
else if ( cvip_keymatch( argv[1], "-itex", 2 ) )
   newformat = ITX;
else if ( cvip_keymatch( argv[1], "-pbm", 3 ) )
   newformat = PBM;
else if ( cvip_keymatch( argv[1], "-pgm", 3 ) )
   newformat = PGM;
else if ( cvip_keymatch( argv[1], "-ppm", 3 ) )
   newformat = PPM;
else if ( cvip_keymatch( argv[1], "-ras", 2 ) )
   newformat = RAS;
else if ( cvip_keymatch( argv[1], "-tiff", 2 ) )
   newformat = TIF;
else if ( cvip_keymatch( argv[1], "-bin", 2 ) )
   newformat = BIN;
else if ( cvip_keymatch( argv[1], "-vip", 2 ) )
   newformat = VIP;
else
   cvip_usage( argv[0], usage );

if(argc >= 3)
   if ( (argv[2][0] == '-' && argv[2][1] != '\0') || sscanf( argv[2], "%s", inputfile ) != 1 )
      cvip_usage( argv[0], usage );
if(argc == 4) {
   if ( (argv[3][0] == '-' && argv[3][1] != '\0') || sscanf( argv[3], "%s", outputfile ) != 1 )
      cvip_usage( argv[0], usage );
}
else if(argc == 3)
   (void) strcpy(outputfile, "-");
else if(argc ==2) {
   (void) strcpy(inputfile, "-");
   (void) strcpy(outputfile, "-");
}
else 
   cvip_usage( argv[0], usage );

format = CVIPgetformat(inputfile);
cvipImage = CVIPreadimage(inputfile, format, 1);

if(!strcmp(inputfile,"-")) {
   cvipImage->image_format = newformat;
   CVIPwriteimage(cvipImage, outputfile, CVIP_NO, CVIP_NO, newformat, 1);
}
else
   CVIPwriteimage(cvipImage, outputfile, CVIP_NO, CVIP_YES, newformat, 1);

/* image_free(cvipImage); */
exit(0);
} /* End Main */

     
         





   
      
