/***************************************************************************
* ======================================================================
* Computer Vision/ImageRec Processing Tool Project - Dr. Scott Umbaugh SIUE
* ======================================================================
*
*             File Name: cvipImg.h
*           Description: 
*         Related Files: 
*   Initial Coding Date: Tue Nov 28 21:51:23 CST 1995
*           Portability: Standard (ANSI) C
*            References:
*             Author(s): Greg Hance
*                        Southern Illinois University @ Edwardsville
*
** Copyright (C) 1993 SIUE - by Greg Hance.
**
** Permission to use, copy, modify, and distribute this software and its
** documentation for any purpose and without fee is hereby granted, provided
** that the above copyright notice appear in all copies and that both that
** copyright notice and this permission notice appear in supporting
** documentation.  This software is provided "as is" without express or
** implied warranty.
**
* RCS (Revision Control System) Information
* ...Added automatically by RCS 
*
** $Log: cvipImg.h,v $
** Revision 1.3  1996/01/19 21:25:45  kluo
** add another definition of ECMD
**
 * Revision 1.2  1996/01/16  20:32:07  kluo
 * add function declaration and CVIPimage.h include header.
 *
 * Revision 1.1  1996/01/16  16:30:49  kluo
 * Initial revision
 *
*
****************************************************************************/

#ifndef PUBLIC_H
#define PUBLIC_H
#include <CVIPimage.h>

#define CREATE(name, proc) Tcl_CreateCommand(interp, name, proc, (ClientData) NULL, (Tcl_CmdDeleteProc *)NULL)
#define CMD(cmd) static int cmd (ClientData, Tcl_Interp *, int, char **)
#define ECMD(cmd) extern int cmd (ClientData, Tcl_Interp *, int, char **)


/*
** The following structure defines all of the commands in the CvipTcl core,
** and the C procedures that execute them.
*/

typedef struct {
    char *			Name;	/* Name of command. */
    Tcl_CmdProc *	Proc;	/* Procedure that executes command. */
} CmdInfo;

#define USE(x) if(&(x) == NULL)

extern int S_ImageAddToHash(Tcl_Interp *interp, Image* imageP, const char *name);
extern Image *S_ImageGetFromHash(Tcl_Interp *interp, const char *name);
#endif /* PUBLIC_H */



