/***************************************************************************
* ======================================================================
* Computer Vision/ImageRec Processing Tool Project - Dr. Scott Umbaugh SIUE
* ======================================================================
*
*             File Name: cvipUtil.c
*           Description: 
*         Related Files: 
*   Initial Coding Date: Tue Nov 28 21:52:00 CST 1995
*           Portability: Standard (ANSI) C
*            References:
*             Author(s): Greg Hance
*                        Southern Illinois University @ Edwardsville
*
** Copyright (C) 1993 SIUE - by Greg Hance.
**
** Permission to use, copy, modify, and distribute this software and its
** documentation for any purpose and without fee is hereby granted, provided
** that the above copyright notice appear in all copies and that both that
** copyright notice and this permission notice appear in supporting
** documentation.  This software is provided "as is" without express or
** implied warranty.
**
* RCS (Revision Control System) Information
* ...Added automatically by RCS 
*
** $Log: cvipUtil.c,v $
** Revision 1.2  1996/04/02 17:51:45  kluo
** change menu
**
 * Revision 1.1  1996/01/16  16:30:50  kluo
 * Initial revision
 *
*
****************************************************************************/
#include <tcl.h>
#include <stdio.h>
#include <assert.h>

#include "cvipUtil.h"



static char S_StatusBuffer[TCL_RESULT_SIZE];

int Util_AppendCommands(Tcl_Interp *interp, CmdInfo *cmds) {
	
	char *name = (NULL);
	int i = (0);
	int counter=0, pos;
	char space[21];

	memset(space,' ',sizeof(space));
	space[20] = '\0';

	if (NULL == cmds) {
		Tcl_AppendResult(interp, "NULL Command List", NULL);
		return TCL_ERROR;
	}

	while(NULL != (name = cmds[i++].Name)) {
		counter++;
		if(name[0] < 'a'){
			Tcl_AppendResult(interp,"\n\n",name,":\n",NULL);
			counter = 0;
		}
		else if(counter == 4){
			Tcl_AppendResult(interp, name, "\n", NULL);
			counter = 0;
		}
		else{
			pos = strlen(name);
			Tcl_AppendResult(interp, name,&space[pos], NULL);
		}
	}

	return TCL_OK;
}

#if 0

int Util_AppendResultWithStatus(Tcl_Interp *interp, CIcStatus hStatus) {
	assert(interp != NULL);
	Tcl_AppendResult(interp, "\n", NULL);

	if (hStatus == NULL) {
		Tcl_AppendResult(interp, "Illegal Status Object!", NULL);
		return TCL_ERROR;
	}

	CIcStatus_translate(hStatus, TCL_RESULT_SIZE, S_StatusBuffer);
	Tcl_AppendResult(interp, S_StatusBuffer, NULL);
	return TCL_OK;
}

char *Util_GetStatusSummary(CIcStatus hStatus) {

	static char buf[96];  /* Requires minimum 72 currently. */
	char *facility, *severity;
	

	switch (CIcStatus_severity(hStatus)) {
	 case CIC_NULL_SEVERITY:
		severity = "Null";
		break;
	 case CIC_SUCCESS:
		severity = "Success";
		break;
	 case CIC_WARNING:
		severity = "Warning";
		break;
	 case CIC_ERROR:
		severity = "Error";
		break;
	 case CIC_FATAL_ERROR:
		severity = "Fatal Error";
		break;
	 default:
		severity = "Unknown";
	}

	switch (CIcStatus_facility(hStatus)) {
	 case CIC_NULL_FACILITY:
		facility = "Null";
		break;
	 case CIC_CLIENT:
		facility = "Client";
		break;
	 case CIC_IC:
		facility = "InConcert";
		break;
	 case CIC_NETWORK:
		facility = "Network";
		break;
	 case CIC_FILE_SYSTEM:
		facility = "File System";
		break;
	 case CIC_DBMS:
		facility = "Database";
		break;
	 case CIC_OS:
		facility = "Operating System";
		break;
	 case CIC_ADMIN:
		facility = "Admin";
		break;
	 case CIC_GUI:
		facility = "GUI";
		break;
	 case CIC_WINDOW_SYSTEM:
		facility = "Window System";
		break;
	 case CIC_LICENSE:
		facility = "License";
		break;
	 default:
		facility = "Unknown";
	}

	sprintf(buf, "(SEVERITY: %s, FACILITY: %s, CODE: %ld)",
			  severity, facility, CIcStatus_code(hStatus));
	return buf;
}

char *Util_StrOfLong(long l) {
	static char buf[16];

	sprintf(buf, "%ld", l);
	return buf;
}

#endif
