# **********************************************************************
# Computer Vision/Image Processing Tool Project - Dr. Scott Umbaugh SIUE
# **********************************************************************
#
#             File Name: ana_geometry.tcl
#           Description: Geometry module
#         Related Files: 
#   Initial Coding Date: Tue Jun  3 17:38:50 CDT 1997
#           Portability: TCL script file
#            References:
#             Author(s): Yansheng Wei
#                        Southern Illinois University @ Edwardsville
#
## Copyright (C) 1996 SIUE - by Scott Umbaugh and Yansheng Wei.
##
## Permission to use, copy, modify, and distribute this software and its
## documentation for any purpose and without fee is hereby granted, provided
## that the above copyright notice appear in all copies and that both that
## copyright notice and this permission notice appear in supporting
## documentation.  This software is provided "as is" without express or
## implied warranty.
##
# RCS (Revision Control System) Information
# ...Added automatically by RCS 
#
## $Log: ana_geometry.tcl,v $
## Revision 1.8  1997/07/21 17:59:52  yawei
## changed variable name
##
## Revision 1.7  1997/07/02 22:19:57  yawei
## PERFORM color
##
## Revision 1.6  1997/07/02 22:19:13  yawei
## changed PERFORM color
##
## Revision 1.5  1997/07/02 22:18:21  yawei
## checked back changes for wzheng
##
## Revision 1.4  1997/06/19 22:01:50  yawei
## added initial position setup
##
## Revision 1.3  1997/06/16 21:47:59  yawei
## added too missing popup boxes
##
## Revision 1.2  1997/06/09 21:45:21  yawei
## cleaned up
##
## Revision 1.1  1997/06/09 20:10:30  yawei
## Initial revision
##
#
#****************************************************************************
proc geometry { } {

global topwin
global toplevel_position
global GuiColor
global GuiMisc
global analysis

  if [ winfo exists $topwin(analysis_name).info] {
	  set tempname $topwin(analysis_name);\
destroy $topwin(analysis_name).info;\
set topwin(analysis_name) $tempname;}
  if [ winfo exists $topwin(analysis_name).current_image] {
	  set tempname $topwin(analysis_name);\
destroy $topwin(analysis_name).current_image;\
set topwin(analysis_name) $tempname;}
  if [ winfo exists $topwin(analysis_name).perform] {
	  set tempname $topwin(analysis_name);\
destroy $topwin(analysis_name).perform;\
set topwin(analysis_name) $tempname;}
  wm positionfrom $topwin(analysis_name) user
  wm sizefrom $topwin(analysis_name) user

  wm geometry $topwin(analysis_name) $topwin(analysis_geometry)[get_pos $topwin(analysis_name)]
  wm maxsize $topwin(analysis_name) [lindex $topwin(analysis_geometry_max) 0] \
  	[lindex $topwin(analysis_geometry_max) 1]
  wm minsize $topwin(analysis_name) [lindex $topwin(analysis_geometry_min) 0] \
  	[lindex $topwin(analysis_geometry_min) 1]
  wm title $topwin(analysis_name) {ANALYSIS -> Geometry}

  # build widget $topwin(analysis_name).info
  frame $topwin(analysis_name).info  -background "$GuiColor(frame_bg)"  -borderwidth {0}  -relief {flat}

  # build widget $topwin(analysis_name).info.geom
  frame $topwin(analysis_name).info.geom  -background "$GuiColor(frame_bg)"  -borderwidth {2}

  # build widget $topwin(analysis_name).info.geom.crop
  frame $topwin(analysis_name).info.geom.crop  -background "$GuiColor(frame_bg)"  -borderwidth {2}  -relief {ridge}

  # build widget $topwin(analysis_name).info.geom.crop.frame7
  frame $topwin(analysis_name).info.geom.crop.frame7  -background "$GuiColor(frame_bg)"  -borderwidth {2}

  # build widget $topwin(analysis_name).info.geom.crop.frame7.util_radio4
	radiobutton $topwin(analysis_name).info.geom.crop.frame7.util_radio4 -padx {1}\
	-pady {1} -highlightthickness {0}  \
	-activebackground "$GuiColor(btn_act_bg)" -background "$GuiColor(btn_bg)"  \
	-relief {flat}  -text {Crop }  \
	-value {crop}  -variable {analysis(geometry)}

  # build widget $topwin(analysis_name).info.geom.crop.frame7.label0
  label $topwin(analysis_name).info.geom.crop.frame7.label0  -background "$GuiColor(label_bg)"\
  -text {a subimage from the upper left corner at row}

  # build widget $topwin(analysis_name).info.geom.crop.frame7.label1
  label $topwin(analysis_name).info.geom.crop.frame7.label1  -background "$GuiColor(label_bg)"  -text {and column}

  # build widget $topwin(analysis_name).info.geom.crop.frame7.frame1
  frame $topwin(analysis_name).info.geom.crop.frame7.frame1 \
    -borderwidth {2} \
    -highlightthickness {0} \
	 -background "$GuiColor(frame_bg)" \
    -height {30} \
    -width {30}

  # build widget $topwin(analysis_name).info.geom.crop.frame7.frame1.entry
  entry $topwin(analysis_name).info.geom.crop.frame7.frame1.entry \
    -background "$GuiColor(entry_bg)" \
    -foreground "$GuiColor(entry_fg)" \
    -relief {sunken} \
    -textvariable {analysis(crop_ul_row)} \
	 -width {5}
  endEntry $topwin(analysis_name).info.geom.crop.frame7.frame1.entry 1 \
  	$topwin(analysis_name).info.geom.crop.frame7.frame2.entry \
  	$topwin(analysis_name).info.geom.crop.frame8.frame2.entry


  # build widget $topwin(analysis_name).info.geom.crop.frame7.frame1.menubutton7
  menubutton $topwin(analysis_name).info.geom.crop.frame7.frame1.menubutton7 \
	 -activebackground "$GuiColor(btn_act_bg)" -background "$GuiColor(btn_bg)"  \
    -font "$GuiMisc(pop_up_fn)" \
    -relief "$GuiMisc(pop_up_relief)" \
    -padx {1} -pady {1} -highlightthickness {0} \
    -text "$GuiMisc(pop_up_text)" -width {2} 

  # bindings
  bind $topwin(analysis_name).info.geom.crop.frame7.frame1.menubutton7 <Button-1> { MenuPopupPost $topwin(analysis_name).info.geom.crop.frame7.frame1.menubutton7.menu0 %X %Y}
  bind $topwin(analysis_name).info.geom.crop.frame7.frame1.menubutton7 <ButtonRelease-1> {MenuPopupRelease $topwin(analysis_name).info.geom.crop.frame7.frame1.menubutton7.menu0 %W }

  # build widget $topwin(analysis_name).info.geom.crop.frame7.frame1.menubutton7.menu0
  menu $topwin(analysis_name).info.geom.crop.frame7.frame1.menubutton7.menu0 
  $topwin(analysis_name).info.geom.crop.frame7.frame1.menubutton7.menu0 add command \
    -label {  0} \
	 -command {set analysis(crop_ul_row) 0}
  $topwin(analysis_name).info.geom.crop.frame7.frame1.menubutton7.menu0 add command \
    -label {  8} \
	 -command {set analysis(crop_ul_row) 8}
  $topwin(analysis_name).info.geom.crop.frame7.frame1.menubutton7.menu0 add command \
    -label { 16} \
	 -command {set analysis(crop_ul_row) 16}
  $topwin(analysis_name).info.geom.crop.frame7.frame1.menubutton7.menu0 add command \
    -label { 32} \
	 -command {set analysis(crop_ul_row) 32}
  $topwin(analysis_name).info.geom.crop.frame7.frame1.menubutton7.menu0 add command \
    -label { 64} \
	 -command {set analysis(crop_ul_row) 64}
  $topwin(analysis_name).info.geom.crop.frame7.frame1.menubutton7.menu0 add command \
    -label {128} \
	 -command {set analysis(crop_ul_row) 128}
  $topwin(analysis_name).info.geom.crop.frame7.frame1.menubutton7.menu0 add command \
    -label {256} \
	 -command {set analysis(crop_ul_row) 256}

  bind $topwin(analysis_name).info.geom.crop.frame7.frame1.menubutton7.menu0 <B1-Motion> { MenuPopupMotion $topwin(analysis_name).info.geom.crop.frame7.frame1.menubutton7.menu0 %W %X %Y}
  bind $topwin(analysis_name).info.geom.crop.frame7.frame1.menubutton7.menu0 <ButtonRelease-1>  { MenuPopupRelease $topwin(analysis_name).info.geom.crop.frame7.frame1.menubutton7.menu0 %W }

  # pack master $topwin(analysis_name).info.geom.crop.frame7.frame1
  pack configure $topwin(analysis_name).info.geom.crop.frame7.frame1.entry \
    -fill both \
    -side left
  pack configure $topwin(analysis_name).info.geom.crop.frame7.frame1.menubutton7 \
    -fill both \
    -side right

  # build widget  $topwin(analysis_name).info.geom.crop.frame7.frame2
  frame  $topwin(analysis_name).info.geom.crop.frame7.frame2 \
    -borderwidth {0} \
    -highlightthickness {0} \
	 -background "$GuiColor(frame_bg)" \
    -height {30} \
    -width {30}

  # build widget  $topwin(analysis_name).info.geom.crop.frame7.frame2.entry
  entry  $topwin(analysis_name).info.geom.crop.frame7.frame2.entry \
    -background "$GuiColor(entry_bg)" \
    -foreground "$GuiColor(entry_fg)" \
    -relief {sunken} \
    -textvariable {analysis(crop_ul_col)} -width {5}

  endEntry $topwin(analysis_name).info.geom.crop.frame7.frame2.entry 1 \
  	$topwin(analysis_name).info.geom.crop.frame8.frame1.entry \
	$topwin(analysis_name).info.geom.crop.frame7.frame1.entry 


  # build widget  $topwin(analysis_name).info.geom.crop.frame7.frame2.menubutton7
  menubutton  $topwin(analysis_name).info.geom.crop.frame7.frame2.menubutton7 \
	 -activebackground "$GuiColor(btn_act_bg)" -background "$GuiColor(btn_bg)"  \
    -font "$GuiMisc(pop_up_fn)" \
    -relief "$GuiMisc(pop_up_relief)" \
    -padx {1} -pady {1} -highlightthickness {0} \
    -text "$GuiMisc(pop_up_text)" -width {2}

  # bindings
  bind  $topwin(analysis_name).info.geom.crop.frame7.frame2.menubutton7 <Button-1> { MenuPopupPost  $topwin(analysis_name).info.geom.crop.frame7.frame2.menubutton7.menu0 %X %Y}
  bind  $topwin(analysis_name).info.geom.crop.frame7.frame2.menubutton7 <ButtonRelease-1> {MenuPopupRelease  $topwin(analysis_name).info.geom.crop.frame7.frame2.menubutton7.menu0 %W }

  # build widget  $topwin(analysis_name).info.geom.crop.frame7.frame2.menubutton7.menu0
  menu  $topwin(analysis_name).info.geom.crop.frame7.frame2.menubutton7.menu0 
   $topwin(analysis_name).info.geom.crop.frame7.frame2.menubutton7.menu0 add command \
    -label {  0} \
	 -command {set analysis(crop_ul_col) 0}
   $topwin(analysis_name).info.geom.crop.frame7.frame2.menubutton7.menu0 add command \
    -label {  8} \
	 -command {set analysis(crop_ul_col) 8}
   $topwin(analysis_name).info.geom.crop.frame7.frame2.menubutton7.menu0 add command \
    -label { 16} \
	 -command {set analysis(crop_ul_col) 16}
   $topwin(analysis_name).info.geom.crop.frame7.frame2.menubutton7.menu0 add command \
    -label { 32} \
	 -command {set analysis(crop_ul_col) 32}
   $topwin(analysis_name).info.geom.crop.frame7.frame2.menubutton7.menu0 add command \
    -label { 64} \
	 -command {set analysis(crop_ul_col) 64}
   $topwin(analysis_name).info.geom.crop.frame7.frame2.menubutton7.menu0 add command \
    -label {128} \
	 -command {set analysis(crop_ul_col) 128}
   $topwin(analysis_name).info.geom.crop.frame7.frame2.menubutton7.menu0 add command \
    -label {256} \
	 -command {set analysis(crop_ul_col) 256}
   $topwin(analysis_name).info.geom.crop.frame7.frame2.menubutton7.menu0 add command \
    -label {512} \
	 -command {set analysis(crop_ul_col) 512}

  bind  $topwin(analysis_name).info.geom.crop.frame7.frame2.menubutton7.menu0 <B1-Motion> { MenuPopupMotion  $topwin(analysis_name).info.geom.crop.frame7.frame2.menubutton7.menu0 %W %X %Y}
  bind  $topwin(analysis_name).info.geom.crop.frame7.frame2.menubutton7.menu0 <ButtonRelease-1>  { MenuPopupRelease  $topwin(analysis_name).info.geom.crop.frame7.frame2.menubutton7.menu0 %W }

  # pack master  $topwin(analysis_name).info.geom.crop.frame7.frame2
  pack configure  $topwin(analysis_name).info.geom.crop.frame7.frame2.menubutton7 \
    -fill both \
    -side right
  pack configure  $topwin(analysis_name).info.geom.crop.frame7.frame2.entry \
    -fill both \
    -side left


  # pack widget $topwin(analysis_name).info.geom.crop.frame7
  pack append $topwin(analysis_name).info.geom.crop.frame7 \
  $topwin(analysis_name).info.geom.crop.frame7.util_radio4 {left frame center}\
  $topwin(analysis_name).info.geom.crop.frame7.label0 {left frame center} \
  $topwin(analysis_name).info.geom.crop.frame7.frame1 {left frame center} \
  $topwin(analysis_name).info.geom.crop.frame7.label1 {left frame center} \
  $topwin(analysis_name).info.geom.crop.frame7.frame2 {left frame center} 

  # build widget $topwin(analysis_name).info.geom.crop.frame8
  frame $topwin(analysis_name).info.geom.crop.frame8  -background "$GuiColor(frame_bg)"

  # build widget $topwin(analysis_name).info.geom.crop.frame8.label9
  label $topwin(analysis_name).info.geom.crop.frame8.label9  -background "$GuiColor(label_bg)"  -text {        with a height}

  # build widget $topwin(analysis_name).info.geom.crop.frame8.frame1
  frame $topwin(analysis_name).info.geom.crop.frame8.frame1 \
    -borderwidth {0} \
    -highlightthickness {0} \
	 -background "$GuiColor(frame_bg)" \
    -height {30} \
    -width {30}

  # build widget $topwin(analysis_name).info.geom.crop.frame8.frame1.entry
  entry $topwin(analysis_name).info.geom.crop.frame8.frame1.entry \
    -background "$GuiColor(entry_bg)" \
    -foreground "$GuiColor(entry_fg)" \
    -relief {sunken} \
    -textvariable {analysis(util_crop_height)} -width {5}

  endEntry $topwin(analysis_name).info.geom.crop.frame8.frame1.entry 1  \
	$topwin(analysis_name).info.geom.crop.frame8.frame2.entry  \
  	$topwin(analysis_name).info.geom.crop.frame7.frame2.entry


  # build widget $topwin(analysis_name).info.geom.crop.frame8.frame1.menubutton7
  menubutton $topwin(analysis_name).info.geom.crop.frame8.frame1.menubutton7 \
	 -activebackground "$GuiColor(btn_act_bg)" -background "$GuiColor(btn_bg)"  \
    -font "$GuiMisc(pop_up_fn)" \
    -relief "$GuiMisc(pop_up_relief)" \
    -padx {1} -pady {1} -highlightthickness {0} \
    -text "$GuiMisc(pop_up_text)" -width {2}

  # bindings
  bind $topwin(analysis_name).info.geom.crop.frame8.frame1.menubutton7 <Button-1> { MenuPopupPost $topwin(analysis_name).info.geom.crop.frame8.frame1.menubutton7.menu0 %X %Y}
  bind $topwin(analysis_name).info.geom.crop.frame8.frame1.menubutton7 <ButtonRelease-1> {MenuPopupRelease $topwin(analysis_name).info.geom.crop.frame8.frame1.menubutton7.menu0 %W }

  # build widget $topwin(analysis_name).info.geom.crop.frame8.frame1.menubutton7.menu0
  menu $topwin(analysis_name).info.geom.crop.frame8.frame1.menubutton7.menu0 
  $topwin(analysis_name).info.geom.crop.frame8.frame1.menubutton7.menu0 add command \
    -label {  8} \
	 -command {set analysis(util_crop_height) 8}
  $topwin(analysis_name).info.geom.crop.frame8.frame1.menubutton7.menu0 add command \
    -label { 16} \
	 -command {set analysis(util_crop_height) 16}
  $topwin(analysis_name).info.geom.crop.frame8.frame1.menubutton7.menu0 add command \
    -label { 32} \
	 -command {set analysis(util_crop_height) 32}
  $topwin(analysis_name).info.geom.crop.frame8.frame1.menubutton7.menu0 add command \
    -label { 64} \
	 -command {set analysis(util_crop_height) 64}
  $topwin(analysis_name).info.geom.crop.frame8.frame1.menubutton7.menu0 add command \
    -label {128} \
	 -command {set analysis(util_crop_height) 128}
  $topwin(analysis_name).info.geom.crop.frame8.frame1.menubutton7.menu0 add command \
    -label {256} \
	 -command {set analysis(util_crop_height) 256}
  $topwin(analysis_name).info.geom.crop.frame8.frame1.menubutton7.menu0 add command \
    -label {512} \
	 -command {set analysis(util_crop_height) 512}

  bind $topwin(analysis_name).info.geom.crop.frame8.frame1.menubutton7.menu0 <B1-Motion> { MenuPopupMotion $topwin(analysis_name).info.geom.crop.frame8.frame1.menubutton7.menu0 %W %X %Y}
  bind $topwin(analysis_name).info.geom.crop.frame8.frame1.menubutton7.menu0 <ButtonRelease-1>  { MenuPopupRelease $topwin(analysis_name).info.geom.crop.frame8.frame1.menubutton7.menu0 %W }

  # pack master $topwin(analysis_name).info.geom.crop.frame8.frame1
  pack configure $topwin(analysis_name).info.geom.crop.frame8.frame1.menubutton7 \
    -fill both \
    -side right
  pack configure $topwin(analysis_name).info.geom.crop.frame8.frame1.entry \
    -fill both \
    -side left


  # build widget $topwin(analysis_name).info.geom.crop.frame8.label14
  label $topwin(analysis_name).info.geom.crop.frame8.label14  -background "$GuiColor(label_bg)"  -text {rows and width}

  # build widget $topwin(analysis_name).info.geom.crop.frame8.frame2
  frame $topwin(analysis_name).info.geom.crop.frame8.frame2 \
    -borderwidth {0} \
    -highlightthickness {0} \
	 -background "$GuiColor(frame_bg)" \
    -height {30} \
    -width {30}

  # build widget $topwin(analysis_name).info.geom.crop.frame8.frame2.entry
  entry $topwin(analysis_name).info.geom.crop.frame8.frame2.entry \
    -background "$GuiColor(entry_bg)" \
    -foreground "$GuiColor(entry_fg)" \
    -relief {sunken} \
    -textvariable {analysis(util_crop_width)} -width {5}

  endEntry $topwin(analysis_name).info.geom.crop.frame8.frame2.entry 1 \
	$topwin(analysis_name).info.geom.crop.frame7.frame1.entry  \
  	$topwin(analysis_name).info.geom.crop.frame8.frame1.entry 


  # build widget $topwin(analysis_name).info.geom.crop.frame8.frame2.menubutton7
  menubutton $topwin(analysis_name).info.geom.crop.frame8.frame2.menubutton7 \
	 -activebackground "$GuiColor(btn_act_bg)" -background "$GuiColor(btn_bg)"  \
    -font "$GuiMisc(pop_up_fn)" \
    -relief "$GuiMisc(pop_up_relief)" \
    -padx {1} -pady {1} -highlightthickness {0} \
    -text "$GuiMisc(pop_up_text)" -width {2}

  # bindings
  bind $topwin(analysis_name).info.geom.crop.frame8.frame2.menubutton7 <Button-1> { MenuPopupPost $topwin(analysis_name).info.geom.crop.frame8.frame2.menubutton7.menu0 %X %Y}
  bind $topwin(analysis_name).info.geom.crop.frame8.frame2.menubutton7 <ButtonRelease-1> {MenuPopupRelease $topwin(analysis_name).info.geom.crop.frame8.frame2.menubutton7.menu0 %W }

  # build widget $topwin(analysis_name).info.geom.crop.frame8.frame2.menubutton7.menu0
  menu $topwin(analysis_name).info.geom.crop.frame8.frame2.menubutton7.menu0 
  $topwin(analysis_name).info.geom.crop.frame8.frame2.menubutton7.menu0 add command \
    -label {  8} \
	 -command {set analysis(util_crop_width) 8}
  $topwin(analysis_name).info.geom.crop.frame8.frame2.menubutton7.menu0 add command \
    -label { 16} \
	 -command {set analysis(util_crop_width) 16}
  $topwin(analysis_name).info.geom.crop.frame8.frame2.menubutton7.menu0 add command \
    -label { 32} \
	 -command {set analysis(util_crop_width) 32}
  $topwin(analysis_name).info.geom.crop.frame8.frame2.menubutton7.menu0 add command \
    -label { 64} \
	 -command {set analysis(util_crop_width) 64}
  $topwin(analysis_name).info.geom.crop.frame8.frame2.menubutton7.menu0 add command \
    -label {128} \
	 -command {set analysis(util_crop_width) 128}
  $topwin(analysis_name).info.geom.crop.frame8.frame2.menubutton7.menu0 add command \
    -label {256} \
	 -command {set analysis(util_crop_width) 256}
  $topwin(analysis_name).info.geom.crop.frame8.frame2.menubutton7.menu0 add command \
    -label {512} \
	 -command {set analysis(util_crop_width) 512}

  bind $topwin(analysis_name).info.geom.crop.frame8.frame2.menubutton7.menu0 <B1-Motion> { MenuPopupMotion $topwin(analysis_name).info.geom.crop.frame8.frame2.menubutton7.menu0 %W %X %Y}
  bind $topwin(analysis_name).info.geom.crop.frame8.frame2.menubutton7.menu0 <ButtonRelease-1>  { MenuPopupRelease $topwin(analysis_name).info.geom.crop.frame8.frame2.menubutton7.menu0 %W }

  # pack master $topwin(analysis_name).info.geom.crop.frame8.frame2
  pack configure $topwin(analysis_name).info.geom.crop.frame8.frame2.menubutton7 \
    -fill both \
    -side right
  pack configure $topwin(analysis_name).info.geom.crop.frame8.frame2.entry \
    -fill both \
    -side left


  # build widget $topwin(analysis_name).info.geom.crop.frame8.label15
  label $topwin(analysis_name).info.geom.crop.frame8.label15  -background "$GuiColor(label_bg)"  -text {columns}

  # pack widget $topwin(analysis_name).info.geom.crop.frame8
  pack append $topwin(analysis_name).info.geom.crop.frame8 \
  $topwin(analysis_name).info.geom.crop.frame8.label9 {left frame center} \
  $topwin(analysis_name).info.geom.crop.frame8.frame1 {left frame center}\
  $topwin(analysis_name).info.geom.crop.frame8.label14 {left frame center}\
  $topwin(analysis_name).info.geom.crop.frame8.frame2 {left frame center}\
  $topwin(analysis_name).info.geom.crop.frame8.label15 {left frame center}

  # pack widget $topwin(analysis_name).info.geom.crop
  pack append $topwin(analysis_name).info.geom.crop \
  $topwin(analysis_name).info.geom.crop.frame7 {top frame nw expand fill} \
  $topwin(analysis_name).info.geom.crop.frame8 {top frame nw expand fill padx 10}

  # build widget $topwin(analysis_name).info.geom.cut_paste
  frame $topwin(analysis_name).info.geom.cut_paste  -background "$GuiColor(frame_bg)"  -borderwidth {2}  -relief {ridge}


  # build widget $topwin(analysis_name).info.geom.cut_paste.util_radio4
	radiobutton $topwin(analysis_name).info.geom.cut_paste.util_radio4 -padx {1} -pady {5} \
	-activebackground "$GuiColor(btn_act_bg)" -background "$GuiColor(btn_bg)"  \
	-highlightthickness {0}   \
	-relief {flat}  -text {Paste }  -value {copy_paste}  -variable {analysis(geometry)}

  # build widget $topwin(analysis_name).info.geom.cut_paste.second
  entry $topwin(analysis_name).info.geom.cut_paste.second \
  -background "$GuiColor(entry_bg)" \
  -relief {sunken}  -textvariable {second_image} \
  -borderwidth {2}
  endEntry $topwin(analysis_name).info.geom.cut_paste.second 0 \
    $topwin(analysis_name).info.geom.cut_paste.paste.frame2.entry \
    $topwin(analysis_name).info.geom.cut_paste.paste.frame1.entry 

  # build widget $topwin(analysis_name).info.geom.cut_paste.paste
  frame $topwin(analysis_name).info.geom.cut_paste.paste  -background "$GuiColor(frame_bg)"  -borderwidth {2}

  # build widget $topwin(analysis_name).info.geom.cut_paste.paste.label9
  label $topwin(analysis_name).info.geom.cut_paste.paste.label9  -background "$GuiColor(label_bg)"\
  -text {with its upper left corner at row}

  # build widget $topwin(analysis_name).info.geom.cut_paste.paste.frame2
  frame $topwin(analysis_name).info.geom.cut_paste.paste.frame2 \
    -borderwidth {0} \
    -highlightthickness {0} \
	 -background "$GuiColor(frame_bg)" \
    -height {30} \
    -width {30}

  # build widget $topwin(analysis_name).info.geom.cut_paste.paste.frame2.entry
  entry $topwin(analysis_name).info.geom.cut_paste.paste.frame2.entry \
    -background "$GuiColor(entry_bg)" \
    -foreground "$GuiColor(entry_fg)" \
    -relief {sunken} \
    -textvariable {analysis(paste_to_row)} -width {5}
  endEntry $topwin(analysis_name).info.geom.cut_paste.paste.frame2.entry 0 \
    $topwin(analysis_name).info.geom.cut_paste.paste.frame1.entry \
  	 $topwin(analysis_name).info.geom.cut_paste.second 


  # build widget $topwin(analysis_name).info.geom.cut_paste.paste.frame2.menubutton7
  menubutton $topwin(analysis_name).info.geom.cut_paste.paste.frame2.menubutton7 \
	 -activebackground "$GuiColor(btn_act_bg)" -background "$GuiColor(btn_bg)"  \
    -font "$GuiMisc(pop_up_fn)" \
    -relief "$GuiMisc(pop_up_relief)" \
    -padx {1} -pady {1} -highlightthickness {0} \
    -text "$GuiMisc(pop_up_text)" -width {2}

  # bindings
  bind $topwin(analysis_name).info.geom.cut_paste.paste.frame2.menubutton7 <Button-1> { MenuPopupPost $topwin(analysis_name).info.geom.cut_paste.paste.frame2.menubutton7.menu0 %X %Y}
  bind $topwin(analysis_name).info.geom.cut_paste.paste.frame2.menubutton7 <ButtonRelease-1> {MenuPopupRelease $topwin(analysis_name).info.geom.cut_paste.paste.frame2.menubutton7.menu0 %W }

  # build widget $topwin(analysis_name).info.geom.cut_paste.paste.frame2.menubutton7.menu0
  menu $topwin(analysis_name).info.geom.cut_paste.paste.frame2.menubutton7.menu0 
  $topwin(analysis_name).info.geom.cut_paste.paste.frame2.menubutton7.menu0 add command \
    -label {  0} \
	 -command {set analysis(paste_to_row) 0}
  $topwin(analysis_name).info.geom.cut_paste.paste.frame2.menubutton7.menu0 add command \
    -label {  8} \
	 -command {set analysis(paste_to_row) 8}
  $topwin(analysis_name).info.geom.cut_paste.paste.frame2.menubutton7.menu0 add command \
    -label { 16} \
	 -command {set analysis(paste_to_row) 16}
  $topwin(analysis_name).info.geom.cut_paste.paste.frame2.menubutton7.menu0 add command \
    -label { 32} \
	 -command {set analysis(paste_to_row) 32}
  $topwin(analysis_name).info.geom.cut_paste.paste.frame2.menubutton7.menu0 add command \
    -label { 64} \
	 -command {set analysis(paste_to_row) 64}
  $topwin(analysis_name).info.geom.cut_paste.paste.frame2.menubutton7.menu0 add command \
    -label {128} \
	 -command {set analysis(paste_to_row) 128}
  $topwin(analysis_name).info.geom.cut_paste.paste.frame2.menubutton7.menu0 add command \
    -label {256} \
	 -command {set analysis(paste_to_row) 256}

  bind $topwin(analysis_name).info.geom.cut_paste.paste.frame2.menubutton7.menu0 <B1-Motion> { MenuPopupMotion $topwin(analysis_name).info.geom.cut_paste.paste.frame2.menubutton7.menu0 %W %X %Y}
  bind $topwin(analysis_name).info.geom.cut_paste.paste.frame2.menubutton7.menu0 <ButtonRelease-1>  { MenuPopupRelease $topwin(analysis_name).info.geom.cut_paste.paste.frame2.menubutton7.menu0 %W }

  # pack master $topwin(analysis_name).info.geom.cut_paste.paste.frame2
  pack configure $topwin(analysis_name).info.geom.cut_paste.paste.frame2.menubutton7 \
    -fill both \
    -side right
  pack configure $topwin(analysis_name).info.geom.cut_paste.paste.frame2.entry \
    -fill both \
    -side left


  # build widget $topwin(analysis_name).info.geom.cut_paste.paste.label14
  label $topwin(analysis_name).info.geom.cut_paste.paste.label14  -background "$GuiColor(label_bg)"  -text {and column}

  # build widget $topwin(analysis_name).info.geom.cut_paste.paste.frame1
  frame $topwin(analysis_name).info.geom.cut_paste.paste.frame1 \
    -borderwidth {0} \
    -highlightthickness {0} \
	 -background "$GuiColor(frame_bg)" \
    -height {30} \
    -width {30}

  # build widget $topwin(analysis_name).info.geom.cut_paste.paste.frame1.entry
  entry $topwin(analysis_name).info.geom.cut_paste.paste.frame1.entry \
    -background "$GuiColor(entry_bg)" \
    -foreground "$GuiColor(entry_fg)" \
    -relief {sunken} \
    -textvariable {analysis(paste_to_col)} -width {5}
  endEntry $topwin(analysis_name).info.geom.cut_paste.paste.frame1.entry 0 \
  	$topwin(analysis_name).info.geom.cut_paste.second \
	$topwin(analysis_name).info.geom.cut_paste.paste.frame2.entry

  # build widget $topwin(analysis_name).info.geom.cut_paste.paste.frame1.menubutton7
  menubutton $topwin(analysis_name).info.geom.cut_paste.paste.frame1.menubutton7 \
	 -activebackground "$GuiColor(btn_act_bg)" -background "$GuiColor(btn_bg)"  \
    -font "$GuiMisc(pop_up_fn)" \
    -relief "$GuiMisc(pop_up_relief)" \
    -padx {1} -pady {1} -highlightthickness {0} \
    -text "$GuiMisc(pop_up_text)" -width {2}

  # bindings
  bind $topwin(analysis_name).info.geom.cut_paste.paste.frame1.menubutton7 <Button-1> { MenuPopupPost $topwin(analysis_name).info.geom.cut_paste.paste.frame1.menubutton7.menu0 %X %Y}
  bind $topwin(analysis_name).info.geom.cut_paste.paste.frame1.menubutton7 <ButtonRelease-1> {MenuPopupRelease $topwin(analysis_name).info.geom.cut_paste.paste.frame1.menubutton7.menu0 %W }

  # build widget $topwin(analysis_name).info.geom.cut_paste.paste.frame1.menubutton7.menu0
  menu $topwin(analysis_name).info.geom.cut_paste.paste.frame1.menubutton7.menu0 
  $topwin(analysis_name).info.geom.cut_paste.paste.frame1.menubutton7.menu0 add command \
    -label {  0} \
	 -command {set analysis(paste_to_col) 0}
  $topwin(analysis_name).info.geom.cut_paste.paste.frame1.menubutton7.menu0 add command \
    -label {  8} \
	 -command {set analysis(paste_to_col) 8}
  $topwin(analysis_name).info.geom.cut_paste.paste.frame1.menubutton7.menu0 add command \
    -label { 16} \
	 -command {set analysis(paste_to_col) 16}
  $topwin(analysis_name).info.geom.cut_paste.paste.frame1.menubutton7.menu0 add command \
    -label { 32} \
	 -command {set analysis(paste_to_col) 32}
  $topwin(analysis_name).info.geom.cut_paste.paste.frame1.menubutton7.menu0 add command \
    -label { 64} \
	 -command {set analysis(paste_to_col) 64}
  $topwin(analysis_name).info.geom.cut_paste.paste.frame1.menubutton7.menu0 add command \
    -label {128} \
	 -command {set analysis(paste_to_col) 128}
  $topwin(analysis_name).info.geom.cut_paste.paste.frame1.menubutton7.menu0 add command \
    -label {256} \
	 -command {set analysis(paste_to_col) 256}

  bind $topwin(analysis_name).info.geom.cut_paste.paste.frame1.menubutton7.menu0 <B1-Motion> { MenuPopupMotion $topwin(analysis_name).info.geom.cut_paste.paste.frame1.menubutton7.menu0 %W %X %Y}
  bind $topwin(analysis_name).info.geom.cut_paste.paste.frame1.menubutton7.menu0 <ButtonRelease-1>  { MenuPopupRelease $topwin(analysis_name).info.geom.cut_paste.paste.frame1.menubutton7.menu0 %W }

  # pack master $topwin(analysis_name).info.geom.cut_paste.paste.frame1
  pack configure $topwin(analysis_name).info.geom.cut_paste.paste.frame1.menubutton7 \
    -fill both \
    -side right
  pack configure $topwin(analysis_name).info.geom.cut_paste.paste.frame1.entry \
    -fill both \
    -side left

  # build widget $topwin(analysis_name).info.geom.cut_paste.paste.comma
  label $topwin(analysis_name).info.geom.cut_paste.paste.comma  -background "$GuiColor(label_bg)"  -text {}

  # pack widget $topwin(analysis_name).info.geom.cut_paste.paste
  pack append $topwin(analysis_name).info.geom.cut_paste.paste  \
  	$topwin(analysis_name).info.geom.cut_paste.paste.label9 {left frame center} \
	$topwin(analysis_name).info.geom.cut_paste.paste.frame2 {left frame center} \
	$topwin(analysis_name).info.geom.cut_paste.paste.label14 {left frame center} \
	$topwin(analysis_name).info.geom.cut_paste.paste.frame1 {left frame center} \
	$topwin(analysis_name).info.geom.cut_paste.paste.comma {left frame center}

  # build widget $topwin(analysis_name).info.geom.cut_paste.fill
  frame $topwin(analysis_name).info.geom.cut_paste.fill  -background "$GuiColor(frame_bg)"  -borderwidth {2}

  # build widget $topwin(analysis_name).info.geom.cut_paste.fill.fill
  label $topwin(analysis_name).info.geom.cut_paste.fill.fill  -background "$GuiColor(label_bg)"  -text {to the current image}

  # build widget $topwin(analysis_name).info.geom.cut_paste.fill.fill_value
  checkbutton $topwin(analysis_name).info.geom.cut_paste.fill.fill_value  \
	-activebackground "$GuiColor(btn_act_bg)" -background "$GuiColor(btn_bg)"  \
	  -highlightthickness {0}  \
	 -variable {analysis(paste_transparent)} \
	 -relief {flat}  -text {transparently} 

  # build widget $topwin(analysis_name).info.geom.cut_paste.fill.dot
  label $topwin(analysis_name).info.geom.cut_paste.fill.dot  -background "$GuiColor(label_bg)"  -text {.}

  # pack widget $topwin(analysis_name).info.geom.cut_paste.fill
  pack append $topwin(analysis_name).info.geom.cut_paste.fill  $topwin(analysis_name).info.geom.cut_paste.fill.fill {left frame center}  $topwin(analysis_name).info.geom.cut_paste.fill.fill_value {left frame center}  $topwin(analysis_name).info.geom.cut_paste.fill.dot {left frame center}

  # pack widget $topwin(analysis_name).info.geom.cut_paste
  pack append $topwin(analysis_name).info.geom.cut_paste  \
  $topwin(analysis_name).info.geom.cut_paste.util_radio4 {left frame n }\
  $topwin(analysis_name).info.geom.cut_paste.second {top frame nw fill}\
  $topwin(analysis_name).info.geom.cut_paste.paste {top frame nw fill}\
  $topwin(analysis_name).info.geom.cut_paste.fill {top frame nw fill}

  # build widget $topwin(analysis_name).info.geom.enlarge
  frame $topwin(analysis_name).info.geom.enlarge \
	 -relief {ridge} \
	 -borderwidth {2} \
    -background "$GuiColor(frame_bg)"    

  # build widget $topwin(analysis_name).info.geom.enlarge.left
  frame $topwin(analysis_name).info.geom.enlarge.left \
    -background "$GuiColor(frame_bg)"

  # build widget $topwin(analysis_name).info.geom.enlarge.left.util_crop_width
  entry $topwin(analysis_name).info.geom.enlarge.left.util_crop_width \
    -background "$GuiColor(entry_bg)" \
    -relief {sunken} \
    -textvariable {analysis(resize_width)} \
    -width {5}
  # bindings
  endEntry $topwin(analysis_name).info.geom.enlarge.left.util_crop_width 0  \
  	$topwin(analysis_name).info.geom.enlarge.left.util_crop_height  \
  	$topwin(analysis_name).info.geom.enlarge.left.util_crop_height 

  # build widget $topwin(analysis_name).info.geom.enlarge.left.menubutton1
  menubutton $topwin(analysis_name).info.geom.enlarge.left.menubutton1 \
	-activebackground "$GuiColor(btn_act_bg)" -background "$GuiColor(btn_bg)"  \
    -padx {1}  -pady {1} -highlightthickness {0} \
	 -font "$GuiMisc(pop_up_fn)" \
	 -relief "$GuiMisc(pop_up_relief)"  \
	 -text "$GuiMisc(pop_up_text)" -width {2}
  # bindings
   bind $topwin(analysis_name).info.geom.enlarge.left.menubutton1 <Button-1> {MenuPopupPost $topwin(analysis_name).info.geom.enlarge.left.menubutton1.menu %X %Y}
   bind $topwin(analysis_name).info.geom.enlarge.left.menubutton1 <ButtonRelease-1> {MenuPopupRelease $topwin(analysis_name).info.geom.enlarge.left.menubutton1.menu %W}

  # build widget $topwin(analysis_name).info.geom.enlarge.left.menubutton1.menu
  menu $topwin(analysis_name).info.geom.enlarge.left.menubutton1.menu
  $topwin(analysis_name).info.geom.enlarge.left.menubutton1.menu add command \
	 -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
	 -command {set analysis(resize_width) 8} \
    -label {  8}
  $topwin(analysis_name).info.geom.enlarge.left.menubutton1.menu add command \
	 -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
	 -command {set analysis(resize_width) 16} \
    -label { 16}
  $topwin(analysis_name).info.geom.enlarge.left.menubutton1.menu add command \
	 -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
	 -command {set analysis(resize_width) 32} \
    -label { 32}
  $topwin(analysis_name).info.geom.enlarge.left.menubutton1.menu add command \
	 -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
	 -command {set analysis(resize_width) 64} \
    -label { 64}
  $topwin(analysis_name).info.geom.enlarge.left.menubutton1.menu add command \
	 -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
	 -command {set analysis(resize_width) 128} \
    -label {128}
  $topwin(analysis_name).info.geom.enlarge.left.menubutton1.menu add command \
	 -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
	 -command {set analysis(resize_width) 256} \
    -label {256}
  $topwin(analysis_name).info.geom.enlarge.left.menubutton1.menu add command \
	 -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
	 -command {set analysis(resize_width) 512} \
    -label {512}

  bindtags $topwin(analysis_name).info.geom.enlarge.left.menubutton1.menu {Menu all}
# bindings
  bind $topwin(analysis_name).info.geom.enlarge.left.menubutton1.menu <B1-Motion> {
  MenuPopupMotion $topwin(analysis_name).info.geom.enlarge.left.menubutton1.menu %W %X %Y}
  bind $topwin(analysis_name).info.geom.enlarge.left.menubutton1.menu <ButtonRelease-1> {
  MenuPopupRelease $topwin(analysis_name).info.geom.enlarge.left.menubutton1.menu %W}

  # build widget $topwin(analysis_name).info.geom.enlarge.left.label1
  label $topwin(analysis_name).info.geom.enlarge.left.label1 \
    -background {gray90} \
    -text {rows and width}

  # build widget $topwin(analysis_name).info.geom.enlarge.left.util_crop_height
  entry $topwin(analysis_name).info.geom.enlarge.left.util_crop_height \
    -background "$GuiColor(entry_bg)" \
    -relief {sunken} \
    -textvariable {analysis(resize_height)} \
    -width {5}
  # bindings
  endEntry $topwin(analysis_name).info.geom.enlarge.left.util_crop_height 0  \
		$topwin(analysis_name).info.geom.enlarge.left.util_crop_width \
		$topwin(analysis_name).info.geom.enlarge.left.util_crop_width


  # build widget $topwin(analysis_name).info.geom.enlarge.left.menubutton0
  menubutton $topwin(analysis_name).info.geom.enlarge.left.menubutton0 \
	-activebackground "$GuiColor(btn_act_bg)" -background "$GuiColor(btn_bg)"  \
    -padx {1}  -pady {1} -highlightthickness {0} \
	 -font "$GuiMisc(pop_up_fn)" \
	 -relief "$GuiMisc(pop_up_relief)"  \
	 -text "$GuiMisc(pop_up_text)" -width {2}
  # bindings
   bind $topwin(analysis_name).info.geom.enlarge.left.menubutton0 <Button-1> {MenuPopupPost $topwin(analysis_name).info.geom.enlarge.left.menubutton0.menu %X %Y}
   bind $topwin(analysis_name).info.geom.enlarge.left.menubutton0 <ButtonRelease-1> {MenuPopupRelease $topwin(analysis_name).info.geom.enlarge.left.menubutton0.menu %W}

  # build widget $topwin(analysis_name).info.geom.enlarge.left.menubutton0.menu
  menu $topwin(analysis_name).info.geom.enlarge.left.menubutton0.menu
  $topwin(analysis_name).info.geom.enlarge.left.menubutton0.menu add command \
	 -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
	 -command {set analysis(resize_height) 8} \
    -label {  8}
  $topwin(analysis_name).info.geom.enlarge.left.menubutton0.menu add command \
	 -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
	 -command {set analysis(resize_height) 16} \
    -label { 16}
  $topwin(analysis_name).info.geom.enlarge.left.menubutton0.menu add command \
	 -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
	 -command {set analysis(resize_height) 32} \
    -label { 32}
  $topwin(analysis_name).info.geom.enlarge.left.menubutton0.menu add command \
	 -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
	 -command {set analysis(resize_height) 64} \
    -label { 64}
  $topwin(analysis_name).info.geom.enlarge.left.menubutton0.menu add command \
	 -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
	 -command {set analysis(resize_height) 128} \
    -label {128}
  $topwin(analysis_name).info.geom.enlarge.left.menubutton0.menu add command \
	 -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
	 -command {set analysis(resize_height) 256} \
    -label {256}
  $topwin(analysis_name).info.geom.enlarge.left.menubutton0.menu add command \
	 -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
	 -command {set analysis(resize_height) 512} \
    -label {512}

  bindtags $topwin(analysis_name).info.geom.enlarge.left.menubutton0.menu {Menu all}  
  
# bindings
  bind $topwin(analysis_name).info.geom.enlarge.left.menubutton0.menu <B1-Motion> {
  MenuPopupMotion $topwin(analysis_name).info.geom.enlarge.left.menubutton0.menu %W %X %Y}
  bind $topwin(analysis_name).info.geom.enlarge.left.menubutton0.menu <ButtonRelease-1> {
  MenuPopupRelease $topwin(analysis_name).info.geom.enlarge.left.menubutton0.menu %W}

  # build widget $topwin(analysis_name).info.geom.enlarge.left.label3
  label $topwin(analysis_name).info.geom.enlarge.left.label3 \
    -background {gray90} \
    -text {columns }

  # build widget $topwin(analysis_name).info.geom.enlarge.left.util_radio5
	radiobutton $topwin(analysis_name).info.geom.enlarge.left.util_radio5 \
	-activebackground "$GuiColor(btn_act_bg)" -background "$GuiColor(btn_bg)"  \
	-padx {1} -pady {1} -highlightthickness {0}   \
	-relief {flat}  \
	-text {Resize image height}  \
	-value {resize}  \
	-variable {analysis(geometry)}


  # pack widget $topwin(analysis_name).info.geom.enlarge.left
  pack append $topwin(analysis_name).info.geom.enlarge.left \
    $topwin(analysis_name).info.geom.enlarge.left.util_radio5 {left frame center filly} \
    $topwin(analysis_name).info.geom.enlarge.left.util_crop_height {left frame nw} \
    $topwin(analysis_name).info.geom.enlarge.left.menubutton0 {left frame center filly} \
    $topwin(analysis_name).info.geom.enlarge.left.label1 {left frame nw} \
    $topwin(analysis_name).info.geom.enlarge.left.util_crop_width {left frame nw} \
    $topwin(analysis_name).info.geom.enlarge.left.menubutton1 {left frame center filly} \
    $topwin(analysis_name).info.geom.enlarge.left.label3 {left frame nw}
    
  # build widget $topwin(analysis_name).info.geom.enlarge.right
  frame $topwin(analysis_name).info.geom.enlarge.right \
    -background "$GuiColor(frame_bg)"       

  # build widget $topwin(analysis_name).info.geom.enlarge.right.radiobutton1
  radiobutton $topwin(analysis_name).info.geom.enlarge.right.radiobutton1 \
    -padx {1} -pady {1} -highlightthickness {0}  \
	 -activebackground "$GuiColor(btn_act_bg)" -background "$GuiColor(btn_bg)"  \
    -relief {flat} \
    -text {Zero order hold} \
    -value {0} \
    -variable {analysis(resize_linear)}   
     
  # build widget $topwin(analysis_name).info.geom.enlarge.right.radiobutton2
  radiobutton $topwin(analysis_name).info.geom.enlarge.right.radiobutton2 \
    -padx {1} -pady {1} -highlightthickness {0}  \
	 -activebackground "$GuiColor(btn_act_bg)" -background "$GuiColor(btn_bg)"  \
    -relief {flat} \
    -text {linear interpolation} \
    -value {1} \
    -variable {analysis(resize_linear)}   
   
    
  # pack widget $topwin(analysis_name).info.geom.enlarge.right
  pack append $topwin(analysis_name).info.geom.enlarge.right \
    $topwin(analysis_name).info.geom.enlarge.right.radiobutton1 {top frame w} \
    $topwin(analysis_name).info.geom.enlarge.right.radiobutton2 {left frame w} 
    
  # pack widget $topwin(analysis_name).info.geom.enlarge
  pack append $topwin(analysis_name).info.geom.enlarge \
    $topwin(analysis_name).info.geom.enlarge.left {left frame nw} \
    $topwin(analysis_name).info.geom.enlarge.right {left frame nw}

  # build widget $topwin(analysis_name).info.geom.rotate
  frame $topwin(analysis_name).info.geom.rotate  -background "$GuiColor(frame_bg)"  -borderwidth {2}  -relief {ridge}

  # build widget $topwin(analysis_name).info.geom.rotate.rotate
	radiobutton $topwin(analysis_name).info.geom.rotate.rotate -padx {1} -pady {1} \
	 -activebackground "$GuiColor(btn_act_bg)" -background "$GuiColor(btn_bg)"  \
	 -highlightthickness {0} \
	 -relief {flat}  -text {Rotate an image clockwise by }  -value {rotate}  -variable {analysis(geometry)}

  frame $topwin(analysis_name).info.geom.rotate.frame1 \
    -borderwidth {0} \
    -highlightthickness {0} \
	 -background "$GuiColor(frame_bg)" \
    -height {30} \
    -width {30}

  # build widget $topwin(analysis_name).info.geom.rotate.frame1.entry
  entry $topwin(analysis_name).info.geom.rotate.frame1.entry \
    -background "$GuiColor(entry_bg)" \
    -foreground "$GuiColor(entry_fg)" \
    -relief {sunken} \
    -textvariable {analysis(rotate_degree)} -width {5}
  endEntry $topwin(analysis_name).info.geom.rotate.frame1.entry 0

  # build widget $topwin(analysis_name).info.geom.rotate.frame1

  # build widget $topwin(analysis_name).info.geom.rotate.frame1.menubutton7
  menubutton $topwin(analysis_name).info.geom.rotate.frame1.menubutton7 \
	 -activebackground "$GuiColor(btn_act_bg)" -background "$GuiColor(btn_bg)"  \
    -font "$GuiMisc(pop_up_fn)" \
    -relief "$GuiMisc(pop_up_relief)" \
    -padx {1} -pady {1} -highlightthickness {0} \
    -text "$GuiMisc(pop_up_text)" -width {2}

  # bindings
  bind $topwin(analysis_name).info.geom.rotate.frame1.menubutton7 <Button-1> { MenuPopupPost $topwin(analysis_name).info.geom.rotate.frame1.menubutton7.menu0 %X %Y}
  bind $topwin(analysis_name).info.geom.rotate.frame1.menubutton7 <ButtonRelease-1> {MenuPopupRelease $topwin(analysis_name).info.geom.rotate.frame1.menubutton7.menu0 %W }

  # build widget $topwin(analysis_name).info.geom.rotate.frame1.menubutton7.menu0
  menu $topwin(analysis_name).info.geom.rotate.frame1.menubutton7.menu0 
  $topwin(analysis_name).info.geom.rotate.frame1.menubutton7.menu0 add command \
    -label {-180} \
	 -command {set analysis(rotate_degree) "-180" }
  $topwin(analysis_name).info.geom.rotate.frame1.menubutton7.menu0 add command \
    -label {-150} \
	 -command {set analysis(rotate_degree) "-150" }
  $topwin(analysis_name).info.geom.rotate.frame1.menubutton7.menu0 add command \
    -label {-135} \
	 -command {set analysis(rotate_degree) "-135" }
  $topwin(analysis_name).info.geom.rotate.frame1.menubutton7.menu0 add command \
    -label {-120} \
	 -command {set analysis(rotate_degree) "-120" }
  $topwin(analysis_name).info.geom.rotate.frame1.menubutton7.menu0 add command \
    -label { -90} \
	 -command {set analysis(rotate_degree) "-90" }
  $topwin(analysis_name).info.geom.rotate.frame1.menubutton7.menu0 add command \
    -label { -60} \
	 -command {set analysis(rotate_degree) "-60" }
  $topwin(analysis_name).info.geom.rotate.frame1.menubutton7.menu0 add command \
    -label { -45} \
	 -command {set analysis(rotate_degree) "-45" }
  $topwin(analysis_name).info.geom.rotate.frame1.menubutton7.menu0 add command \
    -label { -30} \
	 -command {set analysis(rotate_degree) "-30" }
  $topwin(analysis_name).info.geom.rotate.frame1.menubutton7.menu0 add command \
    -label { -10} \
	 -command {set analysis(rotate_degree) "-10" }
  $topwin(analysis_name).info.geom.rotate.frame1.menubutton7.menu0 add command \
    -label { -20} \
	 -command {set analysis(rotate_degree) "-20" }
  $topwin(analysis_name).info.geom.rotate.frame1.menubutton7.menu0 add command \
    -label { -10} \
	 -command {set analysis(rotate_degree) "-10" }
  $topwin(analysis_name).info.geom.rotate.frame1.menubutton7.menu0 add command \
    -label {  10} \
	 -command {set analysis(rotate_degree) "10" }
  $topwin(analysis_name).info.geom.rotate.frame1.menubutton7.menu0 add command \
    -label {  20} \
	 -command {set analysis(rotate_degree) "20" }
  $topwin(analysis_name).info.geom.rotate.frame1.menubutton7.menu0 add command \
    -label {  30} \
	 -command {set analysis(rotate_degree) "30" }
  $topwin(analysis_name).info.geom.rotate.frame1.menubutton7.menu0 add command \
    -label {  45} \
	 -command {set analysis(rotate_degree) "45" }
  $topwin(analysis_name).info.geom.rotate.frame1.menubutton7.menu0 add command \
    -label {  60} \
	 -command {set analysis(rotate_degree) "60" }
  $topwin(analysis_name).info.geom.rotate.frame1.menubutton7.menu0 add command \
    -label {  90} \
	 -command {set analysis(rotate_degree) "90" }
  $topwin(analysis_name).info.geom.rotate.frame1.menubutton7.menu0 add command \
    -label { 120} \
	 -command {set analysis(rotate_degree) "120" }
  $topwin(analysis_name).info.geom.rotate.frame1.menubutton7.menu0 add command \
    -label { 135} \
	 -command {set analysis(rotate_degree) "135" }
  $topwin(analysis_name).info.geom.rotate.frame1.menubutton7.menu0 add command \
    -label { 150} \
	 -command {set analysis(rotate_degree) "150" }
  $topwin(analysis_name).info.geom.rotate.frame1.menubutton7.menu0 add command \
    -label { 180} \
	 -command {set analysis(rotate_degree) "180" }

  bind $topwin(analysis_name).info.geom.rotate.frame1.menubutton7.menu0 <B1-Motion> { MenuPopupMotion $topwin(analysis_name).info.geom.rotate.frame1.menubutton7.menu0 %W %X %Y}
  bind $topwin(analysis_name).info.geom.rotate.frame1.menubutton7.menu0 <ButtonRelease-1>  { MenuPopupRelease $topwin(analysis_name).info.geom.rotate.frame1.menubutton7.menu0 %W }

  # pack master $topwin(analysis_name).info.geom.rotate.frame1
  pack configure $topwin(analysis_name).info.geom.rotate.frame1.menubutton7 \
    -fill both \
    -side right
  pack configure $topwin(analysis_name).info.geom.rotate.frame1.entry \
    -fill both \
    -side left

  # build widget $topwin(analysis_name).info.geom.rotate.degrees
  label $topwin(analysis_name).info.geom.rotate.degrees  -background "$GuiColor(label_bg)"  -text {degrees.}

  # pack widget $topwin(analysis_name).info.geom.rotate
  pack append $topwin(analysis_name).info.geom.rotate  \
  $topwin(analysis_name).info.geom.rotate.rotate {left frame center} \
  $topwin(analysis_name).info.geom.rotate.frame1 {left frame center}  \
  $topwin(analysis_name).info.geom.rotate.degrees {left frame center}

  # build widget $topwin(analysis_name).info.geom.translate
  frame $topwin(analysis_name).info.geom.translate  -background "$GuiColor(frame_bg)"  -borderwidth {2}  -relief {ridge}

  # build widget $topwin(analysis_name).info.geom.translate.upper
  frame $topwin(analysis_name).info.geom.translate.upper  -background "$GuiColor(frame_bg)"  -borderwidth {2}

  # build widget $topwin(analysis_name).info.geom.translate.upper.label1
  frame $topwin(analysis_name).info.geom.translate.upper.label1  -background "$GuiColor(frame_bg)"  -borderwidth {2}

  # build widget $topwin(analysis_name).info.geom.translate.upper.label1.translate
	radiobutton $topwin(analysis_name).info.geom.translate.upper.label1.translate  \
	 -activebackground "$GuiColor(btn_act_bg)" -background "$GuiColor(btn_bg)"  \
	 -padx {1} -pady {1} -highlightthickness {0}\
	 -relief {flat}  -text {Translate an image}  -value {translate}  -variable {analysis(geometry)}

  # pack widget $topwin(analysis_name).info.geom.translate.upper.label1
  pack append $topwin(analysis_name).info.geom.translate.upper.label1  $topwin(analysis_name).info.geom.translate.upper.label1.translate {left frame center}

  # build widget $topwin(analysis_name).info.geom.translate.upper.lr
  frame $topwin(analysis_name).info.geom.translate.upper.lr  -background "$GuiColor(frame_bg)"  -borderwidth {2}

  # build widget $topwin(analysis_name).info.geom.translate.upper.lr.radiobutton29
	radiobutton $topwin(analysis_name).info.geom.translate.upper.lr.radiobutton29 \
	 -activebackground "$GuiColor(btn_act_bg)" -background "$GuiColor(btn_bg)"  \
	 -padx {1} -pady {1} -highlightthickness {0} \
	 -relief {flat}  -text {left   }  -value {left}  -variable {analysis(translate_lr)}

  # build widget $topwin(analysis_name).info.geom.translate.upper.lr.radiobutton30
	radiobutton $topwin(analysis_name).info.geom.translate.upper.lr.radiobutton30 \
	 -activebackground "$GuiColor(btn_act_bg)" -background "$GuiColor(btn_bg)"  \
	 -padx {1} -pady {1} -highlightthickness {0} \
	 -relief {flat}  -text {right}  -value {right}  -variable {analysis(translate_lr)}

  # pack widget $topwin(analysis_name).info.geom.translate.upper.lr
  pack append $topwin(analysis_name).info.geom.translate.upper.lr  $topwin(analysis_name).info.geom.translate.upper.lr.radiobutton29 {top frame center}  $topwin(analysis_name).info.geom.translate.upper.lr.radiobutton30 {top frame center}

  # build widget $topwin(analysis_name).info.geom.translate.upper.lr_amount
  frame $topwin(analysis_name).info.geom.translate.upper.lr_amount  -background "$GuiColor(frame_bg)"  -borderwidth {2}

  # build widget $topwin(analysis_name).info.geom.translate.upper.lr_amount.frame1
  frame $topwin(analysis_name).info.geom.translate.upper.lr_amount.frame1 \
    -borderwidth {0} \
    -highlightthickness {0} \
	 -background "$GuiColor(frame_bg)" \
    -height {30} \
    -width {30}

  # build widget $topwin(analysis_name).info.geom.translate.upper.lr_amount.frame1.entry
  entry $topwin(analysis_name).info.geom.translate.upper.lr_amount.frame1.entry \
    -background "$GuiColor(entry_bg)" \
    -foreground "$GuiColor(entry_fg)" \
    -relief {sunken} \
    -textvariable {analysis(translate_lr_amount)} -width {5}

  endEntry $topwin(analysis_name).info.geom.translate.upper.lr_amount.frame1.entry 0 \
  	$topwin(analysis_name).info.geom.translate.upper.ud_amount.frame2.entry \
  	$topwin(analysis_name).info.geom.translate.lower.frame34.fill.frame1.entry 


  # build widget $topwin(analysis_name).info.geom.translate.upper.lr_amount.frame1.menubutton7
  menubutton $topwin(analysis_name).info.geom.translate.upper.lr_amount.frame1.menubutton7 \
	 -activebackground "$GuiColor(btn_act_bg)" -background "$GuiColor(btn_bg)"  \
    -font "$GuiMisc(pop_up_fn)" \
    -relief "$GuiMisc(pop_up_relief)" \
    -padx {1} -pady {1} -highlightthickness {0} \
    -text "$GuiMisc(pop_up_text)" -width {2}

  # bindings
  bind $topwin(analysis_name).info.geom.translate.upper.lr_amount.frame1.menubutton7 <Button-1> { MenuPopupPost $topwin(analysis_name).info.geom.translate.upper.lr_amount.frame1.menubutton7.menu0 %X %Y}
  bind $topwin(analysis_name).info.geom.translate.upper.lr_amount.frame1.menubutton7 <ButtonRelease-1> {MenuPopupRelease $topwin(analysis_name).info.geom.translate.upper.lr_amount.frame1.menubutton7.menu0 %W }

  # build widget $topwin(analysis_name).info.geom.translate.upper.lr_amount.frame1.menubutton7.menu0
  menu $topwin(analysis_name).info.geom.translate.upper.lr_amount.frame1.menubutton7.menu0 
  $topwin(analysis_name).info.geom.translate.upper.lr_amount.frame1.menubutton7.menu0 add command \
    -label {  0} \
	 -command {set analysis(translate_lr_amount) 0}
  $topwin(analysis_name).info.geom.translate.upper.lr_amount.frame1.menubutton7.menu0 add command \
    -label {  8} \
	 -command {set analysis(translate_lr_amount) 8}
  $topwin(analysis_name).info.geom.translate.upper.lr_amount.frame1.menubutton7.menu0 add command \
    -label { 16} \
	 -command {set analysis(translate_lr_amount) 16}
  $topwin(analysis_name).info.geom.translate.upper.lr_amount.frame1.menubutton7.menu0 add command \
    -label { 32} \
	 -command {set analysis(translate_lr_amount) 32}
  $topwin(analysis_name).info.geom.translate.upper.lr_amount.frame1.menubutton7.menu0 add command \
    -label { 64} \
	 -command {set analysis(translate_lr_amount) 64}
  $topwin(analysis_name).info.geom.translate.upper.lr_amount.frame1.menubutton7.menu0 add command \
    -label {128} \
	 -command {set analysis(translate_lr_amount) 128}
  $topwin(analysis_name).info.geom.translate.upper.lr_amount.frame1.menubutton7.menu0 add command \
    -label {256} \
	 -command {set analysis(translate_lr_amount) 256}
  $topwin(analysis_name).info.geom.translate.upper.lr_amount.frame1.menubutton7.menu0 add command \
    -label {512} \
	 -command {set analysis(translate_lr_amount) 512}

  bind $topwin(analysis_name).info.geom.translate.upper.lr_amount.frame1.menubutton7.menu0 <B1-Motion> { MenuPopupMotion $topwin(analysis_name).info.geom.translate.upper.lr_amount.frame1.menubutton7.menu0 %W %X %Y}
  bind $topwin(analysis_name).info.geom.translate.upper.lr_amount.frame1.menubutton7.menu0 <ButtonRelease-1>  { MenuPopupRelease $topwin(analysis_name).info.geom.translate.upper.lr_amount.frame1.menubutton7.menu0 %W }

  # pack master $topwin(analysis_name).info.geom.translate.upper.lr_amount.frame1
  pack configure $topwin(analysis_name).info.geom.translate.upper.lr_amount.frame1.menubutton7 \
    -fill both \
    -side right
  pack configure $topwin(analysis_name).info.geom.translate.upper.lr_amount.frame1.entry \
    -fill both \
    -side left

  # build widget $topwin(analysis_name).info.geom.translate.upper.lr_amount.label32
  label $topwin(analysis_name).info.geom.translate.upper.lr_amount.label32  -background "$GuiColor(label_bg)"  -text {pixels and}

  # pack widget $topwin(analysis_name).info.geom.translate.upper.lr_amount
  pack append $topwin(analysis_name).info.geom.translate.upper.lr_amount  \
  $topwin(analysis_name).info.geom.translate.upper.lr_amount.frame1 {left frame center} \
  $topwin(analysis_name).info.geom.translate.upper.lr_amount.label32 {left frame center}

  # build widget $topwin(analysis_name).info.geom.translate.upper.ud
  frame $topwin(analysis_name).info.geom.translate.upper.ud  -background "$GuiColor(frame_bg)"  -borderwidth {2}

  # build widget $topwin(analysis_name).info.geom.translate.upper.ud.up
	radiobutton $topwin(analysis_name).info.geom.translate.upper.ud.up -padx {1} -pady {1} \
	 -activebackground "$GuiColor(btn_act_bg)" -background "$GuiColor(btn_bg)"  \
	 -highlightthickness {0}  \
	 -relief {flat}  -text {up     }  -value {up}  -variable {analysis(translate_ud)}

  # build widget $topwin(analysis_name).info.geom.translate.upper.ud.down
	radiobutton $topwin(analysis_name).info.geom.translate.upper.ud.down -padx {1} -pady {1} \
	 -activebackground "$GuiColor(btn_act_bg)" -background "$GuiColor(btn_bg)"  \
	 -highlightthickness {0}   \
	 -relief {flat}  -text {down}  -value {down}  -variable {analysis(translate_ud)}

  # pack widget $topwin(analysis_name).info.geom.translate.upper.ud
  pack append $topwin(analysis_name).info.geom.translate.upper.ud  $topwin(analysis_name).info.geom.translate.upper.ud.up {top frame center}  $topwin(analysis_name).info.geom.translate.upper.ud.down {top frame center}

  # build widget $topwin(analysis_name).info.geom.translate.upper.ud_amount
  frame $topwin(analysis_name).info.geom.translate.upper.ud_amount  -background "$GuiColor(frame_bg)"  -borderwidth {2}

  # build widget $topwin(analysis_name).info.geom.translate.upper.ud_amount.frame2
  frame $topwin(analysis_name).info.geom.translate.upper.ud_amount.frame2 \
    -borderwidth {0} \
    -highlightthickness {0} \
	 -background "$GuiColor(frame_bg)" \
    -height {30} \
    -width {30}

  # build widget $topwin(analysis_name).info.geom.translate.upper.ud_amount.frame2.entry
  entry $topwin(analysis_name).info.geom.translate.upper.ud_amount.frame2.entry \
    -background "$GuiColor(entry_bg)" \
    -foreground "$GuiColor(entry_fg)" \
    -relief {sunken} \
    -textvariable {analysis(translate_ud_amount)} -width {5}
  endEntry $topwin(analysis_name).info.geom.translate.upper.ud_amount.frame2.entry 0 \
  	$topwin(analysis_name).info.geom.translate.lower.frame34.fill.frame1.entry  \
  	$topwin(analysis_name).info.geom.translate.upper.lr_amount.frame1.entry 

  # build widget $topwin(analysis_name).info.geom.translate.upper.ud_amount.frame2.menubutton7
  menubutton $topwin(analysis_name).info.geom.translate.upper.ud_amount.frame2.menubutton7 \
	 -activebackground "$GuiColor(btn_act_bg)" -background "$GuiColor(btn_bg)"  \
    -font "$GuiMisc(pop_up_fn)" \
    -relief "$GuiMisc(pop_up_relief)" \
    -padx {1} -pady {1} -highlightthickness {0} \
    -text "$GuiMisc(pop_up_text)" -width {2}

  # bindings
  bind $topwin(analysis_name).info.geom.translate.upper.ud_amount.frame2.menubutton7 <Button-1> { MenuPopupPost $topwin(analysis_name).info.geom.translate.upper.ud_amount.frame2.menubutton7.menu0 %X %Y}
  bind $topwin(analysis_name).info.geom.translate.upper.ud_amount.frame2.menubutton7 <ButtonRelease-1> {MenuPopupRelease $topwin(analysis_name).info.geom.translate.upper.ud_amount.frame2.menubutton7.menu0 %W }

  # build widget $topwin(analysis_name).info.geom.translate.upper.ud_amount.frame2.menubutton7.menu0
  menu $topwin(analysis_name).info.geom.translate.upper.ud_amount.frame2.menubutton7.menu0 
  $topwin(analysis_name).info.geom.translate.upper.ud_amount.frame2.menubutton7.menu0 add command \
    -label {  0} \
	 -command {set analysis(translate_ud_amount) 0}
  $topwin(analysis_name).info.geom.translate.upper.ud_amount.frame2.menubutton7.menu0 add command \
    -label {  8} \
	 -command {set analysis(translate_ud_amount) 8}
  $topwin(analysis_name).info.geom.translate.upper.ud_amount.frame2.menubutton7.menu0 add command \
    -label { 16} \
	 -command {set analysis(translate_ud_amount) 16}
  $topwin(analysis_name).info.geom.translate.upper.ud_amount.frame2.menubutton7.menu0 add command \
    -label { 32} \
	 -command {set analysis(translate_ud_amount) 32}
  $topwin(analysis_name).info.geom.translate.upper.ud_amount.frame2.menubutton7.menu0 add command \
    -label { 64} \
	 -command {set analysis(translate_ud_amount) 64}
  $topwin(analysis_name).info.geom.translate.upper.ud_amount.frame2.menubutton7.menu0 add command \
    -label {128} \
	 -command {set analysis(translate_ud_amount) 128}
  $topwin(analysis_name).info.geom.translate.upper.ud_amount.frame2.menubutton7.menu0 add command \
    -label {256} \
	 -command {set analysis(translate_ud_amount) 256}
  $topwin(analysis_name).info.geom.translate.upper.ud_amount.frame2.menubutton7.menu0 add command \
    -label {512} \
	 -command {set analysis(translate_ud_amount) 512}

  bind $topwin(analysis_name).info.geom.translate.upper.ud_amount.frame2.menubutton7.menu0 <B1-Motion> { MenuPopupMotion $topwin(analysis_name).info.geom.translate.upper.ud_amount.frame2.menubutton7.menu0 %W %X %Y}
  bind $topwin(analysis_name).info.geom.translate.upper.ud_amount.frame2.menubutton7.menu0 <ButtonRelease-1>  { MenuPopupRelease $topwin(analysis_name).info.geom.translate.upper.ud_amount.frame2.menubutton7.menu0 %W }

  # pack master $topwin(analysis_name).info.geom.translate.upper.ud_amount.frame2
  pack configure $topwin(analysis_name).info.geom.translate.upper.ud_amount.frame2.menubutton7 \
    -fill both \
    -side right
  pack configure $topwin(analysis_name).info.geom.translate.upper.ud_amount.frame2.entry \
    -fill both \
    -side left

  # build widget $topwin(analysis_name).info.geom.translate.upper.ud_amount.label32
  label $topwin(analysis_name).info.geom.translate.upper.ud_amount.label32  -background "$GuiColor(label_bg)"  -text {pixels.}

  # pack widget $topwin(analysis_name).info.geom.translate.upper.ud_amount
  pack append $topwin(analysis_name).info.geom.translate.upper.ud_amount  \
  	$topwin(analysis_name).info.geom.translate.upper.ud_amount.frame2 {left frame center} \
	$topwin(analysis_name).info.geom.translate.upper.ud_amount.label32 {left frame center}

  # pack widget $topwin(analysis_name).info.geom.translate.upper
  pack append $topwin(analysis_name).info.geom.translate.upper  $topwin(analysis_name).info.geom.translate.upper.label1 {left frame center}  $topwin(analysis_name).info.geom.translate.upper.lr {left frame center}  $topwin(analysis_name).info.geom.translate.upper.lr_amount {left frame center}  $topwin(analysis_name).info.geom.translate.upper.ud {left frame center}  $topwin(analysis_name).info.geom.translate.upper.ud_amount {left frame center fill}

  # build widget $topwin(analysis_name).info.geom.translate.lower
  frame $topwin(analysis_name).info.geom.translate.lower  -background "$GuiColor(frame_bg)"  -borderwidth {2}

  # build widget $topwin(analysis_name).info.geom.translate.lower.frame33
  frame $topwin(analysis_name).info.geom.translate.lower.frame33  -background "$GuiColor(frame_bg)"  -borderwidth {2}

  # build widget $topwin(analysis_name).info.geom.translate.lower.frame33.label35
  label $topwin(analysis_name).info.geom.translate.lower.frame33.label35  -background "$GuiColor(label_bg)"  -text {How should the image move?}

  # pack widget $topwin(analysis_name).info.geom.translate.lower.frame33
  pack append $topwin(analysis_name).info.geom.translate.lower.frame33  $topwin(analysis_name).info.geom.translate.lower.frame33.label35 {top frame center}

  # build widget $topwin(analysis_name).info.geom.translate.lower.frame34
  frame $topwin(analysis_name).info.geom.translate.lower.frame34  -background "$GuiColor(frame_bg)"  -borderwidth {2}

  # build widget $topwin(analysis_name).info.geom.translate.lower.frame34.wrap
  frame $topwin(analysis_name).info.geom.translate.lower.frame34.wrap  -background "$GuiColor(frame_bg)"  -borderwidth {2}

  # build widget $topwin(analysis_name).info.geom.translate.lower.frame34.wrap.radiobutton38
	radiobutton $topwin(analysis_name).info.geom.translate.lower.frame34.wrap.radiobutton38 \
	 -activebackground "$GuiColor(btn_act_bg)" -background "$GuiColor(btn_bg)"  \
	 -padx {1} -pady {1} -highlightthickness {0}  \
	 -command { pack forget $topwin(analysis_name).info.geom.translate.lower.frame34.fill.frame1}  \
	 -relief {flat}  -text {Wrap the image around the edges}  -value {y}  -variable {analysis(translate_wrap)}

  # pack widget $topwin(analysis_name).info.geom.translate.lower.frame34.wrap
  pack append $topwin(analysis_name).info.geom.translate.lower.frame34.wrap  $topwin(analysis_name).info.geom.translate.lower.frame34.wrap.radiobutton38 {top frame center}

  # build widget $topwin(analysis_name).info.geom.translate.lower.frame34.fill
  frame $topwin(analysis_name).info.geom.translate.lower.frame34.fill  -background "$GuiColor(frame_bg)"  -borderwidth {2}

  # build widget $topwin(analysis_name).info.geom.translate.lower.frame34.fill.radiobutton39
	radiobutton $topwin(analysis_name).info.geom.translate.lower.frame34.fill.radiobutton39 \
	 -activebackground "$GuiColor(btn_act_bg)" -background "$GuiColor(btn_bg)"  \
	 -padx {1} -pady {1} -highlightthickness {0} \
	 -command { 
  		pack append $topwin(analysis_name).info.geom.translate.lower.frame34.fill  \
  		$topwin(analysis_name).info.geom.translate.lower.frame34.fill.frame1 {left frame center} } \
	 -relief {flat}  -text {Fill the area left behind with a gray level value of}  -value {n}  -variable {analysis(translate_wrap)}

  # build widget $topwin(analysis_name).info.geom.translate.lower.frame34.fill.frame1
  frame $topwin(analysis_name).info.geom.translate.lower.frame34.fill.frame1 \
    -borderwidth {0} \
    -highlightthickness {0} \
	 -background "$GuiColor(frame_bg)" \
    -height {30} \
    -width {30}

  # build widget $topwin(analysis_name).info.geom.translate.lower.frame34.fill.frame1.entry
  entry $topwin(analysis_name).info.geom.translate.lower.frame34.fill.frame1.entry \
    -background "$GuiColor(entry_bg)" \
    -highlightthickness {0} \
    -foreground "$GuiColor(entry_fg)" \
    -relief {sunken} \
    -textvariable {analysis(translate_fill)} -width {5}

  endEntry $topwin(analysis_name).info.geom.translate.lower.frame34.fill.frame1.entry 0 \
  	$topwin(analysis_name).info.geom.translate.upper.lr_amount.frame1.entry\
  	$topwin(analysis_name).info.geom.translate.upper.ud_amount.frame2.entry

  # build widget $topwin(analysis_name).info.geom.translate.lower.frame34.fill.frame1.menubutton7
  menubutton $topwin(analysis_name).info.geom.translate.lower.frame34.fill.frame1.menubutton7 \
	 -activebackground "$GuiColor(btn_act_bg)" -background "$GuiColor(btn_bg)"  \
    -font "$GuiMisc(pop_up_fn)" \
    -relief "$GuiMisc(pop_up_relief)" \
    -padx {0} -pady {0} -highlightthickness {0} \
    -text "$GuiMisc(pop_up_text)" -width {2}

  # bindings
  bind $topwin(analysis_name).info.geom.translate.lower.frame34.fill.frame1.menubutton7 <Button-1> { MenuPopupPost $topwin(analysis_name).info.geom.translate.lower.frame34.fill.frame1.menubutton7.menu0 %X %Y}
  bind $topwin(analysis_name).info.geom.translate.lower.frame34.fill.frame1.menubutton7 <ButtonRelease-1> {MenuPopupRelease $topwin(analysis_name).info.geom.translate.lower.frame34.fill.frame1.menubutton7.menu0 %W }

  # build widget $topwin(analysis_name).info.geom.translate.lower.frame34.fill.frame1.menubutton7.menu0
  menu $topwin(analysis_name).info.geom.translate.lower.frame34.fill.frame1.menubutton7.menu0 
  $topwin(analysis_name).info.geom.translate.lower.frame34.fill.frame1.menubutton7.menu0 add command \
    -label {  0} \
	 -command {set analysis(translate_fill) 0}
  $topwin(analysis_name).info.geom.translate.lower.frame34.fill.frame1.menubutton7.menu0 add command \
    -label {  8} \
	 -command {set analysis(translate_fill) 8}
  $topwin(analysis_name).info.geom.translate.lower.frame34.fill.frame1.menubutton7.menu0 add command \
    -label { 16} \
	 -command {set analysis(translate_fill) 16}
  $topwin(analysis_name).info.geom.translate.lower.frame34.fill.frame1.menubutton7.menu0 add command \
    -label { 32} \
	 -command {set analysis(translate_fill) 32}
  $topwin(analysis_name).info.geom.translate.lower.frame34.fill.frame1.menubutton7.menu0 add command \
    -label { 64} \
	 -command {set analysis(translate_fill) 64}
  $topwin(analysis_name).info.geom.translate.lower.frame34.fill.frame1.menubutton7.menu0 add command \
    -label {128} \
	 -command {set analysis(translate_fill) 128}
  $topwin(analysis_name).info.geom.translate.lower.frame34.fill.frame1.menubutton7.menu0 add command \
    -label {256} \
	 -command {set analysis(translate_fill) 256}

  bind $topwin(analysis_name).info.geom.translate.lower.frame34.fill.frame1.menubutton7.menu0 <B1-Motion> { MenuPopupMotion $topwin(analysis_name).info.geom.translate.lower.frame34.fill.frame1.menubutton7.menu0 %W %X %Y}
  bind $topwin(analysis_name).info.geom.translate.lower.frame34.fill.frame1.menubutton7.menu0 <ButtonRelease-1>  { MenuPopupRelease $topwin(analysis_name).info.geom.translate.lower.frame34.fill.frame1.menubutton7.menu0 %W }

  # pack master $topwin(analysis_name).info.geom.translate.lower.frame34.fill.frame1
  pack configure $topwin(analysis_name).info.geom.translate.lower.frame34.fill.frame1.menubutton7 \
    -fill both \
    -side right
  pack configure $topwin(analysis_name).info.geom.translate.lower.frame34.fill.frame1.entry \
    -fill both \
    -side left

  # pack widget $topwin(analysis_name).info.geom.translate.lower.frame34.fill
  pack append $topwin(analysis_name).info.geom.translate.lower.frame34.fill  \
  $topwin(analysis_name).info.geom.translate.lower.frame34.fill.radiobutton39 {left frame center}

  # pack widget $topwin(analysis_name).info.geom.translate.lower.frame34
  pack append $topwin(analysis_name).info.geom.translate.lower.frame34  $topwin(analysis_name).info.geom.translate.lower.frame34.wrap {top frame sw}  $topwin(analysis_name).info.geom.translate.lower.frame34.fill {top frame nw}

  # pack widget $topwin(analysis_name).info.geom.translate.lower
  pack append $topwin(analysis_name).info.geom.translate.lower  $topwin(analysis_name).info.geom.translate.lower.frame33 {left frame center}  $topwin(analysis_name).info.geom.translate.lower.frame34 {left frame center expand fill}

  # pack widget $topwin(analysis_name).info.geom.translate
  pack append $topwin(analysis_name).info.geom.translate  $topwin(analysis_name).info.geom.translate.upper {top frame center expand fill}  $topwin(analysis_name).info.geom.translate.lower {top frame center expand fill}

  # build widget $topwin(analysis_name).info.geom.partial_zoom
  frame $topwin(analysis_name).info.geom.partial_zoom  -background "$GuiColor(frame_bg)"  -borderwidth {2}  -relief {ridge}

  # build widget $topwin(analysis_name).info.geom.partial_zoom.frame53
  frame $topwin(analysis_name).info.geom.partial_zoom.frame53  -background "$GuiColor(frame_bg)"  -borderwidth {2}

  # build widget $topwin(analysis_name).info.geom.partial_zoom.frame53.zoom
	radiobutton $topwin(analysis_name).info.geom.partial_zoom.frame53.zoom -padx {1} -pady {1}\
	 -activebackground "$GuiColor(btn_act_bg)" -background "$GuiColor(btn_bg)"  \
	 -highlightthickness {0} \
	 -relief {flat}  -text {Zoom :}  -value {zoom}  -variable {analysis(geometry)}

  # pack widget $topwin(analysis_name).info.geom.partial_zoom.frame53
  pack append $topwin(analysis_name).info.geom.partial_zoom.frame53  $topwin(analysis_name).info.geom.partial_zoom.frame53.zoom {top frame center}

  # build widget $topwin(analysis_name).info.geom.partial_zoom.frame54
  frame $topwin(analysis_name).info.geom.partial_zoom.frame54  -background "$GuiColor(frame_bg)"  -borderwidth {2}  -relief {ridge}

  # build widget $topwin(analysis_name).info.geom.partial_zoom.frame54.upper
  frame $topwin(analysis_name).info.geom.partial_zoom.frame54.upper  -background "$GuiColor(frame_bg)"  -borderwidth {2}

  # build widget $topwin(analysis_name).info.geom.partial_zoom.frame54.upper.radiobutton47
	radiobutton $topwin(analysis_name).info.geom.partial_zoom.frame54.upper.radiobutton47 \
	 -activebackground "$GuiColor(btn_act_bg)" -background "$GuiColor(btn_bg)"  \
	 -padx {1} -pady {1} -highlightthickness {0}  \
	 -relief {flat}  -text {upper left}  -value {1}  -variable {analysis(zoom_quadrant)}

  # build widget $topwin(analysis_name).info.geom.partial_zoom.frame54.upper.radiobutton48
	radiobutton $topwin(analysis_name).info.geom.partial_zoom.frame54.upper.radiobutton48 \
	 -activebackground "$GuiColor(btn_act_bg)" -background "$GuiColor(btn_bg)"  \
	 -padx {1} -pady {1} -highlightthickness {0}  \
	 -relief {flat}  -text {upper right}  -value {2}  -variable {analysis(zoom_quadrant)}

  # build widget $topwin(analysis_name).info.geom.partial_zoom.frame54.upper.radiobutton49
	radiobutton $topwin(analysis_name).info.geom.partial_zoom.frame54.upper.radiobutton49 \
	 -activebackground "$GuiColor(btn_act_bg)" -background "$GuiColor(btn_bg)"  \
	 -padx {1} -pady {1} -highlightthickness {0}\
	 -relief {flat}  -text {lower left}  -value {3}  -variable {analysis(zoom_quadrant)}

  # build widget $topwin(analysis_name).info.geom.partial_zoom.frame54.upper.radiobutton50
	radiobutton $topwin(analysis_name).info.geom.partial_zoom.frame54.upper.radiobutton50\
	-activebackground "$GuiColor(btn_act_bg)" -background "$GuiColor(btn_bg)"  \
	-padx {1} -pady {1} -highlightthickness {0} \
	-relief {flat}  -text {lower right quadrant, or}  -value {4}  -variable {analysis(zoom_quadrant)}

  # pack widget $topwin(analysis_name).info.geom.partial_zoom.frame54.upper
  pack append $topwin(analysis_name).info.geom.partial_zoom.frame54.upper  $topwin(analysis_name).info.geom.partial_zoom.frame54.upper.radiobutton47 {left frame center}  $topwin(analysis_name).info.geom.partial_zoom.frame54.upper.radiobutton48 {left frame center}  $topwin(analysis_name).info.geom.partial_zoom.frame54.upper.radiobutton49 {left frame center}  $topwin(analysis_name).info.geom.partial_zoom.frame54.upper.radiobutton50 {left frame center}

  # build widget $topwin(analysis_name).info.geom.partial_zoom.frame54.lower
  frame $topwin(analysis_name).info.geom.partial_zoom.frame54.lower  -background "$GuiColor(frame_bg)"  -borderwidth {2}

  # build widget $topwin(analysis_name).info.geom.partial_zoom.frame54.lower.frame57
  frame $topwin(analysis_name).info.geom.partial_zoom.frame54.lower.frame57  -background "$GuiColor(frame_bg)"  -borderwidth {2}

  # build widget $topwin(analysis_name).info.geom.partial_zoom.frame54.lower.frame57.area
	radiobutton $topwin(analysis_name).info.geom.partial_zoom.frame54.lower.frame57.area \
	-activebackground "$GuiColor(btn_act_bg)" -background "$GuiColor(btn_bg)"  \
	-padx {1} -pady {1} -highlightthickness {0} \
	-relief {flat}  -text {area}  -value {6}  -variable {analysis(zoom_quadrant)}

  # build widget $topwin(analysis_name).info.geom.partial_zoom.frame54.lower.frame57.label60
  label $topwin(analysis_name).info.geom.partial_zoom.frame54.lower.frame57.label60  -background "$GuiColor(label_bg)"  -text {beginning from row}

  # build widget $topwin(analysis_name).info.geom.partial_zoom.frame54.lower.frame57.frame1
  frame $topwin(analysis_name).info.geom.partial_zoom.frame54.lower.frame57.frame1 \
    -borderwidth {0} \
    -highlightthickness {0} \
	 -background "$GuiColor(frame_bg)" \
    -height {30} \
    -width {30}

  # build widget $topwin(analysis_name).info.geom.partial_zoom.frame54.lower.frame57.frame1.entry
  entry $topwin(analysis_name).info.geom.partial_zoom.frame54.lower.frame57.frame1.entry \
    -background "$GuiColor(entry_bg)" \
    -foreground "$GuiColor(entry_fg)" \
    -relief {sunken} \
    -textvariable {analysis(zoom_ul_row)} -width {5}

  endEntry $topwin(analysis_name).info.geom.partial_zoom.frame54.lower.frame57.frame1.entry 1 \
  	$topwin(analysis_name).info.geom.partial_zoom.frame54.lower.frame57.frame2.entry\
  	$topwin(analysis_name).info.geom.partial_zoom.frame55.frame1.entry


  # build widget $topwin(analysis_name).info.geom.partial_zoom.frame54.lower.frame57.frame1.menubutton7
  menubutton $topwin(analysis_name).info.geom.partial_zoom.frame54.lower.frame57.frame1.menubutton7 \
	 -activebackground "$GuiColor(btn_act_bg)" -background "$GuiColor(btn_bg)"  \
    -font "$GuiMisc(pop_up_fn)" \
    -relief "$GuiMisc(pop_up_relief)" \
    -padx {1} -pady {1} -highlightthickness {0} \
    -text "$GuiMisc(pop_up_text)" -width {2}

  # bindings
  bind $topwin(analysis_name).info.geom.partial_zoom.frame54.lower.frame57.frame1.menubutton7 <Button-1> { MenuPopupPost $topwin(analysis_name).info.geom.partial_zoom.frame54.lower.frame57.frame1.menubutton7.menu0 %X %Y}
  bind $topwin(analysis_name).info.geom.partial_zoom.frame54.lower.frame57.frame1.menubutton7 <ButtonRelease-1> {MenuPopupRelease $topwin(analysis_name).info.geom.partial_zoom.frame54.lower.frame57.frame1.menubutton7.menu0 %W }

  # build widget $topwin(analysis_name).info.geom.partial_zoom.frame54.lower.frame57.frame1.menubutton7.menu0
  menu $topwin(analysis_name).info.geom.partial_zoom.frame54.lower.frame57.frame1.menubutton7.menu0 
  $topwin(analysis_name).info.geom.partial_zoom.frame54.lower.frame57.frame1.menubutton7.menu0 add command \
    -label {  0} \
	 -command {set analysis(zoom_ul_row) 0}
  $topwin(analysis_name).info.geom.partial_zoom.frame54.lower.frame57.frame1.menubutton7.menu0 add command \
    -label {  8} \
	 -command {set analysis(zoom_ul_row) 8}
  $topwin(analysis_name).info.geom.partial_zoom.frame54.lower.frame57.frame1.menubutton7.menu0 add command \
    -label { 16} \
	 -command {set analysis(zoom_ul_row) 16}
  $topwin(analysis_name).info.geom.partial_zoom.frame54.lower.frame57.frame1.menubutton7.menu0 add command \
    -label { 32} \
	 -command {set analysis(zoom_ul_row) 32}
  $topwin(analysis_name).info.geom.partial_zoom.frame54.lower.frame57.frame1.menubutton7.menu0 add command \
    -label { 64} \
	 -command {set analysis(zoom_ul_row) 64}
  $topwin(analysis_name).info.geom.partial_zoom.frame54.lower.frame57.frame1.menubutton7.menu0 add command \
    -label {128} \
	 -command {set analysis(zoom_ul_row) 128}
  $topwin(analysis_name).info.geom.partial_zoom.frame54.lower.frame57.frame1.menubutton7.menu0 add command \
    -label {256} \
	 -command {set analysis(zoom_ul_row) 256}
  $topwin(analysis_name).info.geom.partial_zoom.frame54.lower.frame57.frame1.menubutton7.menu0 add command \
    -label {512} \
	 -command {set analysis(zoom_ul_row) 512}

  bind $topwin(analysis_name).info.geom.partial_zoom.frame54.lower.frame57.frame1.menubutton7.menu0 <B1-Motion> { MenuPopupMotion $topwin(analysis_name).info.geom.partial_zoom.frame54.lower.frame57.frame1.menubutton7.menu0 %W %X %Y}
  bind $topwin(analysis_name).info.geom.partial_zoom.frame54.lower.frame57.frame1.menubutton7.menu0 <ButtonRelease-1>  { MenuPopupRelease $topwin(analysis_name).info.geom.partial_zoom.frame54.lower.frame57.frame1.menubutton7.menu0 %W }

  # pack master $topwin(analysis_name).info.geom.partial_zoom.frame54.lower.frame57.frame1
  pack configure $topwin(analysis_name).info.geom.partial_zoom.frame54.lower.frame57.frame1.menubutton7 \
    -fill both \
    -side right
  pack configure $topwin(analysis_name).info.geom.partial_zoom.frame54.lower.frame57.frame1.entry \
    -fill both \
    -side left

  # build widget $topwin(analysis_name).info.geom.partial_zoom.frame54.lower.frame57.label62
  label $topwin(analysis_name).info.geom.partial_zoom.frame54.lower.frame57.label62  -background "$GuiColor(label_bg)"  -text {, column}

  # build widget $topwin(analysis_name).info.geom.partial_zoom.frame54.lower.frame57.frame2
  frame $topwin(analysis_name).info.geom.partial_zoom.frame54.lower.frame57.frame2 \
    -borderwidth {0} \
    -highlightthickness {0} \
	 -background "$GuiColor(frame_bg)" \
    -height {30} \
    -width {30}

  # build widget $topwin(analysis_name).info.geom.partial_zoom.frame54.lower.frame57.frame2.entry
  entry $topwin(analysis_name).info.geom.partial_zoom.frame54.lower.frame57.frame2.entry \
    -background "$GuiColor(entry_bg)" \
    -foreground "$GuiColor(entry_fg)" \
    -relief {sunken} \
    -textvariable {analysis(zoom_ul_col)} -width {5}

  endEntry $topwin(analysis_name).info.geom.partial_zoom.frame54.lower.frame57.frame2.entry 1 \
  	$topwin(analysis_name).info.geom.partial_zoom.frame54.lower.frame58.frame3.entry \
  	$topwin(analysis_name).info.geom.partial_zoom.frame54.lower.frame57.frame1.entry

  # build widget $topwin(analysis_name).info.geom.partial_zoom.frame54.lower.frame57.frame2.menubutton7
  menubutton $topwin(analysis_name).info.geom.partial_zoom.frame54.lower.frame57.frame2.menubutton7 \
	 -activebackground "$GuiColor(btn_act_bg)" -background "$GuiColor(btn_bg)"  \
    -font "$GuiMisc(pop_up_fn)" \
    -relief "$GuiMisc(pop_up_relief)" \
    -padx {1} -pady {1} -highlightthickness {0} \
    -text "$GuiMisc(pop_up_text)" -width {2}

  # bindings
  bind $topwin(analysis_name).info.geom.partial_zoom.frame54.lower.frame57.frame2.menubutton7 <Button-1> { MenuPopupPost $topwin(analysis_name).info.geom.partial_zoom.frame54.lower.frame57.frame2.menubutton7.menu0 %X %Y}
  bind $topwin(analysis_name).info.geom.partial_zoom.frame54.lower.frame57.frame2.menubutton7 <ButtonRelease-1> {MenuPopupRelease $topwin(analysis_name).info.geom.partial_zoom.frame54.lower.frame57.frame2.menubutton7.menu0 %W }

  # build widget $topwin(analysis_name).info.geom.partial_zoom.frame54.lower.frame57.frame2.menubutton7.menu0
  menu $topwin(analysis_name).info.geom.partial_zoom.frame54.lower.frame57.frame2.menubutton7.menu0 
  $topwin(analysis_name).info.geom.partial_zoom.frame54.lower.frame57.frame2.menubutton7.menu0 add command \
    -label {  0} \
	 -command {set analysis(zoom_ul_col) 0}
  $topwin(analysis_name).info.geom.partial_zoom.frame54.lower.frame57.frame2.menubutton7.menu0 add command \
    -label {  8} \
	 -command {set analysis(zoom_ul_col) 8}
  $topwin(analysis_name).info.geom.partial_zoom.frame54.lower.frame57.frame2.menubutton7.menu0 add command \
    -label { 16} \
	 -command {set analysis(zoom_ul_col) 16}
  $topwin(analysis_name).info.geom.partial_zoom.frame54.lower.frame57.frame2.menubutton7.menu0 add command \
    -label { 32} \
	 -command {set analysis(zoom_ul_col) 32}
  $topwin(analysis_name).info.geom.partial_zoom.frame54.lower.frame57.frame2.menubutton7.menu0 add command \
    -label { 64} \
	 -command {set analysis(zoom_ul_col) 64}
  $topwin(analysis_name).info.geom.partial_zoom.frame54.lower.frame57.frame2.menubutton7.menu0 add command \
    -label {128} \
	 -command {set analysis(zoom_ul_col) 128}
  $topwin(analysis_name).info.geom.partial_zoom.frame54.lower.frame57.frame2.menubutton7.menu0 add command \
    -label {256} \
	 -command {set analysis(zoom_ul_col) 256}
  $topwin(analysis_name).info.geom.partial_zoom.frame54.lower.frame57.frame2.menubutton7.menu0 add command \
    -label {512} \
	 -command {set analysis(zoom_ul_col) 512}

  bind $topwin(analysis_name).info.geom.partial_zoom.frame54.lower.frame57.frame2.menubutton7.menu0 <B1-Motion> { MenuPopupMotion $topwin(analysis_name).info.geom.partial_zoom.frame54.lower.frame57.frame2.menubutton7.menu0 %W %X %Y}
  bind $topwin(analysis_name).info.geom.partial_zoom.frame54.lower.frame57.frame2.menubutton7.menu0 <ButtonRelease-1>  { MenuPopupRelease $topwin(analysis_name).info.geom.partial_zoom.frame54.lower.frame57.frame2.menubutton7.menu0 %W }

  # pack master $topwin(analysis_name).info.geom.partial_zoom.frame54.lower.frame57.frame2
  pack configure $topwin(analysis_name).info.geom.partial_zoom.frame54.lower.frame57.frame2.menubutton7 \
    -fill both \
    -side right
  pack configure $topwin(analysis_name).info.geom.partial_zoom.frame54.lower.frame57.frame2.entry \
    -fill both \
    -side left

  # pack widget $topwin(analysis_name).info.geom.partial_zoom.frame54.lower.frame57
  pack append $topwin(analysis_name).info.geom.partial_zoom.frame54.lower.frame57  \
  $topwin(analysis_name).info.geom.partial_zoom.frame54.lower.frame57.area {left frame center}  \
  $topwin(analysis_name).info.geom.partial_zoom.frame54.lower.frame57.label60 {left frame center} \
  $topwin(analysis_name).info.geom.partial_zoom.frame54.lower.frame57.frame1 {left frame center}  \
  $topwin(analysis_name).info.geom.partial_zoom.frame54.lower.frame57.label62 {left frame center} \
  $topwin(analysis_name).info.geom.partial_zoom.frame54.lower.frame57.frame2 {left frame center}

  # build widget $topwin(analysis_name).info.geom.partial_zoom.frame54.lower.frame58
  frame $topwin(analysis_name).info.geom.partial_zoom.frame54.lower.frame58  -background "$GuiColor(frame_bg)"  -borderwidth {2}

  # build widget $topwin(analysis_name).info.geom.partial_zoom.frame54.lower.frame58.label64
  label $topwin(analysis_name).info.geom.partial_zoom.frame54.lower.frame58.label64  -background "$GuiColor(label_bg)"  -text {      with a height of }

  # build widget $topwin(analysis_name).info.geom.partial_zoom.frame54.lower.frame58.frame3
  frame $topwin(analysis_name).info.geom.partial_zoom.frame54.lower.frame58.frame3 \
    -borderwidth {0} \
    -highlightthickness {0} \
	 -background "$GuiColor(frame_bg)" \
    -height {30} \
    -width {30}

  # build widget $topwin(analysis_name).info.geom.partial_zoom.frame54.lower.frame58.frame3.entry
  entry $topwin(analysis_name).info.geom.partial_zoom.frame54.lower.frame58.frame3.entry \
    -background "$GuiColor(entry_bg)" \
    -foreground "$GuiColor(entry_fg)" \
    -relief {sunken} \
    -textvariable {analysis(zoom_height)} -width {5}

  endEntry $topwin(analysis_name).info.geom.partial_zoom.frame54.lower.frame58.frame3.entry 1\
  	$topwin(analysis_name).info.geom.partial_zoom.frame54.lower.frame58.frame4.entry \
  	$topwin(analysis_name).info.geom.partial_zoom.frame54.lower.frame57.frame2.entry 


  # build widget $topwin(analysis_name).info.geom.partial_zoom.frame54.lower.frame58.frame3.menubutton7
  menubutton $topwin(analysis_name).info.geom.partial_zoom.frame54.lower.frame58.frame3.menubutton7 \
	 -activebackground "$GuiColor(btn_act_bg)" -background "$GuiColor(btn_bg)"  \
    -font "$GuiMisc(pop_up_fn)" \
    -relief "$GuiMisc(pop_up_relief)" \
    -padx {1} -pady {1} -highlightthickness {0} \
    -text "$GuiMisc(pop_up_text)" -width {2}

  # bindings
  bind $topwin(analysis_name).info.geom.partial_zoom.frame54.lower.frame58.frame3.menubutton7 <Button-1> { MenuPopupPost $topwin(analysis_name).info.geom.partial_zoom.frame54.lower.frame58.frame3.menubutton7.menu0 %X %Y}
  bind $topwin(analysis_name).info.geom.partial_zoom.frame54.lower.frame58.frame3.menubutton7 <ButtonRelease-1> {MenuPopupRelease $topwin(analysis_name).info.geom.partial_zoom.frame54.lower.frame58.frame3.menubutton7.menu0 %W }

  # build widget $topwin(analysis_name).info.geom.partial_zoom.frame54.lower.frame58.frame3.menubutton7.menu0
  menu $topwin(analysis_name).info.geom.partial_zoom.frame54.lower.frame58.frame3.menubutton7.menu0 
  $topwin(analysis_name).info.geom.partial_zoom.frame54.lower.frame58.frame3.menubutton7.menu0 add command \
    -label {  8} \
	 -command {set analysis(zoom_height) 8}
  $topwin(analysis_name).info.geom.partial_zoom.frame54.lower.frame58.frame3.menubutton7.menu0 add command \
    -label { 16} \
	 -command {set analysis(zoom_height) 16}
  $topwin(analysis_name).info.geom.partial_zoom.frame54.lower.frame58.frame3.menubutton7.menu0 add command \
    -label { 32} \
	 -command {set analysis(zoom_height) 32}
  $topwin(analysis_name).info.geom.partial_zoom.frame54.lower.frame58.frame3.menubutton7.menu0 add command \
    -label { 64} \
	 -command {set analysis(zoom_height) 64}
  $topwin(analysis_name).info.geom.partial_zoom.frame54.lower.frame58.frame3.menubutton7.menu0 add command \
    -label {128} \
	 -command {set analysis(zoom_height) 128}
  $topwin(analysis_name).info.geom.partial_zoom.frame54.lower.frame58.frame3.menubutton7.menu0 add command \
    -label {256} \
	 -command {set analysis(zoom_height) 256}
  $topwin(analysis_name).info.geom.partial_zoom.frame54.lower.frame58.frame3.menubutton7.menu0 add command \
    -label {512} \
	 -command {set analysis(zoom_height) 512}

  bind $topwin(analysis_name).info.geom.partial_zoom.frame54.lower.frame58.frame3.menubutton7.menu0 <B1-Motion> { MenuPopupMotion $topwin(analysis_name).info.geom.partial_zoom.frame54.lower.frame58.frame3.menubutton7.menu0 %W %X %Y}
  bind $topwin(analysis_name).info.geom.partial_zoom.frame54.lower.frame58.frame3.menubutton7.menu0 <ButtonRelease-1>  { MenuPopupRelease $topwin(analysis_name).info.geom.partial_zoom.frame54.lower.frame58.frame3.menubutton7.menu0 %W }

  # pack master $topwin(analysis_name).info.geom.partial_zoom.frame54.lower.frame58.frame3
  pack configure $topwin(analysis_name).info.geom.partial_zoom.frame54.lower.frame58.frame3.menubutton7 \
    -fill both \
    -side right
  pack configure $topwin(analysis_name).info.geom.partial_zoom.frame54.lower.frame58.frame3.entry \
    -fill both \
    -side left

  # build widget $topwin(analysis_name).info.geom.partial_zoom.frame54.lower.frame58.label66
  label $topwin(analysis_name).info.geom.partial_zoom.frame54.lower.frame58.label66  -background "$GuiColor(label_bg)"  -text {and a width of}

  # build widget $topwin(analysis_name).info.geom.partial_zoom.frame54.lower.frame58.frame4
  frame $topwin(analysis_name).info.geom.partial_zoom.frame54.lower.frame58.frame4 \
    -borderwidth {0} \
    -highlightthickness {0} \
	 -background "$GuiColor(frame_bg)" \
    -height {30} \
    -width {30}

  # build widget $topwin(analysis_name).info.geom.partial_zoom.frame54.lower.frame58.frame4.entry
  entry $topwin(analysis_name).info.geom.partial_zoom.frame54.lower.frame58.frame4.entry \
    -background "$GuiColor(entry_bg)" \
    -foreground "$GuiColor(entry_fg)" \
    -relief {sunken} \
    -textvariable {analysis(zoom_width)} -width {5}

  endEntry $topwin(analysis_name).info.geom.partial_zoom.frame54.lower.frame58.frame4.entry 1 \
  	$topwin(analysis_name).info.geom.partial_zoom.frame55.frame1.entry \
  	$topwin(analysis_name).info.geom.partial_zoom.frame54.lower.frame58.frame3.entry 


  # build widget $topwin(analysis_name).info.geom.partial_zoom.frame54.lower.frame58.frame4.menubutton7
  menubutton $topwin(analysis_name).info.geom.partial_zoom.frame54.lower.frame58.frame4.menubutton7 \
	 -activebackground "$GuiColor(btn_act_bg)" -background "$GuiColor(btn_bg)"  \
    -font "$GuiMisc(pop_up_fn)" \
    -relief "$GuiMisc(pop_up_relief)" \
    -padx {1} -pady {1} -highlightthickness {0} \
    -text "$GuiMisc(pop_up_text)" -width {2}

  # bindings
  bind $topwin(analysis_name).info.geom.partial_zoom.frame54.lower.frame58.frame4.menubutton7 <Button-1> { MenuPopupPost $topwin(analysis_name).info.geom.partial_zoom.frame54.lower.frame58.frame4.menubutton7.menu0 %X %Y}
  bind $topwin(analysis_name).info.geom.partial_zoom.frame54.lower.frame58.frame4.menubutton7 <ButtonRelease-1> {MenuPopupRelease $topwin(analysis_name).info.geom.partial_zoom.frame54.lower.frame58.frame4.menubutton7.menu0 %W }

  # build widget $topwin(analysis_name).info.geom.partial_zoom.frame54.lower.frame58.frame4.menubutton7.menu0
  menu $topwin(analysis_name).info.geom.partial_zoom.frame54.lower.frame58.frame4.menubutton7.menu0 
  $topwin(analysis_name).info.geom.partial_zoom.frame54.lower.frame58.frame4.menubutton7.menu0 add command \
    -label {  0} \
	 -command {set analysis(zoom_width) 0}
  $topwin(analysis_name).info.geom.partial_zoom.frame54.lower.frame58.frame4.menubutton7.menu0 add command \
    -label {  8} \
	 -command {set analysis(zoom_width) 8}
  $topwin(analysis_name).info.geom.partial_zoom.frame54.lower.frame58.frame4.menubutton7.menu0 add command \
    -label { 16} \
	 -command {set analysis(zoom_width) 16}
  $topwin(analysis_name).info.geom.partial_zoom.frame54.lower.frame58.frame4.menubutton7.menu0 add command \
    -label { 32} \
	 -command {set analysis(zoom_width) 32}
  $topwin(analysis_name).info.geom.partial_zoom.frame54.lower.frame58.frame4.menubutton7.menu0 add command \
    -label { 64} \
	 -command {set analysis(zoom_width) 64}
  $topwin(analysis_name).info.geom.partial_zoom.frame54.lower.frame58.frame4.menubutton7.menu0 add command \
    -label {128} \
	 -command {set analysis(zoom_width) 128}
  $topwin(analysis_name).info.geom.partial_zoom.frame54.lower.frame58.frame4.menubutton7.menu0 add command \
    -label {256} \
	 -command {set analysis(zoom_width) 256}
  $topwin(analysis_name).info.geom.partial_zoom.frame54.lower.frame58.frame4.menubutton7.menu0 add command \
    -label {512} \
	 -command {set analysis(zoom_width) 512}

  bind $topwin(analysis_name).info.geom.partial_zoom.frame54.lower.frame58.frame4.menubutton7.menu0 <B1-Motion> { MenuPopupMotion $topwin(analysis_name).info.geom.partial_zoom.frame54.lower.frame58.frame4.menubutton7.menu0 %W %X %Y}
  bind $topwin(analysis_name).info.geom.partial_zoom.frame54.lower.frame58.frame4.menubutton7.menu0 <ButtonRelease-1>  { MenuPopupRelease $topwin(analysis_name).info.geom.partial_zoom.frame54.lower.frame58.frame4.menubutton7.menu0 %W }

  # pack master $topwin(analysis_name).info.geom.partial_zoom.frame54.lower.frame58.frame4
  pack configure $topwin(analysis_name).info.geom.partial_zoom.frame54.lower.frame58.frame4.menubutton7 \
    -fill both \
    -side right
  pack configure $topwin(analysis_name).info.geom.partial_zoom.frame54.lower.frame58.frame4.entry \
    -fill both \
    -side left

  # build widget $topwin(analysis_name).info.geom.partial_zoom.frame54.lower.frame58.label68
  label $topwin(analysis_name).info.geom.partial_zoom.frame54.lower.frame58.label68  -background "$GuiColor(label_bg)"  -text {pixels.}

  # pack widget $topwin(analysis_name).info.geom.partial_zoom.frame54.lower.frame58
  pack append $topwin(analysis_name).info.geom.partial_zoom.frame54.lower.frame58  \
  $topwin(analysis_name).info.geom.partial_zoom.frame54.lower.frame58.label64 {left frame center} \
  $topwin(analysis_name).info.geom.partial_zoom.frame54.lower.frame58.frame3 {left frame center}  \
  $topwin(analysis_name).info.geom.partial_zoom.frame54.lower.frame58.label66 {left frame center} \
  $topwin(analysis_name).info.geom.partial_zoom.frame54.lower.frame58.frame4 {left frame center} \
  $topwin(analysis_name).info.geom.partial_zoom.frame54.lower.frame58.label68 {left frame center}

  # pack widget $topwin(analysis_name).info.geom.partial_zoom.frame54.lower
  pack append $topwin(analysis_name).info.geom.partial_zoom.frame54.lower  $topwin(analysis_name).info.geom.partial_zoom.frame54.lower.frame57 {top frame center fillx}  $topwin(analysis_name).info.geom.partial_zoom.frame54.lower.frame58 {top frame center fillx}

  # pack widget $topwin(analysis_name).info.geom.partial_zoom.frame54
  pack append $topwin(analysis_name).info.geom.partial_zoom.frame54  $topwin(analysis_name).info.geom.partial_zoom.frame54.upper {top frame center expand fill}  $topwin(analysis_name).info.geom.partial_zoom.frame54.lower {top frame center expand fill}

  # build widget $topwin(analysis_name).info.geom.partial_zoom.frame55
  frame $topwin(analysis_name).info.geom.partial_zoom.frame55  -background "$GuiColor(frame_bg)"  -borderwidth {2}

  # build widget $topwin(analysis_name).info.geom.partial_zoom.frame55.by
  label $topwin(analysis_name).info.geom.partial_zoom.frame55.by  -background "$GuiColor(label_bg)"  -text {by}

  # build widget $topwin(analysis_name).info.geom.partial_zoom.frame55.frame1
  frame $topwin(analysis_name).info.geom.partial_zoom.frame55.frame1 \
    -borderwidth {0} \
    -highlightthickness {0} \
	 -background "$GuiColor(frame_bg)" \
    -height {30} \
    -width {30}

  # build widget $topwin(analysis_name).info.geom.partial_zoom.frame55.frame1.entry
  entry $topwin(analysis_name).info.geom.partial_zoom.frame55.frame1.entry \
    -background "$GuiColor(entry_bg)" \
    -foreground "$GuiColor(entry_fg)" \
    -relief {sunken} \
    -textvariable {analysis(zoom_factor)} -width {5}

  endEntry $topwin(analysis_name).info.geom.partial_zoom.frame55.frame1.entry 0 \
  	$topwin(analysis_name).info.geom.partial_zoom.frame54.lower.frame57.frame1.entry \
  	$topwin(analysis_name).info.geom.partial_zoom.frame54.lower.frame58.frame4.entry 

  # build widget $topwin(analysis_name).info.geom.partial_zoom.frame55.frame1.menubutton7
  menubutton $topwin(analysis_name).info.geom.partial_zoom.frame55.frame1.menubutton7 \
	 -activebackground "$GuiColor(btn_act_bg)" -background "$GuiColor(btn_bg)"  \
    -font "$GuiMisc(pop_up_fn)" \
    -relief "$GuiMisc(pop_up_relief)" \
    -padx {1} -pady {1} -highlightthickness {0} \
    -text "$GuiMisc(pop_up_text)" -width {2}

  # bindings
  bind $topwin(analysis_name).info.geom.partial_zoom.frame55.frame1.menubutton7 <Button-1> { MenuPopupPost $topwin(analysis_name).info.geom.partial_zoom.frame55.frame1.menubutton7.menu0 %X %Y}
  bind $topwin(analysis_name).info.geom.partial_zoom.frame55.frame1.menubutton7 <ButtonRelease-1> {MenuPopupRelease $topwin(analysis_name).info.geom.partial_zoom.frame55.frame1.menubutton7.menu0 %W }

  # build widget $topwin(analysis_name).info.geom.partial_zoom.frame55.frame1.menubutton7.menu0
  menu $topwin(analysis_name).info.geom.partial_zoom.frame55.frame1.menubutton7.menu0 
  $topwin(analysis_name).info.geom.partial_zoom.frame55.frame1.menubutton7.menu0 add command \
    -label { 0.5 } \
	 -command {set analysis(zoom_factor) 0.5}
  $topwin(analysis_name).info.geom.partial_zoom.frame55.frame1.menubutton7.menu0 add command \
    -label { 0.8 } \
	 -command {set analysis(zoom_factor) 0.8}
  $topwin(analysis_name).info.geom.partial_zoom.frame55.frame1.menubutton7.menu0 add command \
    -label { 1.2 } \
	 -command {set analysis(zoom_factor) 1.2}
  $topwin(analysis_name).info.geom.partial_zoom.frame55.frame1.menubutton7.menu0 add command \
    -label { 1.5 } \
	 -command {set analysis(zoom_factor) 1.5}
  $topwin(analysis_name).info.geom.partial_zoom.frame55.frame1.menubutton7.menu0 add command \
    -label { 2.0 } \
	 -command {set analysis(zoom_factor) 2.0}
  $topwin(analysis_name).info.geom.partial_zoom.frame55.frame1.menubutton7.menu0 add command \
    -label { 3.0 } \
	 -command {set analysis(zoom_factor) 3.0}
  $topwin(analysis_name).info.geom.partial_zoom.frame55.frame1.menubutton7.menu0 add command \
    -label { 5.0 } \
	 -command {set analysis(zoom_factor) 5.0}

  bind $topwin(analysis_name).info.geom.partial_zoom.frame55.frame1.menubutton7.menu0 <B1-Motion> { MenuPopupMotion $topwin(analysis_name).info.geom.partial_zoom.frame55.frame1.menubutton7.menu0 %W %X %Y}
  bind $topwin(analysis_name).info.geom.partial_zoom.frame55.frame1.menubutton7.menu0 <ButtonRelease-1>  { MenuPopupRelease $topwin(analysis_name).info.geom.partial_zoom.frame55.frame1.menubutton7.menu0 %W }

  # pack master $topwin(analysis_name).info.geom.partial_zoom.frame55.frame1
  pack configure $topwin(analysis_name).info.geom.partial_zoom.frame55.frame1.menubutton7 \
    -fill both \
    -side right
  pack configure $topwin(analysis_name).info.geom.partial_zoom.frame55.frame1.entry \
    -fill both \
    -side left

  # build widget $topwin(analysis_name).info.geom.partial_zoom.frame1
  frame $topwin(analysis_name).info.geom.partial_zoom.frame1 \
    -borderwidth {2} \
    -highlightthickness {0} \
	 -background "$GuiColor(frame_bg)" \
    -height {30} \
    -width {30}

  # build widget $topwin(analysis_name).info.geom.partial_zoom.frame1.label6
  entry $topwin(analysis_name).info.geom.partial_zoom.frame1.label6 \
    -background "$GuiColor(rentry_bg)" \
    -foreground "$GuiColor(rentry_fg)" \
    -relief {sunken} \
	 -state {disabled} \
    -textvariable {analysis(zoom_method)}

  # build widget $topwin(analysis_name).info.geom.partial_zoom.frame1.menubutton7
  menubutton $topwin(analysis_name).info.geom.partial_zoom.frame1.menubutton7 \
	 -activebackground "$GuiColor(btn_act_bg)" -background "$GuiColor(btn_spec_bg)"  \
    -padx {1} -pady {1} -highlightthickness {0} \
    -relief {flat} \
    -text {use}

  # bindings
  bind $topwin(analysis_name).info.geom.partial_zoom.frame1.menubutton7 <Button-1> { MenuPopupPost $topwin(analysis_name).info.geom.partial_zoom.frame1.menubutton7.menu0 %X %Y}
  bind $topwin(analysis_name).info.geom.partial_zoom.frame1.menubutton7 <ButtonRelease-1> {MenuPopupRelease $topwin(analysis_name).info.geom.partial_zoom.frame1.menubutton7.menu0 %W }

  # build widget $topwin(analysis_name).info.geom.partial_zoom.frame1.menubutton7.menu0
  menu $topwin(analysis_name).info.geom.partial_zoom.frame1.menubutton7.menu0 \
    -font {-Adobe-Helvetica-Bold-R-Normal--*-120-*}
  $topwin(analysis_name).info.geom.partial_zoom.frame1.menubutton7.menu0 add command \
    -label {zero order hold} \
	 -command {set analysis(zoom_method) "0 order"}
  $topwin(analysis_name).info.geom.partial_zoom.frame1.menubutton7.menu0 add command \
    -label {Linear Interpolation} \
	 -command {set analysis(zoom_method) "linear"}

  bind $topwin(analysis_name).info.geom.partial_zoom.frame1.menubutton7.menu0 <B1-Motion> { MenuPopupMotion $topwin(analysis_name).info.geom.partial_zoom.frame1.menubutton7.menu0 %W %X %Y}
  bind $topwin(analysis_name).info.geom.partial_zoom.frame1.menubutton7.menu0 <ButtonRelease-1>  { MenuPopupRelease $topwin(analysis_name).info.geom.partial_zoom.frame1.menubutton7.menu0 %W }

  # pack master $topwin(analysis_name).info.geom.partial_zoom.frame1
  pack configure $topwin(analysis_name).info.geom.partial_zoom.frame1.menubutton7 \
    -fill both \
    -side left
  pack configure $topwin(analysis_name).info.geom.partial_zoom.frame1.label6 \
    -fill both \
    -side right

  # pack widget $topwin(analysis_name).info.geom.partial_zoom.frame55
  pack append $topwin(analysis_name).info.geom.partial_zoom.frame55  \
  $topwin(analysis_name).info.geom.partial_zoom.frame55.by {left frame center}  \
  $topwin(analysis_name).info.geom.partial_zoom.frame55.frame1 {left frame center expand} 

  # pack widget $topwin(analysis_name).info.geom.partial_zoom
  pack append $topwin(analysis_name).info.geom.partial_zoom \
  $topwin(analysis_name).info.geom.partial_zoom.frame53 {left frame center fill} \
  $topwin(analysis_name).info.geom.partial_zoom.frame54 {left frame center fill}  \
  $topwin(analysis_name).info.geom.partial_zoom.frame55 {top frame center expand} \
  $topwin(analysis_name).info.geom.partial_zoom.frame1 {top frame center expand}

  # pack widget $topwin(analysis_name).info.geom
  pack append $topwin(analysis_name).info.geom  $topwin(analysis_name).info.geom.crop {top frame center expand fill}  $topwin(analysis_name).info.geom.cut_paste {top frame center expand fill}  $topwin(analysis_name).info.geom.enlarge {top frame center expand fill}  $topwin(analysis_name).info.geom.rotate {top frame center expand fill}  $topwin(analysis_name).info.geom.translate {top frame center expand fill}  $topwin(analysis_name).info.geom.partial_zoom {top frame center expand fill}

  # pack widget $topwin(analysis_name).info
  pack append $topwin(analysis_name).info  $topwin(analysis_name).info.geom {top frame center expand fill}

  # build widget $topwin(analysis_name).perform
  frame $topwin(analysis_name).perform  -background "$GuiColor(frame_bg)"  -borderwidth {2}  -relief {raised}

  # build widget $topwin(analysis_name).perform.perform
  frame $topwin(analysis_name).perform.perform  -background "$GuiColor(frame_bg)"  -borderwidth {2}

  # build widget $topwin(analysis_name).perform.perform.perform
	button $topwin(analysis_name).perform.perform.perform -padx {1} -pady {1} \
	-activebackground "$GuiColor(perf_act_bg)" \
	-background "$GuiColor(perf_bg)"  \
	-foreground "$GuiColor(perf_fg)"  \
	-highlightthickness {0}  \
	-command {\
  $topwin(analysis_name) configure -cursor watch; update
  if {$current_image == ""} {
 	 	CvipAlert "Please select an image first."
  	$topwin(analysis_name) configure -cursor top_left_arrow; update
  	return
  }
  if {[get_coord] == 0} {
     set null2  0
  } else {
	  if { $null2 == "MOUSE_COORDS" } {
	    set null2 1
		 selection clear .
     } else {set null2 0}
  }

  switch -exact -- $analysis(geometry) {

crop 	{
	if {$null2 == 1} {
     if {$cname != $current_image} {
         CvipAlert "Please select a subimage on the CURRENT image."
 	 $topwin(analysis_name) configure -cursor top_left_arrow; update
         return
     }
	  if [catch {set result [cvip $analysis(geometry) $current_image $row_coord $col_coord $d_row $d_col] } cresult ] {
      CvipAlert "$cresult"
		$topwin(analysis_name) configure -cursor top_left_arrow; update
		return
	  }
	  set analysis(crop_ul_row) $row_coord; set analysis(crop_ul_col) $col_coord
	  set  analysis(util_crop_height) $d_row; set analysis(util_crop_width) $d_col
	} else {
        if {[check_coord $analysis(crop_ul_row) $analysis(crop_ul_col) $analysis(util_crop_height) $analysis(util_crop_width)] != 1} {
 	 $topwin(analysis_name) configure -cursor top_left_arrow; update
	  return
	  } else  {
			 if [catch { set result [cvip $analysis(geometry) $current_image $analysis(crop_ul_row) $analysis(crop_ul_col) \
			 				$analysis(util_crop_height) $analysis(util_crop_width)] } cresult ] {
      		CvipAlert "$cresult"
				$topwin(analysis_name) configure -cursor top_left_arrow; update
				return
			 }
	  }
	}
	set temp $current_image
	set second_image $current_image
   set new_name [cvip rename $result ${current_image}_crop]
	img_q insert end $new_name
	image_post $new_name
   cvip view $new_name
	CvipMessage "crop image  \"$current_image\" at row $analysis(crop_ul_row), column $analysis(crop_ul_col),\
		\nwith height = $analysis(util_crop_height), and width = $analysis(util_crop_width)"
  	}

copy_paste {
	if [catch { scan [cvip info $second_image] {%s %s %d %d %d %s %s}\
					temp temp temp analysis(util_crop_height) analysis(util_crop_width) temp temp \
			} cresult] {
      CvipAlert "$cresult"
		$topwin(analysis_name) configure -cursor top_left_arrow; update
		return
	}
	if {$null2 == 1} {
     if {$cname != $current_image} {
         CvipAlert "Please select a point on the CURRENT image."
 	 $topwin(analysis_name) configure -cursor top_left_arrow; update
         return
     }
	set analysis(paste_to_row) $row_coord; set analysis(paste_to_col) $col_coord
	}

	if {[check_coord $analysis(paste_to_row) $analysis(paste_to_col) "0" "0"] != 1} {
      CvipAlert "Improper paste position: name = $current_image,\n\
				paste_to_row = $analysis(paste_to_row), paste_to_col = $analysis(paste_to_col)."
			$topwin(analysis_name) configure -cursor top_left_arrow; update
			return
	}
	if [catch {set result [cvip $analysis(geometry) $second_image $current_image 0 0\
		$analysis(util_crop_height) $analysis(util_crop_width) $analysis(paste_to_row) $analysis(paste_to_col) $analysis(paste_transparent)]} cresult] {
		CvipAlert $cresult
		$topwin(analysis_name) configure -cursor top_left_arrow; update
		return
	}
	set null2 0
	set temp $current_image
   set new_name [cvip rename $result ${current_image}_cp]
	img_q insert end $new_name
	image_post $new_name
   cvip view $new_name
	CvipMessage "paste image \"$second_image\" to image \"$temp\" \n \
	at row = $analysis(paste_to_row), and column = $analysis(paste_to_col)"
}
	
resize		{
   if [catch {expr $analysis(resize_width) + $analysis(resize_height)} temp] {
      CvipAlert "Numerical values required for resizing: \n\
      height = $analysis(resize_height) width = $analysis(resize_width)"
		$topwin(analysis_name) configure -cursor top_left_arrow; update
      return
   }
 
   if {$analysis(resize_width) < 0 || $analysis(resize_height) < 0} {
      CvipAlert "No negative values allowed for resizing: \n\
      height = $analysis(resize_height) width = $analysis(resize_width)"
		$topwin(analysis_name) configure -cursor top_left_arrow; update
      return
   }
 
	if {($analysis(resize_width) >= $cols && $analysis(resize_height) > $rows && $analysis(resize_linear) == "0") ||
	        ($analysis(resize_width) > $cols && $analysis(resize_height) >= $rows && $analysis(resize_linear) == "0")} {
		if [catch {set result [cvip enlarge $current_image $analysis(resize_height) $analysis(resize_width)]} cresult] {
		   CvipAlert "$cresult."
			$topwin(analysis_name) configure -cursor top_left_arrow; update
			return
		}
		set temp $current_image
		set new_name [cvip rename $result ${current_image}_$analysis(resize_width)x$analysis(resize_height)]
		img_q insert end $new_name
		image_post $new_name
		cvip view $new_name
		CvipMessage "resize image \"$temp\" to width = $analysis(resize_width), and height = \
			$analysis(resize_height) \n using zero-order hold"
	}
	if {($analysis(resize_width) < $cols && $analysis(resize_height) < $rows && $analysis(resize_linear) == "0") || 
	        ($analysis(resize_width) == $cols && $analysis(resize_height) < $rows && $analysis(resize_linear) == "0") || 
	        ($analysis(resize_width) < $cols && $analysis(resize_height) == $rows && $analysis(resize_linear) == "0")} {
		set temp $current_image
		set result [cvip spatial_quant $current_image 1  $analysis(resize_height) $analysis(resize_width)]
		set new_name [cvip rename $result ${current_image}_$analysis(resize_width)x$analysis(resize_height)]
		img_q insert end $new_name
		image_post $new_name
		cvip view $new_name
		CvipMessage "resize image \"$temp\" to width = $analysis(resize_width), and height = \
			$analysis(resize_height) \n using zero-order hold"
	}

	if {($analysis(resize_width) < $cols && $analysis(resize_height) > $rows) && $analysis(resize_linear) == "0"} {
		if [catch {set result [cvip enlarge $current_image $analysis(resize_height) $cols]} cresult] {
		   CvipAlert  "$cresult."
			$topwin(analysis_name) configure -cursor top_left_arrow; update
			return
		}
		
		set temp $current_image
		if [catch { set result [cvip spatial_quant $result 1  $analysis(resize_height) $analysis(resize_width)] } \
					cresult ] {
		   CvipAlert  "$cresult."
			$topwin(analysis_name) configure -cursor top_left_arrow; update
			return
		}
		if [catch {set new_name [cvip rename $result \
			${current_image}_$analysis(resize_width)x$analysis(resize_height)] } cresult ] {
		   CvipAlert  "$cresult."
			$topwin(analysis_name) configure -cursor top_left_arrow; update
			return
		}
		img_q insert end $new_name
		image_post $new_name
		cvip view $new_name		
		CvipMessage "resize image \"$temp\" to width = $analysis(resize_width), and height = \
			$analysis(resize_height) \n using zero-order hold"
	}

	if {($analysis(resize_width) > $cols && $analysis(resize_height) < $rows) && $analysis(resize_linear) == "0"} {
		if [catch {set result [cvip enlarge $current_image $rows $analysis(resize_width)]} cresult] {
		   CvipAlert  "$cresult."
			$topwin(analysis_name) configure -cursor top_left_arrow; update
			return
		}
		
		if [catch { set result [cvip spatial_quant $result 1  $analysis(resize_height) $analysis(resize_width)] }\
			cresult ] {
		   CvipAlert  "$cresult."
			$topwin(analysis_name) configure -cursor top_left_arrow; update
			return
		}
		set temp $current_image
		set new_name [cvip rename $result ${current_image}_$analysis(resize_width)x$analysis(resize_height)]
		img_q insert end $new_name
		image_post $new_name
		cvip view $new_name		
		CvipMessage "resize image \"$temp\" to width = $analysis(resize_width), and height = \
			$analysis(resize_height) \n using zero-order hold"
	}	

    if { $analysis(resize_linear) == "1"} {

        if {[expr 1.0*$analysis(resize_width) / $cols] > [expr 1.0*$analysis(resize_height) / $rows]} {
        	if [catch {set result0 [cvip bilinear_interp $current_image [expr 1.0*$analysis(resize_width) / $cols]]} cresult] {
		   CvipAlert "$cresult."
			$topwin(analysis_name) configure -cursor top_left_arrow; update
			return
		}
        }

        if {[expr 1.0*$analysis(resize_width) / $cols] < [expr 1.0*$analysis(resize_height) / $rows]} {
        	if [catch {set result0 [cvip bilinear_interp $current_image [expr 1.0*$analysis(resize_height) / $rows]]} cresult] {
		   CvipAlert "$cresult."
			$topwin(analysis_name) configure -cursor top_left_arrow; update
			return
		}
        }
       
        if {[expr 1.0*$analysis(resize_width) / $cols] != [expr 1.0*$analysis(resize_height) / $rows]} {
		if [ catch {set result [cvip spatial_quant $result0 1  $analysis(resize_height) $analysis(resize_width)]} \
				cresult ] {
		   CvipAlert  "$cresult."
			$topwin(analysis_name) configure -cursor top_left_arrow; update
			return
		}

		set temp $current_image
		set new_name [cvip rename $result ${current_image}_$analysis(resize_width)x$analysis(resize_height)]
		img_q insert end $new_name
		image_post $new_name
		cvip view $new_name
		CvipMessage "resize image \"$temp\" to width = $analysis(resize_width), and height = \
			$analysis(resize_height) \n using bilinear interplation"
	}
	
	if {([expr 1.0*$analysis(resize_width) / $cols] == [expr 1.0*$analysis(resize_height) / $rows]) && 
		($analysis(resize_width) != $cols)} {
        	if [catch {set result [cvip bilinear_interp $current_image [expr 1.0*$analysis(resize_width) / $cols]]} cresult] {
		   CvipAlert "$cresult."
			$topwin(analysis_name) configure -cursor top_left_arrow; update
			return
		}
		
		set temp $current_image
		set new_name [cvip rename $result ${current_image}_$analysis(resize_width)x$analysis(resize_height)]
		img_q insert end $new_name
		image_post $new_name
		cvip view $new_name	
		CvipMessage "resize image \"$temp\" to width = $analysis(resize_width), and height = \
			$analysis(resize_height) \n using bilinear interplation"
		
	}
    }

	if {$analysis(resize_width) == $cols && $analysis(resize_height) == $rows} {
		CvipAlert "You requested a new image of equal size to the current image.\
			Either the new width or new height must be different."
		$topwin(analysis_name) configure -cursor top_left_arrow; update
		return
	}
		}

rotate {
	if [catch {expr $analysis(rotate_degree)} temp] {
		CvipAlert "Numerical values required for rotation: \n\
		rotate angle = $analysis(rotate_degree)"
		$topwin(analysis_name) configure -cursor top_left_arrow; update
		return
	}
	if [catch { set result [cvip $analysis(geometry) $current_image $analysis(rotate_degree)] } cresult ] {
		CvipAlert  "$cresult."
		$topwin(analysis_name) configure -cursor top_left_arrow; update
		return
	}
	set temp $current_image
	set new_name [cvip rename $result ${current_image}_rot$analysis(rotate_degree)]
	img_q insert end $new_name
	image_post $new_name
	cvip view $new_name
	CvipMessage "image \"$temp\" is rotated by $analysis(rotate_degree) degrees clockwise"
  }

translate {
	if {$analysis(translate_wrap) == "y"} {
		set analysis(translate_fill) 0
	}
	if [catch {expr $analysis(translate_lr_amount) + $analysis(translate_ud_amount) + $analysis(translate_fill)} temp] {
		CvipAlert "Numerical values required for translation: \n\
		left/right slide  = $analysis(translate_lr_amount) \n\
		up/down slide = $analysis(translate_ud_amount)"
		$topwin(analysis_name) configure -cursor top_left_arrow; update
		return
	}
	if {$analysis(translate_lr) == "left"} {set temp1 [expr -$analysis(translate_lr_amount)]} \
	else {set temp1 $analysis(translate_lr_amount)}
	if {$analysis(translate_ud) == "up"} {set temp2 [expr -$analysis(translate_ud_amount)]} \
	else {set temp2 $analysis(translate_ud_amount)}
	if [catch {set result [cvip $analysis(geometry) $current_image $analysis(translate_wrap) \
					$temp2 $temp1 $analysis(translate_fill)]} cresult ] {
		CvipAlert  "$cresult."
		$topwin(analysis_name) configure -cursor top_left_arrow; update
		return
	}
	set temp $current_image
	set new_name [cvip rename $result ${current_image}_trs$analysis(translate_ud_amount)x$analysis(translate_lr_amount)]
	img_q insert end $new_name
	image_post $new_name
	cvip view $new_name
	CvipMessage "image \"$temp\" is shifted $analysis(translate_lr_amount) pixels $analysis(translate_lr),\n\
		and $analysis(translate_ud_amount) pixels $analysis(translate_ud)"
  }

zoom {
	set temp3 "$current_image"
	if {$analysis(zoom_factor) < "0.35"} {
                CvipAlert "The zoom factor should be more than 0.35. \n\
                 To shink an image, please try \"Resize\""
                $topwin(analysis_name) configure -cursor top_left_arrow; update
                return
        }

	if {$analysis(zoom_quadrant) == "6"} {
		if {$null2 == 1} {
     		if {$cname != $current_image} {
        		 CvipAlert "Please select a subimage on the CURRENT image."
			 $topwin(analysis_name) configure -cursor top_left_arrow; update
        		 return
     		}
			if { $analysis(zoom_factor) <= "1.0" || $analysis(zoom_method) == "0 order"} {
				if [catch { set result [cvip $analysis(geometry) $current_image $analysis(zoom_quadrant) $analysis(zoom_factor)\
								$col_coord $row_coord $d_col $d_row]  } cresult ] {
					CvipAlert  "$cresult."
					$topwin(analysis_name) configure -cursor top_left_arrow; update
					return
				}
			}  else {
				if [catch {set temp [cvip crop $current_image $row_coord $col_coord $d_row $d_col];\
							  set result [cvip bilinear_interp $temp $analysis(zoom_factor)]; cvip dq $temp } cresult ] {
					CvipAlert  "$cresult."
					$topwin(analysis_name) configure -cursor top_left_arrow; update
					return
				}
			}
			set analysis(zoom_ul_row) $row_coord; set analysis(zoom_ul_col) $col_coord
			set  analysis(zoom_height) $d_row; set analysis(zoom_width) $d_col
		} else {
			if { [check_coord $analysis(zoom_ul_row) $analysis(zoom_ul_col) $analysis(zoom_height) $analysis(zoom_width)] != "1" } {
				$topwin(analysis_name) configure -cursor top_left_arrow; update
				return
			} elseif { $analysis(zoom_factor) <= "1.0" || $analysis(zoom_method) == "0 order"} {
			 if [catch { set result [cvip $analysis(geometry) $current_image $analysis(zoom_quadrant) $analysis(zoom_factor)\
							$analysis(zoom_ul_col) $analysis(zoom_ul_row) $analysis(zoom_width) $analysis(zoom_height)] } cresult ] {
				CvipAlert  "$cresult."
				$topwin(analysis_name) configure -cursor top_left_arrow; update
				return
			 }
			} else {
				if [ catch { \
						set temp [cvip crop $current_image $analysis(zoom_ul_row) $analysis(zoom_ul_col) $analysis(zoom_height) $analysis(zoom_height)];\
						set result [cvip bilinear_interp $temp $analysis(zoom_factor)]; cvip dq $temp} cresult ] {
					CvipAlert  "$cresult."
					$topwin(analysis_name) configure -cursor top_left_arrow; update
					return
				}
			}
		}

		set temp2 "(the area at row =$analysis(zoom_ul_row), col =$analysis(zoom_ul_col),\
		with width =$analysis(zoom_width), and height =$analysis(zoom_height))"
	} else {
  		switch -exact -- $analysis(zoom_quadrant) {
		1 { set temp2 "(the 1st quadrant)" }
		2 { set temp2 "(the 2nd quadrant)" }
		3 { set temp2 "(the 3rd quadrant)" }
		4 { set temp2 "(the 4th quadrant)" }
		}
		if { $analysis(zoom_factor) <= "1.0" || $analysis(zoom_method) == "0 order"} {
			if [catch { \
						set result [cvip $analysis(geometry) $current_image $analysis(zoom_quadrant) $analysis(zoom_factor) -1 -1 -1 -1] \
						 } cresult ] {
				CvipAlert  "$cresult."
				$topwin(analysis_name) configure -cursor top_left_arrow; update
				return
			}
		} else {
			if [catch { \
						set temp [cvip $analysis(geometry) $current_image $analysis(zoom_quadrant) 1.0 -1 -1 -1 -1];\
						set result [cvip bilinear_interp $temp $analysis(zoom_factor)]; cvip dq $temp \
						 } cresult ] {
				CvipAlert  "$cresult."
				$topwin(analysis_name) configure -cursor top_left_arrow; update
				return
			}
		}
	}
	set new_name [cvip rename $result ${current_image}_zoom_$analysis(zoom_factor)]
	img_q insert end $new_name
	image_post $new_name
	cvip view $new_name
	CvipMessage "image \"$temp3\" $temp2 \n \
	is zoomed by factor $analysis(zoom_factor) using $analysis(zoom_method) interpolation"
  }
}
	$topwin(analysis_name) configure -cursor top_left_arrow; update
} \
-text {PERFORM}

  # build widget $topwin(analysis_name).perform.perform.dismiss
	button $topwin(analysis_name).perform.perform.dismiss -padx {1} -pady {1} \
	-highlightthickness {0}   \
	-activebackground "$GuiColor(dis_act_bg)"  -background "$GuiColor(dis_bg)" \
	-foreground "$GuiColor(dis_fg)" \
	-command {destroy $topwin(analysis_name); set topwin(analysis_name) NONE}  -text {DISMISS}  -width {10}

  # pack widget $topwin(analysis_name).perform.perform
  pack append $topwin(analysis_name).perform.perform  $topwin(analysis_name).perform.perform.dismiss {left frame sw expand}  $topwin(analysis_name).perform.perform.perform {left frame se expand}

  # pack widget $topwin(analysis_name).perform
  pack append $topwin(analysis_name).perform  $topwin(analysis_name).perform.perform {bottom frame center fillx}

  # build widget $topwin(analysis_name).current_image
  frame $topwin(analysis_name).current_image  -background "$GuiColor(frame_bg)"  -borderwidth {2}  -relief {ridge}

  # build widget $topwin(analysis_name).current_image.current
  label $topwin(analysis_name).current_image.current  -background "$GuiColor(label_bg)"  -text {Current image is :}

  # build widget $topwin(analysis_name).current_image.name
  label $topwin(analysis_name).current_image.name  -background "$GuiColor(label_bg)"  -foreground {Blue}  -text {}  -textvariable {current_image}

  # pack widget $topwin(analysis_name).current_image
  pack append $topwin(analysis_name).current_image  $topwin(analysis_name).current_image.current {left frame center filly}  $topwin(analysis_name).current_image.name {left frame center filly}

  # pack widget $topwin(analysis_name)
  pack append $topwin(analysis_name)  \
  $topwin(analysis_name).info {top frame center expand fill}  \
  $topwin(analysis_name).perform {bottom frame center fillx}  \
  $topwin(analysis_name).current_image {top frame center fill}
  pack configure $topwin(analysis_name).current_image -padx {2}
}
