# **********************************************************************
# Computer Vision/Image Processing Tool Project - Dr. Scott Umbaugh SIUE
# **********************************************************************
#
#             File Name: cmpr_lossless.tcl
#           Description: 
#         Related Files: 
#   Initial Coding Date: Sun Sep 22 13:08:47 CDT 1996
#           Portability: TCL script file
#            References:
#             Author(s): Mark Zuke and Yansheng Wei 
#                        Southern Illinois University @ Edwardsville
#
## Copyright (C) 1996 SIUE - by Scott Umbaugh, Yansheng Wei, and Mark Zuke.
##
## Permission to use, copy, modify, and distribute this software and its
## documentation for any purpose and without fee is hereby granted, provided
## that the above copyright notice appear in all copies and that both that
## copyright notice and this permission notice appear in supporting
## documentation.  This software is provided "as is" without express or
## implied warranty.
##
# RCS (Revision Control System) Information
# ...Added automatically by RCS 
#
## $Log: cmprs_lossless.tcl,v $
## Revision 1.14  1997/08/06 00:00:27  yawei
## fixed position problem
##
## Revision 1.13  1997/07/07 21:40:32  yawei
## Gui configuration in place
##
## Revision 1.12  1997/03/12 15:07:45  yawei
## fixed arrow button bugs
##
## Revision 1.11  1997/03/11 20:55:40  yawei
## Tcl/Tk script upgrading from tcl7.3/tk3.6 to tcl7.6/tk4.2
## compatible. This process is automated with tkboost perl
## script. @ Tue Mar 11 14:51:36 CST 1997
##
## Revision 1.10  1996/12/04 20:38:18  yawei
## changed lzw to zvl
##
# Revision 1.9  1996/11/30  18:24:14  yawei
# Changed DPCM to DPC
#
# Revision 1.8  1996/11/30  18:03:21  yawei
# changed command dpcm to dpc
#
# Revision 1.7  1996/10/16  15:56:36  mzuke
# moved 'view image' after 'image_post' to correctly label
# displayed images;checked for too-long new image names, none changed
#
# Revision 1.6  1996/09/28  17:31:29  mzuke
# added buttons for 'save decompressed image' and 'save compressed data'
# and changed image result naming to accept default names provided
# by the cviptcl functions
#
# Revision 1.5  1996/09/26  13:31:53  yawei
# changed naming problem
#
# Revision 1.4  1996/09/26  13:29:33  yawei
# Small changes
#
# Revision 1.3  1996/09/25  12:58:43  mzuke
# changed name 'lzw' to 'Ziv-Lempel'
#
# Revision 1.2  1996/09/22  18:42:00  yawei
# Moved global variables to GUI.tcl
#
# Revision 1.1  1996/09/22  18:37:51  yawei
# Initial revision
#
#
#****************************************************************************
# procedure to show Compress | Lossless window 
proc cmprs_lossless { } {# xf ignore me 7

  global {compress}
  # Window manager configurations
  global topwin
  global GuiColor
  global GuiMisc
  global GUI_DEBUG

  global toplevel_position

  if [ winfo exists $topwin(compress_name).info] {
     set tempname $topwin(compress_name);\
destroy $topwin(compress_name).info;\
set topwin(compress_name) $tempname;}
  if [ winfo exists $topwin(compress_name).current_image] {
     set tempname $topwin(compress_name);\
destroy $topwin(compress_name).current_image;\
set topwin(compress_name) $tempname;}
  if [ winfo exists $topwin(compress_name).perform] {
     set tempname $topwin(compress_name);\
destroy $topwin(compress_name).perform;\
set topwin(compress_name) $tempname;}
  wm positionfrom $topwin(compress_name) user
  wm sizefrom $topwin(compress_name) user
  wm geometry $topwin(compress_name) $topwin(compress_lossless)[get_pos $topwin(compress_name)]
  wm maxsize $topwin(compress_name) [lindex [split $topwin(compress_lossless_max)] 0] \
  	[lindex [split $topwin(compress_lossless_max)] 1]
  wm minsize $topwin(compress_name) [lindex [split $topwin(compress_lossless_min)] 0] \
  	[lindex [split $topwin(compress_lossless_min)] 1]
  wm title $topwin(compress_name) {COMPRESSION -> Lossless}

 # bindings
    bind $topwin(compress_name) <Destroy> {set topwin(compress_name) NONE}

  # build widget $topwin(compress_name).info
  frame $topwin(compress_name).info \
    -background "$GuiColor(frame_bg)"

  # build widget $topwin(compress_name).info.frame1
  frame $topwin(compress_name).info.frame1 \
    -background "$GuiColor(frame_bg)" \
    -borderwidth {2} \
    -relief {ridge}

  # build widget $topwin(compress_name).info.frame1.frame5
  frame $topwin(compress_name).info.frame1.frame5 \
    -background "$GuiColor(frame_bg)" \
    -borderwidth {2}

  # build widget $topwin(compress_name).info.frame1.frame5.radiobutton4
	radiobutton $topwin(compress_name).info.frame1.frame5.radiobutton4 -padx {1} -pady {1} -highlightthickness {0}  \
    -background "$GuiColor(btn_bg)" \
    -activebackground "$GuiColor(btn_act_bg)" \
    -command {pack $topwin(compress_name).info.frame1.frame6
pack append $topwin(compress_name).info.frame1  $topwin(compress_name).info.frame1.frame6 {left frame c}
} \
    -relief {flat} \
    -text {Bit-plane RLC} \
    -value {bitplane_rlc} \
    -variable {compress(lossless)}

  # pack widget $topwin(compress_name).info.frame1.frame5
  pack append $topwin(compress_name).info.frame1.frame5 \
    $topwin(compress_name).info.frame1.frame5.radiobutton4 {left frame center}

  # build widget $topwin(compress_name).info.frame1.frame6
  frame $topwin(compress_name).info.frame1.frame6 \
    -background "$GuiColor(frame_bg)" \
    -borderwidth {2}

  # build widget $topwin(compress_name).info.frame1.frame6.label7
  label $topwin(compress_name).info.frame1.frame6.label7 \
    -background "$GuiColor(label_bg)" \
    -text {Retain bits: }

  # build widget $topwin(compress_name).info.frame1.frame6.checkbutton16
	checkbutton $topwin(compress_name).info.frame1.frame6.checkbutton16 -padx {1} -pady {1} -highlightthickness {0}  \
    -background "$GuiColor(btn_bg)" \
    -activebackground "$GuiColor(btn_act_bg)" \
    -text {0} \
    -variable {compress(brc_bit_0)}

  # build widget $topwin(compress_name).info.frame1.frame6.checkbutton17
	checkbutton $topwin(compress_name).info.frame1.frame6.checkbutton17 -padx {1} -pady {1} -highlightthickness {0}  \
    -background "$GuiColor(btn_bg)" \
    -activebackground "$GuiColor(btn_act_bg)" \
    -text {1} \
    -variable {compress(brc_bit_1)}

  # build widget $topwin(compress_name).info.frame1.frame6.checkbutton18
	checkbutton $topwin(compress_name).info.frame1.frame6.checkbutton18 -padx {1} -pady {1} -highlightthickness {0}  \
    -background "$GuiColor(btn_bg)" \
    -activebackground "$GuiColor(btn_act_bg)" \
    -text {2} \
    -variable {compress(brc_bit_2)}

  # build widget $topwin(compress_name).info.frame1.frame6.checkbutton19
	checkbutton $topwin(compress_name).info.frame1.frame6.checkbutton19 -padx {1} -pady {1} -highlightthickness {0}  \
    -background "$GuiColor(btn_bg)" \
    -activebackground "$GuiColor(btn_act_bg)" \
    -text {3} \
    -variable {compress(brc_bit_3)}

  # build widget $topwin(compress_name).info.frame1.frame6.checkbutton20
	checkbutton $topwin(compress_name).info.frame1.frame6.checkbutton20 -padx {1} -pady {1} -highlightthickness {0}  \
    -background "$GuiColor(btn_bg)" \
    -activebackground "$GuiColor(btn_act_bg)" \
    -text {4} \
    -variable {compress(brc_bit_4)}

  # build widget $topwin(compress_name).info.frame1.frame6.checkbutton21
	checkbutton $topwin(compress_name).info.frame1.frame6.checkbutton21 -padx {1} -pady {1} -highlightthickness {0}  \
    -background "$GuiColor(btn_bg)" \
    -activebackground "$GuiColor(btn_act_bg)" \
    -text {5} \
    -variable {compress(brc_bit_5)}

  # build widget $topwin(compress_name).info.frame1.frame6.checkbutton22
	checkbutton $topwin(compress_name).info.frame1.frame6.checkbutton22 -padx {1} -pady {1} -highlightthickness {0}  \
    -background "$GuiColor(btn_bg)" \
    -activebackground "$GuiColor(btn_act_bg)" \
    -text {6} \
    -variable {compress(brc_bit_6)}

  # build widget $topwin(compress_name).info.frame1.frame6.checkbutton23
	checkbutton $topwin(compress_name).info.frame1.frame6.checkbutton23 -padx {1} -pady {1} -highlightthickness {0}  \
    -background "$GuiColor(btn_bg)" \
    -activebackground "$GuiColor(btn_act_bg)" \
    -text {7} \
    -variable {compress(brc_bit_7)}

  # pack widget $topwin(compress_name).info.frame1.frame6
  pack append $topwin(compress_name).info.frame1.frame6 \
    $topwin(compress_name).info.frame1.frame6.label7 {left frame center} \
    $topwin(compress_name).info.frame1.frame6.checkbutton16 {left frame center} \
    $topwin(compress_name).info.frame1.frame6.checkbutton17 {left frame center} \
    $topwin(compress_name).info.frame1.frame6.checkbutton18 {left frame center} \
    $topwin(compress_name).info.frame1.frame6.checkbutton19 {left frame center} \
    $topwin(compress_name).info.frame1.frame6.checkbutton20 {left frame center} \
    $topwin(compress_name).info.frame1.frame6.checkbutton21 {left frame center} \
    $topwin(compress_name).info.frame1.frame6.checkbutton22 {left frame center} \
    $topwin(compress_name).info.frame1.frame6.checkbutton23 {left frame center}

  # pack widget $topwin(compress_name).info.frame1
  pack append $topwin(compress_name).info.frame1 \
    $topwin(compress_name).info.frame1.frame5 {left frame center}

  # build widget $topwin(compress_name).info.frame2
  frame $topwin(compress_name).info.frame2 \
    -background "$GuiColor(frame_bg)" \
    -borderwidth {2} \
    -relief {ridge}

  # build widget $topwin(compress_name).info.frame2.radiobutton4
	radiobutton $topwin(compress_name).info.frame2.radiobutton4 -padx {1} -pady {1} -highlightthickness {0}  \
    -background "$GuiColor(btn_bg)" \
    -activebackground "$GuiColor(btn_act_bg)" \
    -command {pack forget $topwin(compress_name).info.frame1.frame6} \
    -relief {flat} \
    -text {Huffman} \
    -value {huffman} \
    -variable {compress(lossless)}

  # pack widget $topwin(compress_name).info.frame2
  pack append $topwin(compress_name).info.frame2 \
    $topwin(compress_name).info.frame2.radiobutton4 {left frame center}

  # build widget $topwin(compress_name).info.frame3
  frame $topwin(compress_name).info.frame3 \
    -background "$GuiColor(frame_bg)" \
    -borderwidth {2} \
    -relief {ridge}

  # build widget $topwin(compress_name).info.frame3.radiobutton4
	radiobutton $topwin(compress_name).info.frame3.radiobutton4 -padx {1} -pady {1} -highlightthickness {0}  \
    -background "$GuiColor(btn_bg)" \
    -activebackground "$GuiColor(btn_act_bg)" \
    -command {pack forget $topwin(compress_name).info.frame1.frame6} \
    -relief {flat} \
    -text {Ziv-Lempel} \
    -value {zvl} \
    -variable {compress(lossless)}

  # pack widget $topwin(compress_name).info.frame3
  pack append $topwin(compress_name).info.frame3 \
    $topwin(compress_name).info.frame3.radiobutton4 {left frame center}

  # build widget $topwin(compress_name).info.frame0
  frame $topwin(compress_name).info.frame0 \
    -background "$GuiColor(frame_bg)" \
    -borderwidth {2} \
    -relief {ridge}

  # build widget $topwin(compress_name).info.frame0.frame2
  frame $topwin(compress_name).info.frame0.frame2 \
    -background "$GuiColor(frame_bg)" \
    -borderwidth {2}

  # build widget $topwin(compress_name).info.frame0.frame2.radiobutton4
	radiobutton $topwin(compress_name).info.frame0.frame2.radiobutton4 -padx {1} -pady {1} -highlightthickness {0}  \
    -background "$GuiColor(btn_bg)" \
    -activebackground "$GuiColor(btn_act_bg)" \
    -command {pack forget $topwin(compress_name).info.frame1.frame1
pack forget $topwin(compress_name).info.frame3.frame3.frame6
set compress(encoding) "Reconstr. with Lloyd-Max quantizers"
pack forget $topwin(compress_name).info.frame1.frame6
} \
    -relief {flat} \
    -text {DPC} \
    -value {dpc} \
    -variable {compress(lossless)}

  # pack widget $topwin(compress_name).info.frame0.frame2
  pack append $topwin(compress_name).info.frame0.frame2 \
    $topwin(compress_name).info.frame0.frame2.radiobutton4 {left frame center expand fill}

  # build widget $topwin(compress_name).info.frame0.frame4
  frame $topwin(compress_name).info.frame0.frame4 \
    -background "$GuiColor(frame_bg)" \
    -borderwidth {2}

  # build widget $topwin(compress_name).info.frame0.frame4.frame3
  frame $topwin(compress_name).info.frame0.frame4.frame3 \
    -background "$GuiColor(frame_bg)" \
    -borderwidth {2}

  # build widget $topwin(compress_name).info.frame0.frame4.frame3.frame6
  frame $topwin(compress_name).info.frame0.frame4.frame3.frame6 \
    -background "$GuiColor(frame_bg)" \
    -borderwidth {2}

  # build widget $topwin(compress_name).info.frame0.frame4.frame3.frame6.label7
  label $topwin(compress_name).info.frame0.frame4.frame3.frame6.label7 \
    -background "$GuiColor(label_bg)" \
    -text {Correlation:}

  # build widget $topwin(compress_name).info.frame0.frame4.frame3.frame6.entry8
  entry $topwin(compress_name).info.frame0.frame4.frame3.frame6.entry8 \
    -background "$GuiColor(entry_bg)" \
	 -foreground "$GuiColor(entry_fg)" \
    -relief {sunken} \
    -textvariable {compress(correlation)} \
    -width {5}
  endEntry $topwin(compress_name).info.frame0.frame4.frame3.frame6.entry8 

  # build widget $topwin(compress_name).info.frame0.frame4.frame3.frame6.label9
  menubutton $topwin(compress_name).info.frame0.frame4.frame3.frame6.label9 \
    -background "$GuiColor(btn_bg)" \
    -activebackground "$GuiColor(btn_act_bg)" \
	 -padx {1} -pady {1} -highlightthickness {0}\
	 -font "$GuiMisc(pop_up_fn)" \
	 -text "$GuiMisc(pop_up_text)" \
	 -relief "$GuiMisc(pop_up_relief)" \
	 -width {2}
  # bindings
  bind $topwin(compress_name).info.frame0.frame4.frame3.frame6.label9 <Button-1> {MenuPopupPost $topwin(compress_name).info.frame0.frame4.frame3.frame6.label9.menu %X %Y}
  bind $topwin(compress_name).info.frame0.frame4.frame3.frame6.label9 <ButtonRelease-1> {MenuPopupRelease $topwin(compress_name).info.frame0.frame4.frame3.frame6.label9.menu %W}

  # build widget $topwin(compress_name).info.frame0.frame4.frame3.frame6.label9.menu
  menu $topwin(compress_name).info.frame0.frame4.frame3.frame6.label9.menu \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)"

  $topwin(compress_name).info.frame0.frame4.frame3.frame6.label9.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set compress(correlation) 0.80} \
    -label {0.80}
  $topwin(compress_name).info.frame0.frame4.frame3.frame6.label9.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set compress(correlation) 0.85
} \
    -label {0.85}
  $topwin(compress_name).info.frame0.frame4.frame3.frame6.label9.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set compress(correlation) 0.90
} \
    -label {0.90}
  $topwin(compress_name).info.frame0.frame4.frame3.frame6.label9.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set compress(correlation) 0.95} \
    -label {0.95}
  $topwin(compress_name).info.frame0.frame4.frame3.frame6.label9.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set compress(correlation) 0.98} \
    -label {0.98}
  $topwin(compress_name).info.frame0.frame4.frame3.frame6.label9.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set compress(correlation) 0.99} \
    -label {0.99}
  $topwin(compress_name).info.frame0.frame4.frame3.frame6.label9.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set compress(correlation) 1.00} \
    -label {1.00}
  bindtags $topwin(compress_name).info.frame0.frame4.frame3.frame6.label9.menu {Menu all}
  # bindings
  bind $topwin(compress_name).info.frame0.frame4.frame3.frame6.label9.menu <B1-Motion> {MenuPopupMotion $topwin(compress_name).info.frame0.frame4.frame3.frame6.label9.menu %W %X %Y}
  bind $topwin(compress_name).info.frame0.frame4.frame3.frame6.label9.menu <ButtonRelease-1> {MenuPopupRelease $topwin(compress_name).info.frame0.frame4.frame3.frame6.label9.menu %W}

  # pack widget $topwin(compress_name).info.frame0.frame4.frame3.frame6
  pack append $topwin(compress_name).info.frame0.frame4.frame3.frame6 \
    $topwin(compress_name).info.frame0.frame4.frame3.frame6.label7 {left frame center} \
    $topwin(compress_name).info.frame0.frame4.frame3.frame6.entry8 {left frame center} \
    $topwin(compress_name).info.frame0.frame4.frame3.frame6.label9 {left frame center}


  # build widget $topwin(compress_name).info.frame0.frame4.frame3.frame7
  frame $topwin(compress_name).info.frame0.frame4.frame3.frame7 \
    -background "$GuiColor(frame_bg)" \
    -borderwidth {2}

  # build widget $topwin(compress_name).info.frame0.frame4.frame3.frame7.label7
  label $topwin(compress_name).info.frame0.frame4.frame3.frame7.label7 \
    -background "$GuiColor(label_bg)" \
    -text {Number of bits:}

  # build widget $topwin(compress_name).info.frame0.frame4.frame3.frame7.entry8
  entry $topwin(compress_name).info.frame0.frame4.frame3.frame7.entry8 \
    -background "$GuiColor(rentry_bg)" \
	 -foreground "$GuiColor(rentry_fg)" \
    -relief {sunken} \
    -state {disabled} \
    -textvariable {compress(bits)} \
    -width {2}

  # build widget $topwin(compress_name).info.frame0.frame4.frame3.frame7.label9
  menubutton $topwin(compress_name).info.frame0.frame4.frame3.frame7.label9 \
    -background "$GuiColor(btn_bg)" \
    -activebackground "$GuiColor(btn_act_bg)" \
	 -padx {1} -pady {1} -highlightthickness {0}\
	 -font "$GuiMisc(pop_up_fn)" \
	 -text "$GuiMisc(pop_up_text)" \
	 -relief "$GuiMisc(pop_up_relief)" \
	 -width {2}
  # bindings
  bind $topwin(compress_name).info.frame0.frame4.frame3.frame7.label9 <Button-1> {MenuPopupPost $topwin(compress_name).info.frame0.frame4.frame3.frame7.label9.menu %X %Y}
  bind $topwin(compress_name).info.frame0.frame4.frame3.frame7.label9 <ButtonRelease-1> {MenuPopupRelease $topwin(compress_name).info.frame0.frame4.frame3.frame7.label9.menu %W}

  # build widget $topwin(compress_name).info.frame0.frame4.frame3.frame7.label9.menu
  menu $topwin(compress_name).info.frame0.frame4.frame3.frame7.label9.menu \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)"
  $topwin(compress_name).info.frame0.frame4.frame3.frame7.label9.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set compress(bits) 1} \
    -label { 1 }
  $topwin(compress_name).info.frame0.frame4.frame3.frame7.label9.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set compress(bits) 2} \
    -label { 2 }
  $topwin(compress_name).info.frame0.frame4.frame3.frame7.label9.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set compress(bits) 3} \
    -label { 3 }
  $topwin(compress_name).info.frame0.frame4.frame3.frame7.label9.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set compress(bits) 4} \
    -label { 4 }
  $topwin(compress_name).info.frame0.frame4.frame3.frame7.label9.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set compress(bits) 5} \
    -label { 5 }
  $topwin(compress_name).info.frame0.frame4.frame3.frame7.label9.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set compress(bits) 6} \
    -label { 6 }
  $topwin(compress_name).info.frame0.frame4.frame3.frame7.label9.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set compress(bits) 7} \
    -label { 7 }
  $topwin(compress_name).info.frame0.frame4.frame3.frame7.label9.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set compress(bits) 8} \
    -label { 8 }
  bindtags $topwin(compress_name).info.frame0.frame4.frame3.frame7.label9.menu {Menu all}
  # bindings
  bind $topwin(compress_name).info.frame0.frame4.frame3.frame7.label9.menu <B1-Motion> {MenuPopupMotion $topwin(compress_name).info.frame0.frame4.frame3.frame7.label9.menu %W %X %Y}
  bind $topwin(compress_name).info.frame0.frame4.frame3.frame7.label9.menu <ButtonRelease-1> {MenuPopupRelease $topwin(compress_name).info.frame0.frame4.frame3.frame7.label9.menu %W}

  # pack widget $topwin(compress_name).info.frame0.frame4.frame3.frame7
  pack append $topwin(compress_name).info.frame0.frame4.frame3.frame7 \
    $topwin(compress_name).info.frame0.frame4.frame3.frame7.label7 {left frame center} \
    $topwin(compress_name).info.frame0.frame4.frame3.frame7.entry8 {left frame center} \
    $topwin(compress_name).info.frame0.frame4.frame3.frame7.label9 {left frame center}

  # build widget $topwin(compress_name).info.frame0.frame4.frame3.frame8
  frame $topwin(compress_name).info.frame0.frame4.frame3.frame8 \
    -background "$GuiColor(frame_bg)" \
    -borderwidth {2}

  # build widget $topwin(compress_name).info.frame0.frame4.frame3.frame8.label7
  label $topwin(compress_name).info.frame0.frame4.frame3.frame8.label7 \
    -background "$GuiColor(label_bg)" \
    -text {Scan direction:}

  # build widget $topwin(compress_name).info.frame0.frame4.frame3.frame8.entry8
  entry $topwin(compress_name).info.frame0.frame4.frame3.frame8.entry8 \
    -background "$GuiColor(rentry_bg)" \
	 -foreground "$GuiColor(rentry_fg)" \
    -relief {sunken} \
    -state {disabled} \
    -textvariable {compress(direction)} \
    -width {9}

  # build widget $topwin(compress_name).info.frame0.frame4.frame3.frame8.label9
  menubutton $topwin(compress_name).info.frame0.frame4.frame3.frame8.label9 \
    -background "$GuiColor(btn_bg)" \
    -activebackground "$GuiColor(btn_act_bg)" \
	 -padx {1} -pady {1} -highlightthickness {0}\
	 -font "$GuiMisc(pop_up_fn)" \
	 -text "$GuiMisc(pop_up_text)" \
	 -relief "$GuiMisc(pop_up_relief)" \
	 -width {2}
  # bindings
  bind $topwin(compress_name).info.frame0.frame4.frame3.frame8.label9 <Button-1> {MenuPopupPost $topwin(compress_name).info.frame0.frame4.frame3.frame8.label9.menu %X %Y}
  bind $topwin(compress_name).info.frame0.frame4.frame3.frame8.label9 <ButtonRelease-1> {MenuPopupRelease $topwin(compress_name).info.frame0.frame4.frame3.frame8.label9.menu %W}

  # build widget $topwin(compress_name).info.frame0.frame4.frame3.frame8.label9.menu
  menu $topwin(compress_name).info.frame0.frame4.frame3.frame8.label9.menu \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)"
  $topwin(compress_name).info.frame0.frame4.frame3.frame8.label9.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set compress(direction) Horizontal
set compress(dpcm_dir) 0} \
    -label {Horizontal}
  $topwin(compress_name).info.frame0.frame4.frame3.frame8.label9.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set compress(direction) Vertical
set compress(dpcm_dir) 1} \
    -label {Vertical}
  bindtags $topwin(compress_name).info.frame0.frame4.frame3.frame8.label9.menu {Menu all}
  # bindings
  bind $topwin(compress_name).info.frame0.frame4.frame3.frame8.label9.menu <B1-Motion> {MenuPopupMotion $topwin(compress_name).info.frame0.frame4.frame3.frame8.label9.menu %W %X %Y}
  bind $topwin(compress_name).info.frame0.frame4.frame3.frame8.label9.menu <ButtonRelease-1> {MenuPopupRelease $topwin(compress_name).info.frame0.frame4.frame3.frame8.label9.menu %W}

  # pack widget $topwin(compress_name).info.frame0.frame4.frame3.frame8
  pack append $topwin(compress_name).info.frame0.frame4.frame3.frame8 \
    $topwin(compress_name).info.frame0.frame4.frame3.frame8.label7 {left frame center} \
    $topwin(compress_name).info.frame0.frame4.frame3.frame8.entry8 {left frame center} \
    $topwin(compress_name).info.frame0.frame4.frame3.frame8.label9 {left frame center}


  # pack widget $topwin(compress_name).info.frame0.frame4.frame3
  pack append $topwin(compress_name).info.frame0.frame4.frame3 \
    $topwin(compress_name).info.frame0.frame4.frame3.frame6 {left frame center}\
    $topwin(compress_name).info.frame0.frame4.frame3.frame8 {left frame center}\
    $topwin(compress_name).info.frame0.frame4.frame3.frame7 {left frame center} 


  # pack widget $topwin(compress_name).info.frame0.frame4
  pack append $topwin(compress_name).info.frame0.frame4 \
    $topwin(compress_name).info.frame0.frame4.frame3 {top frame center expand fillx} 

  # pack widget $topwin(compress_name).info.frame0
  pack append $topwin(compress_name).info.frame0 \
    $topwin(compress_name).info.frame0.frame2 {left frame center} \
    $topwin(compress_name).info.frame0.frame4 {left frame center expand fillx}

  # pack widget $topwin(compress_name).info
  pack append $topwin(compress_name).info \
    $topwin(compress_name).info.frame1 {top frame center expand fill} \
    $topwin(compress_name).info.frame2 {top frame center expand fill} \
    $topwin(compress_name).info.frame3 {top frame center expand fill}\
    $topwin(compress_name).info.frame0 {top frame center expand fill} 

  # build widget $topwin(compress_name).current_image
  frame $topwin(compress_name).current_image \
    -background "$GuiColor(frame_bg)" \
    -borderwidth {2} \
    -relief {ridge}

  # build widget $topwin(compress_name).current_image.label0
  label $topwin(compress_name).current_image.label0 \
    -background "$GuiColor(label_bg)" \
    -text {Current image: }

  # build widget $topwin(compress_name).current_image.label1
  label $topwin(compress_name).current_image.label1 \
    -background "$GuiColor(label_bg)" \
    -foreground {Blue} \
    -text {} \
    -textvariable {current_image}

  # pack widget $topwin(compress_name).current_image
  pack append $topwin(compress_name).current_image \
    $topwin(compress_name).current_image.label0 {left frame center} \
    $topwin(compress_name).current_image.label1 {left frame center}

  # build widget $topwin(compress_name).perform
  frame $topwin(compress_name).perform \
    -background "$GuiColor(frame_bg)" \
    -borderwidth {2} \
    -relief {raised}

  # build widget $topwin(compress_name).perform.button2
	button $topwin(compress_name).perform.button2 -padx {1} -pady {1} -highlightthickness {0}  \
    -foreground "$GuiColor(dis_fg)" \
    -background "$GuiColor(dis_bg)" \
    -activebackground "$GuiColor(dis_act_bg)" \
	 -command "destroy $topwin(compress_name)" \
    -text {DISMISS}

  # build widget $topwin(compress_name).perform.button3
	button $topwin(compress_name).perform.button3 -padx {1} -pady {1} -highlightthickness {0}  \
    -foreground "$GuiColor(perf_fg)" \
    -background "$GuiColor(perf_bg)" \
    -activebackground "$GuiColor(perf_act_bg)" \
    -command {
      $topwin(compress_name) configure -cursor watch; update
      if {$current_image == ""} {
         CvipAlert "Please select an image first."
         $topwin(compress_name) configure -cursor top_left_arrow; update
         return
      }  
	switch -exact  -- $compress(lossless) {
		bitplane_rlc {
			set temp2 "\{ "
			for {set i 0} {$i < 8} {incr i} {
				set temp3 "brc_bit_"
				append temp3 $i				
				if {$compress($temp3)} {
					append temp2 $i
				}
				unset temp3
			}
			set temp2 [append temp2 \}]
			if { $GUI_DEBUG == "1" } {
				puts stderr "temp2 = $temp2"
			}
			if [catch {set result [cvip $compress(lossless) $current_image $temp2]} cresult] {
				CvipAlert "$cresult."
				$topwin(compress_name) configure -cursor top_left_arrow; update
				return
			}
			set new_name $result
   	   img_q insert end $new_name
         image_post $new_name
   	   cvip view $new_name
			unset temp2
			CvipMessage "bit-plane RLE performed on image \"$current_image\""
		}

		zvl -
		huffman {
			if { $GUI_DEBUG == "1" } {
				puts stderr "cvip $compress(lossless) $current_image"
			}
			if [catch {set result [cvip $compress(lossless) $current_image]} cresult] {
					CvipAlert "$cresult."
				$topwin(compress_name) configure -cursor top_left_arrow; update
				return
			}
			set new_name $result
   	   img_q insert end $new_name
         image_post $new_name
			cvip view $new_name
			if { $compress(lossless) == "zvl" } {
				CvipMessage "Ziv-Lempel compression performed on image \"$current_image\""
			} else {
				CvipMessage "Huffman encoding  performed on image \"$current_image\""
			}
		}

			dpc {
				set temp "cvip dpc $current_image "
				if [catch {expr $compress(correlation)}] {
					CvipAlert "Numerical values required for the correlation ratio:\n\
					Correlation = $compress(correlation)"
         		$topwin(compress_name) configure -cursor top_left_arrow; update
		         return
				} elseif { $compress(correlation) < "0" || $compress(correlation) > "1" } {
					CvipAlert "The correlation ratio ($compress(correlation)) should be in the range (0-1)."
         		$topwin(compress_name) configure -cursor top_left_arrow; update
		         return
				} else {
					append temp "$compress(correlation) "
				}

				append temp "0 $compress(bits) "

				if { $compress(direction) == "Vertical" } {
					append temp "1 "
				} else {
					append temp "0 "
				}

				append temp "1 -1"

				if { $GUI_DEBUG == "1" } {
					puts stderr  "$temp"
				}
				if [catch {set result [eval $temp] } cresult ] {
					CvipAlert "$cresult."
         		$topwin(compress_name) configure -cursor top_left_arrow; update
		         return
				} 
				set new_name $result
            img_q insert end $new_name
            image_post $new_name
            cvip view $new_name
				CvipMessage "differential predictive coding (DPC) performed on image \"$current_image\""
			}


	}

	  $topwin(compress_name) configure -cursor top_left_arrow; update
     } \
    -text {PERFORM}

  # build widget $topwin(compress_name).perform.button4
	button $topwin(compress_name).perform.button4 -padx {1} -pady {1} -highlightthickness {0}  \
    -foreground "$GuiColor(alert_fg)" \
    -background "$GuiColor(alert_bg)" \
    -activebackground "$GuiColor(alert_act_bg)" \
    -command {
	if {[file exists $current_image]} {
		if [AlertBox "File name \"$current_image\" already exists. Overwrite it?" "" 350x150 "ALERT!" YES NO] {
			$topwin(compress_name) configure -cursor top_left_arrow; update
			return
		}
		
	}
	cvip save $current_image
	$topwin(compress_name) configure -cursor top_left_arrow; update} \
    -text {SAVE DECOMPRESSED IMAGE}

  # build widget $topwin(compress_name).perform.button5
	button $topwin(compress_name).perform.button5 -padx {1} -pady {1} -highlightthickness {0}  \
    -foreground "$GuiColor(alert_fg)" \
    -background "$GuiColor(alert_bg)" \
    -activebackground "$GuiColor(alert_act_bg)" \
    -command {
	if {[file exists $current_image]} {
		if [AlertBox "File name \"$current_image\" already exists. Overwrite it?" "" 350x150 "ALERT!" YES NO] {
			$topwin(compress_name) configure -cursor top_left_arrow; update
			return
		}
		
	}
	cvip save $current_image vip
	$topwin(compress_name) configure -cursor top_left_arrow; update} \
    -text {SAVE COMPRESSED DATA}


  # pack widget $topwin(compress_name).perform
  pack append $topwin(compress_name).perform \
    $topwin(compress_name).perform.button2 {left frame center} \
    $topwin(compress_name).perform.button4 {left frame center expand  padx 15} \
    $topwin(compress_name).perform.button5 {left frame center expand  padx 15} \
    $topwin(compress_name).perform.button3 {right frame center}

  # pack widget $topwin(compress_name).
  pack append $topwin(compress_name) \
    $topwin(compress_name).info {top frame center expand fill} \
    $topwin(compress_name).current_image {top frame center fillx} \
    $topwin(compress_name).perform {bottom frame center fillx}

}

