# **********************************************************************
# Computer Vision/Image Processing Tool Project - Dr. Scott Umbaugh SIUE
# **********************************************************************
#
#             File Name: cmprs_lossy.tcl
#           Description: 
#         Related Files: 
#   Initial Coding Date: Wed Sep 18 17:53:15 CDT 1996
#           Portability: TCL script file
#            References:
#             Author(s): Mark Zuke and Yansheng Wei
#                        Southern Illinois University @ Edwardsville
#
## Copyright (C) 1996 SIUE - by Scott Umbaugh, Yansheng Wei and Mark Zuke.
##
## Permission to use, copy, modify, and distribute this software and its
## documentation for any purpose and without fee is hereby granted, provided
## that the above copyright notice appear in all copies and that both that
## copyright notice and this permission notice appear in supporting
## documentation.  This software is provided "as is" without express or
## implied warranty.
##
# RCS (Revision Control System) Information
# ...Added automatically by RCS 
#
## $Log: cmprs_lossy.tcl,v $
## Revision 1.34  1997/08/08 19:35:38  smakam
## fix the jpeg mutiple working
##
## Revision 1.33  1997/08/08 16:10:21  wzheng
## jpwg auto save quant file after selection
##
## Revision 1.32  1997/08/06 00:01:19  yawei
## fixed position problem
##
## Revision 1.31  1997/08/05 20:58:20  wzheng
## CvipAlert-> AlertBox on file saving
##
## Revision 1.30  1997/07/25 17:53:02  wzheng
## jpeg write quant.txt into temp directory
##
## Revision 1.29  1997/07/22 19:55:59  wzheng
## DC button raised
##
## Revision 1.28  1997/07/08 22:40:28  yawei
## GUI configuration in place
##
## Revision 1.27  1997/07/07 21:41:38  yawei
## checked changes back for wzheng
##
## Revision 1.26  1997/06/23 16:46:44  wzheng
## *** empty log message ***
##
## Revision 1.25  1997/06/15 23:53:53  wzheng
## modified the jpeg quant_table file saving part.
##
## Revision 1.24  1997/06/13 01:34:34  wzheng
## quant. table
##
## Revision 1.23  1997/06/07 02:36:58  wzheng
## modify two entrys to checkbuttons for jpeg
##
## Revision 1.22  1997/06/06 16:18:57  wzheng
## add grayscale function into jpeg
##
## Revision 1.21  1997/05/13 15:00:05  yawei
## modified BTC for another parameter
##
## Revision 1.20  1997/04/29 16:51:46  yawei
## modified "save decompressed image" and "save compressed data"
##
## Revision 1.19  1997/04/29 16:28:47  yawei
## fixed entry bug
##
## Revision 1.18  1997/04/29 16:20:57  yawei
## added jpeg
##
## Revision 1.17  1997/03/12 15:15:48  yawei
## fixed arrow buttons,
## changed window size
##
## Revision 1.16  1997/03/11 20:55:44  yawei
## Tcl/Tk script upgrading from tcl7.3/tk3.6 to tcl7.6/tk4.2
## compatible. This process is automated with tkboost perl
## script. @ Tue Mar 11 14:51:36 CST 1997
##
## Revision 1.15  1996/11/30 18:24:30  yawei
## single '.' or end of file:
## >>
##
# Revision 1.14  1996/11/30  18:03:39  yawei
# changed command dpcm to dpc
#
# Revision 1.13  1996/10/31  04:23:06  yawei
# Added zonal2
#
# Revision 1.12  1996/10/22  18:56:09  yawei
# changed the popup values of zonal "compression ratio"
#
# Revision 1.11  1996/10/17  03:24:58  yawei
# Changed zonal blocksize default values
#
# Revision 1.10  1996/10/16  16:20:09  mzuke
# moved 'view image' after 'image_post' to correctly label
# displayed images
#
# Revision 1.9  1996/10/09  20:48:00  yawei
# hooked up zonal
#
# Revision 1.8  1996/09/28  17:33:21  mzuke
# changed text on 'save' buttons on perform buttonbar
#
# Revision 1.7  1996/09/27  18:13:23  mzuke
# changed all functions to accept default name
# created by cviptcl function
#
# Revision 1.6  1996/09/27  16:23:44  mzuke
# added 'save image' and 'save data' buttons;
# removed rename of image from btc2,btc3,glr
#
# Revision 1.5  1996/09/22  17:58:22  yawei
# set dpcm | clip == 1. the clip=0 case will to go lossless.
#
# Revision 1.4  1996/09/22  17:53:20  yawei
# finished compress_lossy. Once one parameter is lost for dpcm|clip=0,
# now it is added
#
# Revision 1.3  1996/09/20  21:17:12  yawei
# completed "lossy", except zonal
#
# Revision 1.2  1996/09/20  13:14:10  mzuke
# added alert box notification that zonal coding
# not yet installed
#
# Revision 1.1  1996/09/18  22:54:08  yawei
# Initial revision
#
#
#****************************************************************************
# procedure for lossy compression
proc cmprs_lossy { } {# xf ignore me 7

  global {compress}
  global {chrominance}
  global {luminance}
  global GuiColor
  global GuiMisc
  global GUI_DEBUG
  
  # Window manager configurations
  global topwin
  global toplevel_position
  if [ winfo exists $topwin(compress_name).info] {
     set tempname $topwin(compress_name);\
destroy $topwin(compress_name).info;\
set topwin(compress_name) $tempname;}
  if [ winfo exists $topwin(compress_name).current_image] {
     set tempname $topwin(compress_name);\
destroy $topwin(compress_name).current_image;\
set topwin(compress_name) $tempname;}
  if [ winfo exists $topwin(compress_name).perform] {
     set tempname $topwin(compress_name);\
destroy $topwin(compress_name).perform;\
set topwin(compress_name) $tempname;}
  wm positionfrom $topwin(compress_name) user
  wm sizefrom $topwin(compress_name) user

  wm geometry $topwin(compress_name) $topwin(compress_lossy)[get_pos $topwin(compress_name)]
  wm maxsize $topwin(compress_name) [lindex [split $topwin(compress_lossy_max)] 0] \
  	[lindex [split $topwin(compress_lossy_max)] 1]
  wm minsize $topwin(compress_name) [lindex [split $topwin(compress_lossy_min)] 0] \
  	[lindex [split $topwin(compress_lossy_min)] 1]
  wm title $topwin(compress_name) {COMPRESSION -> Lossy}

 # bindings
	 bind $topwin(compress_name) <Destroy> {set topwin(compress_name) NONE}

  # build widget $topwin(compress_name).info
  frame $topwin(compress_name).info \
    -background "$GuiColor(frame_bg)" \
    -borderwidth {0}

  # build widget $topwin(compress_name).info.frame1
  frame $topwin(compress_name).info.frame1 \
    -background "$GuiColor(frame_bg)" \
    -borderwidth {2} \
    -relief {ridge}

  # build widget $topwin(compress_name).info.frame1.frame5
  frame $topwin(compress_name).info.frame1.frame5 \
    -background "$GuiColor(frame_bg)" \
    -borderwidth {2}

  # build widget $topwin(compress_name).info.frame1.frame5.radiobutton4
	radiobutton $topwin(compress_name).info.frame1.frame5.radiobutton4 -padx {1} -pady {1} -highlightthickness {0}  \
    -background "$GuiColor(btn_bg)" \
	 -activebackground "$GuiColor(btn_act_bg)" \
    -command {
#	 pack forget  $topwin(compress_name).info.frame1.frame1
#set compress(block_size) -1
pack append $topwin(compress_name).info.frame1  $topwin(compress_name).info.frame1.frame1 {left frame c expand}
pack forget $topwin(compress_name).info.frame3.frame3.frame6} \
    -relief {flat} \
    -text {Block Truncation Coding (BTC)} \
    -value {btc} \
    -variable {compress(lossy)}

  # build widget $topwin(compress_name).info.frame1.frame5.radiobutton2
	radiobutton $topwin(compress_name).info.frame1.frame5.radiobutton2 -padx {1} -pady {1} -highlightthickness {0}  \
    -background "$GuiColor(btn_bg)" \
	 -activebackground "$GuiColor(btn_act_bg)" \
    -command {
#pack $topwin(compress_name).info.frame1.frame1
pack append $topwin(compress_name).info.frame1  $topwin(compress_name).info.frame1.frame1 {left frame center expand}
if {$compress(block_size) == -1} {  set compress(block_size) 8}
pack forget $topwin(compress_name).info.frame3.frame3.frame6} \
    -relief {flat} \
    -text {Multilevel BTC} \
    -value {btc2} \
    -variable {compress(lossy)}

  # build widget $topwin(compress_name).info.frame1.frame5.radiobutton5
	radiobutton $topwin(compress_name).info.frame1.frame5.radiobutton5 -padx {1} -pady {1} -highlightthickness {0}  \
    -background "$GuiColor(btn_bg)" \
	 -activebackground "$GuiColor(btn_act_bg)" \
    -command {
#	 pack $topwin(compress_name).info.frame1.frame1
pack append $topwin(compress_name).info.frame1  $topwin(compress_name).info.frame1.frame1 {left frame c expand}
if {$compress(block_size) == -1} {  set compress(block_size) 8}
pack forget $topwin(compress_name).info.frame3.frame3.frame6} \
    -relief {flat} \
    -text {Predictive Multilevel BTC} \
    -value {btc3} \
    -variable {compress(lossy)}

  # pack widget $topwin(compress_name).info.frame1.frame5
  pack append $topwin(compress_name).info.frame1.frame5 \
    $topwin(compress_name).info.frame1.frame5.radiobutton4 {top frame w} \
    $topwin(compress_name).info.frame1.frame5.radiobutton2 {top frame w} \
    $topwin(compress_name).info.frame1.frame5.radiobutton5 {top frame w}

  # build widget $topwin(compress_name).info.frame1.frame1
  frame $topwin(compress_name).info.frame1.frame1 \
    -background "$GuiColor(frame_bg)" \
    -borderwidth {2}

  # build widget $topwin(compress_name).info.frame1.frame1.frame6
  frame $topwin(compress_name).info.frame1.frame1.frame6 \
    -background "$GuiColor(frame_bg)" \
    -borderwidth {2}

  # build widget $topwin(compress_name).info.frame1.frame1.frame6.label7
  label $topwin(compress_name).info.frame1.frame1.frame6.label7 \
    -background "$GuiColor(label_bg)" \
    -text {Blocksize:}

  # build widget $topwin(compress_name).info.frame1.frame1.frame6.label9
  menubutton $topwin(compress_name).info.frame1.frame1.frame6.label9 \
    -background "$GuiColor(btn_bg)" \
	 -activebackground "$GuiColor(btn_act_bg)" \
	 -padx {1} -pady {1} -highlightthickness {0} \
	 -font "$GuiMisc(pop_up_fn)" \
	 -text "$GuiMisc(pop_up_text)" \
	 -relief "$GuiMisc(pop_up_relief)" \
	 -width {2}
  # bindings
  bind $topwin(compress_name).info.frame1.frame1.frame6.label9 <Button-1> {MenuPopupPost $topwin(compress_name).info.frame1.frame1.frame6.label9.menu %X %Y}
  bind $topwin(compress_name).info.frame1.frame1.frame6.label9 <ButtonRelease-1> {MenuPopupRelease $topwin(compress_name).info.frame1.frame1.frame6.label9.menu %W}

  # build widget $topwin(compress_name).info.frame1.frame1.frame6.label9.menu
  menu $topwin(compress_name).info.frame1.frame1.frame6.label9.menu \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)"
  $topwin(compress_name).info.frame1.frame1.frame6.label9.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set compress(block_size) 2} \
    -label {  2 }
  $topwin(compress_name).info.frame1.frame1.frame6.label9.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set compress(block_size) 4} \
    -label {  4 }
  $topwin(compress_name).info.frame1.frame1.frame6.label9.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set compress(block_size) 8} \
    -label {  8 }
  $topwin(compress_name).info.frame1.frame1.frame6.label9.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set compress(block_size) 16} \
    -label { 16 }
  $topwin(compress_name).info.frame1.frame1.frame6.label9.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set compress(block_size) 32} \
    -label { 32 }
  bindtags  $topwin(compress_name).info.frame1.frame1.frame6.label9.menu {Menu all}
  # bindings
  bind $topwin(compress_name).info.frame1.frame1.frame6.label9.menu <B1-Motion> {MenuPopupMotion $topwin(compress_name).info.frame1.frame1.frame6.label9.menu0 %W %X %Y}
  bind $topwin(compress_name).info.frame1.frame1.frame6.label9.menu <ButtonRelease-1> {MenuPopupRelease $topwin(compress_name).info.frame1.frame1.frame6.label9.menu0 %W}

  # build widget $topwin(compress_name).info.frame1.frame1.frame6.entry5
  entry $topwin(compress_name).info.frame1.frame1.frame6.entry5 \
    -background "$GuiColor(entry_bg)" \
	 -foreground "$GuiColor(entry_fg)" \
    -relief {sunken} \
    -textvariable {compress(block_size)} \
    -width {5}
  endEntry $topwin(compress_name).info.frame1.frame1.frame6.entry5 \

  # pack widget $topwin(compress_name).info.frame1.frame1.frame6
  pack append $topwin(compress_name).info.frame1.frame1.frame6 \
    $topwin(compress_name).info.frame1.frame1.frame6.label7 {left frame center} \
    $topwin(compress_name).info.frame1.frame1.frame6.entry5 {left frame center} \
    $topwin(compress_name).info.frame1.frame1.frame6.label9 {left frame center}

  # pack widget $topwin(compress_name).info.frame1.frame1
  pack append $topwin(compress_name).info.frame1.frame1 \
    $topwin(compress_name).info.frame1.frame1.frame6 {top frame center expand fillx}

  # pack widget $topwin(compress_name).info.frame1
  pack append $topwin(compress_name).info.frame1 \
    $topwin(compress_name).info.frame1.frame5 {left frame center filly} \
    $topwin(compress_name).info.frame1.frame1 {left frame c expand}

#--------------------------------------------------------------------------------------------
  chrominance_default
  luminance_default
  
  # build widget $topwin(compress_name).info.frame2
  frame $topwin(compress_name).info.frame2 \
    -background "$GuiColor(frame_bg)" \
    -borderwidth {2} \
    -relief {ridge}

  # build widget $topwin(compress_name).info.frame2.top
  frame $topwin(compress_name).info.frame2.top \
    -background "$GuiColor(frame_bg)" \
    -relief {ridge}

  # build widget $topwin(compress_name).info.frame2.top.radiobutton4
	radiobutton $topwin(compress_name).info.frame2.top.radiobutton4 -padx {1} -pady {1} -highlightthickness {0}  \
    -background "$GuiColor(btn_bg)" \
	 -activebackground "$GuiColor(btn_act_bg)" \
    -command {pack forget $topwin(compress_name).info.frame1.frame1
		pack forget $topwin(compress_name).info.frame3.frame3.frame6
                        if {$bands ==1} {
                           $topwin(compress_name).info.frame2.bottom.button1 configure -state disabled
                        } else {
                           $topwin(compress_name).info.frame2.bottom.button1 configure -state normal
                        }
		write_quant_file $bands		
		} \
    -relief {flat} \
    -text {JPEG} \
    -value {jpeg} \
    -variable {compress(lossy)}


  # build widget $topwin(compress_name).info.frame2.top.frame0
  frame $topwin(compress_name).info.frame2.top.frame0 \
    -background "$GuiColor(frame_bg)" \
	 -highlightthickness {0} \
    -borderwidth {2} \
    -height {30} \

  # build widget $topwin(compress_name).info.frame2.top.frame0.label1
  label $topwin(compress_name).info.frame2.top.frame0.label1 \
    -background "$GuiColor(label_bg)" \
    -text {Quality}

  # build widget $topwin(compress_name).info.frame2.top.frame0.entry2
  entry $topwin(compress_name).info.frame2.top.frame0.entry2 \
    -background "$GuiColor(entry_bg)" \
	 -foreground "$GuiColor(entry_fg)" \
	 -textvariable {compress(jpeg_quality)} \
	 -width {5} \
    -highlightthickness {0}
  endEntry $topwin(compress_name).info.frame2.top.frame0.entry2 

  # build widget $topwin(compress_name).info.frame2.top.frame0.menubutton3
  menubutton $topwin(compress_name).info.frame2.top.frame0.menubutton3 \
    -background "$GuiColor(btn_bg)" \
	 -activebackground "$GuiColor(btn_act_bg)" \
	 -font "$GuiMisc(pop_up_fn)" \
	 -text "$GuiMisc(pop_up_text)" \
	 -relief "$GuiMisc(pop_up_relief)" \
	 -width {2}
  # bindings
  bind $topwin(compress_name).info.frame2.top.frame0.menubutton3 <Button-1> { MenuPopupPost  $topwin(compress_name).info.frame2.top.frame0.menubutton3.menu0 %X %Y}
  bind $topwin(compress_name).info.frame2.top.frame0.menubutton3 <ButtonRelease-1> {MenuPopupRelease $topwin(compress_name).info.frame2.top.frame0.menubutton3.menu0  %W}

  # build widget $topwin(compress_name).info.frame2.top.frame0.menubutton3.menu0
  menu $topwin(compress_name).info.frame2.top.frame0.menubutton3.menu0 \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)"
  $topwin(compress_name).info.frame2.top.frame0.menubutton3.menu0 add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -label { 50 } \
	 -command {set compress(jpeg_quality) 50} 
  $topwin(compress_name).info.frame2.top.frame0.menubutton3.menu0 add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -label { 60 } \
	 -command {set compress(jpeg_quality) 60} 
  $topwin(compress_name).info.frame2.top.frame0.menubutton3.menu0 add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -label { 70 } \
	 -command {set compress(jpeg_quality) 70} 
  $topwin(compress_name).info.frame2.top.frame0.menubutton3.menu0 add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -label { 80 } \
	 -command {set compress(jpeg_quality) 80} 
  $topwin(compress_name).info.frame2.top.frame0.menubutton3.menu0 add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -label { 90 } \
	 -command {set compress(jpeg_quality) 90} 
  $topwin(compress_name).info.frame2.top.frame0.menubutton3.menu0 add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -label { 95 } \
	 -command {set compress(jpeg_quality) 95} 
  # bindings
  bind $topwin(compress_name).info.frame2.top.frame0.menubutton3.menu0 <B1-Motion> {MenuPopupMotion   $topwin(compress_name).info.frame2.top.frame0.menubutton3.menu0 %W %X %Y}
  bind $topwin(compress_name).info.frame2.top.frame0.menubutton3.menu0 <ButtonRelease-1> {MenuPopupRelease $topwin(compress_name).info.frame2.top.frame0.menubutton3.menu0  %W}

  # pack master $topwin(compress_name).info.frame2.top.frame0
    pack append $topwin(compress_name).info.frame2.top.frame0 \
    $topwin(compress_name).info.frame2.top.frame0.label1 {left frame center} \
    $topwin(compress_name).info.frame2.top.frame0.entry2 {left frame center} \
    $topwin(compress_name).info.frame2.top.frame0.menubutton3 {left frame center}



  # build widget $topwin(compress_name).info.frame2.top.checkbutton1
        checkbutton $topwin(compress_name).info.frame2.top.checkbutton1 -padx {1} -pady {1} -highlightthickness {0}  \
    -background "$GuiColor(btn_bg)" \
	 -activebackground "$GuiColor(btn_act_bg)" \
    -text {Smooth} \
    -variable {compress(jpeg_smooth)}

  # build widget $topwin(compress_name).info.frame2.top.checkbutton2
        checkbutton $topwin(compress_name).info.frame2.top.checkbutton2 -padx {1} -pady {1} -highlightthickness {0}  \
    -background "$GuiColor(btn_bg)" \
	 -activebackground "$GuiColor(btn_act_bg)" \
    -text {Grayscale} \
    -variable {compress(jpeg_grayscale)}

  # pack widget $topwin(compress_name).info.frame2.top
  pack append $topwin(compress_name).info.frame2.top \
    $topwin(compress_name).info.frame2.top.radiobutton4 {left frame center} \
        $topwin(compress_name).info.frame2.top.frame0 {left frame center expand} \
    $topwin(compress_name).info.frame2.top.checkbutton1 {left frame center} \
    $topwin(compress_name).info.frame2.top.checkbutton2 {left frame center}


  # build widget $topwin(compress_name).info.frame2.bottom
  frame $topwin(compress_name).info.frame2.bottom \
    -background "$GuiColor(frame_bg)" \
    -relief {ridge}

  # build widget $topwin(compress_name).info.frame2.bottom.frame0
  frame $topwin(compress_name).info.frame2.bottom.frame0 \
    -background "$GuiColor(frame_bg)" \
    -relief {ridge}

  label $topwin(compress_name).info.frame2.bottom.frame0.label1 \
    -background "$GuiColor(label_bg)" \
    -text {   Quant. table}

  # build widget $topwin(compress_name).info.frame2.bottom.frame0.entry2
  entry $topwin(compress_name).info.frame2.bottom.frame0.entry2 \
    -background "$GuiColor(rentry_bg)" \
	 -foreground "$GuiColor(rentry_fg)" \
	 -textvariable {compress(jpeg_quant)} \
	 -width {8} \
	 -state {disabled} \
    -highlightthickness {0}

  # build widget $topwin(compress_name).info.frame2.bottom.frame0.menubutton3
  menubutton $topwin(compress_name).info.frame2.bottom.frame0.menubutton3 \
    -background "$GuiColor(btn_bg)" \
	 -activebackground "$GuiColor(btn_act_bg)" \
	 -font "$GuiMisc(pop_up_fn)" \
	 -text "$GuiMisc(pop_up_text)" \
	 -relief "$GuiMisc(pop_up_relief)" \
	 -width {2}
  # bindings
  bind $topwin(compress_name).info.frame2.bottom.frame0.menubutton3 <Button-1> { MenuPopupPost  $topwin(compress_name).info.frame2.bottom.frame0.menubutton3.menu0 %X %Y}
  bind $topwin(compress_name).info.frame2.bottom.frame0.menubutton3 <ButtonRelease-1> {MenuPopupRelease $topwin(compress_name).info.frame2.bottom.frame0.menubutton3.menu0  %W}

  # build widget $topwin(compress_name).info.frame2.bottom.frame0.menubutton3.menu0
  menu $topwin(compress_name).info.frame2.bottom.frame0.menubutton3.menu0 \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)"
  $topwin(compress_name).info.frame2.bottom.frame0.menubutton3.menu0 add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -label { default } \
    -command {set compress(jpeg_quant) default
		chrominance_default
		luminance_default
		write_quant_file $bands
} 
  $topwin(compress_name).info.frame2.bottom.frame0.menubutton3.menu0 add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -label { Nonquant } \
    -command {set compress(jpeg_quant) Nonquant
                chrominance_nonquant
                luminance_nonquant
		write_quant_file $bands
}


  # bindings
  bind $topwin(compress_name).info.frame2.bottom.frame0.menubutton3.menu0 <B1-Motion> {MenuPopupMotion   $topwin(compress_name).info.frame2.bottom.frame0.menubutton3.menu0 %W %X %Y}
  bind $topwin(compress_name).info.frame2.bottom.frame0.menubutton3.menu0 <ButtonRelease-1> {MenuPopupRelease $topwin(compress_name).info.frame2.bottom.frame0.menubutton3.menu0  %W}

  # pack master $topwin(compress_name).info.frame2.bottom.frame0
    pack append $topwin(compress_name).info.frame2.bottom.frame0 \
    $topwin(compress_name).info.frame2.bottom.frame0.label1 {left frame center} \
    $topwin(compress_name).info.frame2.bottom.frame0.entry2 {left frame center} \
    $topwin(compress_name).info.frame2.bottom.frame0.menubutton3 {left frame center}
    
  # build widget .table.perform.default
    button $topwin(compress_name).info.frame2.bottom.button0 -padx {1} -pady {1} -highlightthickness {0}  \
    -background "$GuiColor(btn_bg)" \
	 -activebackground "$GuiColor(btn_act_bg)" \
    -command {mat_specify_luminance 8 compress(jpeg_quant) } \
    -text {View Luminance Table} \
    -width {22}
    
  # build widget .table.perform.default
        button $topwin(compress_name).info.frame2.bottom.button1 -padx {1} -pady {1} -highlightthickness {0}  \
    -background "$GuiColor(btn_bg)" \
	 -activebackground "$GuiColor(btn_act_bg)" \
    -command {mat_specify_chrominance 8 compress(jpeg_quant) } \
    -text {View Chrominance Table} \
    -width {22}


  # pack widget $topwin(compress_name).info.frame2.bottom
  pack append $topwin(compress_name).info.frame2.bottom \
    $topwin(compress_name).info.frame2.bottom.button0 {right frame center} \
    $topwin(compress_name).info.frame2.bottom.button1 {right frame center} \
    $topwin(compress_name).info.frame2.bottom.frame0 {right frame center expand}

    
  # pack widget $topwin(compress_name).info.frame2
  pack append $topwin(compress_name).info.frame2 \
    $topwin(compress_name).info.frame2.top {top frame center expand fill} \
    $topwin(compress_name).info.frame2.bottom {bottom frame center pady 5 fill}

  # build widget $topwin(compress_name).info.frame3
  frame $topwin(compress_name).info.frame3 \
    -background "$GuiColor(frame_bg)" \
    -borderwidth {2} \
    -relief {ridge}

  # build widget $topwin(compress_name).info.frame3.frame2
  frame $topwin(compress_name).info.frame3.frame2 \
    -background "$GuiColor(frame_bg)" \
    -borderwidth {2}

  # build widget $topwin(compress_name).info.frame3.frame2.radiobutton4
	radiobutton $topwin(compress_name).info.frame3.frame2.radiobutton4 -padx {1} -pady {1} -highlightthickness {0}  \
    -background "$GuiColor(btn_bg)" \
	 -activebackground "$GuiColor(btn_act_bg)" \
    -command {pack forget $topwin(compress_name).info.frame1.frame1
   
   pack $topwin(compress_name).info.frame3.frame3.frame6} \
    -relief {flat} \
    -text {Dynamic Window-Based Run Length Coding} \
    -value {gray_rlc} \
    -variable {compress(lossy)}

  # pack widget $topwin(compress_name).info.frame3.frame2
  pack append $topwin(compress_name).info.frame3.frame2 \
    $topwin(compress_name).info.frame3.frame2.radiobutton4 {left frame center expand fill}

  # build widget $topwin(compress_name).info.frame3.frame3
  frame $topwin(compress_name).info.frame3.frame3 \
    -background "$GuiColor(frame_bg)" \
    -borderwidth {0}

  # build widget $topwin(compress_name).info.frame3.frame3.frame6
  frame $topwin(compress_name).info.frame3.frame3.frame6 \
    -background "$GuiColor(frame_bg)" \
    -borderwidth {0}

  # build widget $topwin(compress_name).info.frame3.frame3.frame6.label7
  label $topwin(compress_name).info.frame3.frame3.frame6.label7 \
    -background "$GuiColor(label_bg)" \
    -text {Window size:}

  # build widget $topwin(compress_name).info.frame3.frame3.frame6.entry8
  entry $topwin(compress_name).info.frame3.frame3.frame6.entry8 \
    -background "$GuiColor(entry_bg)" \
	 -highlightthickness {0} \
	 -foreground "$GuiColor(entry_fg)" \
    -relief {sunken} \
    -textvariable {compress(window_size)} \
    -width {5}

  # build widget $topwin(compress_name).info.frame3.frame3.frame6.label9
  menubutton $topwin(compress_name).info.frame3.frame3.frame6.label9 \
    -background "$GuiColor(btn_bg)" \
	 -activebackground "$GuiColor(btn_act_bg)" \
	 -padx {1} -pady {1} -highlightthickness {0} \
	 -font "$GuiMisc(pop_up_fn)" \
	 -text "$GuiMisc(pop_up_text)" \
	 -relief "$GuiMisc(pop_up_relief)" \
	 -width {2}
  # bindings
  bind $topwin(compress_name).info.frame3.frame3.frame6.label9 <Button-1> {MenuPopupPost $topwin(compress_name).info.frame3.frame3.frame6.label9.menu %X %Y}
  bind $topwin(compress_name).info.frame3.frame3.frame6.label9 <ButtonRelease-1> {MenuPopupRelease $topwin(compress_name).info.frame3.frame3.frame6.label9.menu %W}

  # build widget $topwin(compress_name).info.frame3.frame3.frame6.label9.menu
  menu $topwin(compress_name).info.frame3.frame3.frame6.label9.menu \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)"
  $topwin(compress_name).info.frame3.frame3.frame6.label9.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set compress(window_size) 2} \
    -label {2}
  $topwin(compress_name).info.frame3.frame3.frame6.label9.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set compress(window_size) 5} \
    -label {5}
  $topwin(compress_name).info.frame3.frame3.frame6.label9.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set compress(window_size) 10} \
    -label {10}
  $topwin(compress_name).info.frame3.frame3.frame6.label9.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set compress(window_size) 20} \
    -label {20}
  $topwin(compress_name).info.frame3.frame3.frame6.label9.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set compress(window_size) 50} \
    -label {50}
  bindtags $topwin(compress_name).info.frame3.frame3.frame6.label9.menu {Menu all}
  # bindings
  bind $topwin(compress_name).info.frame3.frame3.frame6.label9.menu <B1-Motion> {MenuPopupMotion $topwin(compress_name).info.frame3.frame3.frame6.label9.menu0 %W %X %Y}
  bind $topwin(compress_name).info.frame3.frame3.frame6.label9.menu <ButtonRelease-1> {MenuPopupRelease $topwin(compress_name).info.frame3.frame3.frame6.label9.menu0 %W}

  # pack widget $topwin(compress_name).info.frame3.frame3.frame6
  pack append $topwin(compress_name).info.frame3.frame3.frame6 \
    $topwin(compress_name).info.frame3.frame3.frame6.label7 {left frame center} \
    $topwin(compress_name).info.frame3.frame3.frame6.entry8 {left frame center} \
    $topwin(compress_name).info.frame3.frame3.frame6.label9 {left frame center}

  # pack widget $topwin(compress_name).info.frame3
  pack append $topwin(compress_name).info.frame3 \
    $topwin(compress_name).info.frame3.frame2 {left frame center} \
    $topwin(compress_name).info.frame3.frame3 {left frame center expand} 

  # build widget $topwin(compress_name).info.frame0
  frame $topwin(compress_name).info.frame0 \
    -background "$GuiColor(frame_bg)" \
    -borderwidth {2} \
    -relief {ridge}

  # build widget $topwin(compress_name).info.frame0.frame2
  frame $topwin(compress_name).info.frame0.frame2 \
    -background "$GuiColor(frame_bg)" \
    -borderwidth {2}

  # build widget $topwin(compress_name).info.frame0.frame2.radiobutton4
	radiobutton $topwin(compress_name).info.frame0.frame2.radiobutton4 -padx {1} -pady {1} -highlightthickness {0}  \
    -background "$GuiColor(btn_bg)" \
	 -activebackground "$GuiColor(btn_act_bg)" \
    -command {pack forget $topwin(compress_name).info.frame1.frame1
pack forget $topwin(compress_name).info.frame3.frame3.frame6
set compress(encoding) "Reconstr. with Lloyd-Max quantizers"
pack  $topwin(compress_name).info.frame0.frame4.frame8.frame1
} \
    -relief {flat} \
    -text {DPC} \
    -value {dpc} \
    -variable {compress(lossy)}

  # pack widget $topwin(compress_name).info.frame0.frame2
  pack append $topwin(compress_name).info.frame0.frame2 \
    $topwin(compress_name).info.frame0.frame2.radiobutton4 {left frame center expand fill}

  # build widget $topwin(compress_name).info.frame0.frame4
  frame $topwin(compress_name).info.frame0.frame4 \
    -background "$GuiColor(frame_bg)" \
    -borderwidth {2}

  # build widget $topwin(compress_name).info.frame0.frame4.frame3
  frame $topwin(compress_name).info.frame0.frame4.frame3 \
    -background "$GuiColor(frame_bg)" \
    -borderwidth {2}

  # build widget $topwin(compress_name).info.frame0.frame4.frame3.frame6
  frame $topwin(compress_name).info.frame0.frame4.frame3.frame6 \
    -background "$GuiColor(frame_bg)" \
    -borderwidth {2}

  # build widget $topwin(compress_name).info.frame0.frame4.frame3.frame6.label7
  label $topwin(compress_name).info.frame0.frame4.frame3.frame6.label7 \
    -background "$GuiColor(label_bg)" \
    -text {Correlation:}

  # build widget $topwin(compress_name).info.frame0.frame4.frame3.frame6.entry8
  entry $topwin(compress_name).info.frame0.frame4.frame3.frame6.entry8 \
    -background "$GuiColor(entry_bg)" \
	 -foreground "$GuiColor(entry_fg)" \
    -relief {sunken} \
    -textvariable {compress(correlation)} \
    -width {5}
  endEntry $topwin(compress_name).info.frame0.frame4.frame3.frame6.entry8 0 \
  	 $topwin(compress_name).info.frame0.frame4.frame8.frame1.entry8 \
  	 $topwin(compress_name).info.frame0.frame4.frame8.frame1.entry8 

  # build widget $topwin(compress_name).info.frame0.frame4.frame3.frame6.label9
  menubutton $topwin(compress_name).info.frame0.frame4.frame3.frame6.label9 \
    -background "$GuiColor(btn_bg)" \
	 -activebackground "$GuiColor(btn_act_bg)" \
	 -padx {1} -pady {1} -highlightthickness {0} \
	 -font "$GuiMisc(pop_up_fn)" \
	 -text "$GuiMisc(pop_up_text)" \
	 -relief "$GuiMisc(pop_up_relief)" \
	 -width {2}
  # bindings
  bind $topwin(compress_name).info.frame0.frame4.frame3.frame6.label9 <Button-1> {MenuPopupPost $topwin(compress_name).info.frame0.frame4.frame3.frame6.label9.menu %X %Y}
  bind $topwin(compress_name).info.frame0.frame4.frame3.frame6.label9 <ButtonRelease-1> {MenuPopupRelease $topwin(compress_name).info.frame0.frame4.frame3.frame6.label9.menu %W}

  # build widget $topwin(compress_name).info.frame0.frame4.frame3.frame6.label9.menu
  menu $topwin(compress_name).info.frame0.frame4.frame3.frame6.label9.menu \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)"
  $topwin(compress_name).info.frame0.frame4.frame3.frame6.label9.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set compress(correlation) 0.75} \
    -label {0.75}
  $topwin(compress_name).info.frame0.frame4.frame3.frame6.label9.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set compress(correlation) 0.80} \
    -label {0.80}
  $topwin(compress_name).info.frame0.frame4.frame3.frame6.label9.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set compress(correlation) 0.85
} \
    -label {0.85}
  $topwin(compress_name).info.frame0.frame4.frame3.frame6.label9.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set compress(correlation) 0.90
} \
    -label {0.90}
  $topwin(compress_name).info.frame0.frame4.frame3.frame6.label9.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set compress(correlation) 0.95} \
    -label {0.95}
  $topwin(compress_name).info.frame0.frame4.frame3.frame6.label9.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set compress(correlation) 0.98} \
    -label {0.98}
  bindtags $topwin(compress_name).info.frame0.frame4.frame3.frame6.label9.menu {Menu all}
  # bindings
  bind $topwin(compress_name).info.frame0.frame4.frame3.frame6.label9.menu <B1-Motion> {MenuPopupMotion $topwin(compress_name).info.frame0.frame4.frame3.frame6.label9.menu0 %W %X %Y}
  bind $topwin(compress_name).info.frame0.frame4.frame3.frame6.label9.menu <ButtonRelease-1> {MenuPopupRelease $topwin(compress_name).info.frame0.frame4.frame3.frame6.label9.menu0 %W}

  # pack widget $topwin(compress_name).info.frame0.frame4.frame3.frame6
  pack append $topwin(compress_name).info.frame0.frame4.frame3.frame6 \
    $topwin(compress_name).info.frame0.frame4.frame3.frame6.label7 {left frame center} \
    $topwin(compress_name).info.frame0.frame4.frame3.frame6.entry8 {left frame center} \
    $topwin(compress_name).info.frame0.frame4.frame3.frame6.label9 {left frame center}


  # build widget $topwin(compress_name).info.frame0.frame4.frame3.frame7
  frame $topwin(compress_name).info.frame0.frame4.frame3.frame7 \
    -background "$GuiColor(frame_bg)" \
    -borderwidth {2}

  # build widget $topwin(compress_name).info.frame0.frame4.frame3.frame7.label7
  label $topwin(compress_name).info.frame0.frame4.frame3.frame7.label7 \
    -background "$GuiColor(label_bg)" \
    -text {Number of bits:}

  # build widget $topwin(compress_name).info.frame0.frame4.frame3.frame7.entry8
  entry $topwin(compress_name).info.frame0.frame4.frame3.frame7.entry8 \
    -background "$GuiColor(rentry_bg)" \
	 -foreground "$GuiColor(rentry_fg)" \
    -relief {sunken} \
    -state {disabled} \
    -textvariable {compress(bits)} \
    -width {2}

  # build widget $topwin(compress_name).info.frame0.frame4.frame3.frame7.label9
  menubutton $topwin(compress_name).info.frame0.frame4.frame3.frame7.label9 \
    -background "$GuiColor(btn_bg)" \
	 -activebackground "$GuiColor(btn_act_bg)" \
	 -padx {1} -pady {1} -highlightthickness {0} \
	 -font "$GuiMisc(pop_up_fn)" \
	 -text "$GuiMisc(pop_up_text)" \
	 -relief "$GuiMisc(pop_up_relief)" \
	 -width {2}
  # bindings
  bind $topwin(compress_name).info.frame0.frame4.frame3.frame7.label9 <Button-1> {MenuPopupPost $topwin(compress_name).info.frame0.frame4.frame3.frame7.label9.menu %X %Y}
  bind $topwin(compress_name).info.frame0.frame4.frame3.frame7.label9 <ButtonRelease-1> {MenuPopupRelease $topwin(compress_name).info.frame0.frame4.frame3.frame7.label9.menu %W}

  # build widget $topwin(compress_name).info.frame0.frame4.frame3.frame7.label9.menu
  menu $topwin(compress_name).info.frame0.frame4.frame3.frame7.label9.menu \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)"
  $topwin(compress_name).info.frame0.frame4.frame3.frame7.label9.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set compress(bits) 1} \
    -label { 1 }
  $topwin(compress_name).info.frame0.frame4.frame3.frame7.label9.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set compress(bits) 2} \
    -label { 2 }
  $topwin(compress_name).info.frame0.frame4.frame3.frame7.label9.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set compress(bits) 3} \
    -label { 3 }
  $topwin(compress_name).info.frame0.frame4.frame3.frame7.label9.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set compress(bits) 4} \
    -label { 4 }
  $topwin(compress_name).info.frame0.frame4.frame3.frame7.label9.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set compress(bits) 5} \
    -label { 5 }
  $topwin(compress_name).info.frame0.frame4.frame3.frame7.label9.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set compress(bits) 6} \
    -label { 6 }
  $topwin(compress_name).info.frame0.frame4.frame3.frame7.label9.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set compress(bits) 7} \
    -label { 7 }
  $topwin(compress_name).info.frame0.frame4.frame3.frame7.label9.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set compress(bits) 8} \
    -label { 8 }
  bindtags $topwin(compress_name).info.frame0.frame4.frame3.frame7.label9.menu  {Menu all}
  # bindings
  bind $topwin(compress_name).info.frame0.frame4.frame3.frame7.label9.menu <B1-Motion> {MenuPopupMotion $topwin(compress_name).info.frame0.frame4.frame3.frame7.label9.menu0 %W %X %Y}
  bind $topwin(compress_name).info.frame0.frame4.frame3.frame7.label9.menu <ButtonRelease-1> {MenuPopupRelease $topwin(compress_name).info.frame0.frame4.frame3.frame7.label9.menu0 %W}

  # pack widget $topwin(compress_name).info.frame0.frame4.frame3.frame7
  pack append $topwin(compress_name).info.frame0.frame4.frame3.frame7 \
    $topwin(compress_name).info.frame0.frame4.frame3.frame7.label7 {left frame center} \
    $topwin(compress_name).info.frame0.frame4.frame3.frame7.entry8 {left frame center} \
    $topwin(compress_name).info.frame0.frame4.frame3.frame7.label9 {left frame center}

  # build widget $topwin(compress_name).info.frame0.frame4.frame3.frame8
  frame $topwin(compress_name).info.frame0.frame4.frame3.frame8 \
    -background "$GuiColor(frame_bg)" \
    -borderwidth {2}

  # build widget $topwin(compress_name).info.frame0.frame4.frame3.frame8.label7
  label $topwin(compress_name).info.frame0.frame4.frame3.frame8.label7 \
    -background "$GuiColor(label_bg)" \
    -text {Scan direction:}

  # build widget $topwin(compress_name).info.frame0.frame4.frame3.frame8.entry8
  entry $topwin(compress_name).info.frame0.frame4.frame3.frame8.entry8 \
    -background "$GuiColor(rentry_bg)" \
	 -foreground "$GuiColor(rentry_fg)" \
    -relief {sunken} \
    -state {disabled} \
    -textvariable {compress(direction)} \
    -width {9}

  # build widget $topwin(compress_name).info.frame0.frame4.frame3.frame8.label9
  menubutton $topwin(compress_name).info.frame0.frame4.frame3.frame8.label9 \
    -background "$GuiColor(btn_bg)" \
	 -activebackground "$GuiColor(btn_act_bg)" \
	 -padx {1} -pady {1} -highlightthickness {0} \
	 -font "$GuiMisc(pop_up_fn)" \
	 -text "$GuiMisc(pop_up_text)" \
	 -relief "$GuiMisc(pop_up_relief)" \
	 -width {2}
  # bindings
  bind $topwin(compress_name).info.frame0.frame4.frame3.frame8.label9 <Button-1> {MenuPopupPost $topwin(compress_name).info.frame0.frame4.frame3.frame8.label9.menu %X %Y}
  bind $topwin(compress_name).info.frame0.frame4.frame3.frame8.label9 <ButtonRelease-1> {MenuPopupRelease $topwin(compress_name).info.frame0.frame4.frame3.frame8.label9.menu %W}

  # build widget $topwin(compress_name).info.frame0.frame4.frame3.frame8.label9.menu
  menu $topwin(compress_name).info.frame0.frame4.frame3.frame8.label9.menu \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)"
  $topwin(compress_name).info.frame0.frame4.frame3.frame8.label9.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set compress(direction) Horizontal
set compress(dpcm_dir) 0} \
    -label {Horizontal}
  $topwin(compress_name).info.frame0.frame4.frame3.frame8.label9.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set compress(direction) Vertical
set compress(dpcm_dir) 1} \
    -label {Vertical}
  bindtags $topwin(compress_name).info.frame0.frame4.frame3.frame8.label9.menu {Menu all}
  # bindings
  bind $topwin(compress_name).info.frame0.frame4.frame3.frame8.label9.menu <B1-Motion> {MenuPopupMotion $topwin(compress_name).info.frame0.frame4.frame3.frame8.label9.menu0 %W %X %Y}
  bind $topwin(compress_name).info.frame0.frame4.frame3.frame8.label9.menu <ButtonRelease-1> {MenuPopupRelease $topwin(compress_name).info.frame0.frame4.frame3.frame8.label9.menu0 %W}

  # pack widget $topwin(compress_name).info.frame0.frame4.frame3.frame8
  pack append $topwin(compress_name).info.frame0.frame4.frame3.frame8 \
    $topwin(compress_name).info.frame0.frame4.frame3.frame8.label7 {left frame center} \
    $topwin(compress_name).info.frame0.frame4.frame3.frame8.entry8 {left frame center} \
    $topwin(compress_name).info.frame0.frame4.frame3.frame8.label9 {left frame center}


  # pack widget $topwin(compress_name).info.frame0.frame4.frame3
  pack append $topwin(compress_name).info.frame0.frame4.frame3 \
    $topwin(compress_name).info.frame0.frame4.frame3.frame6 {left frame center}\
    $topwin(compress_name).info.frame0.frame4.frame3.frame8 {left frame center}\
    $topwin(compress_name).info.frame0.frame4.frame3.frame7 {left frame center} 

  # build widget $topwin(compress_name).info.frame0.frame4.frame8
  frame $topwin(compress_name).info.frame0.frame4.frame8 \
    -background "$GuiColor(frame_bg)" \
    -borderwidth {2}

  # build widget $topwin(compress_name).info.frame0.frame4.frame8.frame4
  frame $topwin(compress_name).info.frame0.frame4.frame8.frame4 \
    -background "$GuiColor(frame_bg)" \
    -borderwidth {2}

  # build widget $topwin(compress_name).info.frame0.frame4.frame8.frame4.label7
  label $topwin(compress_name).info.frame0.frame4.frame8.frame4.label7 \
    -background "$GuiColor(label_bg)" \
    -text {Encoding:}

  # build widget $topwin(compress_name).info.frame0.frame4.frame8.frame4.entry8
  entry $topwin(compress_name).info.frame0.frame4.frame8.frame4.entry8 \
    -background "$GuiColor(rentry_bg)" \
	 -foreground "$GuiColor(rentry_fg)" \
    -relief {sunken} \
    -width {35} \
    -state {disabled} \
    -textvariable {compress(encoding)}

  # build widget $topwin(compress_name).info.frame0.frame4.frame8.frame4.label9
  menubutton $topwin(compress_name).info.frame0.frame4.frame8.frame4.label9 \
    -background "$GuiColor(btn_bg)" \
	 -activebackground "$GuiColor(btn_act_bg)" \
	 -padx {1} -pady {1} -highlightthickness {0} \
	 -font "$GuiMisc(pop_up_fn)" \
	 -text "$GuiMisc(pop_up_text)" \
	 -relief "$GuiMisc(pop_up_relief)" \
	 -width {2}
  # bindings
  bind $topwin(compress_name).info.frame0.frame4.frame8.frame4.label9 <Button-1> {MenuPopupPost $topwin(compress_name).info.frame0.frame4.frame8.frame4.label9.menu %X %Y}
  bind $topwin(compress_name).info.frame0.frame4.frame8.frame4.label9 <ButtonRelease-1> {MenuPopupRelease $topwin(compress_name).info.frame0.frame4.frame8.frame4.label9.menu %W}

  # build widget $topwin(compress_name).info.frame0.frame4.frame8.frame4.label9.menu
  menu $topwin(compress_name).info.frame0.frame4.frame8.frame4.label9.menu \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)"
  $topwin(compress_name).info.frame0.frame4.frame8.frame4.label9.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set compress(lossy) dpc
set compress(encoding) "Original values"
set compress(dpcm_enc) 1
pack forget $topwin(compress_name).info.frame1.frame1
pack forget $topwin(compress_name).info.frame3.frame3.frame6
pack  forget $topwin(compress_name).info.frame0.frame4.frame8.frame1
} \
    -label {Original values}
  $topwin(compress_name).info.frame0.frame4.frame8.frame4.label9.menu add command \
    -command {set compress(lossy) dpc
set compress(encoding) "Reconstructed values"
set compress(dpcm_enc) 2
pack forget $topwin(compress_name).info.frame1.frame1
pack forget $topwin(compress_name).info.frame3.frame3.frame6
pack  forget $topwin(compress_name).info.frame0.frame4.frame8.frame1
} \
    -label {Reconstructed values}
  $topwin(compress_name).info.frame0.frame4.frame8.frame4.label9.menu add command \
    -command {set compress(lossy) dpc
set compress(encoding) "Reconstr. with Lloyd-Max quantizers"
set compress(dpcm_enc) 3
pack forget $topwin(compress_name).info.frame1.frame1
pack forget $topwin(compress_name).info.frame3.frame3.frame6
pack  $topwin(compress_name).info.frame0.frame4.frame8.frame1
} \
    -label {Reconstr. with Lloyd-Max quantizers}
  bindtags $topwin(compress_name).info.frame0.frame4.frame8.frame4.label9.menu {Menu all}
  # bindings
  bind $topwin(compress_name).info.frame0.frame4.frame8.frame4.label9.menu <B1-Motion> {MenuPopupMotion $topwin(compress_name).info.frame0.frame4.frame8.frame4.label9.menu0 %W %X %Y}
  bind $topwin(compress_name).info.frame0.frame4.frame8.frame4.label9.menu <ButtonRelease-1> {MenuPopupRelease $topwin(compress_name).info.frame0.frame4.frame8.frame4.label9.menu0 %W}

  # pack widget $topwin(compress_name).info.frame0.frame4.frame8.frame4
  pack append $topwin(compress_name).info.frame0.frame4.frame8.frame4 \
    $topwin(compress_name).info.frame0.frame4.frame8.frame4.label7 {left frame center} \
    $topwin(compress_name).info.frame0.frame4.frame8.frame4.entry8 {left frame center} \
    $topwin(compress_name).info.frame0.frame4.frame8.frame4.label9 {left frame center}
	 

  # build widget $topwin(compress_name).info.frame0.frame4.frame8.frame1
  frame $topwin(compress_name).info.frame0.frame4.frame8.frame1 \
    -background "$GuiColor(frame_bg)" \
    -borderwidth {2}

  # build widget $topwin(compress_name).info.frame0.frame4.frame8.frame1.label7
  label $topwin(compress_name).info.frame0.frame4.frame8.frame1.label7 \
    -background "$GuiColor(label_bg)" \
    -text {Std. Dev. :}

  # build widget $topwin(compress_name).info.frame0.frame4.frame8.frame1.entry8
  entry $topwin(compress_name).info.frame0.frame4.frame8.frame1.entry8 \
    -background "$GuiColor(entry_bg)" \
	 -foreground "$GuiColor(entry_fg)" \
    -relief {sunken} \
    -textvariable {compress(stddev)} \
    -width {5}
  endEntry $topwin(compress_name).info.frame0.frame4.frame8.frame1.entry8 0\
  	 $topwin(compress_name).info.frame0.frame4.frame3.frame6.entry8 \
  	 $topwin(compress_name).info.frame0.frame4.frame3.frame6.entry8 

  # build widget $topwin(compress_name).info.frame0.frame4.frame8.frame1.label9
  menubutton $topwin(compress_name).info.frame0.frame4.frame8.frame1.label9 \
    -background "$GuiColor(btn_bg)" \
	 -activebackground "$GuiColor(btn_act_bg)" \
	 -padx {1} -pady {1} -highlightthickness {0} \
	 -font "$GuiMisc(pop_up_fn)" \
	 -text "$GuiMisc(pop_up_text)" \
	 -relief "$GuiMisc(pop_up_relief)" \
	 -width {2}
  # bindings
  bind $topwin(compress_name).info.frame0.frame4.frame8.frame1.label9 <Button-1> {MenuPopupPost $topwin(compress_name).info.frame0.frame4.frame8.frame1.label9.menu %X %Y}
  bind $topwin(compress_name).info.frame0.frame4.frame8.frame1.label9 <ButtonRelease-1> {MenuPopupRelease $topwin(compress_name).info.frame0.frame4.frame8.frame1.label9.menu %W}

  # build widget $topwin(compress_name).info.frame0.frame4.frame8.frame1.label9.menu
  menu $topwin(compress_name).info.frame0.frame4.frame8.frame1.label9.menu \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)"
  $topwin(compress_name).info.frame0.frame4.frame8.frame1.label9.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set compress(stddev) 10} \
    -label {10}
  $topwin(compress_name).info.frame0.frame4.frame8.frame1.label9.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set compress(stddev) 20} \
    -label {20}
  $topwin(compress_name).info.frame0.frame4.frame8.frame1.label9.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set compress(stddev) 30} \
    -label {30}
  $topwin(compress_name).info.frame0.frame4.frame8.frame1.label9.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set compress(stddev) 40} \
    -label {40}
  $topwin(compress_name).info.frame0.frame4.frame8.frame1.label9.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set compress(stddev) 50} \
    -label {50}
  bindtags $topwin(compress_name).info.frame0.frame4.frame8.frame1.label9.menu {Menu all}
  # bindings
  bind $topwin(compress_name).info.frame0.frame4.frame8.frame1.label9.menu <B1-Motion> {MenuPopupMotion $topwin(compress_name).info.frame0.frame4.frame8.frame1.label9.menu0 %W %X %Y}
  bind $topwin(compress_name).info.frame0.frame4.frame8.frame1.label9.menu <ButtonRelease-1> {MenuPopupRelease $topwin(compress_name).info.frame0.frame4.frame8.frame1.label9.menu0 %W}

  # pack widget $topwin(compress_name).info.frame0.frame4.frame8.frame1
  pack append $topwin(compress_name).info.frame0.frame4.frame8.frame1 \
    $topwin(compress_name).info.frame0.frame4.frame8.frame1.label7 {left frame center} \
    $topwin(compress_name).info.frame0.frame4.frame8.frame1.entry8 {left frame center} \
    $topwin(compress_name).info.frame0.frame4.frame8.frame1.label9 {left frame center}

  # pack widget $topwin(compress_name).info.frame0.frame4.frame8
  pack append $topwin(compress_name).info.frame0.frame4.frame8 \
    $topwin(compress_name).info.frame0.frame4.frame8.frame4 {left frame center} \
    $topwin(compress_name).info.frame0.frame4.frame8.frame1 {left frame center} 

  # pack widget $topwin(compress_name).info.frame0.frame4
  pack append $topwin(compress_name).info.frame0.frame4 \
    $topwin(compress_name).info.frame0.frame4.frame3 {top frame center expand fillx} \
    $topwin(compress_name).info.frame0.frame4.frame8 {top frame center expand fillx}

  # pack widget $topwin(compress_name).info.frame0
  pack append $topwin(compress_name).info.frame0 \
    $topwin(compress_name).info.frame0.frame2 {left frame center} \
    $topwin(compress_name).info.frame0.frame4 {left frame center expand fillx}

  # build widget $topwin(compress_name).info.frame4
  frame $topwin(compress_name).info.frame4 \
    -background "$GuiColor(frame_bg)" \
    -borderwidth {2} \
    -relief {ridge}

  # build widget $topwin(compress_name).info.frame4.frame0
  frame $topwin(compress_name).info.frame4.frame0 \
    -background "$GuiColor(frame_bg)" \
    -borderwidth {2}

  # build widget $topwin(compress_name).info.frame4.frame0.radiobutton4
	radiobutton $topwin(compress_name).info.frame4.frame0.radiobutton4 -padx {1} -pady {1} -highlightthickness {0}  \
    -background "$GuiColor(btn_bg)" \
	 -activebackground "$GuiColor(btn_act_bg)" \
    -command {pack forget $topwin(compress_name).info.frame1.frame1
pack forget $topwin(compress_name).info.frame3.frame3.frame6} \
    -relief {flat} \
    -text {Zonal} \
    -value {zonal} \
    -variable {compress(lossy)}

  # pack widget $topwin(compress_name).info.frame4.frame0
  pack append $topwin(compress_name).info.frame4.frame0 \
    $topwin(compress_name).info.frame4.frame0.radiobutton4 {left frame center}

  # build widget $topwin(compress_name).info.frame4.frame8
  frame $topwin(compress_name).info.frame4.frame8 \
    -background "$GuiColor(frame_bg)" \
    -borderwidth {2}

  # build widget $topwin(compress_name).info.frame4.frame8.frame6
  frame $topwin(compress_name).info.frame4.frame8.frame6 \
    -background "$GuiColor(frame_bg)" \
    -borderwidth {2}

  # build widget $topwin(compress_name).info.frame4.frame8.frame6.label7
  label $topwin(compress_name).info.frame4.frame8.frame6.label7 \
    -background "$GuiColor(label_bg)" \
    -text {Compress ratio:}

  # build widget $topwin(compress_name).info.frame4.frame8.frame6.entry8
  entry $topwin(compress_name).info.frame4.frame8.frame6.entry8 \
    -background "$GuiColor(entry_bg)" \
	 -foreground "$GuiColor(entry_fg)" \
    -relief {sunken} \
    -textvariable {compress(zn_ratio)} \
    -width {4}
  endEntry $topwin(compress_name).info.frame4.frame8.frame6.entry8 0\
  	$topwin(compress_name).info.frame4.frame8.frame0.frame0.entry8 \
  	$topwin(compress_name).info.frame4.frame8.frame0.frame0.entry8

  # build widget $topwin(compress_name).info.frame4.frame8.frame6.label9
  menubutton $topwin(compress_name).info.frame4.frame8.frame6.label9 \
    -background "$GuiColor(btn_bg)" \
	 -activebackground "$GuiColor(btn_act_bg)" \
	 -padx {1} -pady {1} -highlightthickness {0} \
	 -font "$GuiMisc(pop_up_fn)" \
	 -text "$GuiMisc(pop_up_text)" \
	 -relief "$GuiMisc(pop_up_relief)" \
	 -width {2}
  # bindings
  bind $topwin(compress_name).info.frame4.frame8.frame6.label9 <Button-1> {MenuPopupPost $topwin(compress_name).info.frame4.frame8.frame6.label9.menu %X %Y}
  bind $topwin(compress_name).info.frame4.frame8.frame6.label9 <ButtonRelease-1> {MenuPopupRelease $topwin(compress_name).info.frame4.frame8.frame6.label9.menu %W}

  # build widget $topwin(compress_name).info.frame4.frame8.frame6.label9.menu
  menu $topwin(compress_name).info.frame4.frame8.frame6.label9.menu \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)"
  $topwin(compress_name).info.frame4.frame8.frame6.label9.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set compress(zn_ratio) 2} \
    -label {  2:1}
  $topwin(compress_name).info.frame4.frame8.frame6.label9.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set compress(zn_ratio) 2.5} \
    -label {2.5:1}
  $topwin(compress_name).info.frame4.frame8.frame6.label9.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set compress(zn_ratio) 3 }\
    -label {  3:1}
  $topwin(compress_name).info.frame4.frame8.frame6.label9.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set compress(zn_ratio) 4 }\
    -label {  4:1}
  $topwin(compress_name).info.frame4.frame8.frame6.label9.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set compress(zn_ratio) 6}\
    -label {  6:1}
  $topwin(compress_name).info.frame4.frame8.frame6.label9.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set compress(zn_ratio) 8}\
    -label {  8:1}
  $topwin(compress_name).info.frame4.frame8.frame6.label9.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set compress(zn_ratio) 16}\
    -label {16:1}
  $topwin(compress_name).info.frame4.frame8.frame6.label9.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set compress(zn_ratio) 32}\
    -label {32:1}
  bindtags $topwin(compress_name).info.frame4.frame8.frame6.label9.menu  {Menu all}
  # bindings
  bind $topwin(compress_name).info.frame4.frame8.frame6.label9.menu <B1-Motion> {MenuPopupMotion $topwin(compress_name).info.frame4.frame8.frame6.label9.menu0 %W %X %Y}
  bind $topwin(compress_name).info.frame4.frame8.frame6.label9.menu <ButtonRelease-1> {MenuPopupRelease $topwin(compress_name).info.frame4.frame8.frame6.label9.menu0 %W}

  # pack widget $topwin(compress_name).info.frame4.frame8.frame6
  pack append $topwin(compress_name).info.frame4.frame8.frame6 \
    $topwin(compress_name).info.frame4.frame8.frame6.label7 {left frame center} \
    $topwin(compress_name).info.frame4.frame8.frame6.entry8 {left frame center} \
    $topwin(compress_name).info.frame4.frame8.frame6.label9 {left frame center}

  # build widget $topwin(compress_name).info.frame4.frame8.frame0
  frame $topwin(compress_name).info.frame4.frame8.frame0 \
    -background "$GuiColor(frame_bg)" \
    -borderwidth {0}

  # build widget $topwin(compress_name).info.frame4.frame8.frame0.frame0
  frame $topwin(compress_name).info.frame4.frame8.frame0.frame0 \
    -background "$GuiColor(frame_bg)" \
    -borderwidth {2}

  # build widget $topwin(compress_name).info.frame4.frame8.frame0.frame0.label7
  label $topwin(compress_name).info.frame4.frame8.frame0.frame0.label7 \
    -background "$GuiColor(label_bg)" \
    -text {Blocksize:}

  # build widget $topwin(compress_name).info.frame4.frame8.frame0.frame0.entry8
  entry $topwin(compress_name).info.frame4.frame8.frame0.frame0.entry8 \
    -background "$GuiColor(entry_bg)" \
	 -foreground "$GuiColor(entry_fg)" \
    -relief {sunken} \
    -textvariable {compress(zn_blk_size)} \
    -width {4}
  endEntry $topwin(compress_name).info.frame4.frame8.frame0.frame0.entry8 0\
  	 $topwin(compress_name).info.frame4.frame8.frame6.entry8 \
  	 $topwin(compress_name).info.frame4.frame8.frame6.entry8

  # build widget $topwin(compress_name).info.frame4.frame8.frame0.frame0.label9
  menubutton $topwin(compress_name).info.frame4.frame8.frame0.frame0.label9 \
    -background "$GuiColor(btn_bg)" \
	 -activebackground "$GuiColor(btn_act_bg)" \
	 -padx {1} -pady {1} -highlightthickness {0} \
	 -font "$GuiMisc(pop_up_fn)" \
	 -text "$GuiMisc(pop_up_text)" \
	 -relief "$GuiMisc(pop_up_relief)" \
	 -width {2}
  # bindings
  bind $topwin(compress_name).info.frame4.frame8.frame0.frame0.label9 <Button-1> {MenuPopupPost $topwin(compress_name).info.frame4.frame8.frame0.frame0.label9.menu %X %Y}
  bind $topwin(compress_name).info.frame4.frame8.frame0.frame0.label9 <ButtonRelease-1> {MenuPopupRelease $topwin(compress_name).info.frame4.frame8.frame0.frame0.label9.menu %W}

  # build widget $topwin(compress_name).info.frame4.frame8.frame0.frame0.label9.menu
  menu $topwin(compress_name).info.frame4.frame8.frame0.frame0.label9.menu \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)"
  $topwin(compress_name).info.frame4.frame8.frame0.frame0.label9.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set compress(zn_blk_size) 4} \
    -label {  4}
  $topwin(compress_name).info.frame4.frame8.frame0.frame0.label9.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set compress(zn_blk_size) 8} \
    -label {  8}
  $topwin(compress_name).info.frame4.frame8.frame0.frame0.label9.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set compress(zn_blk_size) 16} \
    -label { 16}
  $topwin(compress_name).info.frame4.frame8.frame0.frame0.label9.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set compress(zn_blk_size) 32} \
    -label { 32}
  $topwin(compress_name).info.frame4.frame8.frame0.frame0.label9.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set compress(zn_blk_size) 64} \
    -label { 64}
  $topwin(compress_name).info.frame4.frame8.frame0.frame0.label9.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set compress(zn_blk_size) 128} \
    -label {128}
  $topwin(compress_name).info.frame4.frame8.frame0.frame0.label9.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set compress(zn_blk_size) 256} \
    -label {256}
  bindtags $topwin(compress_name).info.frame4.frame8.frame0.frame0.label9.menu  {Menu all}
  # bindings
  bind $topwin(compress_name).info.frame4.frame8.frame0.frame0.label9.menu <B1-Motion> {MenuPopupMotion $topwin(compress_name).info.frame4.frame8.frame0.frame0.label9.menu0 %W %X %Y}
  bind $topwin(compress_name).info.frame4.frame8.frame0.frame0.label9.menu <ButtonRelease-1> {MenuPopupRelease $topwin(compress_name).info.frame4.frame8.frame0.frame0.label9.menu0 %W}

  # pack widget $topwin(compress_name).info.frame4.frame8.frame0.frame0
  pack append $topwin(compress_name).info.frame4.frame8.frame0.frame0 \
    $topwin(compress_name).info.frame4.frame8.frame0.frame0.label7 {left frame center} \
    $topwin(compress_name).info.frame4.frame8.frame0.frame0.entry8 {left frame center} \
    $topwin(compress_name).info.frame4.frame8.frame0.frame0.label9 {left frame center}

  # build widget $topwin(compress_name).info.frame4.frame8.frame0.frame10
  frame $topwin(compress_name).info.frame4.frame8.frame0.frame10 \
    -background "$GuiColor(frame_bg)" \
    -borderwidth {2}

  # build widget $topwin(compress_name).info.frame4.frame8.frame0.frame10.label7
  label $topwin(compress_name).info.frame4.frame8.frame0.frame10.label7 \
    -background "$GuiColor(label_bg)" \
    -text {Transform:}

  # build widget $topwin(compress_name).info.frame4.frame8.frame0.frame10.entry8
  entry $topwin(compress_name).info.frame4.frame8.frame0.frame10.entry8 \
    -background "$GuiColor(rentry_bg)" \
	 -foreground "$GuiColor(rentry_fg)" \
    -relief {sunken} \
    -state {disabled} \
    -textvariable {compress(zn_xform)} \
    -width {9}

  # build widget $topwin(compress_name).info.frame4.frame8.frame0.frame10.label9
  menubutton $topwin(compress_name).info.frame4.frame8.frame0.frame10.label9 \
    -background "$GuiColor(btn_bg)" \
	 -activebackground "$GuiColor(btn_act_bg)" \
	 -padx {1} -pady {1} -highlightthickness {0} \
	 -font "$GuiMisc(pop_up_fn)" \
	 -text "$GuiMisc(pop_up_text)" \
	 -relief "$GuiMisc(pop_up_relief)" \
	 -width {2}
  # bindings
  bind $topwin(compress_name).info.frame4.frame8.frame0.frame10.label9 <Button-1> {MenuPopupPost $topwin(compress_name).info.frame4.frame8.frame0.frame10.label9.menu %X %Y}
  bind $topwin(compress_name).info.frame4.frame8.frame0.frame10.label9 <ButtonRelease-1> {MenuPopupRelease $topwin(compress_name).info.frame4.frame8.frame0.frame10.label9.menu %W}

  # build widget $topwin(compress_name).info.frame4.frame8.frame0.frame10.label9.menu
  menu $topwin(compress_name).info.frame4.frame8.frame0.frame10.label9.menu \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)"
  $topwin(compress_name).info.frame4.frame8.frame0.frame10.label9.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set compress(zn_xform) FFT
set compress(z_xform) 1} \
    -label {FFT}
  $topwin(compress_name).info.frame4.frame8.frame0.frame10.label9.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set compress(zn_xform) DCT
set compress(z_xform) 2} \
    -label {DCT}
  $topwin(compress_name).info.frame4.frame8.frame0.frame10.label9.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set compress(zn_xform) Walsh
set compress(z_xform) 3} \
    -label {Walsh}
  $topwin(compress_name).info.frame4.frame8.frame0.frame10.label9.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set compress(zn_xform) Hadamard
set compress(z_xform) 4} \
    -label {Hadamard}
  bindtags $topwin(compress_name).info.frame4.frame8.frame0.frame10.label9.menu {Menu all}
  # bindings
  bind $topwin(compress_name).info.frame4.frame8.frame0.frame10.label9.menu <B1-Motion> {MenuPopupMotion $topwin(compress_name).info.frame4.frame8.frame0.frame10.label9.menu0 %W %X %Y}
  bind $topwin(compress_name).info.frame4.frame8.frame0.frame10.label9.menu <ButtonRelease-1> {MenuPopupRelease $topwin(compress_name).info.frame4.frame8.frame0.frame10.label9.menu0 %W}

  # pack widget $topwin(compress_name).info.frame4.frame8.frame0.frame10
  pack append $topwin(compress_name).info.frame4.frame8.frame0.frame10 \
    $topwin(compress_name).info.frame4.frame8.frame0.frame10.label7 {left frame center} \
    $topwin(compress_name).info.frame4.frame8.frame0.frame10.entry8 {left frame center} \
    $topwin(compress_name).info.frame4.frame8.frame0.frame10.label9 {left frame center}

  pack append $topwin(compress_name).info.frame4.frame8.frame0 \
    $topwin(compress_name).info.frame4.frame8.frame0.frame10 {left frame center expand fillx} \
    $topwin(compress_name).info.frame4.frame8.frame0.frame0 {left frame center expand fillx} 

  # build widget $topwin(compress_name).info.frame4.frame8.frame1
  frame $topwin(compress_name).info.frame4.frame8.frame1 \
    -background "$GuiColor(frame_bg)" \
    -borderwidth {0}

  # build widget $topwin(compress_name).info.frame4.frame8.frame1.frame1
  frame $topwin(compress_name).info.frame4.frame8.frame1.frame1 \
    -background "$GuiColor(frame_bg)" \
    -borderwidth {2}

  # build widget $topwin(compress_name).info.frame4.frame8.frame1.frame1.label7
  label $topwin(compress_name).info.frame4.frame8.frame1.frame1.label7 \
    -background "$GuiColor(label_bg)" \
    -text {Mask :}

  # build widget $topwin(compress_name).info.frame4.frame8.frame1.frame1.entry8
  entry $topwin(compress_name).info.frame4.frame8.frame1.frame1.entry8 \
    -background "$GuiColor(rentry_bg)" \
	 -foreground "$GuiColor(rentry_fg)" \
    -relief {sunken} \
    -textvariable {compress(zn_mask)} \
    -width {7}

  # build widget $topwin(compress_name).info.frame4.frame8.frame1.frame1.label9
  menubutton $topwin(compress_name).info.frame4.frame8.frame1.frame1.label9 \
    -background "$GuiColor(btn_bg)" \
	 -activebackground "$GuiColor(btn_act_bg)" \
	 -padx {1} -pady {1} -highlightthickness {0} \
	 -font "$GuiMisc(pop_up_fn)" \
	 -text "$GuiMisc(pop_up_text)" \
	 -relief "$GuiMisc(pop_up_relief)" \
	 -width {2}
  # bindings
  bind $topwin(compress_name).info.frame4.frame8.frame1.frame1.label9 <Button-1> {MenuPopupPost $topwin(compress_name).info.frame4.frame8.frame1.frame1.label9.menu %X %Y}
  bind $topwin(compress_name).info.frame4.frame8.frame1.frame1.label9 <ButtonRelease-1> {MenuPopupRelease $topwin(compress_name).info.frame4.frame8.frame1.frame1.label9.menu %W}

  # build widget $topwin(compress_name).info.frame4.frame8.frame1.frame1.label9.menu
  menu $topwin(compress_name).info.frame4.frame8.frame1.frame1.label9.menu \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)"
  $topwin(compress_name).info.frame4.frame8.frame1.frame1.label9.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set compress(zn_mask) triangle
set compress(z_mask) 1} \
    -label {triangle}
  $topwin(compress_name).info.frame4.frame8.frame1.frame1.label9.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set compress(zn_mask) square
set compress(z_mask) 2} \
    -label {square}
  $topwin(compress_name).info.frame4.frame8.frame1.frame1.label9.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set compress(zn_mask) circle
set compress(z_mask) 3} \
    -label {circle}
  bindtags $topwin(compress_name).info.frame4.frame8.frame1.frame1.label9.menu  {Menu all}
  # bindings
  bind $topwin(compress_name).info.frame4.frame8.frame1.frame1.label9.menu <B1-Motion> {MenuPopupMotion $topwin(compress_name).info.frame4.frame8.frame1.frame1.label9.menu0 %W %X %Y}
  bind $topwin(compress_name).info.frame4.frame8.frame1.frame1.label9.menu <ButtonRelease-1> {MenuPopupRelease $topwin(compress_name).info.frame4.frame8.frame1.frame1.label9.menu0 %W}

  # pack widget $topwin(compress_name).info.frame4.frame8.frame1.frame1
  pack append $topwin(compress_name).info.frame4.frame8.frame1.frame1 \
    $topwin(compress_name).info.frame4.frame8.frame1.frame1.label7 {left frame center} \
    $topwin(compress_name).info.frame4.frame8.frame1.frame1.entry8 {left frame center} \
    $topwin(compress_name).info.frame4.frame8.frame1.frame1.label9 {left frame center}


  # build widget $topwin(compress_name).info.frame4.frame8.frame1.button_final
	checkbutton $topwin(compress_name).info.frame4.frame8.frame1.button_final -padx {1} -pady {1} -highlightthickness {0}  \
    -background "$GuiColor(btn_bg)" \
	 -activebackground "$GuiColor(btn_act_bg)" \
	 -offvalue {n} \
	 -onvalue {y} \
	 -relief {raised} \
    -text {DC quantize} \
	 -variable {compress(zn_dc)}

  pack append $topwin(compress_name).info.frame4.frame8.frame1 \
    $topwin(compress_name).info.frame4.frame8.frame1.frame1 {left frame center expand fillx} \
    $topwin(compress_name).info.frame4.frame8.frame1.button_final {left frame center expand}  

  # pack widget $topwin(compress_name).info.frame4.frame8
  pack append $topwin(compress_name).info.frame4.frame8 \
    $topwin(compress_name).info.frame4.frame8.frame6 {left frame center}  \
    $topwin(compress_name).info.frame4.frame8.frame0 {top frame center fillx}  \
    $topwin(compress_name).info.frame4.frame8.frame1 {top frame center fillx} 

  # pack widget $topwin(compress_name).info.frame4
  pack append $topwin(compress_name).info.frame4 \
    $topwin(compress_name).info.frame4.frame0 {left frame center} \
    $topwin(compress_name).info.frame4.frame8 {top frame center expand fillx}

  # pack widget $topwin(compress_name).info
  pack append $topwin(compress_name).info \
    $topwin(compress_name).info.frame1 {top frame center expand fill} \
    $topwin(compress_name).info.frame2 {top frame center expand fill} \
    $topwin(compress_name).info.frame3 {top frame center expand fill} \
    $topwin(compress_name).info.frame0 {top frame center expand fill} \
    $topwin(compress_name).info.frame4 {top frame center expand fill}

  # build widget $topwin(compress_name).current_image
  frame $topwin(compress_name).current_image \
    -background "$GuiColor(frame_bg)" \
    -borderwidth {2} \
    -relief {ridge}

  # build widget $topwin(compress_name).current_image.label0
  label $topwin(compress_name).current_image.label0 \
    -background "$GuiColor(label_bg)" \
    -text {Current image: }

  # build widget $topwin(compress_name).current_image.label1
  label $topwin(compress_name).current_image.label1 \
    -background "$GuiColor(label_bg)" \
    -foreground {Blue} \
    -text {} \
    -textvariable {current_image}

  # pack widget $topwin(compress_name).current_image
  pack append $topwin(compress_name).current_image \
    $topwin(compress_name).current_image.label0 {left frame center} \
    $topwin(compress_name).current_image.label1 {left frame center}

  # build widget $topwin(compress_name).perform
  frame $topwin(compress_name).perform \
    -background "$GuiColor(frame_bg)" \
    -borderwidth {2} \
    -relief {raised}

  # build widget $topwin(compress_name).perform.button2
	button $topwin(compress_name).perform.button2 -padx {1} -pady {1} -highlightthickness {0}  \
    -background "$GuiColor(dis_bg)" \
	 -activebackground "$GuiColor(dis_act_bg)" \
    -foreground "$GuiColor(dis_fg)" \
    -command "destroy $topwin(compress_name)" \
    -text {DISMISS}

  # build widget $topwin(compress_name).perform.button3
	button $topwin(compress_name).perform.button3 -padx {1} -pady {1} -highlightthickness {0}  \
    -background "$GuiColor(perf_bg)" \
	 -activebackground "$GuiColor(perf_act_bg)" \
    -foreground "$GuiColor(perf_fg)" \
    -text {PERFORM} \
	 -command {
      $topwin(compress_name) configure -cursor watch; update
      if {$current_image == ""} {
         CvipAlert "Please select an image first."
         $topwin(compress_name) configure -cursor top_left_arrow; update
         return
      }  
      switch -exact  -- $compress(lossy) {
			zonal {
				set temp1 [expr { $rows > $cols } ? $cols : $rows ]
				if { $compress(zn_dc) == "y" } {
					set temp "cvip zonal $current_image "
				} else {
					set temp "cvip zonal2 $current_image "
				}
				if [catch {expr $compress(zn_blk_size)} ] {
         		CvipAlert "Numerical value required for the transform block size\n\
					Block size = $compress(zn_blk_size)."
         		$topwin(compress_name) configure -cursor top_left_arrow; update
     		   } elseif {$compress(zn_blk_size) <= 0 || $compress(zn_blk_size) > $temp1} {
            	CvipAlert "The transform block size (=$compress(zn_blk_size)) should be \n\
					in the range (0 - [expr int(pow(2, floor(log($temp1) / log(2.0))))])"
					$topwin(compress_name) configure -cursor top_left_arrow; update
	            return
  		      } else {
					append temp "$compress(zn_blk_size) "
				}
				switch -exact -- $compress(zn_xform) {
					FFT {
						append temp "1 "
					}
					DCT {
						append temp "2 "
					}
					Walsh {
						append temp "3 "
					}
					Hadamard {
						append temp "4 "
					}
				}

				switch -exact -- $compress(zn_mask) {
					triangle {
						append temp "1 "
					}
					square {
						append temp "2 "
					}
					circle {
						append temp "3 "
					}

				}

				if [catch {expr $compress(zn_ratio)} ] {
         		CvipAlert "Numerical value required for the compression ratio\n\
					Compression ratio = $compress(zn_ratio)."
         		$topwin(compress_name) configure -cursor top_left_arrow; update
     		   } elseif {$compress(zn_ratio) < 1 ||\
						$compress(zn_ratio) > [expr $compress(zn_blk_size) * $compress(zn_blk_size) / 4] } {
            	CvipAlert "The compression ratio ($compress(zn_ratio)) should be \n\
					in the range (1.0 - [expr $compress(zn_blk_size) * $compress(zn_blk_size) / 4])"
					$topwin(compress_name) configure -cursor top_left_arrow; update
	            return
  		      } else {
					append temp "$compress(zn_ratio)"
				}

				if [catch {set result [eval $temp] } cresult ] {
					CvipAlert "$cresult."
         		$topwin(compress_name) configure -cursor top_left_arrow; update
		         return
				} 
				set new_name $result
            img_q insert end $new_name
            image_post $new_name
            cvip view $new_name
				if { $GUI_DEBUG == "1" } {
					puts stderr $temp
				}
				CvipMessage "zonal compression performed on image \"$current_image\""

			}

			jpeg {
			        #set quant "$env(HOME)/quant.txt"
			        #set quant quant.txt
				set quant [cvip temp_filename "quant.txt"]
				#puts $quant
				if [catch {expr $compress(jpeg_quality)} ] {
         		CvipAlert "Numerical value required for the compression quality\n\
					Quanlity = $compress(jpeg_quality)."
         		$topwin(compress_name) configure -cursor top_left_arrow; update
				} elseif { $compress(jpeg_quality) < 0 || $compress(jpeg_quality) > 100 } {
         		CvipAlert "The compression quality ($compress(jpeg_quality))\n\
					should be an integer between 0 and 100."
         		$topwin(compress_name) configure -cursor top_left_arrow; update
				}
				if [catch {set result [cvip $compress(lossy) $current_image\
					$compress(jpeg_quality) $compress(jpeg_smooth) $compress(jpeg_grayscale) $quant];\
				} cresult ] {
					CvipAlert "$cresult."
         		$topwin(compress_name) configure -cursor top_left_arrow; update
		         return
				} 
				set new_name $result
            img_q insert end $new_name
            image_post $new_name
            cvip view $new_name
				if { $GUI_DEBUG == "1" } {
					puts stderr "cvip $compress(lossy) $current_image $compress(jpeg_quality)\
						$compress(jpeg_smooth) $compress(jpeg_grayscale)"
				}
				CvipMessage "jpeg compression performed on image \"$current_image\""
			}

			btc  -
			btc2 -
			btc3 -
			gray_rlc {
				if { $compress(block_size) == 2 && $compress(lossy) == "btc" } {
					CvipAlert "The blocksize should be more than 2 for BTC "
         		$topwin(compress_name) configure -cursor top_left_arrow; update
		         return
				} 
				
			
				if { $compress(lossy) == "gray_rlc"} {
					set temp $compress(window_size)
					set temp1 window
				} else {
					set temp $compress(block_size)
					set temp1 block
				}

				if [catch {expr $temp}] {
					CvipAlert "Numerical value required for $temp1 size."
         		$topwin(compress_name) configure -cursor top_left_arrow; update
		         return
				} elseif {$temp < 0 || $temp > [expr { $rows > $cols } ? $cols : $rows ]} {
					CvipAlert "The $temp1 size ($temp) should be in the range 0 - \
					[expr { $rows > $cols } ? $cols : $rows ]"
         		$topwin(compress_name) configure -cursor top_left_arrow; update
		         return
				} 

				if [catch {set result [cvip $compress(lossy) $current_image $temp] } cresult ] {
					CvipAlert "$cresult."
         		$topwin(compress_name) configure -cursor top_left_arrow; update
		         return
				} 
				set new_name $result
            img_q insert end $new_name
            image_post $new_name
            cvip view $new_name
				if { $GUI_DEBUG == "1" } {
					puts stderr "cvip $compress(lossy) $current_image $temp"
				}
				switch -exact -- $compress(lossy) {	
					btc {
						CvipMessage "block truncation coding (BTC)performed on image \"$current_image\""
					}
					btc2 {
						CvipMessage "multilevel BTC  performed on image \"$current_image\""
					}
					btc3 {
						CvipMessage "predictive multilevel BTC performed on image \"$current_image\""
					}
					gray_rlc {
						CvipMessage "dynamic window RLE performed on image \"$current_image\""
					}
				}
			}

			dpc {
				set temp "cvip dpc $current_image "
				if [catch {expr $compress(correlation)}] {
					CvipAlert "Numerical values required for the correlation ratio:\n\
					Correlation = $compress(correlation)"
         		$topwin(compress_name) configure -cursor top_left_arrow; update
		         return
				} elseif { $compress(correlation) < "0" || $compress(correlation) > "1" } {
					CvipAlert "The correlation ratio ($compress(correlation)) should be in the range (0-1)."
         		$topwin(compress_name) configure -cursor top_left_arrow; update
		         return
				} else {
					append temp "$compress(correlation) "
				}

				if { $compress(encoding) == "Reconstr. with Lloyd-Max quantizers" } {
					if { $compress(bits) == "8" } {
						CvipAlert "The number of bits (8) here can only be \[1,7\]." 
         			$topwin(compress_name) configure -cursor top_left_arrow; update
						return
					}
					append temp "-1 $compress(bits) "
				} else {
					append temp "1 $compress(bits) "
				}

				if { $compress(direction) == "Vertical" } {
					append temp "1 "
				} else {
					append temp "0 "
				}

				if { $compress(encoding) == "Original values" } {
					append temp "1 -1"
				} elseif { $compress(encoding) == "Reconstructed values" } {
					append temp "2 -1"
				} else {
					append temp "3 "
					if [catch {expr $compress(stddev)}] {
						CvipAlert "Numerical values required for the standard deviation:\n\
						Standard deviation = $compress(stddev)"
         			$topwin(compress_name) configure -cursor top_left_arrow; update
						return
					} elseif { $compress(stddev) < "0" } {
						CvipAlert "The standard deviation ($compress(stddev)) should be greater than 0"
         			$topwin(compress_name) configure -cursor top_left_arrow; update
						return
					} else {
						append temp $compress(stddev)
					}
				}
				if { $GUI_DEBUG == "1" } {
					puts stderr "$temp"
				}
				if [catch {set result [eval $temp] } cresult ] {
					CvipAlert "$cresult."
         		$topwin(compress_name) configure -cursor top_left_arrow; update
		         return
				} 
				set new_name $result
            img_q insert end $new_name
            image_post $new_name
            cvip view $new_name
				CvipMessage "differential predictive coding performed on image \"$current_image\""
			}


		}
      $topwin(compress_name) configure -cursor top_left_arrow; update
	 }

  # build widget $topwin(compress_name).perform.button4
	button $topwin(compress_name).perform.button4 -padx {1} -pady {1} -highlightthickness {0}  \
    -background "$GuiColor(alert_bg)" \
	 -activebackground "$GuiColor(alert_act_bg)" \
    -foreground "$GuiColor(alert_fg)" \
    -command {
	if {[file exists $current_image]} {
		if [AlertBox "File name \"$current_image\" already exists. Overwrite it?" "" 350x150 "ALERT!" YES NO] {
			$topwin(compress_name) configure -cursor top_left_arrow; update
			return
		}
		
	}
	if { $img_fmt == "JPEG" } {
		cvip save $current_image vip
	} else {
		cvip save $current_image
	}
	$topwin(compress_name) configure -cursor top_left_arrow; update} \
    -text {SAVE DECOMPRESSED IMAGE}

  # build widget $topwin(compress_name).perform.button5
	button $topwin(compress_name).perform.button5 -padx {1} -pady {1} -highlightthickness {0}  \
    -background "$GuiColor(alert_bg)" \
	 -activebackground "$GuiColor(alert_act_bg)" \
    -foreground "$GuiColor(alert_fg)" \
    -command {
	if {[file exists $current_image]} {
		if [AlertBox "File name \"$current_image\" already exists. Overwrite it?" "" 350x150 "ALERT!" YES NO] {
			$topwin(compress_name) configure -cursor top_left_arrow; update
			return
		}
		
	}
	if { $img_fmt == "JPEG" } {
		cvip save $current_image JPG
	} else {
		cvip save $current_image vip
	}
	$topwin(compress_name) configure -cursor top_left_arrow; update} \
    -text {SAVE COMPRESSED DATA}


  # pack widget $topwin(compress_name).perform
  pack append $topwin(compress_name).perform \
    $topwin(compress_name).perform.button2 {left frame center} \
    $topwin(compress_name).perform.button4 {left frame center expand  padx 15} \
    $topwin(compress_name).perform.button5 {left frame center expand  padx 15} \
    $topwin(compress_name).perform.button3 {right frame center}

  # pack widget $topwin(compress_name)
  pack append $topwin(compress_name) \
    $topwin(compress_name).info {top frame center expand fill} \
    $topwin(compress_name).current_image {top frame center fillx} \
    $topwin(compress_name).perform {bottom frame center fillx}
}

# lp means more than high/low pass, used for backward compatibility
# procedure to show window .m_util
proc mat_specify_luminance { mat_dim lp } {# xf ignore me 7

  global {util}
  global {chrominance}
  global {luminance}

  global GuiColor
  global GuiMisc
  global GUI_DEBUG
  
  set util(luminance_dim) $mat_dim
  if [ winfo exists .luminance] {
  destroy .luminance
  }
  toplevel .luminance  -background "$GuiColor(frame_bg)"

  # Window manager configurations
  global tk_version
#  wm positionfrom .luminance user
  wm sizefrom .luminance user
  wm maxsize .luminance 500 360
  wm minsize .luminance 0 0
  wm title .luminance {Specify luminance}

  # bindings
  bind .luminance <Destroy> {set util(luminance_val) ""}

  # build widget .luminance.info
  frame .luminance.info \
    -background "$GuiColor(frame_bg)" \
    -borderwidth {2}

  frame .luminance.info.frame \
    -background "$GuiColor(frame_bg)" \
    -borderwidth {2}

  for {set i 0} {$i <= $mat_dim} {incr i} {
  label .luminance.info.frame.label${i} \
    -background "$GuiColor(label_bg)" \
	 -width {5} \
    -text $i
  pack append .luminance.info.frame \
    .luminance.info.frame.label${i} {left frame center expand} 
  }

  .luminance.info.frame.label0 configure -text Mask
  pack append .luminance.info \
    .luminance.info.frame {top frame center expand fill} 

  for {set i 0} {$i < $mat_dim} {incr i} {
  # build widget .luminance.info.frame$i
  frame .luminance.info.frame$i \
    -background "$GuiColor(frame_bg)" \
    -borderwidth {2}

  label .luminance.info.frame${i}.label${i} \
    -background "$GuiColor(label_bg)" \
	 -width {5} \
    -text [expr $i + 1]
  pack append .luminance.info.frame$i \
	 .luminance.info.frame${i}.label${i} {left frame center fill expand}
  for {set j 0} {$j < $mat_dim} {incr j} {

  # build widget .luminance.info.frame${i}.entry${j}
  entry .luminance.info.frame${i}.entry${j} \
    -background "$GuiColor(entry_bg)" \
	 -foreground "$GuiColor(entry_fg)" \
    -borderwidth {1} \
    -relief {sunken} \
    -textvariable luminance($i,$j) \
    -width {4}

    
  if { $j == $mat_dim - 1 } {
	if { $i == $mat_dim -1 } {
		endEntry .luminance.info.frame${i}.entry${j} 0
	} else {
		set temp [expr $i + 1]
		endEntry .luminance.info.frame${i}.entry${j} 0 .luminance.info.frame${temp}.entry0
	}
  } else {
		set temp [expr $j + 1]
		endEntry .luminance.info.frame${i}.entry${j} 0 .luminance.info.frame${i}.entry$temp
  }

  # pack widget .luminance.info.frame0
  pack append .luminance.info.frame${i} \
    .luminance.info.frame${i}.entry${j} {left frame center expand fill}
  }
#end of j
  # pack widget .luminance.info
  pack append .luminance.info \
    .luminance.info.frame$i {top frame center expand fill}
  }
  endEntry .luminance.info.frame[expr ${i}-1].entry[expr ${j}-1] 0 .luminance.info.frame0.entry0
#end of i

  # build widget .luminance.perform
  frame .luminance.perform \
	 -borderwidth {2} \
	 -relief {raised} \
    -background "$GuiColor(frame_bg)"

  # build widget .luminance.perform.accept1
	button .luminance.perform.accept1 -padx {1} -pady {1} -highlightthickness {0}  \
    -background "$GuiColor(perf_bg)" \
	 -activebackground "$GuiColor(perf_act_bg)" \
    -foreground "$GuiColor(perf_fg)" \
    -command {	$topwin(compress_name) configure -cursor watch; update
	write_quant_file $bands
	$topwin(compress_name) configure -cursor top_left_arrow; update
	} \
    -text {ACCEPT}

  # build widget .luminance.perform.dismiss
	button .luminance.perform.dismiss -padx {1} -pady {1} -highlightthickness {0}  \
    -background "$GuiColor(dis_bg)" \
	 -activebackground "$GuiColor(dis_act_bg)" \
    -foreground "$GuiColor(dis_fg)" \
    -command {set util(luminance_val) "";  destroy .luminance} \
    -text {DISMISS} \
    -width {10}

  # build widget .luminance.perform.default
	button .luminance.perform.default -padx {1} -pady {1} -highlightthickness {0}  \
    -background "$GuiColor(alert_bg)" \
	 -activebackground "$GuiColor(alert_act_bg)" \
    -foreground "$GuiColor(alert_fg)" \
    -command {luminance_default
	set compress(jpeg_quant) default} \
    -text {DEFAULT} \
    -width {10}
    
  # pack widget .luminance.perform
  pack append .luminance.perform \
    .luminance.perform.dismiss {left frame sw fill} \
    .luminance.perform.default {left frame center expand} \
    .luminance.perform.accept1 {right frame se fill}

  # pack widget .luminance
  pack append .luminance \
    .luminance.info {top frame center expand fill} \
    .luminance.perform {bottom frame center pady 5 fill}

}

proc luminance_default {} {# xf ignore me 7
  global {luminance}

  set luminance(0,0) "16";
  set luminance(0,1) "11"
  set luminance(0,2) "10"
  set luminance(0,3) "16"
  set luminance(0,4) "24"
  set luminance(0,5) "40"
  set luminance(0,6) "51"
  set luminance(0,7) "61"
  set luminance(1,0) "12"
  set luminance(1,1) "12"
  set luminance(1,2) "14"
  set luminance(1,3) "19"
  set luminance(1,4) "26"
  set luminance(1,5) "58"
  set luminance(1,6) "60"
  set luminance(1,7) "55"
  set luminance(2,0) "14"
  set luminance(2,1) "13"
  set luminance(2,2) "16"
  set luminance(2,3) "24"
  set luminance(2,4) "40"
  set luminance(2,5) "57"
  set luminance(2,6) "69"
  set luminance(2,7) "56"
  set luminance(3,0) "14"
  set luminance(3,1) "17"
  set luminance(3,2) "22"
  set luminance(3,3) "29"
  set luminance(3,4) "51"
  set luminance(3,5) "87"
  set luminance(3,6) "80"
  set luminance(3,7) "62"
  set luminance(4,0) "18"
  set luminance(4,1) "22"
  set luminance(4,2) "37"
  set luminance(4,3) "56"
  set luminance(4,4) "68"
  set luminance(4,5) "109"
  set luminance(4,6) "103"
  set luminance(4,7) "77"
  set luminance(5,0) "24"
  set luminance(5,1) "35"
  set luminance(5,2) "55"
  set luminance(5,3) "64"
  set luminance(5,4) "81"
  set luminance(5,5) "104"
  set luminance(5,6) "113"
  set luminance(5,7) "92"
  set luminance(6,0) "49"
  set luminance(6,1) "64"
  set luminance(6,2) "78"
  set luminance(6,3) "87"
  set luminance(6,4) "103"
  set luminance(6,5) "121"
  set luminance(6,6) "120"
  set luminance(6,7) "101"
  set luminance(7,0) "72"
  set luminance(7,1) "92"
  set luminance(7,2) "95"
  set luminance(7,3) "98"
  set luminance(7,4) "112"
  set luminance(7,5) "100"
  set luminance(7,6) "103"
  set luminance(7,7) "99"
}
#------------------------------------------------------------
# lp means more than high/low pass, used for backward compatibility
# procedure to show window .m_util
proc mat_specify_chrominance { mat_dim lp } {# xf ignore me 7

  global {util}
  global {chrominance}
  global {luminance}
  global topwin
  global toplevel_position

  global GuiColor
  global GuiMisc
  global GUI_DEBUG
  
  set util(chrominance_dim) $mat_dim
  if [ winfo exists .chrominance] {
  destroy .chrominance
  }
  toplevel .chrominance  -background "$GuiColor(frame_bg)"

  # Window manager configurations
  global tk_version
#  wm positionfrom .chrominance user
  wm sizefrom .chrominance user
  wm maxsize .chrominance 500 360
  wm minsize .chrominance 0 0
  wm title .chrominance {Specify chrominance}

  # bindings
  bind .chrominance <Destroy> {set util(chrominance_val) ""}

  # build widget .chrominance.info
  frame .chrominance.info \
    -background "$GuiColor(frame_bg)" \
    -borderwidth {2}

  frame .chrominance.info.frame \
    -background "$GuiColor(frame_bg)" \
    -borderwidth {2}

  for {set i 0} {$i <= $mat_dim} {incr i} {
  label .chrominance.info.frame.label${i} \
    -background "$GuiColor(label_bg)" \
	 -width {5} \
    -text $i
  pack append .chrominance.info.frame \
    .chrominance.info.frame.label${i} {left frame center expand} 
  }

  .chrominance.info.frame.label0 configure -text Mask
  pack append .chrominance.info \
    .chrominance.info.frame {top frame center expand fill} 

  for {set i 0} {$i < $mat_dim} {incr i} {
  # build widget .chrominance.info.frame$i
  frame .chrominance.info.frame$i \
    -background "$GuiColor(frame_bg)" \
    -borderwidth {2}

  label .chrominance.info.frame${i}.label${i} \
    -background "$GuiColor(label_bg)" \
	 -width {5} \
    -text [expr $i + 1]
  pack append .chrominance.info.frame$i \
	 .chrominance.info.frame${i}.label${i} {left frame center fill expand}
  for {set j 0} {$j < $mat_dim} {incr j} {

  # build widget .chrominance.info.frame${i}.entry${j}
  entry .chrominance.info.frame${i}.entry${j} \
    -background "$GuiColor(entry_bg)" \
	 -foreground "$GuiColor(entry_fg)" \
    -borderwidth {1} \
    -relief {sunken} \
    -textvariable chrominance($i,$j) \
    -width {4}
    
  if { $j == $mat_dim - 1 } {
	if { $i == $mat_dim -1 } {
		endEntry .chrominance.info.frame${i}.entry${j} 0
	} else {
		set temp [expr $i + 1]
		endEntry .chrominance.info.frame${i}.entry${j} 0 .chrominance.info.frame${temp}.entry0
	}
  } else {
		set temp [expr $j + 1]
		endEntry .chrominance.info.frame${i}.entry${j} 0 .chrominance.info.frame${i}.entry$temp
  }

  # pack widget .chrominance.info.frame0
  pack append .chrominance.info.frame${i} \
    .chrominance.info.frame${i}.entry${j} {left frame center expand fill}
  }
#end of j
  # pack widget .chrominance.info
  pack append .chrominance.info \
    .chrominance.info.frame$i {top frame center expand fill}
  }
  endEntry .chrominance.info.frame[expr ${i}-1].entry[expr ${j}-1] 0 .chrominance.info.frame0.entry0
#end of i


  # build widget .chrominance.perform
  frame .chrominance.perform \
	 -borderwidth {2} \
	 -relief {raised} \
    -background "$GuiColor(frame_bg)"

  # build widget .chrominance.perform.accept1
    button .chrominance.perform.accept1 -padx {1} -pady {1} -highlightthickness {0}  \
    -background "$GuiColor(perf_bg)" \
	 -activebackground "$GuiColor(perf_act_bg)" \
    -foreground "$GuiColor(perf_fg)" \
    -command {
	$topwin(compress_name) configure -cursor watch; update
	write_quant_file $bands
	$topwin(compress_name) configure -cursor top_left_arrow; update
	} \
    -text {ACCEPT}

  # build widget .chrominance.perform.dismiss
	button .chrominance.perform.dismiss -padx {1} -pady {1} -highlightthickness {0}  \
    -background "$GuiColor(dis_bg)" \
	 -activebackground "$GuiColor(dis_act_bg)" \
    -foreground "$GuiColor(dis_fg)" \
    -command {set util(chrominance_val) "";  destroy .chrominance} \
    -text {DISMISS} \
    -width {10}

  # build widget .chrominance.perform.default
	button .chrominance.perform.default -padx {1} -pady {1} -highlightthickness {0}  \
    -background "$GuiColor(alert_bg)" \
	 -activebackground "$GuiColor(alert_act_bg)" \
    -foreground "$GuiColor(alert_fg)" \
    -command {chrominance_default
	set compress(jpeg_quant) default} \
    -text {DEFAULT} \
    -width {10}
    
  # pack widget .chrominance.perform
  pack append .chrominance.perform \
    .chrominance.perform.dismiss {left frame sw fill} \
    .chrominance.perform.default {left frame center expand} \
    .chrominance.perform.accept1 {right frame se fill}

  # pack widget .chrominance
  pack append .chrominance \
    .chrominance.info {top frame center expand fill} \
    .chrominance.perform {bottom frame center pady 5 fill}

}

proc chrominance_default {} {# xf ignore me 7
  global {chrominance}

  set chrominance(0,0) "17"
  set chrominance(0,1) "18"
  set chrominance(0,2) "24"
  set chrominance(0,3) "47"
  set chrominance(0,4) "99"
  set chrominance(0,5) "99"
  set chrominance(0,6) "99"
  set chrominance(0,7) "99"
  set chrominance(1,0) "18"
  set chrominance(1,1) "21"
  set chrominance(1,2) "26"
  set chrominance(1,3) "66"
  set chrominance(1,4) "99"
  set chrominance(1,5) "99"
  set chrominance(1,6) "99"
  set chrominance(1,7) "99"
  set chrominance(2,0) "24"
  set chrominance(2,1) "26"
  set chrominance(2,2) "56"
  set chrominance(2,3) "99"
  set chrominance(2,4) "99"
  set chrominance(2,5) "99"
  set chrominance(2,6) "99"
  set chrominance(2,7) "99"
  set chrominance(3,0) "47"
  set chrominance(3,1) "66"
  set chrominance(3,2) "99"
  set chrominance(3,3) "99"
  set chrominance(3,4) "99"
  set chrominance(3,5) "99"
  set chrominance(3,6) "99"
  set chrominance(3,7) "99"
  set chrominance(4,0) "99"
  set chrominance(4,1) "99"
  set chrominance(4,2) "99"
  set chrominance(4,3) "99"
  set chrominance(4,4) "99"
  set chrominance(4,5) "99"
  set chrominance(4,6) "99"
  set chrominance(4,7) "99"
  set chrominance(5,0) "99"
  set chrominance(5,1) "99"
  set chrominance(5,2) "99"
  set chrominance(5,3) "99"
  set chrominance(5,4) "99"
  set chrominance(5,5) "99"
  set chrominance(5,6) "99"
  set chrominance(5,7) "99"
  set chrominance(6,0) "99"
  set chrominance(6,1) "99"
  set chrominance(6,2) "99"
  set chrominance(6,3) "99"
  set chrominance(6,4) "99"
  set chrominance(6,5) "99"
  set chrominance(6,6) "99"
  set chrominance(6,7) "99"
  set chrominance(7,0) "99"
  set chrominance(7,1) "99"
  set chrominance(7,2) "99"
  set chrominance(7,3) "99"
  set chrominance(7,4) "99"
  set chrominance(7,5) "99"
  set chrominance(7,6) "99"
  set chrominance(7,7) "99"
}

proc write_quant_file {bands} {# xf ignore me 7
  global topwin
  global toplevel_position
  global {chrominance}
  global {luminance}
  set bands 3
  global GuiColor
  global GuiMisc
  global GUI_DEBUG
  
  set table_size 8
  set open_file_type w
  #set quant_filename quant.txt
  set quant_filename [cvip temp_filename "quant.txt"]
  #puts $quant_filename
  set outfileID [open $quant_filename $open_file_type+ 0666]

  if {$open_file_type == "w"} {
       for {set i 0} {$i < $table_size} {incr i} {
    	for {set j 0} {$j < $table_size} {incr j} {
        	puts -nonewline $outfileID "$luminance($i,$j)"
        	puts -nonewline $outfileID " "
        }
     }
     puts $outfileID " "
     if {$bands == "3"} {
        for {set i 0} {$i < $table_size} {incr i} {
    	    for {set j 0} {$j < $table_size} {incr j} {
        	puts -nonewline $outfileID "$chrominance($i,$j)"
        	puts -nonewline $outfileID " "
            }
        }
     }
     
  }
  close $outfileID
 
}


proc chrominance_nonquant {} {# xf ignore me 7
  global {chrominance}
  for {set temp 0} { $temp < 8 } {incr temp } {
     for {set temp1 0} { $temp1 < 8 } {incr temp1 } {
          set chrominance($temp,$temp1) "1";
     }
  }

}



proc luminance_nonquant {} {# xf ignore me 7
  global {luminance}
  for {set temp 0} { $temp < 8 } {incr temp } {
     for {set temp1 0} { $temp1 < 8 } {incr temp1 } {
          set luminance($temp,$temp1) "1";
     }
  }

}
