# **********************************************************************
# Computer Vision/Image Processing Tool Project - Dr. Scott Umbaugh SIUE
# **********************************************************************
#
#             File Name: cmprs_prep.tcl
#           Description: 
#         Related Files: 
#   Initial Coding Date: Wed Oct  2 22:21:46 CDT 1996
#           Portability: TCL script file
#            References:
#             Author(s): Mark Zuke and Yansheng Wei
#                        Southern Illinois University @ Edwardsville
#
## Copyright (C) 1996 SIUE - by Scott Umbaugh, Mark Zuke and Yansheng Wei.
##
## Permission to use, copy, modify, and distribute this software and its
## documentation for any purpose and without fee is hereby granted, provided
## that the above copyright notice appear in all copies and that both that
## copyright notice and this permission notice appear in supporting
## documentation.  This software is provided "as is" without express or
## implied warranty.
##
# RCS (Revision Control System) Information
# ...Added automatically by RCS 
#
## $Log: cmprs_prep.tcl,v $
## Revision 1.11  1997/08/06 00:04:41  yawei
## fixed position problem
##
## Revision 1.10  1997/08/06 00:01:57  yawei
## fixed position problem
##
## Revision 1.9  1997/07/07 21:12:25  yawei
## Gui configuration in place.
##
## Revision 1.8  1997/04/25 22:09:39  yawei
## added selection for standard and IGS of gray level quantization
##
## Revision 1.7  1997/03/12 15:01:33  yawei
## fixed arrow button bugs.
##
## Revision 1.6  1997/03/11 20:55:48  yawei
## Tcl/Tk script upgrading from tcl7.3/tk3.6 to tcl7.6/tk4.2
## compatible. This process is automated with tkboost perl
## script. @ Tue Mar 11 14:51:36 CST 1997
##
## Revision 1.5  1996/10/16 16:27:29  mzuke
## moved 'view image' after 'image_post' to correctly label
## displayed images; shortened some image names
##
# Revision 1.4  1996/10/08  02:43:38  yawei
# added boundar checking to the spatial quantization parameters
#
# Revision 1.3  1996/10/04  14:38:58  mzuke
# added command to DISMISS button; returned
# cursor to arrow after bin_gray
#
# Revision 1.2  1996/10/03  19:30:31  yawei
# deleted unnecessary lines
#
# Revision 1.1  1996/10/03  03:23:04  yawei
# Initial revision
#
#
#****************************************************************************
# procedure to show window .
proc cmprs_prep { } {# xf ignore me 7

  # Window manager configurations
  global tk_version
  global topwin
  global GuiColor
  global GuiMisc
  global GUI_DEBUG

  global {compress}
  if [ winfo exists $topwin(compress_name).info] {
     set tempname $topwin(compress_name);\
destroy $topwin(compress_name).info;\
set topwin(compress_name) $tempname;}
  if [ winfo exists $topwin(compress_name).current_image] {
     set tempname $topwin(compress_name);\
destroy $topwin(compress_name).current_image;\
set topwin(compress_name) $tempname;}
  if [ winfo exists $topwin(compress_name).perform] {
     set tempname $topwin(compress_name);\
destroy $topwin(compress_name).perform;\
set topwin(compress_name) $tempname;}
  wm positionfrom $topwin(compress_name) user
  wm sizefrom $topwin(compress_name) user

  wm geometry $topwin(compress_name) $topwin(compress_prep)[get_pos $topwin(compress_name)]
  wm maxsize $topwin(compress_name) [lindex [split $topwin(compress_prep_max)] 0] \
  	[lindex [split $topwin(compress_prep_max)] 1]
  wm minsize $topwin(compress_name) [lindex [split $topwin(compress_prep_min)] 0] \
  	[lindex [split $topwin(compress_prep_min)] 1]
  wm title $topwin(compress_name) {COMPRESSION->Preprocessing}


  # build widget $topwin(compress_name).info
  frame $topwin(compress_name).info \
    -background "$GuiColor(frame_bg)" \
    -borderwidth {0}

  # build widget $topwin(compress_name).info.frame0
  frame $topwin(compress_name).info.frame0 \
    -background "$GuiColor(frame_bg)" \
    -borderwidth {2} \
    -relief {ridge}

  # build widget $topwin(compress_name).info.frame0.frame0
  frame $topwin(compress_name).info.frame0.frame0 \
    -background "$GuiColor(frame_bg)" \
    -borderwidth {2}

  # build widget $topwin(compress_name).info.frame0.frame0.radiobutton4
	radiobutton $topwin(compress_name).info.frame0.frame0.radiobutton4 -padx {1} -pady {1} -highlightthickness {0}  \
    -background "$GuiColor(btn_bg)" \
	 -activebackground "$GuiColor(btn_act_bg)" \
    -relief {flat} \
    -text {Convert binary to gray code} \
    -value {bin_gray} \
    -variable {compress(preproc)}

  # build widget $topwin(compress_name).info.frame0.frame0.radiobutton5
	radiobutton $topwin(compress_name).info.frame0.frame0.radiobutton5 -padx {1} -pady {1} -highlightthickness {0}  \
    -background "$GuiColor(btn_bg)" \
	 -activebackground "$GuiColor(btn_act_bg)" \
    -relief {flat} \
    -text {Convert gray code to binary} \
    -value {gray_bin} \
    -variable {compress(preproc)}

  # pack widget $topwin(compress_name).info.frame0.frame0
  pack append $topwin(compress_name).info.frame0.frame0 \
    $topwin(compress_name).info.frame0.frame0.radiobutton4 {top frame w} \
    $topwin(compress_name).info.frame0.frame0.radiobutton5 {top frame w}

  # pack widget $topwin(compress_name).info.frame0
  pack append $topwin(compress_name).info.frame0 \
    $topwin(compress_name).info.frame0.frame0 {top frame w expand}

  # build widget $topwin(compress_name).info.frame1
  frame $topwin(compress_name).info.frame1 \
    -background "$GuiColor(frame_bg)" \
    -borderwidth {2} \
    -relief {ridge}

  # build widget $topwin(compress_name).info.frame1.radiobutton4
	radiobutton $topwin(compress_name).info.frame1.radiobutton4 -padx {1} -pady {1} -highlightthickness {0}  \
    -background "$GuiColor(btn_bg)" \
	 -activebackground "$GuiColor(btn_act_bg)" \
    -relief {flat} \
    -text {Spatial quantization} \
    -value {spatial_quant} \
    -variable {compress(preproc)}

  # build widget $topwin(compress_name).info.frame1.frame9
  frame $topwin(compress_name).info.frame1.frame9 \
    -background "$GuiColor(frame_bg)" \
    -borderwidth {2}

  # build widget $topwin(compress_name).info.frame1.frame9.label6
  label $topwin(compress_name).info.frame1.frame9.label6 \
    -background "$GuiColor(label_bg)" \
    -text {To height:}

  # build widget $topwin(compress_name).info.frame1.frame9.entry7
  entry $topwin(compress_name).info.frame1.frame9.entry7 \
    -background "$GuiColor(entry_bg)" \
	 -foreground "$GuiColor(entry_fg)" \
    -relief {sunken} \
    -textvariable {compress(quant_ht)} \
    -width {5}
  endEntry  $topwin(compress_name).info.frame1.frame9.entry7 0\
     $topwin(compress_name).info.frame1.frame10.entry7 \
     $topwin(compress_name).info.frame1.frame10.entry7 

  # build widget $topwin(compress_name).info.frame1.frame9.button8
	menubutton $topwin(compress_name).info.frame1.frame9.button8 -padx {1} -pady {1} -highlightthickness {0}  \
    -background "$GuiColor(btn_bg)" \
	 -activebackground "$GuiColor(btn_act_bg)" \
	 -font "$GuiMisc(pop_up_fn)" \
	 -text "$GuiMisc(pop_up_text)" \
	 -relief "$GuiMisc(pop_up_relief)" \
	 -width {2}
  # bindings
  bind $topwin(compress_name).info.frame1.frame9.button8 <Button-1> {MenuPopupPost $topwin(compress_name).info.frame1.frame9.button8.menu %X %Y}
  bind $topwin(compress_name).info.frame1.frame9.button8 <ButtonRelease-1> {MenuPopupRelease $topwin(compress_name).info.frame1.frame9.button8.menu %W}

  # build widget $topwin(compress_name).info.frame1.frame9.button8.menu
  menu $topwin(compress_name).info.frame1.frame9.button8.menu \
   -activebackground "$GuiColor(menu_act_bg)" \
   -background "$GuiColor(menu_bg)"

  $topwin(compress_name).info.frame1.frame9.button8.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -command {set compress(quant_ht) 32} \
    -label {32}
  $topwin(compress_name).info.frame1.frame9.button8.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -command {set compress(quant_ht) 64} \
    -label {64}
  $topwin(compress_name).info.frame1.frame9.button8.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -command {set compress(quant_ht) 128} \
    -label {128}
  $topwin(compress_name).info.frame1.frame9.button8.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -command {set compress(quant_ht) 256} \
    -label {256}
  bindtags $topwin(compress_name).info.frame1.frame9.button8.menu  {Menu all}
  # bindings
  bind $topwin(compress_name).info.frame1.frame9.button8.menu <B1-Motion> {MenuPopupMotion $topwin(compress_name).info.frame1.frame9.button8.menu %W %X %Y}
  bind $topwin(compress_name).info.frame1.frame9.button8.menu <ButtonRelease-1> {MenuPopupRelease $topwin(compress_name).info.frame1.frame9.button8.menu %W}

  # pack widget $topwin(compress_name).info.frame1.frame9
  pack append $topwin(compress_name).info.frame1.frame9 \
    $topwin(compress_name).info.frame1.frame9.label6 {left frame center} \
    $topwin(compress_name).info.frame1.frame9.entry7 {left frame center} \
    $topwin(compress_name).info.frame1.frame9.button8 {left frame center}

  # build widget $topwin(compress_name).info.frame1.frame10
  frame $topwin(compress_name).info.frame1.frame10 \
    -background "$GuiColor(frame_bg)" \
    -borderwidth {2}

  # build widget $topwin(compress_name).info.frame1.frame10.label6
  label $topwin(compress_name).info.frame1.frame10.label6 \
    -background "$GuiColor(label_bg)" \
    -text {To width:}

  # build widget $topwin(compress_name).info.frame1.frame10.entry7
  entry $topwin(compress_name).info.frame1.frame10.entry7 \
    -background "$GuiColor(entry_bg)" \
	 -foreground "$GuiColor(entry_fg)" \
    -relief {sunken} \
    -textvariable {compress(quant_wd)} \
    -width {5}
  endEntry  $topwin(compress_name).info.frame1.frame10.entry7 0\
     $topwin(compress_name).info.frame1.frame9.entry7 \
     $topwin(compress_name).info.frame1.frame9.entry7 

  # build widget $topwin(compress_name).info.frame1.frame10.button8
	menubutton $topwin(compress_name).info.frame1.frame10.button8 -padx {1} -pady {1} -highlightthickness {0}  \
    -background "$GuiColor(btn_bg)" \
	 -activebackground "$GuiColor(btn_act_bg)" \
	 -font "$GuiMisc(pop_up_fn)" \
	 -text "$GuiMisc(pop_up_text)" \
	 -relief "$GuiMisc(pop_up_relief)" \
	 -width {2}
  # bindings
  bind $topwin(compress_name).info.frame1.frame10.button8 <Button-1> {MenuPopupPost $topwin(compress_name).info.frame1.frame10.button8.menu %X %Y}
  bind $topwin(compress_name).info.frame1.frame10.button8 <ButtonRelease-1> {MenuPopupRelease $topwin(compress_name).info.frame1.frame10.button8.menu %W}

  # build widget $topwin(compress_name).info.frame1.frame10.button8.menu
  menu $topwin(compress_name).info.frame1.frame10.button8.menu \
   -activebackground "$GuiColor(menu_act_bg)" \
   -background "$GuiColor(menu_bg)"
  $topwin(compress_name).info.frame1.frame10.button8.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -command {set compress(quant_wd) 32} \
    -label {32}
  $topwin(compress_name).info.frame1.frame10.button8.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -command {set compress(quant_wd) 64} \
    -label {64}
  $topwin(compress_name).info.frame1.frame10.button8.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -command {set compress(quant_wd) 128} \
    -label {128}
  $topwin(compress_name).info.frame1.frame10.button8.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -command {set compress(quant_wd) 256} \
    -label {256}
  bindtags $topwin(compress_name).info.frame1.frame10.button8.menu {Menu all}
  # bindings
  bind $topwin(compress_name).info.frame1.frame10.button8.menu <B1-Motion> {MenuPopupMotion $topwin(compress_name).info.frame1.frame10.button8.menu %W %X %Y}
  bind $topwin(compress_name).info.frame1.frame10.button8.menu <ButtonRelease-1> {MenuPopupRelease $topwin(compress_name).info.frame1.frame10.button8.menu %W}

  # pack widget $topwin(compress_name).info.frame1.frame10
  pack append $topwin(compress_name).info.frame1.frame10 \
    $topwin(compress_name).info.frame1.frame10.label6 {left frame center} \
    $topwin(compress_name).info.frame1.frame10.entry7 {left frame center} \
    $topwin(compress_name).info.frame1.frame10.button8 {left frame center}

  # build widget $topwin(compress_name).info.frame1.frame11
  frame $topwin(compress_name).info.frame1.frame11 \
    -background "$GuiColor(frame_bg)" \
    -borderwidth {2}

  # build widget $topwin(compress_name).info.frame1.frame11.label6
  label $topwin(compress_name).info.frame1.frame11.label6 \
    -background "$GuiColor(label_bg)" \
    -text {Method:}

  # build widget $topwin(compress_name).info.frame1.frame11.entry7
  entry $topwin(compress_name).info.frame1.frame11.entry7 \
    -background "$GuiColor(rentry_bg)" \
	 -foreground "$GuiColor(rentry_fg)" \
    -relief {sunken} \
    -state {disabled} \
    -textvariable {compress(quant_meth)} \
    -width {9}

  # build widget $topwin(compress_name).info.frame1.frame11.button8
	menubutton $topwin(compress_name).info.frame1.frame11.button8 -padx {1} -pady {1} -highlightthickness {0}  \
    -background "$GuiColor(btn_bg)" \
	 -activebackground "$GuiColor(btn_act_bg)" \
	 -font "$GuiMisc(pop_up_fn)" \
	 -text "$GuiMisc(pop_up_text)" \
	 -relief "$GuiMisc(pop_up_relief)" \
	 -width {2}
  # bindings
  bind $topwin(compress_name).info.frame1.frame11.button8 <Button-1> {MenuPopupPost $topwin(compress_name).info.frame1.frame11.button8.menu %X %Y}
  bind $topwin(compress_name).info.frame1.frame11.button8 <ButtonRelease-1> {MenuPopupRelease $topwin(compress_name).info.frame1.frame11.button8.menu %W}

  # build widget $topwin(compress_name).info.frame1.frame11.button8.menu
  menu $topwin(compress_name).info.frame1.frame11.button8.menu \
   -activebackground "$GuiColor(menu_act_bg)" \
   -background "$GuiColor(menu_bg)"
  $topwin(compress_name).info.frame1.frame11.button8.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -command {set compress(quant_meth) average
set compress(quant_method) 1} \
    -label {average value}
  $topwin(compress_name).info.frame1.frame11.button8.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -command {set compress(quant_meth) median
set compress(quant_method) 2} \
    -label {median value}
  $topwin(compress_name).info.frame1.frame11.button8.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -command {set compress(quant_meth) decimation
set compress(quant_method) 3} \
    -label {decimation}
  bindtags $topwin(compress_name).info.frame1.frame11.button8.menu {Menu all}
  # bindings
  bind $topwin(compress_name).info.frame1.frame11.button8.menu <B1-Motion> {MenuPopupMotion $topwin(compress_name).info.frame1.frame11.button8.menu %W %X %Y}
  bind $topwin(compress_name).info.frame1.frame11.button8.menu <ButtonRelease-1> {MenuPopupRelease $topwin(compress_name).info.frame1.frame11.button8.menu %W}

  # pack widget $topwin(compress_name).info.frame1.frame11
  pack append $topwin(compress_name).info.frame1.frame11 \
    $topwin(compress_name).info.frame1.frame11.label6 {left frame center} \
    $topwin(compress_name).info.frame1.frame11.entry7 {left frame center} \
    $topwin(compress_name).info.frame1.frame11.button8 {left frame center}

  # pack widget $topwin(compress_name).info.frame1
  pack append $topwin(compress_name).info.frame1 \
    $topwin(compress_name).info.frame1.radiobutton4 {left frame w} \
    $topwin(compress_name).info.frame1.frame9 {left frame center} \
    $topwin(compress_name).info.frame1.frame10 {left frame center} \
    $topwin(compress_name).info.frame1.frame11 {left frame center}

  # build widget $topwin(compress_name).info.frame2
  frame $topwin(compress_name).info.frame2 \
    -background "$GuiColor(frame_bg)" \
    -borderwidth {2} \
    -relief {ridge}

  # build widget $topwin(compress_name).info.frame2.entry20
  entry $topwin(compress_name).info.frame2.entry20 \
    -background "$GuiColor(entry_bg)" \
	 -foreground "$GuiColor(entry_fg)" \
    -relief {sunken} \
    -textvariable {compress(gray_quant_num)} \
    -width {4}
  endEntry $topwin(compress_name).info.frame2.entry20 

  # build widget $topwin(compress_name).info.frame2.radiobutton7
	radiobutton $topwin(compress_name).info.frame2.radiobutton7 -padx {1} -pady {1} -highlightthickness {0}  \
    -background "$GuiColor(btn_bg)" \
	 -activebackground "$GuiColor(btn_act_bg)" \
    -command { if {$compress(gray_quant_num) == "" } {set compress(gray_quant_num) 4}} \
    -relief {flat} \
    -text {Gray Level Quantization, } \
    -value {gray_quant} \
    -variable {compress(preproc)}

  # build widget $topwin(compress_name).info.frame2.label19
  label $topwin(compress_name).info.frame2.label19 \
    -background "$GuiColor(label_bg)" \
    -text {with the number of gray levels: }

  # build widget $topwin(compress_name).info.frame2.button19
	menubutton $topwin(compress_name).info.frame2.button19 -padx {1} -pady {1} -highlightthickness {0}  \
    -background "$GuiColor(btn_bg)" \
	 -activebackground "$GuiColor(btn_act_bg)" \
	 -font "$GuiMisc(pop_up_fn)" \
	 -text "$GuiMisc(pop_up_text)" \
	 -relief "$GuiMisc(pop_up_relief)" \
	 -width {2}
  # bindings
  bind $topwin(compress_name).info.frame2.button19 <Button-1> {MenuPopupPost $topwin(compress_name).info.frame2.button19.menu %X %Y}
  bind $topwin(compress_name).info.frame2.button19 <ButtonRelease-1> {MenuPopupRelease $topwin(compress_name).info.frame2.button19.menu %W}

  # build widget $topwin(compress_name).info.frame2.button19.menu
  menu $topwin(compress_name).info.frame2.button19.menu \
   -activebackground "$GuiColor(menu_act_bg)" \
   -background "$GuiColor(menu_bg)"
  $topwin(compress_name).info.frame2.button19.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -command {set compress(gray_quant_num) 2} \
    -label {  2}
  $topwin(compress_name).info.frame2.button19.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -command {set compress(gray_quant_num) 4} \
    -label {  4}
  $topwin(compress_name).info.frame2.button19.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -command {set compress(gray_quant_num) 8} \
    -label {  8}
  $topwin(compress_name).info.frame2.button19.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -command {set compress(gray_quant_num) 16} \
    -label { 16}
  $topwin(compress_name).info.frame2.button19.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -command {set compress(gray_quant_num) 32} \
    -label { 32}
  $topwin(compress_name).info.frame2.button19.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -command {set compress(gray_quant_num) 64} \
    -label { 64}
  $topwin(compress_name).info.frame2.button19.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -command {set compress(gray_quant_num) 128} \
    -label {128}
  bindtags $topwin(compress_name).info.frame2.button19.menu {Menu all}
  # bindings
  bind $topwin(compress_name).info.frame2.button19.menu <B1-Motion> {MenuPopupMotion $topwin(compress_name).info.frame2.button19.menu %W %X %Y}
  bind $topwin(compress_name).info.frame2.button19.menu <ButtonRelease-1> {MenuPopupRelease $topwin(compress_name).info.frame2.button19.menu %W}

  # build widget $topwin(compress_name).info.frame2.radiobutton8
	radiobutton $topwin(compress_name).info.frame2.radiobutton8 -padx {1} -pady {1} -highlightthickness {0}  \
    -background "$GuiColor(btn_bg)" \
	 -activebackground "$GuiColor(btn_act_bg)" \
    -relief {flat} \
    -text {Standard} \
    -value {standard} \
    -variable {compress(gray_quant_method)}

  # build widget $topwin(compress_name).info.frame2.radiobutton9
	radiobutton $topwin(compress_name).info.frame2.radiobutton9 -padx {1} -pady {1} -highlightthickness {0}  \
    -background "$GuiColor(btn_bg)" \
	 -activebackground "$GuiColor(btn_act_bg)" \
    -relief {flat} \
    -text {IGS} \
    -value {IGS} \
    -variable {compress(gray_quant_method)}

  # pack widget $topwin(compress_name).info.frame2
  pack append $topwin(compress_name).info.frame2 \
    $topwin(compress_name).info.frame2.radiobutton7 {left frame center} \
    $topwin(compress_name).info.frame2.label19 {left frame center} \
    $topwin(compress_name).info.frame2.entry20 {left frame center} \
    $topwin(compress_name).info.frame2.button19 {left frame center fillx} \
    $topwin(compress_name).info.frame2.radiobutton8 {top frame nw expand filly} \
    $topwin(compress_name).info.frame2.radiobutton9 {bottom frame nw expand filly}

  # pack widget $topwin(compress_name).info
  pack append $topwin(compress_name).info \
    $topwin(compress_name).info.frame0 {top frame center expand fill} \
    $topwin(compress_name).info.frame1 {top frame center expand fill} \
    $topwin(compress_name).info.frame2 {top frame center expand fill}

  # build widget $topwin(compress_name).current_image
  frame $topwin(compress_name).current_image \
    -background "$GuiColor(frame_bg)" \
    -borderwidth {2} \
    -relief {ridge}

  # build widget $topwin(compress_name).current_image.label0
  label $topwin(compress_name).current_image.label0 \
    -background "$GuiColor(label_bg)" \
    -text {Current image: }

  # build widget $topwin(compress_name).current_image.label1
  label $topwin(compress_name).current_image.label1 \
    -background "$GuiColor(label_bg)" \
    -foreground {Blue} \
    -text {} \
    -textvariable {current_image}

  # pack widget $topwin(compress_name).current_image
  pack append $topwin(compress_name).current_image \
    $topwin(compress_name).current_image.label0 {left frame center} \
    $topwin(compress_name).current_image.label1 {left frame center}

  # build widget $topwin(compress_name).perform
  frame $topwin(compress_name).perform \
    -background "$GuiColor(frame_bg)" \
    -borderwidth {2} \
    -relief {raised}

  # build widget $topwin(compress_name).perform.button2
	button $topwin(compress_name).perform.button2 -padx {1} -pady {1} -highlightthickness {0}  \
    -foreground "$GuiColor(dis_fg)" \
    -background "$GuiColor(dis_bg)" \
	 -activebackground "$GuiColor(dis_act_bg)" \
   -command {destroy $topwin(compress_name) } \
    -text {DISMISS}

  # build widget $topwin(compress_name).perform.button3
	button $topwin(compress_name).perform.button3 -padx {1} -pady {1} -highlightthickness {0}  \
    -foreground "$GuiColor(perf_fg)" \
    -background "$GuiColor(perf_bg)" \
	 -activebackground "$GuiColor(perf_act_bg)" \
    -command {

$topwin(compress_name) configure -cursor watch; update

if {$current_image == ""} {
	CvipAlert "Please select an image first."
	$topwin(compress_name) configure -cursor top_left_arrow; update
        return
}
		
switch -exact -- $compress(preproc) {
			
	gray_bin -
	bin_gray	{
				set gb_dir 0
				set gb_name bin 
				if { $compress(preproc) == "bin_gray" } {set gb_dir 1; set gb_name gray}
				if [ catch { set result [cvip gray_binary $current_image $gb_dir]} cresult ] {
					CvipAlert "$cresult."
					$topwin(compress_name) configure -cursor top_left_arrow; update
					return
				}
				set new_name [cvip rename $result ${current_image}_$gb_name]
				$topwin(compress_name) configure -cursor top_left_arrow; update
				img_q insert end $new_name
				image_post $new_name
				cvip view $new_name
				if { $compress(preproc) == "bin_gray" } {
					CvipMessage "binary to gray coding performed on image \"$current_image\""
				} else {
					CvipMessage "gray to binary coding performed on image \"$current_image\""
				}
			}

	gray_quant 	{
				if [catch {expr $compress(gray_quant_num)}] {
					CvipAlert "Numerical values required for the Number_of_gray_levels: \n Number_of_gray_levels= $compress(gray_quant_num)"
					$topwin(compress_name) configure -cursor top_left_arrow; update
					return
				}
				if { $compress(gray_quant_num) < 2 || $compress(gray_quant_num) > 128 || $compress(gray_quant_num)/2*2 != $compress(gray_quant_num)} {
					CvipAlert "Number_of_gray_levels should be one of the following values: \n  (2, 4, 8, 16, ..., 128), instead of ($compress(gray_quant_num))"
					$topwin(compress_name) configure -cursor top_left_arrow; update
					return
				}
				if { $compress(gray_quant_method) == "standard" } {
					if [ catch {set result [cvip $compress(preproc) $current_image $compress(gray_quant_num)]} cresult ] {
						CvipAlert "$cresult."
						$topwin(compress_name) configure -cursor top_left_arrow; update
						return
					}
				} else {
					if [ catch {set result [cvip igs $current_image $compress(gray_quant_num)]} cresult ] {
						CvipAlert "$cresult."
						$topwin(compress_name) configure -cursor top_left_arrow; update
						return
					}
				}
				$topwin(compress_name) configure -cursor top_left_arrow; update
				set new_name [cvip rename $result ${current_image}_quant$compress(gray_quant_num)]
				img_q insert end $new_name
				image_post $new_name
				cvip view $new_name
				if { $compress(gray_quant_method) == "standard" } {
					CvipMessage "standard gray level quantization performed on image \"$current_image\""
				} else {
					CvipMessage "improved gray scale (IGS) quantization performed on image \"$current_image\""
				}
			}

	spatial_quant	{
		if [catch {expr $compress(quant_ht) + $compress(quant_wd)} ] {
			CvipAlert "Numerical values required for the width and height:\n\
			Width = $compress(quant_wd), Height = $compress(quant_ht)."
			$topwin(compress_name) configure -cursor top_left_arrow; update
			return
		}
		if {$compress(quant_ht) > $rows || $compress(quant_ht) < 1} { 
			CvipAlert "The new height ($compress(quant_ht)) must be in the range \[1, $rows\]."
			$topwin(compress_name) configure -cursor top_left_arrow; update
			return
		}
		if [ catch { set result [cvip $compress(preproc) $current_image $compress(quant_method) $compress(quant_ht) \
					$compress(quant_wd)] } cresult ] {
			CvipAlert "$cresult."
			$topwin(compress_name) configure -cursor top_left_arrow; update
			return
		}
		$topwin(compress_name) configure -cursor top_left_arrow; update
		set new_name [cvip rename $result ${current_image}_$compress(quant_ht)x$compress(quant_wd)]
		img_q insert end $new_name
		image_post $new_name
		cvip view $new_name
		CvipMessage "spatial quantization performed on image \"$current_image\""
	}



$topwin(compress_name) configure -cursor top_left_arrow; update

}} \
    -text {PERFORM}

  # pack widget $topwin(compress_name).perform
  pack append $topwin(compress_name).perform \
    $topwin(compress_name).perform.button2 {left frame center} \
    $topwin(compress_name).perform.button3 {right frame center}

  # pack widget $topwin(compress_name)
  pack append $topwin(compress_name) \
    $topwin(compress_name).info {top frame center expand fill} \
    $topwin(compress_name).current_image {top frame center fillx} \
    $topwin(compress_name).perform {bottom frame center fillx}

}

