#***************************************************************************
# **********************************************************************
# Computer Vision/Image Processing Tool Project - Dr. Scott Umbaugh SIUE
# **********************************************************************
#
#             File Name: compression.tcl
#           Description: Compression module for graphical user interface
#         Related Files: 
#   Initial Coding Date: Mon Jul  8 16:28:27 CDT 1996
#           Portability: TCL script file
#            References:
#             Author(s): Yansheng Wei, Mark Zuke
#                        Southern Illinois University @ Edwardsville
#
## Copyright (C) 1996 SIUE - by Scott Umbaugh, Yansheng Wei, and Mark Zuke.
##
## Permission to use, copy, modify, and distribute this software and its
## documentation for any purpose and without fee is hereby granted, provided
## that the above copyright notice appear in all copies and that both that
## copyright notice and this permission notice appear in supporting
## documentation.  This software is provided "as is" without express or
## implied warranty.
##
# RCS (Revision Control System) Information
# ...Added automatically by RCS 
#
## $Log: compression.tcl,v $
## Revision 1.12  1997/07/07 20:38:19  yawei
## Gui configuration in place
##
## Revision 1.11  1997/03/11 20:55:52  yawei
## Tcl/Tk script upgrading from tcl7.3/tk3.6 to tcl7.6/tk4.2
## compatible. This process is automated with tkboost perl
## script. @ Tue Mar 11 14:51:36 CST 1997
##
## Revision 1.10  1996/11/18 13:41:38  mzuke
## corrected call of help screen
##
# Revision 1.9  1996/10/03  03:22:49  yawei
# Added Compress/Pressing
#
# Revision 1.8  1996/09/27  16:28:08  mzuke
# removed 'save options' from menubar
#
# Revision 1.7  1996/09/22  18:35:42  yawei
# changed default size of the Compression windows
#
# Revision 1.6  1996/09/18  22:54:31  yawei
# regular check in
#
# Revision 1.5  1996/09/16  21:10:52  mzuke
# changed relief of menubar buttons to flat
#
# Revision 1.4  1996/09/16  21:00:11  mzuke
# added menu buttons to toplevel
#
# Revision 1.3  1996/09/09  15:43:39  mzuke
# modified code to conform to new style of window call
#
# Revision 1.2  1996/09/04  20:05:30  mzuke
# added icon name {COMPRESS} to toplevel
#
# Revision 1.1  1996/07/08  22:09:15  mzuke
# Initial revision
#
#
#****************************************************************************
# Module: compression.tcl
# Tcl version: 7.3 (Tcl/Tk/XF)
# Tk version: 3.6
# XF version: 2.3
#

# Procedure: compression
proc compression {} {
# xf ignore me 7
##########
# Procedure: compression
# Author: Mark Zuke (mzuke@ee.siue.edu) May 16, 1996
# Description: calls toplevel screen to allow use of compression functions
#             
# Arguments: none
# Returns: none
# Sideeffects: none
##########
 


  # build widget $topwin(compress_name)
#  if {"[info procs XFEdit]" != ""} {
#    catch "XFDestroy $topwin(compress_name)"
#  } {
#    catch "destroy $topwin(compress_name)"
#  }
#  toplevel $topwin(compress_name)   -background {gray90}

 global toplevel_position
 global message
 global topwin
 global GuiColor

  # Window manager configurations
  global tk_version
  wm positionfrom $topwin(compress_name) user
  wm sizefrom $topwin(compress_name) user

  wm geometry $topwin(compress_name) [top_pos $topwin(compress_top)]
  wm maxsize $topwin(compress_name) [lindex [split $topwin(compress_top_max)] 0] \
  	[lindex [split $topwin(compress_top_max)] 1]
  wm minsize $topwin(compress_name) [lindex [split $topwin(compress_top_min)] 0] \
  	[lindex [split $topwin(compress_top_min)] 1]
  wm title $topwin(compress_name) {COMPRESSION}
  wm iconname $topwin(compress_name) {COMPRESS}

  # build widget $topwin(compress_name).perform
  frame $topwin(compress_name).perform  -background "$GuiColor(frame_bg)"  -borderwidth {2} -relief {flat} 

  # build widget $topwin(compress_name).perform.dismiss
	button $topwin(compress_name).perform.dismiss -padx {1} -pady {1} -highlightthickness {0}  \
	-activebackground "$GuiColor(dis_act_bg)" \
	-background "$GuiColor(dis_bg)" \
	-foreground "$GuiColor(dis_fg)" \
	-command {destroy $topwin(compress_name)}  -text {DISMISS}  -width {10}

  # pack widget $topwin(compress_name).perform
  pack append $topwin(compress_name).perform  $topwin(compress_name).perform.dismiss {left frame sw expand}

  # build widget $topwin(compress_name).info
  frame $topwin(compress_name).info  -background "$GuiColor(frame_bg)"  -borderwidth {2}  -width {30} -height {0}  -relief {flat}

  # build widget $topwin(compress_name).menubar
  frame $topwin(compress_name).menubar  -background "$GuiColor(frame_bg)"  -borderwidth {2}  -relief {raised}

  # build widget $topwin(compress_name).menubar.lossless
	button $topwin(compress_name).menubar.lossless -padx {1} -pady {1} -highlightthickness {0}   \
	-activebackground "$GuiColor(btn_act_bg)" \
	-background "$GuiColor(btn_bg)" \
  -command {cmprs_lossless}  \
  -relief {flat}  \
  -text {Lossless}

  # build widget $topwin(compress_name).menubar.lossy
	button $topwin(compress_name).menubar.lossy -padx {1} -pady {1} -highlightthickness {0}   \
	-activebackground "$GuiColor(btn_act_bg)" \
	-background "$GuiColor(btn_bg)" \
  -command {cmprs_lossy}  \
  -relief {flat}  \
  -text {Lossy}

  # build widget $topwin(compress_name).menubar.preprocess
	button $topwin(compress_name).menubar.preprocess -padx {1} -pady {1} -highlightthickness {0}   \
	-activebackground "$GuiColor(btn_act_bg)" \
	-background "$GuiColor(btn_bg)" \
  -command {cmprs_prep} \
  -relief {flat}  \
  -text {Preprocessing}

 
  # build widget $topwin(compress_name).menubar.help
	button $topwin(compress_name).menubar.help -padx {1} -pady {1} -highlightthickness {0}\
	-activebackground "$GuiColor(alert_act_bg)" \
	-background "$GuiColor(alert_bg)" \
	-foreground "$GuiColor(alert_fg)" \
	-relief {flat} -command {help_screen} -text {Help} 
  # pack widget $topwin(compress_name).menubar
  pack append $topwin(compress_name).menubar  $topwin(compress_name).menubar.preprocess {left frame center expand} $topwin(compress_name).menubar.lossless {left frame center expand}  $topwin(compress_name).menubar.lossy {left frame center expand}   $topwin(compress_name).menubar.help {left frame center expand}

  # pack widget $topwin(compress_name)
  pack append $topwin(compress_name)  $topwin(compress_name).menubar {top frame center fillx}  $topwin(compress_name).info {top frame center expand fill}  $topwin(compress_name).perform {bottom frame center fillx} 

  if {"[info procs XFEdit]" != ""} {
    catch "XFMiscBindWidgetTree $topwin(compress_name)"
    after 2 "catch {XFEditSetShowWindows}"
  }
}

