# **********************************************************************
# Computer Vision/Image Processing Tool Project - Dr. Scott Umbaugh SIUE
# **********************************************************************
#
#             File Name: CVIPhelp.tcl
#           Description: 
#         Related Files: 
#   Initial Coding Date: Thu Dec  5 14:02:15 CST 1996
#           Portability: TCL script file
#            References:
#             Author(s): Mark Zuke
#                        Southern Illinois University @ Edwardsville
#
## Copyright (C) 1996 SIUE - by Scott Umbaugh and Mark Zuke.
##
## Permission to use, copy, modify, and distribute this software and its
## documentation for any purpose and without fee is hereby granted, provided
## that the above copyright notice appear in all copies and that both that
## copyright notice and this permission notice appear in supporting
## documentation.  This software is provided "as is" without express or
## implied warranty.
##
# RCS (Revision Control System) Information
# ...Added automatically by RCS 
#
## $Log: CVIPhelp.tcl,v $
## Revision 1.10  1997/08/06 18:07:34  yawei
## added Preferences
##
## Revision 1.9  1997/08/06 00:15:51  yawei
## checked in for sumbaug
##
## Revision 1.8  1997/07/17 23:36:59  yawei
## added globals
##
## Revision 1.7  1997/07/17 23:32:40  yawei
## Configuration finished
##
## Revision 1.6  1997/05/13 22:11:36  sumbaug
## check back for freezing
##
## Revision 1.5  1997/04/24 22:39:09  yawei
## removed word wrap
##
## Revision 1.4  1997/04/11 15:14:56  mzuke
## added initial help screen text
##
## Revision 1.3  1997/03/12 17:31:12  yawei
## Changed size, wrapping, and added horizontal scrollbar.
##
## Revision 1.2  1997/03/11 20:54:59  yawei
## Tcl/Tk script upgrading from tcl7.3/tk3.6 to tcl7.6/tk4.2
## compatible. This process is automated with tkboost perl
## script. @ Tue Mar 11 14:51:36 CST 1997
##
## Revision 1.1  1996/12/05 20:02:44  yawei
## Initial revision
##
#
#****************************************************************************
proc help_screen {} {
##########
# Procedure: help_screen
# Author: Mark Zuke (mzuke@ee.siue.edu) April 23, 1996
# Description: displays toplevel help screen 
#              
# Arguments: none
# Returns: none
# Sideeffects: none 
##########

global toplevel_position
global env
global GuiColor
global GuiMisc
 
  # build widget .help
  if {"[info procs XFEdit]" != ""} {
    catch "XFDestroy .help"
  } {
    catch "destroy .help"
  }
  toplevel .help  \
    -background {white}

  # Window manager configurations
  global tk_version
  wm positionfrom .help user
  wm sizefrom .help user
  wm geometry .help [top_pos 650x300]
  wm maxsize .help 800 800
  wm minsize .help 400 200
  wm title .help {CVIPtools HELP}
  wm iconname .help {CVIPHELP}


  # build widget .help.frame1
  frame .help.frame1 \
    -background "$GuiColor(frame_bg)" \
    -relief {raised} \
    -borderwidth {2} \
    -width {8}

  # build widget .help.frame1.menubutton8
	menubutton .help.frame1.menubutton8 -padx {1} -pady {1} -highlightthickness {0}  \
    -background "$GuiColor(btn_bg)" \
	 -activebackground "$GuiColor(btn_act_bg)" \
    -menu ".help.frame1.menubutton8.menu" \
    -text {Analysis} \
    -width {9}

  # build widget .help.frame1.menubutton8.menu
  menu .help.frame1.menubutton8.menu \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)"
  .help.frame1.menubutton8.menu add command \
	 -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {catch {source $env(CVIPHOME)/man/tcl_help/cvip_ana_geometry.hlp} cresult} \
    -label {Geometry}
  .help.frame1.menubutton8.menu add command \
	 -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {catch {source $env(CVIPHOME)/man/tcl_help/cvip_ana_edgeline.hlp} cresult} \
    -label {Edge/Line detection}
  .help.frame1.menubutton8.menu add command \
	 -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {catch {source $env(CVIPHOME)/man/tcl_help/cvip_segmentation.hlp} cresult} \
    -label {Segmentation}
  .help.frame1.menubutton8.menu add command \
	 -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {catch {source $env(CVIPHOME)/man/tcl_help/cvip_transform.hlp} cresult} \
    -label {Transforms}
  .help.frame1.menubutton8.menu add command \
	 -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {catch {source $env(CVIPHOME)/man/tcl_help/cvip_feature.hlp} cresult} \
    -label {Features}

  # build widget .help.frame1.menubutton9
	menubutton .help.frame1.menubutton9 -padx {1} -pady {1} -highlightthickness {0}  \
    -background "$GuiColor(btn_bg)" \
	 -activebackground "$GuiColor(btn_act_bg)" \
    -menu ".help.frame1.menubutton9.menu" \
    -text {Restoration} \
    -width {11}

  # build widget .help.frame1.menubutton9.menu
  menu .help.frame1.menubutton9.menu \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)"
  .help.frame1.menubutton9.menu add command \
	 -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {catch {source $env(CVIPHOME)/man/tcl_help/cvip_restore_noise.hlp} cresult} \
    -label {Noise}
  .help.frame1.menubutton9.menu add command \
	 -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {catch {source $env(CVIPHOME)/man/tcl_help/cvip_restore_spatfilter.hlp} cresult} \
    -label {Spatial filters}
  .help.frame1.menubutton9.menu add command \
	 -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {catch {source $env(CVIPHOME)/man/tcl_help/cvip_restore_freqfilter.hlp} cresult} \
    -label {Frequency filters}
  .help.frame1.menubutton9.menu add command \
	 -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {catch {source $env(CVIPHOME)/man/tcl_help/cvip_restore_geomtransform.hlp} cresult} \
    -label {Geometric transforms}

  # build widget .help.frame1.menubutton10
	menubutton .help.frame1.menubutton10 -padx {1} -pady {1} -highlightthickness {0}  \
    -background "$GuiColor(btn_bg)" \
	 -activebackground "$GuiColor(btn_act_bg)" \
    -menu ".help.frame1.menubutton10.menu" \
    -text {Enhancement} \
    -width {12}

  # build widget .help.frame1.menubutton10.menu
  menu .help.frame1.menubutton10.menu \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)"
  .help.frame1.menubutton10.menu add command \
    -command {catch {source $env(CVIPHOME)/man/tcl_help/cvip_histograms.hlp} cresult} \
    -label {Histograms}
  .help.frame1.menubutton10.menu add command \
    -command {catch {source $env(CVIPHOME)/man/tcl_help/cvip_enhan_pseudo.hlp} cresult} \
	 -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
   -label {Pseudocolor}
  .help.frame1.menubutton10.menu add command \
    -command {catch {source $env(CVIPHOME)/man/tcl_help/cvip_enhan_sharp.hlp} cresult} \
	 -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -label {Sharpening}
  .help.frame1.menubutton10.menu add command \
    -command {catch {source $env(CVIPHOME)/man/tcl_help/cvip_enhan_smooth.hlp} cresult} \
	 -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -label {Smoothing}

  # build widget .help.frame1.menubutton11
	menubutton .help.frame1.menubutton11 -padx {1} -pady {1} -highlightthickness {0}  \
    -background "$GuiColor(btn_bg)" \
	 -activebackground "$GuiColor(btn_act_bg)" \
    -menu ".help.frame1.menubutton11.menu" \
    -text {Compression} \
    -width {11}

  # build widget .help.frame1.menubutton11.menu
  menu .help.frame1.menubutton11.menu \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)"
  .help.frame1.menubutton11.menu add command \
	 -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {catch {source $env(CVIPHOME)/man/tcl_help/cvip_cmprs_prep.hlp} cresult} \
    -label {Preprocessing}
  .help.frame1.menubutton11.menu add command \
	 -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {catch {source $env(CVIPHOME)/man/tcl_help/cvip_cmprs_lossless.hlp} cresult} \
   -label {Lossless}
  .help.frame1.menubutton11.menu add command \
	 -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {catch {source $env(CVIPHOME)/man/tcl_help/cvip_cmprs_lossy.hlp} cresult} \
    -label {Lossy}

  # build widget .help.frame1.menubutton12
	menubutton .help.frame1.menubutton12 -padx {1} -pady {1} -highlightthickness {0}  \
    -background "$GuiColor(btn_bg)" \
	 -activebackground "$GuiColor(btn_act_bg)" \
    -menu ".help.frame1.menubutton12.menu" \
    -text {Utilities} \
    -width {8}

  # build widget .help.frame1.menubutton12.menu
  menu .help.frame1.menubutton12.menu \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)"
  .help.frame1.menubutton12.menu add command \
	 -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {catch {source $env(CVIPHOME)/man/tcl_help/cvip_utilarithlogic.hlp} cresult} \
    -label {ArithLogic}
  .help.frame1.menubutton12.menu add command \
	 -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {catch {source $env(CVIPHOME)/man/tcl_help/cvip_utilconvert.hlp} cresult} \
    -label {Convert}
  .help.frame1.menubutton12.menu add command \
	 -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {catch {source $env(CVIPHOME)/man/tcl_help/cvip_utilcreate.hlp} cresult} \
    -label {Create}
  .help.frame1.menubutton12.menu add command \
	 -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {catch {source $env(CVIPHOME)/man/tcl_help/cvip_utilenhance.hlp} cresult} \
    -label {Enhance}
  .help.frame1.menubutton12.menu add command \
	 -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {catch {source $env(CVIPHOME)/man/tcl_help/cvip_utilfilter.hlp} cresult} \
    -label {Filter}
  .help.frame1.menubutton12.menu add command \
	 -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {catch {source $env(CVIPHOME)/man/tcl_help/cvip_utilsize.hlp} cresult} \
    -label {Size}
  .help.frame1.menubutton12.menu add command \
	 -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {catch {source $env(CVIPHOME)/man/tcl_help/cvip_utilmisc.hlp} cresult} \
    -label {Misc}



  # build widget .help.frame1.menubutton13
	menubutton .help.frame1.menubutton13 -padx {1} -pady {1} -highlightthickness {0}  \
    -background "$GuiColor(btn_bg)" \
	 -activebackground "$GuiColor(btn_act_bg)" \
    -menu ".help.frame1.menubutton13.menu" \
    -text {Getting Started} \
    -width {13}

  # build widget .help.frame1.menubutton13.menu
  menu .help.frame1.menubutton13.menu \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)"
  .help.frame1.menubutton13.menu add command \
	 -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {catch {source $env(CVIPHOME)/man/tcl_help/cvip_start.hlp} cresult} \
    -label {How to use this program}
  .help.frame1.menubutton13.menu add command \
	 -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {catch {source $env(CVIPHOME)/man/tcl_help/cvip_copyright.hlp} cresult} \
    -label {Copyright information}
  .help.frame1.menubutton13.menu add command \
	 -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {catch {source $env(CVIPHOME)/man/tcl_help/cvip_contributors.hlp} cresult} \
    -label {About CVIPtools}
#  .help.frame1.menubutton13.menu add command \
#	 -activebackground "$GuiColor(menu_act_bg)" \
#	 -background "$GuiColor(menu_bg)" \
#    -command {set alertBox(background) white
#set alertBox(activeBackground) gray70
#set alertBox(justify) {center}
#set alertBox(after) 20
#set box [AlertBox "
#Graphical User Interface
#for
#CVIPtools
#
#Designed
#by
#Scott Umbaugh, Ph.D.
#and
#Mark Zuke
#
#Implemented 
#by
#Yansheng Wei and Mark Zuke"  ""  225x275  "About the program"]} \
#    -label {About this program}
#

  # build widget .help.frame1.menubutton14
	menubutton .help.frame1.menubutton14 -padx {1} -pady {1} -highlightthickness {0}  \
    -background "$GuiColor(btn_bg)" \
	 -activebackground "$GuiColor(btn_act_bg)" \
    -menu ".help.frame1.menubutton14.menu" \
    -text {File} \
    -width {6}

  # build widget .help.frame1.menubutton14.menu
  menu .help.frame1.menubutton14.menu \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)"
  .help.frame1.menubutton14.menu add command \
	 -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {catch {source $env(CVIPHOME)/man/tcl_help/cvip_load_image.hlp} cresult} \
    -label {Loading an image}
  .help.frame1.menubutton14.menu add command \
	 -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {catch {source $env(CVIPHOME)/man/tcl_help/cvip_view.hlp} cresult} \
    -label {Viewing an image}
  .help.frame1.menubutton14.menu add command \
	 -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {catch {source $env(CVIPHOME)/man/tcl_help/cvip_delete_one.hlp} cresult} \
    -label {Deleting an image}
  .help.frame1.menubutton14.menu add command \
	 -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {catch {source $env(CVIPHOME)/man/tcl_help/cvip_delete_all.hlp} cresult} \
    -label {Deleting all images}
  .help.frame1.menubutton14.menu add command \
	 -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {catch {source $env(CVIPHOME)/man/tcl_help/cvip_save.hlp} cresult} \
    -label {Saving an image}
  .help.frame1.menubutton14.menu add command \
	 -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {catch {source $env(CVIPHOME)/man/tcl_help/cvip_preference.hlp} cresult} \
    -label {Preferences}
  .help.frame1.menubutton14.menu add command \
	 -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {catch {source $env(CVIPHOME)/man/tcl_help/cvip_add_path.hlp} cresult} \
    -label {Adding a temporary image path}
  .help.frame1.menubutton14.menu add command \
	 -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {catch {source $env(CVIPHOME)/man/tcl_help/cvip_exit.hlp} cresult} \
    -label {Exiting the program}



   # pack widget .help.frame1
     pack append .help.frame1 \
    .help.frame1.menubutton14 {left frame center expand fillx} \
    .help.frame1.menubutton8 {left frame center expand fillx} \
    .help.frame1.menubutton9 {left frame center expand fillx} \
    .help.frame1.menubutton10 {left frame center expand fillx} \
    .help.frame1.menubutton11 {left frame center expand fillx} \
    .help.frame1.menubutton12 {left frame center expand fillx} \
    .help.frame1.menubutton13 {left frame center expand fillx}


  # build widget .help.frame2
  frame .help.frame2 \
    -background "$GuiColor(frame_bg)" \
    -borderwidth {2}

  # build widget .help.frame2.frame
  frame .help.frame2.frame \
    -background "$GuiColor(frame_bg)" \
    -relief {raised}

  # build widget .help.frame2.frame.scrollbar1
  scrollbar .help.frame2.frame.scrollbar1 \
    -background "$GuiColor(btn_bg)" \
	 -activebackground "$GuiColor(btn_act_bg)" \
    -command {.help.frame2.frame.text2 yview} \
    -background {gray80} \
    -relief {raised}

  # build widget .help.frame2.frame.scrollbar1
  scrollbar .help.frame2.frame.scrollbar2 \
    -background "$GuiColor(btn_bg)" \
	 -activebackground "$GuiColor(btn_act_bg)" \
    -command {.help.frame2.frame.text2 xview} \
	 -orient {horizontal} \
    -relief {raised}

  # build widget .help.frame2.frame.text2
  text .help.frame2.frame.text2 \
    -background {white} \
    -font {*-Courier-Bold-R-Normal-*-140-*} \
    -height {50} \
    -wrap {none} \
    -yscrollcommand {.help.frame2.frame.scrollbar1 set} \
    -xscrollcommand {.help.frame2.frame.scrollbar2 set}

  # bindings
  bind .help.frame2.frame.text2 <Any-Key> {NoFunction}

  # pack widget .help.frame2.frame
  pack append .help.frame2.frame \
    .help.frame2.frame.scrollbar1 {left frame center filly} \
    .help.frame2.frame.scrollbar2 {bottom frame center expand fillx} \
    .help.frame2.frame.text2 {top frame center expand fill}

  # pack widget .help.frame2
  pack append .help.frame2 \
    .help.frame2.frame {top frame center expand fill}

  # build widget .help.frame3
  frame .help.frame3 \
    -background "$GuiColor(frame_bg)" \
    -borderwidth {2} \
    -relief {raised}

  # build widget .help.frame3.dismiss
	button .help.frame3.dismiss -padx {1} -pady {1} -highlightthickness {0}  \
    -foreground "$GuiColor(dis_fg)" \
    -background "$GuiColor(dis_bg)" \
	 -activebackground "$GuiColor(dis_act_bg)" \
    -command {destroy .help} \
    -text {DISMISS}

  # build widget .help.frame3.button0
	button .help.frame3.button0 -padx {1} -pady {1} -highlightthickness {0}  \
    -foreground "$GuiColor(alert_fg)" \
    -background "$GuiColor(alert_bg)" \
	 -activebackground "$GuiColor(alert_act_bg)" \
    -command {help_message delete 1.0 end} \
    -text {CLEAR HELP SCREEN}

  # pack widget .help.frame3
  pack append .help.frame3 \
    .help.frame3.dismiss {left frame w} \
    .help.frame3.button0 {left frame center expand}

  # pack widget .help
  pack append .help \
    .help.frame1 {top frame center fillx} \
    .help.frame3 {bottom frame center fillx} \
    .help.frame2 {top frame center expand fill} 

  .help.frame2.frame.text2 insert end {}


  if {"[info procs XFEdit]" != ""} {
    catch "XFMiscBindWidgetTree .help"
    after 2 "catch {XFEditSetShowWindows}"
  }
source $env(CVIPHOME)/man/tcl_help/cvip_help.hlp
}
