# **********************************************************************
# Computer Vision/Image Processing Tool Project - Dr. Scott Umbaugh SIUE
# **********************************************************************
#
#             File Name: CVIPSizeWin32.tcl
#           Description: Windows size configuration for Microsoft
#                        Windows 95/ NT4.0
#         Related Files: None
#   Initial Coding Date: Mon Jul 21 12:29:06 CDT 1997
#           Portability: TCL script file
#            References:
#             Author(s): Yansheng Wei
#                        Southern Illinois University @ Edwardsville
#
## Copyright (C) 1996 SIUE - by Scott Umbaugh and Yansheng Wei.
##
## Permission to use, copy, modify, and distribute this software and its
## documentation for any purpose and without fee is hereby granted, provided
## that the above copyright notice appear in all copies and that both that
## copyright notice and this permission notice appear in supporting
## documentation.  This software is provided "as is" without express or
## implied warranty.
##
# RCS (Revision Control System) Information
# ...Added automatically by RCS 
#
## $Log: CVIPSizeWin32.tcl,v $
## Revision 1.3  1997/08/08 17:29:51  yawei
##  moved help window size to WM files
##
## Revision 1.2  1997/08/07 22:25:50  smakam
## made the configuration of Windows
##
## Revision 1.1  1997/07/31 20:05:17  yawei
## Initial revision
##
## Revision 1.1  1997/07/21 17:59:45  yawei
## Initial revision
##
#
#****************************************************************************

proc CvipSizeWin32 { } {

###########################################################
# size scheme configuration goes here
###########################################################
  global {topwin}

  #down size percent for min/width
  set {topwin(width_down)}                          {0.40} 
  #down size percent for min/height
  set {topwin(height_down)}                         {0.40} 
  #up size percent for max/width
  set {topwin(width_up)}                            {0.20} 
  #up size percent for max/height
  set {topwin(height_up)}                           {0.20} 

# the main window
  set {topwin(main_name)}                           {NONE}
  set {topwin(main_geom)}                           {625x420}
  set {topwin(main_max)}  \
      [get_size_limit $topwin(main_geom) max]
  set {topwin(main_min)}  \
      [get_size_limit $topwin(main_geom) min]

###########################################################
# Three different sizes for the help windows
###########################################################
  set {help_msg} {}
  global {help_short}
  set {help_short}                 {650x304}
  global {help_medium}
  set {help_medium}                {650x512}
  global {help_long}
  set {help_long}                  {650x709}

# the preference window
  set {topwin(preference)}                           {390x240}
  set {topwin(preference_max)}  \
      [get_size_limit $topwin(preference) max]
  set {topwin(preference_min)}  \
      [get_size_limit $topwin(preference) min]

# analysis windows size goes here
  set {topwin(analysis_name)}                       {NONE}
  set {topwin(analysis_top)}                        {600x100}
  set {topwin(analysis_top_max)}  \
      [get_size_limit $topwin(analysis_top) max]
  set {topwin(analysis_top_min)}  \
      [get_size_limit $topwin(analysis_top) min]

  set {topwin(analysis_geometry)}     {640x530}  
  set {topwin(analysis_geometry_max)}  \
      [get_size_limit $topwin(analysis_geometry) max]
  set {topwin(analysis_geometry_min)}  \
      [get_size_limit $topwin(analysis_geometry) min]

  set {topwin(analysis_edge)}                       {717x490}
  set {topwin(analysis_edge_max)}  \
      [get_size_limit $topwin(analysis_edge) max]
  set {topwin(analysis_edge_min)}  \
      [get_size_limit $topwin(analysis_edge) min]

  set {topwin(analysis_segment)}                    {623x654}
  set {topwin(analysis_segment_max)}  \
      [get_size_limit $topwin(analysis_segment) max]
  set {topwin(analysis_segment_min)}  \
      [get_size_limit $topwin(analysis_segment) min]

  set {topwin(analysis_transform)}                  {614x473}
  set {topwin(analysis_transform_max)}  \
      [get_size_limit $topwin(analysis_transform) max]
  set {topwin(analysis_transform_min)}  \
      [get_size_limit $topwin(analysis_transform) min]
  
  set {topwin(analysis_feature)}                    {600x695}
  set {topwin(analysis_feature_max)}  \
      [get_size_limit $topwin(analysis_feature) max]
  set {topwin(analysis_feature_min)}  \
      [get_size_limit $topwin(analysis_feature) min]

# restoration windows size goes here

  set {topwin(restore_name)}                        {NONE}
  set {topwin(restore_top)}                         {500x100}
  set {topwin(restore_top_max)}  \
      [get_size_limit $topwin(restore_top) max]
  set {topwin(restore_top_min)}  \
      [get_size_limit $topwin(restore_top) min]

  set {topwin(restore_noise)}                       {550x250}
  set {topwin(restore_noise_max)}  \
      [get_size_limit $topwin(restore_noise) max]
  set {topwin(restore_noise_min)}  \
      [get_size_limit $topwin(restore_noise) min]

  set {topwin(restore_spatial)}                     {512x510}
  set {topwin(restore_spatial_max)}  \
      [get_size_limit $topwin(restore_spatial) max]
  set {topwin(restore_spatial_min)}  \
      [get_size_limit $topwin(restore_spatial) min]

  set {topwin(restore_freqency)}                    {706x630}
  set {topwin(restore_freqency_max)}  \
      [get_size_limit $topwin(restore_freqency) max]
  set {topwin(restore_freqency_min)}  \
      [get_size_limit $topwin(restore_freqency) min]

  set {topwin(restore_geometry)}                    {630x425}
  set {topwin(restore_geometry_max)}  \
      [get_size_limit $topwin(restore_geometry) max]
  set {topwin(restore_geometry_min)}  \
      [get_size_limit $topwin(restore_geometry) min]

# enhancement windows size goes here
  set {topwin(enhan_name)}                          {NONE}
  set {topwin(enhan_top)}                           {550x100}
  set {topwin(enhan_top_max)}  \
      [get_size_limit $topwin(enhan_top) max]
  set {topwin(enhan_top_min)}  \
      [get_size_limit $topwin(enhan_top) min]

  set {topwin(enhan_histogram)}                     {560x626}
  set {topwin(enhan_histogram_max)}  \
      [get_size_limit $topwin(enhan_histogram) max]
  set {topwin(enhan_histogram_min)}  \
      [get_size_limit $topwin(enhan_histogram) min]

  set {topwin(enhan_pseudocolor)}                   {560x440}
  set {topwin(enhan_pseudocolor_max)}  \
      [get_size_limit $topwin(enhan_pseudocolor) max]
  set {topwin(enhan_pseudocolor_min)}  \
      [get_size_limit $topwin(enhan_pseudocolor) min]

  set {topwin(enhan_sharp)}                         {576x630}
  set {topwin(enhan_sharp_max)}  \
      [get_size_limit $topwin(enhan_sharp) max]
  set {topwin(enhan_sharp_min)}  \
      [get_size_limit $topwin(enhan_sharp) min]

  set {topwin(enhan_smooth)}                        {500x468}
  set {topwin(enhan_smooth_max)}  \
      [get_size_limit $topwin(enhan_smooth) max]
  set {topwin(enhan_smooth_min)}  \
      [get_size_limit $topwin(enhan_smooth) min]

# compression windows size goes here
  set {topwin(compress_name)}                       {NONE}
  set {topwin(compress_top)}                        {500x100}
  set {topwin(compress_top_max)}  \
      [get_size_limit $topwin(compress_top) max]
  set {topwin(compress_top_min)}  \
      [get_size_limit $topwin(compress_top) min]

  set {topwin(compress_prep)}                       {588x240}
  set {topwin(compress_prep_max)}  \
      [get_size_limit $topwin(compress_prep) max]
  set {topwin(compress_prep_min)}  \
      [get_size_limit $topwin(compress_prep) min]

  set {topwin(compress_lossless)}                   {550x240}
  set {topwin(compress_lossless_max)}  \
      [get_size_limit $topwin(compress_lossless) max]
  set {topwin(compress_lossless_min)}  \
      [get_size_limit $topwin(compress_lossless) min]

  set {topwin(compress_lossy)}                      {560x400}
  set {topwin(compress_lossy_max)}  \
      [get_size_limit $topwin(compress_lossy) max]
  set {topwin(compress_lossy_min)}  \
      [get_size_limit $topwin(compress_lossy) min]

# Utilities windows size goes here
  set {topwin(util_name)}                           {NONE}
  set {topwin(util_top)}                            {500x180}
  set {topwin(util_top_max)}  \
      [get_size_limit $topwin(util_top) max]
  set {topwin(util_top_min)}  \
      [get_size_limit $topwin(util_top) min]

  set {topwin(util_noise)}                          {500x250}
  set {topwin(util_noise_max)}  \
      [get_size_limit $topwin(util_noise) max]
  set {topwin(util_noise_min)}  \
      [get_size_limit $topwin(util_noise) min]

}
