#***************************************************************************
# **********************************************************************
# Computer Vision/Image Processing Tool Project - Dr. Scott Umbaugh SIUE
# **********************************************************************
#
#             File Name: enhancement.tcl
#           Description: Enhancement module for graphical user interface
#         Related Files: 
#   Initial Coding Date: Mon Jul  8 16:28:43 CDT 1996
#           Portability: TCL script file
#            References:
#             Author(s): Yansheng Wei, Mark Zuke
#                        Southern Illinois University @ Edwardsville
#
## Copyright (C) 1996 SIUE - by Scott Umbaugh, Yansheng Wei, and Mark Zuke.
##
## Permission to use, copy, modify, and distribute this software and its
## documentation for any purpose and without fee is hereby granted, provided
## that the above copyright notice appear in all copies and that both that
## copyright notice and this permission notice appear in supporting
## documentation.  This software is provided "as is" without express or
## implied warranty.
##
# RCS (Revision Control System) Information
# ...Added automatically by RCS 
#
## $Log: enhancement.tcl,v $
## Revision 1.9  1997/07/02 18:14:05  yawei
## gui configuration
##
## Revision 1.8  1997/03/11 20:56:16  yawei
## Tcl/Tk script upgrading from tcl7.3/tk3.6 to tcl7.6/tk4.2
## compatible. This process is automated with tkboost perl
## script. @ Tue Mar 11 14:51:36 CST 1997
##
## Revision 1.7  1996/10/23 20:05:25  mzuke
## added help_screen procedure call to the Help button
##
# Revision 1.6  1996/10/02  15:04:16  yawei
# changed the procedure name for sharpening
#
# Revision 1.5  1996/09/23  23:06:28  yawei
# added smooth module
#
# Revision 1.4  1996/09/20  13:07:34  mzuke
# changed menubar name 'Color' to 'Pseudocolor'
#
# Revision 1.3  1996/09/04  20:03:21  mzuke
# added icon name {ENHANCE} for toplevel
#
# Revision 1.2  1996/08/21  19:31:36  yawei
# modified according to the module structure.
#
# Revision 1.1  1996/07/08  22:09:44  mzuke
# Initial revision
#
#
#****************************************************************************
# Module: enhancement.tcl
# Tcl version: 7.3 (Tcl/Tk/XF)
# Tk version: 3.6
# XF version: 2.3
#

# module contents
global moduleList
global autoLoadList
set moduleList(enhancement.tcl) {enhancement}
set autoLoadList(enhancement.tcl) {1}

# procedures to show toplevel windows


# User defined procedures


# Procedure: enhancement
proc enhancement {} {

##########
# Procedure: enhancement
# Author: Mark Zuke (mzuke@ee.siue.edu) May 16, 1996
# Description: calls toplevel screen to allow use of enhancement functions
#             
# Arguments: none
# Returns: none
# Sideeffects: none
##########
 
global toplevel_position
global message
global topwin
global GuiColor
 
  # Window manager configurations
  global tk_version
  wm positionfrom $topwin(enhan_name) user
  wm sizefrom $topwin(enhan_name) user
  wm geometry $topwin(enhan_name) [top_pos $topwin(enhan_top)]
  wm maxsize $topwin(enhan_name) [lindex [split $topwin(enhan_top_max)] 0] \
  	[lindex [split $topwin(enhan_top_max)] 1]
  wm minsize $topwin(enhan_name) [lindex [split $topwin(enhan_top_min)] 0] \
  	[lindex [split $topwin(enhan_top_min)] 1]
  wm title $topwin(enhan_name) {ENHANCEMENT}
  wm iconname $topwin(enhan_name) {ENHANCE}


  # build widget $topwin(enhan_name).perform
  frame $topwin(enhan_name).perform  -background "$GuiColor(frame_bg)"  -borderwidth {2}  -relief {flat}

  # build widget $topwin(enhan_name).perform.perform
  frame $topwin(enhan_name).perform.perform  -background {GRAY90}  -borderwidth {2}

  # build widget $topwin(enhan_name).perform.perform.dismiss
	button $topwin(enhan_name).perform.perform.dismiss -padx {1} -pady {1} -highlightthickness {0} \
	-activebackground "$GuiColor(dis_act_bg)" \
	-background "$GuiColor(dis_bg)" \
	-foreground "$GuiColor(dis_fg)" \
	-command {destroy $topwin(enhan_name)}  -text {DISMISS}  -width {10}

  # pack widget $topwin(enhan_name).perform.perform
  pack append $topwin(enhan_name).perform.perform \
  $topwin(enhan_name).perform.perform.dismiss {left frame sw expand} 

  # pack widget $topwin(enhan_name).perform
  pack append $topwin(enhan_name).perform  $topwin(enhan_name).perform.perform {bottom frame center fillx}

  # build widget $topwin(enhan_name).info
  frame $topwin(enhan_name).info  -background "$GuiColor(frame_bg)"  -borderwidth {2}  -width {30} -height {0}  -relief {flat}

  # build widget $topwin(enhan_name).menubar
  frame $topwin(enhan_name).menubar  -background "$GuiColor(frame_bg)"  -borderwidth {2}  -relief {raised}

  # build widget $topwin(enhan_name).menubar.histograms
	button $topwin(enhan_name).menubar.histograms -padx {1} -pady {1} -highlightthickness {0}   \
	-activebackground "$GuiColor(btn_act_bg)" \
	-background "$GuiColor(btn_bg)" \
  -relief {flat} \
  -command {histogram}  \
  -text {Histograms}

  # build widget $topwin(enhan_name).menubar.color
	button $topwin(enhan_name).menubar.color -padx {1} -pady {1} -highlightthickness {0}   \
	-activebackground "$GuiColor(btn_act_bg)" \
	-background "$GuiColor(btn_bg)" \
  -relief {flat} \
  -command {enhan_color}  \
  -text {Pseudocolor}

  # build widget $topwin(enhan_name).menubar.sharpening
	button $topwin(enhan_name).menubar.sharpening -padx {1} -pady {1} -highlightthickness {0}   \
	-activebackground "$GuiColor(btn_act_bg)" \
	-background "$GuiColor(btn_bg)" \
  -relief {flat} \
  -command {enhan_sharp}  \
  -text {Sharpening}

  # build widget $topwin(enhan_name).menubar.smoothing
	button $topwin(enhan_name).menubar.smoothing -padx {1} -pady {1} -highlightthickness {0}   \
	-activebackground "$GuiColor(btn_act_bg)" \
	-background "$GuiColor(btn_bg)" \
  -relief {flat} \
  -command {enhan_smooth} \
  -text {Smoothing}

  # build widget $topwin(enhan_name).menubar.help
	button $topwin(enhan_name).menubar.help -padx {1} -pady {1} -highlightthickness {0}   \
	-activebackground "$GuiColor(alert_act_bg)" \
	-background "$GuiColor(alert_bg)" \
	-foreground "$GuiColor(alert_fg)" \
  -relief {flat} \
  -command {help_screen} \
  -text {Help}

  # pack widget $topwin(enhan_name).menubar
  pack append $topwin(enhan_name).menubar  \
  $topwin(enhan_name).menubar.histograms {left frame center expand}  \
  $topwin(enhan_name).menubar.color {left frame center expand}  \
  $topwin(enhan_name).menubar.sharpening {left frame center expand}  \
  $topwin(enhan_name).menubar.smoothing {left frame center expand} \
  $topwin(enhan_name).menubar.help {right frame center expand}
 
  # pack widget $topwin(enhan_name)
  pack append $topwin(enhan_name)  $topwin(enhan_name).menubar {top frame center fillx}  $topwin(enhan_name).info {top frame center expand fill}  $topwin(enhan_name).perform {bottom frame center fillx}


  if {"[info procs XFEdit]" != ""} {
    catch "XFMiscBindWidgetTree "
    after 2 "catch {XFEditSetShowWindows}"
  }
  return
}

