# **********************************************************************
# Computer Vision/Image Processing Tool Project - Dr. Scott Umbaugh SIUE
# **********************************************************************
#
#             File Name: enhan_color.tcl
#           Description: 
#         Related Files: 
#   Initial Coding Date: Fri Sep 27 08:17:53 CDT 1996
#           Portability: TCL script file
#            References:
#             Author(s): Yansheng Wei and Mark Zuke
#                        Southern Illinois University @ Edwardsville
#
## Copyright (C) 1996 SIUE - by Scott Umbaugh, Mark Zuke and Yansheng Wei.
##
## Permission to use, copy, modify, and distribute this software and its
## documentation for any purpose and without fee is hereby granted, provided
## that the above copyright notice appear in all copies and that both that
## copyright notice and this permission notice appear in supporting
## documentation.  This software is provided "as is" without express or
## implied warranty.
##
# RCS (Revision Control System) Information
# ...Added automatically by RCS 
#
## $Log: enhan_color.tcl,v $
## Revision 1.10  1997/07/03 21:37:44  yawei
## Gui configuration done
##
## Revision 1.9  1997/03/27 01:56:45  yawei
## GUI ==> CVIPTCL/GUI_SCRIPTS
##
## Revision 1.8  1997/03/12 00:59:17  yawei
## fixed arrow button bugs
##
## Revision 1.7  1997/03/11 20:55:57  yawei
## Tcl/Tk script upgrading from tcl7.3/tk3.6 to tcl7.6/tk4.2
## compatible. This process is automated with tkboost perl
## script. @ Tue Mar 11 14:51:36 CST 1997
##
## Revision 1.6  1996/11/18 13:39:21  yawei
## removed display of intermediate images
##
# Revision 1.5  1996/11/15  23:00:09  yawei
# Removed redundant print out.
# .,
#
# Revision 1.4  1996/11/15  22:54:32  yawei
# fixed intensity slicing bug
#
# Revision 1.3  1996/10/16  03:28:17  yawei
# general changed
#
# Revision 1.2  1996/09/27  23:22:42  yawei
# fixed problems
#
# Revision 1.1  1996/09/27  13:18:37  yawei
# Initial revision
#
#
#****************************************************************************
# procedure to show window .
proc enhan_color { } {# xf ignore me 7

  # Window manager configurations
  global tk_version
  global topwin
  global GuiColor
  global GuiMisc
  global GUI_DEBUG
  global toplevel_position
  global env

  if [ winfo exists  $topwin(enhan_name).info] {
     set tempname $topwin(enhan_name);\
destroy $topwin(enhan_name).info;\
set topwin(enhan_name) $tempname;}
  if [ winfo exists  $topwin(enhan_name).current_image] {
     set tempname $topwin(enhan_name);\
destroy $topwin(enhan_name).current_image;\
set topwin(enhan_name) $tempname;}
  if [ winfo exists  $topwin(enhan_name).perform] {
     set tempname $topwin(enhan_name);\
destroy $topwin(enhan_name).perform;\
set topwin(enhan_name) $tempname;}
  wm positionfrom  $topwin(enhan_name) user
  wm sizefrom  $topwin(enhan_name) user
  wm geometry $topwin(enhan_name) $topwin(enhan_pseudocolor)[get_pos $topwin(enhan_name)]
  wm maxsize $topwin(enhan_name) [lindex $topwin(enhan_pseudocolor_max) 0] \
  	[lindex $topwin(enhan_pseudocolor_max) 1]
  wm minsize $topwin(enhan_name) [lindex $topwin(enhan_pseudocolor_min) 0] \
  	[lindex $topwin(enhan_pseudocolor_min) 1]
  wm title $topwin(enhan_name) {ENHANCEMENT -> Pseudocolor}

  bind $topwin(enhan_name) <Destroy> {set topwin(enhan_name) NONE}

  # build widget $topwin(enhan_name).info
  frame $topwin(enhan_name).info \
    -background "$GuiColor(frame_bg)" \
    -borderwidth {0}

  # build widget $topwin(enhan_name).info.frame0
  frame $topwin(enhan_name).info.frame0 \
    -background "$GuiColor(frame_bg)" \
    -borderwidth {2} \
    -relief {ridge}

  # build widget $topwin(enhan_name).info.frame0.frame3
  frame $topwin(enhan_name).info.frame0.frame3 \
    -background "$GuiColor(frame_bg)" \
    -borderwidth {2}

  # build widget $topwin(enhan_name).info.frame0.frame3.radiobutton10
	radiobutton $topwin(enhan_name).info.frame0.frame3.radiobutton10 -padx {1} -pady {1} -highlightthickness {0}  \
    -activebackground "$GuiColor(btn_act_bg)"  \
    -background "$GuiColor(btn_bg)" \
    -relief {flat} \
    -text { Frequency domain mapping} \
    -value {pseudocol_freq} \
    -variable {enhan(g_c)}

  # pack widget $topwin(enhan_name).info.frame0.frame3
  pack append $topwin(enhan_name).info.frame0.frame3 \
    $topwin(enhan_name).info.frame0.frame3.radiobutton10 {top frame nw padx 23}

  # build widget $topwin(enhan_name).info.frame0.frame5
  frame $topwin(enhan_name).info.frame0.frame5 \
    -background "$GuiColor(frame_bg)"

  # build widget $topwin(enhan_name).info.frame0.frame5.frame0
  frame $topwin(enhan_name).info.frame0.frame5.frame0 \
    -background "$GuiColor(frame_bg)" \
    -relief {sunken}

  # build widget $topwin(enhan_name).info.frame0.frame5.frame0.label1
  label $topwin(enhan_name).info.frame0.frame5.frame0.label1 \
    -background "$GuiColor(label_bg)" \
    -borderwidth {0} \
    -text {Low cutoff frequency: }

  # build widget $topwin(enhan_name).info.frame0.frame5.frame0.value
  entry $topwin(enhan_name).info.frame0.frame5.frame0.value \
    -background "$GuiColor(entry_bg)" \
	 -foreground "$GuiColor(entry_fg)" \
    -relief {sunken} \
    -textvariable {enhan(pseudo_lcf)} \
    -width {5}
  endEntry $topwin(enhan_name).info.frame0.frame5.frame0.value 0 \
  	 $topwin(enhan_name).info.frame0.frame5.frame6.value \
  	 $topwin(enhan_name).info.frame0.frame5.frame6.value 

  # build widget $topwin(enhan_name).info.frame0.frame5.frame0.menubutton2
	menubutton $topwin(enhan_name).info.frame0.frame5.frame0.menubutton2 -padx {1} -pady {1} -highlightthickness {0}  \
    -activebackground "$GuiColor(btn_act_bg)"  \
    -background "$GuiColor(btn_bg)" \
    -font "$GuiMisc(pop_up_fn)" \
	 -text "$GuiMisc(pop_up_text)" \
	 -relief "$GuiMisc(pop_up_relief)" \
	 -width {2}
  # bindings
  bind $topwin(enhan_name).info.frame0.frame5.frame0.menubutton2 <Button-1> {MenuPopupPost $topwin(enhan_name).info.frame0.frame5.frame0.menubutton2.menu %X %Y}
  bind $topwin(enhan_name).info.frame0.frame5.frame0.menubutton2 <ButtonRelease-1> {MenuPopupRelease $topwin(enhan_name).info.frame0.frame5.frame0.menubutton2.menu %W}

  # build widget $topwin(enhan_name).info.frame0.frame5.frame0.menubutton2.menu
  menu $topwin(enhan_name).info.frame0.frame5.frame0.menubutton2.menu \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)"
  $topwin(enhan_name).info.frame0.frame5.frame0.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -command {set enhan(pseudo_lcf) 0} \
    -label {  0 }
  $topwin(enhan_name).info.frame0.frame5.frame0.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -command {set enhan(pseudo_lcf) 10} \
    -label { 10}
  $topwin(enhan_name).info.frame0.frame5.frame0.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -command {set enhan(pseudo_lcf) 30} \
    -label { 30}
  $topwin(enhan_name).info.frame0.frame5.frame0.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -command {set enhan(pseudo_lcf) 50} \
    -label { 50}
  $topwin(enhan_name).info.frame0.frame5.frame0.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -command {set enhan(pseudo_lcf) 100} \
    -label {100}
  $topwin(enhan_name).info.frame0.frame5.frame0.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -command {set enhan(pseudo_lcf) 200} \
    -label {200}
  $topwin(enhan_name).info.frame0.frame5.frame0.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -command {set enhan(pseudo_lcf) 500} \
    -label {500}
  bindtags $topwin(enhan_name).info.frame0.frame5.frame0.menubutton2.menu {Menu all}
  # bindings
  bind $topwin(enhan_name).info.frame0.frame5.frame0.menubutton2.menu <B1-Motion> {MenuPopupMotion $topwin(enhan_name).info.frame0.frame5.frame0.menubutton2.menu %W %X %Y}
  bind $topwin(enhan_name).info.frame0.frame5.frame0.menubutton2.menu <ButtonRelease-1> {MenuPopupRelease $topwin(enhan_name).info.frame0.frame5.frame0.menubutton2.menu %W}

  # pack widget $topwin(enhan_name).info.frame0.frame5.frame0
  pack append $topwin(enhan_name).info.frame0.frame5.frame0 \
    $topwin(enhan_name).info.frame0.frame5.frame0.label1 {left frame center fill} \
    $topwin(enhan_name).info.frame0.frame5.frame0.value {left frame center expand fill} \
    $topwin(enhan_name).info.frame0.frame5.frame0.menubutton2 {right frame center fill}

  # build widget $topwin(enhan_name).info.frame0.frame5.frame6
  frame $topwin(enhan_name).info.frame0.frame5.frame6 \
    -background "$GuiColor(frame_bg)" \
    -relief {sunken}

  # build widget $topwin(enhan_name).info.frame0.frame5.frame6.label1
  label $topwin(enhan_name).info.frame0.frame5.frame6.label1 \
    -background "$GuiColor(label_bg)" \
    -borderwidth {0} \
    -text {High cutoff frequency: }

  # build widget $topwin(enhan_name).info.frame0.frame5.frame6.value
  entry $topwin(enhan_name).info.frame0.frame5.frame6.value \
    -background "$GuiColor(entry_bg)" \
	 -foreground "$GuiColor(entry_fg)" \
    -relief {sunken} \
    -textvariable {enhan(pseudo_hcf)} \
    -width {5}
  endEntry $topwin(enhan_name).info.frame0.frame5.frame6.value 0\
  	 $topwin(enhan_name).info.frame0.frame5.frame0.value \
  	 $topwin(enhan_name).info.frame0.frame5.frame0.value 

  # build widget $topwin(enhan_name).info.frame0.frame5.frame6.menubutton2
	menubutton $topwin(enhan_name).info.frame0.frame5.frame6.menubutton2 -padx {1} -pady {1} -highlightthickness {0}  \
    -activebackground "$GuiColor(btn_act_bg)"  \
    -background "$GuiColor(btn_bg)" \
    -font "$GuiMisc(pop_up_fn)" \
	 -text "$GuiMisc(pop_up_text)" \
	 -relief "$GuiMisc(pop_up_relief)" \
	 -width {2}
  # bindings
  bind $topwin(enhan_name).info.frame0.frame5.frame6.menubutton2 <Button-1> {MenuPopupPost $topwin(enhan_name).info.frame0.frame5.frame6.menubutton2.menu %X %Y}
  bind $topwin(enhan_name).info.frame0.frame5.frame6.menubutton2 <ButtonRelease-1> {MenuPopupRelease $topwin(enhan_name).info.frame0.frame5.frame6.menubutton2.menu %W}

  # build widget $topwin(enhan_name).info.frame0.frame5.frame6.menubutton2.menu
  menu $topwin(enhan_name).info.frame0.frame5.frame6.menubutton2.menu \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)"
  $topwin(enhan_name).info.frame0.frame5.frame6.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -command {set enhan(pseudo_hcf) 100} \
    -label { 100}
  $topwin(enhan_name).info.frame0.frame5.frame6.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -command {set enhan(pseudo_hcf) 200} \
    -label { 200}
  $topwin(enhan_name).info.frame0.frame5.frame6.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -command {set enhan(pseudo_hcf) 500} \
    -label { 500}
  $topwin(enhan_name).info.frame0.frame5.frame6.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -command {set enhan(pseudo_hcf) 1000} \
    -label {1000}
  $topwin(enhan_name).info.frame0.frame5.frame6.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -command {set enhan(pseudo_hcf) 2000} \
    -label {2000}
  bindtags $topwin(enhan_name).info.frame0.frame5.frame6.menubutton2.menu {Menu all}
  # bindings
  bind $topwin(enhan_name).info.frame0.frame5.frame6.menubutton2.menu <B1-Motion> {MenuPopupMotion $topwin(enhan_name).info.frame0.frame5.frame6.menubutton2.menu %W %X %Y}
  bind $topwin(enhan_name).info.frame0.frame5.frame6.menubutton2.menu <ButtonRelease-1> {MenuPopupRelease $topwin(enhan_name).info.frame0.frame5.frame6.menubutton2.menu %W}

  # pack widget $topwin(enhan_name).info.frame0.frame5.frame6
  pack append $topwin(enhan_name).info.frame0.frame5.frame6 \
    $topwin(enhan_name).info.frame0.frame5.frame6.label1 {left frame center fill} \
    $topwin(enhan_name).info.frame0.frame5.frame6.value {left frame center expand fill} \
    $topwin(enhan_name).info.frame0.frame5.frame6.menubutton2 {right frame center fill}

  # pack widget $topwin(enhan_name).info.frame0.frame5
  pack append $topwin(enhan_name).info.frame0.frame5 \
    $topwin(enhan_name).info.frame0.frame5.frame0 {left frame center padx 11} \
    $topwin(enhan_name).info.frame0.frame5.frame6 {left frame center padx 9}

  # build widget $topwin(enhan_name).info.frame0.frame7
  frame $topwin(enhan_name).info.frame0.frame7 \
    -background "$GuiColor(frame_bg)"

  # build widget $topwin(enhan_name).info.frame0.frame7.frame0
  frame $topwin(enhan_name).info.frame0.frame7.frame0 \
    -background "$GuiColor(frame_bg)" \
    -relief {sunken}

  # build widget $topwin(enhan_name).info.frame0.frame7.frame0.label1
  label $topwin(enhan_name).info.frame0.frame7.frame0.label1 \
    -background "$GuiColor(label_bg)" \
    -borderwidth {0} \
    -text {Low-pass color: }

  # build widget $topwin(enhan_name).info.frame0.frame7.frame0.value
  entry $topwin(enhan_name).info.frame0.frame7.frame0.value \
    -background "$GuiColor(rentry_bg)" \
	 -foreground "$GuiColor(rentry_fg)" \
    -relief {sunken} \
    -state {disabled} \
    -textvariable {enhan(pseudo_lpc)} \
    -width {3}

  # build widget $topwin(enhan_name).info.frame0.frame7.frame0.menubutton2
	menubutton $topwin(enhan_name).info.frame0.frame7.frame0.menubutton2 -padx {1} -pady {1} -highlightthickness {0}  \
    -activebackground "$GuiColor(btn_act_bg)"  \
    -background "$GuiColor(btn_bg)" \
    -font "$GuiMisc(pop_up_fn)" \
	 -text "$GuiMisc(pop_up_text)" \
	 -relief "$GuiMisc(pop_up_relief)" \
	 -width {2}
  # bindings
  bind $topwin(enhan_name).info.frame0.frame7.frame0.menubutton2 <Button-1> {MenuPopupPost $topwin(enhan_name).info.frame0.frame7.frame0.menubutton2.menu %X %Y}
  bind $topwin(enhan_name).info.frame0.frame7.frame0.menubutton2 <ButtonRelease-1> {MenuPopupRelease $topwin(enhan_name).info.frame0.frame7.frame0.menubutton2.menu %W}

  # build widget $topwin(enhan_name).info.frame0.frame7.frame0.menubutton2.menu
  menu $topwin(enhan_name).info.frame0.frame7.frame0.menubutton2.menu \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)"
  $topwin(enhan_name).info.frame0.frame7.frame0.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -command {set enhan(pseudo_lpc) R} \
    -label {  red }
  $topwin(enhan_name).info.frame0.frame7.frame0.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -command {set enhan(pseudo_lpc) G} \
    -label { green}
  $topwin(enhan_name).info.frame0.frame7.frame0.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -command {set enhan(pseudo_lpc) B} \
    -label {  blue}
  bindtags $topwin(enhan_name).info.frame0.frame7.frame0.menubutton2.menu {Menu all}
  # bindings
  bind $topwin(enhan_name).info.frame0.frame7.frame0.menubutton2.menu <B1-Motion> {MenuPopupMotion $topwin(enhan_name).info.frame0.frame7.frame0.menubutton2.menu %W %X %Y}
  bind $topwin(enhan_name).info.frame0.frame7.frame0.menubutton2.menu <ButtonRelease-1> {MenuPopupRelease $topwin(enhan_name).info.frame0.frame7.frame0.menubutton2.menu %W}

  # pack widget $topwin(enhan_name).info.frame0.frame7.frame0
  pack append $topwin(enhan_name).info.frame0.frame7.frame0 \
    $topwin(enhan_name).info.frame0.frame7.frame0.label1 {left frame center fill} \
    $topwin(enhan_name).info.frame0.frame7.frame0.value {left frame center expand fill} \
    $topwin(enhan_name).info.frame0.frame7.frame0.menubutton2 {right frame center fill}

  # build widget $topwin(enhan_name).info.frame0.frame7.frame8
  frame $topwin(enhan_name).info.frame0.frame7.frame8 \
    -background "$GuiColor(frame_bg)" \
    -relief {sunken}

  # build widget $topwin(enhan_name).info.frame0.frame7.frame8.label1
  label $topwin(enhan_name).info.frame0.frame7.frame8.label1 \
    -background "$GuiColor(label_bg)" \
    -borderwidth {0} \
    -text {Band-pass color: }

  # build widget $topwin(enhan_name).info.frame0.frame7.frame8.value
  entry $topwin(enhan_name).info.frame0.frame7.frame8.value \
    -background "$GuiColor(rentry_bg)" \
	 -foreground "$GuiColor(rentry_fg)" \
    -relief {sunken} \
    -state {disabled} \
    -textvariable {enhan(pseudo_bpc)} \
    -width {3}

  # build widget $topwin(enhan_name).info.frame0.frame7.frame8.menubutton2
	menubutton $topwin(enhan_name).info.frame0.frame7.frame8.menubutton2 -padx {1} -pady {1} -highlightthickness {0}  \
    -activebackground "$GuiColor(btn_act_bg)"  \
    -background "$GuiColor(btn_bg)" \
    -font "$GuiMisc(pop_up_fn)" \
	 -text "$GuiMisc(pop_up_text)" \
	 -relief "$GuiMisc(pop_up_relief)" \
	 -width {2}
  # bindings
  bind $topwin(enhan_name).info.frame0.frame7.frame8.menubutton2 <Button-1> {MenuPopupPost $topwin(enhan_name).info.frame0.frame7.frame8.menubutton2.menu %X %Y}
  bind $topwin(enhan_name).info.frame0.frame7.frame8.menubutton2 <ButtonRelease-1> {MenuPopupRelease $topwin(enhan_name).info.frame0.frame7.frame8.menubutton2.menu %W}

  # build widget $topwin(enhan_name).info.frame0.frame7.frame8.menubutton2.menu
  menu $topwin(enhan_name).info.frame0.frame7.frame8.menubutton2.menu \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)"
  $topwin(enhan_name).info.frame0.frame7.frame8.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -command {set enhan(pseudo_bpc) R} \
    -label {  red }
  $topwin(enhan_name).info.frame0.frame7.frame8.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -command {set enhan(pseudo_bpc) G} \
    -label { green}
  $topwin(enhan_name).info.frame0.frame7.frame8.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -command {set enhan(pseudo_bpc) B} \
    -label {  blue}
  bindtags $topwin(enhan_name).info.frame0.frame7.frame8.menubutton2.menu {Menu all}
  # bindings
  bind $topwin(enhan_name).info.frame0.frame7.frame8.menubutton2.menu <B1-Motion> {MenuPopupMotion $topwin(enhan_name).info.frame0.frame7.frame8.menubutton2.menu %W %X %Y}
  bind $topwin(enhan_name).info.frame0.frame7.frame8.menubutton2.menu <ButtonRelease-1> {MenuPopupRelease $topwin(enhan_name).info.frame0.frame7.frame8.menubutton2.menu %W}

  # pack widget $topwin(enhan_name).info.frame0.frame7.frame8
  pack append $topwin(enhan_name).info.frame0.frame7.frame8 \
    $topwin(enhan_name).info.frame0.frame7.frame8.label1 {left frame center fill} \
    $topwin(enhan_name).info.frame0.frame7.frame8.value {left frame center expand fill} \
    $topwin(enhan_name).info.frame0.frame7.frame8.menubutton2 {right frame center fill}

  # build widget $topwin(enhan_name).info.frame0.frame7.frame9
  frame $topwin(enhan_name).info.frame0.frame7.frame9 \
    -background "$GuiColor(frame_bg)" \
    -relief {sunken}

  # build widget $topwin(enhan_name).info.frame0.frame7.frame9.label1
  label $topwin(enhan_name).info.frame0.frame7.frame9.label1 \
    -background "$GuiColor(label_bg)" \
    -borderwidth {0} \
    -text {High-pass color: }

  # build widget $topwin(enhan_name).info.frame0.frame7.frame9.value
  entry $topwin(enhan_name).info.frame0.frame7.frame9.value \
    -background "$GuiColor(rentry_bg)" \
	 -foreground "$GuiColor(rentry_fg)" \
    -relief {sunken} \
    -state {disabled} \
    -textvariable {enhan(pseudo_hpc)} \
    -width {3}

  # build widget $topwin(enhan_name).info.frame0.frame7.frame9.menubutton2
	menubutton $topwin(enhan_name).info.frame0.frame7.frame9.menubutton2 -padx {1} -pady {1} -highlightthickness {0}  \
    -activebackground "$GuiColor(btn_act_bg)"  \
    -background "$GuiColor(btn_bg)" \
    -font "$GuiMisc(pop_up_fn)" \
	 -text "$GuiMisc(pop_up_text)" \
	 -relief "$GuiMisc(pop_up_relief)" \
	 -width {2}
  # bindings
  bind $topwin(enhan_name).info.frame0.frame7.frame9.menubutton2 <Button-1> {MenuPopupPost $topwin(enhan_name).info.frame0.frame7.frame9.menubutton2.menu %X %Y}
  bind $topwin(enhan_name).info.frame0.frame7.frame9.menubutton2 <ButtonRelease-1> {MenuPopupRelease $topwin(enhan_name).info.frame0.frame7.frame9.menubutton2.menu %W}

  # build widget $topwin(enhan_name).info.frame0.frame7.frame9.menubutton2.menu
  menu $topwin(enhan_name).info.frame0.frame7.frame9.menubutton2.menu \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)"
  $topwin(enhan_name).info.frame0.frame7.frame9.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -command {set enhan(pseudo_hpc) R} \
    -label {  red }
  $topwin(enhan_name).info.frame0.frame7.frame9.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -command {set enhan(pseudo_hpc) G} \
    -label { green}
  $topwin(enhan_name).info.frame0.frame7.frame9.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -command {set enhan(pseudo_hpc) B} \
    -label {  blue}
  bindtags  $topwin(enhan_name).info.frame0.frame7.frame9.menubutton2.menu {Menu all}
  # bindings
  bind $topwin(enhan_name).info.frame0.frame7.frame9.menubutton2.menu <B1-Motion> {MenuPopupMotion $topwin(enhan_name).info.frame0.frame7.frame9.menubutton2.menu %W %X %Y}
  bind $topwin(enhan_name).info.frame0.frame7.frame9.menubutton2.menu <ButtonRelease-1> {MenuPopupRelease $topwin(enhan_name).info.frame0.frame7.frame9.menubutton2.menu %W}

  # pack widget $topwin(enhan_name).info.frame0.frame7.frame9
  pack append $topwin(enhan_name).info.frame0.frame7.frame9 \
    $topwin(enhan_name).info.frame0.frame7.frame9.label1 {left frame center fill} \
    $topwin(enhan_name).info.frame0.frame7.frame9.value {left frame center expand fill} \
    $topwin(enhan_name).info.frame0.frame7.frame9.menubutton2 {right frame center fill}

  # pack widget $topwin(enhan_name).info.frame0.frame7
  pack append $topwin(enhan_name).info.frame0.frame7 \
    $topwin(enhan_name).info.frame0.frame7.frame0 {left frame center padx 11} \
    $topwin(enhan_name).info.frame0.frame7.frame8 {left frame center padx 11} \
    $topwin(enhan_name).info.frame0.frame7.frame9 {left frame center padx 11}

  # pack widget $topwin(enhan_name).info.frame0
  pack append $topwin(enhan_name).info.frame0 \
    $topwin(enhan_name).info.frame0.frame3 {top frame w} \
    $topwin(enhan_name).info.frame0.frame5 {top frame w expand} \
    $topwin(enhan_name).info.frame0.frame7 {top frame w expand}

  # build widget $topwin(enhan_name).info.frame1
  frame $topwin(enhan_name).info.frame1 \
    -background "$GuiColor(frame_bg)" \
    -borderwidth {2} \
    -relief {ridge}

  # build widget $topwin(enhan_name).info.frame1.frame5
  frame $topwin(enhan_name).info.frame1.frame5 \
    -background "$GuiColor(frame_bg)" \
    -borderwidth {2}

  # build widget $topwin(enhan_name).info.frame1.frame5.radiobutton14
	radiobutton $topwin(enhan_name).info.frame1.frame5.radiobutton14 -padx {1} -pady {1} -highlightthickness {0}  \
    -activebackground "$GuiColor(btn_act_bg)"  \
    -background "$GuiColor(btn_bg)" \
    -relief {flat} \
    -text { Gray level mapping} \
    -value {bitplane} \
    -variable {enhan(g_c)}

  # pack widget $topwin(enhan_name).info.frame1.frame5
  pack append $topwin(enhan_name).info.frame1.frame5 \
    $topwin(enhan_name).info.frame1.frame5.radiobutton14 {left frame w padx 3}

  # build widget $topwin(enhan_name).info.frame1.frame6
  frame $topwin(enhan_name).info.frame1.frame6 \
    -background "$GuiColor(frame_bg)" \
    -borderwidth {2}

  # build widget $topwin(enhan_name).info.frame1.frame6.frame0
  frame $topwin(enhan_name).info.frame1.frame6.frame0 \
    -background "$GuiColor(frame_bg)" \
    -borderwidth {2} \
    -relief {groove}

  # build widget $topwin(enhan_name).info.frame1.frame6.frame0.frame9
  frame $topwin(enhan_name).info.frame1.frame6.frame0.frame9 \
    -background "$GuiColor(frame_bg)" \
    -relief {sunken}

  # build widget $topwin(enhan_name).info.frame1.frame6.frame0.frame9.label1
  label $topwin(enhan_name).info.frame1.frame6.frame0.frame9.label1 \
    -background "$GuiColor(label_bg)" \
    -borderwidth {0} \
    -text {Red: }

  # build widget $topwin(enhan_name).info.frame1.frame6.frame0.frame9.value
  label $topwin(enhan_name).info.frame1.frame6.frame0.frame9.value \
    -background {white} \
    -bitmap @$env(CVIPHOME)/CVIPTCL/GUI_SCRIPTS/bmp/red.bmp \
    -foreground {Blue} \
    -relief {sunken} \
    -textvariable {enhan(g_c_r)} \
    -width {70}

  # build widget $topwin(enhan_name).info.frame1.frame6.frame0.frame9.menubutton2
	menubutton $topwin(enhan_name).info.frame1.frame6.frame0.frame9.menubutton2 -padx {1} -pady {1} -highlightthickness {0}  \
    -activebackground "$GuiColor(btn_act_bg)"  \
    -background "$GuiColor(btn_bg)" \
    -font "$GuiMisc(pop_up_fn)" \
	 -text "$GuiMisc(pop_up_text)" \
	 -relief "$GuiMisc(pop_up_relief)" \
	 -width {2}
  # bindings
  bind $topwin(enhan_name).info.frame1.frame6.frame0.frame9.menubutton2 <Button-1> {MenuPopupPost $topwin(enhan_name).info.frame1.frame6.frame0.frame9.menubutton2.menu %X %Y}
  bind $topwin(enhan_name).info.frame1.frame6.frame0.frame9.menubutton2 <ButtonRelease-1> {MenuPopupRelease $topwin(enhan_name).info.frame1.frame6.frame0.frame9.menubutton2.menu %W}

  # build widget $topwin(enhan_name).info.frame1.frame6.frame0.frame9.menubutton2.menu
  menu $topwin(enhan_name).info.frame1.frame6.frame0.frame9.menubutton2.menu \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -foreground {Blue}
  $topwin(enhan_name).info.frame1.frame6.frame0.frame9.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -bitmap @$env(CVIPHOME)/CVIPTCL/GUI_SCRIPTS/bmp/red.bmp \
    -command {
	 $topwin(enhan_name).info.frame1.frame6.frame0.frame9.value  configure  \
	 -bitmap @$env(CVIPHOME)/CVIPTCL/GUI_SCRIPTS/bmp/red.bmp
set enhan(g_c_r) red }
  $topwin(enhan_name).info.frame1.frame6.frame0.frame9.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -bitmap @$env(CVIPHOME)/CVIPTCL/GUI_SCRIPTS/bmp/green.bmp \
    -command {
	 $topwin(enhan_name).info.frame1.frame6.frame0.frame9.value  configure  \
	 -bitmap @$env(CVIPHOME)/CVIPTCL/GUI_SCRIPTS/bmp/green.bmp
set enhan(g_c_r) green }
  $topwin(enhan_name).info.frame1.frame6.frame0.frame9.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -bitmap @$env(CVIPHOME)/CVIPTCL/GUI_SCRIPTS/bmp/blue.bmp \
    -command {
	 $topwin(enhan_name).info.frame1.frame6.frame0.frame9.value  configure   \
	 -bitmap @$env(CVIPHOME)/CVIPTCL/GUI_SCRIPTS/bmp/blue.bmp
set enhan(g_c_r) blue }
  $topwin(enhan_name).info.frame1.frame6.frame0.frame9.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -bitmap @$env(CVIPHOME)/CVIPTCL/GUI_SCRIPTS/bmp/slash.bmp \
    -command {
	 $topwin(enhan_name).info.frame1.frame6.frame0.frame9.value  configure  \
	 -bitmap @$env(CVIPHOME)/CVIPTCL/GUI_SCRIPTS/bmp/slash.bmp
set enhan(g_c_r) slash }
  $topwin(enhan_name).info.frame1.frame6.frame0.frame9.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -bitmap @$env(CVIPHOME)/CVIPTCL/GUI_SCRIPTS/bmp/backslash.bmp \
    -command {
	 $topwin(enhan_name).info.frame1.frame6.frame0.frame9.value  configure  \
	 -bitmap @$env(CVIPHOME)/CVIPTCL/GUI_SCRIPTS/bmp/backslash.bmp
set enhan(g_c_r) backslash }
  bindtags $topwin(enhan_name).info.frame1.frame6.frame0.frame9.menubutton2.menu {Menu all}
  # bindings
  bind $topwin(enhan_name).info.frame1.frame6.frame0.frame9.menubutton2.menu <B1-Motion> {MenuPopupMotion $topwin(enhan_name).info.frame1.frame6.frame0.frame9.menubutton2.menu %W %X %Y}
  bind $topwin(enhan_name).info.frame1.frame6.frame0.frame9.menubutton2.menu <ButtonRelease-1> {MenuPopupRelease $topwin(enhan_name).info.frame1.frame6.frame0.frame9.menubutton2.menu %W}

  # pack widget $topwin(enhan_name).info.frame1.frame6.frame0.frame9
  pack append $topwin(enhan_name).info.frame1.frame6.frame0.frame9 \
    $topwin(enhan_name).info.frame1.frame6.frame0.frame9.label1 {left frame center fill} \
    $topwin(enhan_name).info.frame1.frame6.frame0.frame9.value {left frame center expand fill} \
    $topwin(enhan_name).info.frame1.frame6.frame0.frame9.menubutton2 {right frame center fill}

  # pack widget $topwin(enhan_name).info.frame1.frame6.frame0
  pack append $topwin(enhan_name).info.frame1.frame6.frame0 \
    $topwin(enhan_name).info.frame1.frame6.frame0.frame9 {left frame center padx 11}

  # build widget $topwin(enhan_name).info.frame1.frame6.frame1
  frame $topwin(enhan_name).info.frame1.frame6.frame1 \
    -background "$GuiColor(frame_bg)" \
    -borderwidth {2} \
    -relief {groove}

  # build widget $topwin(enhan_name).info.frame1.frame6.frame1.frame9
  frame $topwin(enhan_name).info.frame1.frame6.frame1.frame9 \
    -background "$GuiColor(frame_bg)" \
    -relief {sunken}

  # build widget $topwin(enhan_name).info.frame1.frame6.frame1.frame9.label1
  label $topwin(enhan_name).info.frame1.frame6.frame1.frame9.label1 \
    -background "$GuiColor(label_bg)" \
    -borderwidth {0} \
    -text {Green: }

  # build widget $topwin(enhan_name).info.frame1.frame6.frame1.frame9.value
  label $topwin(enhan_name).info.frame1.frame6.frame1.frame9.value \
    -background {white} \
    -bitmap @$env(CVIPHOME)/CVIPTCL/GUI_SCRIPTS/bmp/green.bmp \
    -foreground {Blue} \
    -relief {sunken} \
    -textvariable {enhan(g_c_g)} \
    -width {70}

  # build widget $topwin(enhan_name).info.frame1.frame6.frame1.frame9.menubutton2
	menubutton $topwin(enhan_name).info.frame1.frame6.frame1.frame9.menubutton2 -padx {1} -pady {1} -highlightthickness {0}  \
    -activebackground "$GuiColor(btn_act_bg)"  \
    -background "$GuiColor(btn_bg)" \
    -font "$GuiMisc(pop_up_fn)" \
	 -text "$GuiMisc(pop_up_text)" \
	 -relief "$GuiMisc(pop_up_relief)" \
	 -width {2}
  # bindings
  bind $topwin(enhan_name).info.frame1.frame6.frame1.frame9.menubutton2 <Button-1> {MenuPopupPost $topwin(enhan_name).info.frame1.frame6.frame1.frame9.menubutton2.menu %X %Y}
  bind $topwin(enhan_name).info.frame1.frame6.frame1.frame9.menubutton2 <ButtonRelease-1> {MenuPopupRelease $topwin(enhan_name).info.frame1.frame6.frame1.frame9.menubutton2.menu %W}

  # build widget $topwin(enhan_name).info.frame1.frame6.frame1.frame9.menubutton2.menu
  menu $topwin(enhan_name).info.frame1.frame6.frame1.frame9.menubutton2.menu \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -foreground {Blue}
  $topwin(enhan_name).info.frame1.frame6.frame1.frame9.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -bitmap @$env(CVIPHOME)/CVIPTCL/GUI_SCRIPTS/bmp/red.bmp \
    -command {
	 $topwin(enhan_name).info.frame1.frame6.frame1.frame9.value  configure  \
	 -bitmap @$env(CVIPHOME)/CVIPTCL/GUI_SCRIPTS/bmp/red.bmp
set enhan(g_c_g) red }
  $topwin(enhan_name).info.frame1.frame6.frame1.frame9.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -bitmap @$env(CVIPHOME)/CVIPTCL/GUI_SCRIPTS/bmp/green.bmp \
    -command {
	 $topwin(enhan_name).info.frame1.frame6.frame1.frame9.value  configure  \
	 -bitmap @$env(CVIPHOME)/CVIPTCL/GUI_SCRIPTS/bmp/green.bmp
set enhan(g_c_g) green }
  $topwin(enhan_name).info.frame1.frame6.frame1.frame9.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -bitmap @$env(CVIPHOME)/CVIPTCL/GUI_SCRIPTS/bmp/blue.bmp \
    -command {
	 $topwin(enhan_name).info.frame1.frame6.frame1.frame9.value  configure  \
	 -bitmap @$env(CVIPHOME)/CVIPTCL/GUI_SCRIPTS/bmp/blue.bmp
set enhan(g_c_g) blue }
  $topwin(enhan_name).info.frame1.frame6.frame1.frame9.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -bitmap @$env(CVIPHOME)/CVIPTCL/GUI_SCRIPTS/bmp/slash.bmp \
    -command {
	 $topwin(enhan_name).info.frame1.frame6.frame1.frame9.value  configure  \
	 -bitmap @$env(CVIPHOME)/CVIPTCL/GUI_SCRIPTS/bmp/slash.bmp
set enhan(g_c_g) slash }
  $topwin(enhan_name).info.frame1.frame6.frame1.frame9.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -bitmap @$env(CVIPHOME)/CVIPTCL/GUI_SCRIPTS/bmp/backslash.bmp \
    -command {
	 $topwin(enhan_name).info.frame1.frame6.frame1.frame9.value  configure  \
	 -bitmap @$env(CVIPHOME)/CVIPTCL/GUI_SCRIPTS/bmp/backslash.bmp
set enhan(g_c_g) backslash }
  bindtags $topwin(enhan_name).info.frame1.frame6.frame1.frame9.menubutton2.menu {Menu all}
  # bindings
  bind $topwin(enhan_name).info.frame1.frame6.frame1.frame9.menubutton2.menu <B1-Motion> {MenuPopupMotion $topwin(enhan_name).info.frame1.frame6.frame1.frame9.menubutton2.menu %W %X %Y}
  bind $topwin(enhan_name).info.frame1.frame6.frame1.frame9.menubutton2.menu <ButtonRelease-1> {MenuPopupRelease $topwin(enhan_name).info.frame1.frame6.frame1.frame9.menubutton2.menu %W}

  # pack widget $topwin(enhan_name).info.frame1.frame6.frame1.frame9
  pack append $topwin(enhan_name).info.frame1.frame6.frame1.frame9 \
    $topwin(enhan_name).info.frame1.frame6.frame1.frame9.label1 {left frame center fill} \
    $topwin(enhan_name).info.frame1.frame6.frame1.frame9.value {left frame center expand fill} \
    $topwin(enhan_name).info.frame1.frame6.frame1.frame9.menubutton2 {right frame center fill}

  # pack widget $topwin(enhan_name).info.frame1.frame6.frame1
  pack append $topwin(enhan_name).info.frame1.frame6.frame1 \
    $topwin(enhan_name).info.frame1.frame6.frame1.frame9 {left frame center padx 11}

  # build widget $topwin(enhan_name).info.frame1.frame6.frame2
  frame $topwin(enhan_name).info.frame1.frame6.frame2 \
    -background "$GuiColor(frame_bg)" \
    -borderwidth {2} \
    -relief {groove}

  # build widget $topwin(enhan_name).info.frame1.frame6.frame2.frame9
  frame $topwin(enhan_name).info.frame1.frame6.frame2.frame9 \
    -background "$GuiColor(frame_bg)" \
    -relief {sunken}

  # build widget $topwin(enhan_name).info.frame1.frame6.frame2.frame9.label1
  label $topwin(enhan_name).info.frame1.frame6.frame2.frame9.label1 \
    -background "$GuiColor(label_bg)" \
    -borderwidth {0} \
    -text {Blue: }

  # build widget $topwin(enhan_name).info.frame1.frame6.frame2.frame9.value
  label $topwin(enhan_name).info.frame1.frame6.frame2.frame9.value \
    -background {white} \
    -bitmap @$env(CVIPHOME)/CVIPTCL/GUI_SCRIPTS/bmp/blue.bmp \
    -foreground {Blue} \
    -relief {sunken} \
    -textvariable {enhan(g_c_b)} \
    -width {70}

  # build widget $topwin(enhan_name).info.frame1.frame6.frame2.frame9.menubutton2
	menubutton $topwin(enhan_name).info.frame1.frame6.frame2.frame9.menubutton2 -padx {1} -pady {1} -highlightthickness {0}  \
    -activebackground "$GuiColor(btn_act_bg)"  \
    -background "$GuiColor(btn_bg)" \
    -font "$GuiMisc(pop_up_fn)" \
	 -text "$GuiMisc(pop_up_text)" \
	 -relief "$GuiMisc(pop_up_relief)" \
	 -width {2}
  # bindings
  bind $topwin(enhan_name).info.frame1.frame6.frame2.frame9.menubutton2 <Button-1> {MenuPopupPost $topwin(enhan_name).info.frame1.frame6.frame2.frame9.menubutton2.menu %X %Y}
  bind $topwin(enhan_name).info.frame1.frame6.frame2.frame9.menubutton2 <ButtonRelease-1> {MenuPopupRelease $topwin(enhan_name).info.frame1.frame6.frame2.frame9.menubutton2.menu %W}

  # build widget $topwin(enhan_name).info.frame1.frame6.frame2.frame9.menubutton2.menu
  menu $topwin(enhan_name).info.frame1.frame6.frame2.frame9.menubutton2.menu \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -foreground {Blue}
  $topwin(enhan_name).info.frame1.frame6.frame2.frame9.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -bitmap @$env(CVIPHOME)/CVIPTCL/GUI_SCRIPTS/bmp/red.bmp \
    -command {
	 $topwin(enhan_name).info.frame1.frame6.frame2.frame9.value  configure  \
	 -bitmap @$env(CVIPHOME)/CVIPTCL/GUI_SCRIPTS/bmp/red.bmp
set enhan(g_c_b) red }
  $topwin(enhan_name).info.frame1.frame6.frame2.frame9.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -bitmap @$env(CVIPHOME)/CVIPTCL/GUI_SCRIPTS/bmp/green.bmp \
    -command {
	 $topwin(enhan_name).info.frame1.frame6.frame2.frame9.value  configure  \
	 -bitmap @$env(CVIPHOME)/CVIPTCL/GUI_SCRIPTS/bmp/green.bmp
set enhan(g_c_b) green }
  $topwin(enhan_name).info.frame1.frame6.frame2.frame9.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -bitmap @$env(CVIPHOME)/CVIPTCL/GUI_SCRIPTS/bmp/blue.bmp \
    -command {
	 $topwin(enhan_name).info.frame1.frame6.frame2.frame9.value  configure  \
	 -bitmap @$env(CVIPHOME)/CVIPTCL/GUI_SCRIPTS/bmp/blue.bmp
set enhan(g_c_b) blue }
  $topwin(enhan_name).info.frame1.frame6.frame2.frame9.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -bitmap @$env(CVIPHOME)/CVIPTCL/GUI_SCRIPTS/bmp/slash.bmp \
    -command {
	 $topwin(enhan_name).info.frame1.frame6.frame2.frame9.value  configure  \
	 -bitmap @$env(CVIPHOME)/CVIPTCL/GUI_SCRIPTS/bmp/slash.bmp
set enhan(g_c_b) slash }
  $topwin(enhan_name).info.frame1.frame6.frame2.frame9.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -bitmap @$env(CVIPHOME)/CVIPTCL/GUI_SCRIPTS/bmp/backslash.bmp \
    -command {
	 $topwin(enhan_name).info.frame1.frame6.frame2.frame9.value  configure  \
	 -bitmap @$env(CVIPHOME)/CVIPTCL/GUI_SCRIPTS/bmp/backslash.bmp
set enhan(g_c_b) backslash }
  bindtags $topwin(enhan_name).info.frame1.frame6.frame2.frame9.menubutton2.menu {Menu all}
  # bindings
  bind $topwin(enhan_name).info.frame1.frame6.frame2.frame9.menubutton2.menu <B1-Motion> {MenuPopupMotion $topwin(enhan_name).info.frame1.frame6.frame2.frame9.menubutton2.menu %W %X %Y}
  bind $topwin(enhan_name).info.frame1.frame6.frame2.frame9.menubutton2.menu <ButtonRelease-1> {MenuPopupRelease $topwin(enhan_name).info.frame1.frame6.frame2.frame9.menubutton2.menu %W}

  # pack widget $topwin(enhan_name).info.frame1.frame6.frame2.frame9
  pack append $topwin(enhan_name).info.frame1.frame6.frame2.frame9 \
    $topwin(enhan_name).info.frame1.frame6.frame2.frame9.label1 {left frame center fill} \
    $topwin(enhan_name).info.frame1.frame6.frame2.frame9.value {left frame center expand fill} \
    $topwin(enhan_name).info.frame1.frame6.frame2.frame9.menubutton2 {right frame center fill}

  # pack widget $topwin(enhan_name).info.frame1.frame6.frame2
  pack append $topwin(enhan_name).info.frame1.frame6.frame2 \
    $topwin(enhan_name).info.frame1.frame6.frame2.frame9 {left frame center padx 11}

  # pack widget $topwin(enhan_name).info.frame1.frame6
  pack append $topwin(enhan_name).info.frame1.frame6 \
    $topwin(enhan_name).info.frame1.frame6.frame0 {left frame center expand filly} \
    $topwin(enhan_name).info.frame1.frame6.frame1 {left frame center expand filly} \
    $topwin(enhan_name).info.frame1.frame6.frame2 {left frame center expand filly}

  # pack widget $topwin(enhan_name).info.frame1
  pack append $topwin(enhan_name).info.frame1 \
    $topwin(enhan_name).info.frame1.frame5 {top frame center fillx} \
    $topwin(enhan_name).info.frame1.frame6 {top frame center expand fill}

  # build widget $topwin(enhan_name).info.frame2
  frame $topwin(enhan_name).info.frame2 \
    -background "$GuiColor(frame_bg)" \
    -borderwidth {2} \
    -relief {ridge}

  # build widget $topwin(enhan_name).info.frame2.frame7
  frame $topwin(enhan_name).info.frame2.frame7 \
    -background "$GuiColor(frame_bg)" \
    -borderwidth {2}

  # build widget $topwin(enhan_name).info.frame2.frame7.radiobutton10
	radiobutton $topwin(enhan_name).info.frame2.frame7.radiobutton10 -padx {1} -pady {1} -highlightthickness {0}  \
    -activebackground "$GuiColor(btn_act_bg)"  \
    -background "$GuiColor(btn_bg)" \
    -command {if [AlertBox "Clear the gray ranges?" "" "300x150" "Intensity Slicing"  NO YES] { 
foreach i [list 1 2 3 4] {set enhan(slice_${i}0) "";
set enhan(slice_${i}1) ""}}
} \
    -relief {flat} \
    -text {Intensity slicing} \
    -value {intensity} \
    -variable {enhan(g_c)}

  # build widget $topwin(enhan_name).info.frame2.frame7.checkbutton0
	checkbutton $topwin(enhan_name).info.frame2.frame7.checkbutton0 -padx {1} -pady {1} -highlightthickness {0}  \
    -activebackground "$GuiColor(btn_act_bg)"  \
    -background "$GuiColor(btn_bg)" \
    -text {Set out_of_range data to 0} \
    -variable {enhan(slice_out)}

  # pack widget $topwin(enhan_name).info.frame2.frame7
  pack append $topwin(enhan_name).info.frame2.frame7 \
    $topwin(enhan_name).info.frame2.frame7.radiobutton10 {left frame nw padx 23} \
    $topwin(enhan_name).info.frame2.frame7.checkbutton0 {right frame center padx 40}

  # build widget $topwin(enhan_name).info.frame2.frame8
  frame $topwin(enhan_name).info.frame2.frame8 \
    -background "$GuiColor(frame_bg)" \
    -borderwidth {2}

  # build widget $topwin(enhan_name).info.frame2.frame8.frame0
  frame $topwin(enhan_name).info.frame2.frame8.frame0 \
    -background "$GuiColor(frame_bg)" \
    -borderwidth {2}

  # build widget $topwin(enhan_name).info.frame2.frame8.frame0.frame7
  frame $topwin(enhan_name).info.frame2.frame8.frame0.frame7 \
    -background "$GuiColor(frame_bg)" \
    -borderwidth {2}

  # build widget $topwin(enhan_name).info.frame2.frame8.frame0.frame7.label10
  label $topwin(enhan_name).info.frame2.frame8.frame0.frame7.label10 \
    -background "$GuiColor(label_bg)" \
    -text {Map all gray values in this range}

  # pack widget $topwin(enhan_name).info.frame2.frame8.frame0.frame7
  pack append $topwin(enhan_name).info.frame2.frame8.frame0.frame7 \
    $topwin(enhan_name).info.frame2.frame8.frame0.frame7.label10 {top frame center}

  # build widget $topwin(enhan_name).info.frame2.frame8.frame0.frame8
  frame $topwin(enhan_name).info.frame2.frame8.frame0.frame8 \
    -background "$GuiColor(frame_bg)" \
    -borderwidth {2}

  # build widget $topwin(enhan_name).info.frame2.frame8.frame0.frame8.label12
  label $topwin(enhan_name).info.frame2.frame8.frame0.frame8.label12 \
    -background "$GuiColor(label_bg)" \
    -text {===>} \
    -width {5}

  # pack widget $topwin(enhan_name).info.frame2.frame8.frame0.frame8
  pack append $topwin(enhan_name).info.frame2.frame8.frame0.frame8 \
    $topwin(enhan_name).info.frame2.frame8.frame0.frame8.label12 {top frame center}

  # build widget $topwin(enhan_name).info.frame2.frame8.frame0.frame9
  frame $topwin(enhan_name).info.frame2.frame8.frame0.frame9 \
    -background "$GuiColor(frame_bg)" \
    -borderwidth {2}

  # build widget $topwin(enhan_name).info.frame2.frame8.frame0.frame9.label13
  label $topwin(enhan_name).info.frame2.frame8.frame0.frame9.label13 \
    -background "$GuiColor(label_bg)" \
    -text {         To a color with these values}

  # pack widget $topwin(enhan_name).info.frame2.frame8.frame0.frame9
  pack append $topwin(enhan_name).info.frame2.frame8.frame0.frame9 \
    $topwin(enhan_name).info.frame2.frame8.frame0.frame9.label13 {top frame center}

  # pack widget $topwin(enhan_name).info.frame2.frame8.frame0
  pack append $topwin(enhan_name).info.frame2.frame8.frame0 \
    $topwin(enhan_name).info.frame2.frame8.frame0.frame7 {left frame center} \
    $topwin(enhan_name).info.frame2.frame8.frame0.frame8 {left frame center} \
    $topwin(enhan_name).info.frame2.frame8.frame0.frame9 {left frame center}

  # build widget $topwin(enhan_name).info.frame2.frame8.frame1
  frame $topwin(enhan_name).info.frame2.frame8.frame1 \
    -background "$GuiColor(frame_bg)" \
    -borderwidth {2}

  # build widget $topwin(enhan_name).info.frame2.frame8.frame1.frame18
  frame $topwin(enhan_name).info.frame2.frame8.frame1.frame18 \
    -background "$GuiColor(frame_bg)" \
    -borderwidth {2}

  # build widget $topwin(enhan_name).info.frame2.frame8.frame1.frame18.label15
  label $topwin(enhan_name).info.frame2.frame8.frame1.frame18.label15 \
    -background "$GuiColor(label_bg)" \
    -text {From:}

  # build widget $topwin(enhan_name).info.frame2.frame8.frame1.frame18.entry16
  entry $topwin(enhan_name).info.frame2.frame8.frame1.frame18.entry16 \
    -background "$GuiColor(entry_bg)" \
	 -foreground "$GuiColor(entry_fg)" \
    -background {white} \
    -relief {sunken} \
    -textvariable {enhan(slice_10)} \
    -width {5}
  endEntry $topwin(enhan_name).info.frame2.frame8.frame1.frame18.entry16 0 \
  	 $topwin(enhan_name).info.frame2.frame8.frame1.frame19.entry16 \
  	 $topwin(enhan_name).info.frame2.frame8.frame1.frame23.entry16 

  # build widget $topwin(enhan_name).info.frame2.frame8.frame1.frame18.label17
  menubutton $topwin(enhan_name).info.frame2.frame8.frame1.frame18.label17 \
    -activebackground "$GuiColor(btn_act_bg)"  \
    -background "$GuiColor(btn_bg)" \
    -font "$GuiMisc(pop_up_fn)" \
	 -text "$GuiMisc(pop_up_text)" \
	 -relief "$GuiMisc(pop_up_relief)" \
    -width {1}
  # bindings
  bind $topwin(enhan_name).info.frame2.frame8.frame1.frame18.label17 <Button-1> {MenuPopupPost $topwin(enhan_name).info.frame2.frame8.frame1.frame18.label17.menu %X %Y}
  bind $topwin(enhan_name).info.frame2.frame8.frame1.frame18.label17 <ButtonRelease-1> {MenuPopupRelease $topwin(enhan_name).info.frame2.frame8.frame1.frame18.label17.menu %W}

  # build widget $topwin(enhan_name).info.frame2.frame8.frame1.frame18.label17.menu
  menu $topwin(enhan_name).info.frame2.frame8.frame1.frame18.label17.menu \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)"
  $topwin(enhan_name).info.frame2.frame8.frame1.frame18.label17.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -command {set enhan(slice_10) 0} \
    -label {0}
  $topwin(enhan_name).info.frame2.frame8.frame1.frame18.label17.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -command {set enhan(slice_10) 64} \
    -label {64}
  $topwin(enhan_name).info.frame2.frame8.frame1.frame18.label17.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -command {set enhan(slice_10) 85} \
    -label {85}
  $topwin(enhan_name).info.frame2.frame8.frame1.frame18.label17.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -command {set enhan(slice_10) 128} \
    -label {128}
  $topwin(enhan_name).info.frame2.frame8.frame1.frame18.label17.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -command {set enhan(slice_10) 170} \
    -label {170}
  $topwin(enhan_name).info.frame2.frame8.frame1.frame18.label17.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -command {set enhan(slice_10) 192} \
    -label {192}
  # bindings
  bind $topwin(enhan_name).info.frame2.frame8.frame1.frame18.label17.menu <B1-Motion> {MenuPopupMotion $topwin(enhan_name).info.frame2.frame8.frame1.frame18.label17.menu %W %X %Y}
  bind $topwin(enhan_name).info.frame2.frame8.frame1.frame18.label17.menu <ButtonRelease-1> {MenuPopupRelease $topwin(enhan_name).info.frame2.frame8.frame1.frame18.label17.menu %W}

  # pack widget $topwin(enhan_name).info.frame2.frame8.frame1.frame18
  pack append $topwin(enhan_name).info.frame2.frame8.frame1.frame18 \
    $topwin(enhan_name).info.frame2.frame8.frame1.frame18.label15 {left frame center} \
    $topwin(enhan_name).info.frame2.frame8.frame1.frame18.entry16 {left frame center} \
    $topwin(enhan_name).info.frame2.frame8.frame1.frame18.label17 {left frame center}

  # build widget $topwin(enhan_name).info.frame2.frame8.frame1.frame19
  frame $topwin(enhan_name).info.frame2.frame8.frame1.frame19 \
    -background "$GuiColor(frame_bg)" \
    -borderwidth {2}

  # build widget $topwin(enhan_name).info.frame2.frame8.frame1.frame19.label15
  label $topwin(enhan_name).info.frame2.frame8.frame1.frame19.label15 \
    -background "$GuiColor(label_bg)" \
    -text {To:}

  # build widget $topwin(enhan_name).info.frame2.frame8.frame1.frame19.entry16
  entry $topwin(enhan_name).info.frame2.frame8.frame1.frame19.entry16 \
    -background "$GuiColor(entry_bg)" \
	 -foreground "$GuiColor(entry_fg)" \
    -relief {sunken} \
    -textvariable {enhan(slice_11)} \
    -width {5}
  endEntry $topwin(enhan_name).info.frame2.frame8.frame1.frame19.entry16 0\
    $topwin(enhan_name).info.frame2.frame8.frame1.frame21.entry16 \
    $topwin(enhan_name).info.frame2.frame8.frame1.frame18.entry16 

  # build widget $topwin(enhan_name).info.frame2.frame8.frame1.frame19.label17
  menubutton $topwin(enhan_name).info.frame2.frame8.frame1.frame19.label17 \
    -activebackground "$GuiColor(btn_act_bg)"  \
    -background "$GuiColor(btn_bg)" \
    -font "$GuiMisc(pop_up_fn)" \
	 -text "$GuiMisc(pop_up_text)" \
	 -relief "$GuiMisc(pop_up_relief)" \
    -width {1}
  # bindings
  bind $topwin(enhan_name).info.frame2.frame8.frame1.frame19.label17 <Button-1> {MenuPopupPost $topwin(enhan_name).info.frame2.frame8.frame1.frame19.label17.menu %X %Y}
  bind $topwin(enhan_name).info.frame2.frame8.frame1.frame19.label17 <ButtonRelease-1> {MenuPopupRelease $topwin(enhan_name).info.frame2.frame8.frame1.frame19.label17.menu %W}

  # build widget $topwin(enhan_name).info.frame2.frame8.frame1.frame19.label17.menu
  menu $topwin(enhan_name).info.frame2.frame8.frame1.frame19.label17.menu \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)"
  $topwin(enhan_name).info.frame2.frame8.frame1.frame19.label17.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -command {set enhan(slice_11) 63} \
    -label {63}
  $topwin(enhan_name).info.frame2.frame8.frame1.frame19.label17.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -command {set enhan(slice_11) 84} \
    -label {84}
  $topwin(enhan_name).info.frame2.frame8.frame1.frame19.label17.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -command {set enhan(slice_11) 127} \
    -label {127}
  $topwin(enhan_name).info.frame2.frame8.frame1.frame19.label17.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -command {set enhan(slice_11) 169} \
    -label {169}
  $topwin(enhan_name).info.frame2.frame8.frame1.frame19.label17.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -command {set enhan(slice_11) 191} \
    -label {191}
  $topwin(enhan_name).info.frame2.frame8.frame1.frame19.label17.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -command {set enhan(slice_11) 255} \
    -label {255}
  # bindings
  bind $topwin(enhan_name).info.frame2.frame8.frame1.frame19.label17.menu <B1-Motion> {MenuPopupMotion $topwin(enhan_name).info.frame2.frame8.frame1.frame19.label17.menu %W %X %Y}
  bind $topwin(enhan_name).info.frame2.frame8.frame1.frame19.label17.menu <ButtonRelease-1> {MenuPopupRelease $topwin(enhan_name).info.frame2.frame8.frame1.frame19.label17.menu %W}

  # pack widget $topwin(enhan_name).info.frame2.frame8.frame1.frame19
  pack append $topwin(enhan_name).info.frame2.frame8.frame1.frame19 \
    $topwin(enhan_name).info.frame2.frame8.frame1.frame19.label15 {left frame center} \
    $topwin(enhan_name).info.frame2.frame8.frame1.frame19.entry16 {left frame center} \
    $topwin(enhan_name).info.frame2.frame8.frame1.frame19.label17 {left frame center}

  # build widget $topwin(enhan_name).info.frame2.frame8.frame1.label20
  label $topwin(enhan_name).info.frame2.frame8.frame1.label20 \
    -background "$GuiColor(label_bg)" \
    -text {  ===>    }

  # build widget $topwin(enhan_name).info.frame2.frame8.frame1.frame21
  frame $topwin(enhan_name).info.frame2.frame8.frame1.frame21 \
    -background "$GuiColor(frame_bg)" \
    -borderwidth {2}

  # build widget $topwin(enhan_name).info.frame2.frame8.frame1.frame21.label15
  label $topwin(enhan_name).info.frame2.frame8.frame1.frame21.label15 \
    -background {red} \
    -foreground {white} \
    -text {R:}

  # build widget $topwin(enhan_name).info.frame2.frame8.frame1.frame21.entry16
  entry $topwin(enhan_name).info.frame2.frame8.frame1.frame21.entry16 \
    -background "$GuiColor(entry_bg)" \
	 -foreground "$GuiColor(entry_fg)" \
    -relief {sunken} \
    -textvariable {enhan(slice_12)} \
    -width {5}
  endEntry $topwin(enhan_name).info.frame2.frame8.frame1.frame21.entry16 0\
    $topwin(enhan_name).info.frame2.frame8.frame1.frame22.entry16 \
    $topwin(enhan_name).info.frame2.frame8.frame1.frame19.entry16

  # build widget $topwin(enhan_name).info.frame2.frame8.frame1.frame21.label17
  menubutton $topwin(enhan_name).info.frame2.frame8.frame1.frame21.label17 \
    -activebackground "$GuiColor(btn_act_bg)"  \
    -background "$GuiColor(btn_bg)" \
    -font "$GuiMisc(pop_up_fn)" \
	 -text "$GuiMisc(pop_up_text)" \
	 -relief "$GuiMisc(pop_up_relief)" \
    -width {1}
  # bindings
  bind $topwin(enhan_name).info.frame2.frame8.frame1.frame21.label17 <Button-1> {MenuPopupPost $topwin(enhan_name).info.frame2.frame8.frame1.frame21.label17.menu %X %Y}
  bind $topwin(enhan_name).info.frame2.frame8.frame1.frame21.label17 <ButtonRelease-1> {MenuPopupRelease $topwin(enhan_name).info.frame2.frame8.frame1.frame21.label17.menu %W}

  # build widget $topwin(enhan_name).info.frame2.frame8.frame1.frame21.label17.menu
  menu $topwin(enhan_name).info.frame2.frame8.frame1.frame21.label17.menu \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)"
  $topwin(enhan_name).info.frame2.frame8.frame1.frame21.label17.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -command {set enhan(slice_12) 0} \
    -label {0}
  $topwin(enhan_name).info.frame2.frame8.frame1.frame21.label17.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -command {set enhan(slice_12) 64} \
    -label {64}
  $topwin(enhan_name).info.frame2.frame8.frame1.frame21.label17.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -command {set enhan(slice_12) 128} \
    -label {128}
  $topwin(enhan_name).info.frame2.frame8.frame1.frame21.label17.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -command {set enhan(slice_12) 192} \
    -label {192}
  $topwin(enhan_name).info.frame2.frame8.frame1.frame21.label17.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -command {set enhan(slice_12) 255} \
    -label {255}
  # bindings
  bind $topwin(enhan_name).info.frame2.frame8.frame1.frame21.label17.menu <B1-Motion> {MenuPopupMotion $topwin(enhan_name).info.frame2.frame8.frame1.frame21.label17.menu %W %X %Y}
  bind $topwin(enhan_name).info.frame2.frame8.frame1.frame21.label17.menu <ButtonRelease-1> {MenuPopupRelease $topwin(enhan_name).info.frame2.frame8.frame1.frame21.label17.menu %W}

  # pack widget $topwin(enhan_name).info.frame2.frame8.frame1.frame21
  pack append $topwin(enhan_name).info.frame2.frame8.frame1.frame21 \
    $topwin(enhan_name).info.frame2.frame8.frame1.frame21.label15 {left frame center} \
    $topwin(enhan_name).info.frame2.frame8.frame1.frame21.entry16 {left frame center} \
    $topwin(enhan_name).info.frame2.frame8.frame1.frame21.label17 {left frame center}

  # build widget $topwin(enhan_name).info.frame2.frame8.frame1.frame22
  frame $topwin(enhan_name).info.frame2.frame8.frame1.frame22 \
    -background "$GuiColor(frame_bg)" \
    -borderwidth {2}

  # build widget $topwin(enhan_name).info.frame2.frame8.frame1.frame22.label15
  label $topwin(enhan_name).info.frame2.frame8.frame1.frame22.label15 \
    -background {#00dd00} \
    -foreground {white} \
    -text {G:}

  # build widget $topwin(enhan_name).info.frame2.frame8.frame1.frame22.entry16
  entry $topwin(enhan_name).info.frame2.frame8.frame1.frame22.entry16 \
    -background "$GuiColor(entry_bg)" \
	 -foreground "$GuiColor(entry_fg)" \
    -relief {sunken} \
    -textvariable {enhan(slice_13)} \
    -width {5}
  endEntry $topwin(enhan_name).info.frame2.frame8.frame1.frame22.entry16 0\
    $topwin(enhan_name).info.frame2.frame8.frame1.frame23.entry16 \
    $topwin(enhan_name).info.frame2.frame8.frame1.frame21.entry16 

  # build widget $topwin(enhan_name).info.frame2.frame8.frame1.frame22.label17
  menubutton $topwin(enhan_name).info.frame2.frame8.frame1.frame22.label17 \
    -activebackground "$GuiColor(btn_act_bg)"  \
    -background "$GuiColor(btn_bg)" \
    -font "$GuiMisc(pop_up_fn)" \
	 -text "$GuiMisc(pop_up_text)" \
	 -relief "$GuiMisc(pop_up_relief)" \
    -width {1}
  # bindings
  bind $topwin(enhan_name).info.frame2.frame8.frame1.frame22.label17 <Button-1> {MenuPopupPost $topwin(enhan_name).info.frame2.frame8.frame1.frame22.label17.menu %X %Y}
  bind $topwin(enhan_name).info.frame2.frame8.frame1.frame22.label17 <ButtonRelease-1> {MenuPopupRelease $topwin(enhan_name).info.frame2.frame8.frame1.frame22.label17.menu %W}

  # build widget $topwin(enhan_name).info.frame2.frame8.frame1.frame22.label17.menu
  menu $topwin(enhan_name).info.frame2.frame8.frame1.frame22.label17.menu \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)"
  $topwin(enhan_name).info.frame2.frame8.frame1.frame22.label17.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -command {set enhan(slice_13) 0} \
    -label {0}
  $topwin(enhan_name).info.frame2.frame8.frame1.frame22.label17.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -command {set enhan(slice_13) 64} \
    -label {64}
  $topwin(enhan_name).info.frame2.frame8.frame1.frame22.label17.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -command {set enhan(slice_13) 128} \
    -label {128}
  $topwin(enhan_name).info.frame2.frame8.frame1.frame22.label17.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -command {set enhan(slice_13) 192} \
    -label {192}
  $topwin(enhan_name).info.frame2.frame8.frame1.frame22.label17.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -command {set enhan(slice_13) 255} \
    -label {255}
  # bindings
  bind $topwin(enhan_name).info.frame2.frame8.frame1.frame22.label17.menu <B1-Motion> {MenuPopupMotion $topwin(enhan_name).info.frame2.frame8.frame1.frame22.label17.menu %W %X %Y}
  bind $topwin(enhan_name).info.frame2.frame8.frame1.frame22.label17.menu <ButtonRelease-1> {MenuPopupRelease $topwin(enhan_name).info.frame2.frame8.frame1.frame22.label17.menu %W}

  # pack widget $topwin(enhan_name).info.frame2.frame8.frame1.frame22
  pack append $topwin(enhan_name).info.frame2.frame8.frame1.frame22 \
    $topwin(enhan_name).info.frame2.frame8.frame1.frame22.label15 {left frame center} \
    $topwin(enhan_name).info.frame2.frame8.frame1.frame22.entry16 {left frame center} \
    $topwin(enhan_name).info.frame2.frame8.frame1.frame22.label17 {left frame center}

  # build widget $topwin(enhan_name).info.frame2.frame8.frame1.frame23
  frame $topwin(enhan_name).info.frame2.frame8.frame1.frame23 \
    -background "$GuiColor(frame_bg)" \
    -borderwidth {2}

  # build widget $topwin(enhan_name).info.frame2.frame8.frame1.frame23.label15
  label $topwin(enhan_name).info.frame2.frame8.frame1.frame23.label15 \
    -background {blue} \
    -foreground {white} \
    -text {B:}

  # build widget $topwin(enhan_name).info.frame2.frame8.frame1.frame23.entry16
  entry $topwin(enhan_name).info.frame2.frame8.frame1.frame23.entry16 \
    -background "$GuiColor(entry_bg)" \
	 -foreground "$GuiColor(entry_fg)" \
    -relief {sunken} \
    -textvariable {enhan(slice_14)} \
    -width {5}
  endEntry $topwin(enhan_name).info.frame2.frame8.frame1.frame23.entry16 0\
    $topwin(enhan_name).info.frame2.frame8.frame1.frame18.entry16 \
    $topwin(enhan_name).info.frame2.frame8.frame1.frame22.entry16 

  # build widget $topwin(enhan_name).info.frame2.frame8.frame1.frame23.label17
  menubutton $topwin(enhan_name).info.frame2.frame8.frame1.frame23.label17 \
    -activebackground "$GuiColor(btn_act_bg)"  \
    -background "$GuiColor(btn_bg)" \
    -font "$GuiMisc(pop_up_fn)" \
	 -text "$GuiMisc(pop_up_text)" \
	 -relief "$GuiMisc(pop_up_relief)" \
    -width {1}
  # bindings
  bind $topwin(enhan_name).info.frame2.frame8.frame1.frame23.label17 <Button-1> {MenuPopupPost $topwin(enhan_name).info.frame2.frame8.frame1.frame23.label17.menu %X %Y}
  bind $topwin(enhan_name).info.frame2.frame8.frame1.frame23.label17 <ButtonRelease-1> {MenuPopupRelease $topwin(enhan_name).info.frame2.frame8.frame1.frame23.label17.menu %W}

  # build widget $topwin(enhan_name).info.frame2.frame8.frame1.frame23.label17.menu
  menu $topwin(enhan_name).info.frame2.frame8.frame1.frame23.label17.menu \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)"
  $topwin(enhan_name).info.frame2.frame8.frame1.frame23.label17.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -command {set enhan(slice_14) 0} \
    -label {0}
  $topwin(enhan_name).info.frame2.frame8.frame1.frame23.label17.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -command {set enhan(slice_14) 64} \
    -label {64}
  $topwin(enhan_name).info.frame2.frame8.frame1.frame23.label17.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -command {set enhan(slice_14) 128} \
    -label {128}
  $topwin(enhan_name).info.frame2.frame8.frame1.frame23.label17.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -command {set enhan(slice_14) 192} \
    -label {192}
  $topwin(enhan_name).info.frame2.frame8.frame1.frame23.label17.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -command {set enhan(slice_14) 255} \
    -label {255}
  # bindings
  bind $topwin(enhan_name).info.frame2.frame8.frame1.frame23.label17.menu <B1-Motion> {MenuPopupMotion $topwin(enhan_name).info.frame2.frame8.frame1.frame23.label17.menu %W %X %Y}
  bind $topwin(enhan_name).info.frame2.frame8.frame1.frame23.label17.menu <ButtonRelease-1> {MenuPopupRelease $topwin(enhan_name).info.frame2.frame8.frame1.frame23.label17.menu %W}

  # pack widget $topwin(enhan_name).info.frame2.frame8.frame1.frame23
  pack append $topwin(enhan_name).info.frame2.frame8.frame1.frame23 \
    $topwin(enhan_name).info.frame2.frame8.frame1.frame23.label15 {left frame center} \
    $topwin(enhan_name).info.frame2.frame8.frame1.frame23.entry16 {left frame center} \
    $topwin(enhan_name).info.frame2.frame8.frame1.frame23.label17 {left frame center}

  # pack widget $topwin(enhan_name).info.frame2.frame8.frame1
  pack append $topwin(enhan_name).info.frame2.frame8.frame1 \
    $topwin(enhan_name).info.frame2.frame8.frame1.frame18 {left frame center} \
    $topwin(enhan_name).info.frame2.frame8.frame1.frame19 {left frame center} \
    $topwin(enhan_name).info.frame2.frame8.frame1.label20 {left frame center} \
    $topwin(enhan_name).info.frame2.frame8.frame1.frame21 {left frame center} \
    $topwin(enhan_name).info.frame2.frame8.frame1.frame22 {left frame center} \
    $topwin(enhan_name).info.frame2.frame8.frame1.frame23 {left frame center}

  # build widget $topwin(enhan_name).info.frame2.frame8.frame24
  frame $topwin(enhan_name).info.frame2.frame8.frame24 \
    -background "$GuiColor(frame_bg)" \
    -borderwidth {2}

  # build widget $topwin(enhan_name).info.frame2.frame8.frame24.frame18
  frame $topwin(enhan_name).info.frame2.frame8.frame24.frame18 \
    -background "$GuiColor(frame_bg)" \
    -borderwidth {2}

  # build widget $topwin(enhan_name).info.frame2.frame8.frame24.frame18.label15
  label $topwin(enhan_name).info.frame2.frame8.frame24.frame18.label15 \
    -background "$GuiColor(label_bg)" \
    -text {From:}

  # build widget $topwin(enhan_name).info.frame2.frame8.frame24.frame18.entry16
  entry $topwin(enhan_name).info.frame2.frame8.frame24.frame18.entry16 \
    -background "$GuiColor(entry_bg)" \
	 -foreground "$GuiColor(entry_fg)" \
    -relief {sunken} \
    -textvariable {enhan(slice_20)} \
    -width {5}
  endEntry  $topwin(enhan_name).info.frame2.frame8.frame24.frame18.entry16 0\
     $topwin(enhan_name).info.frame2.frame8.frame24.frame19.entry16 \
     $topwin(enhan_name).info.frame2.frame8.frame24.frame23.entry16 

  # build widget $topwin(enhan_name).info.frame2.frame8.frame24.frame18.label17
  menubutton $topwin(enhan_name).info.frame2.frame8.frame24.frame18.label17 \
    -activebackground "$GuiColor(btn_act_bg)"  \
    -background "$GuiColor(btn_bg)" \
    -font "$GuiMisc(pop_up_fn)" \
	 -text "$GuiMisc(pop_up_text)" \
	 -relief "$GuiMisc(pop_up_relief)" \
    -width {1}
  # bindings
  bind $topwin(enhan_name).info.frame2.frame8.frame24.frame18.label17 <Button-1> {MenuPopupPost $topwin(enhan_name).info.frame2.frame8.frame24.frame18.label17.menu %X %Y}
  bind $topwin(enhan_name).info.frame2.frame8.frame24.frame18.label17 <ButtonRelease-1> {MenuPopupRelease $topwin(enhan_name).info.frame2.frame8.frame24.frame18.label17.menu %W}

  # build widget $topwin(enhan_name).info.frame2.frame8.frame24.frame18.label17.menu
  menu $topwin(enhan_name).info.frame2.frame8.frame24.frame18.label17.menu \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)"
  $topwin(enhan_name).info.frame2.frame8.frame24.frame18.label17.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -command {set enhan(slice_20) 0} \
    -label {0}
  $topwin(enhan_name).info.frame2.frame8.frame24.frame18.label17.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -command {set enhan(slice_20) 64} \
    -label {64}
  $topwin(enhan_name).info.frame2.frame8.frame24.frame18.label17.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -command {set enhan(slice_20) 85} \
    -label {85}
  $topwin(enhan_name).info.frame2.frame8.frame24.frame18.label17.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -command {set enhan(slice_20) 128} \
    -label {128}
  $topwin(enhan_name).info.frame2.frame8.frame24.frame18.label17.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -command {set enhan(slice_20) 170} \
    -label {170}
  $topwin(enhan_name).info.frame2.frame8.frame24.frame18.label17.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -command {set enhan(slice_20) 192} \
    -label {192}
  # bindings
  bind $topwin(enhan_name).info.frame2.frame8.frame24.frame18.label17.menu <B1-Motion> {MenuPopupMotion $topwin(enhan_name).info.frame2.frame8.frame24.frame18.label17.menu %W %X %Y}
  bind $topwin(enhan_name).info.frame2.frame8.frame24.frame18.label17.menu <ButtonRelease-1> {MenuPopupRelease $topwin(enhan_name).info.frame2.frame8.frame24.frame18.label17.menu %W}

  # pack widget $topwin(enhan_name).info.frame2.frame8.frame24.frame18
  pack append $topwin(enhan_name).info.frame2.frame8.frame24.frame18 \
    $topwin(enhan_name).info.frame2.frame8.frame24.frame18.label15 {left frame center} \
    $topwin(enhan_name).info.frame2.frame8.frame24.frame18.entry16 {left frame center} \
    $topwin(enhan_name).info.frame2.frame8.frame24.frame18.label17 {left frame center}

  # build widget $topwin(enhan_name).info.frame2.frame8.frame24.frame19
  frame $topwin(enhan_name).info.frame2.frame8.frame24.frame19 \
    -background "$GuiColor(frame_bg)" \
    -borderwidth {2}

  # build widget $topwin(enhan_name).info.frame2.frame8.frame24.frame19.label15
  label $topwin(enhan_name).info.frame2.frame8.frame24.frame19.label15 \
    -background "$GuiColor(label_bg)" \
    -text {To:}

  # build widget $topwin(enhan_name).info.frame2.frame8.frame24.frame19.entry16
  entry $topwin(enhan_name).info.frame2.frame8.frame24.frame19.entry16 \
    -background "$GuiColor(entry_bg)" \
	 -foreground "$GuiColor(entry_fg)" \
    -relief {sunken} \
    -textvariable {enhan(slice_21)} \
    -width {5}
  endEntry  $topwin(enhan_name).info.frame2.frame8.frame24.frame19.entry16 0\
     $topwin(enhan_name).info.frame2.frame8.frame24.frame21.entry16 \
     $topwin(enhan_name).info.frame2.frame8.frame24.frame18.entry16 

  # build widget $topwin(enhan_name).info.frame2.frame8.frame24.frame19.label17
  menubutton $topwin(enhan_name).info.frame2.frame8.frame24.frame19.label17 \
    -activebackground "$GuiColor(btn_act_bg)"  \
    -background "$GuiColor(btn_bg)" \
    -font "$GuiMisc(pop_up_fn)" \
	 -text "$GuiMisc(pop_up_text)" \
	 -relief "$GuiMisc(pop_up_relief)" \
    -width {1}
  # bindings
  bind $topwin(enhan_name).info.frame2.frame8.frame24.frame19.label17 <Button-1> {MenuPopupPost $topwin(enhan_name).info.frame2.frame8.frame24.frame19.label17.menu %X %Y}
  bind $topwin(enhan_name).info.frame2.frame8.frame24.frame19.label17 <ButtonRelease-1> {MenuPopupRelease $topwin(enhan_name).info.frame2.frame8.frame24.frame19.label17.menu %W}

  # build widget $topwin(enhan_name).info.frame2.frame8.frame24.frame19.label17.menu
  menu $topwin(enhan_name).info.frame2.frame8.frame24.frame19.label17.menu \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)"
  $topwin(enhan_name).info.frame2.frame8.frame24.frame19.label17.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -command {set enhan(slice_21) 63} \
    -label {63}
  $topwin(enhan_name).info.frame2.frame8.frame24.frame19.label17.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -command {set enhan(slice_21) 84} \
    -label {84}
  $topwin(enhan_name).info.frame2.frame8.frame24.frame19.label17.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -command {set enhan(slice_21) 127} \
    -label {127}
  $topwin(enhan_name).info.frame2.frame8.frame24.frame19.label17.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -command {set enhan(slice_21) 169} \
    -label {169}
  $topwin(enhan_name).info.frame2.frame8.frame24.frame19.label17.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -command {set enhan(slice_21) 191} \
    -label {191}
  $topwin(enhan_name).info.frame2.frame8.frame24.frame19.label17.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -command {set enhan(slice_21) 255} \
    -label {255}
  # bindings
  bind $topwin(enhan_name).info.frame2.frame8.frame24.frame19.label17.menu <B1-Motion> {MenuPopupMotion $topwin(enhan_name).info.frame2.frame8.frame24.frame19.label17.menu %W %X %Y}
  bind $topwin(enhan_name).info.frame2.frame8.frame24.frame19.label17.menu <ButtonRelease-1> {MenuPopupRelease $topwin(enhan_name).info.frame2.frame8.frame24.frame19.label17.menu %W}

  # pack widget $topwin(enhan_name).info.frame2.frame8.frame24.frame19
  pack append $topwin(enhan_name).info.frame2.frame8.frame24.frame19 \
    $topwin(enhan_name).info.frame2.frame8.frame24.frame19.label15 {left frame center} \
    $topwin(enhan_name).info.frame2.frame8.frame24.frame19.entry16 {left frame center} \
    $topwin(enhan_name).info.frame2.frame8.frame24.frame19.label17 {left frame center}

  # build widget $topwin(enhan_name).info.frame2.frame8.frame24.label20
  label $topwin(enhan_name).info.frame2.frame8.frame24.label20 \
    -background "$GuiColor(label_bg)" \
    -text {  ===>    }

  # build widget $topwin(enhan_name).info.frame2.frame8.frame24.frame21
  frame $topwin(enhan_name).info.frame2.frame8.frame24.frame21 \
    -background "$GuiColor(frame_bg)" \
    -borderwidth {2}

  # build widget $topwin(enhan_name).info.frame2.frame8.frame24.frame21.label15
  label $topwin(enhan_name).info.frame2.frame8.frame24.frame21.label15 \
    -background {red} \
    -foreground {white} \
    -text {R:}

  # build widget $topwin(enhan_name).info.frame2.frame8.frame24.frame21.entry16
  entry $topwin(enhan_name).info.frame2.frame8.frame24.frame21.entry16 \
    -background "$GuiColor(entry_bg)" \
	 -foreground "$GuiColor(entry_fg)" \
    -relief {sunken} \
    -textvariable {enhan(slice_22)} \
    -width {5}
  endEntry  $topwin(enhan_name).info.frame2.frame8.frame24.frame21.entry16 0\
     $topwin(enhan_name).info.frame2.frame8.frame24.frame22.entry16 \
     $topwin(enhan_name).info.frame2.frame8.frame24.frame19.entry16 

  # build widget $topwin(enhan_name).info.frame2.frame8.frame24.frame21.label17
  menubutton $topwin(enhan_name).info.frame2.frame8.frame24.frame21.label17 \
    -activebackground "$GuiColor(btn_act_bg)"  \
    -background "$GuiColor(btn_bg)" \
    -font "$GuiMisc(pop_up_fn)" \
	 -text "$GuiMisc(pop_up_text)" \
	 -relief "$GuiMisc(pop_up_relief)" \
    -width {1}
  # bindings
  bind $topwin(enhan_name).info.frame2.frame8.frame24.frame21.label17 <Button-1> {MenuPopupPost $topwin(enhan_name).info.frame2.frame8.frame24.frame21.label17.menu %X %Y}
  bind $topwin(enhan_name).info.frame2.frame8.frame24.frame21.label17 <ButtonRelease-1> {MenuPopupRelease $topwin(enhan_name).info.frame2.frame8.frame24.frame21.label17.menu %W}

  # build widget $topwin(enhan_name).info.frame2.frame8.frame24.frame21.label17.menu
  menu $topwin(enhan_name).info.frame2.frame8.frame24.frame21.label17.menu \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)"
  $topwin(enhan_name).info.frame2.frame8.frame24.frame21.label17.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -command {set enhan(slice_22) 0} \
    -label {0}
  $topwin(enhan_name).info.frame2.frame8.frame24.frame21.label17.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -command {set enhan(slice_22) 64} \
    -label {64}
  $topwin(enhan_name).info.frame2.frame8.frame24.frame21.label17.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -command {set enhan(slice_22) 128} \
    -label {128}
  $topwin(enhan_name).info.frame2.frame8.frame24.frame21.label17.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -command {set enhan(slice_22) 192} \
    -label {192}
  $topwin(enhan_name).info.frame2.frame8.frame24.frame21.label17.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -command {set enhan(slice_22) 255} \
    -label {255}
  # bindings
  bind $topwin(enhan_name).info.frame2.frame8.frame24.frame21.label17.menu <B1-Motion> {MenuPopupMotion $topwin(enhan_name).info.frame2.frame8.frame24.frame21.label17.menu %W %X %Y}
  bind $topwin(enhan_name).info.frame2.frame8.frame24.frame21.label17.menu <ButtonRelease-1> {MenuPopupRelease $topwin(enhan_name).info.frame2.frame8.frame24.frame21.label17.menu %W}

  # pack widget $topwin(enhan_name).info.frame2.frame8.frame24.frame21
  pack append $topwin(enhan_name).info.frame2.frame8.frame24.frame21 \
    $topwin(enhan_name).info.frame2.frame8.frame24.frame21.label15 {left frame center} \
    $topwin(enhan_name).info.frame2.frame8.frame24.frame21.entry16 {left frame center} \
    $topwin(enhan_name).info.frame2.frame8.frame24.frame21.label17 {left frame center}

  # build widget $topwin(enhan_name).info.frame2.frame8.frame24.frame22
  frame $topwin(enhan_name).info.frame2.frame8.frame24.frame22 \
    -background "$GuiColor(frame_bg)" \
    -borderwidth {2}

  # build widget $topwin(enhan_name).info.frame2.frame8.frame24.frame22.label15
  label $topwin(enhan_name).info.frame2.frame8.frame24.frame22.label15 \
    -background {#00dd00} \
    -foreground {white} \
    -text {G:}

  # build widget $topwin(enhan_name).info.frame2.frame8.frame24.frame22.entry16
  entry $topwin(enhan_name).info.frame2.frame8.frame24.frame22.entry16 \
    -background "$GuiColor(entry_bg)" \
	 -foreground "$GuiColor(entry_fg)" \
    -relief {sunken} \
    -textvariable {enhan(slice_23)} \
    -width {5}
  endEntry  $topwin(enhan_name).info.frame2.frame8.frame24.frame22.entry16 0\
     $topwin(enhan_name).info.frame2.frame8.frame24.frame23.entry16 \
     $topwin(enhan_name).info.frame2.frame8.frame24.frame21.entry16 

  # build widget $topwin(enhan_name).info.frame2.frame8.frame24.frame22.label17
  menubutton $topwin(enhan_name).info.frame2.frame8.frame24.frame22.label17 \
    -activebackground "$GuiColor(btn_act_bg)"  \
    -background "$GuiColor(btn_bg)" \
    -font "$GuiMisc(pop_up_fn)" \
	 -text "$GuiMisc(pop_up_text)" \
	 -relief "$GuiMisc(pop_up_relief)" \
    -width {1}
  # bindings
  bind $topwin(enhan_name).info.frame2.frame8.frame24.frame22.label17 <Button-1> {MenuPopupPost $topwin(enhan_name).info.frame2.frame8.frame24.frame22.label17.menu %X %Y}
  bind $topwin(enhan_name).info.frame2.frame8.frame24.frame22.label17 <ButtonRelease-1> {MenuPopupRelease $topwin(enhan_name).info.frame2.frame8.frame24.frame22.label17.menu %W}

  # build widget $topwin(enhan_name).info.frame2.frame8.frame24.frame22.label17.menu
  menu $topwin(enhan_name).info.frame2.frame8.frame24.frame22.label17.menu \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)"
  $topwin(enhan_name).info.frame2.frame8.frame24.frame22.label17.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -command {set enhan(slice_23) 0} \
    -label {0}
  $topwin(enhan_name).info.frame2.frame8.frame24.frame22.label17.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -command {set enhan(slice_23) 64} \
    -label {64}
  $topwin(enhan_name).info.frame2.frame8.frame24.frame22.label17.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -command {set enhan(slice_23) 128} \
    -label {128}
  $topwin(enhan_name).info.frame2.frame8.frame24.frame22.label17.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -command {set enhan(slice_23) 192} \
    -label {192}
  $topwin(enhan_name).info.frame2.frame8.frame24.frame22.label17.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -command {set enhan(slice_23) 255} \
    -label {255}
  # bindings
  bind $topwin(enhan_name).info.frame2.frame8.frame24.frame22.label17.menu <B1-Motion> {MenuPopupMotion $topwin(enhan_name).info.frame2.frame8.frame24.frame22.label17.menu %W %X %Y}
  bind $topwin(enhan_name).info.frame2.frame8.frame24.frame22.label17.menu <ButtonRelease-1> {MenuPopupRelease $topwin(enhan_name).info.frame2.frame8.frame24.frame22.label17.menu %W}

  # pack widget $topwin(enhan_name).info.frame2.frame8.frame24.frame22
  pack append $topwin(enhan_name).info.frame2.frame8.frame24.frame22 \
    $topwin(enhan_name).info.frame2.frame8.frame24.frame22.label15 {left frame center} \
    $topwin(enhan_name).info.frame2.frame8.frame24.frame22.entry16 {left frame center} \
    $topwin(enhan_name).info.frame2.frame8.frame24.frame22.label17 {left frame center}

  # build widget $topwin(enhan_name).info.frame2.frame8.frame24.frame23
  frame $topwin(enhan_name).info.frame2.frame8.frame24.frame23 \
    -background "$GuiColor(frame_bg)" \
    -borderwidth {2}

  # build widget $topwin(enhan_name).info.frame2.frame8.frame24.frame23.label15
  label $topwin(enhan_name).info.frame2.frame8.frame24.frame23.label15 \
    -background {blue} \
    -foreground {white} \
    -text {B:}

  # build widget $topwin(enhan_name).info.frame2.frame8.frame24.frame23.entry16
  entry $topwin(enhan_name).info.frame2.frame8.frame24.frame23.entry16 \
    -background "$GuiColor(entry_bg)" \
	 -foreground "$GuiColor(entry_fg)" \
    -relief {sunken} \
    -textvariable {enhan(slice_24)} \
    -width {5}
  endEntry  $topwin(enhan_name).info.frame2.frame8.frame24.frame23.entry16 0\
     $topwin(enhan_name).info.frame2.frame8.frame24.frame18.entry16 \
     $topwin(enhan_name).info.frame2.frame8.frame24.frame22.entry16 

  # build widget $topwin(enhan_name).info.frame2.frame8.frame24.frame23.label17
  menubutton $topwin(enhan_name).info.frame2.frame8.frame24.frame23.label17 \
    -activebackground "$GuiColor(btn_act_bg)"  \
    -background "$GuiColor(btn_bg)" \
    -font "$GuiMisc(pop_up_fn)" \
	 -text "$GuiMisc(pop_up_text)" \
	 -relief "$GuiMisc(pop_up_relief)" \
    -width {1}
  # bindings
  bind $topwin(enhan_name).info.frame2.frame8.frame24.frame23.label17 <Button-1> {MenuPopupPost $topwin(enhan_name).info.frame2.frame8.frame24.frame23.label17.menu %X %Y}
  bind $topwin(enhan_name).info.frame2.frame8.frame24.frame23.label17 <ButtonRelease-1> {MenuPopupRelease $topwin(enhan_name).info.frame2.frame8.frame24.frame23.label17.menu %W}

  # build widget $topwin(enhan_name).info.frame2.frame8.frame24.frame23.label17.menu
  menu $topwin(enhan_name).info.frame2.frame8.frame24.frame23.label17.menu \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)"
  $topwin(enhan_name).info.frame2.frame8.frame24.frame23.label17.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -command {set enhan(slice_24) 0} \
    -label {0}
  $topwin(enhan_name).info.frame2.frame8.frame24.frame23.label17.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -command {set enhan(slice_24) 64} \
    -label {64}
  $topwin(enhan_name).info.frame2.frame8.frame24.frame23.label17.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -command {set enhan(slice_24) 128} \
    -label {128}
  $topwin(enhan_name).info.frame2.frame8.frame24.frame23.label17.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -command {set enhan(slice_24) 192} \
    -label {192}
  $topwin(enhan_name).info.frame2.frame8.frame24.frame23.label17.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -command {set enhan(slice_24) 255} \
    -label {255}
  # bindings
  bind $topwin(enhan_name).info.frame2.frame8.frame24.frame23.label17.menu <B1-Motion> {MenuPopupMotion $topwin(enhan_name).info.frame2.frame8.frame24.frame23.label17.menu %W %X %Y}
  bind $topwin(enhan_name).info.frame2.frame8.frame24.frame23.label17.menu <ButtonRelease-1> {MenuPopupRelease $topwin(enhan_name).info.frame2.frame8.frame24.frame23.label17.menu %W}

  # pack widget $topwin(enhan_name).info.frame2.frame8.frame24.frame23
  pack append $topwin(enhan_name).info.frame2.frame8.frame24.frame23 \
    $topwin(enhan_name).info.frame2.frame8.frame24.frame23.label15 {left frame center} \
    $topwin(enhan_name).info.frame2.frame8.frame24.frame23.entry16 {left frame center} \
    $topwin(enhan_name).info.frame2.frame8.frame24.frame23.label17 {left frame center}

  # pack widget $topwin(enhan_name).info.frame2.frame8.frame24
  pack append $topwin(enhan_name).info.frame2.frame8.frame24 \
    $topwin(enhan_name).info.frame2.frame8.frame24.frame18 {left frame center} \
    $topwin(enhan_name).info.frame2.frame8.frame24.frame19 {left frame center} \
    $topwin(enhan_name).info.frame2.frame8.frame24.label20 {left frame center} \
    $topwin(enhan_name).info.frame2.frame8.frame24.frame21 {left frame center} \
    $topwin(enhan_name).info.frame2.frame8.frame24.frame22 {left frame center} \
    $topwin(enhan_name).info.frame2.frame8.frame24.frame23 {left frame center}

  # build widget $topwin(enhan_name).info.frame2.frame8.frame25
  frame $topwin(enhan_name).info.frame2.frame8.frame25 \
    -background "$GuiColor(frame_bg)" \
    -borderwidth {2}

  # build widget $topwin(enhan_name).info.frame2.frame8.frame25.frame18
  frame $topwin(enhan_name).info.frame2.frame8.frame25.frame18 \
    -background "$GuiColor(frame_bg)" \
    -borderwidth {2}

  # build widget $topwin(enhan_name).info.frame2.frame8.frame25.frame18.label15
  label $topwin(enhan_name).info.frame2.frame8.frame25.frame18.label15 \
    -background "$GuiColor(label_bg)" \
    -text {From:}

  # build widget $topwin(enhan_name).info.frame2.frame8.frame25.frame18.entry16
  entry $topwin(enhan_name).info.frame2.frame8.frame25.frame18.entry16 \
    -background "$GuiColor(entry_bg)" \
	 -foreground "$GuiColor(entry_fg)" \
    -relief {sunken} \
    -textvariable {enhan(slice_30)} \
    -width {5}
  endEntry  $topwin(enhan_name).info.frame2.frame8.frame25.frame18.entry16 0\
     $topwin(enhan_name).info.frame2.frame8.frame25.frame19.entry16 \
     $topwin(enhan_name).info.frame2.frame8.frame25.frame23.entry16 

  # build widget $topwin(enhan_name).info.frame2.frame8.frame25.frame18.label17
  menubutton $topwin(enhan_name).info.frame2.frame8.frame25.frame18.label17 \
    -activebackground "$GuiColor(btn_act_bg)"  \
    -background "$GuiColor(btn_bg)" \
    -font "$GuiMisc(pop_up_fn)" \
	 -text "$GuiMisc(pop_up_text)" \
	 -relief "$GuiMisc(pop_up_relief)" \
    -width {1}
  # bindings
  bind $topwin(enhan_name).info.frame2.frame8.frame25.frame18.label17 <Button-1> {MenuPopupPost $topwin(enhan_name).info.frame2.frame8.frame25.frame18.label17.menu %X %Y}
  bind $topwin(enhan_name).info.frame2.frame8.frame25.frame18.label17 <ButtonRelease-1> {MenuPopupRelease $topwin(enhan_name).info.frame2.frame8.frame25.frame18.label17.menu %W}

  # build widget $topwin(enhan_name).info.frame2.frame8.frame25.frame18.label17.menu
  menu $topwin(enhan_name).info.frame2.frame8.frame25.frame18.label17.menu \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)"
  $topwin(enhan_name).info.frame2.frame8.frame25.frame18.label17.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -command {set enhan(slice_30) 0} \
    -label {0}
  $topwin(enhan_name).info.frame2.frame8.frame25.frame18.label17.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -command {set enhan(slice_30) 64} \
    -label {64}
  $topwin(enhan_name).info.frame2.frame8.frame25.frame18.label17.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -command {set enhan(slice_30) 85} \
    -label {85}
  $topwin(enhan_name).info.frame2.frame8.frame25.frame18.label17.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -command {set enhan(slice_30) 128} \
    -label {128}
  $topwin(enhan_name).info.frame2.frame8.frame25.frame18.label17.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -command {set enhan(slice_30) 170} \
    -label {170}
  $topwin(enhan_name).info.frame2.frame8.frame25.frame18.label17.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -command {set enhan(slice_30) 192} \
    -label {192}
  # bindings
  bind $topwin(enhan_name).info.frame2.frame8.frame25.frame18.label17.menu <B1-Motion> {MenuPopupMotion $topwin(enhan_name).info.frame2.frame8.frame25.frame18.label17.menu %W %X %Y}
  bind $topwin(enhan_name).info.frame2.frame8.frame25.frame18.label17.menu <ButtonRelease-1> {MenuPopupRelease $topwin(enhan_name).info.frame2.frame8.frame25.frame18.label17.menu %W}

  # pack widget $topwin(enhan_name).info.frame2.frame8.frame25.frame18
  pack append $topwin(enhan_name).info.frame2.frame8.frame25.frame18 \
    $topwin(enhan_name).info.frame2.frame8.frame25.frame18.label15 {left frame center} \
    $topwin(enhan_name).info.frame2.frame8.frame25.frame18.entry16 {left frame center} \
    $topwin(enhan_name).info.frame2.frame8.frame25.frame18.label17 {left frame center}

  # build widget $topwin(enhan_name).info.frame2.frame8.frame25.frame19
  frame $topwin(enhan_name).info.frame2.frame8.frame25.frame19 \
    -background "$GuiColor(frame_bg)" \
    -borderwidth {2}

  # build widget $topwin(enhan_name).info.frame2.frame8.frame25.frame19.label15
  label $topwin(enhan_name).info.frame2.frame8.frame25.frame19.label15 \
    -background "$GuiColor(label_bg)" \
    -text {To:}

  # build widget $topwin(enhan_name).info.frame2.frame8.frame25.frame19.entry16
  entry $topwin(enhan_name).info.frame2.frame8.frame25.frame19.entry16 \
    -background "$GuiColor(entry_bg)" \
	 -foreground "$GuiColor(entry_fg)" \
    -relief {sunken} \
    -textvariable {enhan(slice_31)} \
    -width {5}
  endEntry  $topwin(enhan_name).info.frame2.frame8.frame25.frame19.entry16 0\
     $topwin(enhan_name).info.frame2.frame8.frame25.frame21.entry16 \
     $topwin(enhan_name).info.frame2.frame8.frame25.frame18.entry16 

  # build widget $topwin(enhan_name).info.frame2.frame8.frame25.frame19.label17
  menubutton $topwin(enhan_name).info.frame2.frame8.frame25.frame19.label17 \
    -activebackground "$GuiColor(btn_act_bg)"  \
    -background "$GuiColor(btn_bg)" \
    -font "$GuiMisc(pop_up_fn)" \
	 -text "$GuiMisc(pop_up_text)" \
	 -relief "$GuiMisc(pop_up_relief)" \
    -width {1}
  # bindings
  bind $topwin(enhan_name).info.frame2.frame8.frame25.frame19.label17 <Button-1> {MenuPopupPost $topwin(enhan_name).info.frame2.frame8.frame25.frame19.label17.menu %X %Y}
  bind $topwin(enhan_name).info.frame2.frame8.frame25.frame19.label17 <ButtonRelease-1> {MenuPopupRelease $topwin(enhan_name).info.frame2.frame8.frame25.frame19.label17.menu %W}

  # build widget $topwin(enhan_name).info.frame2.frame8.frame25.frame19.label17.menu
  menu $topwin(enhan_name).info.frame2.frame8.frame25.frame19.label17.menu \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)"
  $topwin(enhan_name).info.frame2.frame8.frame25.frame19.label17.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -command {set enhan(slice_31) 63} \
    -label {63}
  $topwin(enhan_name).info.frame2.frame8.frame25.frame19.label17.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -command {set enhan(slice_31) 84} \
    -label {84}
  $topwin(enhan_name).info.frame2.frame8.frame25.frame19.label17.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -command {set enhan(slice_31) 127} \
    -label {127}
  $topwin(enhan_name).info.frame2.frame8.frame25.frame19.label17.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -command {set enhan(slice_31) 169} \
    -label {169}
  $topwin(enhan_name).info.frame2.frame8.frame25.frame19.label17.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -command {set enhan(slice_31) 191} \
    -label {191}
  $topwin(enhan_name).info.frame2.frame8.frame25.frame19.label17.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -command {set enhan(slice_31) 255} \
    -label {255}
  # bindings
  bind $topwin(enhan_name).info.frame2.frame8.frame25.frame19.label17.menu <B1-Motion> {MenuPopupMotion $topwin(enhan_name).info.frame2.frame8.frame25.frame19.label17.menu %W %X %Y}
  bind $topwin(enhan_name).info.frame2.frame8.frame25.frame19.label17.menu <ButtonRelease-1> {MenuPopupRelease $topwin(enhan_name).info.frame2.frame8.frame25.frame19.label17.menu %W}

  # pack widget $topwin(enhan_name).info.frame2.frame8.frame25.frame19
  pack append $topwin(enhan_name).info.frame2.frame8.frame25.frame19 \
    $topwin(enhan_name).info.frame2.frame8.frame25.frame19.label15 {left frame center} \
    $topwin(enhan_name).info.frame2.frame8.frame25.frame19.entry16 {left frame center} \
    $topwin(enhan_name).info.frame2.frame8.frame25.frame19.label17 {left frame center}

  # build widget $topwin(enhan_name).info.frame2.frame8.frame25.label20
  label $topwin(enhan_name).info.frame2.frame8.frame25.label20 \
    -background "$GuiColor(label_bg)" \
    -text {  ===>    }

  # build widget $topwin(enhan_name).info.frame2.frame8.frame25.frame21
  frame $topwin(enhan_name).info.frame2.frame8.frame25.frame21 \
    -background "$GuiColor(frame_bg)" \
    -borderwidth {2}

  # build widget $topwin(enhan_name).info.frame2.frame8.frame25.frame21.label15
  label $topwin(enhan_name).info.frame2.frame8.frame25.frame21.label15 \
    -background {red} \
    -foreground {white} \
    -text {R:}

  # build widget $topwin(enhan_name).info.frame2.frame8.frame25.frame21.entry16
  entry $topwin(enhan_name).info.frame2.frame8.frame25.frame21.entry16 \
    -background "$GuiColor(entry_bg)" \
	 -foreground "$GuiColor(entry_fg)" \
    -relief {sunken} \
    -textvariable {enhan(slice_32)} \
    -width {5}
  endEntry  $topwin(enhan_name).info.frame2.frame8.frame25.frame21.entry16 0\
     $topwin(enhan_name).info.frame2.frame8.frame25.frame22.entry16 \
     $topwin(enhan_name).info.frame2.frame8.frame25.frame19.entry16 

  # build widget $topwin(enhan_name).info.frame2.frame8.frame25.frame21.label17
  menubutton $topwin(enhan_name).info.frame2.frame8.frame25.frame21.label17 \
    -activebackground "$GuiColor(btn_act_bg)"  \
    -background "$GuiColor(btn_bg)" \
    -font "$GuiMisc(pop_up_fn)" \
	 -text "$GuiMisc(pop_up_text)" \
	 -relief "$GuiMisc(pop_up_relief)" \
    -width {1}
  # bindings
  bind $topwin(enhan_name).info.frame2.frame8.frame25.frame21.label17 <Button-1> {MenuPopupPost $topwin(enhan_name).info.frame2.frame8.frame25.frame21.label17.menu %X %Y}
  bind $topwin(enhan_name).info.frame2.frame8.frame25.frame21.label17 <ButtonRelease-1> {MenuPopupRelease $topwin(enhan_name).info.frame2.frame8.frame25.frame21.label17.menu %W}

  # build widget $topwin(enhan_name).info.frame2.frame8.frame25.frame21.label17.menu
  menu $topwin(enhan_name).info.frame2.frame8.frame25.frame21.label17.menu \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)"
  $topwin(enhan_name).info.frame2.frame8.frame25.frame21.label17.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -command {set enhan(slice_32) 0} \
    -label {0}
  $topwin(enhan_name).info.frame2.frame8.frame25.frame21.label17.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -command {set enhan(slice_32) 64} \
    -label {64}
  $topwin(enhan_name).info.frame2.frame8.frame25.frame21.label17.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -command {set enhan(slice_32) 128} \
    -label {128}
  $topwin(enhan_name).info.frame2.frame8.frame25.frame21.label17.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -command {set enhan(slice_32) 192} \
    -label {192}
  $topwin(enhan_name).info.frame2.frame8.frame25.frame21.label17.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -command {set enhan(slice_32) 255} \
    -label {255}
  # bindings
  bind $topwin(enhan_name).info.frame2.frame8.frame25.frame21.label17.menu <B1-Motion> {MenuPopupMotion $topwin(enhan_name).info.frame2.frame8.frame25.frame21.label17.menu %W %X %Y}
  bind $topwin(enhan_name).info.frame2.frame8.frame25.frame21.label17.menu <ButtonRelease-1> {MenuPopupRelease $topwin(enhan_name).info.frame2.frame8.frame25.frame21.label17.menu %W}

  # pack widget $topwin(enhan_name).info.frame2.frame8.frame25.frame21
  pack append $topwin(enhan_name).info.frame2.frame8.frame25.frame21 \
    $topwin(enhan_name).info.frame2.frame8.frame25.frame21.label15 {left frame center} \
    $topwin(enhan_name).info.frame2.frame8.frame25.frame21.entry16 {left frame center} \
    $topwin(enhan_name).info.frame2.frame8.frame25.frame21.label17 {left frame center}

  # build widget $topwin(enhan_name).info.frame2.frame8.frame25.frame22
  frame $topwin(enhan_name).info.frame2.frame8.frame25.frame22 \
    -background "$GuiColor(frame_bg)" \
    -borderwidth {2}

  # build widget $topwin(enhan_name).info.frame2.frame8.frame25.frame22.label15
  label $topwin(enhan_name).info.frame2.frame8.frame25.frame22.label15 \
    -background {#00dd00} \
    -foreground {white} \
    -text {G:}

  # build widget $topwin(enhan_name).info.frame2.frame8.frame25.frame22.entry16
  entry $topwin(enhan_name).info.frame2.frame8.frame25.frame22.entry16 \
    -background "$GuiColor(entry_bg)" \
	 -foreground "$GuiColor(entry_fg)" \
    -relief {sunken} \
    -textvariable {enhan(slice_33)} \
    -width {5}
  endEntry  $topwin(enhan_name).info.frame2.frame8.frame25.frame22.entry16 0\
     $topwin(enhan_name).info.frame2.frame8.frame25.frame23.entry16 \
     $topwin(enhan_name).info.frame2.frame8.frame25.frame21.entry16 

  # build widget $topwin(enhan_name).info.frame2.frame8.frame25.frame22.label17
  menubutton $topwin(enhan_name).info.frame2.frame8.frame25.frame22.label17 \
    -activebackground "$GuiColor(btn_act_bg)"  \
    -background "$GuiColor(btn_bg)" \
    -font "$GuiMisc(pop_up_fn)" \
	 -text "$GuiMisc(pop_up_text)" \
	 -relief "$GuiMisc(pop_up_relief)" \
    -width {1}
  # bindings
  bind $topwin(enhan_name).info.frame2.frame8.frame25.frame22.label17 <Button-1> {MenuPopupPost $topwin(enhan_name).info.frame2.frame8.frame25.frame22.label17.menu %X %Y}
  bind $topwin(enhan_name).info.frame2.frame8.frame25.frame22.label17 <ButtonRelease-1> {MenuPopupRelease $topwin(enhan_name).info.frame2.frame8.frame25.frame22.label17.menu %W}

  # build widget $topwin(enhan_name).info.frame2.frame8.frame25.frame22.label17.menu
  menu $topwin(enhan_name).info.frame2.frame8.frame25.frame22.label17.menu \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)"
  $topwin(enhan_name).info.frame2.frame8.frame25.frame22.label17.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -command {set enhan(slice_33) 0} \
    -label {0}
  $topwin(enhan_name).info.frame2.frame8.frame25.frame22.label17.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -command {set enhan(slice_33) 64} \
    -label {64}
  $topwin(enhan_name).info.frame2.frame8.frame25.frame22.label17.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -command {set enhan(slice_33) 128} \
    -label {128}
  $topwin(enhan_name).info.frame2.frame8.frame25.frame22.label17.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -command {set enhan(slice_33) 192} \
    -label {192}
  $topwin(enhan_name).info.frame2.frame8.frame25.frame22.label17.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -command {set enhan(slice_33) 255} \
    -label {255}
  # bindings
  bind $topwin(enhan_name).info.frame2.frame8.frame25.frame22.label17.menu <B1-Motion> {MenuPopupMotion $topwin(enhan_name).info.frame2.frame8.frame25.frame22.label17.menu %W %X %Y}
  bind $topwin(enhan_name).info.frame2.frame8.frame25.frame22.label17.menu <ButtonRelease-1> {MenuPopupRelease $topwin(enhan_name).info.frame2.frame8.frame25.frame22.label17.menu %W}

  # pack widget $topwin(enhan_name).info.frame2.frame8.frame25.frame22
  pack append $topwin(enhan_name).info.frame2.frame8.frame25.frame22 \
    $topwin(enhan_name).info.frame2.frame8.frame25.frame22.label15 {left frame center} \
    $topwin(enhan_name).info.frame2.frame8.frame25.frame22.entry16 {left frame center} \
    $topwin(enhan_name).info.frame2.frame8.frame25.frame22.label17 {left frame center}

  # build widget $topwin(enhan_name).info.frame2.frame8.frame25.frame23
  frame $topwin(enhan_name).info.frame2.frame8.frame25.frame23 \
    -background "$GuiColor(frame_bg)" \
    -borderwidth {2}

  # build widget $topwin(enhan_name).info.frame2.frame8.frame25.frame23.label15
  label $topwin(enhan_name).info.frame2.frame8.frame25.frame23.label15 \
    -background {blue} \
    -foreground {white} \
    -text {B:}

  # build widget $topwin(enhan_name).info.frame2.frame8.frame25.frame23.entry16
  entry $topwin(enhan_name).info.frame2.frame8.frame25.frame23.entry16 \
    -background "$GuiColor(entry_bg)" \
	 -foreground "$GuiColor(entry_fg)" \
    -relief {sunken} \
    -textvariable {enhan(slice_34)} \
    -width {5}
  endEntry  $topwin(enhan_name).info.frame2.frame8.frame25.frame23.entry16 0\
     $topwin(enhan_name).info.frame2.frame8.frame25.frame18.entry16 \
     $topwin(enhan_name).info.frame2.frame8.frame25.frame22.entry16 

  # build widget $topwin(enhan_name).info.frame2.frame8.frame25.frame23.label17
  menubutton $topwin(enhan_name).info.frame2.frame8.frame25.frame23.label17 \
    -activebackground "$GuiColor(btn_act_bg)"  \
    -background "$GuiColor(btn_bg)" \
    -font "$GuiMisc(pop_up_fn)" \
	 -text "$GuiMisc(pop_up_text)" \
	 -relief "$GuiMisc(pop_up_relief)" \
    -width {1}
  # bindings
  bind $topwin(enhan_name).info.frame2.frame8.frame25.frame23.label17 <Button-1> {MenuPopupPost $topwin(enhan_name).info.frame2.frame8.frame25.frame23.label17.menu %X %Y}
  bind $topwin(enhan_name).info.frame2.frame8.frame25.frame23.label17 <ButtonRelease-1> {MenuPopupRelease $topwin(enhan_name).info.frame2.frame8.frame25.frame23.label17.menu %W}

  # build widget $topwin(enhan_name).info.frame2.frame8.frame25.frame23.label17.menu
  menu $topwin(enhan_name).info.frame2.frame8.frame25.frame23.label17.menu \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)"
  $topwin(enhan_name).info.frame2.frame8.frame25.frame23.label17.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -command {set enhan(slice_34) 0} \
    -label {0}
  $topwin(enhan_name).info.frame2.frame8.frame25.frame23.label17.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -command {set enhan(slice_34) 64} \
    -label {64}
  $topwin(enhan_name).info.frame2.frame8.frame25.frame23.label17.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -command {set enhan(slice_34) 128} \
    -label {128}
  $topwin(enhan_name).info.frame2.frame8.frame25.frame23.label17.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -command {set enhan(slice_34) 192} \
    -label {192}
  $topwin(enhan_name).info.frame2.frame8.frame25.frame23.label17.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -command {set enhan(slice_34) 255} \
    -label {255}
  # bindings
  bind $topwin(enhan_name).info.frame2.frame8.frame25.frame23.label17.menu <B1-Motion> {MenuPopupMotion $topwin(enhan_name).info.frame2.frame8.frame25.frame23.label17.menu %W %X %Y}
  bind $topwin(enhan_name).info.frame2.frame8.frame25.frame23.label17.menu <ButtonRelease-1> {MenuPopupRelease $topwin(enhan_name).info.frame2.frame8.frame25.frame23.label17.menu %W}

  # pack widget $topwin(enhan_name).info.frame2.frame8.frame25.frame23
  pack append $topwin(enhan_name).info.frame2.frame8.frame25.frame23 \
    $topwin(enhan_name).info.frame2.frame8.frame25.frame23.label15 {left frame center} \
    $topwin(enhan_name).info.frame2.frame8.frame25.frame23.entry16 {left frame center} \
    $topwin(enhan_name).info.frame2.frame8.frame25.frame23.label17 {left frame center}

  # pack widget $topwin(enhan_name).info.frame2.frame8.frame25
  pack append $topwin(enhan_name).info.frame2.frame8.frame25 \
    $topwin(enhan_name).info.frame2.frame8.frame25.frame18 {left frame center} \
    $topwin(enhan_name).info.frame2.frame8.frame25.frame19 {left frame center} \
    $topwin(enhan_name).info.frame2.frame8.frame25.label20 {left frame center} \
    $topwin(enhan_name).info.frame2.frame8.frame25.frame21 {left frame center} \
    $topwin(enhan_name).info.frame2.frame8.frame25.frame22 {left frame center} \
    $topwin(enhan_name).info.frame2.frame8.frame25.frame23 {left frame center}

  # build widget $topwin(enhan_name).info.frame2.frame8.frame26
  frame $topwin(enhan_name).info.frame2.frame8.frame26 \
    -background "$GuiColor(frame_bg)" \
    -borderwidth {2}

  # build widget $topwin(enhan_name).info.frame2.frame8.frame26.frame18
  frame $topwin(enhan_name).info.frame2.frame8.frame26.frame18 \
    -background "$GuiColor(frame_bg)" \
    -borderwidth {2}

  # build widget $topwin(enhan_name).info.frame2.frame8.frame26.frame18.label15
  label $topwin(enhan_name).info.frame2.frame8.frame26.frame18.label15 \
    -background "$GuiColor(label_bg)" \
    -text {From:}

  # build widget $topwin(enhan_name).info.frame2.frame8.frame26.frame18.entry16
  entry $topwin(enhan_name).info.frame2.frame8.frame26.frame18.entry16 \
    -background "$GuiColor(entry_bg)" \
	 -foreground "$GuiColor(entry_fg)" \
    -relief {sunken} \
    -textvariable {enhan(slice_40)} \
    -width {5}
  endEntry  $topwin(enhan_name).info.frame2.frame8.frame26.frame18.entry16 0\
     $topwin(enhan_name).info.frame2.frame8.frame26.frame19.entry16 \
     $topwin(enhan_name).info.frame2.frame8.frame26.frame23.entry16 

  # build widget $topwin(enhan_name).info.frame2.frame8.frame26.frame18.label17
  menubutton $topwin(enhan_name).info.frame2.frame8.frame26.frame18.label17 \
    -activebackground "$GuiColor(btn_act_bg)"  \
    -background "$GuiColor(btn_bg)" \
    -font "$GuiMisc(pop_up_fn)" \
	 -text "$GuiMisc(pop_up_text)" \
	 -relief "$GuiMisc(pop_up_relief)" \
    -width {1}
  # bindings
  bind $topwin(enhan_name).info.frame2.frame8.frame26.frame18.label17 <Button-1> {MenuPopupPost $topwin(enhan_name).info.frame2.frame8.frame26.frame18.label17.menu %X %Y}
  bind $topwin(enhan_name).info.frame2.frame8.frame26.frame18.label17 <ButtonRelease-1> {MenuPopupRelease $topwin(enhan_name).info.frame2.frame8.frame26.frame18.label17.menu %W}

  # build widget $topwin(enhan_name).info.frame2.frame8.frame26.frame18.label17.menu
  menu $topwin(enhan_name).info.frame2.frame8.frame26.frame18.label17.menu \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)"
  $topwin(enhan_name).info.frame2.frame8.frame26.frame18.label17.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -command {set enhan(slice_40) 0} \
    -label {0}
  $topwin(enhan_name).info.frame2.frame8.frame26.frame18.label17.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -command {set enhan(slice_40) 64} \
    -label {64}
  $topwin(enhan_name).info.frame2.frame8.frame26.frame18.label17.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -command {set enhan(slice_40) 85} \
    -label {85}
  $topwin(enhan_name).info.frame2.frame8.frame26.frame18.label17.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -command {set enhan(slice_40) 128} \
    -label {128}
  $topwin(enhan_name).info.frame2.frame8.frame26.frame18.label17.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -command {set enhan(slice_40) 170} \
    -label {170}
  $topwin(enhan_name).info.frame2.frame8.frame26.frame18.label17.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -command {set enhan(slice_40) 192} \
    -label {192}
  # bindings
  bind $topwin(enhan_name).info.frame2.frame8.frame26.frame18.label17.menu <B1-Motion> {MenuPopupMotion $topwin(enhan_name).info.frame2.frame8.frame26.frame18.label17.menu %W %X %Y}
  bind $topwin(enhan_name).info.frame2.frame8.frame26.frame18.label17.menu <ButtonRelease-1> {MenuPopupRelease $topwin(enhan_name).info.frame2.frame8.frame26.frame18.label17.menu %W}

  # pack widget $topwin(enhan_name).info.frame2.frame8.frame26.frame18
  pack append $topwin(enhan_name).info.frame2.frame8.frame26.frame18 \
    $topwin(enhan_name).info.frame2.frame8.frame26.frame18.label15 {left frame center} \
    $topwin(enhan_name).info.frame2.frame8.frame26.frame18.entry16 {left frame center} \
    $topwin(enhan_name).info.frame2.frame8.frame26.frame18.label17 {left frame center}

  # build widget $topwin(enhan_name).info.frame2.frame8.frame26.frame19
  frame $topwin(enhan_name).info.frame2.frame8.frame26.frame19 \
    -background "$GuiColor(frame_bg)" \
    -borderwidth {2}

  # build widget $topwin(enhan_name).info.frame2.frame8.frame26.frame19.label15
  label $topwin(enhan_name).info.frame2.frame8.frame26.frame19.label15 \
    -background "$GuiColor(label_bg)" \
    -text {To:}

  # build widget $topwin(enhan_name).info.frame2.frame8.frame26.frame19.entry16
  entry $topwin(enhan_name).info.frame2.frame8.frame26.frame19.entry16 \
    -background "$GuiColor(entry_bg)" \
	 -foreground "$GuiColor(entry_fg)" \
    -relief {sunken} \
    -textvariable {enhan(slice_41)} \
    -width {5}
  endEntry  $topwin(enhan_name).info.frame2.frame8.frame26.frame19.entry16 0\
     $topwin(enhan_name).info.frame2.frame8.frame26.frame21.entry16 \
     $topwin(enhan_name).info.frame2.frame8.frame26.frame18.entry16 

  # build widget $topwin(enhan_name).info.frame2.frame8.frame26.frame19.label17
  menubutton $topwin(enhan_name).info.frame2.frame8.frame26.frame19.label17 \
    -activebackground "$GuiColor(btn_act_bg)"  \
    -background "$GuiColor(btn_bg)" \
    -font "$GuiMisc(pop_up_fn)" \
	 -text "$GuiMisc(pop_up_text)" \
	 -relief "$GuiMisc(pop_up_relief)" \
    -width {1}
  # bindings
  bind $topwin(enhan_name).info.frame2.frame8.frame26.frame19.label17 <Button-1> {MenuPopupPost $topwin(enhan_name).info.frame2.frame8.frame26.frame19.label17.menu %X %Y}
  bind $topwin(enhan_name).info.frame2.frame8.frame26.frame19.label17 <ButtonRelease-1> {MenuPopupRelease $topwin(enhan_name).info.frame2.frame8.frame26.frame19.label17.menu %W}

  # build widget $topwin(enhan_name).info.frame2.frame8.frame26.frame19.label17.menu
  menu $topwin(enhan_name).info.frame2.frame8.frame26.frame19.label17.menu \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)"
  $topwin(enhan_name).info.frame2.frame8.frame26.frame19.label17.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -command {set enhan(slice_41) 63} \
    -label {63}
  $topwin(enhan_name).info.frame2.frame8.frame26.frame19.label17.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -command {set enhan(slice_41) 84} \
    -label {84}
  $topwin(enhan_name).info.frame2.frame8.frame26.frame19.label17.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -command {set enhan(slice_41) 127} \
    -label {127}
  $topwin(enhan_name).info.frame2.frame8.frame26.frame19.label17.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -command {set enhan(slice_41) 169} \
    -label {169}
  $topwin(enhan_name).info.frame2.frame8.frame26.frame19.label17.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -command {set enhan(slice_41) 191} \
    -label {191}
  $topwin(enhan_name).info.frame2.frame8.frame26.frame19.label17.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -command {set enhan(slice_41) 255} \
    -label {255}
  # bindings
  bind $topwin(enhan_name).info.frame2.frame8.frame26.frame19.label17.menu <B1-Motion> {MenuPopupMotion $topwin(enhan_name).info.frame2.frame8.frame26.frame19.label17.menu %W %X %Y}
  bind $topwin(enhan_name).info.frame2.frame8.frame26.frame19.label17.menu <ButtonRelease-1> {MenuPopupRelease $topwin(enhan_name).info.frame2.frame8.frame26.frame19.label17.menu %W}

  # pack widget $topwin(enhan_name).info.frame2.frame8.frame26.frame19
  pack append $topwin(enhan_name).info.frame2.frame8.frame26.frame19 \
    $topwin(enhan_name).info.frame2.frame8.frame26.frame19.label15 {left frame center} \
    $topwin(enhan_name).info.frame2.frame8.frame26.frame19.entry16 {left frame center} \
    $topwin(enhan_name).info.frame2.frame8.frame26.frame19.label17 {left frame center}

  # build widget $topwin(enhan_name).info.frame2.frame8.frame26.label20
  label $topwin(enhan_name).info.frame2.frame8.frame26.label20 \
    -background "$GuiColor(label_bg)" \
    -text {  ===>    }

  # build widget $topwin(enhan_name).info.frame2.frame8.frame26.frame21
  frame $topwin(enhan_name).info.frame2.frame8.frame26.frame21 \
    -background "$GuiColor(frame_bg)" \
    -borderwidth {2}

  # build widget $topwin(enhan_name).info.frame2.frame8.frame26.frame21.label15
  label $topwin(enhan_name).info.frame2.frame8.frame26.frame21.label15 \
    -background {red} \
    -foreground {white} \
    -text {R:}

  # build widget $topwin(enhan_name).info.frame2.frame8.frame26.frame21.entry16
  entry $topwin(enhan_name).info.frame2.frame8.frame26.frame21.entry16 \
    -background "$GuiColor(entry_bg)" \
	 -foreground "$GuiColor(entry_fg)" \
    -relief {sunken} \
    -textvariable {enhan(slice_42)} \
    -width {5}
  endEntry  $topwin(enhan_name).info.frame2.frame8.frame26.frame21.entry16 0\
     $topwin(enhan_name).info.frame2.frame8.frame26.frame22.entry16 \
     $topwin(enhan_name).info.frame2.frame8.frame26.frame19.entry16 

  # build widget $topwin(enhan_name).info.frame2.frame8.frame26.frame21.label17
  menubutton $topwin(enhan_name).info.frame2.frame8.frame26.frame21.label17 \
    -activebackground "$GuiColor(btn_act_bg)"  \
    -background "$GuiColor(btn_bg)" \
    -font "$GuiMisc(pop_up_fn)" \
	 -text "$GuiMisc(pop_up_text)" \
	 -relief "$GuiMisc(pop_up_relief)" \
    -width {1}
  # bindings
  bind $topwin(enhan_name).info.frame2.frame8.frame26.frame21.label17 <Button-1> {MenuPopupPost $topwin(enhan_name).info.frame2.frame8.frame26.frame21.label17.menu %X %Y}
  bind $topwin(enhan_name).info.frame2.frame8.frame26.frame21.label17 <ButtonRelease-1> {MenuPopupRelease $topwin(enhan_name).info.frame2.frame8.frame26.frame21.label17.menu %W}

  # build widget $topwin(enhan_name).info.frame2.frame8.frame26.frame21.label17.menu
  menu $topwin(enhan_name).info.frame2.frame8.frame26.frame21.label17.menu \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)"
  $topwin(enhan_name).info.frame2.frame8.frame26.frame21.label17.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -command {set enhan(slice_42) 0} \
    -label {0}
  $topwin(enhan_name).info.frame2.frame8.frame26.frame21.label17.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -command {set enhan(slice_42) 64} \
    -label {64}
  $topwin(enhan_name).info.frame2.frame8.frame26.frame21.label17.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -command {set enhan(slice_42) 128} \
    -label {128}
  $topwin(enhan_name).info.frame2.frame8.frame26.frame21.label17.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -command {set enhan(slice_42) 192} \
    -label {192}
  $topwin(enhan_name).info.frame2.frame8.frame26.frame21.label17.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -command {set enhan(slice_42) 255} \
    -label {255}
  # bindings
  bind $topwin(enhan_name).info.frame2.frame8.frame26.frame21.label17.menu <B1-Motion> {MenuPopupMotion $topwin(enhan_name).info.frame2.frame8.frame26.frame21.label17.menu %W %X %Y}
  bind $topwin(enhan_name).info.frame2.frame8.frame26.frame21.label17.menu <ButtonRelease-1> {MenuPopupRelease $topwin(enhan_name).info.frame2.frame8.frame26.frame21.label17.menu %W}

  # pack widget $topwin(enhan_name).info.frame2.frame8.frame26.frame21
  pack append $topwin(enhan_name).info.frame2.frame8.frame26.frame21 \
    $topwin(enhan_name).info.frame2.frame8.frame26.frame21.label15 {left frame center} \
    $topwin(enhan_name).info.frame2.frame8.frame26.frame21.entry16 {left frame center} \
    $topwin(enhan_name).info.frame2.frame8.frame26.frame21.label17 {left frame center}

  # build widget $topwin(enhan_name).info.frame2.frame8.frame26.frame22
  frame $topwin(enhan_name).info.frame2.frame8.frame26.frame22 \
    -background "$GuiColor(frame_bg)" \
    -borderwidth {2}

  # build widget $topwin(enhan_name).info.frame2.frame8.frame26.frame22.label15
  label $topwin(enhan_name).info.frame2.frame8.frame26.frame22.label15 \
    -background {#00dd00} \
    -foreground {white} \
    -text {G:}

  # build widget $topwin(enhan_name).info.frame2.frame8.frame26.frame22.entry16
  entry $topwin(enhan_name).info.frame2.frame8.frame26.frame22.entry16 \
    -background "$GuiColor(entry_bg)" \
	 -foreground "$GuiColor(entry_fg)" \
    -relief {sunken} \
    -textvariable {enhan(slice_43)} \
    -width {5}
  endEntry  $topwin(enhan_name).info.frame2.frame8.frame26.frame22.entry16 0\
     $topwin(enhan_name).info.frame2.frame8.frame26.frame23.entry16 \
     $topwin(enhan_name).info.frame2.frame8.frame26.frame21.entry16 

  # build widget $topwin(enhan_name).info.frame2.frame8.frame26.frame22.label17
  menubutton $topwin(enhan_name).info.frame2.frame8.frame26.frame22.label17 \
    -activebackground "$GuiColor(btn_act_bg)"  \
    -background "$GuiColor(btn_bg)" \
    -font "$GuiMisc(pop_up_fn)" \
	 -text "$GuiMisc(pop_up_text)" \
	 -relief "$GuiMisc(pop_up_relief)" \
    -width {1}
  # bindings
  bind $topwin(enhan_name).info.frame2.frame8.frame26.frame22.label17 <Button-1> {MenuPopupPost $topwin(enhan_name).info.frame2.frame8.frame26.frame22.label17.menu %X %Y}
  bind $topwin(enhan_name).info.frame2.frame8.frame26.frame22.label17 <ButtonRelease-1> {MenuPopupRelease $topwin(enhan_name).info.frame2.frame8.frame26.frame22.label17.menu %W}

  # build widget $topwin(enhan_name).info.frame2.frame8.frame26.frame22.label17.menu
  menu $topwin(enhan_name).info.frame2.frame8.frame26.frame22.label17.menu \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)"
  $topwin(enhan_name).info.frame2.frame8.frame26.frame22.label17.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -command {set enhan(slice_43) 0} \
    -label {0}
  $topwin(enhan_name).info.frame2.frame8.frame26.frame22.label17.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -command {set enhan(slice_43) 64} \
    -label {64}
  $topwin(enhan_name).info.frame2.frame8.frame26.frame22.label17.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -command {set enhan(slice_43) 128} \
    -label {128}
  $topwin(enhan_name).info.frame2.frame8.frame26.frame22.label17.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -command {set enhan(slice_43) 192} \
    -label {192}
  $topwin(enhan_name).info.frame2.frame8.frame26.frame22.label17.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -command {set enhan(slice_43) 255} \
    -label {255}
  # bindings
  bind $topwin(enhan_name).info.frame2.frame8.frame26.frame22.label17.menu <B1-Motion> {MenuPopupMotion $topwin(enhan_name).info.frame2.frame8.frame26.frame22.label17.menu %W %X %Y}
  bind $topwin(enhan_name).info.frame2.frame8.frame26.frame22.label17.menu <ButtonRelease-1> {MenuPopupRelease $topwin(enhan_name).info.frame2.frame8.frame26.frame22.label17.menu %W}

  # pack widget $topwin(enhan_name).info.frame2.frame8.frame26.frame22
  pack append $topwin(enhan_name).info.frame2.frame8.frame26.frame22 \
    $topwin(enhan_name).info.frame2.frame8.frame26.frame22.label15 {left frame center} \
    $topwin(enhan_name).info.frame2.frame8.frame26.frame22.entry16 {left frame center} \
    $topwin(enhan_name).info.frame2.frame8.frame26.frame22.label17 {left frame center}

  # build widget $topwin(enhan_name).info.frame2.frame8.frame26.frame23
  frame $topwin(enhan_name).info.frame2.frame8.frame26.frame23 \
    -background "$GuiColor(frame_bg)" \
    -borderwidth {2}

  # build widget $topwin(enhan_name).info.frame2.frame8.frame26.frame23.label15
  label $topwin(enhan_name).info.frame2.frame8.frame26.frame23.label15 \
    -background {blue} \
    -foreground {white} \
    -text {B:}

  # build widget $topwin(enhan_name).info.frame2.frame8.frame26.frame23.entry16
  entry $topwin(enhan_name).info.frame2.frame8.frame26.frame23.entry16 \
    -background "$GuiColor(entry_bg)" \
	 -foreground "$GuiColor(entry_fg)" \
    -relief {sunken} \
    -textvariable {enhan(slice_44)} \
    -width {5}
  endEntry  $topwin(enhan_name).info.frame2.frame8.frame26.frame23.entry16 0\
     $topwin(enhan_name).info.frame2.frame8.frame26.frame18.entry16 \
     $topwin(enhan_name).info.frame2.frame8.frame26.frame22.entry16 

  # build widget $topwin(enhan_name).info.frame2.frame8.frame26.frame23.label17
  menubutton $topwin(enhan_name).info.frame2.frame8.frame26.frame23.label17 \
    -activebackground "$GuiColor(btn_act_bg)"  \
    -background "$GuiColor(btn_bg)" \
    -font "$GuiMisc(pop_up_fn)" \
	 -text "$GuiMisc(pop_up_text)" \
	 -relief "$GuiMisc(pop_up_relief)" \
    -width {1}
  # bindings
  bind $topwin(enhan_name).info.frame2.frame8.frame26.frame23.label17 <Button-1> {MenuPopupPost $topwin(enhan_name).info.frame2.frame8.frame26.frame23.label17.menu %X %Y}
  bind $topwin(enhan_name).info.frame2.frame8.frame26.frame23.label17 <ButtonRelease-1> {MenuPopupRelease $topwin(enhan_name).info.frame2.frame8.frame26.frame23.label17.menu %W}

  # build widget $topwin(enhan_name).info.frame2.frame8.frame26.frame23.label17.menu
  menu $topwin(enhan_name).info.frame2.frame8.frame26.frame23.label17.menu \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)"
  $topwin(enhan_name).info.frame2.frame8.frame26.frame23.label17.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -command {set enhan(slice_44) 0} \
    -label {0}
  $topwin(enhan_name).info.frame2.frame8.frame26.frame23.label17.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -command {set enhan(slice_44) 64} \
    -label {64}
  $topwin(enhan_name).info.frame2.frame8.frame26.frame23.label17.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -command {set enhan(slice_44) 128} \
    -label {128}
  $topwin(enhan_name).info.frame2.frame8.frame26.frame23.label17.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -command {set enhan(slice_44) 192} \
    -label {192}
  $topwin(enhan_name).info.frame2.frame8.frame26.frame23.label17.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -command {set enhan(slice_44) 255} \
    -label {255}
  # bindings
  bind $topwin(enhan_name).info.frame2.frame8.frame26.frame23.label17.menu <B1-Motion> {MenuPopupMotion $topwin(enhan_name).info.frame2.frame8.frame26.frame23.label17.menu %W %X %Y}
  bind $topwin(enhan_name).info.frame2.frame8.frame26.frame23.label17.menu <ButtonRelease-1> {MenuPopupRelease $topwin(enhan_name).info.frame2.frame8.frame26.frame23.label17.menu %W}

  # pack widget $topwin(enhan_name).info.frame2.frame8.frame26.frame23
  pack append $topwin(enhan_name).info.frame2.frame8.frame26.frame23 \
    $topwin(enhan_name).info.frame2.frame8.frame26.frame23.label15 {left frame center} \
    $topwin(enhan_name).info.frame2.frame8.frame26.frame23.entry16 {left frame center} \
    $topwin(enhan_name).info.frame2.frame8.frame26.frame23.label17 {left frame center}

  # pack widget $topwin(enhan_name).info.frame2.frame8.frame26
  pack append $topwin(enhan_name).info.frame2.frame8.frame26 \
    $topwin(enhan_name).info.frame2.frame8.frame26.frame18 {left frame center} \
    $topwin(enhan_name).info.frame2.frame8.frame26.frame19 {left frame center} \
    $topwin(enhan_name).info.frame2.frame8.frame26.label20 {left frame center} \
    $topwin(enhan_name).info.frame2.frame8.frame26.frame21 {left frame center} \
    $topwin(enhan_name).info.frame2.frame8.frame26.frame22 {left frame center} \
    $topwin(enhan_name).info.frame2.frame8.frame26.frame23 {left frame center}

  # pack widget $topwin(enhan_name).info.frame2.frame8
  pack append $topwin(enhan_name).info.frame2.frame8 \
    $topwin(enhan_name).info.frame2.frame8.frame0 {top frame center fillx} \
    $topwin(enhan_name).info.frame2.frame8.frame1 {top frame center fillx} \
    $topwin(enhan_name).info.frame2.frame8.frame24 {top frame center fillx} \
    $topwin(enhan_name).info.frame2.frame8.frame25 {top frame center fillx} \
    $topwin(enhan_name).info.frame2.frame8.frame26 {top frame center fillx}

  # pack widget $topwin(enhan_name).info.frame2
  pack append $topwin(enhan_name).info.frame2 \
    $topwin(enhan_name).info.frame2.frame7 {top frame center fillx} \
    $topwin(enhan_name).info.frame2.frame8 {top frame center expand fill}

  # pack widget $topwin(enhan_name).info
  pack append $topwin(enhan_name).info \
    $topwin(enhan_name).info.frame0 {top frame center expand fill} \
    $topwin(enhan_name).info.frame1 {top frame center expand fill} \
    $topwin(enhan_name).info.frame2 {top frame center expand fill}

  # build widget $topwin(enhan_name).current_image
  frame $topwin(enhan_name).current_image \
    -background "$GuiColor(frame_bg)" \
    -borderwidth {2} \
    -relief {ridge}

  # build widget $topwin(enhan_name).current_image.label0
  label $topwin(enhan_name).current_image.label0 \
    -background "$GuiColor(label_bg)" \
    -text {Current image: }

  # build widget $topwin(enhan_name).current_image.label1
  label $topwin(enhan_name).current_image.label1 \
    -background "$GuiColor(label_bg)" \
    -foreground {Blue} \
    -text {} \
    -textvariable {current_image}

  # pack widget $topwin(enhan_name).current_image
  pack append $topwin(enhan_name).current_image \
    $topwin(enhan_name).current_image.label0 {left frame center} \
    $topwin(enhan_name).current_image.label1 {left frame center}

  # build widget $topwin(enhan_name).perform
  frame $topwin(enhan_name).perform \
    -background "$GuiColor(frame_bg)" \
    -borderwidth {2} \
    -relief {raised}

  # build widget $topwin(enhan_name).perform.button2
	button $topwin(enhan_name).perform.button2 -padx {1} -pady {1} -highlightthickness {0}  \
    -activebackground "$GuiColor(dis_act_bg)"  \
    -background "$GuiColor(dis_bg)" \
    -foreground "$GuiColor(dis_fg)" \
	 -command {destroy $topwin(enhan_name)} \
    -text {DISMISS}

  # build widget $topwin(enhan_name).perform.button3
	button $topwin(enhan_name).perform.button3 -padx {1} -pady {1} -highlightthickness {0}  \
    -activebackground "$GuiColor(perf_act_bg)"  \
    -background "$GuiColor(perf_bg)" \
    -foreground "$GuiColor(perf_fg)" \
    -text {PERFORM} \
	 -command {
		$topwin(enhan_name) configure -cursor watch; update
      if { $current_image == ""} {
         CvipAlert "Please select an image first."
			$topwin(enhan_name) configure -cursor top_left_arrow; update
         return
      }  

      if { $bands != "1" } {
          CvipAlert "Pseudo color  applies to gray level image only."
			 $topwin(enhan_name) configure -cursor top_left_arrow; update
          return
      }

		switch -exact -- $enhan(g_c) {
		  pseudocol_freq {
			if [catch {expr $enhan(pseudo_lcf) + $enhan(pseudo_hcf)} ] {
				CvipAlert "Numerical values required for conversion parameters:\n \
					Low cutoff frequency =$enhan(pseudo_lcf), High cutoff frequency= $enhan(pseudo_hcf)."
					$topwin(enhan_name) configure -cursor top_left_arrow; update
					return
			}
	
			if {$enhan(pseudo_lcf) > $enhan(pseudo_hcf) } {
  	   	   CvipAlert "High cutoff frequency ( $enhan(pseudo_hcf) ) must be greater\
				than low  cutoff frequency ( $enhan(pseudo_lcf) )."
				$topwin(enhan_name) configure -cursor top_left_arrow; update
			   return
			}
	
			if {$enhan(pseudo_lpc) == $enhan(pseudo_bpc) || $enhan(pseudo_bpc) == $enhan(pseudo_hpc)\
				|| $enhan(pseudo_hpc) == $enhan(pseudo_lpc) } {
		       CvipAlert "Please use different colors for different bands:\n\
				 Low pass color = $enhan(pseudo_lpc), Band pass color = $enhan(pseudo_bpc),\
				 High pass color = $enhan(pseudo_hpc)."
				$topwin(enhan_name) configure -cursor top_left_arrow; update
				 return
			}
	
			if { $data_type == "FLOAT" } {
				if [catch {set temp1 [cvip data_remap $current_image 2]} cresult ] {
  	   	   	CvipAlert "$cresult."
					$topwin(enhan_name) configure -cursor top_left_arrow; update
				   return
				}
  		   	set temp "cvip pseudocol_freq $temp1 $enhan(pseudo_lcf) $enhan(pseudo_hcf) "
			} else {
  		   	set temp "cvip pseudocol_freq $current_image $enhan(pseudo_lcf) $enhan(pseudo_hcf) "
			}

  		   if { $enhan(pseudo_lpc) ==  "R" } {
  		       append temp "0 "
			} elseif { $enhan(pseudo_lpc) ==  "G" } {
  	      	append temp "1 "
			} else {
				append temp "2 "
      	}
      	if { $enhan(pseudo_bpc) ==  "R" } {
         	append temp "0 "
      	} elseif { $enhan(pseudo_bpc) ==  "G" } {
         	append temp "1 "
      	} else {
         	append temp "2 "
      	}
      	if { $enhan(pseudo_hpc) ==  "R" } {
         	append temp "0"
      	} elseif { $enhan(pseudo_hpc) ==  "G" } {
         	append temp "1"
      	} else {
         	append temp "2"
      	}

			if { $GUI_DEBUG == "1" } {
      		puts stderr $temp
			}

			if [catch {set result [eval $temp]
							if { $data_type == "FLOAT"} {
								cvip dq $temp1
							}
						} cresult] {
		   	CvipAlert "$cresult."
				$topwin(enhan_name) configure -cursor top_left_arrow; update
     	   	return
			}
     		set new_name [cvip rename $result ${current_image}_pseudo]       
     		img_q insert end $new_name
			image_post $new_name
			cvip view $new_name
			CvipMessage "frequency domain pseudo-coloring performed on image \"$current_image\""
		  }

		  bitplane {
			if [catch {
				if {$enhan(g_c_r) == "red" || $enhan(g_c_g) == "red" || $enhan(g_c_b) == "red" } {
					set temp [cvip gray_linear $current_image 0 63 0 4 0]
               set temp1 [cvip gray_linear $current_image 64 191 255 0 0]
               set temp2 [cvip add $temp1 $temp]
               cvip dq $temp
               cvip dq $temp1
               set temp [cvip gray_linear $current_image 192 254 255 -4 0]
               set temp1 [cvip add $temp $temp2]
               cvip dq $temp
               cvip dq $temp2
               cvip rename $temp1 red
				}

				if {$enhan(g_c_r) == "green" || $enhan(g_c_g) == "green" || $enhan(g_c_b) == "green" } {
               set temp [cvip gray_linear $current_image 0 63 0 0 0]
               set temp1 [cvip gray_linear $current_image 64 127 0 0 0]
               set temp2 [cvip add $temp1 $temp]
               cvip dq $temp
               cvip dq $temp1
               set temp [cvip gray_linear $current_image 127 254 255 0 0]
               set temp1 [cvip add $temp $temp2]
               cvip dq $temp
               cvip dq $temp2
               cvip rename $temp1 green
				}
				if {$enhan(g_c_r) == "blue" || $enhan(g_c_g) == "blue" || $enhan(g_c_b) == "blue" } {
               set temp [cvip gray_linear $current_image 0 127 255 0 0]
               set temp1 [cvip gray_linear $current_image 128 191 255 -4 0]
               set temp2 [cvip add $temp1 $temp]
               cvip dq $temp
               cvip dq $temp1
               set temp [cvip gray_linear $current_image 192 255 0 0 0]
               set temp1 [cvip add $temp $temp2]
               cvip dq $temp
               cvip dq $temp2
               cvip rename $temp1 blue
				}

				if {$enhan(g_c_r) == "slash" || $enhan(g_c_g) == "slash" || $enhan(g_c_b) == "slash" } {
               set temp [cvip gray_linear $current_image 0 255 0 1 0]
					cvip rename $temp slash
				}
				if {$enhan(g_c_r)=="backslash" || $enhan(g_c_g)=="backslash" || $enhan(g_c_b)=="backslash" } {
               set temp [cvip gray_linear $current_image 0 255 255 -1 0]
					cvip rename $temp backslash
				}
			} cresult ] {
			CvipAlert "$cresult."
			$topwin(enhan_name) configure -cursor top_left_arrow; update
			return
			}
         if [catch {set result [cvip assemble_bands $enhan(g_c_r) $enhan(g_c_g) $enhan(g_c_b)]} cresult] {
               CvipAlert "$cresult ."
					$topwin(enhan_name) configure -cursor top_left_arrow; update
               return
         }

			if [catch {cvip dq $enhan(g_c_r); cvip dq $enhan(g_c_g); cvip dq $enhan(g_c_b)} cresult] {
				puts ""
			}
         set new_name [cvip rename $result ${current_image}_grayMap]
         img_q insert end $new_name
         image_post $new_name
         cvip view $new_name
			CvipMessage "bitplane slicing pseudo-coloring performed on image \"$current_image\""
		  }

		  intensity {
			set temp 1
			while  {$temp <= 4 && $enhan(slice_${temp}0) != ""} {
				if [ catch { expr $enhan(slice_${temp}0) + $enhan(slice_${temp}1) } ] {
					CvipAlert "Numerical values required for start and end histogram values:\n \
						from =$enhan(slice_${temp}0), to = $enhan(slice_${temp}1)."
						$topwin(enhan_name) configure -cursor top_left_arrow; update
						return
				} elseif { $enhan(slice_${temp}0) >= $enhan(slice_${temp}1) } {
					CvipAlert "The start histogram value should be less than the end value:\n \
						from =$enhan(slice_${temp}0), to = $enhan(slice_${temp}1)." 
						$topwin(enhan_name) configure -cursor top_left_arrow; update
						return
				} elseif { $enhan(slice_${temp}0) < 0 } {
					CvipAlert "The histogram value should be in the range (0-255):\n \
						Start value = $enhan(slice_${temp}0)."
						$topwin(enhan_name) configure -cursor top_left_arrow; update
						return
				} elseif { $enhan(slice_${temp}1) > 255 } {
					CvipAlert "The histogram value should be in the range (0-255):\n \
						End value = $enhan(slice_${temp}1)."
						$topwin(enhan_name) configure -cursor top_left_arrow; update
						return
				} elseif { $temp > 1 && $enhan(slice_[expr ${temp} -1]1) >= $enhan(slice_${temp}0) } {
					CvipAlert "The start value should be greater than the last end value:\n \
						Start value = $enhan(slice_${temp}0), \
						last end value = $enhan(slice_[expr ${temp} -1]1)."
						$topwin(enhan_name) configure -cursor top_left_arrow; update
						return
				} else {
					if [catch { expr $enhan(slice_${temp}2)+$enhan(slice_${temp}3)+$enhan(slice_${temp}4) }] {
						CvipAlert "Numerical values required for RGB values:\n \
							R =$enhan(slice_${temp}2), G = $enhan(slice_${temp}3), B = $enhan(slice_${temp}4)."
							$topwin(enhan_name) configure -cursor top_left_arrow; update
							return
					} elseif { $enhan(slice_${temp}2) <0 || $enhan(slice_${temp}2) > 255 ||
								  $enhan(slice_${temp}3) <0 || $enhan(slice_${temp}3) > 255 ||
								  $enhan(slice_${temp}4) <0 || $enhan(slice_${temp}4) > 255 } {
						CvipAlert "The RGB values should be in the range (0-255):\n \
							R =$enhan(slice_${temp}2), G = $enhan(slice_${temp}3), B = $enhan(slice_${temp}4)."
							$topwin(enhan_name) configure -cursor top_left_arrow; update
							return
					}
				}

				incr temp
			}
			set temp1 [expr $temp ]

			while { $temp1 <= 4} {
				set enhan(slice_${temp1}0) ""; set enhan(slice_${temp1}1) ""
				incr temp1
			}

			if { $temp == "1" } {
				CvipAlert "Please set the proper values of histogram ranges first."
				$topwin(enhan_name) configure -cursor top_left_arrow; update
				return
			}
			
			for {set temp1 1} { $temp1 < $temp } {incr temp1} {
				set tmp_img_r [cvip gray_linear $current_image \
					$enhan(slice_${temp1}0) $enhan(slice_${temp1}1) $enhan(slice_${temp1}2) 0 0]
				set tmp_img_g [cvip gray_linear $current_image \
					$enhan(slice_${temp1}0) $enhan(slice_${temp1}1) $enhan(slice_${temp1}3) 0 0]
				set tmp_img_b [cvip gray_linear $current_image \
					$enhan(slice_${temp1}0) $enhan(slice_${temp1}1) $enhan(slice_${temp1}4) 0 0]

				set temp2 [cvip assemble_bands $tmp_img_r $tmp_img_g $tmp_img_b]
				cvip dq $tmp_img_r; cvip dq $tmp_img_g; cvip dq $tmp_img_b
	
				if { $temp1 == "1" } {
					cvip rename $temp2	T_m__P_i__M_a__G_e
					if { $enhan(slice_out) == "0" } {
						cvip rename [cvip gray_linear $current_image $enhan(slice_${temp1}0) \
							$enhan(slice_${temp1}1) 0 0 1] T_m__P_i__M_a__G_e_AGN
#						cvip view T_m__P_i__M_a__G_e_AGN
					}
				} else {
					set temp3 [cvip add $temp2 T_m__P_i__M_a__G_e]
					cvip dq $temp2; cvip dq T_m__P_i__M_a__G_e
					cvip rename $temp3 T_m__P_i__M_a__G_e
					if { $enhan(slice_out) == "0" } {
						set temp2 [cvip gray_linear T_m__P_i__M_a__G_e_AGN $enhan(slice_${temp1}0) \
							$enhan(slice_${temp1}1) 0 0 1]
						cvip dq T_m__P_i__M_a__G_e_AGN
						cvip rename $temp2 T_m__P_i__M_a__G_e_AGN
#						cvip view T_m__P_i__M_a__G_e_AGN
					}
				}
			}

			if { $enhan(slice_out) == "0" } {
				set temp [cvip assemble_bands T_m__P_i__M_a__G_e_AGN T_m__P_i__M_a__G_e_AGN \
					T_m__P_i__M_a__G_e_AGN]
				set temp1 [cvip add $temp T_m__P_i__M_a__G_e]
				cvip dq $temp; 
#				cvip view T_m__P_i__M_a__G_e_AGN
				cvip dq T_m__P_i__M_a__G_e_AGN; 
				cvip dq T_m__P_i__M_a__G_e
	         set new_name [cvip rename $temp1 ${current_image}_IntSlic]
			} else {
	         set new_name [cvip rename T_m__P_i__M_a__G_e ${current_image}_IntSlic]
			}
         img_q insert end $new_name
         image_post $new_name
         cvip view $new_name
			unset temp2
			CvipMessage "intensity slicing pseudo-coloring performed on image \"$current_image\""
		  }
		}
		$topwin(enhan_name) configure -cursor top_left_arrow; update

	 }

  # pack widget $topwin(enhan_name).perform
  pack append $topwin(enhan_name).perform \
    $topwin(enhan_name).perform.button2 {left frame center} \
    $topwin(enhan_name).perform.button3 {right frame center}

  # pack widget $topwin(enhan_name)
  pack append $topwin(enhan_name) \
    $topwin(enhan_name).info {top frame center expand fill} \
    $topwin(enhan_name).current_image {top frame center fillx} \
    $topwin(enhan_name).perform {bottom frame center fillx}

}
