# **********************************************************************
# Computer Vision/Image Processing Tool Project - Dr. Scott Umbaugh SIUE
# **********************************************************************
#
#             File Name: enhan_histogram.tcl
#           Description: 
#         Related Files: 
#   Initial Coding Date: Tue Aug 20 17:02:29 CDT 1996
#           Portability: TCL script file
#            References:
#             Author(s): Yansheng Wei, Mark Zuke
#                        Southern Illinois University @ Edwardsville
#
## Copyright (C) 1996 SIUE - by Scott Umbaugh, Mark Zuke, and Yansheng Wei.
##
## Permission to use, copy, modify, and distribute this software and its
## documentation for any purpose and without fee is hereby granted, provided
## that the above copyright notice appear in all copies and that both that
## copyright notice and this permission notice appear in supporting
## documentation.  This software is provided "as is" without express or
## implied warranty.
##
# RCS (Revision Control System) Information
# ...Added automatically by RCS 
#
## $Log: enhan_histogram.tcl,v $
## Revision 1.20  1997/07/02 22:29:14  yawei
## gui configuration done
##
## Revision 1.19  1997/03/12 00:54:16  yawei
## fixed arrow button
##
## Revision 1.18  1997/03/11 20:56:03  yawei
## Tcl/Tk script upgrading from tcl7.3/tk3.6 to tcl7.6/tk4.2
## compatible. This process is automated with tkboost perl
## script. @ Tue Mar 11 14:51:36 CST 1997
##
## Revision 1.17  1996/12/31 21:15:33  yawei
## histo_spec ==> hist_spec
##
# Revision 1.16  1996/11/19  03:52:29  yawei
# Tried to fix the hist_spec bug, but not successfull
#
# Revision 1.15  1996/11/18  14:31:51  yawei
# Changed default window size.
#
# Revision 1.14  1996/11/18  14:27:23  yawei
# Added choice to "BYTE clipping" to gray_level_multiplication.
#
# Revision 1.13  1996/11/16  00:38:55  yawei
# tried to fix the hist_spec problem, but don't whether it is
# fixed or not.
#
# Revision 1.12  1996/11/13  20:51:07  yawei
# Added clipping percentage for hist_stretch
#
# Revision 1.11  1996/11/12  15:46:56  yawei
# nged default for hist_stretch to 0.025
#
# Revision 1.10  1996/11/08  17:49:40  yawei
# added default "50 50" to hist_stretch
#
# Revision 1.9  1996/10/22  19:31:22  yawei
# added adaptive_constrast
#
# Revision 1.8  1996/10/16  03:43:41  yawei
# general change
#
# Revision 1.7  1996/09/27  18:30:42  mzuke
#  made window resizable
#
# Revision 1.6  1996/09/25  14:00:10  mzuke
# changed entry box bindings to eliminate '\x0d' after
# hitting return; used procedure 'endEntry' in analysis.tcl
# also added circulation to some entry boxes upon hitting return
#
# Revision 1.5  1996/09/18  15:06:09  mzuke
# changed 'symbol' font calls to full description
# of font for portability\
#
# Revision 1.4  1996/09/14  02:57:54  yawei
# Added handle to the out-of-range (keep or zero) for gray_linear
#
# Revision 1.3  1996/09/11  15:26:22  yawei
# changed range of gray_linear to 0-255
#
# Revision 1.2  1996/09/01  15:07:33  mzuke
# 
# tried to fix hist_spec, but could
# find no problem
#
# Revision 1.1  1996/08/21  19:31:18  yawei
# Initial revision
#
#
#****************************************************************************
# procedure to show window $topwin(enhan_name).
proc histogram { } {# xf ignore me 7

  global tk_version
  global topwin
  global toplevel_position
  global GuiColor
  global GuiMisc
  global GUI_DEBUG

  if [ winfo exists  $topwin(enhan_name).info] {
     set tempname $topwin(enhan_name);\
destroy $topwin(enhan_name).info;\
set topwin(enhan_name) $tempname;}
  if [ winfo exists  $topwin(enhan_name).current_image] {
     set tempname $topwin(enhan_name);\
destroy $topwin(enhan_name).current_image;\
set topwin(enhan_name) $tempname;}
  if [ winfo exists  $topwin(enhan_name).perform] {
     set tempname $topwin(enhan_name);\
destroy $topwin(enhan_name).perform;\
set topwin(enhan_name) $tempname;}
  wm positionfrom  $topwin(enhan_name) user
  wm sizefrom  $topwin(enhan_name) user

  wm geometry $topwin(enhan_name) $topwin(enhan_histogram)[get_pos $topwin(enhan_name)]
  wm maxsize $topwin(enhan_name) [lindex $topwin(enhan_histogram_max) 0] \
  	[lindex $topwin(enhan_histogram_max) 1]
  wm minsize $topwin(enhan_name) [lindex $topwin(enhan_histogram_min) 0] \
  	[lindex $topwin(enhan_histogram_min) 1]
  wm title $topwin(enhan_name) {ENHANCEMENT->Histograms}

  # build widget $topwin(enhan_name).info
  frame $topwin(enhan_name).info \
    -background "$GuiColor(frame_bg)" \
    -borderwidth {0}

  # build widget $topwin(enhan_name).info.frame0
  frame $topwin(enhan_name).info.frame0 \
    -background "$GuiColor(frame_bg)" \
    -borderwidth {2} \
    -relief {ridge}

  # build widget $topwin(enhan_name).info.frame0.radiobutton0
	radiobutton $topwin(enhan_name).info.frame0.radiobutton0 -padx {1} -pady {1} -highlightthickness {0}  \
    -activebackground "$GuiColor(btn_act_bg)" \
    -background "$GuiColor(btn_bg)" \
    -relief {flat} \
    -text {Histogram equalization} \
    -value {histeq} \
    -variable {enhan(hist)}

  # build widget $topwin(enhan_name).info.frame0.radiobutton1
	radiobutton $topwin(enhan_name).info.frame0.radiobutton1 -padx {1} -pady {1} -highlightthickness {0}  \
    -activebackground "$GuiColor(btn_act_bg)" \
    -background "$GuiColor(btn_bg)" \
    -relief {flat} \
    -text {Value} \
    -value {3} \
    -variable {enhan(hist_band)}

  # build widget $topwin(enhan_name).info.frame0.radiobutton2
	radiobutton $topwin(enhan_name).info.frame0.radiobutton2 -padx {1} -pady {1} -highlightthickness {0}  \
    -activebackground "$GuiColor(btn_act_bg)" \
    -background "$GuiColor(btn_bg)" \
    -relief {flat} \
    -text {Red} \
    -value {0} \
    -variable {enhan(hist_band)}

  # build widget $topwin(enhan_name).info.frame0.radiobutton3
	radiobutton $topwin(enhan_name).info.frame0.radiobutton3 -padx {1} -pady {1} -highlightthickness {0}  \
    -activebackground "$GuiColor(btn_act_bg)" \
    -background "$GuiColor(btn_bg)" \
    -relief {flat} \
    -text {Green} \
    -value {1} \
    -variable {enhan(hist_band)}

  # build widget $topwin(enhan_name).info.frame0.radiobutton4
	radiobutton $topwin(enhan_name).info.frame0.radiobutton4 -padx {1} -pady {1} -highlightthickness {0}  \
    -activebackground "$GuiColor(btn_act_bg)" \
    -background "$GuiColor(btn_bg)" \
    -relief {flat} \
    -text {Blue} \
    -value {2} \
    -variable {enhan(hist_band)}

  # build widget $topwin(enhan_name).info.frame0.label5
  label $topwin(enhan_name).info.frame0.label5 \
    -background "$GuiColor(label_bg)" \
    -text {     on band:}

  # pack widget $topwin(enhan_name).info.frame0
  pack append $topwin(enhan_name).info.frame0 \
    $topwin(enhan_name).info.frame0.radiobutton0 {left frame center} \
    $topwin(enhan_name).info.frame0.label5 {left frame center expand} \
    $topwin(enhan_name).info.frame0.radiobutton1 {left frame center expand} \
    $topwin(enhan_name).info.frame0.radiobutton2 {left frame center expand} \
    $topwin(enhan_name).info.frame0.radiobutton3 {left frame center expand} \
    $topwin(enhan_name).info.frame0.radiobutton4 {left frame center expand}

  # build widget $topwin(enhan_name).info.frame1
  frame $topwin(enhan_name).info.frame1 \
    -background "$GuiColor(frame_bg)" \
    -borderwidth {2} \
    -relief {ridge}

  # build widget $topwin(enhan_name).info.frame1.radiobutton6
	radiobutton $topwin(enhan_name).info.frame1.radiobutton6 -padx {1} -pady {1} -highlightthickness {0}  \
    -activebackground "$GuiColor(btn_act_bg)" \
    -background "$GuiColor(btn_bg)" \
    -relief {flat} \
    -text {Histogram slide        } \
    -value {hist_slide} \
    -variable {enhan(hist)}

  # build widget $topwin(enhan_name).info.frame1.frame7
  frame $topwin(enhan_name).info.frame1.frame7 \
    -background "$GuiColor(frame_bg)" \
    -borderwidth {2}

  # build widget $topwin(enhan_name).info.frame1.frame7.radiobutton11
	radiobutton $topwin(enhan_name).info.frame1.frame7.radiobutton11 -padx {1} -pady {1} -highlightthickness {0}  \
    -activebackground "$GuiColor(btn_act_bg)" \
    -background "$GuiColor(btn_bg)" \
    -relief {flat} \
    -text {up     } \
    -value {1} \
    -variable {enhan(hist_slide_dir)}

  # build widget $topwin(enhan_name).info.frame1.frame7.radiobutton12
	radiobutton $topwin(enhan_name).info.frame1.frame7.radiobutton12 -padx {1} -pady {1} -highlightthickness {0}  \
    -activebackground "$GuiColor(btn_act_bg)" \
    -background "$GuiColor(btn_bg)" \
    -relief {flat} \
    -text {down} \
    -value {-1} \
    -variable {enhan(hist_slide_dir)}

  # pack widget $topwin(enhan_name).info.frame1.frame7
  pack append $topwin(enhan_name).info.frame1.frame7 \
    $topwin(enhan_name).info.frame1.frame7.radiobutton11 {top frame center expand }\
    $topwin(enhan_name).info.frame1.frame7.radiobutton12 {top frame center expand } 

  # build widget $topwin(enhan_name).info.frame1.frame8
  frame $topwin(enhan_name).info.frame1.frame8 \
    -background "$GuiColor(frame_bg)" \
    -borderwidth {2}

  # build widget $topwin(enhan_name).info.frame1.frame8.frame0
  frame $topwin(enhan_name).info.frame1.frame8.frame0 \
    -background "$GuiColor(frame_bg)" \
    -borderwidth {2}

  # build widget $topwin(enhan_name).info.frame1.frame8.frame0.label1
  label $topwin(enhan_name).info.frame1.frame8.frame0.label1 \
    -background "$GuiColor(label_bg)" \
    -borderwidth {0} \
    -text {   by the amount:}

  # build widget $topwin(enhan_name).info.frame1.frame8.frame0.value
  entry $topwin(enhan_name).info.frame1.frame8.frame0.value \
    -background "$GuiColor(entry_bg)" \
	 -foreground "$GuiColor(entry_fg)" \
    -relief {sunken} \
    -textvariable {enhan(hist_slide_value)} \
    -width {5}

# bind return to do nothing
 endEntry $topwin(enhan_name).info.frame1.frame8.frame0.value

  # build widget $topwin(enhan_name).info.frame1.frame8.frame0.menubutton2
	menubutton $topwin(enhan_name).info.frame1.frame8.frame0.menubutton2 -padx {1} -pady {1} -highlightthickness {0}  \
    -activebackground "$GuiColor(btn_act_bg)" \
    -background "$GuiColor(btn_bg)" \
    -font "$GuiMisc(pop_up_fn)" \
    -relief "$GuiMisc(pop_up_relief)" \
    -text "$GuiMisc(pop_up_text)" \
    -width {2} 

  bind $topwin(enhan_name).info.frame1.frame8.frame0.menubutton2 <Button-1> {
  MenuPopupPost $topwin(enhan_name).info.frame1.frame8.frame0.menubutton2.menu %X %Y}
  bind $topwin(enhan_name).info.frame1.frame8.frame0.menubutton2 <ButtonRelease-1> {
  MenuPopupRelease $topwin(enhan_name).info.frame1.frame8.frame0.menubutton2.menu %W}

  # build widget $topwin(enhan_name).info.frame1.frame8.frame0.menubutton2.menu
  menu $topwin(enhan_name).info.frame1.frame8.frame0.menubutton2.menu \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)"
  $topwin(enhan_name).info.frame1.frame8.frame0.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -command {set enhan(hist_slide_value) 10} \
    -label { 10} \
    -state {active}
  $topwin(enhan_name).info.frame1.frame8.frame0.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -command {set enhan(hist_slide_value) 20} \
    -label { 20}
  $topwin(enhan_name).info.frame1.frame8.frame0.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -command {set enhan(hist_slide_value) 30} \
    -label { 30}
  $topwin(enhan_name).info.frame1.frame8.frame0.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -command {set enhan(hist_slide_value) 40} \
    -label { 40}
  $topwin(enhan_name).info.frame1.frame8.frame0.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -command {set enhan(hist_slide_value) 50} \
    -label { 50}
  $topwin(enhan_name).info.frame1.frame8.frame0.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -command {set enhan(hist_slide_value) 75} \
    -label { 75}
  $topwin(enhan_name).info.frame1.frame8.frame0.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -command {set enhan(hist_slide_value) 100} \
    -label {100}
  bindtags $topwin(enhan_name).info.frame1.frame8.frame0.menubutton2.menu {Menu all}
  bind $topwin(enhan_name).info.frame1.frame8.frame0.menubutton2.menu <B1-Motion> {
  MenuPopupMotion $topwin(enhan_name).info.frame1.frame8.frame0.menubutton2.menu %W %X %Y}
  bind $topwin(enhan_name).info.frame1.frame8.frame0.menubutton2.menu <ButtonRelease-1> {
  MenuPopupRelease $topwin(enhan_name).info.frame1.frame8.frame0.menubutton2.menu %W}

  # pack widget $topwin(enhan_name).info.frame1.frame8.frame0
  pack append $topwin(enhan_name).info.frame1.frame8.frame0 \
    $topwin(enhan_name).info.frame1.frame8.frame0.label1 {left frame center fill} \
    $topwin(enhan_name).info.frame1.frame8.frame0.value {left frame center expand fill} \
    $topwin(enhan_name).info.frame1.frame8.frame0.menubutton2 {right frame center fill}

  # pack widget $topwin(enhan_name).info.frame1.frame8
  pack append $topwin(enhan_name).info.frame1.frame8 \
    $topwin(enhan_name).info.frame1.frame8.frame0 {top frame center fillx}

  # pack widget $topwin(enhan_name).info.frame1
  pack append $topwin(enhan_name).info.frame1 \
    $topwin(enhan_name).info.frame1.radiobutton6 {left frame center} \
    $topwin(enhan_name).info.frame1.frame7 {left frame center} \
    $topwin(enhan_name).info.frame1.frame8 {left frame center}

  # build widget $topwin(enhan_name).info.frame2
  frame $topwin(enhan_name).info.frame2 \
    -background "$GuiColor(frame_bg)" \
    -borderwidth {2} \
    -relief {ridge}

  # build widget $topwin(enhan_name).info.frame2.frame1
  frame $topwin(enhan_name).info.frame2.frame1 \
    -background "$GuiColor(frame_bg)" \
	 -height {56} \
    -borderwidth {2}

  # build widget $topwin(enhan_name).info.frame2.frame1.frame7
  frame $topwin(enhan_name).info.frame2.frame1.frame7 \
    -background "$GuiColor(frame_bg)" \
	 -height {56} \
    -borderwidth {2}

  # build widget $topwin(enhan_name).info.frame2.frame1.frame7.radiobutton11
	radiobutton $topwin(enhan_name).info.frame2.frame1.frame7.radiobutton11 -padx {1} -pady {1} -highlightthickness {0}  \
    -activebackground "$GuiColor(btn_act_bg)" \
    -background "$GuiColor(btn_bg)" \
    -command {set enhan(hist_shrink_lower) 0
  pack append $topwin(enhan_name).info.frame2.frame1.frame9 \
    $topwin(enhan_name).info.frame2.frame1.frame9.frame9 {top frame center}
set enhan(hist_shrink_upper) 255} \
    -relief {flat} \
    -text {Histogram stretch    } \
    -value {hist_stretch} \
    -variable {enhan(hist)}

  # build widget $topwin(enhan_name).info.frame2.frame1.frame7.radiobutton12
	radiobutton $topwin(enhan_name).info.frame2.frame1.frame7.radiobutton12 -padx {1} -pady {1} -highlightthickness {0}  \
    -activebackground "$GuiColor(btn_act_bg)" \
    -background "$GuiColor(btn_bg)" \
    -command {set enhan(hist_shrink_lower) 1
  pack forget $topwin(enhan_name).info.frame2.frame1.frame9.frame9
set enhan(hist_shrink_upper) 254} \
    -relief {flat} \
    -text {Histogram shrink      } \
    -value {hist_shrink} \
    -variable {enhan(hist)}

  # pack widget $topwin(enhan_name).info.frame2.frame1.frame7
  pack append $topwin(enhan_name).info.frame2.frame1.frame7 \
    $topwin(enhan_name).info.frame2.frame1.frame7.radiobutton12 {top frame center} \
    $topwin(enhan_name).info.frame2.frame1.frame7.radiobutton11 {top frame center}

  # build widget $topwin(enhan_name).info.frame2.frame1.frame8
  frame $topwin(enhan_name).info.frame2.frame1.frame8 \
    -background "$GuiColor(frame_bg)" \
    -borderwidth {2}

  # build widget $topwin(enhan_name).info.frame2.frame1.frame8.frame0
  frame $topwin(enhan_name).info.frame2.frame1.frame8.frame0 \
    -background "$GuiColor(frame_bg)" \
    -borderwidth {2}

  # build widget $topwin(enhan_name).info.frame2.frame1.frame8.frame0.label1
  label $topwin(enhan_name).info.frame2.frame1.frame8.frame0.label1 \
    -background "$GuiColor(label_bg)" \
    -borderwidth {0} \
    -text {to a lower limit:}

  # build widget $topwin(enhan_name).info.frame2.frame1.frame8.frame0.value
  entry $topwin(enhan_name).info.frame2.frame1.frame8.frame0.value \
    -background "$GuiColor(entry_bg)" \
	 -foreground "$GuiColor(entry_fg)" \
    -relief {sunken} \
    -textvariable {enhan(hist_shrink_lower)} \
    -width {5}

# bind return to do nothing
 endEntry $topwin(enhan_name).info.frame2.frame1.frame8.frame0.value 0 \
 	$topwin(enhan_name).info.frame2.frame1.frame8.frame13.value \
  	$topwin(enhan_name).info.frame2.frame1.frame9.frame9.frame5.entry3 

  # build widget $topwin(enhan_name).info.frame2.frame1.frame8.frame0.menubutton2
	menubutton $topwin(enhan_name).info.frame2.frame1.frame8.frame0.menubutton2 -padx {1} -pady {1} -highlightthickness {0}  \
    -activebackground "$GuiColor(btn_act_bg)" \
    -background "$GuiColor(btn_bg)" \
    -font "$GuiMisc(pop_up_fn)" \
    -relief "$GuiMisc(pop_up_relief)" \
    -text "$GuiMisc(pop_up_text)" \
    -width {2}
  bind $topwin(enhan_name).info.frame2.frame1.frame8.frame0.menubutton2 <Button-1> {
  MenuPopupPost $topwin(enhan_name).info.frame2.frame1.frame8.frame0.menubutton2.menu %X %Y}
  bind $topwin(enhan_name).info.frame1.frame8.frame0.menubutton2 <ButtonRelease-1> {
  MenuPopupRelease $topwin(enhan_name).info.frame2.frame1.frame8.frame0.menubutton2.menu %W}

  # build widget $topwin(enhan_name).info.frame2.frame1.frame8.frame0.menubutton2.menu
  menu $topwin(enhan_name).info.frame2.frame1.frame8.frame0.menubutton2.menu \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)"
  $topwin(enhan_name).info.frame2.frame1.frame8.frame0.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -command {set enhan(hist_shrink_lower) 0} \
    -label {  0}
  $topwin(enhan_name).info.frame2.frame1.frame8.frame0.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -command {set enhan(hist_shrink_lower) 1} \
    -label {  1}
  $topwin(enhan_name).info.frame2.frame1.frame8.frame0.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -command {set enhan(hist_shrink_lower) 10} \
    -label { 10}
  $topwin(enhan_name).info.frame2.frame1.frame8.frame0.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -command {set enhan(hist_shrink_lower) 20} \
    -label { 20}
  $topwin(enhan_name).info.frame2.frame1.frame8.frame0.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -command {set enhan(hist_shrink_lower) 30} \
    -label { 30}
  $topwin(enhan_name).info.frame2.frame1.frame8.frame0.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -command {set enhan(hist_shrink_lower) 40} \
    -label { 40}
  $topwin(enhan_name).info.frame2.frame1.frame8.frame0.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -command {set enhan(hist_shrink_lower) 50} \
    -label { 50}
  $topwin(enhan_name).info.frame2.frame1.frame8.frame0.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -command {set enhan(hist_shrink_lower) 75} \
    -label { 75}
  $topwin(enhan_name).info.frame2.frame1.frame8.frame0.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -command {set enhan(hist_shrink_lower) 100} \
    -label {100}

  bindtags $topwin(enhan_name).info.frame2.frame1.frame8.frame0.menubutton2.menu  {Menu all}
  bind $topwin(enhan_name).info.frame2.frame1.frame8.frame0.menubutton2.menu  <Button-1> {
  MenuPopupPost $topwin(enhan_name).info.frame2.frame1.frame8.frame0.menubutton2.menu %X %Y}
  bind $topwin(enhan_name).info.frame2.frame1.frame8.frame0.menubutton2.menu  <ButtonRelease-1> {
  MenuPopupRelease $topwin(enhan_name).info.frame2.frame1.frame8.frame0.menubutton2.menu  %W}

  # pack widget $topwin(enhan_name).info.frame2.frame1.frame8.frame0
  pack append $topwin(enhan_name).info.frame2.frame1.frame8.frame0 \
    $topwin(enhan_name).info.frame2.frame1.frame8.frame0.label1 {left frame center fill} \
    $topwin(enhan_name).info.frame2.frame1.frame8.frame0.value {left frame center expand fill} \
    $topwin(enhan_name).info.frame2.frame1.frame8.frame0.menubutton2 {right frame center fill}

  # build widget $topwin(enhan_name).info.frame2.frame1.frame8.frame13
  frame $topwin(enhan_name).info.frame2.frame1.frame8.frame13 \
    -background "$GuiColor(frame_bg)" \
    -borderwidth {2}

  # build widget $topwin(enhan_name).info.frame2.frame1.frame8.frame13.label1
  label $topwin(enhan_name).info.frame2.frame1.frame8.frame13.label1 \
    -background "$GuiColor(label_bg)" \
    -borderwidth {0} \
    -text {and an upper limit:}

  # build widget $topwin(enhan_name).info.frame2.frame1.frame8.frame13.value
  entry $topwin(enhan_name).info.frame2.frame1.frame8.frame13.value \
    -background "$GuiColor(entry_bg)" \
	 -foreground "$GuiColor(entry_fg)" \
    -relief {sunken} \
    -textvariable {enhan(hist_shrink_upper)} \
    -width {5}

# bind return to do nothing
 endEntry $topwin(enhan_name).info.frame2.frame1.frame8.frame13.value 0  \
 	$topwin(enhan_name).info.frame2.frame1.frame9.frame9.frame6.entry3  \
 	$topwin(enhan_name).info.frame2.frame1.frame8.frame0.value 


  # build widget $topwin(enhan_name).info.frame2.frame1.frame8.frame13.menubutton2
	menubutton $topwin(enhan_name).info.frame2.frame1.frame8.frame13.menubutton2 -padx {1} -pady {1} -highlightthickness {0}  \
    -activebackground "$GuiColor(btn_act_bg)" \
    -background "$GuiColor(btn_bg)" \
    -font "$GuiMisc(pop_up_fn)" \
    -relief "$GuiMisc(pop_up_relief)" \
    -text "$GuiMisc(pop_up_text)" \
    -width {2}
  bind $topwin(enhan_name).info.frame2.frame1.frame8.frame13.menubutton2 <Button-1> {
  MenuPopupPost $topwin(enhan_name).info.frame2.frame1.frame8.frame13.menubutton2.menu %X %Y}
  bind $topwin(enhan_name).info.frame2.frame1.frame8.frame13.menubutton2 <ButtonRelease-1> {
  MenuPopupRelease $topwin(enhan_name).info.frame2.frame1.frame8.frame13.menubutton2.menu %W}

  # build widget $topwin(enhan_name).info.frame2.frame1.frame8.frame13.menubutton2.menu
  menu $topwin(enhan_name).info.frame2.frame1.frame8.frame13.menubutton2.menu \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)"
  $topwin(enhan_name).info.frame2.frame1.frame8.frame13.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -command {set enhan(hist_shrink_upper) 10} \
    -label { 10}
  $topwin(enhan_name).info.frame2.frame1.frame8.frame13.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -command {set enhan(hist_shrink_upper) 20} \
    -label { 20}
  $topwin(enhan_name).info.frame2.frame1.frame8.frame13.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -command {set enhan(hist_shrink_upper) 30} \
    -label { 30}
  $topwin(enhan_name).info.frame2.frame1.frame8.frame13.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -command {set enhan(hist_shrink_upper) 40} \
    -label { 40}
  $topwin(enhan_name).info.frame2.frame1.frame8.frame13.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -command {set enhan(hist_shrink_upper) 50} \
    -label { 50}
  $topwin(enhan_name).info.frame2.frame1.frame8.frame13.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -command {set enhan(hist_shrink_upper) 75} \
    -label { 75}
  $topwin(enhan_name).info.frame2.frame1.frame8.frame13.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -command {set enhan(hist_shrink_upper) 100} \
    -label {100}
  $topwin(enhan_name).info.frame2.frame1.frame8.frame13.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -command {set enhan(hist_shrink_upper) 200} \
    -label {200}
  $topwin(enhan_name).info.frame2.frame1.frame8.frame13.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -command {set enhan(hist_shrink_upper) 254} \
    -label {254}
  $topwin(enhan_name).info.frame2.frame1.frame8.frame13.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -command {set enhan(hist_shrink_upper) 255} \
    -label {255}

  bindtags $topwin(enhan_name).info.frame2.frame1.frame8.frame13.menubutton2.menu {Menu all}
  bind $topwin(enhan_name).info.frame2.frame1.frame8.frame13.menubutton2.menu <Button-1> {
  MenuPopupPost $topwin(enhan_name).info.frame2.frame1.frame8.frame13.menubutton2.menu %X %Y}
  bind $topwin(enhan_name).info.frame2.frame1.frame8.frame13.menubutton2.menu <ButtonRelease-1> {
  MenuPopupRelease $topwin(enhan_name).info.frame2.frame1.frame8.frame13.menubutton2.menu %W}

  # pack widget $topwin(enhan_name).info.frame2.frame1.frame8.frame13
  pack append $topwin(enhan_name).info.frame2.frame1.frame8.frame13 \
    $topwin(enhan_name).info.frame2.frame1.frame8.frame13.label1 {left frame center fill} \
    $topwin(enhan_name).info.frame2.frame1.frame8.frame13.value {left frame center expand fill} \
    $topwin(enhan_name).info.frame2.frame1.frame8.frame13.menubutton2 {right frame center fill}

  # pack widget $topwin(enhan_name).info.frame2.frame1.frame8
  pack append $topwin(enhan_name).info.frame2.frame1.frame8 \
    $topwin(enhan_name).info.frame2.frame1.frame8.frame0 {left frame center fillx} \
    $topwin(enhan_name).info.frame2.frame1.frame8.frame13 {left frame center fillx}

  # build widget $topwin(enhan_name).info.frame2.frame1.frame9
  frame $topwin(enhan_name).info.frame2.frame1.frame9\
    -background "$GuiColor(frame_bg)" \
	 -height {30} \
    -borderwidth {2}

  # build widget $topwin(enhan_name).info.frame2.frame1.frame9.frame9
  frame $topwin(enhan_name).info.frame2.frame1.frame9.frame9 \
    -background "$GuiColor(frame_bg)" \
    -borderwidth {2}

  # build widget $topwin(enhan_name).info.frame2.frame1.frame9.frame9.frame5
  frame $topwin(enhan_name).info.frame2.frame1.frame9.frame9.frame5 \
    -background "$GuiColor(frame_bg)" \
    -borderwidth {0}

  # build widget $topwin(enhan_name).info.frame2.frame1.frame9.frame9.frame5.label2
  label $topwin(enhan_name).info.frame2.frame1.frame9.frame9.frame5.label2 \
    -background "$GuiColor(label_bg)" \
    -text {High clip percent: }

  # build widget $topwin(enhan_name).info.frame2.frame1.frame9.frame9.frame5.entry3
  entry $topwin(enhan_name).info.frame2.frame1.frame9.frame9.frame5.entry3 \
    -background "$GuiColor(entry_bg)" \
	 -foreground "$GuiColor(entry_fg)" \
    -relief {sunken} \
    -textvariable {enhan(hist_h_c)} \
    -width {5}
  endEntry $topwin(enhan_name).info.frame2.frame1.frame9.frame9.frame5.entry3  0 \
   $topwin(enhan_name).info.frame2.frame1.frame8.frame0.value \
   $topwin(enhan_name).info.frame2.frame1.frame9.frame9.frame6.entry3

  # build widget $topwin(enhan_name).info.frame2.frame1.frame9.frame9.frame5.menubutton4
	menubutton $topwin(enhan_name).info.frame2.frame1.frame9.frame9.frame5.menubutton4 -padx {1} -pady {1} -highlightthickness {0}  \
    -activebackground "$GuiColor(btn_act_bg)" \
    -background "$GuiColor(btn_bg)" \
    -font "$GuiMisc(pop_up_fn)" \
    -relief "$GuiMisc(pop_up_relief)" \
    -text "$GuiMisc(pop_up_text)" \
    -width {2}
  # bindings
  bind $topwin(enhan_name).info.frame2.frame1.frame9.frame9.frame5.menubutton4 <Button-1> {MenuPopupPost $topwin(enhan_name).info.frame2.frame1.frame9.frame9.frame5.menubutton4.menu %X %Y}
  bind $topwin(enhan_name).info.frame2.frame1.frame9.frame9.frame5.menubutton4 <ButtonRelease-1> {MenuPopupRelease $topwin(enhan_name).info.frame2.frame1.frame9.frame9.frame5.menubutton4.menu %W}

  # build widget $topwin(enhan_name).info.frame2.frame1.frame9.frame9.frame5.menubutton4.menu
  menu $topwin(enhan_name).info.frame2.frame1.frame9.frame9.frame5.menubutton4.menu \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)"
  $topwin(enhan_name).info.frame2.frame1.frame9.frame9.frame5.menubutton4.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -command {set enhan(hist_h_c) 0.01} \
    -label { 0.01 }
  $topwin(enhan_name).info.frame2.frame1.frame9.frame9.frame5.menubutton4.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -command {set enhan(hist_h_c) 0.02} \
    -label { 0.02 }
  $topwin(enhan_name).info.frame2.frame1.frame9.frame9.frame5.menubutton4.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -command {set enhan(hist_h_c) 0.03} \
    -label { 0.03 }
  $topwin(enhan_name).info.frame2.frame1.frame9.frame9.frame5.menubutton4.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -command {set enhan(hist_h_c) 0.04} \
    -label { 0.04 }
  $topwin(enhan_name).info.frame2.frame1.frame9.frame9.frame5.menubutton4.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -command {set enhan(hist_h_c) 0.05} \
    -label { 0.05 }
  $topwin(enhan_name).info.frame2.frame1.frame9.frame9.frame5.menubutton4.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -command {set enhan(hist_h_c) 0.075} \
    -label { 0.075}
  $topwin(enhan_name).info.frame2.frame1.frame9.frame9.frame5.menubutton4.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -command {set enhan(hist_h_c) 0.10} \
    -label { 0.10 }
  $topwin(enhan_name).info.frame2.frame1.frame9.frame9.frame5.menubutton4.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -command {set enhan(hist_h_c) 0.15} \
    -label { 0.15 }
  bindtags $topwin(enhan_name).info.frame2.frame1.frame9.frame9.frame5.menubutton4.menu  {Menu all}
  # bindings
  bind $topwin(enhan_name).info.frame2.frame1.frame9.frame9.frame5.menubutton4.menu <B1-Motion> {MenuPopupMotion $topwin(enhan_name).info.frame2.frame1.frame9.frame9.frame5.menubutton4.menu %W %X %Y}
  bind $topwin(enhan_name).info.frame2.frame1.frame9.frame9.frame5.menubutton4.menu <ButtonRelease-1> {MenuPopupRelease $topwin(enhan_name).info.frame2.frame1.frame9.frame9.frame5.menubutton4.menu %W}

  # pack widget $topwin(enhan_name).info.frame2.frame1.frame9.frame9.frame5
  pack append $topwin(enhan_name).info.frame2.frame1.frame9.frame9.frame5 \
    $topwin(enhan_name).info.frame2.frame1.frame9.frame9.frame5.label2 {left frame center} \
    $topwin(enhan_name).info.frame2.frame1.frame9.frame9.frame5.entry3 {left frame center} \
    $topwin(enhan_name).info.frame2.frame1.frame9.frame9.frame5.menubutton4 {right frame center filly}

  # build widget $topwin(enhan_name).info.frame2.frame1.frame9.frame9.frame6
  frame $topwin(enhan_name).info.frame2.frame1.frame9.frame9.frame6 \
    -background "$GuiColor(frame_bg)" \
    -borderwidth {0}

  # build widget $topwin(enhan_name).info.frame2.frame1.frame9.frame9.frame6.label2
  label $topwin(enhan_name).info.frame2.frame1.frame9.frame9.frame6.label2 \
    -background "$GuiColor(label_bg)" \
    -text {Low clip percent: }

  # build widget $topwin(enhan_name).info.frame2.frame1.frame9.frame9.frame6.entry3
  entry $topwin(enhan_name).info.frame2.frame1.frame9.frame9.frame6.entry3 \
    -background "$GuiColor(entry_bg)" \
	 -foreground "$GuiColor(entry_fg)" \
    -relief {sunken} \
    -textvariable {enhan(hist_l_c)} \
    -width {5}

  endEntry $topwin(enhan_name).info.frame2.frame1.frame9.frame9.frame6.entry3  0 \
  	$topwin(enhan_name).info.frame2.frame1.frame9.frame9.frame5.entry3 \
   $topwin(enhan_name).info.frame2.frame1.frame8.frame13.value 

  # build widget $topwin(enhan_name).info.frame2.frame1.frame9.frame9.frame6.menubutton4
	menubutton $topwin(enhan_name).info.frame2.frame1.frame9.frame9.frame6.menubutton4 -padx {1} -pady {1} -highlightthickness {0}  \
    -activebackground "$GuiColor(btn_act_bg)" \
    -background "$GuiColor(btn_bg)" \
    -font "$GuiMisc(pop_up_fn)" \
    -relief "$GuiMisc(pop_up_relief)" \
    -text "$GuiMisc(pop_up_text)" \
    -width {2}
  # bindings
  bind $topwin(enhan_name).info.frame2.frame1.frame9.frame9.frame6.menubutton4 <Button-1> {MenuPopupPost $topwin(enhan_name).info.frame2.frame1.frame9.frame9.frame6.menubutton4.menu %X %Y}
  bind $topwin(enhan_name).info.frame2.frame1.frame9.frame9.frame6.menubutton4 <ButtonRelease-1> {MenuPopupRelease $topwin(enhan_name).info.frame2.frame1.frame9.frame9.frame6.menubutton4.menu %W}

  # build widget $topwin(enhan_name).info.frame2.frame1.frame9.frame9.frame6.menubutton4.menu
  menu $topwin(enhan_name).info.frame2.frame1.frame9.frame9.frame6.menubutton4.menu \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)"
  $topwin(enhan_name).info.frame2.frame1.frame9.frame9.frame6.menubutton4.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -command {set enhan(hist_l_c) 0.01} \
    -label { 0.01 }
  $topwin(enhan_name).info.frame2.frame1.frame9.frame9.frame6.menubutton4.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -command {set enhan(hist_l_c) 0.02} \
    -label { 0.02 }
  $topwin(enhan_name).info.frame2.frame1.frame9.frame9.frame6.menubutton4.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -command {set enhan(hist_l_c) 0.03} \
    -label { 0.03 }
  $topwin(enhan_name).info.frame2.frame1.frame9.frame9.frame6.menubutton4.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -command {set enhan(hist_l_c) 0.04} \
    -label { 0.04 }
  $topwin(enhan_name).info.frame2.frame1.frame9.frame9.frame6.menubutton4.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -command {set enhan(hist_l_c) 0.05} \
    -label { 0.05 }
  $topwin(enhan_name).info.frame2.frame1.frame9.frame9.frame6.menubutton4.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -command {set enhan(hist_l_c) 0.075} \
    -label { 0.075}
  $topwin(enhan_name).info.frame2.frame1.frame9.frame9.frame6.menubutton4.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -command {set enhan(hist_l_c) 0.10} \
    -label { 0.10 }
  $topwin(enhan_name).info.frame2.frame1.frame9.frame9.frame6.menubutton4.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -command {set enhan(hist_l_c) 0.15} \
    -label { 0.15 }
  bindtags $topwin(enhan_name).info.frame2.frame1.frame9.frame9.frame6.menubutton4.menu {Menu all}
  # bindings
  bind $topwin(enhan_name).info.frame2.frame1.frame9.frame9.frame6.menubutton4.menu <B1-Motion> {MenuPopupMotion $topwin(enhan_name).info.frame2.frame1.frame9.frame9.frame6.menubutton4.menu %W %X %Y}
  bind $topwin(enhan_name).info.frame2.frame1.frame9.frame9.frame6.menubutton4.menu <ButtonRelease-1> {MenuPopupRelease $topwin(enhan_name).info.frame2.frame1.frame9.frame9.frame6.menubutton4.menu %W}

  # pack widget $topwin(enhan_name).info.frame2.frame1.frame9.frame9.frame6
  pack append $topwin(enhan_name).info.frame2.frame1.frame9.frame9.frame6 \
    $topwin(enhan_name).info.frame2.frame1.frame9.frame9.frame6.label2 {left frame center} \
    $topwin(enhan_name).info.frame2.frame1.frame9.frame9.frame6.entry3 {left frame center} \
    $topwin(enhan_name).info.frame2.frame1.frame9.frame9.frame6.menubutton4 {right frame center filly}

  # pack widget $topwin(enhan_name).info.frame2.frame1.frame9.frame9
  pack append $topwin(enhan_name).info.frame2.frame1.frame9.frame9 \
    $topwin(enhan_name).info.frame2.frame1.frame9.frame9.frame6 {left frame center expand} \
    $topwin(enhan_name).info.frame2.frame1.frame9.frame9.frame5 {right frame center expand} 

  # pack widget $topwin(enhan_name).info.frame2.frame1
  pack append $topwin(enhan_name).info.frame2.frame1 \
    $topwin(enhan_name).info.frame2.frame1.frame7 {left frame center filly} \
    $topwin(enhan_name).info.frame2.frame1.frame8 {top frame center}  \
    $topwin(enhan_name).info.frame2.frame1.frame9 {top frame center}

  # pack widget $topwin(enhan_name).info.frame2
  pack append $topwin(enhan_name).info.frame2 \
    $topwin(enhan_name).info.frame2.frame1 {top frame center expand fill}

  # build widget $topwin(enhan_name).info.frame3
  frame $topwin(enhan_name).info.frame3 \
    -background "$GuiColor(frame_bg)" \
    -borderwidth {2} \
    -relief {ridge}

  # build widget $topwin(enhan_name).info.frame3.frame0
  frame $topwin(enhan_name).info.frame3.frame0 \
    -background "$GuiColor(frame_bg)" \
    -borderwidth {2}

  # build widget $topwin(enhan_name).info.frame3.frame0.radiobutton0
	radiobutton $topwin(enhan_name).info.frame3.frame0.radiobutton0 -padx {1} -pady {1} -highlightthickness {0}  \
    -activebackground "$GuiColor(btn_act_bg)" \
    -background "$GuiColor(btn_bg)" \
    -relief {flat} \
	 -command {if {$enhan(hist_band) == "3" } {set enhan(hist_band) "0"} } \
    -text {Local equalization} \
    -value {local_histeq} \
    -variable {enhan(hist)}

  # build widget $topwin(enhan_name).info.frame3.frame0.radiobutton2
	radiobutton $topwin(enhan_name).info.frame3.frame0.radiobutton2 -padx {1} -pady {1} -highlightthickness {0}  \
    -activebackground "$GuiColor(btn_act_bg)" \
    -background "$GuiColor(btn_bg)" \
    -relief {flat} \
    -text {Red} \
    -value {0} \
    -variable {enhan(hist_band)}

  # build widget $topwin(enhan_name).info.frame3.frame0.radiobutton3
	radiobutton $topwin(enhan_name).info.frame3.frame0.radiobutton3 -padx {1} -pady {1} -highlightthickness {0}  \
    -activebackground "$GuiColor(btn_act_bg)" \
    -background "$GuiColor(btn_bg)" \
    -relief {flat} \
    -text {Green} \
    -value {1} \
    -variable {enhan(hist_band)}

  # build widget $topwin(enhan_name).info.frame3.frame0.radiobutton4
	radiobutton $topwin(enhan_name).info.frame3.frame0.radiobutton4 -padx {1} -pady {1} -highlightthickness {0}  \
    -activebackground "$GuiColor(btn_act_bg)" \
    -background "$GuiColor(btn_bg)" \
    -relief {flat} \
    -text {Blue} \
    -value {2} \
    -variable {enhan(hist_band)}

  # build widget $topwin(enhan_name).info.frame3.frame0.label5
  label $topwin(enhan_name).info.frame3.frame0.label5 \
    -background "$GuiColor(label_bg)" \
    -text {     on band:}

  # build widget $topwin(enhan_name).info.frame3.frame0.frame0
  frame $topwin(enhan_name).info.frame3.frame0.frame0 \
    -background "$GuiColor(frame_bg)" \
    -borderwidth {2}

  # build widget $topwin(enhan_name).info.frame3.frame0.frame0.label1
  label $topwin(enhan_name).info.frame3.frame0.frame0.label1 \
    -background "$GuiColor(label_bg)" \
    -borderwidth {0} \
    -text {   blocksize:}

  # build widget $topwin(enhan_name).info.frame3.frame0.frame0.value
  entry $topwin(enhan_name).info.frame3.frame0.frame0.value \
    -background "$GuiColor(entry_bg)" \
	 -foreground "$GuiColor(entry_fg)" \
    -relief {sunken} \
    -textvariable {enhan(hist_leq_size)} \
    -width {5}

# bind return to do nothing
 endEntry $topwin(enhan_name).info.frame3.frame0.frame0.value


  # build widget $topwin(enhan_name).info.frame3.frame0.frame0.menubutton2
	menubutton $topwin(enhan_name).info.frame3.frame0.frame0.menubutton2 -padx {1} -pady {1} -highlightthickness {0}  \
    -activebackground "$GuiColor(btn_act_bg)" \
    -background "$GuiColor(btn_bg)" \
    -font "$GuiMisc(pop_up_fn)" \
    -relief "$GuiMisc(pop_up_relief)" \
    -text "$GuiMisc(pop_up_text)" \
	 -width {2}
  bind $topwin(enhan_name).info.frame3.frame0.frame0.menubutton2 <Button-1> {
  MenuPopupPost $topwin(enhan_name).info.frame3.frame0.frame0.menubutton2.menu %X %Y}
  bind $topwin(enhan_name).info.frame3.frame0.frame0.menubutton2 <ButtonRelease-1> {
  MenuPopupRelease $topwin(enhan_name).info.frame3.frame0.frame0.menubutton2.menu %W}

  # build widget $topwin(enhan_name).info.frame3.frame0.frame0.menubutton2.menu
  menu $topwin(enhan_name).info.frame3.frame0.frame0.menubutton2.menu \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)"
  $topwin(enhan_name).info.frame3.frame0.frame0.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -command {set enhan(hist_leq_size) 4} \
    -label { 4}
  $topwin(enhan_name).info.frame3.frame0.frame0.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -command {set enhan(hist_leq_size) 8} \
    -label { 8}
  $topwin(enhan_name).info.frame3.frame0.frame0.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -command {set enhan(hist_leq_size) 16} \
    -label {16}
  $topwin(enhan_name).info.frame3.frame0.frame0.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -command {set enhan(hist_leq_size) 32} \
    -label {32}
  bindtags $topwin(enhan_name).info.frame3.frame0.frame0.menubutton2.menu  {Menu all}

  bind $topwin(enhan_name).info.frame3.frame0.frame0.menubutton2.menu <Button-1> {
  MenuPopupPost $topwin(enhan_name).info.frame3.frame0.frame0.menubutton2.menu %X %Y}
  bind $topwin(enhan_name).info.frame3.frame0.frame0.menubutton2.menu <ButtonRelease-1> {
  MenuPopupRelease $topwin(enhan_name).info.frame3.frame0.frame0.menubutton2.menu %W}

  # pack widget $topwin(enhan_name).info.frame3.frame0.frame0
  pack append $topwin(enhan_name).info.frame3.frame0.frame0 \
    $topwin(enhan_name).info.frame3.frame0.frame0.label1 {left frame center fill} \
    $topwin(enhan_name).info.frame3.frame0.frame0.value {left frame center expand fill} \
    $topwin(enhan_name).info.frame3.frame0.frame0.menubutton2 {right frame center fill}

  # pack widget $topwin(enhan_name).info.frame3.frame0
  pack append $topwin(enhan_name).info.frame3.frame0 \
    $topwin(enhan_name).info.frame3.frame0.radiobutton0 {left frame center} \
    $topwin(enhan_name).info.frame3.frame0.label5 {left frame center} \
    $topwin(enhan_name).info.frame3.frame0.radiobutton2 {left frame center} \
    $topwin(enhan_name).info.frame3.frame0.radiobutton3 {left frame center} \
    $topwin(enhan_name).info.frame3.frame0.radiobutton4 {left frame center} \
    $topwin(enhan_name).info.frame3.frame0.frame0 {left frame center}

  # build widget $topwin(enhan_name).info.frame3.frame1
  frame $topwin(enhan_name).info.frame3.frame1 \
    -background "$GuiColor(frame_bg)" \
	 -borderwidth {3}

  # build widget $topwin(enhan_name).info.frame3.frame1.radiobutton1
	radiobutton $topwin(enhan_name).info.frame3.frame1.radiobutton1 -padx {1} -pady {1} -highlightthickness {0}  \
    -activebackground "$GuiColor(btn_act_bg)" \
    -background "$GuiColor(btn_bg)" \
    -relief {flat} \
    -text {Adaptive-contrast} \
    -value {adaptive_contrast} \
    -variable {enhan(hist)}

  # build widget $topwin(enhan_name).info.frame3.frame1.frame0
  frame $topwin(enhan_name).info.frame3.frame1.frame0 \
    -background "$GuiColor(frame_bg)" \
    -borderwidth {1}

  # build widget $topwin(enhan_name).info.frame3.frame1.frame0.frame0
  frame $topwin(enhan_name).info.frame3.frame1.frame0.frame0 \
    -background "$GuiColor(frame_bg)"

  # build widget $topwin(enhan_name).info.frame3.frame1.frame0.frame0.label1
  label $topwin(enhan_name).info.frame3.frame1.frame0.frame0.label1 \
    -background "$GuiColor(label_bg)" \
    -borderwidth {0} \
    -text {Local gain factor: }

  # build widget $topwin(enhan_name).info.frame3.frame1.frame0.frame0.value
  entry $topwin(enhan_name).info.frame3.frame1.frame0.frame0.value \
    -background "$GuiColor(entry_bg)" \
	 -foreground "$GuiColor(entry_fg)" \
    -relief {sunken} \
    -textvariable {enhan(adap_k1)} \
    -width {4}
  endEntry $topwin(enhan_name).info.frame3.frame1.frame0.frame0.value 0\
  	 $topwin(enhan_name).info.frame3.frame1.frame0.frame2.value \
  	 $topwin(enhan_name).info.frame3.frame1.frame2.frame3.value

  # build widget $topwin(enhan_name).info.frame3.frame1.frame0.frame0.menubutton2
	menubutton $topwin(enhan_name).info.frame3.frame1.frame0.frame0.menubutton2 -padx {1} -pady {1} -highlightthickness {0}  \
    -activebackground "$GuiColor(btn_act_bg)" \
    -background "$GuiColor(btn_bg)" \
    -font "$GuiMisc(pop_up_fn)" \
    -relief "$GuiMisc(pop_up_relief)" \
    -text "$GuiMisc(pop_up_text)" \
	 -width {2}
  # bindings
  bind $topwin(enhan_name).info.frame3.frame1.frame0.frame0.menubutton2 <Button-1> {MenuPopupPost $topwin(enhan_name).info.frame3.frame1.frame0.frame0.menubutton2.menu %X %Y}
  bind $topwin(enhan_name).info.frame3.frame1.frame0.frame0.menubutton2 <ButtonRelease-1> {MenuPopupRelease $topwin(enhan_name).info.frame3.frame1.frame0.frame0.menubutton2.menu %W}

  # build widget $topwin(enhan_name).info.frame3.frame1.frame0.frame0.menubutton2.menu
  menu $topwin(enhan_name).info.frame3.frame1.frame0.frame0.menubutton2.menu \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)"
  $topwin(enhan_name).info.frame3.frame1.frame0.frame0.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -command {set enhan(adap_k1) 0.2} \
    -label { 0.2 }
  $topwin(enhan_name).info.frame3.frame1.frame0.frame0.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -command {set enhan(adap_k1) 0.5} \
    -label { 0.5 }
  $topwin(enhan_name).info.frame3.frame1.frame0.frame0.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -command {set enhan(adap_k1) 0.6} \
    -label { 0.6 }
  $topwin(enhan_name).info.frame3.frame1.frame0.frame0.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -command {set enhan(adap_k1) 0.7} \
    -label { 0.7 }
  $topwin(enhan_name).info.frame3.frame1.frame0.frame0.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -command {set enhan(adap_k1) 0.8} \
    -label { 0.8 }
  $topwin(enhan_name).info.frame3.frame1.frame0.frame0.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -command {set enhan(adap_k1) 0.9} \
    -label { 0.9 }
  bindtags $topwin(enhan_name).info.frame3.frame1.frame0.frame0.menubutton2.menu  {Menu all}
  # bindings
  bind $topwin(enhan_name).info.frame3.frame1.frame0.frame0.menubutton2.menu <B1-Motion> {MenuPopupMotion $topwin(enhan_name).info.frame3.frame1.frame0.frame0.menubutton2.menu %W %X %Y}
  bind $topwin(enhan_name).info.frame3.frame1.frame0.frame0.menubutton2.menu <ButtonRelease-1> {MenuPopupRelease $topwin(enhan_name).info.frame3.frame1.frame0.frame0.menubutton2.menu %W}

  # pack widget $topwin(enhan_name).info.frame3.frame1.frame0.frame0
  pack append $topwin(enhan_name).info.frame3.frame1.frame0.frame0 \
    $topwin(enhan_name).info.frame3.frame1.frame0.frame0.label1 {left frame center fill} \
    $topwin(enhan_name).info.frame3.frame1.frame0.frame0.value {left frame center expand fill} \
    $topwin(enhan_name).info.frame3.frame1.frame0.frame0.menubutton2 {right frame center fill}

  # build widget $topwin(enhan_name).info.frame3.frame1.frame0.frame1
  frame $topwin(enhan_name).info.frame3.frame1.frame0.frame1 \
    -background "$GuiColor(frame_bg)"

  # build widget $topwin(enhan_name).info.frame3.frame1.frame0.frame1.label1
  label $topwin(enhan_name).info.frame3.frame1.frame0.frame1.label1 \
    -background "$GuiColor(label_bg)" \
    -borderwidth {0} \
    -text {Local gain max: }

  # build widget $topwin(enhan_name).info.frame3.frame1.frame0.frame1.value
  entry $topwin(enhan_name).info.frame3.frame1.frame0.frame1.value \
    -background "$GuiColor(entry_bg)" \
	 -foreground "$GuiColor(entry_fg)" \
    -relief {sunken} \
    -textvariable {enhan(adap_max)} \
    -width {4}
  endEntry $topwin(enhan_name).info.frame3.frame1.frame0.frame1.value 0 \
  	 $topwin(enhan_name).info.frame3.frame1.frame2.frame0.value \
  	 $topwin(enhan_name).info.frame3.frame1.frame0.frame2.value

  # build widget $topwin(enhan_name).info.frame3.frame1.frame0.frame1.menubutton2
	menubutton $topwin(enhan_name).info.frame3.frame1.frame0.frame1.menubutton2 -padx {1} -pady {1} -highlightthickness {0}  \
    -activebackground "$GuiColor(btn_act_bg)" \
    -background "$GuiColor(btn_bg)" \
    -font "$GuiMisc(pop_up_fn)" \
    -relief "$GuiMisc(pop_up_relief)" \
    -text "$GuiMisc(pop_up_text)" \
	 -width {2}
  # bindings
  bind $topwin(enhan_name).info.frame3.frame1.frame0.frame1.menubutton2 <Button-1> {MenuPopupPost $topwin(enhan_name).info.frame3.frame1.frame0.frame1.menubutton2.menu %X %Y}
  bind $topwin(enhan_name).info.frame3.frame1.frame0.frame1.menubutton2 <ButtonRelease-1> {MenuPopupRelease $topwin(enhan_name).info.frame3.frame1.frame0.frame1.menubutton2.menu %W}

  # build widget $topwin(enhan_name).info.frame3.frame1.frame0.frame1.menubutton2.menu
  menu $topwin(enhan_name).info.frame3.frame1.frame0.frame1.menubutton2.menu \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)"
  $topwin(enhan_name).info.frame3.frame1.frame0.frame1.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -command {set enhan(adap_max) 5} \
    -label {  5 }
  $topwin(enhan_name).info.frame3.frame1.frame0.frame1.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -command {set enhan(adap_max) 10} \
    -label { 10 }
  $topwin(enhan_name).info.frame3.frame1.frame0.frame1.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -command {set enhan(adap_max) 15} \
    -label { 15 }
  $topwin(enhan_name).info.frame3.frame1.frame0.frame1.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -command {set enhan(adap_max) 20} \
    -label { 20 }
  $topwin(enhan_name).info.frame3.frame1.frame0.frame1.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -command {set enhan(adap_max) 25} \
    -label { 25 }
  $topwin(enhan_name).info.frame3.frame1.frame0.frame1.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -command {set enhan(adap_max) 30} \
    -label { 30 }
  $topwin(enhan_name).info.frame3.frame1.frame0.frame1.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -command {set enhan(adap_max) 100} \
    -label {100 }
  bindtags $topwin(enhan_name).info.frame3.frame1.frame0.frame1.menubutton2.menu {Menu all}
  # bindings
  bind $topwin(enhan_name).info.frame3.frame1.frame0.frame1.menubutton2.menu <B1-Motion> {MenuPopupMotion $topwin(enhan_name).info.frame3.frame1.frame0.frame1.menubutton2.menu %W %X %Y}
  bind $topwin(enhan_name).info.frame3.frame1.frame0.frame1.menubutton2.menu <ButtonRelease-1> {MenuPopupRelease $topwin(enhan_name).info.frame3.frame1.frame0.frame1.menubutton2.menu %W}

  # pack widget $topwin(enhan_name).info.frame3.frame1.frame0.frame1
  pack append $topwin(enhan_name).info.frame3.frame1.frame0.frame1 \
    $topwin(enhan_name).info.frame3.frame1.frame0.frame1.label1 {left frame center fill} \
    $topwin(enhan_name).info.frame3.frame1.frame0.frame1.value {left frame center expand fill} \
    $topwin(enhan_name).info.frame3.frame1.frame0.frame1.menubutton2 {right frame center fill}

  # build widget $topwin(enhan_name).info.frame3.frame1.frame0.frame2
  frame $topwin(enhan_name).info.frame3.frame1.frame0.frame2 \
    -background "$GuiColor(frame_bg)"

  # build widget $topwin(enhan_name).info.frame3.frame1.frame0.frame2.label1
  label $topwin(enhan_name).info.frame3.frame1.frame0.frame2.label1 \
    -background "$GuiColor(label_bg)" \
    -borderwidth {0} \
    -relief {sunken} \
    -text {Local gain min: }

  # build widget $topwin(enhan_name).info.frame3.frame1.frame0.frame2.value
  entry $topwin(enhan_name).info.frame3.frame1.frame0.frame2.value \
    -background "$GuiColor(entry_bg)" \
	 -foreground "$GuiColor(entry_fg)" \
    -relief {sunken} \
    -textvariable {enhan(adap_min)} \
    -width {4}
  endEntry $topwin(enhan_name).info.frame3.frame1.frame0.frame2.value 0\
  	 $topwin(enhan_name).info.frame3.frame1.frame0.frame1.value \
  	 $topwin(enhan_name).info.frame3.frame1.frame0.frame0.value 

  # build widget $topwin(enhan_name).info.frame3.frame1.frame0.frame2.menubutton2
	menubutton $topwin(enhan_name).info.frame3.frame1.frame0.frame2.menubutton2 -padx {1} -pady {1} -highlightthickness {0}  \
    -activebackground "$GuiColor(btn_act_bg)" \
    -background "$GuiColor(btn_bg)" \
    -font "$GuiMisc(pop_up_fn)" \
    -relief "$GuiMisc(pop_up_relief)" \
    -text "$GuiMisc(pop_up_text)" \
	 -width {2}
  # bindings
  bind $topwin(enhan_name).info.frame3.frame1.frame0.frame2.menubutton2 <Button-1> {MenuPopupPost $topwin(enhan_name).info.frame3.frame1.frame0.frame2.menubutton2.menu %X %Y}
  bind $topwin(enhan_name).info.frame3.frame1.frame0.frame2.menubutton2 <ButtonRelease-1> {MenuPopupRelease $topwin(enhan_name).info.frame3.frame1.frame0.frame2.menubutton2.menu %W}

  # build widget $topwin(enhan_name).info.frame3.frame1.frame0.frame2.menubutton2.menu
  menu $topwin(enhan_name).info.frame3.frame1.frame0.frame2.menubutton2.menu \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)"
  $topwin(enhan_name).info.frame3.frame1.frame0.frame2.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -command {set enhan(adap_min) 0.5} \
    -label {  0.5 }
  $topwin(enhan_name).info.frame3.frame1.frame0.frame2.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -command {set enhan(adap_min) 1.0} \
    -label {  1.0 }
  $topwin(enhan_name).info.frame3.frame1.frame0.frame2.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -command {set enhan(adap_min) 2.0} \
    -label {  2.0 }
  $topwin(enhan_name).info.frame3.frame1.frame0.frame2.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -command {set enhan(adap_min) 5.0} \
    -label {  5.0 }
  $topwin(enhan_name).info.frame3.frame1.frame0.frame2.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -command {set enhan(adap_min) 10.0} \
    -label { 10.0 }
  $topwin(enhan_name).info.frame3.frame1.frame0.frame2.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -command {set enhan(adap_min) 15.0} \
    -label { 15.0 }
  $topwin(enhan_name).info.frame3.frame1.frame0.frame2.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -command {set enhan(adap_min) 20.0} \
    -label { 20.0 }
  bindtags $topwin(enhan_name).info.frame3.frame1.frame0.frame2.menubutton2.menu {Menu all}
  # bindings
  bind $topwin(enhan_name).info.frame3.frame1.frame0.frame2.menubutton2.menu <B1-Motion> {MenuPopupMotion $topwin(enhan_name).info.frame3.frame1.frame0.frame2.menubutton2.menu %W %X %Y}
  bind $topwin(enhan_name).info.frame3.frame1.frame0.frame2.menubutton2.menu <ButtonRelease-1> {MenuPopupRelease $topwin(enhan_name).info.frame3.frame1.frame0.frame2.menubutton2.menu %W}

  # pack widget $topwin(enhan_name).info.frame3.frame1.frame0.frame2
  pack append $topwin(enhan_name).info.frame3.frame1.frame0.frame2 \
    $topwin(enhan_name).info.frame3.frame1.frame0.frame2.label1 {left frame center fill} \
    $topwin(enhan_name).info.frame3.frame1.frame0.frame2.value {left frame center expand fill} \
    $topwin(enhan_name).info.frame3.frame1.frame0.frame2.menubutton2 {right frame center fill}

  # pack widget $topwin(enhan_name).info.frame3.frame1.frame0
  pack append $topwin(enhan_name).info.frame3.frame1.frame0 \
    $topwin(enhan_name).info.frame3.frame1.frame0.frame0 {left frame e padx 22} \
    $topwin(enhan_name).info.frame3.frame1.frame0.frame2 {left frame center expand} \
    $topwin(enhan_name).info.frame3.frame1.frame0.frame1 {left frame center expand}

  # build widget $topwin(enhan_name).info.frame3.frame1.frame2
  frame $topwin(enhan_name).info.frame3.frame1.frame2 \
    -background "$GuiColor(frame_bg)" \
    -borderwidth {1}

  # build widget $topwin(enhan_name).info.frame3.frame1.frame2.frame0
  frame $topwin(enhan_name).info.frame3.frame1.frame2.frame0 \
    -background "$GuiColor(frame_bg)"

  # build widget $topwin(enhan_name).info.frame3.frame1.frame2.frame0.label1
  label $topwin(enhan_name).info.frame3.frame1.frame2.frame0.label1 \
    -background "$GuiColor(label_bg)" \
    -borderwidth {0} \
    -text {Local mean factor: }

  # build widget $topwin(enhan_name).info.frame3.frame1.frame2.frame0.value
  entry $topwin(enhan_name).info.frame3.frame1.frame2.frame0.value \
    -background "$GuiColor(entry_bg)" \
	 -foreground "$GuiColor(entry_fg)" \
    -relief {sunken} \
    -textvariable {enhan(adap_k2)} \
    -width {5}
  endEntry $topwin(enhan_name).info.frame3.frame1.frame2.frame0.value 0\
  	 $topwin(enhan_name).info.frame3.frame1.frame2.frame3.value \
  	 $topwin(enhan_name).info.frame3.frame1.frame0.frame1.value

  # build widget $topwin(enhan_name).info.frame3.frame1.frame2.frame0.menubutton2
	menubutton $topwin(enhan_name).info.frame3.frame1.frame2.frame0.menubutton2 -padx {1} -pady {1} -highlightthickness {0}  \
    -activebackground "$GuiColor(btn_act_bg)" \
    -background "$GuiColor(btn_bg)" \
    -font "$GuiMisc(pop_up_fn)" \
    -relief "$GuiMisc(pop_up_relief)" \
    -text "$GuiMisc(pop_up_text)" \
	 -width {2}
  # bindings
  bind $topwin(enhan_name).info.frame3.frame1.frame2.frame0.menubutton2 <Button-1> {MenuPopupPost $topwin(enhan_name).info.frame3.frame1.frame2.frame0.menubutton2.menu %X %Y}
  bind $topwin(enhan_name).info.frame3.frame1.frame2.frame0.menubutton2 <ButtonRelease-1> {MenuPopupRelease $topwin(enhan_name).info.frame3.frame1.frame2.frame0.menubutton2.menu %W}

  # build widget $topwin(enhan_name).info.frame3.frame1.frame2.frame0.menubutton2.menu
  menu $topwin(enhan_name).info.frame3.frame1.frame2.frame0.menubutton2.menu \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)"
  $topwin(enhan_name).info.frame3.frame1.frame2.frame0.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -command {set enhan(adap_k2) 0.5} \
    -label { 0.5 }
  $topwin(enhan_name).info.frame3.frame1.frame2.frame0.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -command {set enhan(adap_k2) 0.6} \
    -label { 0.6 }
  $topwin(enhan_name).info.frame3.frame1.frame2.frame0.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -command {set enhan(adap_k2) 0.7} \
    -label { 0.7 }
  $topwin(enhan_name).info.frame3.frame1.frame2.frame0.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -command {set enhan(adap_k2) 0.8} \
    -label { 0.8 }
  $topwin(enhan_name).info.frame3.frame1.frame2.frame0.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -command {set enhan(adap_k2) 0.9} \
    -label { 0.9 }
  $topwin(enhan_name).info.frame3.frame1.frame2.frame0.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -command {set enhan(adap_k2) 1.0} \
    -label { 1.0 }
  bindtags $topwin(enhan_name).info.frame3.frame1.frame2.frame0.menubutton2.menu {Menu all}
  # bindings
  bind $topwin(enhan_name).info.frame3.frame1.frame2.frame0.menubutton2.menu <B1-Motion> {MenuPopupMotion $topwin(enhan_name).info.frame3.frame1.frame2.frame0.menubutton2.menu %W %X %Y}
  bind $topwin(enhan_name).info.frame3.frame1.frame2.frame0.menubutton2.menu <ButtonRelease-1> {MenuPopupRelease $topwin(enhan_name).info.frame3.frame1.frame2.frame0.menubutton2.menu %W}

  # pack widget $topwin(enhan_name).info.frame3.frame1.frame2.frame0
  pack append $topwin(enhan_name).info.frame3.frame1.frame2.frame0 \
    $topwin(enhan_name).info.frame3.frame1.frame2.frame0.label1 {left frame center fill} \
    $topwin(enhan_name).info.frame3.frame1.frame2.frame0.value {left frame center expand fill} \
    $topwin(enhan_name).info.frame3.frame1.frame2.frame0.menubutton2 {right frame center fill}

  # build widget $topwin(enhan_name).info.frame3.frame1.frame2.frame3
  frame $topwin(enhan_name).info.frame3.frame1.frame2.frame3 \
    -background "$GuiColor(frame_bg)"

  # build widget $topwin(enhan_name).info.frame3.frame1.frame2.frame3.label1
  label $topwin(enhan_name).info.frame3.frame1.frame2.frame3.label1 \
    -background "$GuiColor(label_bg)" \
    -borderwidth {0} \
    -text {Kernel size: }

  # build widget $topwin(enhan_name).info.frame3.frame1.frame2.frame3.value
  entry $topwin(enhan_name).info.frame3.frame1.frame2.frame3.value \
    -background "$GuiColor(entry_bg)" \
	 -foreground "$GuiColor(entry_fg)" \
    -relief {sunken} \
    -textvariable {enhan(adap_kern)} \
    -width {3}
  endEntry $topwin(enhan_name).info.frame3.frame1.frame2.frame3.value 0\
  	 $topwin(enhan_name).info.frame3.frame1.frame0.frame0.value \
  	 $topwin(enhan_name).info.frame3.frame1.frame2.frame0.value

  # build widget $topwin(enhan_name).info.frame3.frame1.frame2.frame3.menubutton2
	menubutton $topwin(enhan_name).info.frame3.frame1.frame2.frame3.menubutton2 -padx {1} -pady {1} -highlightthickness {0}  \
    -activebackground "$GuiColor(btn_act_bg)" \
    -background "$GuiColor(btn_bg)" \
    -font "$GuiMisc(pop_up_fn)" \
    -relief "$GuiMisc(pop_up_relief)" \
    -text "$GuiMisc(pop_up_text)" \
	 -width {2}
  # bindings
  bind $topwin(enhan_name).info.frame3.frame1.frame2.frame3.menubutton2 <Button-1> {MenuPopupPost $topwin(enhan_name).info.frame3.frame1.frame2.frame3.menubutton2.menu %X %Y}
  bind $topwin(enhan_name).info.frame3.frame1.frame2.frame3.menubutton2 <ButtonRelease-1> {MenuPopupRelease $topwin(enhan_name).info.frame3.frame1.frame2.frame3.menubutton2.menu %W}

  # build widget $topwin(enhan_name).info.frame3.frame1.frame2.frame3.menubutton2.menu
  menu $topwin(enhan_name).info.frame3.frame1.frame2.frame3.menubutton2.menu \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)"
  $topwin(enhan_name).info.frame3.frame1.frame2.frame3.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -command {set enhan(adap_kern) 7} \
    -label {  7 }
  $topwin(enhan_name).info.frame3.frame1.frame2.frame3.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -command {set enhan(adap_kern) 9} \
    -label {  9 }
  $topwin(enhan_name).info.frame3.frame1.frame2.frame3.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -command {set enhan(adap_kern) 11} \
    -label { 11 }
  $topwin(enhan_name).info.frame3.frame1.frame2.frame3.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -command {set enhan(adap_kern) 13} \
    -label { 13 }
  $topwin(enhan_name).info.frame3.frame1.frame2.frame3.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -command {set enhan(adap_kern) 15} \
    -label { 15 }
  $topwin(enhan_name).info.frame3.frame1.frame2.frame3.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -command {set enhan(adap_kern) 21} \
    -label { 21 }
  bindtags  $topwin(enhan_name).info.frame3.frame1.frame2.frame3.menubutton2.menu {Menu all}
  # bindings
  bind $topwin(enhan_name).info.frame3.frame1.frame2.frame3.menubutton2.menu <B1-Motion> {MenuPopupMotion $topwin(enhan_name).info.frame3.frame1.frame2.frame3.menubutton2.menu %W %X %Y}
  bind $topwin(enhan_name).info.frame3.frame1.frame2.frame3.menubutton2.menu <ButtonRelease-1> {MenuPopupRelease $topwin(enhan_name).info.frame3.frame1.frame2.frame3.menubutton2.menu %W}

  # pack widget $topwin(enhan_name).info.frame3.frame1.frame2.frame3
  pack append $topwin(enhan_name).info.frame3.frame1.frame2.frame3 \
    $topwin(enhan_name).info.frame3.frame1.frame2.frame3.label1 {left frame center fill} \
    $topwin(enhan_name).info.frame3.frame1.frame2.frame3.value {left frame center expand fill} \
    $topwin(enhan_name).info.frame3.frame1.frame2.frame3.menubutton2 {right frame center fill}

  # pack widget $topwin(enhan_name).info.frame3.frame1.frame2
  pack append $topwin(enhan_name).info.frame3.frame1.frame2 \
    $topwin(enhan_name).info.frame3.frame1.frame2.frame0 {left frame e padx 22} \
    $topwin(enhan_name).info.frame3.frame1.frame2.frame3 {left frame center expand}

  # pack widget $topwin(enhan_name).info.frame3.frame1
  pack append $topwin(enhan_name).info.frame3.frame1 \
    $topwin(enhan_name).info.frame3.frame1.radiobutton1 {top frame nw} \
    $topwin(enhan_name).info.frame3.frame1.frame0 {top frame center expand fillx} \
    $topwin(enhan_name).info.frame3.frame1.frame2 {top frame center expand fillx}

  # pack widget $topwin(enhan_name).info.frame3
  pack append $topwin(enhan_name).info.frame3 \
    $topwin(enhan_name).info.frame3.frame0 {top frame center expand fill} \
    $topwin(enhan_name).info.frame3.frame1 {top frame center expand fill}

  # build widget $topwin(enhan_name).info.frame4
  frame $topwin(enhan_name).info.frame4 \
    -background "$GuiColor(frame_bg)" \
    -borderwidth {2} \
    -relief {ridge}

  # build widget $topwin(enhan_name).info.frame4.radiobutton0
	radiobutton $topwin(enhan_name).info.frame4.radiobutton0 -padx {1} -pady {1} -highlightthickness {0}  \
    -activebackground "$GuiColor(btn_act_bg)" \
    -background "$GuiColor(btn_bg)" \
    -relief {flat} \
    -text {Histogram specification} \
    -value {hist_spec} \
    -variable {enhan(hist)}

  # build widget $topwin(enhan_name).info.frame4.frame1
  frame $topwin(enhan_name).info.frame4.frame1 \
    -background "$GuiColor(frame_bg)" \
    -borderwidth {0} \
    -relief {flat}

  # build widget $topwin(enhan_name).info.frame4.frame1.frame
  frame $topwin(enhan_name).info.frame4.frame1.frame \
    -background "$GuiColor(frame_bg)"

  # build widget $topwin(enhan_name).info.frame4.frame1.frame.scrollbar7
  scrollbar $topwin(enhan_name).info.frame4.frame1.frame.scrollbar7 \
	 -activebackground "$GuiColor(btn_act_bg)" \
    -troughcolor "$GuiColor(btn_act_bg)" \
    -background "$GuiColor(btn_bg)" \
    -command "$topwin(enhan_name).info.frame4.frame1.frame.entry5 xview" \
    -orient {horizontal} \
    -width {9}

  # build widget $topwin(enhan_name).info.frame4.frame1.frame.entry5
  entry $topwin(enhan_name).info.frame4.frame1.frame.entry5 \
    -background "$GuiColor(entry_bg)" \
	 -foreground "$GuiColor(entry_fg)" \
    -relief {sunken} \
 -xscrollcommand "$topwin(enhan_name).info.frame4.frame1.frame.scrollbar7 set" \
    -textvariable {enhan(hist_eqr)} \
    -width {25}
# bind return to do nothing
 endEntry $topwin(enhan_name).info.frame4.frame1.frame.entry5 0 \
 	 $topwin(enhan_name).info.frame4.frame2.frame.entry5 \
 	 $topwin(enhan_name).info.frame4.frame3.frame.entry5



  # build widget $topwin(enhan_name).info.frame4.frame1.frame.menubutton2
	menubutton $topwin(enhan_name).info.frame4.frame1.frame.menubutton2 -padx {1} -pady {1} -highlightthickness {0}  \
    -activebackground "$GuiColor(btn_act_bg)" \
    -background "$GuiColor(btn_bg)" \
    -font "$GuiMisc(pop_up_fn)" \
    -relief "$GuiMisc(pop_up_relief)" \
    -text "$GuiMisc(pop_up_text)" \
    -width {2} 

  bind $topwin(enhan_name).info.frame4.frame1.frame.menubutton2 <Button-1> {
  MenuPopupPost $topwin(enhan_name).info.frame4.frame1.frame.menubutton2.menu %X %Y}
  bind $topwin(enhan_name).info.frame4.frame1.frame.menubutton2 <ButtonRelease-1> {
  MenuPopupRelease $topwin(enhan_name).info.frame4.frame1.frame.menubutton2.menu %W}

  # build widget $topwin(enhan_name).info.frame4.frame1.frame.menubutton2.menu
  menu $topwin(enhan_name).info.frame4.frame1.frame.menubutton2.menu \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)"
  $topwin(enhan_name).info.frame4.frame1.frame.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -command {set enhan(hist_eqr) "sin(0.025*x)"} \
    -label {sin(0.025*x)} \
    -state {active}
  $topwin(enhan_name).info.frame4.frame1.frame.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -command {set enhan(hist_eqr) "x+25"} \
    -label {x+25        } \
    -state {active}
  $topwin(enhan_name).info.frame4.frame1.frame.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -command {set enhan(hist_eqr) "x*2.0"} \
    -label {x*2.0       } \
    -state {active}
  $topwin(enhan_name).info.frame4.frame1.frame.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -command {set enhan(hist_eqr) "ramp(2.0*x+5)"} \
    -label {ramp(2.0*x+5)} \
    -state {active}
  $topwin(enhan_name).info.frame4.frame1.frame.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -command {set enhan(hist_eqr) "exp(0.025*x)"} \
    -label {exp(0.025*x) } \
    -state {active}
  $topwin(enhan_name).info.frame4.frame1.frame.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -command {set enhan(hist_eqr) "log(0.5*x+2)"} \
    -label {log(0.5*x+2) } \
    -state {active}
  bindtags $topwin(enhan_name).info.frame4.frame1.frame.menubutton2.menu  {Menu all}
  bind $topwin(enhan_name).info.frame4.frame1.frame.menubutton2.menu <B1-Motion> {
  MenuPopupMotion $topwin(enhan_name).info.frame4.frame1.frame.menubutton2.menu %W %X %Y}
  bind $topwin(enhan_name).info.frame4.frame1.frame.menubutton2.menu <ButtonRelease-1> {
  MenuPopupRelease $topwin(enhan_name).info.frame4.frame1.frame.menubutton2.menu %W}

  # build widget $topwin(enhan_name).info.frame4.frame1.frame.label4
  label $topwin(enhan_name).info.frame4.frame1.frame.label4 \
    -background "$GuiColor(label_bg)" \
    -padx {2} \
    -text {Formula for gray image or red band:}

  # pack widget $topwin(enhan_name).info.frame4.frame1.frame
  pack append $topwin(enhan_name).info.frame4.frame1.frame \
    $topwin(enhan_name).info.frame4.frame1.frame.label4 {left frame center} \
	 $topwin(enhan_name).info.frame4.frame1.frame.menubutton2 {right frame center expand fill} \
    $topwin(enhan_name).info.frame4.frame1.frame.entry5 {top frame center expand fill} \
    $topwin(enhan_name).info.frame4.frame1.frame.scrollbar7 {top frame center fillx}

  # build widget $topwin(enhan_name).info.frame4.frame1.button1
	button $topwin(enhan_name).info.frame4.frame1.button1 -padx {1} -pady {1} -highlightthickness {0}  \
    -activebackground "$GuiColor(btn_act_bg)" \
    -background "$GuiColor(btn_bg)" \
    -command {set enhan(hist_eqr) ""} \
    -text {Clear Function}

  # pack widget $topwin(enhan_name).info.frame4.frame1
  pack append $topwin(enhan_name).info.frame4.frame1 \
    $topwin(enhan_name).info.frame4.frame1.button1 {right frame center padx 10} \
    $topwin(enhan_name).info.frame4.frame1.frame {right  frame center} 

  # build widget $topwin(enhan_name).info.frame4.frame2
  frame $topwin(enhan_name).info.frame4.frame2 \
    -background "$GuiColor(frame_bg)" \
    -borderwidth {0} \
    -relief {flat}

  # build widget $topwin(enhan_name).info.frame4.frame2.frame
  frame $topwin(enhan_name).info.frame4.frame2.frame \
    -background "$GuiColor(frame_bg)"

  # build widget $topwin(enhan_name).info.frame4.frame2.frame.scrollbar7
  scrollbar $topwin(enhan_name).info.frame4.frame2.frame.scrollbar7 \
	 -activebackground "$GuiColor(btn_act_bg)" \
    -troughcolor "$GuiColor(btn_act_bg)" \
    -background "$GuiColor(btn_bg)" \
    -command "$topwin(enhan_name).info.frame4.frame2.frame.entry5 xview" \
    -orient {horizontal} \
    -width {9}

  # build widget $topwin(enhan_name).info.frame4.frame2.frame.entry5
  entry $topwin(enhan_name).info.frame4.frame2.frame.entry5 \
    -background "$GuiColor(entry_bg)" \
	 -foreground "$GuiColor(entry_fg)" \
    -relief {sunken} \
 -xscrollcommand "$topwin(enhan_name).info.frame4.frame2.frame.scrollbar7 set" \
    -textvariable {enhan(hist_eqg)} \
    -width {25}

# bind return to do nothing
 endEntry $topwin(enhan_name).info.frame4.frame2.frame.entry5 0 \
 	 $topwin(enhan_name).info.frame4.frame3.frame.entry5 \
 	 $topwin(enhan_name).info.frame4.frame1.frame.entry5


  # build widget $topwin(enhan_name).info.frame4.frame2.frame.menubutton2
	menubutton $topwin(enhan_name).info.frame4.frame2.frame.menubutton2 -padx {1} -pady {1} -highlightthickness {0}  \
    -activebackground "$GuiColor(btn_act_bg)" \
    -background "$GuiColor(btn_bg)" \
    -font "$GuiMisc(pop_up_fn)" \
    -relief "$GuiMisc(pop_up_relief)" \
    -text "$GuiMisc(pop_up_text)" \
    -width {2} 

  bind $topwin(enhan_name).info.frame4.frame2.frame.menubutton2 <Button-1> {
  MenuPopupPost $topwin(enhan_name).info.frame4.frame2.frame.menubutton2.menu %X %Y}
  bind $topwin(enhan_name).info.frame4.frame2.frame.menubutton2 <ButtonRelease-1> {
  MenuPopupRelease $topwin(enhan_name).info.frame4.frame2.frame.menubutton2.menu %W}

  # build widget $topwin(enhan_name).info.frame4.frame2.frame.menubutton2.menu
  menu $topwin(enhan_name).info.frame4.frame2.frame.menubutton2.menu \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)"
  $topwin(enhan_name).info.frame4.frame2.frame.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -command {set enhan(hist_eqg) "sin(0.025*x)"} \
    -label {sin(0.025*x)} \
    -state {active}
  $topwin(enhan_name).info.frame4.frame2.frame.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -command {set enhan(hist_eqg) "x+25"} \
    -label {x+25        } \
    -state {active}
  $topwin(enhan_name).info.frame4.frame2.frame.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -command {set enhan(hist_eqg) "x*2.0"} \
    -label {x*2.0       } \
    -state {active}
  $topwin(enhan_name).info.frame4.frame2.frame.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -command {set enhan(hist_eqg) "ramp(2.0*x+5)"} \
    -label {ramp(2.0*x+5)} \
    -state {active}
  $topwin(enhan_name).info.frame4.frame2.frame.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -command {set enhan(hist_eqg) "exp(0.025*x)"} \
    -label {exp(0.025*x) } \
    -state {active}
  $topwin(enhan_name).info.frame4.frame2.frame.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -command {set enhan(hist_eqg) "log(0.5*x+2)"} \
    -label {log(0.5*x+2) } \
    -state {active}
  bindtags $topwin(enhan_name).info.frame4.frame2.frame.menubutton2.menu  {Menu all}
  bind $topwin(enhan_name).info.frame4.frame2.frame.menubutton2.menu <B1-Motion> {
  MenuPopupMotion $topwin(enhan_name).info.frame4.frame2.frame.menubutton2.menu %W %X %Y}
  bind $topwin(enhan_name).info.frame4.frame2.frame.menubutton2.menu <ButtonRelease-1> {
  MenuPopupRelease $topwin(enhan_name).info.frame4.frame2.frame.menubutton2.menu %W}

  # build widget $topwin(enhan_name).info.frame4.frame2.frame.label4
  label $topwin(enhan_name).info.frame4.frame2.frame.label4 \
    -background "$GuiColor(label_bg)" \
    -padx {2} \
    -text {Formula for green band:}

  # pack widget $topwin(enhan_name).info.frame4.frame2.frame
  pack append $topwin(enhan_name).info.frame4.frame2.frame \
    $topwin(enhan_name).info.frame4.frame2.frame.label4 {left frame center} \
	 $topwin(enhan_name).info.frame4.frame2.frame.menubutton2 {right frame center expand fill} \
    $topwin(enhan_name).info.frame4.frame2.frame.entry5 {top frame center expand fill} \
    $topwin(enhan_name).info.frame4.frame2.frame.scrollbar7 {top frame center fillx}

  # build widget $topwin(enhan_name).info.frame4.frame2.button1
	button $topwin(enhan_name).info.frame4.frame2.button1 -padx {1} -pady {1} -highlightthickness {0}  \
    -activebackground "$GuiColor(btn_act_bg)" \
    -background "$GuiColor(btn_bg)" \
    -command {set enhan(hist_eqg) ""} \
    -text {Clear Function}

  # pack widget $topwin(enhan_name).info.frame4
  pack append $topwin(enhan_name).info.frame4.frame2 \
    $topwin(enhan_name).info.frame4.frame2.button1 {right frame center padx 10} \
    $topwin(enhan_name).info.frame4.frame2.frame {right  frame center} 


  # build widget $topwin(enhan_name).info.frame4.frame3
  frame $topwin(enhan_name).info.frame4.frame3 \
    -background "$GuiColor(frame_bg)" \
    -borderwidth {0} \
    -relief {flat}

  # build widget $topwin(enhan_name).info.frame4.frame3.frame
  frame $topwin(enhan_name).info.frame4.frame3.frame \
    -background "$GuiColor(frame_bg)"

  # build widget $topwin(enhan_name).info.frame4.frame3.frame.scrollbar7
  scrollbar $topwin(enhan_name).info.frame4.frame3.frame.scrollbar7 \
	 -activebackground "$GuiColor(btn_act_bg)" \
    -troughcolor "$GuiColor(btn_act_bg)" \
    -background "$GuiColor(btn_bg)" \
    -command "$topwin(enhan_name).info.frame4.frame3.frame.entry5 xview" \
    -orient {horizontal} \
    -width {9}

  # build widget $topwin(enhan_name).info.frame4.frame3.frame.entry5
  entry $topwin(enhan_name).info.frame4.frame3.frame.entry5 \
    -background "$GuiColor(entry_bg)" \
	 -foreground "$GuiColor(entry_fg)" \
    -relief {sunken} \
 -xscrollcommand "$topwin(enhan_name).info.frame4.frame3.frame.scrollbar7 set" \
    -textvariable {enhan(hist_eqb)} \
    -width {25}

# bind return to do nothing
 endEntry $topwin(enhan_name).info.frame4.frame3.frame.entry5 0 \
 	 $topwin(enhan_name).info.frame4.frame1.frame.entry5 \
 	 $topwin(enhan_name).info.frame4.frame2.frame.entry5 

  # build widget $topwin(enhan_name).info.frame4.frame3.frame.menubutton2
	menubutton $topwin(enhan_name).info.frame4.frame3.frame.menubutton2 -padx {1} -pady {1} -highlightthickness {0}  \
    -activebackground "$GuiColor(btn_act_bg)" \
    -background "$GuiColor(btn_bg)" \
    -font "$GuiMisc(pop_up_fn)" \
    -relief "$GuiMisc(pop_up_relief)" \
    -text "$GuiMisc(pop_up_text)" \
    -width {2} 

  bind $topwin(enhan_name).info.frame4.frame3.frame.menubutton2 <Button-1> {
  MenuPopupPost $topwin(enhan_name).info.frame4.frame3.frame.menubutton2.menu %X %Y}
  bind $topwin(enhan_name).info.frame4.frame3.frame.menubutton2 <ButtonRelease-1> {
  MenuPopupRelease $topwin(enhan_name).info.frame4.frame3.frame.menubutton2.menu %W}

  # build widget $topwin(enhan_name).info.frame4.frame3.frame.menubutton2.menu
  menu $topwin(enhan_name).info.frame4.frame3.frame.menubutton2.menu \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)"
  $topwin(enhan_name).info.frame4.frame3.frame.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -command {set enhan(hist_eqb) "sin(0.025*x)"} \
    -label {sin(0.025*x)} \
    -state {active}
  $topwin(enhan_name).info.frame4.frame3.frame.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -command {set enhan(hist_eqb) "x+25"} \
    -label {x+25        } \
    -state {active}
  $topwin(enhan_name).info.frame4.frame3.frame.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -command {set enhan(hist_eqb) "x*2.0"} \
    -label {x*2.0       } \
    -state {active}
  $topwin(enhan_name).info.frame4.frame3.frame.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -command {set enhan(hist_eqb) "ramp(2.0*x+5)"} \
    -label {ramp(2.0*x+5)} \
    -state {active}
  $topwin(enhan_name).info.frame4.frame3.frame.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -command {set enhan(hist_eqb) "exp(0.025*x)"} \
    -label {exp(0.025*x)} \
    -state {active}
  $topwin(enhan_name).info.frame4.frame3.frame.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -command {set enhan(hist_eqb) "log(0.5*x+2)"} \
    -label {log(0.5*x+2)} \
    -state {active}
  bindtags  $topwin(enhan_name).info.frame4.frame3.frame.menubutton2.menu {Menu all}

  bind $topwin(enhan_name).info.frame4.frame3.frame.menubutton2.menu <B1-Motion> {
  MenuPopupMotion $topwin(enhan_name).info.frame4.frame3.frame.menubutton2.menu %W %X %Y}
  bind $topwin(enhan_name).info.frame4.frame3.frame.menubutton2.menu <ButtonRelease-1> {
  MenuPopupRelease $topwin(enhan_name).info.frame4.frame3.frame.menubutton2.menu %W}

  # build widget $topwin(enhan_name).info.frame4.frame3.frame.label4
  label $topwin(enhan_name).info.frame4.frame3.frame.label4 \
    -background "$GuiColor(label_bg)" \
    -padx {2} \
    -text {Formula for blue band:}

  # pack widget $topwin(enhan_name).info.frame4.frame3.frame
  pack append $topwin(enhan_name).info.frame4.frame3.frame \
    $topwin(enhan_name).info.frame4.frame3.frame.label4 {left frame center} \
	 $topwin(enhan_name).info.frame4.frame3.frame.menubutton2 {right frame center expand fill} \
    $topwin(enhan_name).info.frame4.frame3.frame.entry5 {top frame center expand fill} \
    $topwin(enhan_name).info.frame4.frame3.frame.scrollbar7 {top frame center fillx}

  # build widget $topwin(enhan_name).info.frame4.frame3.button1
	button $topwin(enhan_name).info.frame4.frame3.button1 -padx {1} -pady {1} -highlightthickness {0}  \
    -activebackground "$GuiColor(btn_act_bg)" \
    -background "$GuiColor(btn_bg)" \
    -command {set enhan(hist_eqb) ""} \
    -text {Clear Function}

  # pack widget $topwin(enhan_name).info.frame4
  pack append $topwin(enhan_name).info.frame4.frame3 \
    $topwin(enhan_name).info.frame4.frame3.button1 {right frame center padx 10} \
    $topwin(enhan_name).info.frame4.frame3.frame {right  frame center} 

  # pack widget $topwin(enhan_name).info.frame4
  pack append $topwin(enhan_name).info.frame4 \
    $topwin(enhan_name).info.frame4.radiobutton0 {top frame w} \
    $topwin(enhan_name).info.frame4.frame1 {top frame e}  \
    $topwin(enhan_name).info.frame4.frame2 {top frame e}  \
    $topwin(enhan_name).info.frame4.frame3 {top frame e} 

  # build widget $topwin(enhan_name).info.frame5
  frame $topwin(enhan_name).info.frame5 \
    -background "$GuiColor(frame_bg)" \
    -borderwidth {2} \
    -relief {ridge}

  # build widget $topwin(enhan_name).info.frame5.frame0
  frame $topwin(enhan_name).info.frame5.frame0 \
    -background "$GuiColor(frame_bg)" \
    -borderwidth {0} \
    -relief {flat}

  # build widget $topwin(enhan_name).info.frame5.frame0
  frame $topwin(enhan_name).info.frame5.frame1 \
    -background "$GuiColor(frame_bg)" \
    -borderwidth {0} \
    -relief {flat}

  # build widget $topwin(enhan_name).info.frame5.frame1.radiobutton1
	radiobutton $topwin(enhan_name).info.frame5.frame1.radiobutton1 -padx {1} -pady {1} -highlightthickness {0}  \
    -activebackground "$GuiColor(btn_act_bg)" \
    -background "$GuiColor(btn_bg)" \
    -relief {flat} \
    -text {Set out-of-range data to 0} \
    -value {0} \
    -variable {enhan(hist_linear_outer)}


  # build widget $topwin(enhan_name).info.frame5.frame1.radiobutton2
	radiobutton $topwin(enhan_name).info.frame5.frame1.radiobutton2 -padx {1} -pady {1} -highlightthickness {0}  \
    -activebackground "$GuiColor(btn_act_bg)" \
    -background "$GuiColor(btn_bg)" \
    -relief {flat} \
    -text {Keep out-of-range data} \
    -value {1} \
    -variable {enhan(hist_linear_outer)}

  # pack widget $topwin(enhan_name).info.frame5.frame1
  pack append $topwin(enhan_name).info.frame5.frame1 \
    $topwin(enhan_name).info.frame5.frame1.radiobutton2 {left frame e padx 155} \
    $topwin(enhan_name).info.frame5.frame1.radiobutton1 {left frame center} 

  # build widget $topwin(enhan_name).info.frame5.frame0.radiobutton2
	radiobutton $topwin(enhan_name).info.frame5.frame0.radiobutton2 -padx {1} -pady {1} -highlightthickness {0}  \
    -activebackground "$GuiColor(btn_act_bg)" \
    -background "$GuiColor(btn_bg)" \
    -relief {flat} \
    -text {Linear modify} \
    -value {gray_linear} \
    -variable {enhan(hist)}

  # build widget $topwin(enhan_name).info.frame5.frame0.frame
  frame $topwin(enhan_name).info.frame5.frame0.frame \
    -background "$GuiColor(frame_bg)"

  # build widget $topwin(enhan_name).info.frame5.frame0.frame.label4
  label $topwin(enhan_name).info.frame5.frame0.frame.label4 \
    -background "$GuiColor(label_bg)" \
    -padx {2} \
    -text {Range: start}

  # build widget $topwin(enhan_name).info.frame5.frame0.frame.entry5
  entry $topwin(enhan_name).info.frame5.frame0.frame.entry5 \
    -background "$GuiColor(entry_bg)" \
	 -foreground "$GuiColor(entry_fg)" \
    -relief {sunken} \
    -textvariable {enhan(hist_linear_srt)} \
    -width {5}

# bind return to do nothing
 endEntry $topwin(enhan_name).info.frame5.frame0.frame.entry5 0 \
 	 $topwin(enhan_name).info.frame5.frame0.frame3.entry5 \
 	 $topwin(enhan_name).info.frame5.frame0.frame5.entry5 

  # pack widget $topwin(enhan_name).info.frame5.frame0.frame
  pack append $topwin(enhan_name).info.frame5.frame0.frame \
    $topwin(enhan_name).info.frame5.frame0.frame.label4 {left frame center} \
    $topwin(enhan_name).info.frame5.frame0.frame.entry5 {top frame center expand fill}

  # build widget $topwin(enhan_name).info.frame5.frame0.frame3
  frame $topwin(enhan_name).info.frame5.frame0.frame3 \
    -relief {raised}

  # build widget $topwin(enhan_name).info.frame5.frame0.frame3.label4
  label $topwin(enhan_name).info.frame5.frame0.frame3.label4 \
    -background "$GuiColor(label_bg)" \
    -padx {2} \
    -text {end}

  # build widget $topwin(enhan_name).info.frame5.frame0.frame3.entry5
  entry $topwin(enhan_name).info.frame5.frame0.frame3.entry5 \
    -background "$GuiColor(entry_bg)" \
	 -foreground "$GuiColor(entry_fg)" \
    -relief {sunken} \
    -textvariable {enhan(hist_linear_end)} \
    -width {5}

# bind return to do nothing
 endEntry $topwin(enhan_name).info.frame5.frame0.frame3.entry5 0 \
 	 $topwin(enhan_name).info.frame5.frame0.frame4.entry5 \
 	 $topwin(enhan_name).info.frame5.frame0.frame.entry5 


  # pack widget $topwin(enhan_name).info.frame5.frame0.frame3
  pack append $topwin(enhan_name).info.frame5.frame0.frame3 \
    $topwin(enhan_name).info.frame5.frame0.frame3.label4 {left frame center} \
    $topwin(enhan_name).info.frame5.frame0.frame3.entry5 {top frame center expand fill}

  # build widget $topwin(enhan_name).info.frame5.frame0.frame4
  frame $topwin(enhan_name).info.frame5.frame0.frame4 \
    -relief {raised}

  # build widget $topwin(enhan_name).info.frame5.frame0.frame4.label4
  label $topwin(enhan_name).info.frame5.frame0.frame4.label4 \
    -background "$GuiColor(label_bg)" \
    -padx {2} \
    -text {Initial value:}

  # build widget $topwin(enhan_name).info.frame5.frame0.frame4.entry5
  entry $topwin(enhan_name).info.frame5.frame0.frame4.entry5 \
    -background "$GuiColor(entry_bg)" \
	 -foreground "$GuiColor(entry_fg)" \
    -relief {sunken} \
    -textvariable {enhan(hist_linear_val)} \
    -width {5}

# bind return to do nothing
 endEntry $topwin(enhan_name).info.frame5.frame0.frame4.entry5 0 \
 	 $topwin(enhan_name).info.frame5.frame0.frame5.entry5 \
 	 $topwin(enhan_name).info.frame5.frame0.frame3.entry5 

  # pack widget $topwin(enhan_name).info.frame5.frame0.frame4
  pack append $topwin(enhan_name).info.frame5.frame0.frame4 \
    $topwin(enhan_name).info.frame5.frame0.frame4.label4 {left frame center} \
    $topwin(enhan_name).info.frame5.frame0.frame4.entry5 {top frame center expand fill}

  # build widget $topwin(enhan_name).info.frame5.frame0.frame5
  frame $topwin(enhan_name).info.frame5.frame0.frame5 \
    -relief {raised}

  # build widget $topwin(enhan_name).info.frame5.frame0.frame5.label4
  label $topwin(enhan_name).info.frame5.frame0.frame5.label4 \
    -background "$GuiColor(label_bg)" \
    -padx {2} \
    -text {Slope:}

  # build widget $topwin(enhan_name).info.frame5.frame0.frame5.entry5
  entry $topwin(enhan_name).info.frame5.frame0.frame5.entry5 \
    -background "$GuiColor(entry_bg)" \
	 -foreground "$GuiColor(entry_fg)" \
    -relief {sunken} \
    -textvariable {enhan(hist_linear_slp)} \
    -width {5}

# bind return to do nothing
 endEntry $topwin(enhan_name).info.frame5.frame0.frame5.entry5 0 \
 	 $topwin(enhan_name).info.frame5.frame0.frame.entry5 \
 	 $topwin(enhan_name).info.frame5.frame0.frame4.entry5


  # pack widget $topwin(enhan_name).info.frame5.frame0.frame5
  pack append $topwin(enhan_name).info.frame5.frame0.frame5 \
    $topwin(enhan_name).info.frame5.frame0.frame5.label4 {left frame center} \
    $topwin(enhan_name).info.frame5.frame0.frame5.entry5 {top frame center expand fill}

  # pack widget $topwin(enhan_name).info.frame5.frame0
  pack append $topwin(enhan_name).info.frame5.frame0 \
    $topwin(enhan_name).info.frame5.frame0.radiobutton2 {left frame center} \
    $topwin(enhan_name).info.frame5.frame0.frame {left frame center} \
    $topwin(enhan_name).info.frame5.frame0.frame3 {left frame center} \
    $topwin(enhan_name).info.frame5.frame0.frame4 {left frame center} \
    $topwin(enhan_name).info.frame5.frame0.frame5 {left frame center}

  # pack widget $topwin(enhan_name).info.frame5
  pack append $topwin(enhan_name).info.frame5 \
	 $topwin(enhan_name).info.frame5.frame0 {top frame w} \
	 $topwin(enhan_name).info.frame5.frame1 {top frame w}

  # build widget $topwin(enhan_name).info.frame6
  frame $topwin(enhan_name).info.frame6 \
    -background "$GuiColor(frame_bg)" \
    -borderwidth {2} \
    -relief {ridge}

  # build widget $topwin(enhan_name).info.frame6.radiobutton2
	radiobutton $topwin(enhan_name).info.frame6.radiobutton2 -padx {1} -pady {1} -highlightthickness {0}  \
    -activebackground "$GuiColor(btn_act_bg)" \
    -background "$GuiColor(btn_bg)" \
    -relief {flat} \
    -text {Gray level multiplication} \
    -value {gray_multiply} \
    -variable {enhan(hist)}

  frame $topwin(enhan_name).info.frame6.frame1 \
	-background "$GuiColor(frame_bg)" \
	-borderwidth {0}

	radiobutton $topwin(enhan_name).info.frame6.frame1.radiobutton2 -padx {1} -pady {1} -highlightthickness {0}  \
    -activebackground "$GuiColor(btn_act_bg)" \
    -background "$GuiColor(btn_bg)" \
	-anchor {w} \
	-relief {flat} \
	-text {With} \
	-value {1} \
	-variable {enhan(mult_clip)}

	radiobutton $topwin(enhan_name).info.frame6.frame1.radiobutton3 -padx {1} -pady {1} -highlightthickness {0}  \
    -activebackground "$GuiColor(btn_act_bg)" \
    -background "$GuiColor(btn_bg)" \
	-anchor {w} \
	-relief {flat} \
	-text {Without} \
	-value {0} \
	-variable {enhan(mult_clip)}

  # build widget $topwin(enhan_name).info.frame6.frame1.label1
  label $topwin(enhan_name).info.frame6.frame1.label1 \
    -anchor {e} \
    -background "$GuiColor(label_bg)" \
    -borderwidth {0} \
    -text {BYTE clipping,}

  pack append $topwin(enhan_name).info.frame6.frame1 \
    $topwin(enhan_name).info.frame6.frame1.label1 {right frame center fill} \
    $topwin(enhan_name).info.frame6.frame1.radiobutton2 {top frame w fill} \
    $topwin(enhan_name).info.frame6.frame1.radiobutton3 {top frame w fill}

  # build widget $topwin(enhan_name).info.frame6.frame0
  frame $topwin(enhan_name).info.frame6.frame0 \
    -background "$GuiColor(frame_bg)"

  # build widget $topwin(enhan_name).info.frame6.frame0.label1
  label $topwin(enhan_name).info.frame6.frame0.label1 \
    -anchor {e} \
    -background "$GuiColor(label_bg)" \
    -borderwidth {0} \
    -text {by a factor factor: }

  # build widget $topwin(enhan_name).info.frame6.frame0.value
  entry $topwin(enhan_name).info.frame6.frame0.value \
    -background "$GuiColor(entry_bg)" \
	 -foreground "$GuiColor(entry_fg)" \
    -relief {sunken} \
    -textvariable {enhan(histo_multiply)} \
    -width {10}

  # bindings
  endEntry $topwin(enhan_name).info.frame6.frame0.value

  # build widget $topwin(enhan_name).info.frame6.frame0.menubutton2
	menubutton $topwin(enhan_name).info.frame6.frame0.menubutton2 -padx {1} -pady {1} -highlightthickness {0}  \
    -activebackground "$GuiColor(btn_act_bg)" \
    -background "$GuiColor(btn_bg)" \
    -font "$GuiMisc(pop_up_fn)" \
    -relief "$GuiMisc(pop_up_relief)" \
    -text "$GuiMisc(pop_up_text)" \
	 -width {2}
  # bindings
  bind $topwin(enhan_name).info.frame6.frame0.menubutton2 <Button-1> {
  MenuPopupPost $topwin(enhan_name).info.frame6.frame0.menubutton2.menu %X %Y}
  bind $topwin(enhan_name).info.frame6.frame0.menubutton2  <ButtonRelease-1> {
  MenuPopupRelease $topwin(enhan_name).info.frame6.frame0.menubutton2.menu %W}

  # build widget $topwin(enhan_name).info.frame6.frame0.menubutton2.menu
  menu $topwin(enhan_name).info.frame6.frame0.menubutton2.menu \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)"
  $topwin(enhan_name).info.frame6.frame0.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -command {set enhan(histo_multiply) 0.2} \
    -label {  0.2}
  $topwin(enhan_name).info.frame6.frame0.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -command {set enhan(histo_multiply) 0.5} \
    -label {  0.5}
  $topwin(enhan_name).info.frame6.frame0.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -command {set enhan(histo_multiply) 0.8} \
    -label {  0.8}
  $topwin(enhan_name).info.frame6.frame0.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -command {set enhan(histo_multiply) 1.2} \
    -label {  1.2}
  $topwin(enhan_name).info.frame6.frame0.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -command {set enhan(histo_multiply) 1.5} \
    -label {  1.5}
  $topwin(enhan_name).info.frame6.frame0.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -command {set enhan(histo_multiply) 1.8} \
    -label {  1.8}
  $topwin(enhan_name).info.frame6.frame0.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -command {set enhan(histo_multiply) 2.0} \
    -label {  2.0}
  $topwin(enhan_name).info.frame6.frame0.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -command {set enhan(histo_multiply) 2.5} \
    -label {  2.5}
  $topwin(enhan_name).info.frame6.frame0.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -command {set enhan(histo_multiply) 3.0} \
    -label {  3.0}
  bindtags $topwin(enhan_name).info.frame6.frame0.menubutton2.menu {Menu all}
  # bindings
  bind $topwin(enhan_name).info.frame6.frame0.menubutton2.menu <B1-Motion> {
  MenuPopupMotion $topwin(enhan_name).info.frame6.frame0.menubutton2.menu %W %X %Y}
  bind $topwin(enhan_name).info.frame6.frame0.menubutton2.menu <ButtonRelease-1> {
  MenuPopupRelease $topwin(enhan_name).info.frame6.frame0.menubutton2.menu %W}

  # pack widget $topwin(enhan_name).info.frame6.frame0
  pack append $topwin(enhan_name).info.frame6.frame0 \
    $topwin(enhan_name).info.frame6.frame0.label1 {left frame center fill} \
    $topwin(enhan_name).info.frame6.frame0.value {left frame center fill} \
    $topwin(enhan_name).info.frame6.frame0.menubutton2 {right frame center fill}

  # pack widget $topwin(enhan_name).info.frame6
  pack append $topwin(enhan_name).info.frame6 \
    $topwin(enhan_name).info.frame6.radiobutton2 {left frame center} \
    $topwin(enhan_name).info.frame6.frame1 {left frame center } \
    $topwin(enhan_name).info.frame6.frame0 {left frame center padx 215}


  # pack widget $topwin(enhan_name).info
  pack append $topwin(enhan_name).info \
    $topwin(enhan_name).info.frame0 {top frame center expand fill} \
    $topwin(enhan_name).info.frame1 {top frame center expand fill} \
    $topwin(enhan_name).info.frame2 {top frame center expand fill} \
    $topwin(enhan_name).info.frame3 {top frame center expand fill} \
    $topwin(enhan_name).info.frame4 {top frame center expand fill} \
    $topwin(enhan_name).info.frame5 {top frame center expand fill} \
    $topwin(enhan_name).info.frame6 {top frame center expand fill} 

  # build widget $topwin(enhan_name).current_image
  frame $topwin(enhan_name).current_image \
    -background "$GuiColor(frame_bg)" \
    -borderwidth {2} \
    -relief {ridge}

  # build widget $topwin(enhan_name).current_image.label6
  label $topwin(enhan_name).current_image.label6 \
    -background "$GuiColor(label_bg)" \
    -text {Current image:}

  # build widget $topwin(enhan_name).current_image.label7
  label $topwin(enhan_name).current_image.label7 \
    -background "$GuiColor(label_bg)" \
    -foreground {Blue} \
    -text {} \
    -textvariable {current_image}

  # pack widget $topwin(enhan_name).current_image
  pack append $topwin(enhan_name).current_image \
    $topwin(enhan_name).current_image.label6 {left frame center} \
    $topwin(enhan_name).current_image.label7 {left frame center}

  # build widget $topwin(enhan_name).perform
  frame $topwin(enhan_name).perform \
	 -relief {raised} \
    -background "$GuiColor(frame_bg)" \
    -borderwidth {2}

  # build widget $topwin(enhan_name).perform.dismiss
	button $topwin(enhan_name).perform.dismiss -padx {1} -pady {1} -highlightthickness {0}  \
    -background "$GuiColor(dis_bg)"  \
    -activebackground "$GuiColor(dis_act_bg)"  \
    -foreground "$GuiColor(dis_fg)"  \
	 -command {destroy $topwin(enhan_name)} \
    -text {DISMISS}

  # build widget $topwin(enhan_name).perform.button9
	button $topwin(enhan_name).perform.button9 -padx {1} -pady {1} -highlightthickness {0}  \
    -background "$GuiColor(alert_bg)"  \
    -activebackground "$GuiColor(alert_act_bg)"  \
    -foreground "$GuiColor(alert_fg)"  \
    -command {catch [cvip view $current_image h] cresult} \
    -text {View histogram}

  # build widget $topwin(enhan_name).perform.button10
	button $topwin(enhan_name).perform.button10 -padx {1} -pady {1} -highlightthickness {0}  \
    -background "$GuiColor(perf_bg)"  \
    -activebackground "$GuiColor(perf_act_bg)"  \
    -foreground "$GuiColor(perf_fg)"  \
    -text {PERFORM} \
	 -command {
		set new_name ""
		$topwin(enhan_name) configure -cursor watch; update
      if { $current_image == ""} {
         CvipAlert "Please select an image first."
			$topwin(enhan_name) configure -cursor top_left_arrow; update
         return
      } 
		switch -exact -- $enhan(hist) {
		histeq {
	   	if {$bands == "1"} {
				if [catch {set result [cvip histeq $current_image]} cresult] {
            CvipAlert "$cresult."
				$topwin(enhan_name) configure -cursor top_left_arrow; update
  	         return
			}	
			set temp "cvip rename $result [append new_name $current_image _histeq]"
			set new_name [eval $temp]
			img_q insert end $new_name
			image_post $new_name
			cvip view $new_name
			$topwin(enhan_name) configure -cursor top_left_arrow; update
			CvipMessage "histogram equalization performed on image \"$current_image\""
			return
			}

			if {$bands == "3" && $enhan(hist_band) == "3"} {
				if [catch {set temp1 [cvip cxform $current_image HSL 1 1 1]} cresult] {
		         CvipAlert "$cresult."
					$topwin(enhan_name) configure -cursor top_left_arrow; update
		         return
				} elseif [catch { set temp2 [cvip histeq $temp1 2] } cresult] {
		         CvipAlert "$cresult."
					$topwin(enhan_name) configure -cursor top_left_arrow; update
	  				return
				} elseif [catch { cvip dq $temp1 } cresult ] {
		         CvipAlert "$cresult."
					$topwin(enhan_name) configure -cursor top_left_arrow; update
		         return
				} elseif [catch {set result [cvip cxform $temp2 HSL 0 1 1]} cresult] {
		         CvipAlert "$cresult."
					$topwin(enhan_name) configure -cursor top_left_arrow; update
		         return
				} elseif [catch {cvip dq $temp2} cresult] {
		         CvipAlert "$cresult."
					$topwin(enhan_name) configure -cursor top_left_arrow; update
		         return
				}
				set temp "cvip rename $result [append new_name $current_image _heq_val]"
				set new_name [eval $temp]
				img_q insert end $new_name
				image_post $new_name
				cvip view $new_name
				unset temp1
				unset temp2
				$topwin(enhan_name) configure -cursor top_left_arrow; update
				CvipMessage "histogram equalization performed on image \"$current_image\"\n \
					for all the bands"
				return
			}

			if {$bands == "3" && $enhan(hist_band) != "3"} {
				if [catch {set result [cvip histeq $current_image $enhan(hist_band)]} cresult] {
		         CvipAlert "$cresult."
					$topwin(enhan_name) configure -cursor top_left_arrow; update
		         return
				}
				switch -exact -- $enhan(hist_band) {
					0 {set eq_color red}
					1 {set eq_color green}
					2 {set eq_color blue}
	   		}
				set new_name [cvip rename $result  "${current_image}_heq_$eq_color"]
				img_q insert end $new_name
				image_post $new_name
				CvipMessage "histogram equalization performed on image \"$current_image\"\n \
					for band $enhan(hist_band)"
				cvip view $new_name
			}
		}

		hist_slide {
			if [catch {expr $enhan(hist_slide_value)}] {
	         CvipAlert "Numerical value required for the histogram slide amount:\n\
				Slide amount = $enhan(hist_slide_value)."
				$topwin(enhan_name) configure -cursor top_left_arrow; update
	         return
			} elseif {$enhan(hist_slide_value) < 0} {
	         CvipAlert "Positive value required for the histogram slide amount:\n\
				Slide amount = $enhan(hist_slide_value)."
				$topwin(enhan_name) configure -cursor top_left_arrow; update
	         return
			}
			if [catch {set result [cvip hist_slide $current_image $enhan(hist_slide_dir)\
											$enhan(hist_slide_value)]} cresult] {
	        CvipAlert "$cresult."
				$topwin(enhan_name) configure -cursor top_left_arrow; update
	        return
			}
			if {$enhan(hist_slide_dir) == "1" } {
			  set temp Up
			} else {
			  set temp Down
			}
			set new_name [cvip rename $result "${current_image}_slide${temp}_$enhan(hist_slide_value)"]
			img_q insert end $new_name
			image_post $new_name
			CvipMessage "histogram slide performed on image \"$current_image\""
			cvip view $new_name
		}

		hist_shrink -
		hist_stretch {
			if [catch {expr $enhan(hist_shrink_lower) + $enhan(hist_shrink_upper)}] {
	         CvipAlert "Numerical value required for the $enhan(hist) upper and lower limit:\n\
				Lower limit = $enhan(hist_shrink_lower), Upper limit = $enhan(hist_shrink_upper)."
				$topwin(enhan_name) configure -cursor top_left_arrow; update
	         return
			} elseif {$enhan(hist_shrink_lower) < 0 || $enhan(hist_shrink_lower) > 254} {
	         CvipAlert "The $enhan(hist) lower limit should be in the range (0-254):\n\
				Lower limit = $enhan(hist_shrink_lower)."
				$topwin(enhan_name) configure -cursor top_left_arrow; update
	         return
			} elseif {$enhan(hist_shrink_upper) < 1 || $enhan(hist_shrink_upper) > 255} {
	         CvipAlert "The $enhan(hist) upper limit should be in the range (1-255):\n\
				Upper limit = $enhan(hist_shrink_upper)."
				$topwin(enhan_name) configure -cursor top_left_arrow; update
	         return
			}
			set temp "cvip $enhan(hist)  $current_image $enhan(hist_shrink_lower) $enhan(hist_shrink_upper)"
			if { $enhan(hist) == "hist_stretch" } {
				if [catch { expr  $enhan(hist_h_c) + $enhan(hist_l_c) } ] {
	         	CvipAlert "Numerical values required for high and low clip percentage:\n\
					Low clip  = $enhan(hist_l_c), High clip = $enhan(hist_h_c)."
					$topwin(enhan_name) configure -cursor top_left_arrow; update
	         	return
				} elseif { $enhan(hist_h_c) < 0 || $enhan(hist_h_c) > 1 ||
							  $enhan(hist_l_c) < 0 || $enhan(hist_l_c) > 1 } {
	         	CvipAlert "The high and low clip percentage should be in the range \[0, 1\]:\n\
					Low clip  = [expr 100*$enhan(hist_l_c)]%, High clip = [expr 100*$enhan(hist_h_c)]%."
					$topwin(enhan_name) configure -cursor top_left_arrow; update
	         	return

				}
				append temp "  $enhan(hist_l_c) $enhan(hist_h_c)"
			}
			if [catch {set result [eval $temp ] } cresult] {
	        CvipAlert "$cresult."
				$topwin(enhan_name) configure -cursor top_left_arrow; update
	        return
			}
			if { $GUI_DEBUG == "1" } {
				puts stderr $temp
			}
			set new_name [cvip rename $result "${current_image}_$enhan(hist)"]
			img_q insert end $new_name
			image_post $new_name
			cvip view $new_name
			if { $enhan(hist) == "hist_shrink" } {
				CvipMessage "histogram shrink performed on image \"$current_image\""
			} else {
				CvipMessage "histogram stretch performed on image \"$current_image\""
			}
		}

		local_histeq {
			set temp [expr {$rows > $cols} ? $cols : $rows]
			if {$enhan(hist_band) == "3"} {
	         CvipAlert "Please select a band first."
				$topwin(enhan_name) configure -cursor top_left_arrow; update
	         return
			}
			if {$bands == "1"} {
				set temp1 0
			} else {
				set temp1 $enhan(hist_band)
			}
			if [catch {expr $enhan(hist_leq_size)}] {
	         CvipAlert "Numerical value required for block size of local histogram equalization:\n\
				Block size = $enhan(hist_leq_size)."
				$topwin(enhan_name) configure -cursor top_left_arrow; update
	         return
			} elseif {$enhan(hist_leq_size) < 0 || $enhan(hist_leq_size) > $temp} {
	         CvipAlert "The block size of local histogram equalization for image ($current_image)\
				should be in the range (0-$temp):\n Block size = $enhan(hist_leq_size)."
				$topwin(enhan_name) configure -cursor top_left_arrow; update
	         return
			}

			if [catch {set result [cvip $enhan(hist)  $current_image $temp1 $enhan(hist_leq_size)]} cresult] {
	        CvipAlert "$cresult."
				$topwin(enhan_name) configure -cursor top_left_arrow; update
	        return
			}
			set new_name [cvip rename $result "${current_image}_$enhan(hist)"]
			img_q insert end $new_name
			image_post $new_name
			CvipMessage "local histogram equalization performed on image \"$current_image\""
			cvip view $new_name
		}

		hist_spec {
			if {$bands == "3"} {
				if {$enhan(hist_eqr) == "" || $enhan(hist_eqg) == "" || $enhan(hist_eqb) == ""} {
	        		CvipAlert "Please input a function for every band."
					$topwin(enhan_name) configure -cursor top_left_arrow; update
	        		return
				}
				set temp "cvip $enhan(hist) $current_image "
				append temp "\{[string trim $enhan(hist_eqr)]\} "
				append temp "\{[string trim $enhan(hist_eqg)]\} "
				append temp "\{[string trim $enhan(hist_eqb)]\}"
				if [catch {set result [eval $temp]} cresult] {
	        		CvipAlert "$cresult."
					$topwin(enhan_name) configure -cursor top_left_arrow; update
	        		return
				}
				if { $GUI_DEBUG == "1" } {
					puts stderr $temp
				}
				set new_name [cvip rename $result "${current_image}_$enhan(hist)"]
				img_q insert end $new_name
				image_post $new_name
				cvip view $new_name
			} else {
				if {$enhan(hist_eqr) == ""}  {
	        		CvipAlert "Please input a function first."
					$topwin(enhan_name) configure -cursor top_left_arrow; update
	        		return
				}
				set temp "cvip $enhan(hist) $current_image \{[string trim $enhan(hist_eqr)]\}"
				if [catch {set result [eval $temp]} cresult] {
	        		CvipAlert "$cresult."
					$topwin(enhan_name) configure -cursor top_left_arrow; update
	        		return
				}
				if { $GUI_DEBUG == "1" } {
					puts stderr $temp
				}
				set new_name [cvip rename $result "${current_image}_$enhan(hist)"]
				img_q insert end $new_name
				image_post $new_name
				cvip view $new_name
			}
			CvipMessage "histogram specification performed on image \"$current_image\""
		}

		gray_linear {
			if [catch {expr $enhan(hist_linear_srt) + $enhan(hist_linear_end) +\
				$enhan(hist_linear_val) + $enhan(hist_linear_slp)}] {
	         CvipAlert "Numerical value required for the $enhan(hist) parameters:\n\
				Start value = $enhan(hist_linear_srt), End value = $enhan(hist_linear_end),\n\
				Offset = $enhan(hist_linear_val), Slope = $enhan(hist_linear_slp)."
				$topwin(enhan_name) configure -cursor top_left_arrow; update
	         return
			} elseif {$enhan(hist_linear_srt) < 0 || $enhan(hist_linear_srt) > 255} {
	         CvipAlert "The $enhan(hist) start value should be in the range (0-255):\n\
				Start value = $enhan(hist_linear_srt)."
				$topwin(enhan_name) configure -cursor top_left_arrow; update
	         return
			} elseif {$enhan(hist_linear_end) < 1 || $enhan(hist_linear_end) > 255} {
	         CvipAlert "The $enhan(hist) end value should be in the range (0-255):\n\
				End value = $enhan(hist_linear_end)."
				$topwin(enhan_name) configure -cursor top_left_arrow; update
	         return
			} elseif {$enhan(hist_linear_end) <= $enhan(hist_linear_srt)} {
	         CvipAlert "The $enhan(hist) end value ($enhan(hist_linear_end))should be greater than the start\
				value ($enhan(hist_linear_srt))."
				$topwin(enhan_name) configure -cursor top_left_arrow; update
	         return
			} elseif {$enhan(hist_linear_val) < 0} {
	         CvipAlert "The $enhan(hist) offset value ($enhan(hist_linear_val))should be greater than 0."
				$topwin(enhan_name) configure -cursor top_left_arrow; update
	         return
			} 
			if [catch {set result [cvip $enhan(hist)  $current_image $enhan(hist_linear_srt) \
								$enhan(hist_linear_end) $enhan(hist_linear_val) $enhan(hist_linear_slp)\
								$enhan(hist_linear_outer)]} cresult] {
	        	CvipAlert "$cresult."
				$topwin(enhan_name) configure -cursor top_left_arrow; update
	        	return
			}
			set new_name [cvip rename $result "${current_image}_$enhan(hist)"]
			img_q insert end $new_name
			image_post $new_name
			cvip view $new_name
			CvipMessage "linear modification performed on image \"$current_image\""
		}
		gray_multiply {
			if [catch {expr $enhan(histo_multiply)} ] {
         CvipAlert "Numerical value required for gray level multiplication factor.\n
			Multiplication factor = $enhan(histo_multiply)"
			$topwin(enhan_name) configure -cursor top_left_arrow; update
         return
      } elseif { $enhan(histo_multiply) < 0 } {
         CvipAlert "Multiplication factor should be a non-negative value.\n\
			Multiplication factor = $enhan(histo_multiply)"
			$topwin(enhan_name) configure -cursor top_left_arrow; update
         return
      }  
      if [catch {set result [cvip gray_multiply $current_image $enhan(histo_multiply) $enhan(mult_clip)]\
					 } cresult ] {
         CvipAlert "$cresult"
			$topwin(enhan_name) configure -cursor top_left_arrow; update
         return
      }  
      set new_name [cvip rename $result ${current_image}_x$enhan(histo_multiply)]
      img_q insert end $new_name
      image_post $new_name
      cvip view $new_name
		CvipMessage "gray level multiplication performed on image \"$current_image\""
		}

		adaptive_contrast {
			if [catch {expr $enhan(adap_k1) + $enhan(adap_k2) + $enhan(adap_kern) + \
				$enhan(adap_max) + $enhan(adap_min) } ] {
               CvipAlert "Numerical parameters required : \n \
                  Local gain factor = $enhan(adap_k1), Local gain max = $enhan(adap_max), \
					Local gain min = $enhan(adap_min),\n\
					Loacal mean factor = $enhan(adap_k2), Kernel size = $enhan(adap_kern)." 
               $topwin(enhan_name) configure -cursor top_left_arrow; update
               return
				
			} elseif { $enhan(adap_k1) < "0" || $enhan(adap_k2) < "0" || \
						$enhan(adap_max) < "0" || $enhan(adap_min) < "0" || $enhan(adap_kern) < "0" } {
               CvipAlert "Positive values  required : \n \
                  Local gain factor = $enhan(adap_k1), Local gain max = $enhan(adap_max),  \
					Local gain min = $enhan(adap_min),\n\
					Loacal mean factor = $enhan(adap_k2), Kernel size = $enhan(adap_kern). "
               $topwin(enhan_name) configure -cursor top_left_arrow; update
               return
			} elseif { floor($enhan(adap_kern)) != $enhan(adap_kern) || \
							floor($enhan(adap_kern) / 2) * 2 == $enhan(adap_kern) } {
               CvipAlert "Positive odd integer  required for the kernel size ($enhan(adap_kern))." 
               $topwin(enhan_name) configure -cursor top_left_arrow; update
               return
			}
            if [catch {set result [cvip $enhan(hist) $current_image\
						$enhan(adap_k1) $enhan(adap_k2) $enhan(adap_kern)\
						$enhan(adap_min) $enhan(adap_max)]} cresult] {
               CvipAlert "$cresult."
               $topwin(enhan_name) configure -cursor top_left_arrow; update
               return
            } else {
               set new_name [cvip rename $result ${current_image}_AdptContra]
               img_q insert end $new_name
               image_post $new_name
               cvip view $new_name
            }
			if { $GUI_DEBUG == "1" } {
				puts stderr "cvip $enhan(hist) $current_image\
					$enhan(adap_k1) $enhan(adap_k2) $enhan(adap_kern)\
					$enhan(adap_min) $enhan(adap_max)"
			}
			CvipMessage "adaptive contrast enhancement performed on image \"$current_image\""
		}
		}

		$topwin(enhan_name) configure -cursor top_left_arrow; update
	 }

  # pack widget $topwin(enhan_name).perform
  pack append $topwin(enhan_name).perform \
    $topwin(enhan_name).perform.dismiss {left frame center} \
    $topwin(enhan_name).perform.button9 {left frame center expand} \
    $topwin(enhan_name).perform.button10 {left frame center}

  # pack widget $topwin(enhan_name).
  pack append $topwin(enhan_name) \
    $topwin(enhan_name).info {top frame center expand fill} \
    $topwin(enhan_name).current_image {top frame center fillx} \
    $topwin(enhan_name).perform {bottom frame center fillx}


  if {"[info procs XFEdit]" != ""} {
    catch "XFMiscBindWidgetTree $topwin(enhan_name)."
    after 2 "catch {XFEditSetShowWindows}"
  }
}

