# **********************************************************************
# Computer Vision/Image Processing Tool Project - Dr. Scott Umbaugh SIUE
# **********************************************************************
#
#             File Name: enhan_sharp.tcl
#           Description: 
#         Related Files: 
#   Initial Coding Date: Wed Oct  2 13:06:36 CDT 1996
#           Portability: TCL script file
#            References:
#             Author(s): Yansheng Wei and Mark Zuke
#                        Southern Illinois University @ Edwardsville
#
## Copyright (C) 1996 SIUE - by Scott Umbaugh, Mark Zuke and Yansheng Wei.
##
## Permission to use, copy, modify, and distribute this software and its
## documentation for any purpose and without fee is hereby granted, provided
## that the above copyright notice appear in all copies and that both that
## copyright notice and this permission notice appear in supporting
## documentation.  This software is provided "as is" without express or
## implied warranty.
##
# RCS (Revision Control System) Information
# ...Added automatically by RCS 
#
## $Log: enhan_sharp.tcl,v $
## Revision 1.24  1997/07/25 18:42:00  wzheng
## High boost: Center value popup, chnage the values to:
## 5,7,8,9,25,49,81
##
## Revision 1.23  1997/07/22 20:06:39  wzheng
## DC button raised
##
## Revision 1.22  1997/07/09 02:35:41  wzheng
## homo-cutoff seting
##
## Revision 1.21  1997/07/08 00:28:56  wzheng
## *** empty log message ***
##
## Revision 1.20  1997/07/08 00:19:11  wzheng
## *** empty log message ***
##
## Revision 1.19  1997/07/07 20:22:56  yawei
## Gui configuration in place
##
## Revision 1.18  1997/07/07 19:18:13  yawei
## check in for Sreenivas
##
## Revision 1.17  1997/06/25 17:54:24  wzheng
## initial blocksize of H.F.E.
##
## Revision 1.16  1997/06/23 16:42:57  wzheng
## add result with origal on the Homomorphic sharp
##
## Revision 1.15  1997/06/17 21:34:22  wzheng
## add butterworth order drop-down list entry for FFT, DCT
##
## Revision 1.14  1997/06/17 17:30:17  wzheng
## add the original image and hist stretch to FFT DTC HFE HOMOMOR
##
## Revision 1.13  1997/03/20 18:49:24  yawei
## updated freq filters
##
## Revision 1.12  1997/03/12 01:02:50  yawei
## fixed arrow button bugs
##
## Revision 1.11  1997/03/11 20:56:08  yawei
## Tcl/Tk script upgrading from tcl7.3/tk3.6 to tcl7.6/tk4.2
## compatible. This process is automated with tkboost perl
## script. @ Tue Mar 11 14:51:36 CST 1997
##
## Revision 1.10  1996/11/14 00:12:16  yawei
## Changed the unsharp so the hist_stretch is done internally in cviptcl
##
# Revision 1.9  1996/11/13  21:14:34  yawei
# Added hist_stretch to the unsharp mask
#
# Revision 1.8  1996/11/02  04:40:49  yawei
# Added homomorphic under ENHANCE/SHARP/FREQ_SHARP
#
# Revision 1.7  1996/10/18  14:54:12  yawei
# Changed so "Add to original image" applying to only three options.
#
# Revision 1.6  1996/10/16  03:49:51  yawei
# general changes
#
# Revision 1.5  1996/10/13  23:30:22  yawei
# Changed the cutoff frequency of the fft/dct sharpening, so it is adjustable now, with the
# upper bound to be blocksize/16.
#
# Revision 1.4  1996/10/07  01:37:23  yawei
# 1) changed the "add to original image" option to all four spatiacl enhancement
# 2) changed the default mask size for High-boost to 3
#
# Revision 1.3  1996/10/03  02:39:38  yawei
# added the missing name in frequency hfe
#
# Revision 1.2  1996/10/03  02:12:19  yawei
# changed the offset value range of hfe to 0.01 - 3.0
#
# Revision 1.1  1996/10/02  18:08:26  yawei
# Initial revision
#
#
#****************************************************************************
# procedure to show window $topwin(enhan_name)
proc enhan_sharp { } {# xf ignore me 7

  # Window manager configurations
  global tk_version
  global topwin
  global toplevel_position
  global {enhan}
  global {GuiColor}
  global {GuiMisc}
  global {GUI_DEBUG}


  if [ winfo exists  $topwin(enhan_name).info] {
     set tempname $topwin(enhan_name);\
destroy $topwin(enhan_name).info;\
set topwin(enhan_name) $tempname;}
  if [ winfo exists  $topwin(enhan_name).current_image] {
     set tempname $topwin(enhan_name);\
destroy $topwin(enhan_name).current_image;\
set topwin(enhan_name) $tempname;}
  if [ winfo exists  $topwin(enhan_name).perform] {
     set tempname $topwin(enhan_name);\
destroy $topwin(enhan_name).perform;\
set topwin(enhan_name) $tempname;}
 
  wm positionfrom $topwin(enhan_name) user
  wm sizefrom $topwin(enhan_name) user
  wm geometry $topwin(enhan_name) $topwin(enhan_sharp)[get_pos $topwin(enhan_name)]
  wm maxsize $topwin(enhan_name) [lindex $topwin(enhan_sharp_max) 0] \
  	[lindex $topwin(enhan_sharp_max) 1]
  wm minsize $topwin(enhan_name) [lindex $topwin(enhan_sharp_min) 0] \
  	[lindex $topwin(enhan_sharp_min) 1]
  wm title $topwin(enhan_name) {ENHANCEMENT -> Sharpening}

  bind $topwin(enhan_name) <Destroy> {set topwin(enhan_name) NONE}

  # build widget $topwin(enhan_name).info
  frame $topwin(enhan_name).info \
    -background "$GuiColor(frame_bg)" \
    -borderwidth {0}

  # build widget $topwin(enhan_name).info.frame3
  frame $topwin(enhan_name).info.frame3 \
    -background "$GuiColor(frame_bg)" \
    -borderwidth {3} \
    -relief {ridge}

  # build widget $topwin(enhan_name).info.frame3.frame0
  frame $topwin(enhan_name).info.frame3.frame0 \
    -background "$GuiColor(frame_bg)" \
    -borderwidth {2} \
    -relief {ridge}

  # build widget $topwin(enhan_name).info.frame3.frame0.frame3
  frame $topwin(enhan_name).info.frame3.frame0.frame3 \
    -background "$GuiColor(frame_bg)" \
    -borderwidth {2}

  # build widget $topwin(enhan_name).info.frame3.frame0.frame3.frame9
  frame $topwin(enhan_name).info.frame3.frame0.frame3.frame9 \
    -background "$GuiColor(frame_bg)" \
    -borderwidth {2}

  # build widget $topwin(enhan_name).info.frame3.frame0.frame3.frame9.radiobutton5
	radiobutton $topwin(enhan_name).info.frame3.frame0.frame3.frame9.radiobutton5 -padx {1} -pady {1} -highlightthickness {0}  \
    -activebackground "$GuiColor(btn_act_bg)" \
    -background "$GuiColor(btn_bg)" \
    -command {
pack forget $topwin(enhan_name).info.frame3.frame0.frame3.frame13.frame10.frame5
pack forget $topwin(enhan_name).info.frame3.frame0.frame3.frame13.frame14.frame12
} \
    -relief {flat} \
    -text {Sharpening algorithm} \
    -value {sharp} \
    -variable {enhan(sharp)}

  set enhan(sharp) high_boost
  # build widget $topwin(enhan_name).info.frame3.frame0.frame3.frame9.radiobutton1
	radiobutton $topwin(enhan_name).info.frame3.frame0.frame3.frame9.radiobutton1 -padx {1} -pady {1} -highlightthickness {0}  \
    -activebackground "$GuiColor(btn_act_bg)" \
    -background "$GuiColor(btn_bg)" \
    -command {
pack $topwin(enhan_name).info.frame3.frame0.frame3.frame13.frame10.frame5
pack $topwin(enhan_name).info.frame3.frame0.frame3.frame13.frame14.frame12
set enhan(sh_mask_size) 3
set enhan(sh_mask_center) 9
} \
    -relief {flat} \
    -text {High boost} \
    -value {high_boost} \
    -variable {enhan(sharp)}

  # build widget $topwin(enhan_name).info.frame3.frame0.frame3.frame9.radiobutton3
	radiobutton $topwin(enhan_name).info.frame3.frame0.frame3.frame9.radiobutton3 -padx {1} -pady {1} -highlightthickness {0}  \
    -activebackground "$GuiColor(btn_act_bg)" \
    -background "$GuiColor(btn_bg)" \
    -command {
pack forget $topwin(enhan_name).info.frame3.frame0.frame3.frame13.frame10.frame5
pack forget $topwin(enhan_name).info.frame3.frame0.frame3.frame13.frame14.frame12
} \
    -relief {flat} \
    -text {Highpass spatial filter } \
    -value {highpass_spatial} \
    -variable {enhan(sharp)}

  # pack widget $topwin(enhan_name).info.frame3.frame0.frame3.frame9
  pack append $topwin(enhan_name).info.frame3.frame0.frame3.frame9 \
    $topwin(enhan_name).info.frame3.frame0.frame3.frame9.radiobutton5 {top frame w} \
    $topwin(enhan_name).info.frame3.frame0.frame3.frame9.radiobutton3 {top frame w} \
    $topwin(enhan_name).info.frame3.frame0.frame3.frame9.radiobutton1 {top frame w}

  # build widget $topwin(enhan_name).info.frame3.frame0.frame3.frame13
  frame $topwin(enhan_name).info.frame3.frame0.frame3.frame13 \
    -background "$GuiColor(frame_bg)" \
    -borderwidth {2}

  # build widget $topwin(enhan_name).info.frame3.frame0.frame3.frame13.frame10
  frame $topwin(enhan_name).info.frame3.frame0.frame3.frame13.frame10 \
    -background "$GuiColor(frame_bg)" \
    -borderwidth {2}

  # build widget $topwin(enhan_name).info.frame3.frame0.frame3.frame13.frame10.frame5
  frame $topwin(enhan_name).info.frame3.frame0.frame3.frame13.frame10.frame5 \
    -background "$GuiColor(frame_bg)" \
    -borderwidth {2}

  # build widget $topwin(enhan_name).info.frame3.frame0.frame3.frame13.frame10.frame5.label6
  label $topwin(enhan_name).info.frame3.frame0.frame3.frame13.frame10.frame5.label6 \
    -background "$GuiColor(label_bg)" \
    -text {Mask size :}

  # build widget $topwin(enhan_name).info.frame3.frame0.frame3.frame13.frame10.frame5.entry7
  entry $topwin(enhan_name).info.frame3.frame0.frame3.frame13.frame10.frame5.entry7 \
    -background "$GuiColor(rentry_bg)" \
    -foreground "$GuiColor(rentry_fg)" \
    -relief {sunken} \
    -state {disabled} \
    -textvariable {enhan(sh_mask_size)} \
    -width {3}

  # build widget $topwin(enhan_name).info.frame3.frame0.frame3.frame13.frame10.frame5.button8
	menubutton $topwin(enhan_name).info.frame3.frame0.frame3.frame13.frame10.frame5.button8 -padx {1} -pady {1} -highlightthickness {0}  \
    -activebackground "$GuiColor(btn_act_bg)" \
    -background "$GuiColor(btn_bg)" \
	 -font "$GuiMisc(pop_up_fn)" \
	 -text "$GuiMisc(pop_up_text)" \
	 -relief "$GuiMisc(pop_up_relief)" \
	 -width {2}
  # bindings
  bind $topwin(enhan_name).info.frame3.frame0.frame3.frame13.frame10.frame5.button8 <Button-1> {MenuPopupPost $topwin(enhan_name).info.frame3.frame0.frame3.frame13.frame10.frame5.button8.menu %X %Y}
  bind $topwin(enhan_name).info.frame3.frame0.frame3.frame13.frame10.frame5.button8 <ButtonRelease-1> {MenuPopupRelease $topwin(enhan_name).info.frame3.frame0.frame3.frame13.frame10.frame5.button8.menu %W}

  # build widget $topwin(enhan_name).info.frame3.frame0.frame3.frame13.frame10.frame5.button8.menu
  menu $topwin(enhan_name).info.frame3.frame0.frame3.frame13.frame10.frame5.button8.menu \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" 
  $topwin(enhan_name).info.frame3.frame0.frame3.frame13.frame10.frame5.button8.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set enhan(sh_mask_size) 3} \
    -label { 3 }
  $topwin(enhan_name).info.frame3.frame0.frame3.frame13.frame10.frame5.button8.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set enhan(sh_mask_size) 5} \
    -label { 5 }
  $topwin(enhan_name).info.frame3.frame0.frame3.frame13.frame10.frame5.button8.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set enhan(sh_mask_size) 7} \
    -label { 7 }
  $topwin(enhan_name).info.frame3.frame0.frame3.frame13.frame10.frame5.button8.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set enhan(sh_mask_size) 7} \
    -label { 9 }
  # bindings
  bind $topwin(enhan_name).info.frame3.frame0.frame3.frame13.frame10.frame5.button8.menu <B1-Motion> {MenuPopupMotion $topwin(enhan_name).info.frame3.frame0.frame3.frame13.frame10.frame5.button8.menu %W %X %Y}
  bind $topwin(enhan_name).info.frame3.frame0.frame3.frame13.frame10.frame5.button8.menu <ButtonRelease-1> {MenuPopupRelease $topwin(enhan_name).info.frame3.frame0.frame3.frame13.frame10.frame5.button8.menu %W}

  # pack widget $topwin(enhan_name).info.frame3.frame0.frame3.frame13.frame10.frame5
  pack append $topwin(enhan_name).info.frame3.frame0.frame3.frame13.frame10.frame5 \
    $topwin(enhan_name).info.frame3.frame0.frame3.frame13.frame10.frame5.label6 {left frame center} \
    $topwin(enhan_name).info.frame3.frame0.frame3.frame13.frame10.frame5.entry7 {left frame center} \
    $topwin(enhan_name).info.frame3.frame0.frame3.frame13.frame10.frame5.button8 {left frame center}

  # pack widget $topwin(enhan_name).info.frame3.frame0.frame3.frame13.frame10
  pack append $topwin(enhan_name).info.frame3.frame0.frame3.frame13.frame10 \
    $topwin(enhan_name).info.frame3.frame0.frame3.frame13.frame10.frame5 {top frame center}

  # build widget $topwin(enhan_name).info.frame3.frame0.frame3.frame13.frame14
  frame $topwin(enhan_name).info.frame3.frame0.frame3.frame13.frame14 \
    -background "$GuiColor(frame_bg)" \
    -borderwidth {2}

  # build widget $topwin(enhan_name).info.frame3.frame0.frame3.frame13.frame14.frame12
  frame $topwin(enhan_name).info.frame3.frame0.frame3.frame13.frame14.frame12 \
    -background "$GuiColor(frame_bg)" \
    -borderwidth {2}

  # build widget $topwin(enhan_name).info.frame3.frame0.frame3.frame13.frame14.frame12.label6
  label $topwin(enhan_name).info.frame3.frame0.frame3.frame13.frame14.frame12.label6 \
    -background "$GuiColor(label_bg)" \
    -text {Center value :}

  # build widget $topwin(enhan_name).info.frame3.frame0.frame3.frame13.frame14.frame12.entry7
  entry $topwin(enhan_name).info.frame3.frame0.frame3.frame13.frame14.frame12.entry7 \
    -background "$GuiColor(entry_bg)" \
    -foreground "$GuiColor(entry_fg)" \
    -relief {sunken} \
    -textvariable {enhan(sh_mask_center)} \
    -width {3}
  endEntry $topwin(enhan_name).info.frame3.frame0.frame3.frame13.frame14.frame12.entry7

  # build widget $topwin(enhan_name).info.frame3.frame0.frame3.frame13.frame14.frame12.button8
	menubutton $topwin(enhan_name).info.frame3.frame0.frame3.frame13.frame14.frame12.button8 -padx {1} -pady {1} -highlightthickness {0}  \
    -activebackground "$GuiColor(btn_act_bg)" \
    -background "$GuiColor(btn_bg)" \
	 -font "$GuiMisc(pop_up_fn)" \
	 -text "$GuiMisc(pop_up_text)" \
	 -relief "$GuiMisc(pop_up_relief)" \
	 -width {2}
  # bindings
  bind $topwin(enhan_name).info.frame3.frame0.frame3.frame13.frame14.frame12.button8 <Button-1> {MenuPopupPost $topwin(enhan_name).info.frame3.frame0.frame3.frame13.frame14.frame12.button8.menu %X %Y}
  bind $topwin(enhan_name).info.frame3.frame0.frame3.frame13.frame14.frame12.button8 <ButtonRelease-1> {MenuPopupRelease $topwin(enhan_name).info.frame3.frame0.frame3.frame13.frame14.frame12.button8.menu %W}

  # build widget $topwin(enhan_name).info.frame3.frame0.frame3.frame13.frame14.frame12.button8.menu
  menu $topwin(enhan_name).info.frame3.frame0.frame3.frame13.frame14.frame12.button8.menu \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" 
  $topwin(enhan_name).info.frame3.frame0.frame3.frame13.frame14.frame12.button8.menu add command \
    -command {set enhan(sh_mask_center) 7} \
    -label { 5}
  $topwin(enhan_name).info.frame3.frame0.frame3.frame13.frame14.frame12.button8.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set enhan(sh_mask_center) 8} \
    -label { 7}
  $topwin(enhan_name).info.frame3.frame0.frame3.frame13.frame14.frame12.button8.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set enhan(sh_mask_center) 9} \
    -label { 8}
  $topwin(enhan_name).info.frame3.frame0.frame3.frame13.frame14.frame12.button8.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set enhan(sh_mask_center) 10} \
    -label { 9}
  $topwin(enhan_name).info.frame3.frame0.frame3.frame13.frame14.frame12.button8.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set enhan(sh_mask_center) 15} \
    -label {25}
  $topwin(enhan_name).info.frame3.frame0.frame3.frame13.frame14.frame12.button8.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set enhan(sh_mask_center) 25} \
    -label {49}
  $topwin(enhan_name).info.frame3.frame0.frame3.frame13.frame14.frame12.button8.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set enhan(sh_mask_center) 40} \
    -label {81}
  # bindings
  bind $topwin(enhan_name).info.frame3.frame0.frame3.frame13.frame14.frame12.button8.menu <B1-Motion> {MenuPopupMotion $topwin(enhan_name).info.frame3.frame0.frame3.frame13.frame14.frame12.button8.menu %W %X %Y}
  bind $topwin(enhan_name).info.frame3.frame0.frame3.frame13.frame14.frame12.button8.menu <ButtonRelease-1> {MenuPopupRelease $topwin(enhan_name).info.frame3.frame0.frame3.frame13.frame14.frame12.button8.menu %W}

  # pack widget $topwin(enhan_name).info.frame3.frame0.frame3.frame13.frame14.frame12
  pack append $topwin(enhan_name).info.frame3.frame0.frame3.frame13.frame14.frame12 \
    $topwin(enhan_name).info.frame3.frame0.frame3.frame13.frame14.frame12.label6 {left frame center} \
    $topwin(enhan_name).info.frame3.frame0.frame3.frame13.frame14.frame12.entry7 {left frame center} \
    $topwin(enhan_name).info.frame3.frame0.frame3.frame13.frame14.frame12.button8 {left frame center}

  # pack widget $topwin(enhan_name).info.frame3.frame0.frame3.frame13.frame14
  pack append $topwin(enhan_name).info.frame3.frame0.frame3.frame13.frame14 \
    $topwin(enhan_name).info.frame3.frame0.frame3.frame13.frame14.frame12 {top frame center}

  # pack widget $topwin(enhan_name).info.frame3.frame0.frame3.frame13
  pack append $topwin(enhan_name).info.frame3.frame0.frame3.frame13 \
    $topwin(enhan_name).info.frame3.frame0.frame3.frame13.frame10 {top frame e padx 20} \
    $topwin(enhan_name).info.frame3.frame0.frame3.frame13.frame14 {top frame e padx 20}

  # pack widget $topwin(enhan_name).info.frame3.frame0.frame3
  pack append $topwin(enhan_name).info.frame3.frame0.frame3 \
    $topwin(enhan_name).info.frame3.frame0.frame3.frame9 {top frame w fillx} \
    $topwin(enhan_name).info.frame3.frame0.frame3.frame13 {top frame center fillx} 

  # build widget $topwin(enhan_name).info.frame3.frame0.frame4
  frame $topwin(enhan_name).info.frame3.frame0.frame4 \
    -background "$GuiColor(frame_bg)" \
    -borderwidth {2}

  # build widget $topwin(enhan_name).info.frame3.frame0.frame4.frame6
  frame $topwin(enhan_name).info.frame3.frame0.frame4.frame6 \
    -background "$GuiColor(frame_bg)" \
    -borderwidth {2}

  # pack widget $topwin(enhan_name).info.frame3.frame0.frame4
  pack append $topwin(enhan_name).info.frame3.frame0.frame4 \
    $topwin(enhan_name).info.frame3.frame0.frame4.frame6 {left frame center expand fill}

  # build widget $topwin(enhan_name).info.frame3.frame0.check
	checkbutton $topwin(enhan_name).info.frame3.frame0.check -padx {1} -pady {1} -highlightthickness {0}  \
    -activebackground "$GuiColor(btn_act_bg)" \
    -background "$GuiColor(btn_bg)" \
    -relief {raised} \
    -text {Add result to the original image} \
    -variable {enhan(sh_add_result)}

  # pack widget $topwin(enhan_name).info.frame3.frame0
  pack append $topwin(enhan_name).info.frame3.frame0 \
	 $topwin(enhan_name).info.frame3.frame0.check {top frame e expand} \
    $topwin(enhan_name).info.frame3.frame0.frame3 {left frame nw filly} \
    $topwin(enhan_name).info.frame3.frame0.frame4 {left frame ne expand fill}

  # build widget $topwin(enhan_name).info.frame3.frame2
  frame $topwin(enhan_name).info.frame3.frame2 \
    -background "$GuiColor(frame_bg)" \
    -borderwidth {2} \
    -relief {ridge}

  # build widget $topwin(enhan_name).info.frame3.frame2.frame3
  frame $topwin(enhan_name).info.frame3.frame2.frame3 \
    -background "$GuiColor(frame_bg)" \
    -borderwidth {2}

  # build widget $topwin(enhan_name).info.frame3.frame2.frame3.radiobutton5
	radiobutton $topwin(enhan_name).info.frame3.frame2.frame3.radiobutton5 -padx {1} -pady {1} -highlightthickness {0}  \
    -activebackground "$GuiColor(btn_act_bg)" \
    -background "$GuiColor(btn_bg)" \
    -relief {flat} \
    -text {Unsharp masking} \
    -value {unsharp} \
    -variable {enhan(sharp)}

  # pack widget $topwin(enhan_name).info.frame3.frame2.frame3
  pack append $topwin(enhan_name).info.frame3.frame2.frame3 \
    $topwin(enhan_name).info.frame3.frame2.frame3.radiobutton5 {top frame center}

  # build widget $topwin(enhan_name).info.frame3.frame2.frame0
  frame $topwin(enhan_name).info.frame3.frame2.frame0 \
    -background "$GuiColor(frame_bg)" \
    -borderwidth {2}

  # build widget $topwin(enhan_name).info.frame3.frame2.frame0.label1
  label $topwin(enhan_name).info.frame3.frame2.frame0.label1 \
    -background "$GuiColor(label_bg)" \
    -borderwidth {0} \
    -relief {sunken} \
    -text {Upper limit:  }

  # build widget $topwin(enhan_name).info.frame3.frame2.frame0.value
  entry $topwin(enhan_name).info.frame3.frame2.frame0.value \
    -background "$GuiColor(entry_bg)" \
    -foreground "$GuiColor(entry_fg)" \
    -relief {sunken} \
    -textvariable {enhan(unsharp_ul)} \
    -width {4}
  endEntry  $topwin(enhan_name).info.frame3.frame2.frame0.value 0\
     $topwin(enhan_name).info.frame3.frame2.frame2.frame6.entry3 \
    $topwin(enhan_name).info.frame3.frame2.frame1.value 

  # build widget $topwin(enhan_name).info.frame3.frame2.frame0.menubutton2
	menubutton $topwin(enhan_name).info.frame3.frame2.frame0.menubutton2 -padx {1} -pady {1} -highlightthickness {0}  \
    -activebackground "$GuiColor(btn_act_bg)" \
    -background "$GuiColor(btn_bg)" \
	 -font "$GuiMisc(pop_up_fn)" \
	 -text "$GuiMisc(pop_up_text)" \
	 -relief "$GuiMisc(pop_up_relief)" \
	 -width {2}
  # bindings
  bind $topwin(enhan_name).info.frame3.frame2.frame0.menubutton2 <Button-1> {MenuPopupPost $topwin(enhan_name).info.frame3.frame2.frame0.menubutton2.menu %X %Y}
  bind $topwin(enhan_name).info.frame3.frame2.frame0.menubutton2 <ButtonRelease-1> {MenuPopupRelease $topwin(enhan_name).info.frame3.frame2.frame0.menubutton2.menu %W}

  # build widget $topwin(enhan_name).info.frame3.frame2.frame0.menubutton2.menu
  menu $topwin(enhan_name).info.frame3.frame2.frame0.menubutton2.menu \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" 
  $topwin(enhan_name).info.frame3.frame2.frame0.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set enhan(unsharp_ul) 100} \
    -label { 100 }
  $topwin(enhan_name).info.frame3.frame2.frame0.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set enhan(unsharp_ul) 120} \
    -label { 120 }
  $topwin(enhan_name).info.frame3.frame2.frame0.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set enhan(unsharp_ul) 150} \
    -label { 150 }
  $topwin(enhan_name).info.frame3.frame2.frame0.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set enhan(unsharp_ul) 170} \
    -label { 170 }
  $topwin(enhan_name).info.frame3.frame2.frame0.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set enhan(unsharp_ul) 200} \
    -label { 200 }
  $topwin(enhan_name).info.frame3.frame2.frame0.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set enhan(unsharp_ul) 220} \
    -label { 220 }
  $topwin(enhan_name).info.frame3.frame2.frame0.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set enhan(unsharp_ul) 240} \
    -label { 240 }
  $topwin(enhan_name).info.frame3.frame2.frame0.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set enhan(unsharp_ul) 255} \
    -label { 255}
  bindtags $topwin(enhan_name).info.frame3.frame2.frame0.menubutton2.menu  {Menu all}
  # bindings
  bind $topwin(enhan_name).info.frame3.frame2.frame0.menubutton2.menu <B1-Motion> {MenuPopupMotion $topwin(enhan_name).info.frame3.frame2.frame0.menubutton2.menu %W %X %Y}
  bind $topwin(enhan_name).info.frame3.frame2.frame0.menubutton2.menu <ButtonRelease-1> {MenuPopupRelease $topwin(enhan_name).info.frame3.frame2.frame0.menubutton2.menu %W}

  # pack widget $topwin(enhan_name).info.frame3.frame2.frame0
  pack append $topwin(enhan_name).info.frame3.frame2.frame0 \
    $topwin(enhan_name).info.frame3.frame2.frame0.label1 {left frame center fill} \
    $topwin(enhan_name).info.frame3.frame2.frame0.value {left frame center expand fill} \
    $topwin(enhan_name).info.frame3.frame2.frame0.menubutton2 {right frame center fill}

  # build widget $topwin(enhan_name).info.frame3.frame2.frame1
  frame $topwin(enhan_name).info.frame3.frame2.frame1 \
    -background "$GuiColor(frame_bg)" \
    -borderwidth {2}

  # build widget $topwin(enhan_name).info.frame3.frame2.frame1.label1
  label $topwin(enhan_name).info.frame3.frame2.frame1.label1 \
    -background "$GuiColor(label_bg)" \
    -borderwidth {0} \
    -relief {sunken} \
    -text {Lower limit: }

  # build widget $topwin(enhan_name).info.frame3.frame2.frame1.value
  entry $topwin(enhan_name).info.frame3.frame2.frame1.value \
    -background "$GuiColor(entry_bg)" \
    -foreground "$GuiColor(entry_fg)" \
    -relief {sunken} \
    -textvariable {enhan(unsharp_ll)} \
    -width {4}
  endEntry $topwin(enhan_name).info.frame3.frame2.frame1.value 0\
     $topwin(enhan_name).info.frame3.frame2.frame0.value \
     $topwin(enhan_name).info.frame3.frame2.frame2.frame5.entry3 

  # build widget $topwin(enhan_name).info.frame3.frame2.frame1.menubutton2
	menubutton $topwin(enhan_name).info.frame3.frame2.frame1.menubutton2 -padx {1} -pady {1} -highlightthickness {0}  \
    -activebackground "$GuiColor(btn_act_bg)" \
    -background "$GuiColor(btn_bg)" \
	 -font "$GuiMisc(pop_up_fn)" \
	 -text "$GuiMisc(pop_up_text)" \
	 -relief "$GuiMisc(pop_up_relief)" \
	 -width {2}
  # bindings
  bind $topwin(enhan_name).info.frame3.frame2.frame1.menubutton2 <Button-1> {MenuPopupPost $topwin(enhan_name).info.frame3.frame2.frame1.menubutton2.menu %X %Y}
  bind $topwin(enhan_name).info.frame3.frame2.frame1.menubutton2 <ButtonRelease-1> {MenuPopupRelease $topwin(enhan_name).info.frame3.frame2.frame1.menubutton2.menu %W}

  # build widget $topwin(enhan_name).info.frame3.frame2.frame1.menubutton2.menu
  menu $topwin(enhan_name).info.frame3.frame2.frame1.menubutton2.menu \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" 
  $topwin(enhan_name).info.frame3.frame2.frame1.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set enhan(unsharp_ll) 0} \
    -label {   0}
  $topwin(enhan_name).info.frame3.frame2.frame1.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set enhan(unsharp_ll) 10} \
    -label {  10}
  $topwin(enhan_name).info.frame3.frame2.frame1.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set enhan(unsharp_ll) 30} \
    -label {  30}
  $topwin(enhan_name).info.frame3.frame2.frame1.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set enhan(unsharp_ll) 50} \
    -label {  50}
  $topwin(enhan_name).info.frame3.frame2.frame1.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set enhan(unsharp_ll) 70} \
    -label {  70}
  $topwin(enhan_name).info.frame3.frame2.frame1.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set enhan(unsharp_ll) 80} \
    -label {  80}
  $topwin(enhan_name).info.frame3.frame2.frame1.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set enhan(unsharp_ll) 100} \
    -label { 100}
  bindtags $topwin(enhan_name).info.frame3.frame2.frame1.menubutton2.menu {Menu all}
  # bindings
  bind $topwin(enhan_name).info.frame3.frame2.frame1.menubutton2.menu <B1-Motion> {MenuPopupMotion $topwin(enhan_name).info.frame3.frame2.frame1.menubutton2.menu %W %X %Y}
  bind $topwin(enhan_name).info.frame3.frame2.frame1.menubutton2.menu <ButtonRelease-1> {MenuPopupRelease $topwin(enhan_name).info.frame3.frame2.frame1.menubutton2.menu %W}

  # pack widget $topwin(enhan_name).info.frame3.frame2.frame1
  pack append $topwin(enhan_name).info.frame3.frame2.frame1 \
    $topwin(enhan_name).info.frame3.frame2.frame1.label1 {left frame center fill} \
    $topwin(enhan_name).info.frame3.frame2.frame1.value {left frame center expand fill} \
    $topwin(enhan_name).info.frame3.frame2.frame1.menubutton2 {right frame center fill}

  # build widget $topwin(enhan_name).info.frame3.frame2.frame2
  frame $topwin(enhan_name).info.frame3.frame2.frame2 \
    -background "$GuiColor(frame_bg)" \
    -borderwidth {2}

  # build widget $topwin(enhan_name).info.frame3.frame2.frame2.frame5
  frame $topwin(enhan_name).info.frame3.frame2.frame2.frame5 \
    -background "$GuiColor(frame_bg)" \
    -borderwidth {2}

  # build widget $topwin(enhan_name).info.frame3.frame2.frame2.frame5.label2
  label $topwin(enhan_name).info.frame3.frame2.frame2.frame5.label2 \
    -background "$GuiColor(label_bg)" \
    -text {High clip percentage: }

  # build widget $topwin(enhan_name).info.frame3.frame2.frame2.frame5.entry3
  entry $topwin(enhan_name).info.frame3.frame2.frame2.frame5.entry3 \
    -background "$GuiColor(entry_bg)" \
    -foreground "$GuiColor(entry_fg)" \
    -relief {sunken} \
    -textvariable {enhan(unsharp_h_c)} \
    -width {5}
  endEntry  $topwin(enhan_name).info.frame3.frame2.frame2.frame5.entry3 0\
    $topwin(enhan_name).info.frame3.frame2.frame1.value \
  	  $topwin(enhan_name).info.frame3.frame2.frame2.frame6.entry3

  # build widget $topwin(enhan_name).info.frame3.frame2.frame2.frame5.menubutton4
	menubutton $topwin(enhan_name).info.frame3.frame2.frame2.frame5.menubutton4 -padx {1} -pady {1} -highlightthickness {0}  \
    -activebackground "$GuiColor(btn_act_bg)" \
    -background "$GuiColor(btn_bg)" \
	 -font "$GuiMisc(pop_up_fn)" \
	 -text "$GuiMisc(pop_up_text)" \
	 -relief "$GuiMisc(pop_up_relief)" \
	 -width {2}
  # bindings
  bind $topwin(enhan_name).info.frame3.frame2.frame2.frame5.menubutton4 <Button-1> {MenuPopupPost $topwin(enhan_name).info.frame3.frame2.frame2.frame5.menubutton4.menu %X %Y}
  bind $topwin(enhan_name).info.frame3.frame2.frame2.frame5.menubutton4 <ButtonRelease-1> {MenuPopupRelease $topwin(enhan_name).info.frame3.frame2.frame2.frame5.menubutton4.menu %W}

  # build widget $topwin(enhan_name).info.frame3.frame2.frame2.frame5.menubutton4.menu
  menu $topwin(enhan_name).info.frame3.frame2.frame2.frame5.menubutton4.menu \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" 
  $topwin(enhan_name).info.frame3.frame2.frame2.frame5.menubutton4.menu add command \
    -command {set enhan(unsharp_h_c) 0.01} \
    -label { 0.01 }
  $topwin(enhan_name).info.frame3.frame2.frame2.frame5.menubutton4.menu add command \
    -command {set enhan(unsharp_h_c) 0.02} \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -label { 0.02 }
  $topwin(enhan_name).info.frame3.frame2.frame2.frame5.menubutton4.menu add command \
    -command {set enhan(unsharp_h_c) 0.03} \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -label { 0.03 }
  $topwin(enhan_name).info.frame3.frame2.frame2.frame5.menubutton4.menu add command \
    -command {set enhan(unsharp_h_c) 0.04} \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -label { 0.04 }
  $topwin(enhan_name).info.frame3.frame2.frame2.frame5.menubutton4.menu add command \
    -command {set enhan(unsharp_h_c) 0.05} \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -label { 0.05 }
  $topwin(enhan_name).info.frame3.frame2.frame2.frame5.menubutton4.menu add command \
    -command {set enhan(unsharp_h_c) 0.075} \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -label { 0.075}
  $topwin(enhan_name).info.frame3.frame2.frame2.frame5.menubutton4.menu add command \
    -command {set enhan(unsharp_h_c) 0.10} \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -label { 0.10 }
  $topwin(enhan_name).info.frame3.frame2.frame2.frame5.menubutton4.menu add command \
    -command {set enhan(unsharp_h_c) 0.15} \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -label { 0.15 }
  bindtags $topwin(enhan_name).info.frame3.frame2.frame2.frame5.menubutton4.menu {Menu all}
  # bindings
  bind $topwin(enhan_name).info.frame3.frame2.frame2.frame5.menubutton4.menu <B1-Motion> {MenuPopupMotion $topwin(enhan_name).info.frame3.frame2.frame2.frame5.menubutton4.menu %W %X %Y}
  bind $topwin(enhan_name).info.frame3.frame2.frame2.frame5.menubutton4.menu <ButtonRelease-1> {MenuPopupRelease $topwin(enhan_name).info.frame3.frame2.frame2.frame5.menubutton4.menu %W}

  # pack widget $topwin(enhan_name).info.frame3.frame2.frame2.frame5
  pack append $topwin(enhan_name).info.frame3.frame2.frame2.frame5 \
    $topwin(enhan_name).info.frame3.frame2.frame2.frame5.label2 {left frame center} \
    $topwin(enhan_name).info.frame3.frame2.frame2.frame5.entry3 {left frame center} \
    $topwin(enhan_name).info.frame3.frame2.frame2.frame5.menubutton4 {right frame center filly}

  # build widget $topwin(enhan_name).info.frame3.frame2.frame2.frame6
  frame $topwin(enhan_name).info.frame3.frame2.frame2.frame6 \
    -background "$GuiColor(frame_bg)" \
    -borderwidth {2}

  # build widget $topwin(enhan_name).info.frame3.frame2.frame2.frame6.label2
  label $topwin(enhan_name).info.frame3.frame2.frame2.frame6.label2 \
    -background "$GuiColor(label_bg)" \
    -text {Low clip percentage: }

  # build widget $topwin(enhan_name).info.frame3.frame2.frame2.frame6.entry3
  entry $topwin(enhan_name).info.frame3.frame2.frame2.frame6.entry3 \
    -background "$GuiColor(entry_bg)" \
    -foreground "$GuiColor(entry_fg)" \
    -relief {sunken} \
    -textvariable {enhan(unsharp_l_c)} \
    -width {5}
  endEntry  $topwin(enhan_name).info.frame3.frame2.frame2.frame6.entry3 0\
     $topwin(enhan_name).info.frame3.frame2.frame2.frame5.entry3 \
     $topwin(enhan_name).info.frame3.frame2.frame0.value 

  # build widget $topwin(enhan_name).info.frame3.frame2.frame2.frame6.menubutton4
	menubutton $topwin(enhan_name).info.frame3.frame2.frame2.frame6.menubutton4 -padx {1} -pady {1} -highlightthickness {0}  \
    -activebackground "$GuiColor(btn_act_bg)" \
    -background "$GuiColor(btn_bg)" \
	 -font "$GuiMisc(pop_up_fn)" \
	 -text "$GuiMisc(pop_up_text)" \
	 -relief "$GuiMisc(pop_up_relief)" \
	 -width {2}
  # bindings
  bind $topwin(enhan_name).info.frame3.frame2.frame2.frame6.menubutton4 <Button-1> {MenuPopupPost $topwin(enhan_name).info.frame3.frame2.frame2.frame6.menubutton4.menu %X %Y}
  bind $topwin(enhan_name).info.frame3.frame2.frame2.frame6.menubutton4 <ButtonRelease-1> {MenuPopupRelease $topwin(enhan_name).info.frame3.frame2.frame2.frame6.menubutton4.menu %W}

  # build widget $topwin(enhan_name).info.frame3.frame2.frame2.frame6.menubutton4.menu
  menu $topwin(enhan_name).info.frame3.frame2.frame2.frame6.menubutton4.menu \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" 
  $topwin(enhan_name).info.frame3.frame2.frame2.frame6.menubutton4.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set enhan(unsharp_l_c) 0.01} \
    -label { 0.01 }
  $topwin(enhan_name).info.frame3.frame2.frame2.frame6.menubutton4.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set enhan(unsharp_l_c) 0.02} \
    -label { 0.02 }
  $topwin(enhan_name).info.frame3.frame2.frame2.frame6.menubutton4.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set enhan(unsharp_l_c) 0.03} \
    -label { 0.03 }
  $topwin(enhan_name).info.frame3.frame2.frame2.frame6.menubutton4.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set enhan(unsharp_l_c) 0.04} \
    -label { 0.04 }
  $topwin(enhan_name).info.frame3.frame2.frame2.frame6.menubutton4.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set enhan(unsharp_l_c) 0.05} \
    -label { 0.05 }
  $topwin(enhan_name).info.frame3.frame2.frame2.frame6.menubutton4.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set enhan(unsharp_l_c) 0.075} \
    -label { 0.075}
  $topwin(enhan_name).info.frame3.frame2.frame2.frame6.menubutton4.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set enhan(unsharp_l_c) 0.10} \
    -label { 0.10 }
  $topwin(enhan_name).info.frame3.frame2.frame2.frame6.menubutton4.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set enhan(unsharp_l_c) 0.15} \
    -label { 0.15 }
  bindtags $topwin(enhan_name).info.frame3.frame2.frame2.frame6.menubutton4.menu  {Menu all}
  # bindings
  bind $topwin(enhan_name).info.frame3.frame2.frame2.frame6.menubutton4.menu <B1-Motion> {MenuPopupMotion $topwin(enhan_name).info.frame3.frame2.frame2.frame6.menubutton4.menu %W %X %Y}
  bind $topwin(enhan_name).info.frame3.frame2.frame2.frame6.menubutton4.menu <ButtonRelease-1> {MenuPopupRelease $topwin(enhan_name).info.frame3.frame2.frame2.frame6.menubutton4.menu %W}

  # pack widget $topwin(enhan_name).info.frame3.frame2.frame2.frame6
  pack append $topwin(enhan_name).info.frame3.frame2.frame2.frame6 \
    $topwin(enhan_name).info.frame3.frame2.frame2.frame6.label2 {left frame center} \
    $topwin(enhan_name).info.frame3.frame2.frame2.frame6.entry3 {left frame center} \
    $topwin(enhan_name).info.frame3.frame2.frame2.frame6.menubutton4 {right frame center filly}

  # pack widget $topwin(enhan_name).info.frame3.frame2.frame2
  pack append $topwin(enhan_name).info.frame3.frame2.frame2 \
    $topwin(enhan_name).info.frame3.frame2.frame2.frame5 {right frame center expand} \
    $topwin(enhan_name).info.frame3.frame2.frame2.frame6 {left frame center expand}

  # pack widget $topwin(enhan_name).info.frame3.frame2
  pack append $topwin(enhan_name).info.frame3.frame2 \
    $topwin(enhan_name).info.frame3.frame2.frame3 {left frame center} \
    $topwin(enhan_name).info.frame3.frame2.frame2 {bottom frame center } \
    $topwin(enhan_name).info.frame3.frame2.frame1 {left frame center padx 30} \
    $topwin(enhan_name).info.frame3.frame2.frame0 {right frame center padx 30}

  # build widget $topwin(enhan_name).info.frame3.frame1
  frame $topwin(enhan_name).info.frame3.frame1 \
    -background "$GuiColor(frame_bg)" \
    -borderwidth {2} \
    -relief {flat}

  # build widget $topwin(enhan_name).info.frame3.frame1.label5
  label $topwin(enhan_name).info.frame3.frame1.label5 \
    -background "$GuiColor(label_bg)" \
    -text {Spatial domain sharpening}

  # pack widget $topwin(enhan_name).info.frame3.frame1
  pack append $topwin(enhan_name).info.frame3.frame1 \
	 $topwin(enhan_name).info.frame3.frame1.label5 {left frame center }

  # pack widget $topwin(enhan_name).info.frame3
  pack append $topwin(enhan_name).info.frame3 \
    $topwin(enhan_name).info.frame3.frame1 {top frame center fillx} \
    $topwin(enhan_name).info.frame3.frame0 {top frame center expand fill} \
    $topwin(enhan_name).info.frame3.frame2 {top frame center expand fill}

  # build widget $topwin(enhan_name).info.frame9
  frame $topwin(enhan_name).info.frame9 \
    -background "$GuiColor(frame_bg)" \
    -borderwidth {3} \
    -relief {ridge}

  # build widget $topwin(enhan_name).info.frame9.label5
  label $topwin(enhan_name).info.frame9.label5 \
    -background "$GuiColor(label_bg)" \
    -text {Frequency domain sharpening}

  # build widget $topwin(enhan_name).info.frame9.frame6
  frame $topwin(enhan_name).info.frame9.frame6 \
    -background "$GuiColor(frame_bg)" \
    -borderwidth {2} \
    -relief {ridge}

  # build widget $topwin(enhan_name).info.frame9.frame6.frame3
  frame $topwin(enhan_name).info.frame9.frame6.frame3 \
    -background "$GuiColor(frame_bg)" \
    -borderwidth {2}

  # build widget $topwin(enhan_name).info.frame9.frame6.frame3.radiobutton7
	radiobutton $topwin(enhan_name).info.frame9.frame6.frame3.radiobutton7 -padx {1} -pady {1} -highlightthickness {0}  \
    -activebackground "$GuiColor(btn_act_bg)" \
    -background "$GuiColor(btn_bg)" \
    -command {
		if [catch {expr $rows + $cols} ] {
			set enhan(sh_cutoff) ""
		} else {
			set temp [expr { $rows < $cols} ? $cols : $rows ]
			set enhan(block) [expr int(pow(2, ceil(log($temp) / log(2.0))))]
			set enhan(sh_FFT_cutoff) [expr $enhan(block)/4]
			set enhan(sh_cutoff) [expr $enhan(block)/4]
		}
	  } \
    -relief {flat} \
    -text {FFT sharpening} \
    -value {fft} \
    -variable {enhan(sharp)}

  # pack widget $topwin(enhan_name).info.frame9.frame6.frame3
  pack append $topwin(enhan_name).info.frame9.frame6.frame3 \
    $topwin(enhan_name).info.frame9.frame6.frame3.radiobutton7 {top frame w}

  # build widget $topwin(enhan_name).info.frame9.frame6.frame6
  frame $topwin(enhan_name).info.frame9.frame6.frame6 \
    -background "$GuiColor(frame_bg)" \
    -borderwidth {2}

  # build widget $topwin(enhan_name).info.frame9.frame6.frame6.label7
  label $topwin(enhan_name).info.frame9.frame6.frame6.label7 \
    -background "$GuiColor(label_bg)" \
    -text {Cutoff frequency: }

  # build widget $topwin(enhan_name).info.frame9.frame6.frame6.entry8
  entry $topwin(enhan_name).info.frame9.frame6.frame6.entry8 \
    -background "$GuiColor(entry_bg)" \
    -foreground "$GuiColor(entry_fg)" \
    -relief {sunken} \
    -textvariable {enhan(sh_cutoff)} \
    -width {5}
  endEntry  $topwin(enhan_name).info.frame9.frame6.frame6.entry8 0\
     $topwin(enhan_name).info.frame9.frame6.frame2.frame0.value \
     $topwin(enhan_name).info.frame9.frame6.frame2.frame0.value 

  # build widget $topwin(enhan_name).info.frame9.frame6.frame6.menubutton4
	menubutton $topwin(enhan_name).info.frame9.frame6.frame6.menubutton4 -padx {1} -pady {1} -highlightthickness {0}  \
    -activebackground "$GuiColor(btn_act_bg)" \
    -background "$GuiColor(btn_bg)" \
	 -font "$GuiMisc(pop_up_fn)" \
	 -text "$GuiMisc(pop_up_text)" \
	 -relief "$GuiMisc(pop_up_relief)" \
	 -width {2}
  # bindings
  bind $topwin(enhan_name).info.frame9.frame6.frame6.menubutton4 <Button-1> {MenuPopupPost $topwin(enhan_name).info.frame9.frame6.frame6.menubutton4.menu %X %Y}
  bind $topwin(enhan_name).info.frame9.frame6.frame6.menubutton4 <ButtonRelease-1> {MenuPopupRelease $topwin(enhan_name).info.frame9.frame6.frame6.menubutton4.menu %W}

  # build widget $topwin(enhan_name).info.frame9.frame6.frame6.menubutton4.menu
  menu $topwin(enhan_name).info.frame9.frame6.frame6.menubutton4.menu \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" 
#  $topwin(enhan_name).info.frame9.frame6.frame6.menubutton4.menu add command \
#    -command {set enhan(sh_cutoff) 16} \
#    -label { 16 }
#  $topwin(enhan_name).info.frame9.frame6.frame6.menubutton4.menu add command \
#    -command {set enhan(sh_cutoff) 16} \
#    -label { 16 }
#  $topwin(enhan_name).info.frame9.frame6.frame6.menubutton4.menu add command \
#    -command {set enhan(sh_cutoff) 16} \
#    -label {  16 }
#  $topwin(enhan_name).info.frame9.frame6.frame6.menubutton4.menu add command \
#    -command {set enhan(sh_cutoff) 32} \
#    -label {  32 }
#  $topwin(enhan_name).info.frame9.frame6.frame6.menubutton4.menu add command \
#    -command {set enhan(sh_cutoff) 16} \
#    -label {  16  }
#  $topwin(enhan_name).info.frame9.frame6.frame6.menubutton4.menu add command \
#    -command {set enhan(sh_cutoff) 8} \
#    -label {   8}
#  $topwin(enhan_name).info.frame9.frame6.frame6.menubutton4.menu add command \
#    -command {set enhan(sh_cutoff) 4} \
#    -label {   4 }
#  bindtags $topwin(enhan_name).info.frame9.frame6.frame6.menubutton4.menu {Menu #all}
#  # bindings
#  bind $topwin(enhan_name).info.frame9.frame6.frame6.menubutton4.menu #<B1-Motion> {MenuPopupMotion #$topwin(enhan_name).info.frame9.frame6.frame6.menubutton4.menu %W %X %Y}
#  bind $topwin(enhan_name).info.frame9.frame6.frame6.menubutton4.menu #<ButtonRelease-1> {MenuPopupRelease #$topwin(enhan_name).info.frame9.frame6.frame6.menubutton4.menu %W}

  # pack widget $topwin(enhan_name).info.frame9.frame6.frame6
  pack append $topwin(enhan_name).info.frame9.frame6.frame6 \
    $topwin(enhan_name).info.frame9.frame6.frame6.label7 {left frame center} \
    $topwin(enhan_name).info.frame9.frame6.frame6.entry8 {left frame center}
#    $topwin(enhan_name).info.frame9.frame6.frame6.menubutton4 {right frame center filly}

  # build widget $topwin(enhan_name).info.frame9.frame6.frame2
  frame $topwin(enhan_name).info.frame9.frame6.frame2 \
    -background "$GuiColor(frame_bg)" \
    -borderwidth {2}

  # build widget $topwin(enhan_name).info.frame9.frame6.frame2.frame0
  frame $topwin(enhan_name).info.frame9.frame6.frame2.frame0 \
    -background "$GuiColor(frame_bg)" \
    -borderwidth {2}

  # build widget $topwin(enhan_name).info.frame9.frame6.frame2.frame0.label1
  label $topwin(enhan_name).info.frame9.frame6.frame2.frame0.label1 \
    -background "$GuiColor(label_bg)" \
    -borderwidth {0} \
    -relief {sunken} \
    -text {with Butterworth order: }

  # build widget $topwin(enhan_name).info.frame9.frame6.frame2.frame0.value
  entry $topwin(enhan_name).info.frame9.frame6.frame2.frame0.value \
    -background "$GuiColor(entry_bg)" \
    -foreground "$GuiColor(entry_fg)" \
    -relief {sunken} \
    -textvariable {enhan(order)} \
    -width {4}
  endEntry  $topwin(enhan_name).info.frame9.frame6.frame2.frame0.value 0\
     $topwin(enhan_name).info.frame9.frame6.frame6.entry8 \
     $topwin(enhan_name).info.frame9.frame6.frame6.entry8 

  # build widget $topwin(enhan_name).info.frame9.frame6.frame2.frame0.menubutton2
  menubutton $topwin(enhan_name).info.frame9.frame6.frame2.frame0.menubutton2 \
    -activebackground "$GuiColor(btn_act_bg)" \
    -background "$GuiColor(btn_bg)" \
    -font "$GuiMisc(pop_up_fn)" \
    -relief "$GuiMisc(pop_up_relief)" \
    -padx {1} -pady {1} -highlightthickness {0} \
    -text "$GuiMisc(pop_up_text)" -width {2}



  # bindings
  bind $topwin(enhan_name).info.frame9.frame6.frame2.frame0.menubutton2 <Button-1> {MenuPopupPost $topwin(enhan_name).info.frame9.frame6.frame2.frame0.menubutton2.menu %X %Y}
  bind $topwin(enhan_name).info.frame9.frame6.frame2.frame0.menubutton2 <ButtonRelease-1> {MenuPopupRelease $topwin(enhan_name).info.frame9.frame6.frame2.frame0.menubutton2.menu %W}

  # build widget $topwin(enhan_name).info.frame9.frame6.frame2.frame0.menubutton2.menu
  menu $topwin(enhan_name).info.frame9.frame6.frame2.frame0.menubutton2.menu \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" 
  $topwin(enhan_name).info.frame9.frame6.frame2.frame0.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set enhan(order) 1} \
    -label { 1 }
  $topwin(enhan_name).info.frame9.frame6.frame2.frame0.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set enhan(order) 2} \
    -label { 2 }
  $topwin(enhan_name).info.frame9.frame6.frame2.frame0.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set enhan(order) 3} \
    -label { 3 }
  $topwin(enhan_name).info.frame9.frame6.frame2.frame0.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set enhan(order) 4} \
    -label { 4 }
  $topwin(enhan_name).info.frame9.frame6.frame2.frame0.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set enhan(order) 5} \
    -label { 5 }
  $topwin(enhan_name).info.frame9.frame6.frame2.frame0.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set enhan(order) 6} \
    -label { 6 }
  $topwin(enhan_name).info.frame9.frame6.frame2.frame0.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set enhan(order) 7} \
    -label { 7 }
  $topwin(enhan_name).info.frame9.frame6.frame2.frame0.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set enhan(order) 8} \
    -label { 8}
  bindtags $topwin(enhan_name).info.frame9.frame6.frame2.frame0.menubutton2.menu  {Menu all}
  # bindings
  bind $topwin(enhan_name).info.frame9.frame6.frame2.frame0.menubutton2.menu <B1-Motion> {MenuPopupMotion $to
pwin(enhan_name).info.frame3.frame2.frame0.menubutton2.menu %W %X %Y}
  bind $topwin(enhan_name).info.frame9.frame6.frame2.frame0.menubutton2.menu <ButtonRelease-1> {MenuPopupRele
ase $topwin(enhan_name).info.frame9.frame6.frame2.frame0.menubutton2.menu %W}

  # pack widget $topwin(enhan_name).info.frame9.frame6.frame2.frame0
  pack append $topwin(enhan_name).info.frame9.frame6.frame2.frame0 \
    $topwin(enhan_name).info.frame9.frame6.frame2.frame0.label1 {left frame center fill} \
    $topwin(enhan_name).info.frame9.frame6.frame2.frame0.value {left frame center expand fill} \
    $topwin(enhan_name).info.frame9.frame6.frame2.frame0.menubutton2 {right frame center fill}

  # build widget $topwin(enhan_name).info.frame9.frame6.frame2.label4
  label $topwin(enhan_name).info.frame9.frame6.frame2.label4 \
    -background "$GuiColor(label_bg)" \
    -text {block size}

  # build widget $topwin(enhan_name).info.frame9.frame6.frame2.label5
  label $topwin(enhan_name).info.frame9.frame6.frame2.label5 \
    -background "$GuiColor(label_bg)" \
    -text {} \
    -textvariable {enhan(block)}

  # pack widget $topwin(enhan_name).info.frame9.frame6.frame2
  pack append $topwin(enhan_name).info.frame9.frame6.frame2 \
    $topwin(enhan_name).info.frame9.frame6.frame2.frame0 {top frame w} \
    $topwin(enhan_name).info.frame9.frame6.frame2.label4 {left frame w} \
    $topwin(enhan_name).info.frame9.frame6.frame2.label5 {left frame w}

  # pack widget $topwin(enhan_name).info.frame9.frame6
  pack append $topwin(enhan_name).info.frame9.frame6 \
    $topwin(enhan_name).info.frame9.frame6.frame3 {left frame center} \
    $topwin(enhan_name).info.frame9.frame6.frame6 {left frame center} \
    $topwin(enhan_name).info.frame9.frame6.frame2 {left frame center expand fill}

  # build widget $topwin(enhan_name).info.frame9.frame10
  frame $topwin(enhan_name).info.frame9.frame10 \
    -background "$GuiColor(frame_bg)" \
    -borderwidth {2} \
    -relief {ridge}

  # build widget $topwin(enhan_name).info.frame9.frame10.frame3
  frame $topwin(enhan_name).info.frame9.frame10.frame3 \
    -background "$GuiColor(frame_bg)" \
    -borderwidth {2}

  # build widget $topwin(enhan_name).info.frame9.frame10.frame3.radiobutton7
	radiobutton $topwin(enhan_name).info.frame9.frame10.frame3.radiobutton7 -padx {1} -pady {1} -highlightthickness {0}  \
    -activebackground "$GuiColor(btn_act_bg)" \
    -background "$GuiColor(btn_bg)" \
    -relief {flat} \
	 -command {
		if [catch {expr $rows + $cols} ] {
			set enhan(sh_cutoff) ""
		} else {
			set temp [expr { $rows < $cols} ? $cols : $rows ]
			set enhan(block) [expr int(pow(2, ceil(log($temp) / log(2.0))))]
			set enhan(sh_DCT_cutoff) [expr $enhan(block)/2]
			set enhan(sh_cutoff) [expr $enhan(block)/2]
		}
	 } \
    -text {DCT sharpening} \
    -value {dct} \
    -variable {enhan(sharp)}

  # pack widget $topwin(enhan_name).info.frame9.frame10.frame3
  pack append $topwin(enhan_name).info.frame9.frame10.frame3 \
    $topwin(enhan_name).info.frame9.frame10.frame3.radiobutton7 {top frame w}

  # build widget $topwin(enhan_name).info.frame9.frame10.frame6
  frame $topwin(enhan_name).info.frame9.frame10.frame6 \
    -background "$GuiColor(frame_bg)" \
    -borderwidth {2}

  # build widget $topwin(enhan_name).info.frame9.frame10.frame6.label7
  label $topwin(enhan_name).info.frame9.frame10.frame6.label7 \
    -background "$GuiColor(label_bg)" \
    -text {Cutoff frequency: }

  # build widget $topwin(enhan_name).info.frame9.frame10.frame6.entry8
  entry $topwin(enhan_name).info.frame9.frame10.frame6.entry8 \
    -background "$GuiColor(entry_bg)" \
    -foreground "$GuiColor(entry_fg)" \
    -relief {sunken} \
    -textvariable {enhan(sh_cutoff)} \
    -width {5}
  endEntry  $topwin(enhan_name).info.frame9.frame10.frame6.entry8 0\
     $topwin(enhan_name).info.frame9.frame10.frame2.frame55.value \
     $topwin(enhan_name).info.frame9.frame10.frame2.frame55.value 

  # build widget $topwin(enhan_name).info.frame9.frame10.frame6.menubutton4
	menubutton $topwin(enhan_name).info.frame9.frame10.frame6.menubutton4 -padx {1} -pady {1} -highlightthickness {0}  \
    -activebackground "$GuiColor(btn_act_bg)" \
    -background "$GuiColor(btn_bg)" \
	 -font "$GuiMisc(pop_up_fn)" \
	 -text "$GuiMisc(pop_up_text)" \
	 -relief "$GuiMisc(pop_up_relief)" \
	 -width {2}
  # bindings
  bind $topwin(enhan_name).info.frame9.frame10.frame6.menubutton4 <Button-1> {MenuPopupPost $topwin(enhan_name).info.frame9.frame10.frame6.menubutton4.menu %X %Y}
  bind $topwin(enhan_name).info.frame9.frame10.frame6.menubutton4 <ButtonRelease-1> {MenuPopupRelease $topwin(enhan_name).info.frame9.frame10.frame6.menubutton4.menu %W}

  # build widget $topwin(enhan_name).info.frame9.frame10.frame6.menubutton4.menu
#  menu $topwin(enhan_name).info.frame9.frame10.frame6.menubutton4.menu \
#    -activebackground "$GuiColor(menu_act_bg)" \
#	 -background "$GuiColor(menu_bg)" 
#  $topwin(enhan_name).info.frame9.frame10.frame6.menubutton4.menu add command \
#    -command {set enhan(sh_cutoff) 16} \
#    -label { 16 }
#  $topwin(enhan_name).info.frame9.frame10.frame6.menubutton4.menu add command \
#    -command {set enhan(sh_cutoff) 16} \
#    -label { 16 }
#  $topwin(enhan_name).info.frame9.frame10.frame6.menubutton4.menu add command \
#    -command {set enhan(sh_cutoff) 16} \
#    -label {  16 }
#  $topwin(enhan_name).info.frame9.frame10.frame6.menubutton4.menu add command \
#    -command {set enhan(sh_cutoff) 16} \
#    -label {  16 }
#  $topwin(enhan_name).info.frame9.frame10.frame6.menubutton4.menu add command \
#    -command {set enhan(sh_cutoff) 16} \
#    -label {  16 }
#  $topwin(enhan_name).info.frame9.frame10.frame6.menubutton4.menu add command \
#    -command {set enhan(sh_cutoff) 8} \
#    -label {   8}
#  $topwin(enhan_name).info.frame9.frame10.frame6.menubutton4.menu add command \
#    -command {set enhan(sh_cutoff) 4} \
#    -label {   4 }
#  bindtags $topwin(enhan_name).info.frame9.frame10.frame6.menubutton4.menu #{Menu all}
#  # bindings
#  bind $topwin(enhan_name).info.frame9.frame10.frame6.menubutton4.menu #<B1-Motion> {MenuPopupMotion #$topwin(enhan_name).info.frame9.frame10.frame6.menubutton4.menu %W %X %Y}
#  bind $topwin(enhan_name).info.frame9.frame10.frame6.menubutton4.menu #<ButtonRelease-1> {MenuPopupRelease #$topwin(enhan_name).info.frame9.frame10.frame6.menubutton4.menu %W}

  # pack widget $topwin(enhan_name).info.frame9.frame10.frame6
  pack append $topwin(enhan_name).info.frame9.frame10.frame6 \
    $topwin(enhan_name).info.frame9.frame10.frame6.label7 {left frame center} \
    $topwin(enhan_name).info.frame9.frame10.frame6.entry8 {left frame center}
#    $topwin(enhan_name).info.frame9.frame10.frame6.menubutton4 {right frame #center filly}

  # build widget $topwin(enhan_name).info.frame9.frame10.frame2
  frame $topwin(enhan_name).info.frame9.frame10.frame2 \
    -background "$GuiColor(frame_bg)" \
    -borderwidth {2}

  # build widget $topwin(enhan_name).info.frame9.frame10.frame2.frame55
  frame $topwin(enhan_name).info.frame9.frame10.frame2.frame55 \
    -background "$GuiColor(frame_bg)" \
    -borderwidth {2}


  # build widget $topwin(enhan_name).info.frame9.frame10.frame2.frame55.label1
  label $topwin(enhan_name).info.frame9.frame10.frame2.frame55.label1 \
    -background "$GuiColor(label_bg)" \
    -borderwidth {0} \
    -relief {sunken} \
    -text {with Butterworth order:  }

  # build widget $topwin(enhan_name).info.frame9.frame10.frame2.frame55.value
  entry $topwin(enhan_name).info.frame9.frame10.frame2.frame55.value \
    -background "$GuiColor(entry_bg)" \
    -foreground "$GuiColor(entry_fg)" \
    -relief {sunken} \
    -textvariable {enhan(order)} \
    -width {4}
  endEntry  $topwin(enhan_name).info.frame9.frame10.frame2.frame55.value 0\
     $topwin(enhan_name).info.frame9.frame10.frame6.entry8 \
     $topwin(enhan_name).info.frame9.frame10.frame6.entry8 

  # build widget $topwin(enhan_name).info.frame9.frame10.frame2.frame55.menubutton2
  menubutton $topwin(enhan_name).info.frame9.frame10.frame2.frame55.menubutton2 \
         -activebackground "$GuiColor(btn_act_bg)" -background "$GuiColor(btn_bg)"  \
    -font "$GuiMisc(pop_up_fn)" \
    -relief "$GuiMisc(pop_up_relief)" \
    -padx {1} -pady {1} -highlightthickness {0} \
    -text "$GuiMisc(pop_up_text)" -width {2}


  # bindings
  bind $topwin(enhan_name).info.frame9.frame10.frame2.frame55.menubutton2 <Button-1> {MenuPopupPost $topwin(enhan_name).info.frame9.frame10.frame2.frame55.menubutton2.menu %X %Y}
  bind $topwin(enhan_name).info.frame9.frame10.frame2.frame55.menubutton2 <ButtonRelease-1> {MenuPopupRelease $topwin(enhan_name).info.frame9.frame10.frame2.frame55.menubutton2.menu %W}

  # build widget $topwin(enhan_name).info.frame9.frame10.frame2.frame55.menubutton2.menu
  menu $topwin(enhan_name).info.frame9.frame10.frame2.frame55.menubutton2.menu \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" 
  $topwin(enhan_name).info.frame9.frame10.frame2.frame55.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set enhan(order) 1} \
    -label { 1 }
  $topwin(enhan_name).info.frame9.frame10.frame2.frame55.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set enhan(order) 2} \
    -label { 2 }
  $topwin(enhan_name).info.frame9.frame10.frame2.frame55.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set enhan(order) 3} \
    -label { 3 }
  $topwin(enhan_name).info.frame9.frame10.frame2.frame55.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set enhan(order) 4} \
    -label { 4 }
  $topwin(enhan_name).info.frame9.frame10.frame2.frame55.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set enhan(order) 5} \
    -label { 5 }
  $topwin(enhan_name).info.frame9.frame10.frame2.frame55.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set enhan(order) 6} \
    -label { 6 }
  $topwin(enhan_name).info.frame9.frame10.frame2.frame55.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set enhan(order) 7} \
    -label { 7 }
  $topwin(enhan_name).info.frame9.frame10.frame2.frame55.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set enhan(order) 8} \
    -label { 8}
  bindtags $topwin(enhan_name).info.frame9.frame10.frame2.frame55.menubutton2.menu  {Menu all}
  # bindings
  bind $topwin(enhan_name).info.frame9.frame10.frame2.frame55.menubutton2.menu <B1-Motion> {MenuPopupMotion $to
pwin(enhan_name).info.frame3.frame2.frame0.menubutton2.menu %W %X %Y}
  bind $topwin(enhan_name).info.frame9.frame10.frame2.frame55.menubutton2.menu <ButtonRelease-1> {MenuPopupRele
ase $topwin(enhan_name).info.frame9.frame10.frame2.frame55.menubutton2.menu %W}

  # pack widget $topwin(enhan_name).info.frame9.frame10.frame2.frame55
  pack append $topwin(enhan_name).info.frame9.frame10.frame2.frame55 \
    $topwin(enhan_name).info.frame9.frame10.frame2.frame55.label1 {left frame center fill} \
    $topwin(enhan_name).info.frame9.frame10.frame2.frame55.value {left frame center expand fill} \
    $topwin(enhan_name).info.frame9.frame10.frame2.frame55.menubutton2 {right frame center fill}

  # build widget $topwin(enhan_name).info.frame9.frame10.frame2.label4
  label $topwin(enhan_name).info.frame9.frame10.frame2.label4 \
    -background "$GuiColor(label_bg)" \
    -text {block size}

  # build widget $topwin(enhan_name).info.frame9.frame10.frame2.label5
  label $topwin(enhan_name).info.frame9.frame10.frame2.label5 \
    -background "$GuiColor(label_bg)" \
    -text {} \
    -textvariable {enhan(block)}

  # pack widget $topwin(enhan_name).info.frame9.frame10.frame2
  pack append $topwin(enhan_name).info.frame9.frame10.frame2 \
    $topwin(enhan_name).info.frame9.frame10.frame2.frame55 {top frame w} \
    $topwin(enhan_name).info.frame9.frame10.frame2.label4 {left frame w} \
    $topwin(enhan_name).info.frame9.frame10.frame2.label5 {left frame w}

  # pack widget $topwin(enhan_name).info.frame9.frame10
  pack append $topwin(enhan_name).info.frame9.frame10 \
    $topwin(enhan_name).info.frame9.frame10.frame3 {left frame center} \
    $topwin(enhan_name).info.frame9.frame10.frame6 {left frame center} \
    $topwin(enhan_name).info.frame9.frame10.frame2 {left frame center expand fill}

  # build widget $topwin(enhan_name).info.frame9.frame5
  frame $topwin(enhan_name).info.frame9.frame5 \
    -background "$GuiColor(frame_bg)" \
    -borderwidth {2} \
    -relief {ridge}

  # build widget $topwin(enhan_name).info.frame9.frame5.frame0
  frame $topwin(enhan_name).info.frame9.frame5.frame0 \
    -background "$GuiColor(frame_bg)" \
    -relief {ridge}

  # build widget $topwin(enhan_name).info.frame9.frame5.frame0.radiobutton18
	radiobutton $topwin(enhan_name).info.frame9.frame5.frame0.radiobutton18 -padx {1} -pady {1} -highlightthickness {0}  \
    -activebackground "$GuiColor(btn_act_bg)" \
    -background "$GuiColor(btn_bg)" \
    -command { set enhan(filter_lcf) [expr $enhan(block)/4] } \
    -relief {flat} \
    -text {High frequency emphasize} \
    -value {hfe_filter} \
    -variable {enhan(sharp)} \
    -width {22}

  # build widget $topwin(enhan_name).info.frame9.frame5.frame0.frame1
  frame $topwin(enhan_name).info.frame9.frame5.frame0.frame1 \
    -background "$GuiColor(frame_bg)" \
    -borderwidth {2}

  # build widget $topwin(enhan_name).info.frame9.frame5.frame0.frame1.label1
  label $topwin(enhan_name).info.frame9.frame5.frame0.frame1.label1 \
    -background "$GuiColor(label_bg)" \
    -borderwidth {0} \
    -relief {sunken} \
    -text {Transform: }

  # build widget $topwin(enhan_name).info.frame9.frame5.frame0.frame1.value
  entry $topwin(enhan_name).info.frame9.frame5.frame0.frame1.value \
    -background "$GuiColor(rentry_bg)" \
    -foreground "$GuiColor(rentry_fg)" \
    -relief {sunken} \
	 -state {disabled} \
    -textvariable {enhan(transform)} \
    -width {8}

  # build widget $topwin(enhan_name).info.frame9.frame5.frame0.frame1.menubutton2
	menubutton $topwin(enhan_name).info.frame9.frame5.frame0.frame1.menubutton2 -padx {1} -pady {1} -highlightthickness {0}  \
    -activebackground "$GuiColor(btn_act_bg)" \
    -background "$GuiColor(btn_bg)" \
	 -font "$GuiMisc(pop_up_fn)" \
	 -text "$GuiMisc(pop_up_text)" \
	 -relief "$GuiMisc(pop_up_relief)" \
	 -width {2}
  # bindings
  bind $topwin(enhan_name).info.frame9.frame5.frame0.frame1.menubutton2 <Button-1> {MenuPopupPost $topwin(enhan_name).info.frame9.frame5.frame0.frame1.menubutton2.menu %X %Y}
  bind $topwin(enhan_name).info.frame9.frame5.frame0.frame1.menubutton2 <ButtonRelease-1> {MenuPopupRelease $topwin(enhan_name).info.frame9.frame5.frame0.frame1.menubutton2.menu %W}

  # build widget $topwin(enhan_name).info.frame9.frame5.frame0.frame1.menubutton2.menu
  menu $topwin(enhan_name).info.frame9.frame5.frame0.frame1.menubutton2.menu \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" 
  $topwin(enhan_name).info.frame9.frame5.frame0.frame1.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set enhan(transform) fft} \
    -label {fft }
  $topwin(enhan_name).info.frame9.frame5.frame0.frame1.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set enhan(transform) dct} \
    -label {dct }
  $topwin(enhan_name).info.frame9.frame5.frame0.frame1.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
  -command {set enhan(transform) haar} \
    -label {haar }
  $topwin(enhan_name).info.frame9.frame5.frame0.frame1.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
  -command {set enhan(transform) walsh} \
    -label {walsh }
  $topwin(enhan_name).info.frame9.frame5.frame0.frame1.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
  -command {set enhan(transform) hadamard} \
    -label {hadamard}
  bindtags $topwin(enhan_name).info.frame9.frame5.frame0.frame1.menubutton2.menu {Menu all}

  # bindings
  bind $topwin(enhan_name).info.frame9.frame5.frame0.frame1.menubutton2.menu <B1-Motion> {MenuPopupMotion $topwin(enhan_name).info.frame9.frame5.frame0.frame1.menubutton2.menu %W %X %Y}
  bind $topwin(enhan_name).info.frame9.frame5.frame0.frame1.menubutton2.menu <ButtonRelease-1> {MenuPopupRelease $topwin(enhan_name).info.frame9.frame5.frame0.frame1.menubutton2.menu %W}

  # pack widget $topwin(enhan_name).info.frame9.frame5.frame0.frame1
  pack append $topwin(enhan_name).info.frame9.frame5.frame0.frame1 \
    $topwin(enhan_name).info.frame9.frame5.frame0.frame1.label1 {left frame center fill} \
    $topwin(enhan_name).info.frame9.frame5.frame0.frame1.value {left frame center expand fill} \
    $topwin(enhan_name).info.frame9.frame5.frame0.frame1.menubutton2 {right frame center fill}

  # build widget $topwin(enhan_name).info.frame9.frame5.frame0.frame0
  frame $topwin(enhan_name).info.frame9.frame5.frame0.frame0 \
    -background "$GuiColor(frame_bg)" \
    -borderwidth {2}

  # build widget $topwin(enhan_name).info.frame9.frame5.frame0.frame0.label1
  label $topwin(enhan_name).info.frame9.frame5.frame0.frame0.label1 \
    -background "$GuiColor(label_bg)" \
    -borderwidth {0} \
    -text {Cutoff Frequency: }

  # build widget $topwin(enhan_name).info.frame9.frame5.frame0.frame0.value
  entry $topwin(enhan_name).info.frame9.frame5.frame0.frame0.value \
    -background "$GuiColor(entry_bg)" \
    -foreground "$GuiColor(entry_fg)" \
    -relief {sunken} \
    -textvariable {enhan(filter_lcf)} \
    -width {5}
  endEntry  $topwin(enhan_name).info.frame9.frame5.frame0.frame0.value 0\
     $topwin(enhan_name).info.frame9.frame5.frame14.frame0.value \
     $topwin(enhan_name).info.frame9.frame5.frame14.frame0.value 

  # pack widget $topwin(enhan_name).info.frame9.frame5.frame0.frame0
  pack append $topwin(enhan_name).info.frame9.frame5.frame0.frame0 \
    $topwin(enhan_name).info.frame9.frame5.frame0.frame0.label1 {left frame center fill} \
    $topwin(enhan_name).info.frame9.frame5.frame0.frame0.value {left frame center expand fill}

  # pack widget $topwin(enhan_name).info.frame9.frame5.frame0
  pack append $topwin(enhan_name).info.frame9.frame5.frame0 \
    $topwin(enhan_name).info.frame9.frame5.frame0.radiobutton18 {left frame center} \
    $topwin(enhan_name).info.frame9.frame5.frame0.frame1 {left frame center padx 26} \
    $topwin(enhan_name).info.frame9.frame5.frame0.frame0 {left frame center padx 26}

  # build widget $topwin(enhan_name).info.frame9.frame5.frame14
  frame $topwin(enhan_name).info.frame9.frame5.frame14 \
    -background "$GuiColor(frame_bg)" \
    -relief {ridge}

  # build widget $topwin(enhan_name).info.frame9.frame5.frame14.frame0
  frame $topwin(enhan_name).info.frame9.frame5.frame14.frame0 \
    -background "$GuiColor(frame_bg)" \
    -borderwidth {2}

  # build widget $topwin(enhan_name).info.frame9.frame5.frame14.frame0.label1
  label $topwin(enhan_name).info.frame9.frame5.frame14.frame0.label1 \
    -background "$GuiColor(label_bg)" \
    -borderwidth {0} \
    -relief {sunken} \
    -text {Emphasis offset: }

  # build widget $topwin(enhan_name).info.frame9.frame5.frame14.frame0.value
  entry $topwin(enhan_name).info.frame9.frame5.frame14.frame0.value \
    -background "$GuiColor(entry_bg)" \
    -foreground "$GuiColor(entry_fg)" \
    -relief {sunken} \
    -textvariable {enhan(filter_offset)} \
    -width {4}
  endEntry  $topwin(enhan_name).info.frame9.frame5.frame14.frame0.value 0\
     $topwin(enhan_name).info.frame9.frame5.frame0.frame0.value \
     $topwin(enhan_name).info.frame9.frame5.frame0.frame0.value 

  # build widget $topwin(enhan_name).info.frame9.frame5.frame14.frame0.menubutton2
	menubutton $topwin(enhan_name).info.frame9.frame5.frame14.frame0.menubutton2 -padx {1} -pady {1} -highlightthickness {0}  \
    -activebackground "$GuiColor(btn_act_bg)" \
    -background "$GuiColor(btn_bg)" \
	 -font "$GuiMisc(pop_up_fn)" \
	 -text "$GuiMisc(pop_up_text)" \
	 -relief "$GuiMisc(pop_up_relief)" \
	 -width {2}
  # bindings
  bind $topwin(enhan_name).info.frame9.frame5.frame14.frame0.menubutton2 <Button-1> {MenuPopupPost $topwin(enhan_name).info.frame9.frame5.frame14.frame0.menubutton2.menu %X %Y}
  bind $topwin(enhan_name).info.frame9.frame5.frame14.frame0.menubutton2 <ButtonRelease-1> {MenuPopupRelease $topwin(enhan_name).info.frame9.frame5.frame14.frame0.menubutton2.menu %W}

  # build widget $topwin(enhan_name).info.frame9.frame5.frame14.frame0.menubutton2.menu
  menu $topwin(enhan_name).info.frame9.frame5.frame14.frame0.menubutton2.menu \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" 
  $topwin(enhan_name).info.frame9.frame5.frame14.frame0.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set enhan(filter_offset) 1.2} \
    -label { 1.2 }
  $topwin(enhan_name).info.frame9.frame5.frame14.frame0.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set enhan(filter_offset) 1.3} \
    -label { 1.3 }
  $topwin(enhan_name).info.frame9.frame5.frame14.frame0.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set enhan(filter_offset) 1.5} \
    -label { 1.5 }
  $topwin(enhan_name).info.frame9.frame5.frame14.frame0.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set enhan(filter_offset) 1.7} \
    -label { 1.7 }
  $topwin(enhan_name).info.frame9.frame5.frame14.frame0.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set enhan(filter_offset) 1.9} \
    -label { 1.9 }
  $topwin(enhan_name).info.frame9.frame5.frame14.frame0.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set enhan(filter_offset) 2.0} \
    -label { 2.0 }
  $topwin(enhan_name).info.frame9.frame5.frame14.frame0.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set enhan(filter_offset) 2.5} \
    -label { 2.5 }
  bindtags $topwin(enhan_name).info.frame9.frame5.frame14.frame0.menubutton2.menu {Menu all}
  # bindings
  bind $topwin(enhan_name).info.frame9.frame5.frame14.frame0.menubutton2.menu <B1-Motion> {MenuPopupMotion $topwin(enhan_name).info.frame9.frame5.frame14.frame0.menubutton2.menu %W %X %Y}
  bind $topwin(enhan_name).info.frame9.frame5.frame14.frame0.menubutton2.menu <ButtonRelease-1> {MenuPopupRelease $topwin(enhan_name).info.frame9.frame5.frame14.frame0.menubutton2.menu %W}

  # pack widget $topwin(enhan_name).info.frame9.frame5.frame14.frame0
  pack append $topwin(enhan_name).info.frame9.frame5.frame14.frame0 \
    $topwin(enhan_name).info.frame9.frame5.frame14.frame0.label1 {left frame center fill} \
    $topwin(enhan_name).info.frame9.frame5.frame14.frame0.value {left frame center expand fill} \
    $topwin(enhan_name).info.frame9.frame5.frame14.frame0.menubutton2 {right frame center fill}
# build widget $topwin(enhan_name).info.frame9.frame5.frame14.frame1
  frame $topwin(enhan_name).info.frame9.frame5.frame14.frame1 \
    -background "$GuiColor(frame_bg)" \
    -borderwidth {2}

  # build widget $topwin(enhan_name).info.frame9.frame5.frame14.frame1.label1
  label $topwin(enhan_name).info.frame9.frame5.frame14.frame1.label1 \
    -background "$GuiColor(label_bg)" \
    -borderwidth {0} \
    -relief {sunken} \
    -text {Filter order: }

  # build widget $topwin(enhan_name).info.frame9.frame5.frame14.frame1.value
  entry $topwin(enhan_name).info.frame9.frame5.frame14.frame1.value \
    -background "$GuiColor(rentry_bg)" \
    -foreground "$GuiColor(rentry_fg)" \
    -relief {sunken} \
    -textvariable {enhan(filter_order)} \
    -width {3}

  # build widget $topwin(enhan_name).info.frame9.frame5.frame14.frame1.menubutton2
	menubutton $topwin(enhan_name).info.frame9.frame5.frame14.frame1.menubutton2 -padx {1} -pady {1} -highlightthickness {0}  \
    -activebackground "$GuiColor(btn_act_bg)" \
    -background "$GuiColor(btn_bg)" \
	 -font "$GuiMisc(pop_up_fn)" \
	 -text "$GuiMisc(pop_up_text)" \
	 -relief "$GuiMisc(pop_up_relief)" \
	 -width {2}
  # bindings
  bind $topwin(enhan_name).info.frame9.frame5.frame14.frame1.menubutton2 <Button-1> {MenuPopupPost $topwin(enhan_name).info.frame9.frame5.frame14.frame1.menubutton2.menu %X %Y}
  bind $topwin(enhan_name).info.frame9.frame5.frame14.frame1.menubutton2 <ButtonRelease-1> {MenuPopupRelease $topwin(enhan_name).info.frame9.frame5.frame14.frame1.menubutton2.menu %W}

  # build widget $topwin(enhan_name).info.frame9.frame5.frame14.frame1.menubutton2.menu
  menu $topwin(enhan_name).info.frame9.frame5.frame14.frame1.menubutton2.menu \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" 
  $topwin(enhan_name).info.frame9.frame5.frame14.frame1.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set enhan(filter_order) 1} \
    -label { 1 }
  $topwin(enhan_name).info.frame9.frame5.frame14.frame1.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set enhan(filter_order) 2} \
    -label { 2 }
  $topwin(enhan_name).info.frame9.frame5.frame14.frame1.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set enhan(filter_order) 3} \
    -label { 3 }
  $topwin(enhan_name).info.frame9.frame5.frame14.frame1.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set enhan(filter_order) 4} \
    -label { 4 }
  $topwin(enhan_name).info.frame9.frame5.frame14.frame1.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set enhan(filter_order) 5} \
    -label { 5 }
  $topwin(enhan_name).info.frame9.frame5.frame14.frame1.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set enhan(filter_order) 6} \
    -label { 6 }
  $topwin(enhan_name).info.frame9.frame5.frame14.frame1.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set enhan(filter_order) 7} \
    -label { 7 }
  $topwin(enhan_name).info.frame9.frame5.frame14.frame1.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set enhan(filter_order) 8} \
    -label { 8 }
  bindtags $topwin(enhan_name).info.frame9.frame5.frame14.frame1.menubutton2.menu {Menu all}
  # bindings
  bind $topwin(enhan_name).info.frame9.frame5.frame14.frame1.menubutton2.menu <B1-Motion> {MenuPopupMotion $topwin(enhan_name).info.frame9.frame5.frame14.frame1.menubutton2.menu %W %X %Y}
  bind $topwin(enhan_name).info.frame9.frame5.frame14.frame1.menubutton2.menu <ButtonRelease-1> {MenuPopupRelease $topwin(enhan_name).info.frame9.frame5.frame14.frame1.menubutton2.menu %W}

  # pack widget $topwin(enhan_name).info.frame9.frame5.frame14.frame1
  pack append $topwin(enhan_name).info.frame9.frame5.frame14.frame1 \
    $topwin(enhan_name).info.frame9.frame5.frame14.frame1.label1 {left frame center fill} \
    $topwin(enhan_name).info.frame9.frame5.frame14.frame1.value {left frame center expand fill} \
    $topwin(enhan_name).info.frame9.frame5.frame14.frame1.menubutton2 {right frame center fill}

  # build widget $topwin(enhan_name).info.frame9.frame5.frame14.checkbutton20
	checkbutton $topwin(enhan_name).info.frame9.frame5.frame14.checkbutton20 -padx {1} -pady {1} -highlightthickness {0}  \
    -activebackground "$GuiColor(btn_act_bg)" \
    -background "$GuiColor(btn_bg)" \
    -offvalue {n} \
    -onvalue {y} \
    -relief {raised} \
    -text {Keep DC} \
    -variable {enhan(filter_dc)}

  # pack widget $topwin(enhan_name).info.frame9.frame5.frame14
  pack append $topwin(enhan_name).info.frame9.frame5.frame14 \
    $topwin(enhan_name).info.frame9.frame5.frame14.checkbutton20 {left frame e padx 20} \
    $topwin(enhan_name).info.frame9.frame5.frame14.frame0 {right frame w padx 20} \
    $topwin(enhan_name).info.frame9.frame5.frame14.frame1 {right frame w padx 20}

  # pack widget $topwin(enhan_name).info.frame9.frame5
  pack append $topwin(enhan_name).info.frame9.frame5 \
    $topwin(enhan_name).info.frame9.frame5.frame0 {top frame center expand fill} \
    $topwin(enhan_name).info.frame9.frame5.frame14 {top frame center expand fill}

  # build widget $topwin(enhan_name).info.frame9.frame0
  frame $topwin(enhan_name).info.frame9.frame0 \
    -background "$GuiColor(frame_bg)" \
    -borderwidth {2} \
    -relief {ridge}

  # build widget $topwin(enhan_name).info.frame9.frame0.frame0
  frame $topwin(enhan_name).info.frame9.frame0.frame0 \
    -background "$GuiColor(frame_bg)" \
    -relief {ridge}

  # build widget $topwin(enhan_name).info.frame9.frame0.frame0.radiobutton18
	radiobutton $topwin(enhan_name).info.frame9.frame0.frame0.radiobutton18 -padx {1} -pady {1} -highlightthickness {0}  \
    -activebackground "$GuiColor(btn_act_bg)" \
    -background "$GuiColor(btn_bg)" \
    -relief {flat} \
    -text {Homomorphic sharp} \
    -value {homomorphic} \
    -variable {enhan(sharp)} \
    -command {
	if { $rows <= $cols } {
	    set enhan(filter_lcf) [expr $rows/4]
	} else {
	    set enhan(filter_lcf) [expr $cols/4]
	    }
	}

  # build widget $topwin(enhan_name).info.frame9.frame0.frame0.frame0
  frame $topwin(enhan_name).info.frame9.frame0.frame0.frame0 \
    -background "$GuiColor(frame_bg)" \
    -borderwidth {2}

  # build widget $topwin(enhan_name).info.frame9.frame0.frame0.frame0.label1
  label $topwin(enhan_name).info.frame9.frame0.frame0.frame0.label1 \
    -background "$GuiColor(label_bg)" \
    -borderwidth {0} \
    -text {Cutoff Frequency: }

  # build widget $topwin(enhan_name).info.frame9.frame0.frame0.frame0.value
  entry $topwin(enhan_name).info.frame9.frame0.frame0.frame0.value \
    -background "$GuiColor(entry_bg)" \
    -foreground "$GuiColor(entry_fg)" \
    -relief {sunken} \
    -textvariable {enhan(filter_lcf)} \
    -width {5}

  endEntry  $topwin(enhan_name).info.frame9.frame0.frame0.frame0.value 0\
     $topwin(enhan_name).info.frame9.frame0.frame14.frame2.value \
     $topwin(enhan_name).info.frame9.frame0.frame14.frame3.value 

  # build widget $topwin(enhan_name).info.frame9.frame0.frame0.frame0.menubutton2
	menubutton $topwin(enhan_name).info.frame9.frame0.frame0.frame0.menubutton2 -padx {1} -pady {1} -highlightthickness {0}  \
    -activebackground "$GuiColor(btn_act_bg)" \
    -background "$GuiColor(btn_bg)" \
	 -font "$GuiMisc(pop_up_fn)" \
	 -text "$GuiMisc(pop_up_text)" \
	 -relief "$GuiMisc(pop_up_relief)" \
	 -width {2}
  # bindings
  bind $topwin(enhan_name).info.frame9.frame0.frame0.frame0.menubutton2 <Button-1> {MenuPopupPost $topwin(enhan_name).info.frame9.frame0.frame0.frame0.menubutton2.menu %X %Y}
  bind $topwin(enhan_name).info.frame9.frame0.frame0.frame0.menubutton2 <ButtonRelease-1> {MenuPopupRelease $topwin(enhan_name).info.frame9.frame0.frame0.frame0.menubutton2.menu %W}

  # build widget $topwin(enhan_name).info.frame9.frame0.frame0.frame0.menubutton2.menu
  menu $topwin(enhan_name).info.frame9.frame0.frame0.frame0.menubutton2.menu \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" 
  $topwin(enhan_name).info.frame9.frame0.frame0.frame0.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set enhan(filter_lcf) 16} \
    -label {  16 }
  $topwin(enhan_name).info.frame9.frame0.frame0.frame0.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set enhan(filter_lcf) 24} \
    -label {  24 }
  $topwin(enhan_name).info.frame9.frame0.frame0.frame0.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set enhan(filter_lcf) 32} \
    -label {  32 }
  $topwin(enhan_name).info.frame9.frame0.frame0.frame0.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set enhan(filter_lcf) 40} \
    -label {  40 }
  $topwin(enhan_name).info.frame9.frame0.frame0.frame0.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set enhan(filter_lcf) 48} \
    -label {  48 }
  $topwin(enhan_name).info.frame9.frame0.frame0.frame0.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set enhan(filter_lcf) 56} \
    -label {  56 }
  $topwin(enhan_name).info.frame9.frame0.frame0.frame0.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set enhan(filter_lcf) 64} \
    -label {  64 }
  $topwin(enhan_name).info.frame9.frame0.frame0.frame0.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set enhan(filter_lcf) 80} \
    -label {  80 }
  $topwin(enhan_name).info.frame9.frame0.frame0.frame0.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
         -background "$GuiColor(menu_bg)" \
    -command {set enhan(filter_lcf) 128} \
    -label { 128 }
  bindtags $topwin(enhan_name).info.frame9.frame0.frame0.frame0.menubutton2.menu {Menu all}
  # bindings
  bind $topwin(enhan_name).info.frame9.frame0.frame0.frame0.menubutton2.menu <B1-Motion> {MenuPopupMotion $topwin(enhan_name).info.frame9.frame0.frame0.frame0.menubutton2.menu %W %X %Y}
  bind $topwin(enhan_name).info.frame9.frame0.frame0.frame0.menubutton2.menu <ButtonRelease-1> {MenuPopupRelease $topwin(enhan_name).info.frame9.frame0.frame0.frame0.menubutton2.menu %W}

  # pack widget $topwin(enhan_name).info.frame9.frame0.frame0.frame0
  pack append $topwin(enhan_name).info.frame9.frame0.frame0.frame0 \
    $topwin(enhan_name).info.frame9.frame0.frame0.frame0.label1 {left frame center fill} \
    $topwin(enhan_name).info.frame9.frame0.frame0.frame0.value {left frame center expand fill} \
    $topwin(enhan_name).info.frame9.frame0.frame0.frame0.menubutton2 {left frame center fill}

  # build widget $topwin(enhan_name).info.frame9.frame0.frame0.check0
        checkbutton $topwin(enhan_name).info.frame9.frame0.frame0.check0 -padx {1} -pady {1} -highlightthickness {0}\
    -activebackground "$GuiColor(btn_act_bg)" \
    -background "$GuiColor(btn_bg)" \
    -text {Add result with original} \
    -variable {enhan(sh_add_result)}

  # pack widget $topwin(enhan_name).info.frame9.frame0.frame0
  pack append $topwin(enhan_name).info.frame9.frame0.frame0 \
    $topwin(enhan_name).info.frame9.frame0.frame0.radiobutton18 {left frame center} \
    $topwin(enhan_name).info.frame9.frame0.frame0.frame0 {left frame center padx 56} \
    $topwin(enhan_name).info.frame9.frame0.frame0.check0 {right frame center fill}
    
  # build widget $topwin(enhan_name).info.frame9.frame0.frame14
  frame $topwin(enhan_name).info.frame9.frame0.frame14 \
    -background "$GuiColor(frame_bg)" \
    -relief {ridge}

  # build widget $topwin(enhan_name).info.frame9.frame0.frame14.frame2
  frame $topwin(enhan_name).info.frame9.frame0.frame14.frame2 \
    -background "$GuiColor(frame_bg)" \
    -borderwidth {2}

  # build widget $topwin(enhan_name).info.frame9.frame0.frame14.frame2.label1
  label $topwin(enhan_name).info.frame9.frame0.frame14.frame2.label1 \
    -background "$GuiColor(label_bg)" \
    -borderwidth {0} \
    -relief {sunken} \
    -text {Lower frequency gain: }

  # build widget $topwin(enhan_name).info.frame9.frame0.frame14.frame2.value
  entry $topwin(enhan_name).info.frame9.frame0.frame14.frame2.value \
    -background "$GuiColor(entry_bg)" \
    -foreground "$GuiColor(entry_fg)" \
    -relief {sunken} \
    -textvariable {enhan(filter_lfg)} \
    -width {5}
  endEntry  $topwin(enhan_name).info.frame9.frame0.frame14.frame2.value 0\
     $topwin(enhan_name).info.frame9.frame0.frame14.frame3.value \
     $topwin(enhan_name).info.frame9.frame0.frame0.frame0.value 

  # build widget $topwin(enhan_name).info.frame9.frame0.frame14.frame2.menubutton2
	menubutton $topwin(enhan_name).info.frame9.frame0.frame14.frame2.menubutton2 -padx {1} -pady {1} -highlightthickness {0}  \
    -activebackground "$GuiColor(btn_act_bg)" \
    -background "$GuiColor(btn_bg)" \
	 -font "$GuiMisc(pop_up_fn)" \
	 -text "$GuiMisc(pop_up_text)" \
	 -relief "$GuiMisc(pop_up_relief)" \
	 -width {2}
  # bindings
  bind $topwin(enhan_name).info.frame9.frame0.frame14.frame2.menubutton2 <Button-1> {MenuPopupPost  $topwin(enhan_name).info.frame9.frame0.frame14.frame2.menubutton2.menu %X %Y}
  bind $topwin(enhan_name).info.frame9.frame0.frame14.frame2.menubutton2 <ButtonRelease-1> {MenuPopupRelease  $topwin(enhan_name).info.frame9.frame0.frame14.frame2.menubutton2.menu  %W}

  # build widget $topwin(enhan_name).info.frame9.frame0.frame14.frame2.menubutton2.menu
  menu $topwin(enhan_name).info.frame9.frame0.frame14.frame2.menubutton2.menu \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" 
  $topwin(enhan_name).info.frame9.frame0.frame14.frame2.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set enhan(filter_lfg) 0.2} \
    -label { 0.20 }
  $topwin(enhan_name).info.frame9.frame0.frame14.frame2.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set enhan(filter_lfg) 0.4} \
    -label { 0.40 }
  $topwin(enhan_name).info.frame9.frame0.frame14.frame2.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set enhan(filter_lfg) 0.6} \
    -label { 0.60 }
  $topwin(enhan_name).info.frame9.frame0.frame14.frame2.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set enhan(filter_lfg) 0.7} \
    -label { 0.70 }
  $topwin(enhan_name).info.frame9.frame0.frame14.frame2.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set enhan(filter_lfg) 0.8} \
    -label { 0.80 }
  $topwin(enhan_name).info.frame9.frame0.frame14.frame2.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set enhan(filter_lfg) 0.85} \
    -label { 0.85 }
  $topwin(enhan_name).info.frame9.frame0.frame14.frame2.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set enhan(filter_lfg) 0.9} \
    -label { 0.90 }
  $topwin(enhan_name).info.frame9.frame0.frame14.frame2.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set enhan(filter_lfg) 0.95} \
    -label { 0.95 }
  bindtags $topwin(enhan_name).info.frame9.frame0.frame14.frame2.menubutton2.menu {Menu all}
  # bindings
  bind $topwin(enhan_name).info.frame9.frame0.frame14.frame2.menubutton2.menu <B1-Motion> {MenuPopupMotion $topwin(enhan_name).info.frame9.frame0.frame14.frame2.menubutton2.menu  %W %X %Y}
  bind $topwin(enhan_name).info.frame9.frame0.frame14.frame2.menubutton2.menu <ButtonRelease-1> {MenuPopupRelease $topwin(enhan_name).info.frame9.frame0.frame14.frame2.menubutton2.menu  %W}

  # pack widget $topwin(enhan_name).info.frame9.frame0.frame14.frame2
  pack append $topwin(enhan_name).info.frame9.frame0.frame14.frame2 \
    $topwin(enhan_name).info.frame9.frame0.frame14.frame2.label1 {left frame center fill} \
    $topwin(enhan_name).info.frame9.frame0.frame14.frame2.value {left frame center expand fill} \
    $topwin(enhan_name).info.frame9.frame0.frame14.frame2.menubutton2 {right frame center fill}

  # build widget $topwin(enhan_name).info.frame9.frame0.frame14.frame3
  frame $topwin(enhan_name).info.frame9.frame0.frame14.frame3 \
    -background "$GuiColor(frame_bg)" \
    -borderwidth {2}

  # build widget $topwin(enhan_name).info.frame9.frame0.frame14.frame3.label1
  label $topwin(enhan_name).info.frame9.frame0.frame14.frame3.label1 \
    -background "$GuiColor(label_bg)" \
    -borderwidth {0} \
    -relief {sunken} \
    -text {Higher frequency gain: }

  # build widget $topwin(enhan_name).info.frame9.frame0.frame14.frame3.value
  entry $topwin(enhan_name).info.frame9.frame0.frame14.frame3.value \
    -background "$GuiColor(entry_bg)" \
    -foreground "$GuiColor(entry_fg)" \
    -relief {sunken} \
    -textvariable {enhan(filter_hfg)} \
    -width {5}
  endEntry  $topwin(enhan_name).info.frame9.frame0.frame14.frame3.value 0\
     $topwin(enhan_name).info.frame9.frame0.frame0.frame0.value \
     $topwin(enhan_name).info.frame9.frame0.frame14.frame2.value 

  # build widget $topwin(enhan_name).info.frame9.frame0.frame14.frame3.menubutton2
	menubutton $topwin(enhan_name).info.frame9.frame0.frame14.frame3.menubutton2 -padx {1} -pady {1} -highlightthickness {0}  \
    -activebackground "$GuiColor(btn_act_bg)" \
    -background "$GuiColor(btn_bg)" \
	 -font "$GuiMisc(pop_up_fn)" \
	 -text "$GuiMisc(pop_up_text)" \
	 -relief "$GuiMisc(pop_up_relief)" \
	 -width {2}
  # bindings
  bind $topwin(enhan_name).info.frame9.frame0.frame14.frame3.menubutton2 <Button-1> {MenuPopupPost  $topwin(enhan_name).info.frame9.frame0.frame14.frame3.menubutton2.menu %X %Y}
  bind $topwin(enhan_name).info.frame9.frame0.frame14.frame3.menubutton2 <ButtonRelease-1> {MenuPopupRelease  $topwin(enhan_name).info.frame9.frame0.frame14.frame3.menubutton2.menu  %W}

  # build widget $topwin(enhan_name).info.frame9.frame0.frame14.frame3.menubutton2.menu
  menu $topwin(enhan_name).info.frame9.frame0.frame14.frame3.menubutton2.menu \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" 
  $topwin(enhan_name).info.frame9.frame0.frame14.frame3.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set enhan(filter_hfg) 1.1} \
    -label { 1.1 }
  $topwin(enhan_name).info.frame9.frame0.frame14.frame3.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set enhan(filter_hfg) 1.2} \
    -label { 1.2 }
  $topwin(enhan_name).info.frame9.frame0.frame14.frame3.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set enhan(filter_hfg) 1.3} \
    -label { 1.3 }
  $topwin(enhan_name).info.frame9.frame0.frame14.frame3.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set enhan(filter_hfg) 1.4} \
    -label { 1.4 }
  $topwin(enhan_name).info.frame9.frame0.frame14.frame3.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set enhan(filter_hfg) 1.5} \
    -label { 1.5 }
  $topwin(enhan_name).info.frame9.frame0.frame14.frame3.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set enhan(filter_hfg) 1.8} \
    -label { 1.8 }
  $topwin(enhan_name).info.frame9.frame0.frame14.frame3.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set enhan(filter_hfg) 2.0} \
    -label { 2.0 }
  $topwin(enhan_name).info.frame9.frame0.frame14.frame3.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set enhan(filter_hfg) 1.3} \
    -label { 2.5 }
  bindtags $topwin(enhan_name).info.frame9.frame0.frame14.frame3.menubutton2.menu {Menu all}
  # bindings
  bind $topwin(enhan_name).info.frame9.frame0.frame14.frame3.menubutton2.menu <B1-Motion> {MenuPopupMotion $topwin(enhan_name).info.frame9.frame0.frame14.frame3.menubutton2.menu  %W %X %Y}
  bind $topwin(enhan_name).info.frame9.frame0.frame14.frame3.menubutton2.menu <ButtonRelease-1> {MenuPopupRelease $topwin(enhan_name).info.frame9.frame0.frame14.frame3.menubutton2.menu  %W}

  # pack widget $topwin(enhan_name).info.frame9.frame0.frame14.frame3
  pack append $topwin(enhan_name).info.frame9.frame0.frame14.frame3 \
    $topwin(enhan_name).info.frame9.frame0.frame14.frame3.label1 {left frame center fill} \
    $topwin(enhan_name).info.frame9.frame0.frame14.frame3.value {left frame center expand fill} \
    $topwin(enhan_name).info.frame9.frame0.frame14.frame3.menubutton2 {right frame center fill}

  # pack widget $topwin(enhan_name).info.frame9.frame0.frame14
  pack append $topwin(enhan_name).info.frame9.frame0.frame14 \
    $topwin(enhan_name).info.frame9.frame0.frame14.frame2 {left frame e padx 85} \
    $topwin(enhan_name).info.frame9.frame0.frame14.frame3 {left frame center padx 37}

  # pack widget $topwin(enhan_name).info.frame9.frame0
  pack append $topwin(enhan_name).info.frame9.frame0 \
    $topwin(enhan_name).info.frame9.frame0.frame0 {top frame center expand fill} \
    $topwin(enhan_name).info.frame9.frame0.frame14 {top frame center expand fill}

  # pack widget $topwin(enhan_name).info.frame9
  pack append $topwin(enhan_name).info.frame9 \
    $topwin(enhan_name).info.frame9.label5 {top frame w} \
    $topwin(enhan_name).info.frame9.frame6 {top frame center expand fill} \
    $topwin(enhan_name).info.frame9.frame10 {top frame center expand fill} \
    $topwin(enhan_name).info.frame9.frame5 {top frame center expand fill} \
    $topwin(enhan_name).info.frame9.frame0 {top frame center expand fill}

  # pack widget $topwin(enhan_name).info
  pack append $topwin(enhan_name).info \
    $topwin(enhan_name).info.frame3 {top frame center expand fill} \
    $topwin(enhan_name).info.frame9 {top frame center expand fill}

  # build widget $topwin(enhan_name).current_image
  frame $topwin(enhan_name).current_image \
    -background "$GuiColor(frame_bg)" \
    -borderwidth {2} \
    -relief {ridge}

  # build widget $topwin(enhan_name).current_image.label0
  label $topwin(enhan_name).current_image.label0 \
    -background "$GuiColor(label_bg)" \
    -text {Current image: }

  # build widget $topwin(enhan_name).current_image.label1
  label $topwin(enhan_name).current_image.label1 \
    -background "$GuiColor(label_bg)" \
    -foreground {Blue} \
    -text {} \
    -textvariable {current_image}

  # pack widget $topwin(enhan_name).current_image
  pack append $topwin(enhan_name).current_image \
    $topwin(enhan_name).current_image.label0 {left frame center} \
    $topwin(enhan_name).current_image.label1 {left frame center}

  # build widget $topwin(enhan_name).perform
  frame $topwin(enhan_name).perform \
    -background "$GuiColor(frame_bg)" \
    -borderwidth {2} \
    -relief {raised}

  # build widget $topwin(enhan_name).perform.button2
	button $topwin(enhan_name).perform.button2 -padx {1} -pady {1} -highlightthickness {0}  \
    -activebackground "$GuiColor(dis_act_bg)" \
    -background "$GuiColor(dis_bg)" \
    -foreground "$GuiColor(dis_fg)" \
	 -command "destroy $topwin(enhan_name)" \
    -text {DISMISS}

  # build widget $topwin(enhan_name).perform.button3
	button $topwin(enhan_name).perform.button3 -padx {1} -pady {1} -highlightthickness {0}  \
    -activebackground "$GuiColor(perf_act_bg)" \
    -background "$GuiColor(perf_bg)" \
    -foreground "$GuiColor(perf_fg)" \
    -command {
		set new_name ""
      $topwin(enhan_name) configure -cursor watch; update
      if {$current_image == ""} {
         CvipAlert "Please select an image first."
         $topwin(enhan_name) configure -cursor top_left_arrow; update
         return
      }  

      switch -exact  -- $enhan(sharp) {
			homomorphic {
				set temp [expr { $rows > $cols } ? $cols : $rows ]
				set temp [expr  $temp /2 ]
				if [catch { expr $enhan(filter_lcf) + $enhan(filter_lfg) + $enhan(filter_hfg) } ] {
         		CvipAlert "Numerical values required: Cutoff frequency = $enhan(filter_lcf),\n\
					Lower frequency gain = $enhan(filter_lfg),\n\
					Higher frequency gain = $enhan(filter_hfg)."
					$topwin(enhan_name) configure -cursor top_left_arrow; update
					return
				}
				if { $enhan(filter_lcf) < 0 || $enhan(filter_lcf) > $temp } {
         		CvipAlert "The cutoff frequency ($enhan(filter_lcf)) should be in the \
					range \[0, $temp\]."
					$topwin(enhan_name) configure -cursor top_left_arrow; update
					return
				}
				if [catch { set temp [cvip $enhan(sharp)  $current_image $enhan(filter_hfg) \
								$enhan(filter_lfg) $enhan(filter_lcf)] } cresult ] {
         		CvipAlert "$cresult."
					$topwin(enhan_name) configure -cursor top_left_arrow; update
					return
				}

				if { $GUI_DEBUG == "1" } {
					puts stderr "cvip $enhan(sharp)  $current_image $enhan(filter_hfg) \
							$enhan(filter_lfg) $enhan(filter_lcf)"
				}

				if { $enhan(sh_add_result) == "1" } {			
					if [catch {set temp1 [cvip add $current_image $temp]; cvip dq $temp; \
						set result [cvip hist_stretch $temp1 1 254 0.01 0.01]; cvip dq $temp1} cresult ] {
         			CvipAlert "$cresult."
						$topwin(enhan_name) configure -cursor top_left_arrow; update
						return
					}
					if { $GUI_DEBUG == "1" } {
						puts stderr "cvip add $current_image $temp"
 						puts stderr "cvip hist_stretch $temp1"
					}
 				} else {
 					set result $temp
 				}

				set new_name [cvip rename $result [append new_name $current_image _homomorphic]]
				img_q insert end $new_name
				image_post $new_name
				cvip view $new_name
				CvipMessage "homomorphic filtering perfomed on image \"$current_image\""

			}

			sharp {
				if [catch {
						set temp [cvip hist_shrink $current_image 10 100]
						if { $GUI_DEBUG == "1" } {
							puts stderr "cvip hist_shrink $current_image 10 100"
						}
						set temp1 [cvip sharp $temp]; cvip dq $temp
						if { $GUI_DEBUG == "1" } {
							puts stderr "cvip sharp $temp"
						}
						if { $bands == "1" } {
							set temp [cvip histeq $temp1]
							if { $GUI_DEBUG == "1" } {
								puts stderr "cvip histeq $temp1"
							}
							cvip dq $temp1
						}  else {
							set temp [cvip cxform $temp1 HSL 1 1 1]; cvip dq $temp1
							if { $GUI_DEBUG == "1" } {
								puts stderr "cvip cxform $temp1 HSL 1 1 1"
							}
							set temp1 [cvip histeq $temp 2] ; cvip dq $temp
							if { $GUI_DEBUG == "1" } {
								puts stderr "cvip histeq $temp 2"
							}
							set temp [cvip cxform $temp1 HSL 0 1 1]; cvip dq $temp1
							if { $GUI_DEBUG == "1" } {
								puts stderr "cvip cxform $temp1 HSL 0 1 1"
							}
						}
						if { $enhan(sh_add_result) == "1" } {
							set result [cvip add $current_image $temp]; cvip dq $temp
							if { $GUI_DEBUG == "1" } {
								puts stderr "cvip add $current_image $temp"
							}
						} else {
							set result $temp
						}
					} cresult ] {
         		CvipAlert "$cresult."
					$topwin(enhan_name) configure -cursor top_left_arrow; update
					return
				}
				set new_name [cvip rename $result [append new_name $current_image _sharp]]
				img_q insert end $new_name
				image_post $new_name
				cvip view $new_name
				CvipMessage "sharpening algorithm perfomed on image \"$current_image\""
			}
	
			highpass_spatial {
				if [catch {
						set temp [cvip $enhan(sharp) $current_image];
						if { $GUI_DEBUG == "1" } {
							puts stderr "cvip $enhan(sharp) $current_image"
						}
						set temp1 [cvip add $current_image $temp]; cvip dq $temp
						if { $GUI_DEBUG == "1" } {
							puts stderr "cvip add $current_image $temp"
						}
						if { $enhan(sh_add_result) == "1" } {
							set result [cvip add $current_image $temp1]; cvip dq $temp1
							if { $GUI_DEBUG == "1" } {
								puts stderr "cvip add $current_image $temp1"
							}
						} else {
							set result $temp1
						}
					} cresult] {
         		CvipAlert "$cresult."
					$topwin(enhan_name) configure -cursor top_left_arrow; update
					return
				}
				set new_name [cvip rename $result [append new_name $current_image _highpass]]
				img_q insert end $new_name
				image_post $new_name
				cvip view $new_name
				CvipMessage "high-pass spatial filter perfomed on image \"$current_image\""
			}
	
			high_boost {
				if [catch {expr $enhan(sh_mask_center)} ] {
         		CvipAlert "An integer center value is required:\n\
					Center value = $enhan(sh_mask_center)."
					$topwin(enhan_name) configure -cursor top_left_arrow; update
					return
				}
				set temp "cvip specify_spatial $current_image $enhan(sh_mask_size) $enhan(sh_mask_size) {"
				set temp2 [expr $enhan(sh_mask_size) * $enhan(sh_mask_size)]
				for {set temp1 1} {$temp1 <=  $temp2/2 } { incr temp1 } {
					append temp " -1"
				}
				append temp " $enhan(sh_mask_center)"
				for {set temp1 [expr $temp2/2 + 2] } {$temp1 <=  $temp2 } { incr temp1 } {
					append temp " -1"
				}
				append temp "}"
				if { $GUI_DEBUG == "1" } {
					puts stderr $temp
				}
				if [catch {
						set temp1 [eval $temp]
						if { $enhan(sh_add_result) == "1" } {
							set result [cvip add $current_image $temp1]; cvip dq $temp1
							if { $GUI_DEBUG == "1" } {
								puts stderr "cvip add $current_image $temp1"
							}
						} else {
							set result $temp1
						}

					} cresult ] {
         		CvipAlert "$cresult."
					$topwin(enhan_name) configure -cursor top_left_arrow; update
					return
				}
				set new_name [cvip rename $result [append new_name $current_image _highboost]]
				img_q insert end $new_name
				image_post $new_name
				cvip view $new_name
				CvipMessage "high-boost filter perfomed on image \"$current_image\""
			}
	
			unsharp {
				if [catch {expr $enhan(unsharp_ll) + $enhan(unsharp_ul)} ] {
         		CvipAlert "Numerical values required for the upper and lower limits:\n Lower limit\
					= $enhan(unsharp_ll), Upper limit = $enhan(unsharp_ul)."
					$topwin(enhan_name) configure -cursor top_left_arrow; update
					return
				}
				if [catch { expr  $enhan(unsharp_h_c) + $enhan(unsharp_l_c) } ] {
	         	CvipAlert "Numerical values required for high and low clip percentage:\n\
					Low clip  = $enhan(unsharp_l_c), High clip = $enhan(unsharp_h_c)."
					$topwin(enhan_name) configure -cursor top_left_arrow; update
	         	return
				} elseif { $enhan(unsharp_h_c) < 0 || $enhan(unsharp_h_c) > 1 ||
							  $enhan(unsharp_l_c) < 0 || $enhan(unsharp_l_c) > 1 } {
	         	CvipAlert "The high and low clip percentage should be in the range \[0, 1\]:\n\
					Low clip  = [expr 100*$enhan(unsharp_l_c)]%, High clip = [expr 100*$enhan(unsharp_h_c)]%."
					$topwin(enhan_name) configure -cursor top_left_arrow; update
	         	return

				}
				if [catch {
						set result [cvip unsharp $current_image $enhan(unsharp_ll) $enhan(unsharp_ul)\
							$enhan(unsharp_l_c) $enhan(unsharp_h_c)]
							if { $GUI_DEBUG == "1" } {
								puts stderr "cvip unsharp $current_image $enhan(unsharp_ll) $enhan(unsharp_ul) \
									$enhan(unsharp_l_c) $enhan(unsharp_h_c)"
							}
					} cresult ] {
         		CvipAlert "$cresult."
					$topwin(enhan_name) configure -cursor top_left_arrow; update
					return
				}
				set new_name [cvip rename $result [append new_name $current_image _unsharp]]
				img_q insert end $new_name
				image_post $new_name
				cvip view $new_name
				CvipMessage "unsharp masking perfomed on image \"$current_image\""
			}
	
			fft -
			dct {
				if {$enhan(sharp) == "dct"} {
					set std_cutoff $enhan(sh_DCT_cutoff)
				} else {
					set std_cutoff $enhan(sh_FFT_cutoff)
				}
				if { $GUI_DEBUG == "1" } {
					puts stderr " enhan(sh_cutoff)=$ enhan(sh_cutoff)"
				}
				if [catch {expr $rows + $cols} ] {
         		CvipAlert "Inappropriate image size:\n\
					Height = $rows, Width = $cols."
					$topwin(enhan_name) configure -cursor top_left_arrow; update
					return
				}
				set temp [expr { $rows < $cols} ? $cols : $rows ]
				set enhan(block) [expr int(pow(2, ceil(log($temp) / log(2.0))))]
				if [catch {expr $enhan(sh_cutoff)} ] {
         		CvipAlert "Numerical value required for the cutoff frequency:\n\
					Cutoff frequency  = $enhan(sh_cutoff)."
					$topwin(enhan_name) configure -cursor top_left_arrow; update
					return
				} elseif { $enhan(sh_cutoff) < "0" || $enhan(sh_cutoff) > $std_cutoff } {
         		CvipAlert "The cutoff frequency ($enhan(sh_cutoff)) should be in the range \
					\[1 - $std_cutoff\]."
					$topwin(enhan_name) configure -cursor top_left_arrow; update
					return
				}
				if [catch {
						set temp [cvip $enhan(sharp) $current_image 1 $enhan(block)];
						if { $GUI_DEBUG == "1" } {
							puts stderr "cvip $enhan(sharp) $current_image 1 $enhan(block)"
						}
						set temp1 [cvip hpf_filter $temp y BUTTER_HIGH $enhan(sh_cutoff) $enhan(order)]; cvip dq $temp
						if { $GUI_DEBUG == "1" } {
							puts stderr "cvip hpf_filter $temp y BUTTER_HIGH $enhan(sh_cutoff) 1"
						}
						set temp2 [cvip $enhan(sharp) $temp1 0 -1]; cvip dq $temp1
						if { $GUI_DEBUG == "1" } {
							puts stderr "cvip $enhan(sharp) $temp1 0 -1"
						}
						set temp3 [cvip add $current_image $temp2]; cvip dq $temp2
						if { $GUI_DEBUG == "1" } {
							puts stderr "cvip add $current_image $temp2"
						}
						set result [cvip hist_stretch $temp3 1 254 0.01 0.01]; cvip dq $temp3
						if { $GUI_DEBUG == "1" } {
 							puts stderr "cvip hist_stretch $temp3"
						}
					} cresult ] {
         		CvipAlert "$cresult."
					$topwin(enhan_name) configure -cursor top_left_arrow; update
					return
				}

				set new_name [cvip rename $result [append new_name $current_image _$enhan(sharp)sharp]]
				img_q insert end $new_name
				image_post $new_name
				cvip view $new_name
				if { $enhan(sharp) == "fft" } {
					CvipMessage "fft sharpening perfomed on image \"$current_image\""
				} else {
					CvipMessage "dct sharpening perfomed on image \"$current_image\""
				}
			}
	
			hfe_filter {
				if [catch {expr $enhan(filter_lcf)} ] {
         		CvipAlert "Numerical value required for the cutoff frequency:\n\
					Cutoff frequency = $enhan(filter_lcf)."
					$topwin(enhan_name) configure -cursor top_left_arrow; update
					return
				} elseif {$enhan(filter_lcf) < 0 } {
         		CvipAlert "Cutoff frequency ($enhan(filter_lcf)) should be greater than or equal to 0."
					$topwin(enhan_name) configure -cursor top_left_arrow; update
					return
				}
				if [catch {expr $enhan(filter_offset)} ] {
         		CvipAlert "Numerical value required for the offset value:\n\
					Offset value = $enhan(filter_offset)."
					$topwin(enhan_name) configure -cursor top_left_arrow; update
					return
				} elseif {$enhan(filter_offset) < "0.01" || $enhan(filter_offset) > "3.0"} {
         		CvipAlert "Offset value ($enhan(filter_offset)) should be in the range (0.01-3.0)"
					$topwin(enhan_name) configure -cursor top_left_arrow; update
					return
				}

				if [catch {expr $rows + $cols} ] {
         		CvipAlert "Inappropriate image size:\n\
					Height = $rows, Width = $cols."
					$topwin(enhan_name) configure -cursor top_left_arrow; update
					return
				}
				set temp [expr { $rows < $cols} ? $cols : $rows ]
				set temp [expr int(pow(2, ceil(log($temp) / log(2.0))))];
				if [catch {set temp1 [cvip $enhan(transform) $current_image 1 $temp]} cresult] {
         		CvipAlert "$cresult."
					$topwin(enhan_name) configure -cursor top_left_arrow; update
					return
				}
				if { $GUI_DEBUG == "1" } {
					puts stderr $temp;
					puts stderr "cvip $enhan(transform) $current_image 1 $temp"
				}

            if [catch {set result [cvip $enhan(sharp) $temp1 $enhan(filter_dc) $enhan(filter_lcf)\
						$enhan(filter_offset) $enhan(filter_order)];
						cvip dq $temp1
					} cresult] {
               CvipAlert "$cresult"
					$topwin(enhan_name) configure -cursor top_left_arrow; update
               return
            }

				if { $GUI_DEBUG == "1" } {
					puts stderr "cvip $enhan(sharp) $temp1 $enhan(filter_dc) $enhan(filter_lcf)\
								$enhan(filter_offset) $enhan(filter_order)"
				}

            if [catch {
						set temp [cvip $enhan(transform) $result 0 -1]
						if { $GUI_DEBUG == "1" } {
							puts stderr "cvip $enhan(transform) $result 0"
						}
						cvip dq $result
					} cresult] {
					CvipAlert "$cresult"
					$topwin(enhan_name) configure -cursor top_left_arrow; update
					return
	         } else {
	         			set temp2 [cvip add $current_image $temp]; cvip dq $temp
					if { $GUI_DEBUG == "1" } {
						puts stderr "cvip add $current_image $temp"
					}
					set result [cvip hist_stretch $temp2 1 254 0.01 0.01]; cvip dq $temp2
					if { $GUI_DEBUG == "1" } {
 						puts stderr "cvip hist_stretch $temp2"
					}

					set new_name [cvip rename $result ${current_image}_$enhan(sharp)_$enhan(transform)]
					img_q insert end $new_name
					image_post $new_name
					cvip view $new_name
					CvipMessage "high frequency emphasis perfomed on image \"$current_image\""
  	         }
			}

		}

		$topwin(enhan_name) configure -cursor top_left_arrow; update
	 } \
    -text {PERFORM}

  # pack widget $topwin(enhan_name).perform
  pack append $topwin(enhan_name).perform \
    $topwin(enhan_name).perform.button2 {left frame center} \
    $topwin(enhan_name).perform.button3 {right frame center}

  # pack widget $topwin(enhan_name)
  pack append $topwin(enhan_name) \
    $topwin(enhan_name).info {top frame center expand fill} \
    $topwin(enhan_name).current_image {top frame center fillx} \
    $topwin(enhan_name).perform {bottom frame center fillx}

  if {"[info procs XFEdit]" != ""} {
    catch "XFMiscBindWidgetTree $topwin(enhan_name)"
    after 2 "catch {XFEditSetShowWindows}"
  }
}

