# **********************************************************************
# Computer Vision/Image Processing Tool Project - Dr. Scott Umbaugh SIUE
# **********************************************************************
#
#             File Name: enhan_smooth.tcl
#           Description: 
#         Related Files: 
#   Initial Coding Date: Mon Sep 23 18:01:22 CDT 1996
#           Portability: TCL script file
#            References:
#             Author(s): Yansheng Wei and Mark Zuke
#                        Southern Illinois University @ Edwardsville
#
## Copyright (C) 1996 SIUE - by Scott Umbaugh, Mark Zuke and Yansheng Wei.
##
## Permission to use, copy, modify, and distribute this software and its
## documentation for any purpose and without fee is hereby granted, provided
## that the above copyright notice appear in all copies and that both that
## copyright notice and this permission notice appear in supporting
## documentation.  This software is provided "as is" without express or
## implied warranty.
##
# RCS (Revision Control System) Information
# ...Added automatically by RCS 
#
## $Log: enhan_smooth.tcl,v $
## Revision 1.12  1997/07/09 21:01:19  yawei
## Gui configuration finished
##
## Revision 1.11  1997/07/08 00:40:46  smakam
## didnt accept the proper blocksize for fft smoothing,removes that error
##
## Revision 1.10  1997/07/06 19:55:49  smakam
## changed the block size parameter for fft_smooth
##
## Revision 1.9  1997/03/20 18:46:16  yawei
## update lpf_filter
##
## Revision 1.8  1997/03/12 01:15:08  yawei
## update arrow button
##
## Revision 1.7  1997/03/11 20:56:12  yawei
## Tcl/Tk script upgrading from tcl7.3/tk3.6 to tcl7.6/tk4.2
## compatible. This process is automated with tkboost perl
## script. @ Tue Mar 11 14:51:36 CST 1997
##
## Revision 1.6  1996/11/14 13:30:23  mzuke
## changed kernel to mask for Gaussian
##
# Revision 1.5  1996/10/27  19:24:59  yawei
# Added Gaussian_blur
#
# Revision 1.4  1996/10/16  03:53:22  yawei
# general changes
#
# Revision 1.3  1996/09/24  02:27:32  yawei
# Fixed problems:
# 1) keep DC for fft/dct smoothing
# 2) the max frequency for fft is maxsize/4, and for dct is maxsize/2
#
# Revision 1.2  1996/09/24  00:32:19  yawei
# Moved global variables to GUI.tcl
#
# Revision 1.1  1996/09/24  00:26:29  yawei
# Initial revision
#
#
#****************************************************************************
# procedure to show window $topwin(enhan_name).
proc enhan_smooth { } {# xf ignore me 7

  global tk_version
  global topwin
  global toplevel_position
  global GuiColor
  global GuiMisc
  global GUI_DEBUG

  if [ winfo exists  $topwin(enhan_name).info] {
     set tempname $topwin(enhan_name);\
destroy $topwin(enhan_name).info;\
set topwin(enhan_name) $tempname;}
  if [ winfo exists  $topwin(enhan_name).current_image] {
     set tempname $topwin(enhan_name);\
destroy $topwin(enhan_name).current_image;\
set topwin(enhan_name) $tempname;}
  if [ winfo exists  $topwin(enhan_name).perform] {
     set tempname $topwin(enhan_name);\
destroy $topwin(enhan_name).perform;\
set topwin(enhan_name) $tempname;}
  wm positionfrom  $topwin(enhan_name) user
  wm sizefrom  $topwin(enhan_name) user
  wm geometry $topwin(enhan_name) $topwin(enhan_smooth)[get_pos $topwin(enhan_name)]
  wm maxsize $topwin(enhan_name) [lindex $topwin(enhan_smooth_max) 0] \
  	[lindex $topwin(enhan_smooth_max) 1]
  wm minsize $topwin(enhan_name) [lindex $topwin(enhan_smooth_min) 0] \
  	[lindex $topwin(enhan_smooth_min) 1]
  wm title $topwin(enhan_name) {ENHANCEMENT -> Smoothing}

  bind $topwin(enhan_name) <Destroy> {set topwin(enhan_name) NONE}

  # build widget $topwin(enhan_name).info
  frame $topwin(enhan_name).info \
    -background "$GuiColor(frame_bg)" \
    -borderwidth {0}

  # build widget $topwin(enhan_name).info.frame3
  frame $topwin(enhan_name).info.frame3 \
    -background "$GuiColor(frame_bg)" \
    -borderwidth {3} \
    -relief {ridge}

  # build widget $topwin(enhan_name).info.frame3.frame0
  frame $topwin(enhan_name).info.frame3.frame0 \
    -background "$GuiColor(frame_bg)" \
    -borderwidth {2} \
    -relief {ridge}

  # build widget $topwin(enhan_name).info.frame3.frame0.frame3
  frame $topwin(enhan_name).info.frame3.frame0.frame3 \
    -background "$GuiColor(frame_bg)" \
    -borderwidth {2}

  # build widget $topwin(enhan_name).info.frame3.frame0.frame3.radiobutton5
	radiobutton $topwin(enhan_name).info.frame3.frame0.frame3.radiobutton5 -padx {1} -pady {1} -highlightthickness {0}  \
    -background "$GuiColor(btn_bg)" \
    -activebackground "$GuiColor(btn_act_bg)" \
    -command {set enhan(sm_mean) 3} \
    -relief {flat} \
    -text {Mean filter   } \
    -value {mean_filter} \
    -variable {enhan(smooth)}

  # pack widget $topwin(enhan_name).info.frame3.frame0.frame3
  pack append $topwin(enhan_name).info.frame3.frame0.frame3 \
    $topwin(enhan_name).info.frame3.frame0.frame3.radiobutton5 {top frame center}

  # build widget $topwin(enhan_name).info.frame3.frame0.frame4
  frame $topwin(enhan_name).info.frame3.frame0.frame4 \
    -background "$GuiColor(frame_bg)" \
    -borderwidth {2}

  # build widget $topwin(enhan_name).info.frame3.frame0.frame4.frame6
  frame $topwin(enhan_name).info.frame3.frame0.frame4.frame6 \
    -background "$GuiColor(frame_bg)" \
    -borderwidth {2}

  # build widget $topwin(enhan_name).info.frame3.frame0.frame4.frame6.label7
  label $topwin(enhan_name).info.frame3.frame0.frame4.frame6.label7 \
    -background "$GuiColor(label_bg)" \
    -anchor {e} \
    -text {Mask size:} \
    -width {15}


  # build widget $topwin(enhan_name).info.frame3.frame0.frame4.frame6.entry8
  entry $topwin(enhan_name).info.frame3.frame0.frame4.frame6.entry8 \
    -background "$GuiColor(rentry_bg)" \
	 -foreground "$GuiColor(rentry_fg)" \
    -relief {sunken} \
    -state {disabled} \
    -textvariable {enhan(sm_mean)} \
    -width {5}

  # build widget $topwin(enhan_name).info.frame3.frame0.frame4.frame6.label9
  menubutton $topwin(enhan_name).info.frame3.frame0.frame4.frame6.label9 \
    -background "$GuiColor(btn_bg)" \
    -activebackground "$GuiColor(btn_act_bg)" \
	 -padx {1} -pady {5} \
	 -font "$GuiMisc(pop_up_fn)" \
	 -text "$GuiMisc(pop_up_text)" \
	 -relief "$GuiMisc(pop_up_relief)" \
	 -width {2}
  # bindings
  bind $topwin(enhan_name).info.frame3.frame0.frame4.frame6.label9 <Button-1> {MenuPopupPost $topwin(enhan_name).info.frame3.frame0.frame4.frame6.label9.menu %X %Y}
  bind $topwin(enhan_name).info.frame3.frame0.frame4.frame6.label9 <ButtonRelease-1> {MenuPopupRelease $topwin(enhan_name).info.frame3.frame0.frame4.frame6.label9.menu %W}

  # build widget $topwin(enhan_name).info.frame3.frame0.frame4.frame6.label9.menu
  menu $topwin(enhan_name).info.frame3.frame0.frame4.frame6.label9.menu \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)"
  $topwin(enhan_name).info.frame3.frame0.frame4.frame6.label9.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set enhan(sm_mean) 3
set enhan(smooth) mean_filter} \
    -label {3}
  $topwin(enhan_name).info.frame3.frame0.frame4.frame6.label9.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set enhan(sm_mean) 5
set enhan(smooth) mean_filter
} \
    -label {5}
  $topwin(enhan_name).info.frame3.frame0.frame4.frame6.label9.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set enhan(sm_mean) 7
set enhan(smooth) mean_filter
} \
    -label {7}
  $topwin(enhan_name).info.frame3.frame0.frame4.frame6.label9.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set enhan(sm_mean) 9
set enhan(smooth) mean_filter
} \
    -label {9}
  $topwin(enhan_name).info.frame3.frame0.frame4.frame6.label9.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set enhan(sm_mean) 11
set enhan(smooth) mean_filter
} \
    -label {11}
  bindtags $topwin(enhan_name).info.frame3.frame0.frame4.frame6.label9.menu {Menu all}
  # bindings
  bind $topwin(enhan_name).info.frame3.frame0.frame4.frame6.label9.menu <B1-Motion> {MenuPopupMotion $topwin(enhan_name).info.frame3.frame0.frame4.frame6.label9.menu %W %X %Y}
  bind $topwin(enhan_name).info.frame3.frame0.frame4.frame6.label9.menu <ButtonRelease-1> {MenuPopupRelease $topwin(enhan_name).info.frame3.frame0.frame4.frame6.label9.menu %W}

  # pack widget $topwin(enhan_name).info.frame3.frame0.frame4.frame6
  pack append $topwin(enhan_name).info.frame3.frame0.frame4.frame6 \
    $topwin(enhan_name).info.frame3.frame0.frame4.frame6.label7 {left frame center} \
    $topwin(enhan_name).info.frame3.frame0.frame4.frame6.entry8 {left frame center} \
    $topwin(enhan_name).info.frame3.frame0.frame4.frame6.label9 {left frame center}

  # pack widget $topwin(enhan_name).info.frame3.frame0.frame4
  pack append $topwin(enhan_name).info.frame3.frame0.frame4 \
    $topwin(enhan_name).info.frame3.frame0.frame4.frame6 {left frame center expand}

  # pack widget $topwin(enhan_name).info.frame3.frame0
  pack append $topwin(enhan_name).info.frame3.frame0 \
    $topwin(enhan_name).info.frame3.frame0.frame3 {left frame center} \
    $topwin(enhan_name).info.frame3.frame0.frame4 {left frame center}

  # build widget $topwin(enhan_name).info.frame3.frame1
  frame $topwin(enhan_name).info.frame3.frame1 \
    -background "$GuiColor(frame_bg)" \
    -borderwidth {2} \
    -relief {ridge}

  # build widget $topwin(enhan_name).info.frame3.frame1.frame3
  frame $topwin(enhan_name).info.frame3.frame1.frame3 \
    -background "$GuiColor(frame_bg)" \
    -borderwidth {2}

  # build widget $topwin(enhan_name).info.frame3.frame1.frame3.radiobutton5
	radiobutton $topwin(enhan_name).info.frame3.frame1.frame3.radiobutton5 -padx {1} -pady {1} -highlightthickness {0}  \
    -background "$GuiColor(btn_bg)" \
    -activebackground "$GuiColor(btn_act_bg)" \
    -command {set enhan(sm_median) 3} \
    -relief {flat} \
    -text {Median filter } \
    -value {median_filter} \
    -variable {enhan(smooth)}

  # pack widget $topwin(enhan_name).info.frame3.frame1.frame3
  pack append $topwin(enhan_name).info.frame3.frame1.frame3 \
    $topwin(enhan_name).info.frame3.frame1.frame3.radiobutton5 {top frame center}

  # build widget $topwin(enhan_name).info.frame3.frame1.frame10
  frame $topwin(enhan_name).info.frame3.frame1.frame10 \
    -background "$GuiColor(frame_bg)" \
    -borderwidth {2}

  # build widget $topwin(enhan_name).info.frame3.frame1.frame10.frame6
  frame $topwin(enhan_name).info.frame3.frame1.frame10.frame6 \
    -background "$GuiColor(frame_bg)" \
    -borderwidth {2}

  # build widget $topwin(enhan_name).info.frame3.frame1.frame10.frame6.label7
  label $topwin(enhan_name).info.frame3.frame1.frame10.frame6.label7 \
    -background "$GuiColor(label_bg)" \
    -text {Mask size:} \
    -anchor {e} \
    -width {15}

  # build widget $topwin(enhan_name).info.frame3.frame1.frame10.frame6.entry8
  entry $topwin(enhan_name).info.frame3.frame1.frame10.frame6.entry8 \
    -background "$GuiColor(rentry_bg)" \
	 -foreground "$GuiColor(rentry_fg)" \
    -relief {sunken} \
    -state {disabled} \
    -textvariable {enhan(sm_median)} \
    -width {5}

  # build widget $topwin(enhan_name).info.frame3.frame1.frame10.frame6.label9
  menubutton $topwin(enhan_name).info.frame3.frame1.frame10.frame6.label9 \
    -background "$GuiColor(btn_bg)" \
    -activebackground "$GuiColor(btn_act_bg)" \
	 -padx {1} -pady {5} \
	 -font "$GuiMisc(pop_up_fn)" \
	 -text "$GuiMisc(pop_up_text)" \
	 -relief "$GuiMisc(pop_up_relief)" \
	 -width {2}
  # bindings
  bind $topwin(enhan_name).info.frame3.frame1.frame10.frame6.label9 <Button-1> {MenuPopupPost $topwin(enhan_name).info.frame3.frame1.frame10.frame6.label9.menu %X %Y}
  bind $topwin(enhan_name).info.frame3.frame1.frame10.frame6.label9 <ButtonRelease-1> {MenuPopupRelease $topwin(enhan_name).info.frame3.frame1.frame10.frame6.label9.menu %W}

  # build widget $topwin(enhan_name).info.frame3.frame1.frame10.frame6.label9.menu
  menu $topwin(enhan_name).info.frame3.frame1.frame10.frame6.label9.menu \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)"
  $topwin(enhan_name).info.frame3.frame1.frame10.frame6.label9.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set enhan(sm_median) 3
set enhan(smooth) median_filter
} \
    -label {3}
  $topwin(enhan_name).info.frame3.frame1.frame10.frame6.label9.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set enhan(sm_median) 5
set enhan(smooth) median_filter
} \
    -label {5}
  $topwin(enhan_name).info.frame3.frame1.frame10.frame6.label9.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set enhan(sm_median) 7
set enhan(smooth) median_filter
} \
    -label {7}
  $topwin(enhan_name).info.frame3.frame1.frame10.frame6.label9.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set enhan(sm_median) 9
set enhan(smooth) median_filter
} \
    -label {9}
  $topwin(enhan_name).info.frame3.frame1.frame10.frame6.label9.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set enhan(sm_median) 11
set enhan(smooth) median_filter
} \
    -label {11}
  bindtags $topwin(enhan_name).info.frame3.frame1.frame10.frame6.label9.menu {Menu all}
  # bindings
  bind $topwin(enhan_name).info.frame3.frame1.frame10.frame6.label9.menu <B1-Motion> {MenuPopupMotion $topwin(enhan_name).info.frame3.frame1.frame10.frame6.label9.menu %W %X %Y}
  bind $topwin(enhan_name).info.frame3.frame1.frame10.frame6.label9.menu <ButtonRelease-1> {MenuPopupRelease $topwin(enhan_name).info.frame3.frame1.frame10.frame6.label9.menu %W}

  # pack widget $topwin(enhan_name).info.frame3.frame1.frame10.frame6
  pack append $topwin(enhan_name).info.frame3.frame1.frame10.frame6 \
    $topwin(enhan_name).info.frame3.frame1.frame10.frame6.label7 {left frame center} \
    $topwin(enhan_name).info.frame3.frame1.frame10.frame6.entry8 {left frame center} \
    $topwin(enhan_name).info.frame3.frame1.frame10.frame6.label9 {left frame center}

  # pack widget $topwin(enhan_name).info.frame3.frame1.frame10
  pack append $topwin(enhan_name).info.frame3.frame1.frame10 \
    $topwin(enhan_name).info.frame3.frame1.frame10.frame6 {left frame center expand}

  # pack widget $topwin(enhan_name).info.frame3.frame1
  pack append $topwin(enhan_name).info.frame3.frame1 \
    $topwin(enhan_name).info.frame3.frame1.frame3 {left frame center} \
    $topwin(enhan_name).info.frame3.frame1.frame10 {left frame center}

  # build widget $topwin(enhan_name).info.frame3.frame2
  frame $topwin(enhan_name).info.frame3.frame2 \
    -background "$GuiColor(frame_bg)" \
    -borderwidth {2} \
    -relief {ridge}

  # build widget $topwin(enhan_name).info.frame3.frame2.frame3
  frame $topwin(enhan_name).info.frame3.frame2.frame3 \
    -background "$GuiColor(frame_bg)" \
    -borderwidth {2}

  # build widget $topwin(enhan_name).info.frame3.frame2.frame3.radiobutton5
	radiobutton $topwin(enhan_name).info.frame3.frame2.frame3.radiobutton5 -padx {1} -pady {1} -highlightthickness {0}  \
    -background "$GuiColor(btn_bg)" \
    -activebackground "$GuiColor(btn_act_bg)" \
    -command {set enhan(sm_midpt) 3} \
    -relief {flat} \
    -text {Midpoint filter} \
    -value {midpoint_filter} \
    -variable {enhan(smooth)}

  # pack widget $topwin(enhan_name).info.frame3.frame2.frame3
  pack append $topwin(enhan_name).info.frame3.frame2.frame3 \
    $topwin(enhan_name).info.frame3.frame2.frame3.radiobutton5 {top frame center}

  # build widget $topwin(enhan_name).info.frame3.frame2.frame10
  frame $topwin(enhan_name).info.frame3.frame2.frame10 \
    -background "$GuiColor(frame_bg)" \
    -borderwidth {2}

  # build widget $topwin(enhan_name).info.frame3.frame2.frame10.frame6
  frame $topwin(enhan_name).info.frame3.frame2.frame10.frame6 \
    -background "$GuiColor(frame_bg)" \
    -borderwidth {2}

  # build widget $topwin(enhan_name).info.frame3.frame2.frame10.frame6.label7
  label $topwin(enhan_name).info.frame3.frame2.frame10.frame6.label7 \
    -background "$GuiColor(label_bg)" \
    -text {Mask size:} \
    -anchor {e} \
    -width {15}

  # build widget $topwin(enhan_name).info.frame3.frame2.frame10.frame6.entry8
  entry $topwin(enhan_name).info.frame3.frame2.frame10.frame6.entry8 \
    -background "$GuiColor(rentry_bg)" \
	 -foreground "$GuiColor(rentry_fg)" \
    -relief {sunken} \
    -state {disabled} \
    -textvariable {enhan(sm_midpt)} \
    -width {5}

  # build widget $topwin(enhan_name).info.frame3.frame2.frame10.frame6.label9
  menubutton $topwin(enhan_name).info.frame3.frame2.frame10.frame6.label9 \
    -background "$GuiColor(btn_bg)" \
    -activebackground "$GuiColor(btn_act_bg)" \
	 -padx {1} -pady {5} \
	 -font "$GuiMisc(pop_up_fn)" \
	 -text "$GuiMisc(pop_up_text)" \
	 -relief "$GuiMisc(pop_up_relief)" \
	 -width {2}

  # bindings
  bind $topwin(enhan_name).info.frame3.frame2.frame10.frame6.label9 <Button-1> {MenuPopupPost $topwin(enhan_name).info.frame3.frame2.frame10.frame6.label9.menu %X %Y}
  bind $topwin(enhan_name).info.frame3.frame2.frame10.frame6.label9 <ButtonRelease-1> {MenuPopupRelease $topwin(enhan_name).info.frame3.frame2.frame10.frame6.label9.menu %W}

  # build widget $topwin(enhan_name).info.frame3.frame2.frame10.frame6.label9.menu
  menu $topwin(enhan_name).info.frame3.frame2.frame10.frame6.label9.menu \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)"
  $topwin(enhan_name).info.frame3.frame2.frame10.frame6.label9.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set enhan(sm_midpt) 3
set enhan(smooth) midpoint_filter
} \
    -label {3}
  $topwin(enhan_name).info.frame3.frame2.frame10.frame6.label9.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set enhan(sm_midpt) 5
set enhan(smooth) midpoint_filter
} \
    -label {5}
  $topwin(enhan_name).info.frame3.frame2.frame10.frame6.label9.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set enhan(sm_midpt) 7
set enhan(smooth) midpoint_filter
} \
    -label {7}
  $topwin(enhan_name).info.frame3.frame2.frame10.frame6.label9.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set enhan(sm_midpt) 9
set enhan(smooth) midpoint_filter
} \
    -label {9}
  $topwin(enhan_name).info.frame3.frame2.frame10.frame6.label9.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set enhan(sm_midpt) 11
set enhan(smooth) midpoint_filter
} \
    -label {11}
  bindtags $topwin(enhan_name).info.frame3.frame2.frame10.frame6.label9.menu {Menu all}
  # bindings
  bind $topwin(enhan_name).info.frame3.frame2.frame10.frame6.label9.menu <B1-Motion> {MenuPopupMotion $topwin(enhan_name).info.frame3.frame2.frame10.frame6.label9.menu %W %X %Y}
  bind $topwin(enhan_name).info.frame3.frame2.frame10.frame6.label9.menu <ButtonRelease-1> {MenuPopupRelease $topwin(enhan_name).info.frame3.frame2.frame10.frame6.label9.menu %W}

  # pack widget $topwin(enhan_name).info.frame3.frame2.frame10.frame6
  pack append $topwin(enhan_name).info.frame3.frame2.frame10.frame6 \
    $topwin(enhan_name).info.frame3.frame2.frame10.frame6.label7 {left frame center} \
    $topwin(enhan_name).info.frame3.frame2.frame10.frame6.entry8 {left frame center} \
    $topwin(enhan_name).info.frame3.frame2.frame10.frame6.label9 {left frame center}

  # pack widget $topwin(enhan_name).info.frame3.frame2.frame10
  pack append $topwin(enhan_name).info.frame3.frame2.frame10 \
    $topwin(enhan_name).info.frame3.frame2.frame10.frame6 {left frame center expand}

  # pack widget $topwin(enhan_name).info.frame3.frame2
  pack append $topwin(enhan_name).info.frame3.frame2 \
    $topwin(enhan_name).info.frame3.frame2.frame3 {left frame center} \
    $topwin(enhan_name).info.frame3.frame2.frame10 {left frame center}

  # build widget $topwin(enhan_name).info.frame3.frame3
  frame $topwin(enhan_name).info.frame3.frame3 \
    -background "$GuiColor(frame_bg)" \
	 -borderwidth {2} \
	 -relief {ridge}

  # build widget $topwin(enhan_name).info.frame3.frame3.radio
	radiobutton $topwin(enhan_name).info.frame3.frame3.radio -padx {1} -pady {1} -highlightthickness {0}  \
    -background "$GuiColor(btn_bg)" \
    -activebackground "$GuiColor(btn_act_bg)" \
	 -relief {flat} \
	 -text {Gaussian blur } \
	 -value {gauss_blur} \
	 -variable {enhan(smooth)}

  # build widget $topwin(enhan_name).info.frame3.frame3.frame0
  frame $topwin(enhan_name).info.frame3.frame3.frame0 \
    -background "$GuiColor(frame_bg)"

  # build widget $topwin(enhan_name).info.frame3.frame3.frame0.label1
  label $topwin(enhan_name).info.frame3.frame3.frame0.label1 \
    -anchor {e} \
    -background "$GuiColor(label_bg)" \
    -borderwidth {0} \
    -text {Mask size:} \
    -width {15}

  # build widget $topwin(enhan_name).info.frame3.frame3.frame0.value
  entry $topwin(enhan_name).info.frame3.frame3.frame0.value \
    -background "$GuiColor(entry_bg)" \
	 -foreground "$GuiColor(entry_fg)" \
    -relief {sunken} \
    -textvariable {enhan(sm_gauss)} \
    -width {5}
   endEntry $topwin(enhan_name).info.frame3.frame3.frame0.value 0
	$topwin(enhan_name).info.frame3.frame3.frame0.value configure -state disabled -foreground blue

  # build widget $topwin(enhan_name).info.frame3.frame3.frame0.menubutton2
	menubutton $topwin(enhan_name).info.frame3.frame3.frame0.menubutton2 -padx {1} -pady {5} -highlightthickness {0}  \
    -background "$GuiColor(btn_bg)" \
    -activebackground "$GuiColor(btn_act_bg)" \
	 -font "$GuiMisc(pop_up_fn)" \
	 -text "$GuiMisc(pop_up_text)" \
	 -relief "$GuiMisc(pop_up_relief)" \
	 -width {2}
  # bindings
  bind $topwin(enhan_name).info.frame3.frame3.frame0.menubutton2 <Button-1> {MenuPopupPost $topwin(enhan_name).info.frame3.frame3.frame0.menubutton2.menu %X %Y}
  bind $topwin(enhan_name).info.frame3.frame3.frame0.menubutton2 <ButtonRelease-1> {MenuPopupRelease $topwin(enhan_name).info.frame3.frame3.frame0.menubutton2.menu %W}

  # build widget $topwin(enhan_name).info.frame3.frame3.frame0.menubutton2.menu
  menu $topwin(enhan_name).info.frame3.frame3.frame0.menubutton2.menu \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)"
  $topwin(enhan_name).info.frame3.frame3.frame0.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set enhan(sm_gauss) 3} \
    -label { 3}
  $topwin(enhan_name).info.frame3.frame3.frame0.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set enhan(sm_gauss) 5} \
    -label { 5}
  $topwin(enhan_name).info.frame3.frame3.frame0.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set enhan(sm_gauss) 7} \
    -label { 7}

  bindtags $topwin(enhan_name).info.frame3.frame3.frame0.menubutton2.menu {Menu all}
  # bindings
  bind $topwin(enhan_name).info.frame3.frame3.frame0.menubutton2.menu <B1-Motion> {MenuPopupMotion $topwin(enhan_name).info.frame3.frame3.frame0.menubutton2.menu %W %X %Y}
  bind $topwin(enhan_name).info.frame3.frame3.frame0.menubutton2.menu <ButtonRelease-1> {MenuPopupRelease $topwin(enhan_name).info.frame3.frame3.frame0.menubutton2.menu %W}

  # pack widget $topwin(enhan_name).info.frame3.frame3.frame0
  pack append $topwin(enhan_name).info.frame3.frame3.frame0 \
    $topwin(enhan_name).info.frame3.frame3.frame0.label1 {left frame center fill} \
    $topwin(enhan_name).info.frame3.frame3.frame0.value {left frame center fill} \
    $topwin(enhan_name).info.frame3.frame3.frame0.menubutton2 {right frame center fill}

  # pack widget $topwin(enhan_name).info.frame3.frame3
  pack append $topwin(enhan_name).info.frame3.frame3 \
    $topwin(enhan_name).info.frame3.frame3.radio {left frame center padx 4}\
    $topwin(enhan_name).info.frame3.frame3.frame0 {left frame center }

  # build widget $topwin(enhan_name).info.frame3.label5
  label $topwin(enhan_name).info.frame3.label5 \
    -background "$GuiColor(label_bg)" \
    -text {Spatial domain smoothing}

  # build widget $topwin(enhan_name).info.frame3.frame6
  frame $topwin(enhan_name).info.frame3.frame6 \
    -background "$GuiColor(frame_bg)" \
    -borderwidth {2} \
    -relief {ridge}

  # build widget $topwin(enhan_name).info.frame3.frame6.frame3
  frame $topwin(enhan_name).info.frame3.frame6.frame3 \
    -background "$GuiColor(frame_bg)" \
    -borderwidth {2}

  # build widget $topwin(enhan_name).info.frame3.frame6.frame3.radiobutton5
	radiobutton $topwin(enhan_name).info.frame3.frame6.frame3.radiobutton5 -padx {1} -pady {1} -highlightthickness {0}  \
    -background "$GuiColor(btn_bg)" \
    -activebackground "$GuiColor(btn_act_bg)" \
    -relief {flat} \
    -text {Contra-harmonic filter} \
    -value {contra_filter} \
    -variable {enhan(smooth)}

  # build widget $topwin(enhan_name).info.frame3.frame6.frame3.radiobutton7
	radiobutton $topwin(enhan_name).info.frame3.frame6.frame3.radiobutton7 -padx {1} -pady {1} -highlightthickness {0}  \
    -background "$GuiColor(btn_bg)" \
    -activebackground "$GuiColor(btn_act_bg)" \
    -relief {flat} \
    -text {Ypmean filter} \
    -value {ypmean_filter} \
    -variable {enhan(smooth)}

  # pack widget $topwin(enhan_name).info.frame3.frame6.frame3
  pack append $topwin(enhan_name).info.frame3.frame6.frame3 \
    $topwin(enhan_name).info.frame3.frame6.frame3.radiobutton5 {top frame w} \
    $topwin(enhan_name).info.frame3.frame6.frame3.radiobutton7 {top frame w}

  # build widget $topwin(enhan_name).info.frame3.frame6.frame10
  frame $topwin(enhan_name).info.frame3.frame6.frame10 \
    -background "$GuiColor(frame_bg)" \
    -borderwidth {2}

  # build widget $topwin(enhan_name).info.frame3.frame6.frame10.frame6
  frame $topwin(enhan_name).info.frame3.frame6.frame10.frame6 \
    -background "$GuiColor(frame_bg)" \
    -borderwidth {2}

  # build widget $topwin(enhan_name).info.frame3.frame6.frame10.frame6.label7
  label $topwin(enhan_name).info.frame3.frame6.frame10.frame6.label7 \
    -background "$GuiColor(label_bg)" \
    -text {Mask size:} \
    -anchor {e} \
    -width {15}

  # build widget $topwin(enhan_name).info.frame3.frame6.frame10.frame6.entry8
  entry $topwin(enhan_name).info.frame3.frame6.frame10.frame6.entry8 \
    -background "$GuiColor(rentry_bg)" \
	 -foreground "$GuiColor(rentry_fg)" \
    -relief {sunken} \
    -state {disabled} \
    -textvariable {enhan(sm_contraYp)} \
    -width {6}

  # build widget $topwin(enhan_name).info.frame3.frame6.frame10.frame6.label9
  menubutton $topwin(enhan_name).info.frame3.frame6.frame10.frame6.label9 \
    -background "$GuiColor(btn_bg)" \
    -activebackground "$GuiColor(btn_act_bg)" \
	 -padx {1} -pady {5} \
	 -font "$GuiMisc(pop_up_fn)" \
	 -text "$GuiMisc(pop_up_text)" \
	 -relief "$GuiMisc(pop_up_relief)" \
	 -width {2}
  # bindings
  bind $topwin(enhan_name).info.frame3.frame6.frame10.frame6.label9 <Button-1> {MenuPopupPost $topwin(enhan_name).info.frame3.frame6.frame10.frame6.label9.menu %X %Y}
  bind $topwin(enhan_name).info.frame3.frame6.frame10.frame6.label9 <ButtonRelease-1> {MenuPopupRelease $topwin(enhan_name).info.frame3.frame6.frame10.frame6.label9.menu %W}

  # build widget $topwin(enhan_name).info.frame3.frame6.frame10.frame6.label9.menu
  menu $topwin(enhan_name).info.frame3.frame6.frame10.frame6.label9.menu \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)"
  $topwin(enhan_name).info.frame3.frame6.frame10.frame6.label9.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set enhan(sm_contraYp) 3
if {$enhan(smooth) != "ypmean_filter"} {set enhan(smooth) contra_filter}

} \
    -label {3}
  $topwin(enhan_name).info.frame3.frame6.frame10.frame6.label9.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set enhan(sm_contraYp) 5
if {$enhan(smooth) != "ypmean_filter"} {set enhan(smooth) contra_filter}

} \
    -label {5}
  $topwin(enhan_name).info.frame3.frame6.frame10.frame6.label9.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set enhan(sm_contraYp) 7
if {$enhan(smooth) != "ypmean_filter"} {set enhan(smooth) contra_filter}

} \
    -label {7}
  $topwin(enhan_name).info.frame3.frame6.frame10.frame6.label9.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set enhan(sm_contraYp) 9
if {$enhan(smooth) != "ypmean_filter"} {set enhan(smooth) contra_filter}

} \
    -label {9}
  $topwin(enhan_name).info.frame3.frame6.frame10.frame6.label9.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set enhan(sm_contraYp) 11
if {$enhan(smooth) != "ypmean_filter"} {set enhan(smooth) contra_filter}

} \
    -label {11}
  # bindings
  bind $topwin(enhan_name).info.frame3.frame6.frame10.frame6.label9.menu <B1-Motion> {MenuPopupMotion $topwin(enhan_name).info.frame3.frame6.frame10.frame6.label9.menu %W %X %Y}
  bind $topwin(enhan_name).info.frame3.frame6.frame10.frame6.label9.menu <ButtonRelease-1> {MenuPopupRelease $topwin(enhan_name).info.frame3.frame6.frame10.frame6.label9.menu %W}

  # pack widget $topwin(enhan_name).info.frame3.frame6.frame10.frame6
  pack append $topwin(enhan_name).info.frame3.frame6.frame10.frame6 \
    $topwin(enhan_name).info.frame3.frame6.frame10.frame6.label7 {left frame center} \
    $topwin(enhan_name).info.frame3.frame6.frame10.frame6.entry8 {left frame center} \
    $topwin(enhan_name).info.frame3.frame6.frame10.frame6.label9 {left frame center}

  # build widget $topwin(enhan_name).info.frame3.frame6.frame10.frame8
  frame $topwin(enhan_name).info.frame3.frame6.frame10.frame8 \
    -background "$GuiColor(frame_bg)" \
    -borderwidth {2}

  # build widget $topwin(enhan_name).info.frame3.frame6.frame10.frame8.label7
  label $topwin(enhan_name).info.frame3.frame6.frame10.frame8.label7 \
    -background "$GuiColor(label_bg)" \
    -text {Order:  }

  # build widget $topwin(enhan_name).info.frame3.frame6.frame10.frame8.entry8
  entry $topwin(enhan_name).info.frame3.frame6.frame10.frame8.entry8 \
    -background "$GuiColor(rentry_bg)" \
	 -foreground "$GuiColor(rentry_fg)" \
    -relief {sunken} \
    -state {disabled} \
    -textvariable {enhan(sm_contraYp_order)} \
    -width {4}

  # build widget $topwin(enhan_name).info.frame3.frame6.frame10.frame8.label9
  menubutton $topwin(enhan_name).info.frame3.frame6.frame10.frame8.label9 \
    -background "$GuiColor(btn_bg)" \
    -activebackground "$GuiColor(btn_act_bg)" \
	 -padx {1} -pady {5} \
	 -font "$GuiMisc(pop_up_fn)" \
	 -text "$GuiMisc(pop_up_text)" \
	 -relief "$GuiMisc(pop_up_relief)" \
	 -width {2}
  # bindings
  bind $topwin(enhan_name).info.frame3.frame6.frame10.frame8.label9 <Button-1> {MenuPopupPost $topwin(enhan_name).info.frame3.frame6.frame10.frame8.label9.menu %X %Y}
  bind $topwin(enhan_name).info.frame3.frame6.frame10.frame8.label9 <ButtonRelease-1> {MenuPopupRelease $topwin(enhan_name).info.frame3.frame6.frame10.frame8.label9.menu %W}

  # build widget $topwin(enhan_name).info.frame3.frame6.frame10.frame8.label9.menu
  menu $topwin(enhan_name).info.frame3.frame6.frame10.frame8.label9.menu \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)"
  $topwin(enhan_name).info.frame3.frame6.frame10.frame8.label9.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set enhan(sm_contraYp_order) 1
} \
    -label {+1}
  $topwin(enhan_name).info.frame3.frame6.frame10.frame8.label9.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set enhan(sm_contraYp_order) 2
} \
    -label {+2}
  $topwin(enhan_name).info.frame3.frame6.frame10.frame8.label9.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set enhan(sm_contraYp_order) 3
} \
    -label {+3}
  $topwin(enhan_name).info.frame3.frame6.frame10.frame8.label9.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set enhan(sm_contraYp_order) 4
} \
    -label {+4}
  $topwin(enhan_name).info.frame3.frame6.frame10.frame8.label9.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set enhan(sm_contraYp_order) 5
} \
    -label {+5}
  bindtags $topwin(enhan_name).info.frame3.frame6.frame10.frame8.label9.menu {Menu all}
  # bindings
  bind $topwin(enhan_name).info.frame3.frame6.frame10.frame8.label9.menu <B1-Motion> {MenuPopupMotion $topwin(enhan_name).info.frame3.frame6.frame10.frame8.label9.menu %W %X %Y}
  bind $topwin(enhan_name).info.frame3.frame6.frame10.frame8.label9.menu <ButtonRelease-1> {MenuPopupRelease $topwin(enhan_name).info.frame3.frame6.frame10.frame8.label9.menu %W}

  # pack widget $topwin(enhan_name).info.frame3.frame6.frame10.frame8
  pack append $topwin(enhan_name).info.frame3.frame6.frame10.frame8 \
    $topwin(enhan_name).info.frame3.frame6.frame10.frame8.label7 {left frame center} \
    $topwin(enhan_name).info.frame3.frame6.frame10.frame8.entry8 {left frame center} \
    $topwin(enhan_name).info.frame3.frame6.frame10.frame8.label9 {left frame center}

  # pack widget $topwin(enhan_name).info.frame3.frame6.frame10
  pack append $topwin(enhan_name).info.frame3.frame6.frame10 \
    $topwin(enhan_name).info.frame3.frame6.frame10.frame6 {left frame center expand} \
    $topwin(enhan_name).info.frame3.frame6.frame10.frame8 {left frame center expand}

  # pack widget $topwin(enhan_name).info.frame3.frame6
  pack append $topwin(enhan_name).info.frame3.frame6 \
    $topwin(enhan_name).info.frame3.frame6.frame3 {left frame center} \
    $topwin(enhan_name).info.frame3.frame6.frame10 {left frame center}

  # pack widget $topwin(enhan_name).info.frame3
  pack append $topwin(enhan_name).info.frame3 \
    $topwin(enhan_name).info.frame3.label5 {top frame w} \
    $topwin(enhan_name).info.frame3.frame0 {top frame center expand fill} \
    $topwin(enhan_name).info.frame3.frame1 {top frame center expand fill} \
    $topwin(enhan_name).info.frame3.frame2 {top frame center expand fill} \
    $topwin(enhan_name).info.frame3.frame3 {top frame center expand fill} \
    $topwin(enhan_name).info.frame3.frame6 {top frame center expand fill}

  # build widget $topwin(enhan_name).info.frame9
  frame $topwin(enhan_name).info.frame9 \
    -background "$GuiColor(frame_bg)" \
    -borderwidth {3} \
    -relief {ridge}

  # build widget $topwin(enhan_name).info.frame9.label5
  label $topwin(enhan_name).info.frame9.label5 \
    -background "$GuiColor(label_bg)" \
    -text {Frequency domain smoothing}

  # build widget $topwin(enhan_name).info.frame9.frame6
  frame $topwin(enhan_name).info.frame9.frame6 \
    -background "$GuiColor(frame_bg)" \
    -borderwidth {2} \
    -relief {ridge}

  # build widget $topwin(enhan_name).info.frame9.frame6.frame3
  frame $topwin(enhan_name).info.frame9.frame6.frame3 \
    -background "$GuiColor(frame_bg)" \
    -borderwidth {2}

  # build widget $topwin(enhan_name).info.frame9.frame6.frame3.radiobutton7
	radiobutton $topwin(enhan_name).info.frame9.frame6.frame3.radiobutton7 -padx {1} -pady {1} -highlightthickness {0}  \
    -background "$GuiColor(btn_bg)" \
    -activebackground "$GuiColor(btn_act_bg)" \
    -relief {flat} \
    -text {FFT smoothing} \
	 -command {
		if ![catch {expr $cols + $rows} ] {
			set temp1 [expr { $rows < $cols} ? $cols : $rows ]
			set temp1 [expr int(pow(2, ceil(log($temp1) / log(2.0))))]
			set enhan(sm_fft_blk) $temp1	
		}
		} \
    -value {fft} \
    -variable {enhan(smooth)}

  # pack widget $topwin(enhan_name).info.frame9.frame6.frame3
  pack append $topwin(enhan_name).info.frame9.frame6.frame3 \
    $topwin(enhan_name).info.frame9.frame6.frame3.radiobutton7 {top frame w}

  # build widget $topwin(enhan_name).info.frame9.frame6.frame6
  frame $topwin(enhan_name).info.frame9.frame6.frame6 \
    -background "$GuiColor(frame_bg)" \
    -borderwidth {2}

  # build widget $topwin(enhan_name).info.frame9.frame6.frame6.label7
  label $topwin(enhan_name).info.frame9.frame6.frame6.label7 \
    -background "$GuiColor(label_bg)" \
    -text {Cutoff frequency:}

  # build widget $topwin(enhan_name).info.frame9.frame6.frame6.entry8
  entry $topwin(enhan_name).info.frame9.frame6.frame6.entry8 \
    -background "$GuiColor(entry_bg)" \
	 -foreground "$GuiColor(entry_fg)" \
    -relief {sunken} \
    -textvariable {enhan(sm_cutfft)} \
    -width {5}
  endEntry $topwin(enhan_name).info.frame9.frame6.frame6.entry8 

  # pack widget $topwin(enhan_name).info.frame9.frame6.frame6
  pack append $topwin(enhan_name).info.frame9.frame6.frame6 \
    $topwin(enhan_name).info.frame9.frame6.frame6.label7 {left frame center} \
    $topwin(enhan_name).info.frame9.frame6.frame6.entry8 {left frame center}

  # build widget $topwin(enhan_name).info.frame9.frame6.frame2
  frame $topwin(enhan_name).info.frame9.frame6.frame2 \
    -background "$GuiColor(frame_bg)" \
    -borderwidth {2}

  # build widget $topwin(enhan_name).info.frame9.frame6.frame2.label3
  label $topwin(enhan_name).info.frame9.frame6.frame2.label3 \
    -background "$GuiColor(label_bg)" \
    -text {with Butterworth order 1 lowpass}

  # build widget $topwin(enhan_name).info.frame9.frame6.frame2.label4
  label $topwin(enhan_name).info.frame9.frame6.frame2.label4 \
    -background "$GuiColor(label_bg)" \
    -text {filter, blocksize = }

  # build widget $topwin(enhan_name).info.frame9.frame6.frame2.label5
  label $topwin(enhan_name).info.frame9.frame6.frame2.label5 \
    -background "$GuiColor(label_bg)" \
    -text {} \
    -textvariable {enhan(sm_fft_blk)}

  # pack widget $topwin(enhan_name).info.frame9.frame6.frame2
  pack append $topwin(enhan_name).info.frame9.frame6.frame2 \
    $topwin(enhan_name).info.frame9.frame6.frame2.label3 {top frame w} \
    $topwin(enhan_name).info.frame9.frame6.frame2.label4 {left frame w} \
    $topwin(enhan_name).info.frame9.frame6.frame2.label5 {left frame w}

  # pack widget $topwin(enhan_name).info.frame9.frame6
  pack append $topwin(enhan_name).info.frame9.frame6 \
    $topwin(enhan_name).info.frame9.frame6.frame3 {left frame center} \
    $topwin(enhan_name).info.frame9.frame6.frame6 {left frame center} \
    $topwin(enhan_name).info.frame9.frame6.frame2 {left frame center expand fill}

  # build widget $topwin(enhan_name).info.frame9.frame10
  frame $topwin(enhan_name).info.frame9.frame10 \
    -background "$GuiColor(frame_bg)" \
    -borderwidth {2} \
    -relief {ridge}

  # build widget $topwin(enhan_name).info.frame9.frame10.frame3
  frame $topwin(enhan_name).info.frame9.frame10.frame3 \
    -background "$GuiColor(frame_bg)" \
    -borderwidth {2}

  # build widget $topwin(enhan_name).info.frame9.frame10.frame3.radiobutton7
	radiobutton $topwin(enhan_name).info.frame9.frame10.frame3.radiobutton7 -padx {1} -pady {1} -highlightthickness {0}  \
    -background "$GuiColor(btn_bg)" \
    -activebackground "$GuiColor(btn_act_bg)" \
    -relief {flat} \
    -text {DCT smoothing} \
	 -command {
		if ![catch {expr $cols + $rows} ] {
			set temp1 [expr { $rows < $cols} ? $cols : $rows ]
			set temp1 [expr int(pow(2, ceil(log($temp1) / log(2.0))))]
			set enhan(sm_dct_blk) $temp1	
		}
		} \
    -value {dct} \
    -variable {enhan(smooth)}

  # pack widget $topwin(enhan_name).info.frame9.frame10.frame3
  pack append $topwin(enhan_name).info.frame9.frame10.frame3 \
    $topwin(enhan_name).info.frame9.frame10.frame3.radiobutton7 {top frame w}

  # build widget $topwin(enhan_name).info.frame9.frame10.frame6
  frame $topwin(enhan_name).info.frame9.frame10.frame6 \
    -background "$GuiColor(frame_bg)" \
    -borderwidth {2}

  # build widget $topwin(enhan_name).info.frame9.frame10.frame6.label7
  label $topwin(enhan_name).info.frame9.frame10.frame6.label7 \
    -background "$GuiColor(label_bg)" \
    -text {Cutoff frequency:}

  # build widget $topwin(enhan_name).info.frame9.frame10.frame6.entry8
  entry $topwin(enhan_name).info.frame9.frame10.frame6.entry8 \
    -background "$GuiColor(entry_bg)" \
	 -foreground "$GuiColor(entry_fg)" \
    -relief {sunken} \
    -textvariable {enhan(sm_cutdct)} \
    -width {5}
  endEntry $topwin(enhan_name).info.frame9.frame10.frame6.entry8 

  # pack widget $topwin(enhan_name).info.frame9.frame10.frame6
  pack append $topwin(enhan_name).info.frame9.frame10.frame6 \
    $topwin(enhan_name).info.frame9.frame10.frame6.label7 {left frame center} \
    $topwin(enhan_name).info.frame9.frame10.frame6.entry8 {left frame center}

  # build widget $topwin(enhan_name).info.frame9.frame10.frame2
  frame $topwin(enhan_name).info.frame9.frame10.frame2 \
    -background "$GuiColor(frame_bg)" \
    -borderwidth {2}

  # build widget $topwin(enhan_name).info.frame9.frame10.frame2.label3
  label $topwin(enhan_name).info.frame9.frame10.frame2.label3 \
    -background "$GuiColor(label_bg)" \
    -text {with Butterworth order 1 lowpass}

  # build widget $topwin(enhan_name).info.frame9.frame10.frame2.label4
  label $topwin(enhan_name).info.frame9.frame10.frame2.label4 \
    -background "$GuiColor(label_bg)" \
    -text {filter, blocksize = }

  # build widget $topwin(enhan_name).info.frame9.frame10.frame2.label5
  label $topwin(enhan_name).info.frame9.frame10.frame2.label5 \
    -background "$GuiColor(label_bg)" \
    -text {} \
    -textvariable {enhan(sm_dct_blk)}

  # pack widget $topwin(enhan_name).info.frame9.frame10.frame2
  pack append $topwin(enhan_name).info.frame9.frame10.frame2 \
    $topwin(enhan_name).info.frame9.frame10.frame2.label3 {top frame w} \
    $topwin(enhan_name).info.frame9.frame10.frame2.label4 {left frame w} \
    $topwin(enhan_name).info.frame9.frame10.frame2.label5 {left frame w}

  # pack widget $topwin(enhan_name).info.frame9.frame10
  pack append $topwin(enhan_name).info.frame9.frame10 \
    $topwin(enhan_name).info.frame9.frame10.frame3 {left frame center} \
    $topwin(enhan_name).info.frame9.frame10.frame6 {left frame center} \
    $topwin(enhan_name).info.frame9.frame10.frame2 {left frame center expand fill}

  # pack widget $topwin(enhan_name).info.frame9
  pack append $topwin(enhan_name).info.frame9 \
    $topwin(enhan_name).info.frame9.label5 {top frame w} \
    $topwin(enhan_name).info.frame9.frame6 {top frame center expand fill} \
    $topwin(enhan_name).info.frame9.frame10 {top frame center expand fill}

  # pack widget $topwin(enhan_name).info
  pack append $topwin(enhan_name).info \
    $topwin(enhan_name).info.frame3 {top frame center expand fill} \
    $topwin(enhan_name).info.frame9 {top frame center expand fill}

  # build widget $topwin(enhan_name).current_image
  frame $topwin(enhan_name).current_image \
    -background "$GuiColor(frame_bg)" \
    -borderwidth {2} \
    -relief {ridge}

  # build widget $topwin(enhan_name).current_image.label0
  label $topwin(enhan_name).current_image.label0 \
    -background "$GuiColor(label_bg)" \
    -text {Current image: }

  # build widget $topwin(enhan_name).current_image.label1
  label $topwin(enhan_name).current_image.label1 \
    -background "$GuiColor(label_bg)" \
    -foreground {Blue} \
    -text {} \
    -textvariable {current_image}

  # pack widget $topwin(enhan_name).current_image
  pack append $topwin(enhan_name).current_image \
    $topwin(enhan_name).current_image.label0 {left frame center} \
    $topwin(enhan_name).current_image.label1 {left frame center}

  # build widget $topwin(enhan_name).perform
  frame $topwin(enhan_name).perform \
    -background "$GuiColor(frame_bg)" \
    -borderwidth {2} \
    -relief {raised}

  # build widget $topwin(enhan_name).perform.button2
	button $topwin(enhan_name).perform.button2 -padx {1} -pady {1} -highlightthickness {0}  \
    -foreground "$GuiColor(dis_fg)" \
    -background "$GuiColor(dis_bg)" \
    -activebackground "$GuiColor(dis_act_bg)" \
    -command "destroy $topwin(enhan_name)" \
    -text {DISMISS}

  # build widget $topwin(enhan_name).perform.button3
	button $topwin(enhan_name).perform.button3 -padx {1} -pady {1} -highlightthickness {0}  \
    -foreground "$GuiColor(perf_fg)" \
    -background "$GuiColor(perf_bg)" \
    -activebackground "$GuiColor(perf_act_bg)" \
    -text {PERFORM} \
    -command {
      $topwin(enhan_name) configure -cursor watch; update
      if {$current_image == ""} {
         CvipAlert "Please select an image first."
         $topwin(enhan_name) configure -cursor top_left_arrow; update
         return
      }

		switch -exact  -- $enhan(smooth) {
			mean_filter -
			median_filter -
			gauss_blur -
			midpoint_filter {
				if { $enhan(smooth) == "mean_filter" } {
					set temp $enhan(sm_mean)
					set temp1 mean
					set temp2 "mean filter"
				} elseif { $enhan(smooth) == "median_filter" } {
					set temp $enhan(sm_median)
					set temp1 median
					set temp2 "median filter"
				} elseif { $enhan(smooth) == "gauss_blur" } {
					set temp $enhan(sm_gauss)
					set temp1 gauss_blur
					set temp2 "Gaussian blur"
				} else {
					set temp $enhan(sm_midpt)
					set temp1 midpoint
					set temp2 "mid-point filter"
				}
				if [catch {set result [cvip $enhan(smooth) $current_image $temp]} cresult ] {
		         CvipAlert "$cresult"
					$topwin(enhan_name) configure -cursor top_left_arrow; update
					return
      		}
		      set new_name [cvip rename $result ${current_image}_${temp1}$temp]
		      img_q insert end $new_name
		      image_post $new_name
				cvip view $new_name
				if { $GUI_DEBUG == "1" } {
					puts stderr "cvip $enhan(smooth) $current_image $temp"
				}
				CvipMessage "$temp2 performed on image \"$current_image\""	
			}

			contra_filter -
			ypmean_filter {
				if [catch {set result [cvip $enhan(smooth) $current_image \
					$enhan(sm_contraYp) $enhan(sm_contraYp_order)]} cresult ] {
		         CvipAlert "$cresult"
					$topwin(enhan_name) configure -cursor top_left_arrow; update
					return
      		}
		      set new_name [cvip rename $result ${current_image}_$enhan(smooth)]
		      img_q insert end $new_name
		      image_post $new_name
				cvip view $new_name
				if { $GUI_DEBUG == "1" } {
					puts "cvip $enhan(smooth) $current_image $enhan(sm_contraYp) $enhan(sm_contraYp_order)"
				}
				if { $enhan(smooth) == "contra_filter" } {
					CvipMessage "contra-harmonic filter performed on image \"$current_image\""	
				} else {
					CvipMessage "Ypmean filter performed on image \"$current_image\""	
				}
			}

			fft -
			dct {
				set temp1 [expr { $rows < $cols} ? $cols : $rows ]
				set temp1 [expr int(pow(2, ceil(log($temp1) / log(2.0))))]
				if { $enhan(smooth) == "fft" } {
					set temp fft
					set temp2 $enhan(sm_cutfft)
					set temp3 [expr $temp1]
				} else {
					set temp dct
					set temp2 $enhan(sm_cutdct)
					set temp3 [expr $temp1]
				}

				if [catch {expr $temp2} ] {
		         CvipAlert "Numerical value required for the cutoff frequency ($temp2)"
					$topwin(enhan_name) configure -cursor top_left_arrow; update
					return
				} elseif { $temp2 < 1 || $temp2 > $temp3 } {
		         CvipAlert "The block size ($temp2) should be in the range (1 - $temp3)." 
					$topwin(enhan_name) configure -cursor top_left_arrow; update
					return
				}

				if [catch {
					set temp [cvip $enhan(smooth) $current_image 1 $temp1]
					if { $GUI_DEBUG == "1" } {
						puts stderr "cvip $enhan(smooth) $current_image 1 $temp1"
					}
					set temp1 [cvip lpf_filter $temp y BUTTER_LOW $temp2 1]
					if { $GUI_DEBUG == "1" } {
						puts stderr "cvip lpf_filter $temp y BUTTER_LOW $temp2 1"
					}
					cvip dq $temp
					set result [cvip $enhan(smooth) $temp1 0 -1]
					if { $GUI_DEBUG == "1" } {
						puts stderr "cvip $enhan(smooth) $temp1 0 -1"
					}
					cvip dq $temp1
				} cresult ] {
		         CvipAlert "$cresult"
					$topwin(enhan_name) configure -cursor top_left_arrow; update
					return
				}
		      set new_name [cvip rename $result ${current_image}_$enhan(smooth)_smooth]
		      img_q insert end $new_name
		      image_post $new_name
				cvip view $new_name
				unset temp2; unset temp3
				if { $enhan(smooth) == "fft" } {
					CvipMessage "fft smoothing performed on image \"$current_image\""	
				} else {
					CvipMessage "dct smoothing performed on image \"$current_image\""	
				}
			}

		}
		$topwin(enhan_name) configure -cursor top_left_arrow; update
	 }

  # pack widget $topwin(enhan_name).perform
  pack append $topwin(enhan_name).perform \
    $topwin(enhan_name).perform.button2 {left frame center} \
    $topwin(enhan_name).perform.button3 {right frame center}

  # pack widget $topwin(enhan_name).
  pack append $topwin(enhan_name) \
    $topwin(enhan_name).info {top frame center expand fill} \
    $topwin(enhan_name).current_image {top frame center fillx} \
    $topwin(enhan_name).perform {bottom frame center fillx}

  if {"[info procs XFEdit]" != ""} {
    catch "XFMiscBindWidgetTree $topwin(enhan_name)."
    after 2 "catch {XFEditSetShowWindows}"
  }
}

