# **********************************************************************
# Computer Vision/Image Processing Tool Project - Dr. Scott Umbaugh SIUE
# **********************************************************************
#
#             File Name: restore_geom.tcl
#           Description: 
#         Related Files: 
#   Initial Coding Date: Sun Sep 29 19:43:42 CDT 1996
#           Portability: TCL script file
#            References:
#             Author(s): Mark Zuke and Yansheng Wei
#                        Southern Illinois University @ Edwardsville
#
## Copyright (C) 1996 SIUE - by Scott Umbaugh, Mark Zuke and Yansheng Wei.
##
## Permission to use, copy, modify, and distribute this software and its
## documentation for any purpose and without fee is hereby granted, provided
## that the above copyright notice appear in all copies and that both that
## copyright notice and this permission notice appear in supporting
## documentation.  This software is provided "as is" without express or
## implied warranty.
##
# RCS (Revision Control System) Information
# ...Added automatically by RCS 
#
## $Log: restore_geom.tcl,v $
## Revision 1.8  1997/07/02 17:47:17  yawei
## configuration finished
##
## Revision 1.7  1997/03/27 01:59:13  yawei
## GUI ==> CVIPTCL/GUI_SCRIPTS
##
## Revision 1.6  1997/03/12 00:45:43  yawei
## Added "env" as the globals
##
## Revision 1.5  1997/03/11 20:56:32  yawei
## Tcl/Tk script upgrading from tcl7.3/tk3.6 to tcl7.6/tk4.2
## compatible. This process is automated with tkboost perl
## script. @ Tue Mar 11 14:51:36 CST 1997
##
## Revision 1.4  1996/10/16 15:43:34  mzuke
## moved view image commands after image_post to correct
## names on resultant images; installed watch cursor
##
# Revision 1.3  1996/10/01  22:06:39  mzuke
# sine mesh now automatically applied to current image
#
# Revision 1.2  1996/09/30  13:18:00  mzuke
# added warped images to image queue; reset SET button activebackground
# to gray70 as needed; eliminated auto erasure of mesh file name
# when it is a duplicate name; added requirement that new meshes
# be square if not a sine mesh
#
# Revision 1.1  1996/09/30  00:45:06  yawei
# Initial revision
#
#
#****************************************************************************
proc restore_geom { } {# xf ignore me 7

  # Window manager configurations
  global {env}
  global tk_version
  global alertBox
  global {topwin}
  global {GuiColor}
  global {GuiMisc}
  global {GUI_DEBUG}
  global toplevel_position

  if [ winfo exists  $topwin(restore_name).info] {
     set tempname $topwin(restore_name);\
destroy $topwin(restore_name).info;\
set topwin(restore_name) $tempname;}
  if [ winfo exists  $topwin(restore_name).current_image] {
     set tempname $topwin(restore_name);\
destroy $topwin(restore_name).current_image;\
set topwin(restore_name) $tempname;}
  if [ winfo exists  $topwin(restore_name).perform] {
     set tempname $topwin(restore_name);\
destroy $topwin(restore_name).perform;\
set topwin(restore_name) $tempname;}
  wm positionfrom  $topwin(restore_name) user
  wm sizefrom  $topwin(restore_name) user
  wm geometry $topwin(restore_name) $topwin(restore_geometry)[get_pos $topwin(restore_name)]
  wm maxsize $topwin(restore_name) [lindex $topwin(restore_geometry_max) 0] \
  	[lindex $topwin(restore_geometry_max) 1]
  wm minsize $topwin(restore_name) [lindex $topwin(restore_geometry_min) 0] \
  	[lindex $topwin(restore_geometry_min) 1]
  wm title $topwin(restore_name) {RESTORATION->Geometric transforms}

  bind $topwin(restore_name) <Destroy> {set topwin(restore_name) NONE}
 
  # build widget $topwin(restore_name).info
  frame $topwin(restore_name).info \
    -background "$GuiColor(frame_bg)" \
    -borderwidth {2}

  # build widget $topwin(restore_name).info.frame0
  frame $topwin(restore_name).info.frame0 \
    -background "$GuiColor(frame_bg)" \
    -borderwidth {2} \
    -relief {ridge}

  # build widget $topwin(restore_name).info.frame0.frame22
  frame $topwin(restore_name).info.frame0.frame22 \
    -background "$GuiColor(frame_bg)" \
    -borderwidth {2}

  # build widget $topwin(restore_name).info.frame0.frame22.frame23
  frame $topwin(restore_name).info.frame0.frame22.frame23 \
    -background "$GuiColor(frame_bg)" \
    -borderwidth {2}

  # build widget $topwin(restore_name).info.frame0.frame22.frame23.radiobutton25
	radiobutton $topwin(restore_name).info.frame0.frame22.frame23.radiobutton25 -padx {1} -pady {1} -highlightthickness {0}  \
    -activebackground "$GuiColor(btn_act_bg)" \
    -background "$GuiColor(btn_bg)" \
    -command {pack forget $topwin(restore_name).info.frame0.frame30.frame36.frame21
pack forget $topwin(restore_name).info.frame1.frame43.frame31
} \
    -relief {flat} \
    -text {Use an existing mesh file} \
    -value {existing} \
    -variable {restore(mesh_select)}

  # build widget $topwin(restore_name).info.frame0.frame22.frame23.radiobutton26
	radiobutton $topwin(restore_name).info.frame0.frame22.frame23.radiobutton26 -padx {1} -pady {1} -highlightthickness {0}  \
    -activebackground "$GuiColor(btn_act_bg)" \
    -background "$GuiColor(btn_bg)" \
    -command {pack $topwin(restore_name).info.frame0.frame30.frame36.frame21
pack $topwin(restore_name).info.frame1.frame43.frame31
set restore(mesh_points) "9"
set restore(current_point) "1"
set restore(mesh_r) 3
set restore(mesh_c) 3
pack forget $topwin(restore_name).info.frame1.frame43.frame31.frame8.frame0.frame37
set step1_mesh 0
$topwin(restore_name).info.frame1.frame43.frame31.frame8.frame0.frame40.button35   configure -activebackground gray70 -bg #ffff80 -state normal


} \
    -relief {flat} \
    -text {Enter a new mesh file} \
    -value {enter_new} \
    -variable {restore(mesh_select)}

  # build widget $topwin(restore_name).info.frame0.frame22.frame23.radiobutton27
	radiobutton $topwin(restore_name).info.frame0.frame22.frame23.radiobutton27 -padx {1} -pady {1} -highlightthickness {0}  \
    -activebackground "$GuiColor(btn_act_bg)" \
    -background "$GuiColor(btn_bg)" \
    -command {pack $topwin(restore_name).info.frame0.frame30.frame36.frame21
pack forget $topwin(restore_name).info.frame1.frame43.frame31
pack forget $topwin(restore_name).info.frame0.frame30.frame36.frame21.checkbutton20
} \
    -relief {flat} \
    -text {Create a sine mesh} \
    -value {sine_mesh} \
    -variable {restore(mesh_select)}

  # pack widget $topwin(restore_name).info.frame0.frame22.frame23
  pack append $topwin(restore_name).info.frame0.frame22.frame23 \
    $topwin(restore_name).info.frame0.frame22.frame23.radiobutton26 {left frame center expand} \
    $topwin(restore_name).info.frame0.frame22.frame23.radiobutton25 {left frame center expand} \
    $topwin(restore_name).info.frame0.frame22.frame23.radiobutton27 {left frame center expand}

  # build widget $topwin(restore_name).info.frame0.frame22.frame24
  frame $topwin(restore_name).info.frame0.frame22.frame24 \
    -background "$GuiColor(frame_bg)" \
    -borderwidth {2}

  # build widget $topwin(restore_name).info.frame0.frame22.frame24.label28
  label $topwin(restore_name).info.frame0.frame22.frame24.label28 \
    -background "$GuiColor(label_bg)" \
    -text {Mesh file name: }

  # build widget $topwin(restore_name).info.frame0.frame22.frame24.entry29
  entry $topwin(restore_name).info.frame0.frame22.frame24.entry29 \
    -background "$GuiColor(entry_bg)" \
    -foreground "$GuiColor(entry_fg)" \
    -relief {sunken} \
    -textvariable {restore(mesh_file)} \
    -width {45}
  # bindings
  bind $topwin(restore_name).info.frame0.frame22.frame24.entry29 <Key-Return> { 
	if {$restore(mesh_select) != "existing" && [file exists $restore(mesh_file)]} {
		AlertBox "The filename you have chosen already exists. Please select a different name" "" "350x150" "ALERT!" DISMISS
focus $topwin(restore_name).info.frame0.frame22.frame24.entry29
return
	}
	if {$restore(mesh_select) == "existing" && ![file exists $restore(mesh_file)]} {
		AlertBox "The filename you have entered does not exists. Please enter the name of an existing mesh file." "" "350x150" "ALERT!" DISMISS
focus $topwin(restore_name).info.frame0.frame22.frame24.entry29
return
	}
focus $topwin(restore_name).info.frame0.frame30.frame36.frame21.entry10 }

  # build widget $topwin(restore_name).info.frame0.frame22.frame24.button0
	button $topwin(restore_name).info.frame0.frame22.frame24.button0 -padx {1} -pady {1} -highlightthickness {0}  \
    -activebackground "$GuiColor(btn_act_bg)" \
    -background "$GuiColor(btn_bg)" \
    -command {set restore(mesh_file) ""} \
    -text {Clear file name}

  # pack widget $topwin(restore_name).info.frame0.frame22.frame24
  pack append $topwin(restore_name).info.frame0.frame22.frame24 \
    $topwin(restore_name).info.frame0.frame22.frame24.label28 {left frame w} \
    $topwin(restore_name).info.frame0.frame22.frame24.entry29 {left frame w} \
    $topwin(restore_name).info.frame0.frame22.frame24.button0 {left frame center padx 10}

  # pack widget $topwin(restore_name).info.frame0.frame22
  pack append $topwin(restore_name).info.frame0.frame22 \
    $topwin(restore_name).info.frame0.frame22.frame23 {top frame center fillx} \
    $topwin(restore_name).info.frame0.frame22.frame24 {top frame center fillx}

  # build widget $topwin(restore_name).info.frame0.frame30
  frame $topwin(restore_name).info.frame0.frame30 \
    -background "$GuiColor(frame_bg)" \
    -borderwidth {2}

  # build widget $topwin(restore_name).info.frame0.frame30.frame36
  frame $topwin(restore_name).info.frame0.frame30.frame36 \
    -background "$GuiColor(frame_bg)" \
    -borderwidth {2}

  # build widget $topwin(restore_name).info.frame0.frame30.frame36.frame21
  frame $topwin(restore_name).info.frame0.frame30.frame36.frame21 \
    -background "$GuiColor(frame_bg)" \
    -borderwidth {2}

  # build widget $topwin(restore_name).info.frame0.frame30.frame36.frame21.label9
  label $topwin(restore_name).info.frame0.frame30.frame36.frame21.label9 \
    -background "$GuiColor(label_bg)" \
    -text {Select number of rows: }

  # build widget $topwin(restore_name).info.frame0.frame30.frame36.frame21.entry10
  entry $topwin(restore_name).info.frame0.frame30.frame36.frame21.entry10 \
    -background "$GuiColor(entry_bg)" \
    -foreground "$GuiColor(entry_fg)" \
    -relief {sunken} \
    -textvariable {restore(mesh_r)} \
    -width {5}
  # bindings
  bind $topwin(restore_name).info.frame0.frame30.frame36.frame21.entry10 <Key-Return> {if {$restore(mesh_select)!="enter_new"} {set restore(mesh_c) $restore(mesh_r)}; set restore(mesh_points) [expr $restore(mesh_r)*$restore(mesh_c)]; focus $topwin(restore_name).info.frame0.frame30.frame36.frame21.entry13}

  # build widget $topwin(restore_name).info.frame0.frame30.frame36.frame21.label11
  menubutton $topwin(restore_name).info.frame0.frame30.frame36.frame21.label11 \
    -activebackground "$GuiColor(btn_act_bg)" \
    -background "$GuiColor(btn_bg)" \
    -font "$GuiMisc(pop_up_fn)" \
    -relief "$GuiMisc(pop_up_relief)" \
    -text "$GuiMisc(pop_up_text)" \
    -width {2}
  # bindings
  bind $topwin(restore_name).info.frame0.frame30.frame36.frame21.label11 <Button-1> {MenuPopupPost $topwin(restore_name).info.frame0.frame30.frame36.frame21.label11.menu %X %Y}
  bind $topwin(restore_name).info.frame0.frame30.frame36.frame21.label11 <ButtonRelease-1> {MenuPopupRelease $topwin(restore_name).info.frame0.frame30.frame36.frame21.label11.menu %W}

  # build widget $topwin(restore_name).info.frame0.frame30.frame36.frame21.label11.menu
  menu $topwin(restore_name).info.frame0.frame30.frame36.frame21.label11.menu \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)"
  $topwin(restore_name).info.frame0.frame30.frame36.frame21.label11.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -command {if {$restore(mesh_select)!="enter_new"} {
set restore(mesh_r) 3
set restore(mesh_c) 3
set restore(mesh_points) [expr $restore(mesh_r)*$restore(mesh_c)]
	      } else {
set restore(mesh_r) 3
set restore(mesh_points) [expr $restore(mesh_r)*$restore(mesh_c)]}} \
    -label {3}
  $topwin(restore_name).info.frame0.frame30.frame36.frame21.label11.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -command {if {$restore(mesh_select)!="enter_new"} {
set restore(mesh_r) 4
set restore(mesh_c) 4
set restore(mesh_points) [expr $restore(mesh_r)*$restore(mesh_c)]
	      } else {
set restore(mesh_r) 4
set restore(mesh_points) [expr $restore(mesh_r)*$restore(mesh_c)]}} \
    -label {4}
  $topwin(restore_name).info.frame0.frame30.frame36.frame21.label11.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -command {if {$restore(mesh_select)!="enter_new"} {
set restore(mesh_r) 5
set restore(mesh_c) 5
set restore(mesh_points) [expr $restore(mesh_r)*$restore(mesh_c)]
	      } else {
set restore(mesh_r) 5
set restore(mesh_points) [expr $restore(mesh_r)*$restore(mesh_c)]}} \
    -label {5}
  $topwin(restore_name).info.frame0.frame30.frame36.frame21.label11.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -command {if {$restore(mesh_select)!="enter_new"} {
set restore(mesh_r) 6
set restore(mesh_c) 6
set restore(mesh_points) [expr $restore(mesh_r)*$restore(mesh_c)]
	      } else {
set restore(mesh_r) 6
set restore(mesh_points) [expr $restore(mesh_r)*$restore(mesh_c)]}} \
    -label {6}
  $topwin(restore_name).info.frame0.frame30.frame36.frame21.label11.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -command {if {$restore(mesh_select)!="enter_new"} {
set restore(mesh_r) 7
set restore(mesh_c) 7
set restore(mesh_points) [expr $restore(mesh_r)*$restore(mesh_c)]
	      } else {
set restore(mesh_r) 7
set restore(mesh_points) [expr $restore(mesh_r)*$restore(mesh_c)]}} \
    -label {7}
  # bindings
  bind $topwin(restore_name).info.frame0.frame30.frame36.frame21.label11.menu <B1-Motion> {MenuPopupMotion $topwin(restore_name).info.frame0.frame30.frame36.frame21.label11.menu0 %W %X %Y}
  bind $topwin(restore_name).info.frame0.frame30.frame36.frame21.label11.menu <ButtonRelease-1> {MenuPopupRelease $topwin(restore_name).info.frame0.frame30.frame36.frame21.label11.menu0 %W}

  # build widget $topwin(restore_name).info.frame0.frame30.frame36.frame21.label12
  label $topwin(restore_name).info.frame0.frame30.frame36.frame21.label12 \
    -background "$GuiColor(label_bg)" \
    -text {and columns:}

  # build widget $topwin(restore_name).info.frame0.frame30.frame36.frame21.entry13
  entry $topwin(restore_name).info.frame0.frame30.frame36.frame21.entry13 \
    -background "$GuiColor(entry_bg)" \
    -foreground "$GuiColor(entry_fg)" \
    -relief {sunken} \
    -textvariable {restore(mesh_c)} \
    -width {5}
  # bindings
  bind $topwin(restore_name).info.frame0.frame30.frame36.frame21.entry13 <Key-Return> {if {$restore(mesh_select)!="enter_new"} {set restore(mesh_r) $restore(mesh_c)}; set restore(mesh_points) [expr $restore(mesh_r)*$restore(mesh_c)]; focus $topwin(restore_name).info.frame1.frame43.frame31.frame8.frame0.frame40.entry10; set restore(current_point 1}

  # build widget $topwin(restore_name).info.frame0.frame30.frame36.frame21.label14
  menubutton $topwin(restore_name).info.frame0.frame30.frame36.frame21.label14 \
    -activebackground "$GuiColor(btn_act_bg)" \
    -background "$GuiColor(btn_bg)" \
    -font "$GuiMisc(pop_up_fn)" \
    -relief "$GuiMisc(pop_up_relief)" \
    -text "$GuiMisc(pop_up_text)" \
    -width {2}
  # bindings
  bind $topwin(restore_name).info.frame0.frame30.frame36.frame21.label14 <Button-1> {MenuPopupPost $topwin(restore_name).info.frame0.frame30.frame36.frame21.label14.menu %X %Y}
  bind $topwin(restore_name).info.frame0.frame30.frame36.frame21.label14 <ButtonRelease-1> {MenuPopupRelease $topwin(restore_name).info.frame0.frame30.frame36.frame21.label14.menu %W}

  # build widget $topwin(restore_name).info.frame0.frame30.frame36.frame21.label14.menu
  menu $topwin(restore_name).info.frame0.frame30.frame36.frame21.label14.menu \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)"
  $topwin(restore_name).info.frame0.frame30.frame36.frame21.label14.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -command {if {$restore(mesh_select)!="enter_new"} {
set restore(mesh_r) 3
set restore(mesh_c) 3
set restore(mesh_points) [expr $restore(mesh_r)*$restore(mesh_c)]
	      } else {
set restore(mesh_c) 3
set restore(mesh_points) [expr $restore(mesh_r)*$restore(mesh_c)]}} \
    -label {3}
  $topwin(restore_name).info.frame0.frame30.frame36.frame21.label14.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -command {if {$restore(mesh_select)!="enter_new"} {
set restore(mesh_r) 4
set restore(mesh_c) 4
set restore(mesh_points) [expr $restore(mesh_r)*$restore(mesh_c)]
	      } else {
set restore(mesh_c) 4
set restore(mesh_points) [expr $restore(mesh_r)*$restore(mesh_c)]}} \
    -label {4}
  $topwin(restore_name).info.frame0.frame30.frame36.frame21.label14.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -command {if {$restore(mesh_select)!="enter_new"} {
set restore(mesh_r) 5
set restore(mesh_c) 5
set restore(mesh_points) [expr $restore(mesh_r)*$restore(mesh_c)]
	      } else {
set restore(mesh_c) 5
set restore(mesh_points) [expr $restore(mesh_r)*$restore(mesh_c)]}} \
    -label {5}
  $topwin(restore_name).info.frame0.frame30.frame36.frame21.label14.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -command {if {$restore(mesh_select)!="enter_new"} {
set restore(mesh_r) 6
set restore(mesh_c) 6
set restore(mesh_points) [expr $restore(mesh_r)*$restore(mesh_c)]
	      } else {
set restore(mesh_c) 6
set restore(mesh_points) [expr $restore(mesh_r)*$restore(mesh_c)]}} \
    -label {6}
  $topwin(restore_name).info.frame0.frame30.frame36.frame21.label14.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -command {if {$restore(mesh_select)!="enter_new"} {
set restore(mesh_r) 7
set restore(mesh_c) 7
set restore(mesh_points) [expr $restore(mesh_r)*$restore(mesh_c)]
	      } else {
set restore(mesh_c) 7
set restore(mesh_points) [expr $restore(mesh_r)*$restore(mesh_c)]}} \
    -label {7}
  # bindings
  bind $topwin(restore_name).info.frame0.frame30.frame36.frame21.label14.menu <B1-Motion> {MenuPopupMotion $topwin(restore_name).info.frame0.frame30.frame36.frame21.label14.menu0 %W %X %Y}
  bind $topwin(restore_name).info.frame0.frame30.frame36.frame21.label14.menu <ButtonRelease-1> {MenuPopupRelease $topwin(restore_name).info.frame0.frame30.frame36.frame21.label14.menu0 %W}

  # build widget $topwin(restore_name).info.frame0.frame30.frame36.frame21.label15
  label $topwin(restore_name).info.frame0.frame30.frame36.frame21.label15 \
    -background "$GuiColor(label_bg)" \
    -text {of mesh points.}

  # pack widget $topwin(restore_name).info.frame0.frame30.frame36.frame21
  pack append $topwin(restore_name).info.frame0.frame30.frame36.frame21 \
    $topwin(restore_name).info.frame0.frame30.frame36.frame21.label9 {left frame w} \
    $topwin(restore_name).info.frame0.frame30.frame36.frame21.entry10 {left frame w} \
    $topwin(restore_name).info.frame0.frame30.frame36.frame21.label11 {left frame w} \
    $topwin(restore_name).info.frame0.frame30.frame36.frame21.label12 {left frame w} \
    $topwin(restore_name).info.frame0.frame30.frame36.frame21.entry13 {left frame w} \
    $topwin(restore_name).info.frame0.frame30.frame36.frame21.label14 {left frame w} \
    $topwin(restore_name).info.frame0.frame30.frame36.frame21.label15 {left frame w}

  # pack widget $topwin(restore_name).info.frame0.frame30.frame36
  pack append $topwin(restore_name).info.frame0.frame30.frame36 \
    $topwin(restore_name).info.frame0.frame30.frame36.frame21 {top frame center}

  # pack widget $topwin(restore_name).info.frame0.frame30
  pack append $topwin(restore_name).info.frame0.frame30 \
    $topwin(restore_name).info.frame0.frame30.frame36 {left frame w}

  # pack widget $topwin(restore_name).info.frame0
  pack append $topwin(restore_name).info.frame0 \
    $topwin(restore_name).info.frame0.frame22 {top frame center fillx} \
    $topwin(restore_name).info.frame0.frame30 {top frame center fillx}

  # build widget $topwin(restore_name).info.frame1
  frame $topwin(restore_name).info.frame1 \
    -background "$GuiColor(frame_bg)" \
    -borderwidth {2} \
    -relief {ridge}

  # build widget $topwin(restore_name).info.frame1.frame43
  frame $topwin(restore_name).info.frame1.frame43 \
    -background "$GuiColor(frame_bg)" \
    -borderwidth {2}

  # build widget $topwin(restore_name).info.frame1.frame43.frame31
  frame $topwin(restore_name).info.frame1.frame43.frame31 \
    -background "$GuiColor(frame_bg)" \
    -borderwidth {2}

  # build widget $topwin(restore_name).info.frame1.frame43.frame31.frame6
  frame $topwin(restore_name).info.frame1.frame43.frame31.frame6 \
    -background "$GuiColor(frame_bg)" \
    -borderwidth {2}

  # build widget $topwin(restore_name).info.frame1.frame43.frame31.frame6.label4
  label $topwin(restore_name).info.frame1.frame43.frame31.frame6.label4 \
    -background "$GuiColor(label_bg)" \
    -borderwidth {0} \
    -foreground {blue} \
    -text {Example: enter 9 mesh points in order shown.} \
    -width {40}

  # build widget $topwin(restore_name).info.frame1.frame43.frame31.frame6.label3
  label $topwin(restore_name).info.frame1.frame43.frame31.frame6.label3 \
    -background "$GuiColor(label_bg)" \
    -bitmap "@$env(CVIPHOME)/CVIPTCL/GUI_SCRIPTS/bmp/mesh_icon3.bmp" \
    -borderwidth {0} \
    -foreground {blue} \
    -height {100} \
    -text {label3}

  # pack widget $topwin(restore_name).info.frame1.frame43.frame31.frame6
  pack append $topwin(restore_name).info.frame1.frame43.frame31.frame6 \
    $topwin(restore_name).info.frame1.frame43.frame31.frame6.label4 {left frame center} \
    $topwin(restore_name).info.frame1.frame43.frame31.frame6.label3 {left frame w}

  # build widget $topwin(restore_name).info.frame1.frame43.frame31.frame7
  frame $topwin(restore_name).info.frame1.frame43.frame31.frame7 \
    -background "$GuiColor(frame_bg)" \
    -borderwidth {2}

  # build widget $topwin(restore_name).info.frame1.frame43.frame31.frame7.label16
  label $topwin(restore_name).info.frame1.frame43.frame31.frame7.label16 \
    -background "$GuiColor(label_bg)" \
    -text {You have }

  # build widget $topwin(restore_name).info.frame1.frame43.frame31.frame7.label17
  label $topwin(restore_name).info.frame1.frame43.frame31.frame7.label17 \
    -background "$GuiColor(label_bg)" \
    -text {9} \
    -textvariable {restore(mesh_points)} \
    -width {2}

  # build widget $topwin(restore_name).info.frame1.frame43.frame31.frame7.label18
  label $topwin(restore_name).info.frame1.frame43.frame31.frame7.label18 \
    -background "$GuiColor(label_bg)" \
    -text {mesh point(s) to enter.}

  # pack widget $topwin(restore_name).info.frame1.frame43.frame31.frame7
  pack append $topwin(restore_name).info.frame1.frame43.frame31.frame7 \
    $topwin(restore_name).info.frame1.frame43.frame31.frame7.label16 {left frame w} \
    $topwin(restore_name).info.frame1.frame43.frame31.frame7.label17 {left frame w} \
    $topwin(restore_name).info.frame1.frame43.frame31.frame7.label18 {left frame center}

  # build widget $topwin(restore_name).info.frame1.frame43.frame31.frame8
  frame $topwin(restore_name).info.frame1.frame43.frame31.frame8 \
    -background "$GuiColor(frame_bg)" \
    -borderwidth {2}

  # build widget $topwin(restore_name).info.frame1.frame43.frame31.frame8.frame0
  frame $topwin(restore_name).info.frame1.frame43.frame31.frame8.frame0 \
    -background "$GuiColor(frame_bg)" \
    -borderwidth {2}

  # build widget $topwin(restore_name).info.frame1.frame43.frame31.frame8.frame0.frame37
  frame $topwin(restore_name).info.frame1.frame43.frame31.frame8.frame0.frame37 \
    -background "$GuiColor(frame_bg)" \
    -borderwidth {2}

  # build widget $topwin(restore_name).info.frame1.frame43.frame31.frame8.frame0.frame37.button39
	button $topwin(restore_name).info.frame1.frame43.frame31.frame8.frame0.frame37.button39 -padx {1} -pady {1} -highlightthickness {0}  \
    -activebackground {gray70} \
    -background {#ffff80} \
    -command {pack forget $topwin(restore_name).info.frame1.frame43.frame31.frame8.frame0.frame37
set restore(mesh_points) [expr $restore(mesh_r)*$restore(mesh_c)]
set restore(current_point) 1
$topwin(restore_name).info.frame1.frame43.frame31.frame8.frame0.frame40.button35   configure -activebackground gray70 -bg #ffff80 -state normal
catch {exec rm $restore(mesh_file)} cresult

} \
    -text {REDO MESH}

  # pack widget $topwin(restore_name).info.frame1.frame43.frame31.frame8.frame0.frame37
  pack append $topwin(restore_name).info.frame1.frame43.frame31.frame8.frame0.frame37 \
    $topwin(restore_name).info.frame1.frame43.frame31.frame8.frame0.frame37.button39 {left frame center}

  # build widget $topwin(restore_name).info.frame1.frame43.frame31.frame8.frame0.frame40
  frame $topwin(restore_name).info.frame1.frame43.frame31.frame8.frame0.frame40 \
    -background "$GuiColor(frame_bg)" \
    -borderwidth {2}

  # build widget $topwin(restore_name).info.frame1.frame43.frame31.frame8.frame0.frame40.label9
  label $topwin(restore_name).info.frame1.frame43.frame31.frame8.frame0.frame40.label9 \
    -background "$GuiColor(label_bg)" \
    -text {: Set row: }

  # build widget $topwin(restore_name).info.frame1.frame43.frame31.frame8.frame0.frame40.entry10
  entry $topwin(restore_name).info.frame1.frame43.frame31.frame8.frame0.frame40.entry10 \
    -background "$GuiColor(entry_bg)" \
    -foreground "$GuiColor(entry_fg)" \
    -relief {sunken} \
    -textvariable {restore(mesh_point_r)} \
    -width {5}
  # bindings
  bind $topwin(restore_name).info.frame1.frame43.frame31.frame8.frame0.frame40.entry10 <Key-Return> { focus $topwin(restore_name).info.frame1.frame43.frame31.frame8.frame0.frame40.entry0 }

  # build widget $topwin(restore_name).info.frame1.frame43.frame31.frame8.frame0.frame40.label12
  label $topwin(restore_name).info.frame1.frame43.frame31.frame8.frame0.frame40.label12 \
    -background "$GuiColor(label_bg)" \
    -text {and column:}

  # build widget $topwin(restore_name).info.frame1.frame43.frame31.frame8.frame0.frame40.button35
	button $topwin(restore_name).info.frame1.frame43.frame31.frame8.frame0.frame40.button35 -padx {1} -pady {1} -highlightthickness {0}  \
    -activebackground {gray70} \
    -background {#ffff80} \
    -command {
	if {$current_image == ""} {
		CvipAlert "Please select an image."
		return
	}

	if {$restore(mesh_file) == ""} {
		CvipAlert "Please provide a mesh file name."
		return
	}

	if {$restore(mesh_r) != $restore(mesh_c)} {AlertBox "Only square meshes are supported for non-sine meshes at this time. Please set the number of rows of mesh points equal to the number of columns of mesh points." "" 350x170 "ALERT!" DISMISS
		return}

	catch {set coordinate_info [selection get]
	scan $coordinate_info {%s %s %d %d %d %d} cname null2 row_coord col_coord d_row d_col} cresult

	if {$restore(mesh_point_r) == "" || $restore(mesh_point_c) == ""} {
		if  {$row_coord == ""} {
			CvipAlert "Both row and column must be filled in. Select a point  with the mouse or  enter values from the keyboard." "" "350x150" "ALERT!" DISMISS
			return
		}
	}



	if {$row_coord != "" } { 
		if {[string compare $row_coord $old_mouse_row] != 0} {
			set restoreRow($restore(current_point)) $row_coord
			set restore(mesh_point_r) $row_coord
			set old_mouse_row $row_coord
		} else {
			set restoreRow($restore(current_point)) $restore(mesh_point_r)
		}

		if {[string compare $col_coord $old_mouse_col] != 0} {
			set restoreCol($restore(current_point)) $col_coord
			set restore(mesh_point_c) $col_coord
			set old_mouse_col $col_coord
		}  else {
			set restoreCol($restore(current_point)) $restore(mesh_point_c)
				}

			
	} else {
		set restoreRow($restore(current_point)) $restore(mesh_point_r)
		set restoreCol($restore(current_point)) $restore(mesh_point_c)
	}


		
		incr restore(mesh_points) -1
		incr restore(current_point)
		if {$restore(mesh_points) <= 0} {
			$topwin(restore_name).info.frame1.frame43.frame31.frame8.frame0.frame40.button35 configure -bg red -activebackground red -state disabled
			set restore(current_point) "X"
			set restore(mesh_points) no
			pack $topwin(restore_name).info.frame1.frame43.frame31.frame8.frame0.frame37
	set tempC " "
	for {set i 1} {$i < [expr $restore(mesh_r)*$restore(mesh_c)+1]} {incr i} {set tempC [append tempC " " $restoreCol($i)] }
        set tempC [append tempC " "]
	set tempR " "
	for {set i 1} {$i < [expr $restore(mesh_r)*$restore(mesh_c)+1]} {incr i} {set tempR [append tempR " " $restoreRow($i)] }
        set tempR [append tempR " "]
	set cmd [list cvip keyboard_mesh $restore(mesh_file) $restore(mesh_c) $restore(mesh_r) $tempC $tempR]	
	eval $cmd  
	unset tempC
	unset tempR 
		}

	      } \
    -foreground {black} \
    -text {SET}


  # build widget $topwin(restore_name).info.frame1.frame43.frame31.frame8.frame0.frame40.label41
  label $topwin(restore_name).info.frame1.frame43.frame31.frame8.frame0.frame40.label41 \
    -background "$GuiColor(label_bg)" \
    -text {For point}

  # build widget $topwin(restore_name).info.frame1.frame43.frame31.frame8.frame0.frame40.label42
  label $topwin(restore_name).info.frame1.frame43.frame31.frame8.frame0.frame40.label42 \
    -background "$GuiColor(label_bg)" \
    -text {1} \
    -textvariable {restore(current_point)} \
    -width {2}

  # build widget $topwin(restore_name).info.frame1.frame43.frame31.frame8.frame0.frame40.entry0
  entry $topwin(restore_name).info.frame1.frame43.frame31.frame8.frame0.frame40.entry0 \
    -background "$GuiColor(entry_bg)" \
    -foreground "$GuiColor(entry_fg)" \
    -relief {sunken} \
    -textvariable {restore(mesh_point_c)} \
    -width {5}
  # bindings
  bind $topwin(restore_name).info.frame1.frame43.frame31.frame8.frame0.frame40.entry0 <Key-Return> {focus $topwin(restore_name).info.frame1.frame43.frame31.frame8.frame0.frame40.entry10 }

  # pack widget $topwin(restore_name).info.frame1.frame43.frame31.frame8.frame0.frame40
  pack append $topwin(restore_name).info.frame1.frame43.frame31.frame8.frame0.frame40 \
    $topwin(restore_name).info.frame1.frame43.frame31.frame8.frame0.frame40.label41 {left frame center} \
    $topwin(restore_name).info.frame1.frame43.frame31.frame8.frame0.frame40.label42 {left frame center} \
    $topwin(restore_name).info.frame1.frame43.frame31.frame8.frame0.frame40.label9 {left frame w} \
    $topwin(restore_name).info.frame1.frame43.frame31.frame8.frame0.frame40.entry10 {left frame center} \
    $topwin(restore_name).info.frame1.frame43.frame31.frame8.frame0.frame40.label12 {left frame center} \
    $topwin(restore_name).info.frame1.frame43.frame31.frame8.frame0.frame40.entry0 {left frame center} \
    $topwin(restore_name).info.frame1.frame43.frame31.frame8.frame0.frame40.button35 {left frame center padx 20}

  # pack widget $topwin(restore_name).info.frame1.frame43.frame31.frame8.frame0
  pack append $topwin(restore_name).info.frame1.frame43.frame31.frame8.frame0 \
    $topwin(restore_name).info.frame1.frame43.frame31.frame8.frame0.frame40 {left frame w}

  # pack widget $topwin(restore_name).info.frame1.frame43.frame31.frame8
  pack append $topwin(restore_name).info.frame1.frame43.frame31.frame8 \
    $topwin(restore_name).info.frame1.frame43.frame31.frame8.frame0 {top frame center fillx}

  # pack widget $topwin(restore_name).info.frame1.frame43.frame31
  pack append $topwin(restore_name).info.frame1.frame43.frame31 \
    $topwin(restore_name).info.frame1.frame43.frame31.frame7 {top frame center fillx} \
    $topwin(restore_name).info.frame1.frame43.frame31.frame8 {top frame center fillx} \
    $topwin(restore_name).info.frame1.frame43.frame31.frame6 {top frame center fillx}

  # pack widget $topwin(restore_name).info.frame1.frame43
  pack append $topwin(restore_name).info.frame1.frame43 \
    $topwin(restore_name).info.frame1.frame43.frame31 {top frame center}

  # pack widget $topwin(restore_name).info.frame1
  pack append $topwin(restore_name).info.frame1 \
    $topwin(restore_name).info.frame1.frame43 {left frame center fillx}

  # build widget $topwin(restore_name).info.frame2
  frame $topwin(restore_name).info.frame2 \
    -background "$GuiColor(frame_bg)" \
    -borderwidth {2} \
    -relief {ridge}

  # build widget $topwin(restore_name).info.frame2.frame44
  frame $topwin(restore_name).info.frame2.frame44 \
    -background "$GuiColor(frame_bg)" \
    -borderwidth {2}

  # build widget $topwin(restore_name).info.frame2.frame44.frame3
  frame $topwin(restore_name).info.frame2.frame44.frame3 \
    -background "$GuiColor(frame_bg)" \
    -borderwidth {2}

  # build widget $topwin(restore_name).info.frame2.frame44.frame3.label12
  label $topwin(restore_name).info.frame2.frame44.frame3.label12 \
    -background "$GuiColor(label_bg)" \
    -text {Direction: }

  # build widget $topwin(restore_name).info.frame2.frame44.frame3.entry10
  entry $topwin(restore_name).info.frame2.frame44.frame3.entry10 \
    -background "$GuiColor(rentry_bg)" \
    -foreground "$GuiColor(rentry_fg)" \
    -relief {sunken} \
    -textvariable {restore(mesh_direct)} \
    -width {18}

  # build widget $topwin(restore_name).info.frame2.frame44.frame3.label11
  menubutton $topwin(restore_name).info.frame2.frame44.frame3.label11 \
    -activebackground "$GuiColor(btn_act_bg)" \
    -background "$GuiColor(btn_bg)" \
    -font "$GuiMisc(pop_up_fn)" \
    -relief "$GuiMisc(pop_up_relief)" \
    -text "$GuiMisc(pop_up_text)" \
    -width {2}
  # bindings
  bind $topwin(restore_name).info.frame2.frame44.frame3.label11 <Button-1> {MenuPopupPost $topwin(restore_name).info.frame2.frame44.frame3.label11.menu %X %Y}
  bind $topwin(restore_name).info.frame2.frame44.frame3.label11 <ButtonRelease-1> {MenuPopupRelease $topwin(restore_name).info.frame2.frame44.frame3.label11.menu %W}

  # build widget $topwin(restore_name).info.frame2.frame44.frame3.label11.menu
  menu $topwin(restore_name).info.frame2.frame44.frame3.label11.menu \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)"
  $topwin(restore_name).info.frame2.frame44.frame3.label11.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -command {set restore(mesh_direct) " irregular -> regular"
	set restore(direction) 1} \
    -label {irregular->regular}
  $topwin(restore_name).info.frame2.frame44.frame3.label11.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -command {set restore(mesh_direct) " regular -> irregular"
set restore(direction) 2} \
    -label {regular->irregular}
  # bindings
  bind $topwin(restore_name).info.frame2.frame44.frame3.label11.menu <B1-Motion> {MenuPopupMotion $topwin(restore_name).info.frame2.frame44.frame3.label11.menu0 %W %X %Y}
  bind $topwin(restore_name).info.frame2.frame44.frame3.label11.menu <ButtonRelease-1> {MenuPopupRelease $topwin(restore_name).info.frame2.frame44.frame3.label11.menu0 %W}

  # pack widget $topwin(restore_name).info.frame2.frame44.frame3
  pack append $topwin(restore_name).info.frame2.frame44.frame3 \
    $topwin(restore_name).info.frame2.frame44.frame3.label12 {left frame center} \
    $topwin(restore_name).info.frame2.frame44.frame3.entry10 {left frame center} \
    $topwin(restore_name).info.frame2.frame44.frame3.label11 {left frame center}

  # build widget $topwin(restore_name).info.frame2.frame44.frame8
  frame $topwin(restore_name).info.frame2.frame44.frame8 \
    -background "$GuiColor(frame_bg)" \
    -borderwidth {2}

  # build widget $topwin(restore_name).info.frame2.frame44.frame8.label12
  label $topwin(restore_name).info.frame2.frame44.frame8.label12 \
    -background "$GuiColor(label_bg)" \
    -text {Gray value interpolation method:}

  # build widget $topwin(restore_name).info.frame2.frame44.frame8.entry10
  entry $topwin(restore_name).info.frame2.frame44.frame8.entry10 \
    -background "$GuiColor(rentry_bg)" \
    -foreground "$GuiColor(rentry_fg)" \
    -relief {sunken} \
    -textvariable {restore(mesh_interp)} \
    -width {18}

  # build widget $topwin(restore_name).info.frame2.frame44.frame8.label11
  menubutton $topwin(restore_name).info.frame2.frame44.frame8.label11 \
    -activebackground "$GuiColor(btn_act_bg)" \
    -background "$GuiColor(btn_bg)" \
    -font "$GuiMisc(pop_up_fn)" \
    -relief "$GuiMisc(pop_up_relief)" \
    -text "$GuiMisc(pop_up_text)" \
    -width {2}
  # bindings
  bind $topwin(restore_name).info.frame2.frame44.frame8.label11 <Button-1> {MenuPopupPost $topwin(restore_name).info.frame2.frame44.frame8.label11.menu %X %Y}
  bind $topwin(restore_name).info.frame2.frame44.frame8.label11 <ButtonRelease-1> {MenuPopupRelease $topwin(restore_name).info.frame2.frame44.frame8.label11.menu %W}

  # build widget $topwin(restore_name).info.frame2.frame44.frame8.label11.menu
  menu $topwin(restore_name).info.frame2.frame44.frame8.label11.menu \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)"
  $topwin(restore_name).info.frame2.frame44.frame8.label11.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -command {set restore(mesh_interp) " nearest neighbor"
set restore(mesh_interpolate) 1} \
    -label {nearest neighbor (quick)}
  $topwin(restore_name).info.frame2.frame44.frame8.label11.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -command {set restore(mesh_interp) " bilinear interpolation"
set restore(mesh_interpolate) 2
} \
    -label {bilinear interpolation (slow)}
  $topwin(restore_name).info.frame2.frame44.frame8.label11.menu add command \
    -command {set restore(mesh_interp) " neighbor average"
set restore(mesh_interpolate) 3} \
    -label {neighbor average (medium)}
  # bindings
  bind $topwin(restore_name).info.frame2.frame44.frame8.label11.menu <B1-Motion> {MenuPopupMotion $topwin(restore_name).info.frame2.frame44.frame8.label11.menu0 %W %X %Y}
  bind $topwin(restore_name).info.frame2.frame44.frame8.label11.menu <ButtonRelease-1> {MenuPopupRelease $topwin(restore_name).info.frame2.frame44.frame8.label11.menu0 %W}

  # pack widget $topwin(restore_name).info.frame2.frame44.frame8
  pack append $topwin(restore_name).info.frame2.frame44.frame8 \
    $topwin(restore_name).info.frame2.frame44.frame8.label12 {left frame center} \
    $topwin(restore_name).info.frame2.frame44.frame8.entry10 {left frame center} \
    $topwin(restore_name).info.frame2.frame44.frame8.label11 {left frame center}

  # pack widget $topwin(restore_name).info.frame2.frame44
  pack append $topwin(restore_name).info.frame2.frame44 \
    $topwin(restore_name).info.frame2.frame44.frame3 {left frame center} \
    $topwin(restore_name).info.frame2.frame44.frame8 {left frame center}

  # pack widget $topwin(restore_name).info.frame2
  pack append $topwin(restore_name).info.frame2 \
    $topwin(restore_name).info.frame2.frame44 {left frame center expand fill}

  # pack widget $topwin(restore_name).info
  pack append $topwin(restore_name).info \
    $topwin(restore_name).info.frame0 {top frame center expand fill} \
    $topwin(restore_name).info.frame1 {top frame center expand fill} \
    $topwin(restore_name).info.frame2 {bottom frame center fillx}

  # build widget $topwin(restore_name).current_image
  frame $topwin(restore_name).current_image \
    -background "$GuiColor(frame_bg)" \
    -borderwidth {2} \
    -relief {ridge}

  # build widget $topwin(restore_name).current_image.label0
  label $topwin(restore_name).current_image.label0 \
    -background "$GuiColor(label_bg)" \
    -text {Current image: }

  # build widget $topwin(restore_name).current_image.label1
  label $topwin(restore_name).current_image.label1 \
    -background "$GuiColor(label_bg)" \
    -foreground {Blue} \
    -text {} \
    -textvariable {current_image}

  # pack widget $topwin(restore_name).current_image
  pack append $topwin(restore_name).current_image \
    $topwin(restore_name).current_image.label0 {left frame center} \
    $topwin(restore_name).current_image.label1 {left frame center}

  # build widget $topwin(restore_name).perform
  frame $topwin(restore_name).perform \
    -background "$GuiColor(frame_bg)" \
    -borderwidth {2} \
    -relief {raised}

  # build widget $topwin(restore_name).perform.button2
	button $topwin(restore_name).perform.button2 -padx {1} -pady {1} -highlightthickness {0}  \
    -activebackground "$GuiColor(dis_act_bg)" \
    -background "$GuiColor(dis_bg)" \
    -foreground "$GuiColor(dis_fg)" \
	 -command {destroy $topwin(restore_name); set topwin(restore_name) NONE} \
    -text {DISMISS}

  # build widget $topwin(restore_name).perform.button3
	button $topwin(restore_name).perform.button3 -padx {1} -pady {1} -highlightthickness {0}  \
    -activebackground "$GuiColor(perf_act_bg)" \
    -background "$GuiColor(perf_bg)" \
    -foreground "$GuiColor(perf_fg)" \
    -command {
	$topwin(restore_name) configure -cursor watch; update
	set restore(current_point) 1
	if {$restore(mesh_file) == ""} {
		CvipAlert "Please provide a mesh file name."
		$topwin(restore_name) configure -cursor top_left_arrow; update
		return
	}
	
	if {$restore(mesh_select) == "existing" && ![file exists $restore(mesh_file)]} {
		CvipAlert "The filename you have entered does not exists. Please enter the name of an existing mesh  file."
		focus $topwin(restore_name).info.frame0.frame22.frame24.entry29
		$topwin(restore_name) configure -cursor top_left_arrow; update
		return
	} elseif {$restore(mesh_select) == "existing" && [file exists $restore(mesh_file)]} {
			pack forget $topwin(restore_name).info.frame1.frame43.frame31.frame8.frame0.frame37.button39
			$topwin(restore_name).info.frame1.frame43.frame31.frame8.frame0.frame40.button35 configure -state normal -bg #ffff80    -activebackground gray70
			if [ catch { set result [cvip warp $current_image $restore(mesh_file) $restore(direction) \
							$restore(mesh_interpolate)]} cresult ] {
				CvipAlert "$cresult."
				$topwin(restore_name) configure -cursor top_left_arrow; update
				return
			}
			set new_name [cvip rename $result ${current_image}_warp]
               		img_q insert end $new_name
               		image_post $new_name
			cvip view $new_name
			CvipMessage "warping performed on image \"$current_image\""

	}
	
	if {$restore(mesh_select) == "enter_new"} {

		pack forget $topwin(restore_name).info.frame1.frame43.frame31.frame8.frame0.frame37.button39
		$topwin(restore_name).info.frame1.frame43.frame31.frame8.frame0.frame40.button35 configure -state normal -bg #ffff80 -activebackground gray70
		if [ catch { set result [cvip warp $current_image $restore(mesh_file) $restore(direction) \
						$restore(mesh_interpolate)] } cresult ] {
				CvipAlert "$cresult."
				$topwin(restore_name) configure -cursor top_left_arrow; update
				return
		}
		set new_name [cvip rename $result ${current_image}_warp]
                img_q insert end $new_name
                image_post $new_name
		cvip view $new_name
		CvipMessage "warping performed on image \"$current_image\""

	}

	if {$restore(mesh_select) == "sine_mesh"} {
		if {[file exists $restore(mesh_file)]} {
			CvipAlert "The filename you have chosen already exists. Please select a different name" 
			$topwin(restore_name) configure -cursor top_left_arrow; update
			return
		}
		pack forget $topwin(restore_name).info.frame1.frame43.frame31.frame8.frame0.frame37.button39
		$topwin(restore_name).info.frame1.frame43.frame31.frame8.frame0.frame40.button35 configure -state normal -bg #ffff80
		if [ catch { cvip create_mesh $restore(mesh_r) $restore(mesh_c) $restore(mesh_file) } cresult ] {
			CvipAlert "$cresult."
			$topwin(restore_name) configure -cursor top_left_arrow; update
			return
		}
		if [ catch { set result [cvip warp $current_image $restore(mesh_file) $restore(direction) \
						$restore(mesh_interpolate)] } cresult ] {
			CvipAlert "$cresult."
			$topwin(restore_name) configure -cursor top_left_arrow; update
			return
		}
		set new_name [cvip rename $result ${current_image}_warp]
                img_q insert end $new_name
                image_post $new_name
		cvip view $new_name
		CvipMessage "warping performed on image \"$current_image\""
	}

$topwin(restore_name) configure -cursor top_left_arrow; update
} \
    -text {PERFORM}

  # build widget $topwin(restore_name).perform.button0
	button $topwin(restore_name).perform.button0 -padx {1} -pady {1} -highlightthickness {0}  \
    -activebackground "$GuiColor(alert_act_bg)" \
    -background "$GuiColor(alert_bg)" \
    -foreground "$GuiColor(alert_fg)" \
    -command { 	if { $restore(mesh_file) == "" } {
	 		AlertBox "\n\tPlease enter a mesh file name" "" "350x150" "Geometric Transforms Alert" "DISMISS";
			return
		}
		if [catch {cvip display_mesh $restore(mesh_file)} cresult ] {
			CvipAlert "\nDoes this file exist?\t$cresult " "" 350x150 "Geometric Transforms Alert" "DISMISS"
		} 
	

     } \
    -text {View Mesh}

  # pack widget $topwin(restore_name).perform
  pack append $topwin(restore_name).perform \
    $topwin(restore_name).perform.button2 {left frame center} \
    $topwin(restore_name).perform.button3 {right frame center} \
    $topwin(restore_name).perform.button0 {left frame center expand} 

  # pack widget $topwin(restore_name)
  pack append $topwin(restore_name) \
    $topwin(restore_name).info {top frame center expand fill} \
    $topwin(restore_name).current_image {top frame center fillx} \
    $topwin(restore_name).perform {bottom frame center fillx}

}
