# **********************************************************************
# Computer Vision/Image Processing Tool Project - Dr. Scott Umbaugh SIUE
# **********************************************************************
#
#             File Name: restore_noise.tcl
#           Description: 
#         Related Files: 
#   Initial Coding Date: Tue Aug 27 13:48:55 CDT 1996
#           Portability: TCL script file
#            References:
#             Author(s): Yansheng Wei, Mark Zuke
#                        Southern Illinois University @ Edwardsville
#
## Copyright (C) 1996 SIUE - by Scott Umbaugh, Yansheng Wei and Mark Zuke.
##
## Permission to use, copy, modify, and distribute this software and its
## documentation for any purpose and without fee is hereby granted, provided
## that the above copyright notice appear in all copies and that both that
## copyright notice and this permission notice appear in supporting
## documentation.  This software is provided "as is" without express or
## implied warranty.
##
# RCS (Revision Control System) Information
# ...Added automatically by RCS 
#
## $Log: restore_noise.tcl,v $
## Revision 1.9  1997/06/24 21:17:06  yawei
## finished GUI configuration
##
## Revision 1.8  1997/03/12 00:14:36  yawei
## fixed arrow buttons
##
## Revision 1.7  1997/03/11 20:56:36  yawei
## Tcl/Tk script upgrading from tcl7.3/tk3.6 to tcl7.6/tk4.2
## compatible. This process is automated with tkboost perl
## script. @ Tue Mar 11 14:51:36 CST 1997
##
## Revision 1.6  1996/11/03 01:19:32  yawei
## added "add noise to black iamge" to Restore/noise
##
# Revision 1.5  1996/10/16  18:43:55  yawei
# regular changes
#
# Revision 1.4  1996/09/26  22:06:24  mzuke
# changed maxsize to allow resizing of window
#
# Revision 1.3  1996/09/18  15:10:26  mzuke
# changed 'symbol' font calls to full description
# of font for portability
#
# Revision 1.2  1996/08/28  22:18:20  yawei
# *** empty log message ***
#
# Revision 1.2  1996/08/28  19:32:39  yawei
# 1) 600 and 800 have been added to the Variance
# 2) the current range for variance is [0, 65535] ([,] means inclusive)
# 3) the range for Mean is [-128, 128]
# 4) Alpha range is [1, infinity)
# 5) salt and pepper is [0,], provided salt+ pepper <= 1.
#
# Revision 1.1  1996/08/28  03:18:12  yawei
# Initial revision
#
#
#****************************************************************************
# procedure to show window $topwin(restore_name)
proc res_noise { } {# xf ignore me 7

  # Window manager configurations
  global tk_version
  global topwin
  global toplevel_position
  global {GuiColor}
  global {GuiMisc}
  global {GUI_DEBUG}

  if [ winfo exists  $topwin(restore_name).info] {
     set tempname $topwin(restore_name);\
destroy $topwin(restore_name).info;\
set topwin(restore_name) $tempname;}
  if [ winfo exists  $topwin(restore_name).current_image] {
     set tempname $topwin(restore_name);\
destroy $topwin(restore_name).current_image;\
set topwin(restore_name) $tempname;}
  if [ winfo exists  $topwin(restore_name).perform] {
     set tempname $topwin(restore_name);\
destroy $topwin(restore_name).perform;\
set topwin(restore_name) $tempname;}
  wm positionfrom  $topwin(restore_name) user
  wm sizefrom  $topwin(restore_name) user
  wm geometry $topwin(restore_name) $topwin(restore_noise)[get_pos $topwin(restore_name)]
  wm maxsize $topwin(restore_name) [lindex $topwin(restore_noise_max) 0] \
  	[lindex $topwin(restore_noise_max) 1]
  wm minsize $topwin(restore_name) [lindex $topwin(restore_noise_min) 0] \
  	[lindex $topwin(restore_noise_min) 1]
  wm title $topwin(restore_name) {RESTORATION->Noise}

  bind $topwin(restore_name) <Destroy> {set topwin(restore_name) NONE}

  # build widget $topwin(restore_name).info
  frame $topwin(restore_name).info \
    -background "$GuiColor(frame_bg)" \
    -borderwidth {0}

  # build widget $topwin(restore_name).info.frame14
  frame $topwin(restore_name).info.frame14 \
    -background "$GuiColor(frame_bg)" \
    -borderwidth {2} \
    -relief {ridge}

  # build widget $topwin(restore_name).info.frame14.radiobutton18
	radiobutton $topwin(restore_name).info.frame14.radiobutton18 -padx {1} -pady {1} -highlightthickness {0}  \
    -activebackground "$GuiColor(btn_act_bg)" \
    -background "$GuiColor(btn_bg)" \
    -relief {flat} \
	 -anchor {w} \
    -text {Negative exponential} \
	 -width {18} \
    -value {negative_exp_noise} \
    -variable {restore(noise)}

  # build widget $topwin(restore_name).info.frame14.radiobutton19
	radiobutton $topwin(restore_name).info.frame14.radiobutton19 -padx {1} -pady {1} -highlightthickness {0}  \
    -activebackground "$GuiColor(btn_act_bg)" \
    -background "$GuiColor(btn_bg)" \
    -relief {flat} \
	 -anchor {w} \
    -text {Rayleigh} \
	 -width {8} \
    -value {rayleigh_noise} \
    -variable {restore(noise)}

  # build widget $topwin(restore_name).info.frame14.special
  frame $topwin(restore_name).info.frame14.special \
    -background "$GuiColor(frame_bg)" \
    -borderwidth {2}

  # build widget $topwin(restore_name).info.frame14.special.label1
  label $topwin(restore_name).info.frame14.special.label1 \
    -background "$GuiColor(label_bg)" \
    -borderwidth {0} \
    -text {Variance:}

  # build widget $topwin(restore_name).info.frame14.special.value
  entry $topwin(restore_name).info.frame14.special.value \
    -background "$GuiColor(entry_bg)" \
    -foreground "$GuiColor(entry_fg)" \
    -relief {sunken} \
    -textvariable {restore(ns_var)} \
    -width {5}
  endEntry $topwin(restore_name).info.frame14.special.value 

  # build widget $topwin(restore_name).info.frame14.special.menubutton2
	menubutton $topwin(restore_name).info.frame14.special.menubutton2 -padx {1} -pady {1} -highlightthickness {0}  \
    -activebackground "$GuiColor(btn_act_bg)" \
    -background "$GuiColor(btn_bg)" \
    -font "$GuiMisc(pop_up_fn)" \
    -relief "$GuiMisc(pop_up_relief)" \
    -text "$GuiMisc(pop_up_text)" \
	 -width {2}
  bind $topwin(restore_name).info.frame14.special.menubutton2 <Button-1> {
	MenuPopupPost $topwin(restore_name).info.frame14.special.menubutton2.menu %X %Y
  }
  bind $topwin(restore_name).info.frame14.special.menubutton2 <ButtonRelease-1> {
	MenuPopupRelease $topwin(restore_name).info.frame14.special.menubutton2.menu %W
  }
  # build widget $topwin(restore_name).info.frame14.special.menubutton2.menu
  menu $topwin(restore_name).info.frame14.special.menubutton2.menu \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)"
  $topwin(restore_name).info.frame14.special.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -command {set restore(ns_var) 100} \
    -label {100}
  $topwin(restore_name).info.frame14.special.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -command {set restore(ns_var) 200} \
    -label {200}
  $topwin(restore_name).info.frame14.special.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -command {set restore(ns_var) 300} \
    -label {300}
  $topwin(restore_name).info.frame14.special.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -command {set restore(ns_var) 400} \
    -label {400}
  $topwin(restore_name).info.frame14.special.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -command {set restore(ns_var) 600} \
    -label {600}
  $topwin(restore_name).info.frame14.special.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -command {set restore(ns_var) 800} \
    -label {800}
  bindtags $topwin(restore_name).info.frame14.special.menubutton2.menu  {Menu all}
  bind $topwin(restore_name).info.frame14.special.menubutton2.menu <B1-Motion> {
	MenuPopupMotion $topwin(restore_name).info.frame14.special.menubutton2.menu %W %X %Y
  }
  bind $topwin(restore_name).info.frame14.special.menubutton2.menu <ButtonRelease-1> {
	MenuPopupRelease $topwin(restore_name).info.frame14.special.menubutton2.menu %W
  }

  # pack widget $topwin(restore_name).info.frame14.special
  pack append $topwin(restore_name).info.frame14.special \
    $topwin(restore_name).info.frame14.special.label1 {left frame center fill} \
    $topwin(restore_name).info.frame14.special.value {left frame center expand fill} \
    $topwin(restore_name).info.frame14.special.menubutton2 {right frame center fill}

  # pack widget $topwin(restore_name).info.frame14
  pack append $topwin(restore_name).info.frame14 \
    $topwin(restore_name).info.frame14.radiobutton18 {left frame center} \
    $topwin(restore_name).info.frame14.radiobutton19 {left frame center} \
    $topwin(restore_name).info.frame14.special {left frame center fillx}

  # build widget $topwin(restore_name).info.frame15
  frame $topwin(restore_name).info.frame15 \
    -background "$GuiColor(frame_bg)" \
    -borderwidth {2} \
    -relief {ridge}

  # build widget $topwin(restore_name).info.frame15.radiobutton18
	radiobutton $topwin(restore_name).info.frame15.radiobutton18 -padx {1} -pady {1} -highlightthickness {0}  \
    -activebackground "$GuiColor(btn_act_bg)" \
    -background "$GuiColor(btn_bg)" \
    -relief {flat} \
	 -anchor {w} \
    -text {Gaussian} \
	 -width {18} \
    -value {gaussian_noise} \
    -variable {restore(noise)}

  # build widget $topwin(restore_name).info.frame15.radiobutton19
	radiobutton $topwin(restore_name).info.frame15.radiobutton19 -padx {1} -pady {1} -highlightthickness {0}  \
    -activebackground "$GuiColor(btn_act_bg)" \
    -background "$GuiColor(btn_bg)" \
    -relief {flat} \
	 -anchor {w} \
    -text {Uniform } \
	 -width {8} \
    -value {uniform_noise} \
    -variable {restore(noise)}

  # build widget $topwin(restore_name).info.frame15.special
  frame $topwin(restore_name).info.frame15.special \
    -background "$GuiColor(frame_bg)" \
    -borderwidth {2}

  # build widget $topwin(restore_name).info.frame15.special.label1
  label $topwin(restore_name).info.frame15.special.label1 \
    -background "$GuiColor(label_bg)" \
    -borderwidth {0} \
    -text {Variance:}

  # build widget $topwin(restore_name).info.frame15.special.value
  entry $topwin(restore_name).info.frame15.special.value \
    -background "$GuiColor(entry_bg)" \
    -foreground "$GuiColor(entry_fg)" \
    -relief {sunken} \
    -textvariable {restore(ns_var)} \
    -width {5}
  endEntry $topwin(restore_name).info.frame15.special.value  0 \
  	 $topwin(restore_name).info.frame15.frame20.value \
  	 $topwin(restore_name).info.frame15.frame20.value 

  # build widget $topwin(restore_name).info.frame15.special.menubutton2
	menubutton $topwin(restore_name).info.frame15.special.menubutton2 -padx {1} -pady {1} -highlightthickness {0}  \
    -activebackground "$GuiColor(btn_act_bg)" \
    -background "$GuiColor(btn_bg)" \
    -font "$GuiMisc(pop_up_fn)" \
    -relief "$GuiMisc(pop_up_relief)" \
    -text "$GuiMisc(pop_up_text)" \
	 -width {2}
  bind $topwin(restore_name).info.frame15.special.menubutton2 <Button-1> {
	MenuPopupPost $topwin(restore_name).info.frame15.special.menubutton2.menu %X %Y
  }
  bind $topwin(restore_name).info.frame15.special.menubutton2 <ButtonRelease-1> {
	MenuPopupRelease $topwin(restore_name).info.frame15.special.menubutton2.menu %W
  }

  # build widget $topwin(restore_name).info.frame15.special.menubutton2.menu
  menu $topwin(restore_name).info.frame15.special.menubutton2.menu \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)"
  $topwin(restore_name).info.frame15.special.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -command {set restore(ns_var) 100} \
    -label {100}
  $topwin(restore_name).info.frame15.special.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -command {set restore(ns_var) 200} \
    -label {200}
  $topwin(restore_name).info.frame15.special.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -command {set restore(ns_var) 300} \
    -label {300}
  $topwin(restore_name).info.frame15.special.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -command {set restore(ns_var) 400} \
    -label {400}
  $topwin(restore_name).info.frame15.special.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -command {set restore(ns_var) 600} \
    -label {600}
  $topwin(restore_name).info.frame15.special.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -command {set restore(ns_var) 800} \
    -label {800}
  bindtags $topwin(restore_name).info.frame15.special.menubutton2.menu {Menu all}
  bind $topwin(restore_name).info.frame15.special.menubutton2.menu <B1-Motion> {
	MenuPopupMotion $topwin(restore_name).info.frame15.special.menubutton2.menu %W %X %Y
  }
  bind $topwin(restore_name).info.frame15.special.menubutton2.menu <ButtonRelease-1> {
	MenuPopupRelease $topwin(restore_name).info.frame15.special.menubutton2.menu %W
  }

  # pack widget $topwin(restore_name).info.frame15.special
  pack append $topwin(restore_name).info.frame15.special \
    $topwin(restore_name).info.frame15.special.label1 {left frame center fill} \
    $topwin(restore_name).info.frame15.special.value {left frame center expand fill} \
    $topwin(restore_name).info.frame15.special.menubutton2 {right frame center fill}

  # build widget $topwin(restore_name).info.frame15.frame20
  frame $topwin(restore_name).info.frame15.frame20 \
    -background "$GuiColor(frame_bg)" \
    -borderwidth {2}

  # build widget $topwin(restore_name).info.frame15.frame20.label1
  label $topwin(restore_name).info.frame15.frame20.label1 \
    -background "$GuiColor(label_bg)" \
    -borderwidth {0} \
    -text {            Mean:}

  # build widget $topwin(restore_name).info.frame15.frame20.value
  entry $topwin(restore_name).info.frame15.frame20.value \
    -background "$GuiColor(entry_bg)" \
    -foreground "$GuiColor(entry_fg)" \
    -relief {sunken} \
    -textvariable {restore(ns_mean)} \
    -width {5}
  endEntry $topwin(restore_name).info.frame15.frame20.value 0\
  	 $topwin(restore_name).info.frame15.special.value \
  	 $topwin(restore_name).info.frame15.special.value 

  # build widget $topwin(restore_name).info.frame15.frame20.menubutton2
	menubutton $topwin(restore_name).info.frame15.frame20.menubutton2 -padx {1} -pady {1} -highlightthickness {0}  \
    -activebackground "$GuiColor(btn_act_bg)" \
    -background "$GuiColor(btn_bg)" \
    -font "$GuiMisc(pop_up_fn)" \
    -relief "$GuiMisc(pop_up_relief)" \
    -text "$GuiMisc(pop_up_text)" \
	 -width {2}

  bind $topwin(restore_name).info.frame15.frame20.menubutton2 <Button-1> {
	MenuPopupPost $topwin(restore_name).info.frame15.frame20.menubutton2.menu %X %Y
  }
  bind $topwin(restore_name).info.frame15.frame20.menubutton2 <ButtonRelease-1> {
	MenuPopupRelease $topwin(restore_name).info.frame15.frame20.menubutton2.menu %W
  }

  # build widget $topwin(restore_name).info.frame15.frame20.menubutton2.menu
  menu $topwin(restore_name).info.frame15.frame20.menubutton2.menu \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)"
  $topwin(restore_name).info.frame15.frame20.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -command {set restore(ns_mean) -20} \
    -label {-20}
  $topwin(restore_name).info.frame15.frame20.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -command {set restore(ns_mean) -10} \
    -label {-10}
  $topwin(restore_name).info.frame15.frame20.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -command {set restore(ns_mean) 0} \
    -label {   0}
  $topwin(restore_name).info.frame15.frame20.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -command {set restore(ns_mean) 10} \
    -label {  10}
  $topwin(restore_name).info.frame15.frame20.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -command {set restore(ns_mean) 20} \
    -label {  20}
  bindtags $topwin(restore_name).info.frame15.frame20.menubutton2.menu {Menu all}
  bind $topwin(restore_name).info.frame15.frame20.menubutton2.menu <B1-Motion> {
	MenuPopupMotion $topwin(restore_name).info.frame15.frame20.menubutton2.menu %W %X %Y
  }
  bind $topwin(restore_name).info.frame15.frame20.menubutton2.menu <ButtonRelease-1> {
	MenuPopupRelease $topwin(restore_name).info.frame15.frame20.menubutton2.menu %W
  }

  # pack widget $topwin(restore_name).info.frame15.frame20
  pack append $topwin(restore_name).info.frame15.frame20 \
    $topwin(restore_name).info.frame15.frame20.label1 {left frame center fill} \
    $topwin(restore_name).info.frame15.frame20.value {left frame center expand fill} \
    $topwin(restore_name).info.frame15.frame20.menubutton2 {right frame center fill}

  # pack widget $topwin(restore_name).info.frame15
  pack append $topwin(restore_name).info.frame15 \
    $topwin(restore_name).info.frame15.radiobutton18 {left frame center} \
    $topwin(restore_name).info.frame15.radiobutton19 {left frame center} \
    $topwin(restore_name).info.frame15.special {left frame center fillx} \
    $topwin(restore_name).info.frame15.frame20 {left frame center fillx}

  # build widget $topwin(restore_name).info.frame16
  frame $topwin(restore_name).info.frame16 \
    -background "$GuiColor(frame_bg)" \
    -borderwidth {2} \
    -relief {ridge}

  # build widget $topwin(restore_name).info.frame16.radiobutton18
	radiobutton $topwin(restore_name).info.frame16.radiobutton18 -padx {1} -pady {1} -highlightthickness {0}  \
    -activebackground "$GuiColor(btn_act_bg)" \
    -background "$GuiColor(btn_bg)" \
    -relief {flat} \
	 -anchor {w} \
    -text {Gamma} \
	 -width {30} \
    -value {gamma_noise} \
    -variable {restore(noise)}

  # build widget $topwin(restore_name).info.frame16.special
  frame $topwin(restore_name).info.frame16.special \
    -background "$GuiColor(frame_bg)" \
    -borderwidth {2}

  # build widget $topwin(restore_name).info.frame16.special.label1
  label $topwin(restore_name).info.frame16.special.label1 \
    -background "$GuiColor(label_bg)" \
    -borderwidth {0} \
    -text {Variance:}

  # build widget $topwin(restore_name).info.frame16.special.value
  entry $topwin(restore_name).info.frame16.special.value \
    -background "$GuiColor(entry_bg)" \
    -foreground "$GuiColor(entry_fg)" \
    -relief {sunken} \
    -textvariable {restore(ns_var)} \
    -width {5}
  endEntry $topwin(restore_name).info.frame16.special.value 0 \
  	 $topwin(restore_name).info.frame16.frame20.value \
  	 $topwin(restore_name).info.frame16.frame20.value 

  # build widget $topwin(restore_name).info.frame16.special.menubutton2
	menubutton $topwin(restore_name).info.frame16.special.menubutton2 -padx {1} -pady {1} -highlightthickness {0}  \
    -activebackground "$GuiColor(btn_act_bg)" \
    -background "$GuiColor(btn_bg)" \
    -font "$GuiMisc(pop_up_fn)" \
    -relief "$GuiMisc(pop_up_relief)" \
    -text "$GuiMisc(pop_up_text)" \
	 -width {2}
  bind $topwin(restore_name).info.frame16.special.menubutton2 <Button-1> {
	MenuPopupPost $topwin(restore_name).info.frame16.special.menubutton2.menu %X %Y
  }
  bind $topwin(restore_name).info.frame16.special.menubutton2 <ButtonRelease-1> {
	MenuPopupRelease $topwin(restore_name).info.frame16.special.menubutton2.menu %W
  }

  # build widget $topwin(restore_name).info.frame16.special.menubutton2.menu
  menu $topwin(restore_name).info.frame16.special.menubutton2.menu \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)"
  $topwin(restore_name).info.frame16.special.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -command {set restore(ns_var) 100} \
    -label {100}
  $topwin(restore_name).info.frame16.special.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -command {set restore(ns_var) 200} \
    -label {200}
  $topwin(restore_name).info.frame16.special.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -command {set restore(ns_var) 300} \
    -label {300}
  $topwin(restore_name).info.frame16.special.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -command {set restore(ns_var) 400} \
    -label {400}
  $topwin(restore_name).info.frame16.special.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -command {set restore(ns_var) 600} \
    -label {600}
  $topwin(restore_name).info.frame16.special.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -command {set restore(ns_var) 800} \
    -label {800}
  bindtags $topwin(restore_name).info.frame16.special.menubutton2.menu {Menu all}
  bind $topwin(restore_name).info.frame16.special.menubutton2.menu <B1-Motion> {
	MenuPopupMotion $topwin(restore_name).info.frame16.special.menubutton2.menu %W %X %Y
  }
  bind $topwin(restore_name).info.frame16.special.menubutton2.menu <ButtonRelease-1> {
	MenuPopupRelease $topwin(restore_name).info.frame16.special.menubutton2.menu %W
  }

  # pack widget $topwin(restore_name).info.frame16.special
  pack append $topwin(restore_name).info.frame16.special \
    $topwin(restore_name).info.frame16.special.label1 {left frame center fill} \
    $topwin(restore_name).info.frame16.special.value {left frame center expand fill} \
    $topwin(restore_name).info.frame16.special.menubutton2 {right frame center fill}

  # build widget $topwin(restore_name).info.frame16.frame20
  frame $topwin(restore_name).info.frame16.frame20 \
    -background "$GuiColor(frame_bg)" \
    -borderwidth {2}

  # build widget $topwin(restore_name).info.frame16.frame20.label1
  label $topwin(restore_name).info.frame16.frame20.label1 \
    -background "$GuiColor(label_bg)" \
    -borderwidth {0} \
    -text {            Alpha:}

  # build widget $topwin(restore_name).info.frame16.frame20.value
  entry $topwin(restore_name).info.frame16.frame20.value \
    -background "$GuiColor(entry_bg)" \
    -foreground "$GuiColor(entry_fg)" \
    -relief {sunken} \
    -textvariable {restore(ns_alpha)} \
    -width {5}
  endEntry $topwin(restore_name).info.frame16.frame20.value 0 \
  	 $topwin(restore_name).info.frame16.special.value \
  	 $topwin(restore_name).info.frame16.special.value 

  # build widget $topwin(restore_name).info.frame16.frame20.menubutton2
	menubutton $topwin(restore_name).info.frame16.frame20.menubutton2 -padx {1} -pady {1} -highlightthickness {0}  \
    -activebackground "$GuiColor(btn_act_bg)" \
    -background "$GuiColor(btn_bg)" \
    -font "$GuiMisc(pop_up_fn)" \
    -relief "$GuiMisc(pop_up_relief)" \
    -text "$GuiMisc(pop_up_text)" \
	 -width {2}
  bind $topwin(restore_name).info.frame16.frame20.menubutton2 <Button-1> {
	MenuPopupPost $topwin(restore_name).info.frame16.frame20.menubutton2.menu %X %Y
  }
  bind $topwin(restore_name).info.frame16.frame20.menubutton2 <ButtonRelease-1> {
	MenuPopupRelease $topwin(restore_name).info.frame16.frame20.menubutton2.menu %W
  }

  # build widget $topwin(restore_name).info.frame16.frame20.menubutton2.menu
  menu $topwin(restore_name).info.frame16.frame20.menubutton2.menu \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)"
  $topwin(restore_name).info.frame16.frame20.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -command {set restore(ns_alpha) 1.0} \
    -label { 1.0 }
  $topwin(restore_name).info.frame16.frame20.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -command {set restore(ns_alpha) 2.0} \
    -label { 2.0 }
  $topwin(restore_name).info.frame16.frame20.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -command {set restore(ns_alpha) 3.0} \
    -label { 3.0 }
  $topwin(restore_name).info.frame16.frame20.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -command {set restore(ns_alpha) 4.0} \
    -label { 4.0 }
  $topwin(restore_name).info.frame16.frame20.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -command {set restore(ns_alpha) 5.0} \
    -label { 5.0 }
  bindtags $topwin(restore_name).info.frame16.frame20.menubutton2.menu {Menu all}
  bind $topwin(restore_name).info.frame16.frame20.menubutton2.menu <B1-Motion> {
	MenuPopupMotion $topwin(restore_name).info.frame16.frame20.menubutton2.menu %W %X %Y
  }
  bind $topwin(restore_name).info.frame16.frame20.menubutton2.menu <ButtonRelease-1> {
	MenuPopupRelease $topwin(restore_name).info.frame16.frame20.menubutton2.menu %W
  }

  # pack widget $topwin(restore_name).info.frame16.frame20
  pack append $topwin(restore_name).info.frame16.frame20 \
    $topwin(restore_name).info.frame16.frame20.label1 {left frame center fill} \
    $topwin(restore_name).info.frame16.frame20.value {left frame center expand fill} \
    $topwin(restore_name).info.frame16.frame20.menubutton2 {right frame center fill}

  # pack widget $topwin(restore_name).info.frame16
  pack append $topwin(restore_name).info.frame16 \
    $topwin(restore_name).info.frame16.radiobutton18 {left frame center} \
    $topwin(restore_name).info.frame16.special {left frame center fillx} \
    $topwin(restore_name).info.frame16.frame20 {left frame center fillx}

  # build widget $topwin(restore_name).info.frame17
  frame $topwin(restore_name).info.frame17 \
    -background "$GuiColor(frame_bg)" \
    -borderwidth {2} \
    -relief {ridge}

  # build widget $topwin(restore_name).info.frame17.radiobutton18
	radiobutton $topwin(restore_name).info.frame17.radiobutton18 -padx {1} -pady {1} -highlightthickness {0}  \
    -activebackground "$GuiColor(btn_act_bg)" \
    -background "$GuiColor(btn_bg)" \
    -relief {flat} \
	 -anchor {w} \
    -text {Salt and Pepper} \
	 -width {17} \
    -value {speckle_noise} \
    -variable {restore(noise)}

  # build widget $topwin(restore_name).info.frame17.frame20
  frame $topwin(restore_name).info.frame17.frame20 \
    -background "$GuiColor(frame_bg)" \
    -borderwidth {2}

  # build widget $topwin(restore_name).info.frame17.frame20.label1
  label $topwin(restore_name).info.frame17.frame20.label1 \
    -background "$GuiColor(label_bg)" \
    -borderwidth {0} \
    -text {Probabilities:   of pepper:}

  # build widget $topwin(restore_name).info.frame17.frame20.value
  entry $topwin(restore_name).info.frame17.frame20.value \
    -background "$GuiColor(entry_bg)" \
    -foreground "$GuiColor(entry_fg)" \
    -relief {sunken} \
    -textvariable {restore(ns_pepper)} \
    -width {5}
  endEntry $topwin(restore_name).info.frame17.frame20.value 0 \
  	 $topwin(restore_name).info.frame17.frame22.value \
  	 $topwin(restore_name).info.frame17.frame22.value 

  # build widget $topwin(restore_name).info.frame17.frame20.menubutton2
	menubutton $topwin(restore_name).info.frame17.frame20.menubutton2 -padx {1} -pady {1} -highlightthickness {0}  \
    -activebackground "$GuiColor(btn_act_bg)" \
    -background "$GuiColor(btn_bg)" \
    -font "$GuiMisc(pop_up_fn)" \
    -relief "$GuiMisc(pop_up_relief)" \
    -text "$GuiMisc(pop_up_text)" \
	 -width {2}
  bind $topwin(restore_name).info.frame17.frame20.menubutton2 <Button-1> {
	MenuPopupPost $topwin(restore_name).info.frame17.frame20.menubutton2.menu %X %Y
  }
  bind $topwin(restore_name).info.frame17.frame20.menubutton2 <ButtonRelease-1> {
	MenuPopupRelease $topwin(restore_name).info.frame17.frame20.menubutton2.menu %W
  }

  # build widget $topwin(restore_name).info.frame17.frame20.menubutton2.menu
  menu $topwin(restore_name).info.frame17.frame20.menubutton2.menu \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)"
  $topwin(restore_name).info.frame17.frame20.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -command {set restore(ns_pepper) 0.02} \
    -label {0.02}
  $topwin(restore_name).info.frame17.frame20.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -command {set restore(ns_pepper) 0.05} \
    -label {0.05}
  $topwin(restore_name).info.frame17.frame20.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -command {set restore(ns_pepper) 0.08} \
    -label {0.08}
  $topwin(restore_name).info.frame17.frame20.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -command {set restore(ns_pepper) 0.10} \
    -label {0.10}
  $topwin(restore_name).info.frame17.frame20.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -command {set restore(ns_pepper) 0.15} \
    -label {0.15}
  $topwin(restore_name).info.frame17.frame20.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -command {set restore(ns_pepper) 0.20} \
    -label {0.20}
  bindtags $topwin(restore_name).info.frame17.frame20.menubutton2.menu {Menu all}
  bind $topwin(restore_name).info.frame17.frame20.menubutton2.menu <B1-Motion> {
	MenuPopupMotion $topwin(restore_name).info.frame17.frame20.menubutton2.menu %W %X %Y
  }
  bind $topwin(restore_name).info.frame17.frame20.menubutton2.menu <ButtonRelease-1> {
	MenuPopupRelease $topwin(restore_name).info.frame17.frame20.menubutton2.menu %W
  }

  # pack widget $topwin(restore_name).info.frame17.frame20
  pack append $topwin(restore_name).info.frame17.frame20 \
    $topwin(restore_name).info.frame17.frame20.label1 {left frame center fill} \
    $topwin(restore_name).info.frame17.frame20.value {left frame center expand fill} \
    $topwin(restore_name).info.frame17.frame20.menubutton2 {right frame center fill}

  # build widget $topwin(restore_name).info.frame17.frame22
  frame $topwin(restore_name).info.frame17.frame22 \
    -background "$GuiColor(frame_bg)" \
    -borderwidth {2}

  # build widget $topwin(restore_name).info.frame17.frame22.label1
  label $topwin(restore_name).info.frame17.frame22.label1 \
    -background "$GuiColor(label_bg)" \
    -borderwidth {0} \
    -text {           of salt:}

  # build widget $topwin(restore_name).info.frame17.frame22.value
  entry $topwin(restore_name).info.frame17.frame22.value \
    -background "$GuiColor(entry_bg)" \
    -foreground "$GuiColor(entry_fg)" \
    -relief {sunken} \
    -textvariable {restore(ns_salt)} \
    -width {5}
  endEntry $topwin(restore_name).info.frame17.frame22.value 0 \
  	 $topwin(restore_name).info.frame17.frame20.value  \
  	 $topwin(restore_name).info.frame17.frame20.value 

  # build widget $topwin(restore_name).info.frame17.frame22.menubutton2
	menubutton $topwin(restore_name).info.frame17.frame22.menubutton2 -padx {1} -pady {1} -highlightthickness {0}  \
    -activebackground "$GuiColor(btn_act_bg)" \
    -background "$GuiColor(btn_bg)" \
    -font "$GuiMisc(pop_up_fn)" \
    -relief "$GuiMisc(pop_up_relief)" \
    -text "$GuiMisc(pop_up_text)" \
	 -width {2}
  bind $topwin(restore_name).info.frame17.frame22.menubutton2 <Button-1> {
	MenuPopupPost $topwin(restore_name).info.frame17.frame22.menubutton2.menu %X %Y
  }
  bind $topwin(restore_name).info.frame17.frame22.menubutton2 <ButtonRelease-1> {
	MenuPopupRelease $topwin(restore_name).info.frame17.frame22.menubutton2.menu %W
  }

  # build widget $topwin(restore_name).info.frame17.frame22.menubutton2.menu
  menu $topwin(restore_name).info.frame17.frame22.menubutton2.menu \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)"
  $topwin(restore_name).info.frame17.frame22.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -command {set restore(ns_salt) 0.02} \
    -label {0.02}
  $topwin(restore_name).info.frame17.frame22.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -command {set restore(ns_salt) 0.05} \
    -label {0.05}
  $topwin(restore_name).info.frame17.frame22.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -command {set restore(ns_salt) 0.08} \
    -label {0.08}
  $topwin(restore_name).info.frame17.frame22.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -command {set restore(ns_salt) 0.10} \
    -label {0.10}
  $topwin(restore_name).info.frame17.frame22.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -command {set restore(ns_salt) 0.15} \
    -label {0.15}
  $topwin(restore_name).info.frame17.frame22.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -command {set restore(ns_salt) 0.20} \
    -label {0.20}
  bindtags $topwin(restore_name).info.frame17.frame22.menubutton2.menu  {Menu all}
  bind $topwin(restore_name).info.frame17.frame22.menubutton2.menu <B1-Motion> {
	MenuPopupMotion $topwin(restore_name).info.frame17.frame22.menubutton2.menu %W %X %Y
  }
  bind $topwin(restore_name).info.frame17.frame22.menubutton2.menu <ButtonRelease-1> {
	MenuPopupRelease $topwin(restore_name).info.frame17.frame22.menubutton2.menu %W
  }

  # pack widget $topwin(restore_name).info.frame17.frame22
  pack append $topwin(restore_name).info.frame17.frame22 \
    $topwin(restore_name).info.frame17.frame22.label1 {left frame center fill} \
    $topwin(restore_name).info.frame17.frame22.value {left frame center expand fill} \
    $topwin(restore_name).info.frame17.frame22.menubutton2 {right frame center fill}

  # pack widget $topwin(restore_name).info.frame17
  pack append $topwin(restore_name).info.frame17 \
    $topwin(restore_name).info.frame17.radiobutton18 {left frame center} \
    $topwin(restore_name).info.frame17.frame20 {left frame center fillx} \
    $topwin(restore_name).info.frame17.frame22 {left frame center fillx}

  # pack widget $topwin(restore_name).info
  pack append $topwin(restore_name).info \
    $topwin(restore_name).info.frame14 {top frame center expand fill} \
    $topwin(restore_name).info.frame15 {top frame center expand fill} \
    $topwin(restore_name).info.frame16 {top frame center expand fill} \
    $topwin(restore_name).info.frame17 {top frame center expand fill}


  # build widget $topwin(restore_name).current_image
  frame $topwin(restore_name).current_image \
    -background "$GuiColor(frame_bg)" \
    -borderwidth {2} \
    -relief {ridge}

  # build widget $topwin(restore_name).current_image.frame1
  frame $topwin(restore_name).current_image.frame1 \
    -background "$GuiColor(frame_bg)" \
    -borderwidth {2}

  # build widget $topwin(restore_name).current_image.frame1.radiobutton4
	radiobutton $topwin(restore_name).current_image.frame1.radiobutton4 -padx {1} -pady {1} -highlightthickness {0}  \
    -activebackground "$GuiColor(btn_act_bg)" \
    -background "$GuiColor(btn_bg)" \
    -command {
		pack append $topwin(restore_name).current_image.frame1  $topwin(restore_name).current_image.frame1.label6 {left frame center fill}
		pack forget $topwin(restore_name).current_image.frame2.frame9
	 } \
    -relief {flat} \
    -text {Use current image: } \
    -value {current} \
    -variable {restore(noise_img)}

  # build widget $topwin(restore_name).current_image.frame1.label6
  label $topwin(restore_name).current_image.frame1.label6 \
    -background "$GuiColor(label_bg)" \
    -foreground {blue} \
    -text {house.ppm} \
    -textvariable {current_image}

  # pack widget $topwin(restore_name).current_image.frame1
  pack append $topwin(restore_name).current_image.frame1 \
    $topwin(restore_name).current_image.frame1.radiobutton4 {left frame center padx 30} \
    $topwin(restore_name).current_image.frame1.label6 {left frame center fill}

  # build widget $topwin(restore_name).current_image.frame2
  frame $topwin(restore_name).current_image.frame2 \
    -background "$GuiColor(frame_bg)" \
    -borderwidth {2}

  # build widget $topwin(restore_name).current_image.frame2.radiobutton5
	radiobutton $topwin(restore_name).current_image.frame2.radiobutton5 -padx {1} -pady {1} -highlightthickness {0}  \
    -activebackground "$GuiColor(btn_act_bg)" \
    -background "$GuiColor(btn_bg)" \
    -command {
		pack append $topwin(restore_name).current_image.frame2   $topwin(restore_name).current_image.frame2.frame9 {left frame center}
		pack forget $topwin(restore_name).current_image.frame1.label6
	 } \
    -relief {flat} \
    -text {Use black image: } \
    -value {black} \
    -variable {restore(noise_img)}

  # build widget $topwin(restore_name).current_image.frame2.frame9
  frame $topwin(restore_name).current_image.frame2.frame9 \
    -background "$GuiColor(frame_bg)" -borderwidth {0}

  # build widget $topwin(restore_name).current_image.frame2.frame9.frame7
  frame $topwin(restore_name).current_image.frame2.frame9.frame7 \
    -background "$GuiColor(frame_bg)" -borderwidth {0}

  # build widget $topwin(restore_name).current_image.frame2.frame9.frame7.frame0
  frame $topwin(restore_name).current_image.frame2.frame9.frame7.frame0 \
    -background "$GuiColor(frame_bg)" -borderwidth {0}

  # build widget $topwin(restore_name).current_image.frame2.frame9.frame7.frame0.label1
  label $topwin(restore_name).current_image.frame2.frame9.frame7.frame0.label1 \
    -background "$GuiColor(label_bg)"  \
    -borderwidth {0} \
    -text {Height: }

  # build widget $topwin(restore_name).current_image.frame2.frame9.frame7.frame0.value
  entry $topwin(restore_name).current_image.frame2.frame9.frame7.frame0.value \
	 -highlightthickness {0} \
    -background "$GuiColor(entry_bg)" \
    -foreground "$GuiColor(entry_fg)" \
    -relief {sunken} \
    -textvariable {restore(black_height)} \
    -width {10}
  endEntry $topwin(restore_name).current_image.frame2.frame9.frame7.frame0.value 0 \
  	 $topwin(restore_name).current_image.frame2.frame9.frame8.frame0.value \
  	 $topwin(restore_name).current_image.frame2.frame9.frame8.frame0.value

  # build widget $topwin(restore_name).current_image.frame2.frame9.frame7.frame0.menubutton2
	menubutton $topwin(restore_name).current_image.frame2.frame9.frame7.frame0.menubutton2 -padx {1} -pady {1} -highlightthickness {0}  \
    -activebackground "$GuiColor(btn_act_bg)" \
    -background "$GuiColor(btn_bg)" \
    -font "$GuiMisc(pop_up_fn)" \
    -relief "$GuiMisc(pop_up_relief)" \
    -text "$GuiMisc(pop_up_text)" \
	 -width {2}
  # bindings
  bind $topwin(restore_name).current_image.frame2.frame9.frame7.frame0.menubutton2 <Button-1> {MenuPopupPost $topwin(restore_name).current_image.frame2.frame9.frame7.frame0.menubutton2.menu %X %Y}
  bind $topwin(restore_name).current_image.frame2.frame9.frame7.frame0.menubutton2 <ButtonRelease-1> {MenuPopupRelease $topwin(restore_name).current_image.frame2.frame9.frame7.frame0.menubutton2.menu %W}

  # build widget $topwin(restore_name).current_image.frame2.frame9.frame7.frame0.menubutton2.menu
  menu $topwin(restore_name).current_image.frame2.frame9.frame7.frame0.menubutton2.menu \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)"
  $topwin(restore_name).current_image.frame2.frame9.frame7.frame0.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -command {set restore(black_height) 32} \
    -label { 32}
  $topwin(restore_name).current_image.frame2.frame9.frame7.frame0.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -command {set restore(black_height) 64} \
    -label { 64}
  $topwin(restore_name).current_image.frame2.frame9.frame7.frame0.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -command {set restore(black_height) 128} \
    -label {128}
  $topwin(restore_name).current_image.frame2.frame9.frame7.frame0.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -command {set restore(black_height) 256} \
    -label {256}
  $topwin(restore_name).current_image.frame2.frame9.frame7.frame0.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -command {set restore(black_height) 512} \
    -label {512}
  bindtags $topwin(restore_name).current_image.frame2.frame9.frame7.frame0.menubutton2.menu  {Menu all}
  # bindings
  bind $topwin(restore_name).current_image.frame2.frame9.frame7.frame0.menubutton2.menu <B1-Motion> {MenuPopupMotion $topwin(restore_name).current_image.frame2.frame9.frame7.frame0.menubutton2.menu %W %X %Y}
  bind $topwin(restore_name).current_image.frame2.frame9.frame7.frame0.menubutton2.menu <ButtonRelease-1> {MenuPopupRelease $topwin(restore_name).current_image.frame2.frame9.frame7.frame0.menubutton2.menu %W}

  # pack widget $topwin(restore_name).current_image.frame2.frame9.frame7.frame0
  pack append $topwin(restore_name).current_image.frame2.frame9.frame7.frame0 \
    $topwin(restore_name).current_image.frame2.frame9.frame7.frame0.label1 {left frame center fill} \
    $topwin(restore_name).current_image.frame2.frame9.frame7.frame0.value {left frame center expand fill} \
    $topwin(restore_name).current_image.frame2.frame9.frame7.frame0.menubutton2 {right frame center fill}

  # pack widget $topwin(restore_name).current_image.frame2.frame9.frame7
  pack append $topwin(restore_name).current_image.frame2.frame9.frame7 \
    $topwin(restore_name).current_image.frame2.frame9.frame7.frame0 {top frame center fillx}

  # build widget $topwin(restore_name).current_image.frame2.frame9.frame8
  frame $topwin(restore_name).current_image.frame2.frame9.frame8 \
    -background "$GuiColor(frame_bg)" -borderwidth {0}

  # build widget $topwin(restore_name).current_image.frame2.frame9.frame8.frame0
  frame $topwin(restore_name).current_image.frame2.frame9.frame8.frame0 \
    -background "$GuiColor(frame_bg)" -borderwidth {0}

  # build widget $topwin(restore_name).current_image.frame2.frame9.frame8.frame0.label1
  label $topwin(restore_name).current_image.frame2.frame9.frame8.frame0.label1 \
    -background "$GuiColor(label_bg)" \
    -borderwidth {0} \
    -text {Width: }

  # build widget $topwin(restore_name).current_image.frame2.frame9.frame8.frame0.value
  entry $topwin(restore_name).current_image.frame2.frame9.frame8.frame0.value \
	 -highlightthickness {0} \
    -background "$GuiColor(entry_bg)" \
    -foreground "$GuiColor(entry_fg)" \
    -relief {sunken} \
    -textvariable {restore(black_width)} \
    -width {10}
  endEntry $topwin(restore_name).current_image.frame2.frame9.frame8.frame0.value 0 \
  	 $topwin(restore_name).current_image.frame2.frame9.frame7.frame0.value \
  	 $topwin(restore_name).current_image.frame2.frame9.frame7.frame0.value 

  # build widget $topwin(restore_name).current_image.frame2.frame9.frame8.frame0.menubutton2
	menubutton $topwin(restore_name).current_image.frame2.frame9.frame8.frame0.menubutton2 -padx {1} -pady {1} -highlightthickness {0}  \
    -activebackground "$GuiColor(btn_act_bg)" \
    -background "$GuiColor(btn_bg)" \
    -font "$GuiMisc(pop_up_fn)" \
    -relief "$GuiMisc(pop_up_relief)" \
    -text "$GuiMisc(pop_up_text)" \
	 -width {2}
  # bindings
  bind $topwin(restore_name).current_image.frame2.frame9.frame8.frame0.menubutton2 <Button-1> {MenuPopupPost $topwin(restore_name).current_image.frame2.frame9.frame8.frame0.menubutton2.menu %X %Y}
  bind $topwin(restore_name).current_image.frame2.frame9.frame8.frame0.menubutton2 <ButtonRelease-1> {MenuPopupRelease $topwin(restore_name).current_image.frame2.frame9.frame8.frame0.menubutton2.menu %W}

  # build widget $topwin(restore_name).current_image.frame2.frame9.frame8.frame0.menubutton2.menu
  menu $topwin(restore_name).current_image.frame2.frame9.frame8.frame0.menubutton2.menu \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)"
  $topwin(restore_name).current_image.frame2.frame9.frame8.frame0.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -command {set restore(black_width) 32} \
    -label { 32}
  $topwin(restore_name).current_image.frame2.frame9.frame8.frame0.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -command {set restore(black_width) 64} \
    -label { 64}
  $topwin(restore_name).current_image.frame2.frame9.frame8.frame0.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -command {set restore(black_width) 128} \
    -label {128}
  $topwin(restore_name).current_image.frame2.frame9.frame8.frame0.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -command {set restore(black_width) 256} \
    -label {256}
  $topwin(restore_name).current_image.frame2.frame9.frame8.frame0.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -command {set restore(black_width) 512} \
    -label {512}
  bindtags $topwin(restore_name).current_image.frame2.frame9.frame8.frame0.menubutton2.menu {Menu all}
  # bindings
  bind $topwin(restore_name).current_image.frame2.frame9.frame8.frame0.menubutton2.menu <B1-Motion> {MenuPopupMotion $topwin(restore_name).current_image.frame2.frame9.frame8.frame0.menubutton2.menu %W %X %Y}
  bind $topwin(restore_name).current_image.frame2.frame9.frame8.frame0.menubutton2.menu <ButtonRelease-1> {MenuPopupRelease $topwin(restore_name).current_image.frame2.frame9.frame8.frame0.menubutton2.menu %W}

  # pack widget $topwin(restore_name).current_image.frame2.frame9.frame8.frame0
  pack append $topwin(restore_name).current_image.frame2.frame9.frame8.frame0 \
    $topwin(restore_name).current_image.frame2.frame9.frame8.frame0.label1 {left frame center fill} \
    $topwin(restore_name).current_image.frame2.frame9.frame8.frame0.value {left frame center expand fill} \
    $topwin(restore_name).current_image.frame2.frame9.frame8.frame0.menubutton2 {right frame center fill}

  # pack widget $topwin(restore_name).current_image.frame2.frame9.frame8
  pack append $topwin(restore_name).current_image.frame2.frame9.frame8 \
    $topwin(restore_name).current_image.frame2.frame9.frame8.frame0 {top frame center fillx}

  # pack widget $topwin(restore_name).current_image.frame2.frame9
  pack append $topwin(restore_name).current_image.frame2.frame9 \
    $topwin(restore_name).current_image.frame2.frame9.frame7 {left frame center expand} \
    $topwin(restore_name).current_image.frame2.frame9.frame8 {left frame center expand}

  # pack widget $topwin(restore_name).current_image.frame2
  pack append $topwin(restore_name).current_image.frame2 \
    $topwin(restore_name).current_image.frame2.radiobutton5 {left frame center padx 30}

  # pack widget $topwin(restore_name).current_image
  pack append $topwin(restore_name).current_image \
    $topwin(restore_name).current_image.frame1 {top frame center expand fill} \
    $topwin(restore_name).current_image.frame2 {top frame center expand fill}

  # build widget $topwin(restore_name).perform
  frame $topwin(restore_name).perform \
    -background "$GuiColor(frame_bg)" \
    -borderwidth {2} \
    -relief {raised}

  # build widget $topwin(restore_name).perform.button25
	button $topwin(restore_name).perform.button25 -padx {1} -pady {1} -highlightthickness {0}  \
    -activebackground "$GuiColor(dis_act_bg)" \
    -background "$GuiColor(dis_bg)" \
    -foreground "$GuiColor(dis_fg)" \
	 -command {destroy $topwin(restore_name); set topwin(restore_name) NONE } \
    -text {DISMISS}

  # build widget $topwin(restore_name).perform.button26
	button $topwin(restore_name).perform.button26 -padx {1} -pady {1} -highlightthickness {0}  \
    -activebackground  "$GuiColor(perf_act_bg)" \
    -background "$GuiColor(perf_bg)" \
    -foreground "$GuiColor(perf_fg)" \
	 -command {
		$topwin(restore_name) configure -cursor watch; update
		if { $restore(noise_img) == "current" } {
		$topwin(restore_name) configure -cursor watch; update
	      if {$current_image == ""} {
  	       CvipAlert "Please select an image first."
				$topwin(restore_name) configure -cursor top_left_arrow; update
  	       return
  	    }  
		 set temp $current_image
		} else {
			if [catch {expr $restore(black_width) + $restore(black_height)} ] {
               CvipAlert "Numerical values required for the black image size: \n \
                  Height = $restore(black_height), Width = $restore(black_width)."
					$topwin(restore_name) configure -cursor top_left_arrow; update
					return
			} elseif { $restore(black_width) < 1 || $restore(black_height) < 1 } {
               CvipAlert "The black image size should be positive integers: \n \
                  Height = $restore(black_height), Width = $restore(black_width)."
					$topwin(restore_name) configure -cursor top_left_arrow; update
					return
			}
			set restore(black_height) [expr int(floor($restore(black_height)))]
			set restore(black_width) [expr int(floor($restore(black_width)))]
			set temp [cvip black $restore(black_width) $restore(black_height)]

		}

		set temp1 [string trimright $restore(noise) _noise]
		switch -exact -- $restore(noise) {
			rayleigh_noise -
			negative_exp_noise {
            if [catch {expr $restore(ns_var)}] {
               CvipAlert "Numerical values required for the Variance value: \n \
                  Variance = $restore(ns_var)."
					$topwin(restore_name) configure -cursor top_left_arrow; update
               return
            } elseif {$restore(ns_var) < 0 || $restore(ns_var) > 65535} {
               CvipAlert "The Variance value (=$restore(ns_var)) should be \n\
               in the range (0--65530)."
					$topwin(restore_name) configure -cursor top_left_arrow; update
               return
            }
            if [catch {set result [cvip $restore(noise) $temp $restore(ns_var)]} cresult] {
               CvipAlert "$cresult."
					$topwin(restore_name) configure -cursor top_left_arrow; update
               return
            } else {
               set new_name [cvip rename $result ${temp}_$temp1]
               img_q insert end $new_name
               image_post $new_name
               cvip view $new_name
					CvipMessage "$temp1 noise added to image \"$temp\""
            }
				if { $GUI_DEBUG == 1 } {
            	puts "cvip $restore(noise) $temp $restore(ns_var)"
				}
			}
			gaussian_noise -
			uniform_noise {
            if [catch {expr $restore(ns_var) + $restore(ns_mean)}] {
               CvipAlert "Numerical values required for the Variance  and Mean value: \n \
                  Variance = $restore(ns_var), Mean = $restore(ns_mean)."
					$topwin(restore_name) configure -cursor top_left_arrow; update
               return
            } elseif {$restore(ns_var) < 0 || $restore(ns_var) > 65535} {
               CvipAlert "The Variance value (=$restore(ns_var)) should be \n\
               in the range (0--65535)."
					$topwin(restore_name) configure -cursor top_left_arrow; update
               return
            } elseif {$restore(ns_mean) < -128 || $restore(ns_mean) > 128 } {
               CvipAlert "The Mean value (=$restore(ns_mean)) should be \n\
               in the range (-128 -- 128)."
					$topwin(restore_name) configure -cursor top_left_arrow; update
               return
				}
            if [catch {set result [cvip $restore(noise) $temp $restore(ns_var)\
							$restore(ns_mean)]} cresult] {
               CvipAlert "$cresult."
					$topwin(restore_name) configure -cursor top_left_arrow; update
               return
            } else {
               set new_name [cvip rename $result ${temp}_$temp1]
               img_q insert end $new_name
               image_post $new_name
               cvip view $new_name
					CvipMessage "$temp1 noise added to image \"$temp\""
            }
				if { $GUI_DEBUG == 1 } {
            	puts "cvip $restore(noise) $temp $restore(ns_var) $restore(ns_mean)"
				}
			}

			gamma_noise {
            if [catch {expr $restore(ns_var) + $restore(ns_alpha)}] {
               CvipAlert "Numerical values required for the Variance  and Alpha value: \n \
                  Variance = $restore(ns_var), Alpha = $restore(ns_alpha)."
					$topwin(restore_name) configure -cursor top_left_arrow; update
               return
            } elseif {$restore(ns_var) < 0 || $restore(ns_var) > 65535} {
               CvipAlert "The Variance value (=$restore(ns_var)) should be \n\
               in the range (0--65535)."
					$topwin(restore_name) configure -cursor top_left_arrow; update
               return
            } elseif {$restore(ns_alpha) < 1} {
               CvipAlert "The Alpha value (=$restore(ns_alpha)) should be \n\
               greater than or equal to 1."
					$topwin(restore_name) configure -cursor top_left_arrow; update
               return
				}
            if [catch {set result [cvip $restore(noise) $temp $restore(ns_var)\
							$restore(ns_alpha)]} cresult] {
               CvipAlert "$cresult."
					$topwin(restore_name) configure -cursor top_left_arrow; update
               return
            } else {
               set new_name [cvip rename $result ${temp}_$temp1]
               img_q insert end $new_name
               image_post $new_name
               cvip view $new_name
					CvipMessage "$temp1 noise added to image \"$temp\""
            }
				if { $GUI_DEBUG == 1 } {
            	puts "cvip $restore(noise) $temp $restore(ns_var) $restore(ns_alpha)"
				}
			}

			speckle_noise {
            if [catch {expr $restore(ns_pepper) + $restore(ns_salt)}] {
               CvipAlert "Numerical values required for the probability of salt and pepper: \n \
                  Pepper = $restore(ns_pepper), Salt = $restore(ns_salt)."
					$topwin(restore_name) configure -cursor top_left_arrow; update
               return
            } elseif {$restore(ns_pepper) < 0 || $restore(ns_salt) < 0} {
               CvipAlert "Positive values required for the probability of salt and pepper: \n \
                  Pepper = $restore(ns_pepper), Salt = $restore(ns_salt)."
					$topwin(restore_name) configure -cursor top_left_arrow; update
               return
            } elseif { $restore(ns_pepper) + $restore(ns_salt) > 1} {
               CvipAlert "The total probability of salt and pepper ($restore(ns_pepper) +\
					$restore(ns_salt) = [expr $restore(ns_pepper) + $restore(ns_salt)]) \
               should be less than or equal to 1."
					$topwin(restore_name) configure -cursor top_left_arrow; update
               return
				}
            if [catch {set result [cvip $restore(noise) $temp $restore(ns_salt)\
							$restore(ns_pepper)]} cresult] {
               CvipAlert "$cresult."
					$topwin(restore_name) configure -cursor top_left_arrow; update
               return
            } else {
               set new_name [cvip rename $result ${temp}_$temp1]
               img_q insert end $new_name
               image_post $new_name
               cvip view $new_name
					CvipMessage "$temp1 noise added to image \"$temp\""
            }
				if { $GUI_DEBUG == 1 } {
            	puts "cvip $restore(noise) $temp $restore(ns_salt) $restore(ns_pepper)"
				}

			}
		}
		$topwin(restore_name) configure -cursor top_left_arrow; update
	 } \
    -text {PERFORM}

  # pack widget $topwin(restore_name).perform
  pack append $topwin(restore_name).perform \
    $topwin(restore_name).perform.button25 {left frame center} \
    $topwin(restore_name).perform.button26 {right frame center}

  # pack widget $topwin(restore_name)
  pack append $topwin(restore_name) \
    $topwin(restore_name).info {top frame center expand fill} \
    $topwin(restore_name).current_image {top frame center fillx} \
    $topwin(restore_name).perform {bottom frame center fillx}

  if {"[info procs XFEdit]" != ""} {
    catch "XFMiscBindWidgetTree ."
    after 2 "catch {XFEditSetShowWindows}"
  }
}

