# **********************************************************************
# Computer Vision/Image Processing Tool Project - Dr. Scott Umbaugh SIUE
# **********************************************************************
#
#             File Name: restore_spatial.tcl
#           Description: 
#         Related Files: 
#   Initial Coding Date: Thu Aug 29 20:34:57 CDT 1996
#           Portability: TCL script file
#            References:
#             Author(s): Yansheng Wei and Mark Zuke
#                        Southern Illinois University @ Edwardsville
#
## Copyright (C) 1996 SIUE - by Scott Umbaugh, Yansheng Wei and Mark Zuke.
##
## Permission to use, copy, modify, and distribute this software and its
## documentation for any purpose and without fee is hereby granted, provided
## that the above copyright notice appear in all copies and that both that
## copyright notice and this permission notice appear in supporting
## documentation.  This software is provided "as is" without express or
## implied warranty.
##
# RCS (Revision Control System) Information
# ...Added automatically by RCS 
#
## $Log: restore_spatial.tcl,v $
## Revision 1.16  1997/06/25 19:46:43  yawei
## GUI configuration in place
##
## Revision 1.15  1997/03/12 00:18:48  yawei
## fixed arrow buttons
##
## Revision 1.14  1997/03/11 20:56:41  yawei
## Tcl/Tk script upgrading from tcl7.3/tk3.6 to tcl7.6/tk4.2
## compatible. This process is automated with tkboost perl
## script. @ Tue Mar 11 14:51:36 CST 1997
##
## Revision 1.13  1996/12/24 20:35:32  yawei
## Changed name:
##
##   mini_filter ==> minimum_filter
##   max_filter  ==> maximum_filter
##
# Revision 1.12  1996/10/22  18:50:10  yawei
# changed the popup values of spatial-contrast
#
# Revision 1.11  1996/10/18  03:33:50  yawei
# Changed MMSE Variance to "Noise Variance"
#
# Revision 1.10  1996/10/17  23:06:04  yawei
# changed adaptive_constrast so it will print the execution commands to the screen.
#
# Revision 1.9  1996/10/17  23:01:03  yawei
#  Added adaptive_contrast.
#
# Revision 1.8  1996/10/16  18:53:13  yawei
# general changes
#
# Revision 1.7  1996/10/10  20:25:27  yawei
# added "13" and "15" to the MMSE kernel size
#
# Revision 1.6  1996/10/08  01:22:41  yawei
# connected the mmse_filter
#
# Revision 1.5  1996/09/27  18:29:56  mzuke
#  made window resizable
#
# Revision 1.4  1996/09/20  14:19:57  mzuke
# added kernel and variance entries to MMSE
#
# Revision 1.3  1996/09/18  15:13:51  mzuke
# changed 'symbol' font calls to full description
# of font for portability
#
# Revision 1.2  1996/09/03  13:20:13  yawei
# changed alert message for Yp_mean
#
# Revision 1.1  1996/08/30  01:35:41  yawei
# Initial revision
#
#
#****************************************************************************
#!/opt/apps3/local/bin/wish -f
# Program: restore_spat_filtE
# Tcl version: 7.3 (Tcl/Tk/XF)
# Tk version: 3.6
# XF version: 2.3
#


# procedure to show window $topwin(restore_name)
proc spat_filters { } {# xf ignore me 7

  # Window manager configurations
  global tk_version
  global topwin
  global {GuiColor}
  global {GuiMisc}
  global toplevel_position
  global {restore}

  set restore(spatial_filter) "median_filter"
  if [ winfo exists $topwin(restore_name).info] {
     set tempname $topwin(restore_name);\
destroy $topwin(restore_name).info;\
set topwin(restore_name) $tempname;}
  if [ winfo exists $topwin(restore_name).current_image] {
     set tempname $topwin(restore_name);\
destroy $topwin(restore_name).current_image;\
set topwin(restore_name) $tempname;}
  if [ winfo exists $topwin(restore_name).perform] {
     set tempname $topwin(restore_name);\
destroy $topwin(restore_name).perform;\
set topwin(restore_name) $tempname;}
  bind $topwin(restore_name) <Destroy> {set topwin(restore_name) NONE}

  wm positionfrom $topwin(restore_name) user
  wm sizefrom $topwin(restore_name) user
  wm geometry $topwin(restore_name) $topwin(restore_spatial)[get_pos $topwin(restore_name)]
  wm maxsize $topwin(restore_name) [lindex $topwin(restore_spatial_max) 0] \
  	[lindex $topwin(restore_spatial_max) 1]
  wm minsize $topwin(restore_name) [lindex $topwin(restore_spatial_min) 0] \
  	[lindex $topwin(restore_spatial_min) 1]
  wm title $topwin(restore_name) {RESTORATION -> Spatial filters}

  # build widget $topwin(restore_name).info
  frame $topwin(restore_name).info \
    -background "$GuiColor(frame_bg)" \
    -borderwidth {0}

  # build widget $topwin(restore_name).info.frame11
  frame $topwin(restore_name).info.frame11 \
    -background "$GuiColor(frame_bg)" \
    -borderwidth {2} \
    -relief {ridge}

  # build widget $topwin(restore_name).info.frame11.frame17
  frame $topwin(restore_name).info.frame11.frame17 \
    -background "$GuiColor(frame_bg)" \
    -borderwidth {2}

  # build widget $topwin(restore_name).info.frame11.frame17.radiobutton19
	radiobutton $topwin(restore_name).info.frame11.frame17.radiobutton19 -padx {1} -pady {1} -highlightthickness {0}  \
    -activebackground "$GuiColor(btn_act_bg)" \
    -background "$GuiColor(btn_bg)" \
    -command {pack forget $topwin(restore_name).info.frame11.frame18.frame4.frame
	pack forget $topwin(restore_name).info.frame13.frame7.frame19.frame0 } \
    -relief {flat} \
    -text {Median} \
    -value {median_filter} \
    -variable {restore(spatial_filter)}

  # build widget $topwin(restore_name).info.frame11.frame17.radiobutton20
	radiobutton $topwin(restore_name).info.frame11.frame17.radiobutton20 -padx {1} -pady {1} -highlightthickness {0}  \
    -activebackground "$GuiColor(btn_act_bg)" \
    -background "$GuiColor(btn_bg)" \
    -command {pack forget $topwin(restore_name).info.frame11.frame18.frame4.frame
pack forget $topwin(restore_name).info.frame13.frame7.frame19.frame0 } \
    -relief {flat} \
    -text {Minimum} \
    -value {minimum_filter} \
    -variable {restore(spatial_filter)}

  # build widget $topwin(restore_name).info.frame11.frame17.radiobutton21
	radiobutton $topwin(restore_name).info.frame11.frame17.radiobutton21 -padx {1} -pady {1} -highlightthickness {0}  \
    -activebackground "$GuiColor(btn_act_bg)" \
    -background "$GuiColor(btn_bg)" \
    -command {pack forget $topwin(restore_name).info.frame11.frame18.frame4.frame
pack forget $topwin(restore_name).info.frame13.frame7.frame19.frame0 
} \
    -relief {flat} \
    -text {Midpoint} \
    -value {midpoint_filter} \
    -variable {restore(spatial_filter)}

  # build widget $topwin(restore_name).info.frame11.frame17.radiobutton22
	radiobutton $topwin(restore_name).info.frame11.frame17.radiobutton22 -padx {1} -pady {1} -highlightthickness {0}  \
    -activebackground "$GuiColor(btn_act_bg)" \
    -background "$GuiColor(btn_bg)" \
    -command {pack forget $topwin(restore_name).info.frame11.frame18.frame4.frame
pack forget $topwin(restore_name).info.frame13.frame7.frame19.frame0 
} \
    -relief {flat} \
    -text {Maximum} \
    -value {maximum_filter} \
    -variable {restore(spatial_filter)}

  # build widget $topwin(restore_name).info.frame11.frame17.radiobutton1
	radiobutton $topwin(restore_name).info.frame11.frame17.radiobutton1 -padx {1} -pady {1} -highlightthickness {0}  \
    -activebackground "$GuiColor(btn_act_bg)" \
    -background "$GuiColor(btn_bg)" \
    -command {pack $topwin(restore_name).info.frame11.frame18.frame4.frame
pack forget $topwin(restore_name).info.frame13.frame7.frame19.frame0 
} \
    -relief {flat} \
    -text {Alpha-trimmed mean} \
    -value {alpha_filter} \
    -variable {restore(spatial_filter)}

  # pack widget $topwin(restore_name).info.frame11.frame17
  pack append $topwin(restore_name).info.frame11.frame17 \
    $topwin(restore_name).info.frame11.frame17.radiobutton19 {top frame w} \
    $topwin(restore_name).info.frame11.frame17.radiobutton20 {top frame w} \
    $topwin(restore_name).info.frame11.frame17.radiobutton21 {top frame w} \
    $topwin(restore_name).info.frame11.frame17.radiobutton22 {top frame w} \
    $topwin(restore_name).info.frame11.frame17.radiobutton1 {left frame w}

  # build widget $topwin(restore_name).info.frame11.frame18
  frame $topwin(restore_name).info.frame11.frame18 \
    -background "$GuiColor(frame_bg)" \
    -borderwidth {2}

  # build widget $topwin(restore_name).info.frame11.frame18.frame0
  frame $topwin(restore_name).info.frame11.frame18.frame0 \
    -background "$GuiColor(frame_bg)" \
    -borderwidth {2}

  # build widget $topwin(restore_name).info.frame11.frame18.frame0.label1
  label $topwin(restore_name).info.frame11.frame18.frame0.label1 \
    -background "$GuiColor(label_bg)" \
    -borderwidth {0} \
    -text {Mask size: }

  # build widget $topwin(restore_name).info.frame11.frame18.frame0.value
  entry $topwin(restore_name).info.frame11.frame18.frame0.value \
    -background "$GuiColor(entry_bg)" \
    -foreground "$GuiColor(entry_fg)" \
    -relief {sunken} \
    -textvariable {restore(spat_mask)} \
    -width {3}
  endEntry $topwin(restore_name).info.frame11.frame18.frame0.value  0 \
  	 $topwin(restore_name).info.frame11.frame18.frame4.frame.entry5 \
  	 $topwin(restore_name).info.frame11.frame18.frame4.frame.entry5 

  # build widget $topwin(restore_name).info.frame11.frame18.frame0.menubutton2
	menubutton $topwin(restore_name).info.frame11.frame18.frame0.menubutton2 -padx {1} -pady {1} -highlightthickness {0}  \
    -activebackground "$GuiColor(btn_act_bg)" \
    -background "$GuiColor(btn_bg)" \
    -font "$GuiMisc(pop_up_fn)" \
    -relief "$GuiMisc(pop_up_relief)" \
    -text "$GuiMisc(pop_up_text)" \
	 -width {2}
  bind $topwin(restore_name).info.frame11.frame18.frame0.menubutton2 <Button-1> {
  MenuPopupPost $topwin(restore_name).info.frame11.frame18.frame0.menubutton2.menu %X %Y
  }
  bind $topwin(restore_name).info.frame11.frame18.frame0.menubutton2 <ButtonRelease-1> {
  MenuPopupRelease $topwin(restore_name).info.frame11.frame18.frame0.menubutton2.menu %W
  }
  # build widget $topwin(restore_name).info.frame11.frame18.frame0.menubutton2.menu
  menu $topwin(restore_name).info.frame11.frame18.frame0.menubutton2.menu \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)"
  $topwin(restore_name).info.frame11.frame18.frame0.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -command {set restore(spat_mask) 3} \
    -label {  3 } \
    -state {active}
  $topwin(restore_name).info.frame11.frame18.frame0.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -command {set restore(spat_mask) 5} \
    -label {  5 }
  $topwin(restore_name).info.frame11.frame18.frame0.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -command {set restore(spat_mask) 7} \
    -label {  7 }
  $topwin(restore_name).info.frame11.frame18.frame0.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -command {set restore(spat_mask) 9} \
    -label {  9 }
  $topwin(restore_name).info.frame11.frame18.frame0.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -command {set restore(spat_mask) 11} \
    -label { 11 }
  bindtags  $topwin(restore_name).info.frame11.frame18.frame0.menubutton2.menu {Menu all}
  bind $topwin(restore_name).info.frame11.frame18.frame0.menubutton2.menu <B1-Motion> {
  MenuPopupMotion $topwin(restore_name).info.frame11.frame18.frame0.menubutton2.menu %W %X %Y
  }
  bind $topwin(restore_name).info.frame11.frame18.frame0.menubutton2.menu <ButtonRelease-1> {
  MenuPopupRelease $topwin(restore_name).info.frame11.frame18.frame0.menubutton2.menu %W
  }

  # pack widget $topwin(restore_name).info.frame11.frame18.frame0
  pack append $topwin(restore_name).info.frame11.frame18.frame0 \
    $topwin(restore_name).info.frame11.frame18.frame0.label1 {left frame center fill} \
    $topwin(restore_name).info.frame11.frame18.frame0.value {left frame center expand fill} \
    $topwin(restore_name).info.frame11.frame18.frame0.menubutton2 {right frame center fill}

  # build widget $topwin(restore_name).info.frame11.frame18.frame4
  frame $topwin(restore_name).info.frame11.frame18.frame4 \
    -background "$GuiColor(frame_bg)" \
    -borderwidth {2}

  # build widget $topwin(restore_name).info.frame11.frame18.frame4.frame
  frame $topwin(restore_name).info.frame11.frame18.frame4.frame \
    -background "$GuiColor(frame_bg)" \
    -relief {raised}

  # build widget $topwin(restore_name).info.frame11.frame18.frame4.frame.label4
  label $topwin(restore_name).info.frame11.frame18.frame4.frame.label4 \
    -background "$GuiColor(label_bg)" \
    -padx {2} \
    -text {Trim size: }

  # build widget $topwin(restore_name).info.frame11.frame18.frame4.frame.entry5
  entry $topwin(restore_name).info.frame11.frame18.frame4.frame.entry5 \
    -background "$GuiColor(entry_bg)" \
    -foreground "$GuiColor(entry_fg)" \
    -relief {sunken} \
    -textvariable {restore(spat_trim)} \
    -width {3}
  endEntry $topwin(restore_name).info.frame11.frame18.frame4.frame.entry5 0 \
  	 $topwin(restore_name).info.frame11.frame18.frame0.value  \
  	 $topwin(restore_name).info.frame11.frame18.frame0.value 

  # build widget $topwin(restore_name).info.frame11.frame18.frame4.frame.label3
  label $topwin(restore_name).info.frame11.frame18.frame4.frame.label3 \
    -background "$GuiColor(label_bg)" \
    -text {(from 0 to mask size)}

  # pack widget $topwin(restore_name).info.frame11.frame18.frame4.frame
  pack append $topwin(restore_name).info.frame11.frame18.frame4.frame \
    $topwin(restore_name).info.frame11.frame18.frame4.frame.label4 {left frame center} \
    $topwin(restore_name).info.frame11.frame18.frame4.frame.entry5 {left frame center expand fill} \
    $topwin(restore_name).info.frame11.frame18.frame4.frame.label3 {top frame center}

  # pack widget $topwin(restore_name).info.frame11.frame18
  pack append $topwin(restore_name).info.frame11.frame18 \
    $topwin(restore_name).info.frame11.frame18.frame0 {top frame center } \
    $topwin(restore_name).info.frame11.frame18.frame4 {bottom frame center }

  # build widget $topwin(restore_name).info.frame11.frame23
  frame $topwin(restore_name).info.frame11.frame23 \
    -background "$GuiColor(frame_bg)" \
    -borderwidth {2}

  # build widget $topwin(restore_name).info.frame11.frame23.label24
  label $topwin(restore_name).info.frame11.frame23.label24 \
    -background "$GuiColor(label_bg)" \
    -text {ORDER FILTERS}

  # pack widget $topwin(restore_name).info.frame11.frame23
  pack append $topwin(restore_name).info.frame11.frame23 \
    $topwin(restore_name).info.frame11.frame23.label24 {left frame center}

  # pack widget $topwin(restore_name).info.frame11
  pack append $topwin(restore_name).info.frame11 \
    $topwin(restore_name).info.frame11.frame23 {top frame center fillx} \
    $topwin(restore_name).info.frame11.frame17 {left frame center} \
    $topwin(restore_name).info.frame11.frame18 {top frame center expand fill}

  # build widget $topwin(restore_name).info.frame13
  frame $topwin(restore_name).info.frame13 \
    -background "$GuiColor(frame_bg)" \
    -borderwidth {2} \
    -relief {ridge}

  # build widget $topwin(restore_name).info.frame13.frame5
  frame $topwin(restore_name).info.frame13.frame5 \
    -background "$GuiColor(frame_bg)" \
    -borderwidth {2}

  # build widget $topwin(restore_name).info.frame13.frame5.label24
  label $topwin(restore_name).info.frame13.frame5.label24 \
    -background "$GuiColor(label_bg)" \
    -text {MEAN FILTERS}

  # pack widget $topwin(restore_name).info.frame13.frame5
  pack append $topwin(restore_name).info.frame13.frame5 \
    $topwin(restore_name).info.frame13.frame5.label24 {left frame center}

  # build widget $topwin(restore_name).info.frame13.frame6
  frame $topwin(restore_name).info.frame13.frame6 \
    -background "$GuiColor(frame_bg)" \
    -borderwidth {2}

  # build widget $topwin(restore_name).info.frame13.frame6.radiobutton19
	radiobutton $topwin(restore_name).info.frame13.frame6.radiobutton19 -padx {1} -pady {1} -highlightthickness {0}  \
    -activebackground "$GuiColor(btn_act_bg)" \
    -background "$GuiColor(btn_bg)" \
    -command {pack forget $topwin(restore_name).info.frame13.frame7.frame19.frame0 
pack forget $topwin(restore_name).info.frame11.frame18.frame4.frame
} \
    -relief {flat} \
    -text {Arithmetic} \
    -value {mean_filter} \
    -variable {restore(spatial_filter)}

  # build widget $topwin(restore_name).info.frame13.frame6.radiobutton10
	radiobutton $topwin(restore_name).info.frame13.frame6.radiobutton10 -padx {1} -pady {1} -highlightthickness {0}  \
    -activebackground "$GuiColor(btn_act_bg)" \
    -background "$GuiColor(btn_bg)" \
    -command {pack forget $topwin(restore_name).info.frame13.frame7.frame19.frame0 
pack forget $topwin(restore_name).info.frame11.frame18.frame4.frame

} \
    -relief {flat} \
    -text {Geometric} \
    -value {geometric_filter} \
    -variable {restore(spatial_filter)}

  # build widget $topwin(restore_name).info.frame13.frame6.radiobutton12
	radiobutton $topwin(restore_name).info.frame13.frame6.radiobutton12 -padx {1} -pady {1} -highlightthickness {0}  \
    -activebackground "$GuiColor(btn_act_bg)" \
    -background "$GuiColor(btn_bg)" \
    -command {pack forget $topwin(restore_name).info.frame13.frame7.frame19.frame0 
pack forget $topwin(restore_name).info.frame11.frame18.frame4.frame
} \
    -relief {flat} \
    -text {Harmonic} \
    -value {harmonic_filter} \
    -variable {restore(spatial_filter)}

  # build widget $topwin(restore_name).info.frame13.frame6.radiobutton14
	radiobutton $topwin(restore_name).info.frame13.frame6.radiobutton14 -padx {1} -pady {1} -highlightthickness {0}  \
    -activebackground "$GuiColor(btn_act_bg)" \
    -background "$GuiColor(btn_bg)" \
    -command {pack $topwin(restore_name).info.frame13.frame7.frame19.frame0
pack forget $topwin(restore_name).info.frame11.frame18.frame4.frame

} \
    -relief {flat} \
    -text {Contra-harmonic} \
    -value {contra_filter} \
    -variable {restore(spatial_filter)}

  # build widget $topwin(restore_name).info.frame13.frame6.radiobutton16
	radiobutton $topwin(restore_name).info.frame13.frame6.radiobutton16 -padx {1} -pady {1} -highlightthickness {0}  \
    -activebackground "$GuiColor(btn_act_bg)" \
    -background "$GuiColor(btn_bg)" \
    -command {pack $topwin(restore_name).info.frame13.frame7.frame19.frame0
pack forget $topwin(restore_name).info.frame11.frame18.frame4.frame
} \
    -relief {flat} \
    -text {Yp} \
    -value {ypmean_filter} \
    -variable {restore(spatial_filter)}

  # pack widget $topwin(restore_name).info.frame13.frame6
  pack append $topwin(restore_name).info.frame13.frame6 \
    $topwin(restore_name).info.frame13.frame6.radiobutton19 {top frame w} \
    $topwin(restore_name).info.frame13.frame6.radiobutton10 {top frame w} \
    $topwin(restore_name).info.frame13.frame6.radiobutton12 {top frame w} \
    $topwin(restore_name).info.frame13.frame6.radiobutton14 {top frame w} \
    $topwin(restore_name).info.frame13.frame6.radiobutton16 {top frame w}

  # build widget $topwin(restore_name).info.frame13.frame7
  frame $topwin(restore_name).info.frame13.frame7 \
    -background "$GuiColor(frame_bg)" \
    -borderwidth {2}

  # build widget $topwin(restore_name).info.frame13.frame7.frame18
  frame $topwin(restore_name).info.frame13.frame7.frame18 \
    -background "$GuiColor(frame_bg)" \
    -borderwidth {2}

  # build widget $topwin(restore_name).info.frame13.frame7.frame18.frame0
  frame $topwin(restore_name).info.frame13.frame7.frame18.frame0 \
    -background "$GuiColor(frame_bg)" \
    -borderwidth {2}

  # build widget $topwin(restore_name).info.frame13.frame7.frame18.frame0.label1
  label $topwin(restore_name).info.frame13.frame7.frame18.frame0.label1 \
    -background "$GuiColor(label_bg)" \
    -borderwidth {0} \
    -text {Mask size: }

  # build widget $topwin(restore_name).info.frame13.frame7.frame18.frame0.value
  entry $topwin(restore_name).info.frame13.frame7.frame18.frame0.value \
    -background "$GuiColor(entry_bg)" \
    -foreground "$GuiColor(entry_fg)" \
    -relief {sunken} \
    -textvariable {restore(spat_mask)} \
    -width {3}
  endEntry $topwin(restore_name).info.frame13.frame7.frame18.frame0.value 

  # build widget $topwin(restore_name).info.frame13.frame7.frame18.frame0.menubutton2
	menubutton $topwin(restore_name).info.frame13.frame7.frame18.frame0.menubutton2 -padx {1} -pady {1} -highlightthickness {0}  \
    -activebackground "$GuiColor(btn_act_bg)" \
    -background "$GuiColor(btn_bg)" \
    -font "$GuiMisc(pop_up_fn)" \
    -relief "$GuiMisc(pop_up_relief)" \
    -text "$GuiMisc(pop_up_text)" \
	 -width {2}
  bind $topwin(restore_name).info.frame13.frame7.frame18.frame0.menubutton2 <Button-1> {
  MenuPopupPost $topwin(restore_name).info.frame13.frame7.frame18.frame0.menubutton2.menu %X %Y
  }
  bind $topwin(restore_name).info.frame13.frame7.frame18.frame0.menubutton2 <ButtonRelease-1> {
  MenuPopupRelease $topwin(restore_name).info.frame13.frame7.frame18.frame0.menubutton2.menu %W
  }

  # build widget $topwin(restore_name).info.frame13.frame7.frame18.frame0.menubutton2.menu
  menu $topwin(restore_name).info.frame13.frame7.frame18.frame0.menubutton2.menu \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)"
  $topwin(restore_name).info.frame13.frame7.frame18.frame0.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -command {set restore(spat_mask) 3} \
    -label {  3 }
  $topwin(restore_name).info.frame13.frame7.frame18.frame0.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -command {set restore(spat_mask) 5} \
    -label {  5 }
  $topwin(restore_name).info.frame13.frame7.frame18.frame0.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -command {set restore(spat_mask) 7} \
    -label {  7 }
  $topwin(restore_name).info.frame13.frame7.frame18.frame0.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -command {set restore(spat_mask) 9} \
    -label {  9 }
  $topwin(restore_name).info.frame13.frame7.frame18.frame0.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -command {set restore(spat_mask) 11} \
    -label { 11 }
  bindtags $topwin(restore_name).info.frame13.frame7.frame18.frame0.menubutton2.menu  {Menu all}
  bind $topwin(restore_name).info.frame13.frame7.frame18.frame0.menubutton2.menu <B1-Motion> {
  MenuPopupMotion $topwin(restore_name).info.frame13.frame7.frame18.frame0.menubutton2.menu %W %X %Y
  }
  bind $topwin(restore_name).info.frame13.frame7.frame18.frame0.menubutton2.menu <ButtonRelease-1> {
  MenuPopupRelease $topwin(restore_name).info.frame13.frame7.frame18.frame0.menubutton2.menu %W
  }

  # pack widget $topwin(restore_name).info.frame13.frame7.frame18.frame0
  pack append $topwin(restore_name).info.frame13.frame7.frame18.frame0 \
    $topwin(restore_name).info.frame13.frame7.frame18.frame0.label1 {left frame center fill} \
    $topwin(restore_name).info.frame13.frame7.frame18.frame0.value {left frame center expand fill} \
    $topwin(restore_name).info.frame13.frame7.frame18.frame0.menubutton2 {right frame center fill}

  # pack widget $topwin(restore_name).info.frame13.frame7.frame18
  pack append $topwin(restore_name).info.frame13.frame7.frame18 \
    $topwin(restore_name).info.frame13.frame7.frame18.frame0 {top frame center expand}

  # build widget $topwin(restore_name).info.frame13.frame7.frame19
  frame $topwin(restore_name).info.frame13.frame7.frame19 \
    -background "$GuiColor(frame_bg)" \
    -borderwidth {2}

  # build widget $topwin(restore_name).info.frame13.frame7.frame19.frame0
  frame $topwin(restore_name).info.frame13.frame7.frame19.frame0 \
    -background "$GuiColor(frame_bg)" \
    -borderwidth {2}

  # build widget $topwin(restore_name).info.frame13.frame7.frame19.frame0.label1
  label $topwin(restore_name).info.frame13.frame7.frame19.frame0.label1 \
    -background "$GuiColor(label_bg)" \
    -borderwidth {0} \
    -text {Filter order:  }

  # build widget $topwin(restore_name).info.frame13.frame7.frame19.frame0.value
  entry $topwin(restore_name).info.frame13.frame7.frame19.frame0.value \
    -background "$GuiColor(rentry_bg)" \
    -foreground "$GuiColor(rentry_fg)" \
    -relief {sunken} \
    -state {disabled} \
    -textvariable {restore(spat_order)} \
    -width {3}

  # build widget $topwin(restore_name).info.frame13.frame7.frame19.frame0.menubutton2
	menubutton $topwin(restore_name).info.frame13.frame7.frame19.frame0.menubutton2 -padx {1} -pady {1} -highlightthickness {0}  \
    -activebackground "$GuiColor(btn_act_bg)" \
    -background "$GuiColor(btn_bg)" \
    -font "$GuiMisc(pop_up_fn)" \
    -relief "$GuiMisc(pop_up_relief)" \
    -text "$GuiMisc(pop_up_text)" \
	 -width {2}
  bind $topwin(restore_name).info.frame13.frame7.frame19.frame0.menubutton2 <Button-1> {
  MenuPopupPost $topwin(restore_name).info.frame13.frame7.frame19.frame0.menubutton2.menu %X %Y
  }
  bind $topwin(restore_name).info.frame13.frame7.frame19.frame0.menubutton2 <ButtonRelease-1> {
  MenuPopupRelease $topwin(restore_name).info.frame13.frame7.frame19.frame0.menubutton2.menu %W 
  }

  # build widget $topwin(restore_name).info.frame13.frame7.frame19.frame0.menubutton2.menu
  menu $topwin(restore_name).info.frame13.frame7.frame19.frame0.menubutton2.menu \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)"
  $topwin(restore_name).info.frame13.frame7.frame19.frame0.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -command {set restore(spat_order) -5} \
    -label { -5 }
  $topwin(restore_name).info.frame13.frame7.frame19.frame0.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -command {set restore(spat_order) -4} \
    -label { -4 }
  $topwin(restore_name).info.frame13.frame7.frame19.frame0.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -command {set restore(spat_order) -3} \
    -label { -3 }
  $topwin(restore_name).info.frame13.frame7.frame19.frame0.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -command {set restore(spat_order) -2} \
    -label { -2 }
  $topwin(restore_name).info.frame13.frame7.frame19.frame0.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -command {set restore(spat_order) -1} \
    -label { -1 }
  $topwin(restore_name).info.frame13.frame7.frame19.frame0.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -command {set restore(spat_order) 0} \
    -label {  0 }
  $topwin(restore_name).info.frame13.frame7.frame19.frame0.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -command {set restore(spat_order) 1} \
    -label { +1 }
  $topwin(restore_name).info.frame13.frame7.frame19.frame0.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -command {set restore(spat_order) 2} \
    -label { +2 }
  $topwin(restore_name).info.frame13.frame7.frame19.frame0.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -command {set restore(spat_order) 3} \
    -label { +3 }
  $topwin(restore_name).info.frame13.frame7.frame19.frame0.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -command {set restore(spat_order) 4} \
    -label { +4 }
  $topwin(restore_name).info.frame13.frame7.frame19.frame0.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -command {set restore(spat_order) 5} \
    -label { +5 }
  bindtags $topwin(restore_name).info.frame13.frame7.frame19.frame0.menubutton2.menu  {Menu all}
  bind $topwin(restore_name).info.frame13.frame7.frame19.frame0.menubutton2.menu <B1-Motion> {
  MenuPopupMotion $topwin(restore_name).info.frame13.frame7.frame19.frame0.menubutton2.menu %W %X %Y
  }
  bind $topwin(restore_name).info.frame13.frame7.frame19.frame0.menubutton2.menu <ButtonRelease-1> {
  MenuPopupRelease $topwin(restore_name).info.frame13.frame7.frame19.frame0.menubutton2.menu %W 
  }

  # pack widget $topwin(restore_name).info.frame13.frame7.frame19.frame0
  pack append $topwin(restore_name).info.frame13.frame7.frame19.frame0 \
    $topwin(restore_name).info.frame13.frame7.frame19.frame0.label1 {left frame center fill} \
    $topwin(restore_name).info.frame13.frame7.frame19.frame0.value {left frame center expand fill} \
    $topwin(restore_name).info.frame13.frame7.frame19.frame0.menubutton2 {right frame center fill}

  # pack widget $topwin(restore_name).info.frame13.frame7
  pack append $topwin(restore_name).info.frame13.frame7 \
    $topwin(restore_name).info.frame13.frame7.frame18 {top frame center} \
    $topwin(restore_name).info.frame13.frame7.frame19 {bottom frame center}

  # pack widget $topwin(restore_name).info.frame13
  pack append $topwin(restore_name).info.frame13 \
    $topwin(restore_name).info.frame13.frame5 {top frame center fillx} \
    $topwin(restore_name).info.frame13.frame6 {left frame center} \
    $topwin(restore_name).info.frame13.frame7 {left frame center expand fill}

  # build widget $topwin(restore_name).info.frame20
  frame $topwin(restore_name).info.frame20 \
    -background "$GuiColor(frame_bg)" \
    -borderwidth {2} \
    -relief {ridge}

  # build widget $topwin(restore_name).info.frame20.frame21
  frame $topwin(restore_name).info.frame20.frame21 \
    -background "$GuiColor(frame_bg)" \
    -borderwidth {2}

  # build widget $topwin(restore_name).info.frame20.frame21.label24
  label $topwin(restore_name).info.frame20.frame21.label24 \
    -background "$GuiColor(label_bg)" \
    -text {ADAPTIVE FILTERS}

  # pack widget $topwin(restore_name).info.frame20.frame21
  pack append $topwin(restore_name).info.frame20.frame21 \
    $topwin(restore_name).info.frame20.frame21.label24 {left frame center}

  # build widget $topwin(restore_name).info.frame20.frame20
  frame $topwin(restore_name).info.frame20.frame20 \
    -background "$GuiColor(frame_bg)" \
    -borderwidth {2}

  # build widget $topwin(restore_name).info.frame20.frame20.frame1
  frame $topwin(restore_name).info.frame20.frame20.frame1 \
    -background "$GuiColor(frame_bg)" \
    -borderwidth {0}

  # build widget $topwin(restore_name).info.frame20.frame20.frame1.radiobutton16
	radiobutton $topwin(restore_name).info.frame20.frame20.frame1.radiobutton16 -padx {1} -pady {1} -highlightthickness {0}  \
    -activebackground "$GuiColor(btn_act_bg)" \
    -background "$GuiColor(btn_bg)" \
    -command {pack forget $topwin(restore_name).info.frame13.frame7.frame19.frame0 
pack forget $topwin(restore_name).info.frame11.frame18.frame4.frame
} \
    -relief {flat} \
    -text {MMSE} \
    -value {mmse_filter} \
    -command {set restore(mmse_kern) 3; set restore(mmse_var) 100} \
    -variable {restore(spatial_filter)}

  # pack widget $topwin(restore_name).info.frame20.frame20.frame1
  pack append $topwin(restore_name).info.frame20.frame20.frame1 \
    $topwin(restore_name).info.frame20.frame20.frame1.radiobutton16 {top frame w}

  # build widget $topwin(restore_name).info.frame20.frame20.frame2
  frame $topwin(restore_name).info.frame20.frame20.frame2 \
    -background "$GuiColor(frame_bg)" \
    -borderwidth {2} 
  
  # build widget $topwin(restore_name).info.frame20.frame20.frame2.frame18
  frame $topwin(restore_name).info.frame20.frame20.frame2.frame18 \
    -background "$GuiColor(frame_bg)" \
    -borderwidth {2}

  # build widget $topwin(restore_name).info.frame20.frame20.frame2.frame18.frame0
  frame $topwin(restore_name).info.frame20.frame20.frame2.frame18.frame0 \
    -background "$GuiColor(frame_bg)" \
    -borderwidth {2}

  # build widget $topwin(restore_name).info.frame20.frame20.frame2.frame18.frame0.label1
  label $topwin(restore_name).info.frame20.frame20.frame2.frame18.frame0.label1 \
    -background "$GuiColor(label_bg)" \
    -borderwidth {0} \
    -text {Kernel size: }

  # build widget $topwin(restore_name).info.frame20.frame20.frame2.frame18.frame0.value
  entry $topwin(restore_name).info.frame20.frame20.frame2.frame18.frame0.value \
    -background "$GuiColor(entry_bg)" \
    -foreground "$GuiColor(entry_fg)" \
    -relief {sunken} \
    -textvariable {restore(mmse_kern)} \
    -width {3}
  endEntry $topwin(restore_name).info.frame20.frame20.frame2.frame18.frame0.value 0 \
  	 $topwin(restore_name).info.frame20.frame20.frame2.frame19.frame0.value \
  	 $topwin(restore_name).info.frame20.frame20.frame2.frame19.frame0.value 

  # build widget $topwin(restore_name).info.frame20.frame20.frame2.frame18.frame0.menubutton2
	menubutton $topwin(restore_name).info.frame20.frame20.frame2.frame18.frame0.menubutton2 -padx {1} -pady {1} -highlightthickness {0}  \
    -activebackground "$GuiColor(btn_act_bg)" \
    -background "$GuiColor(btn_bg)" \
    -font "$GuiMisc(pop_up_fn)" \
    -relief "$GuiMisc(pop_up_relief)" \
    -text "$GuiMisc(pop_up_text)" \
	 -width {2}
  bind $topwin(restore_name).info.frame20.frame20.frame2.frame18.frame0.menubutton2 <Button-1> {
  MenuPopupPost $topwin(restore_name).info.frame20.frame20.frame2.frame18.frame0.menubutton2.menu %X %Y
  }
  bind $topwin(restore_name).info.frame20.frame20.frame2.frame18.frame0.menubutton2 <ButtonRelease-1> {
  MenuPopupRelease $topwin(restore_name).info.frame20.frame20.frame2.frame18.frame0.menubutton2.menu %W
  }

  # build widget $topwin(restore_name).info.frame20.frame20.frame2.frame18.frame0.menubutton2.menu
  menu $topwin(restore_name).info.frame20.frame20.frame2.frame18.frame0.menubutton2.menu \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)"
  $topwin(restore_name).info.frame20.frame20.frame2.frame18.frame0.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -command {set restore(mmse_kern) 3} \
    -label {  3 }
  $topwin(restore_name).info.frame20.frame20.frame2.frame18.frame0.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -command {set restore(mmse_kern) 5} \
    -label {  5 }
  $topwin(restore_name).info.frame20.frame20.frame2.frame18.frame0.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -command {set restore(mmse_kern) 7} \
    -label {  7 }
  $topwin(restore_name).info.frame20.frame20.frame2.frame18.frame0.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -command {set restore(mmse_kern) 9} \
    -label {  9 }
  $topwin(restore_name).info.frame20.frame20.frame2.frame18.frame0.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -command {set restore(mmse_kern) 11} \
    -label { 11 }
  $topwin(restore_name).info.frame20.frame20.frame2.frame18.frame0.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -command {set restore(mmse_kern) 13} \
    -label { 13 }
  $topwin(restore_name).info.frame20.frame20.frame2.frame18.frame0.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -command {set restore(mmse_kern) 15} \
    -label { 15 }
  bindtags $topwin(restore_name).info.frame20.frame20.frame2.frame18.frame0.menubutton2.menu {Menu all}
  bind $topwin(restore_name).info.frame20.frame20.frame2.frame18.frame0.menubutton2.menu <B1-Motion> {
  MenuPopupMotion $topwin(restore_name).info.frame20.frame20.frame2.frame18.frame0.menubutton2.menu %W %X %Y
  }
  bind $topwin(restore_name).info.frame20.frame20.frame2.frame18.frame0.menubutton2.menu <ButtonRelease-1> {
  MenuPopupRelease $topwin(restore_name).info.frame20.frame20.frame2.frame18.frame0.menubutton2.menu %W
  }

  # pack widget $topwin(restore_name).info.frame20.frame20.frame2.frame18.frame0
  pack append $topwin(restore_name).info.frame20.frame20.frame2.frame18.frame0 \
    $topwin(restore_name).info.frame20.frame20.frame2.frame18.frame0.label1 {left frame center fill} \
    $topwin(restore_name).info.frame20.frame20.frame2.frame18.frame0.value {left frame center expand fill} \
    $topwin(restore_name).info.frame20.frame20.frame2.frame18.frame0.menubutton2 {right frame center fill}

  # pack widget $topwin(restore_name).info.frame20.frame20.frame2.frame18
  pack append $topwin(restore_name).info.frame20.frame20.frame2.frame18 \
    $topwin(restore_name).info.frame20.frame20.frame2.frame18.frame0 {top frame center expand}

  # build widget $topwin(restore_name).info.frame20.frame20.frame2.frame19
  frame $topwin(restore_name).info.frame20.frame20.frame2.frame19 \
    -background "$GuiColor(frame_bg)" \
    -borderwidth {2}

  # build widget $topwin(restore_name).info.frame20.frame20.frame2.frame19.frame0
  frame $topwin(restore_name).info.frame20.frame20.frame2.frame19.frame0 \
    -background "$GuiColor(frame_bg)" \
    -borderwidth {2}

  # build widget $topwin(restore_name).info.frame20.frame20.frame2.frame19.frame0.label1
  label $topwin(restore_name).info.frame20.frame20.frame2.frame19.frame0.label1 \
    -background "$GuiColor(label_bg)" \
    -borderwidth {0} \
    -text {Noise variance: }

  # build widget $topwin(restore_name).info.frame20.frame20.frame2.frame19.frame0.value
  entry $topwin(restore_name).info.frame20.frame20.frame2.frame19.frame0.value \
    -background "$GuiColor(entry_bg)" \
    -foreground "$GuiColor(entry_fg)" \
    -relief {sunken} \
    -textvariable {restore(mmse_var)} \
    -width {5}
  endEntry $topwin(restore_name).info.frame20.frame20.frame2.frame19.frame0.value 0 \
  	 $topwin(restore_name).info.frame20.frame20.frame2.frame18.frame0.value \
  	 $topwin(restore_name).info.frame20.frame20.frame2.frame18.frame0.value 

  # build widget $topwin(restore_name).info.frame20.frame20.frame2.frame19.frame0.menubutton2
	menubutton $topwin(restore_name).info.frame20.frame20.frame2.frame19.frame0.menubutton2 -padx {1} -pady {1} -highlightthickness {0}  \
    -activebackground "$GuiColor(btn_act_bg)" \
    -background "$GuiColor(btn_bg)" \
    -font "$GuiMisc(pop_up_fn)" \
    -relief "$GuiMisc(pop_up_relief)" \
    -text "$GuiMisc(pop_up_text)" \
	 -width {2}
  bind $topwin(restore_name).info.frame20.frame20.frame2.frame19.frame0.menubutton2 <Button-1> {
  MenuPopupPost $topwin(restore_name).info.frame20.frame20.frame2.frame19.frame0.menubutton2.menu %X %Y
  }
  bind $topwin(restore_name).info.frame20.frame20.frame2.frame19.frame0.menubutton2 <ButtonRelease-1> {
  MenuPopupRelease $topwin(restore_name).info.frame20.frame20.frame2.frame19.frame0.menubutton2.menu %W
  }

  # build widget $topwin(restore_name).info.frame20.frame20.frame2.frame19.frame0.menubutton2.menu
  menu $topwin(restore_name).info.frame20.frame20.frame2.frame19.frame0.menubutton2.menu \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)"
  $topwin(restore_name).info.frame20.frame20.frame2.frame19.frame0.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -command {set restore(mmse_var) 100} \
    -label { 100 }
  $topwin(restore_name).info.frame20.frame20.frame2.frame19.frame0.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -command {set restore(mmse_var) 200} \
    -label { 200 }
  $topwin(restore_name).info.frame20.frame20.frame2.frame19.frame0.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -command {set restore(mmse_var) 300} \
    -label { 300 }
  $topwin(restore_name).info.frame20.frame20.frame2.frame19.frame0.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -command {set restore(mmse_var) 400} \
    -label { 400 }
  $topwin(restore_name).info.frame20.frame20.frame2.frame19.frame0.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -command {set restore(mmse_var) 500} \
    -label { 500 }
  bindtags $topwin(restore_name).info.frame20.frame20.frame2.frame19.frame0.menubutton2.menu {Menu all}
  bind $topwin(restore_name).info.frame20.frame20.frame2.frame19.frame0.menubutton2.menu <B1-Motion> {
  MenuPopupMotion $topwin(restore_name).info.frame20.frame20.frame2.frame19.frame0.menubutton2.menu %W %X %Y
  }
  bind $topwin(restore_name).info.frame20.frame20.frame2.frame19.frame0.menubutton2.menu <ButtonRelease-1> {
  MenuPopupRelease $topwin(restore_name).info.frame20.frame20.frame2.frame19.frame0.menubutton2.menu %W
  }

  # pack widget $topwin(restore_name).info.frame20.frame20.frame2.frame19.frame0
  pack append $topwin(restore_name).info.frame20.frame20.frame2.frame19.frame0 \
    $topwin(restore_name).info.frame20.frame20.frame2.frame19.frame0.label1 {left frame center fill} \
    $topwin(restore_name).info.frame20.frame20.frame2.frame19.frame0.value {left frame center expand fill} \
    $topwin(restore_name).info.frame20.frame20.frame2.frame19.frame0.menubutton2 {right frame center fill}

  # pack widget $topwin(restore_name).info.frame20.frame20.frame2.frame19
  pack append $topwin(restore_name).info.frame20.frame20.frame2.frame19 \
    $topwin(restore_name).info.frame20.frame20.frame2.frame19.frame0 {top frame center expand}


  # pack widget $topwin(restore_name).info.frame20.frame20.frame2
  pack append $topwin(restore_name).info.frame20.frame20.frame2 \
    $topwin(restore_name).info.frame20.frame20.frame2.frame18  {left frame center} \
    $topwin(restore_name).info.frame20.frame20.frame2.frame19  {left frame center}

  # pack widget $topwin(restore_name).info.frame20.frame20
  pack append $topwin(restore_name).info.frame20.frame20 \
    $topwin(restore_name).info.frame20.frame20.frame1 {left frame center} \
    $topwin(restore_name).info.frame20.frame20.frame2 {left frame center}

  # build widget $topwin(restore_name).info.frame20.frame19
  frame $topwin(restore_name).info.frame20.frame19 \
    -background "$GuiColor(frame_bg)" \
	 -borderwidth {3}

  # build widget $topwin(restore_name).info.frame20.frame19.radiobutton1
	radiobutton $topwin(restore_name).info.frame20.frame19.radiobutton1 -padx {1} -pady {1} -highlightthickness {0}  \
    -activebackground "$GuiColor(btn_act_bg)" \
    -background "$GuiColor(btn_bg)" \
    -relief {flat} \
    -text {Adaptive-contrast} \
    -value {adaptive_contrast} \
    -variable {restore(spatial_filter)}

  # build widget $topwin(restore_name).info.frame20.frame19.frame0
  frame $topwin(restore_name).info.frame20.frame19.frame0 \
    -background "$GuiColor(frame_bg)" \
    -borderwidth {1}

  # build widget $topwin(restore_name).info.frame20.frame19.frame0.frame0
  frame $topwin(restore_name).info.frame20.frame19.frame0.frame0 \
    -background "$GuiColor(frame_bg)"

  # build widget $topwin(restore_name).info.frame20.frame19.frame0.frame0.label1
  label $topwin(restore_name).info.frame20.frame19.frame0.frame0.label1 \
    -background "$GuiColor(label_bg)" \
    -borderwidth {0} \
    -text {Local gain factor: }

  # build widget $topwin(restore_name).info.frame20.frame19.frame0.frame0.value
  entry $topwin(restore_name).info.frame20.frame19.frame0.frame0.value \
    -background "$GuiColor(entry_bg)" \
    -foreground "$GuiColor(entry_fg)" \
    -relief {sunken} \
    -textvariable {restore(adap_k1)} \
    -width {4}
  endEntry $topwin(restore_name).info.frame20.frame19.frame0.frame0.value 0 \
  	 $topwin(restore_name).info.frame20.frame19.frame0.frame2.value \
  	 $topwin(restore_name).info.frame20.frame19.frame2.frame3.value 

  # build widget $topwin(restore_name).info.frame20.frame19.frame0.frame0.menubutton2
	menubutton $topwin(restore_name).info.frame20.frame19.frame0.frame0.menubutton2 -padx {1} -pady {1} -highlightthickness {0}  \
    -activebackground "$GuiColor(btn_act_bg)" \
    -background "$GuiColor(btn_bg)" \
    -font "$GuiMisc(pop_up_fn)" \
    -relief "$GuiMisc(pop_up_relief)" \
    -text "$GuiMisc(pop_up_text)" \
	 -width {2}
  # bindings
  bind $topwin(restore_name).info.frame20.frame19.frame0.frame0.menubutton2 <Button-1> {MenuPopupPost $topwin(restore_name).info.frame20.frame19.frame0.frame0.menubutton2.menu %X %Y}
  bind $topwin(restore_name).info.frame20.frame19.frame0.frame0.menubutton2 <ButtonRelease-1> {MenuPopupRelease $topwin(restore_name).info.frame20.frame19.frame0.frame0.menubutton2.menu %W}

  # build widget $topwin(restore_name).info.frame20.frame19.frame0.frame0.menubutton2.menu
  menu $topwin(restore_name).info.frame20.frame19.frame0.frame0.menubutton2.menu \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)"
  $topwin(restore_name).info.frame20.frame19.frame0.frame0.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -command {set restore(adap_k1) 0.2} \
    -label { 0.2 }
  $topwin(restore_name).info.frame20.frame19.frame0.frame0.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -command {set restore(adap_k1) 0.5} \
    -label { 0.5 }
  $topwin(restore_name).info.frame20.frame19.frame0.frame0.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -command {set restore(adap_k1) 0.6} \
    -label { 0.6 }
  $topwin(restore_name).info.frame20.frame19.frame0.frame0.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -command {set restore(adap_k1) 0.7} \
    -label { 0.7 }
  $topwin(restore_name).info.frame20.frame19.frame0.frame0.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -command {set restore(adap_k1) 0.8} \
    -label { 0.8 }
  $topwin(restore_name).info.frame20.frame19.frame0.frame0.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -command {set restore(adap_k1) 0.9} \
    -label { 0.9 }
  bindtags $topwin(restore_name).info.frame20.frame19.frame0.frame0.menubutton2.menu {Menu all}
  # bindings
  bind $topwin(restore_name).info.frame20.frame19.frame0.frame0.menubutton2.menu <B1-Motion> {MenuPopupMotion $topwin(restore_name).info.frame20.frame19.frame0.frame0.menubutton2.menu %W %X %Y}
  bind $topwin(restore_name).info.frame20.frame19.frame0.frame0.menubutton2.menu <ButtonRelease-1> {MenuPopupRelease $topwin(restore_name).info.frame20.frame19.frame0.frame0.menubutton2.menu %W}

  # pack widget $topwin(restore_name).info.frame20.frame19.frame0.frame0
  pack append $topwin(restore_name).info.frame20.frame19.frame0.frame0 \
    $topwin(restore_name).info.frame20.frame19.frame0.frame0.label1 {left frame center fill} \
    $topwin(restore_name).info.frame20.frame19.frame0.frame0.value {left frame center expand fill} \
    $topwin(restore_name).info.frame20.frame19.frame0.frame0.menubutton2 {right frame center fill}

  # build widget $topwin(restore_name).info.frame20.frame19.frame0.frame1
  frame $topwin(restore_name).info.frame20.frame19.frame0.frame1 \
    -background "$GuiColor(frame_bg)"

  # build widget $topwin(restore_name).info.frame20.frame19.frame0.frame1.label1
  label $topwin(restore_name).info.frame20.frame19.frame0.frame1.label1 \
    -background "$GuiColor(label_bg)" \
    -borderwidth {0} \
    -text {Local gain max: }

  # build widget $topwin(restore_name).info.frame20.frame19.frame0.frame1.value
  entry $topwin(restore_name).info.frame20.frame19.frame0.frame1.value \
    -background "$GuiColor(entry_bg)" \
    -foreground "$GuiColor(entry_fg)" \
    -relief {sunken} \
    -textvariable {restore(adap_max)} \
    -width {4}
  endEntry $topwin(restore_name).info.frame20.frame19.frame0.frame1.value 0 \
  	 $topwin(restore_name).info.frame20.frame19.frame2.frame0.value \
  	 $topwin(restore_name).info.frame20.frame19.frame0.frame2.value 

  # build widget $topwin(restore_name).info.frame20.frame19.frame0.frame1.menubutton2
	menubutton $topwin(restore_name).info.frame20.frame19.frame0.frame1.menubutton2 -padx {1} -pady {1} -highlightthickness {0}  \
    -activebackground "$GuiColor(btn_act_bg)" \
    -background "$GuiColor(btn_bg)" \
    -font "$GuiMisc(pop_up_fn)" \
    -relief "$GuiMisc(pop_up_relief)" \
    -text "$GuiMisc(pop_up_text)" \
	 -width {2}
  # bindings
  bind $topwin(restore_name).info.frame20.frame19.frame0.frame1.menubutton2 <Button-1> {MenuPopupPost $topwin(restore_name).info.frame20.frame19.frame0.frame1.menubutton2.menu %X %Y}
  bind $topwin(restore_name).info.frame20.frame19.frame0.frame1.menubutton2 <ButtonRelease-1> {MenuPopupRelease $topwin(restore_name).info.frame20.frame19.frame0.frame1.menubutton2.menu %W}

  # build widget $topwin(restore_name).info.frame20.frame19.frame0.frame1.menubutton2.menu
  menu $topwin(restore_name).info.frame20.frame19.frame0.frame1.menubutton2.menu \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)"
  $topwin(restore_name).info.frame20.frame19.frame0.frame1.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -command {set restore(adap_max) 5} \
    -label {  5 }
  $topwin(restore_name).info.frame20.frame19.frame0.frame1.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -command {set restore(adap_max) 10} \
    -label { 10 }
  $topwin(restore_name).info.frame20.frame19.frame0.frame1.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -command {set restore(adap_max) 15} \
    -label { 15 }
  $topwin(restore_name).info.frame20.frame19.frame0.frame1.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -command {set restore(adap_max) 20} \
    -label { 20 }
  $topwin(restore_name).info.frame20.frame19.frame0.frame1.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -command {set restore(adap_max) 25} \
    -label { 25 }
  $topwin(restore_name).info.frame20.frame19.frame0.frame1.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -command {set restore(adap_max) 30} \
    -label { 30 }
  $topwin(restore_name).info.frame20.frame19.frame0.frame1.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -command {set restore(adap_max) 100} \
    -label {100 }
  bindtags $topwin(restore_name).info.frame20.frame19.frame0.frame1.menubutton2.menu {Menu all}
  # bindings
  bind $topwin(restore_name).info.frame20.frame19.frame0.frame1.menubutton2.menu <B1-Motion> {MenuPopupMotion $topwin(restore_name).info.frame20.frame19.frame0.frame1.menubutton2.menu %W %X %Y}
  bind $topwin(restore_name).info.frame20.frame19.frame0.frame1.menubutton2.menu <ButtonRelease-1> {MenuPopupRelease $topwin(restore_name).info.frame20.frame19.frame0.frame1.menubutton2.menu %W}

  # pack widget $topwin(restore_name).info.frame20.frame19.frame0.frame1
  pack append $topwin(restore_name).info.frame20.frame19.frame0.frame1 \
    $topwin(restore_name).info.frame20.frame19.frame0.frame1.label1 {left frame center fill} \
    $topwin(restore_name).info.frame20.frame19.frame0.frame1.value {left frame center expand fill} \
    $topwin(restore_name).info.frame20.frame19.frame0.frame1.menubutton2 {right frame center fill}

  # build widget $topwin(restore_name).info.frame20.frame19.frame0.frame2
  frame $topwin(restore_name).info.frame20.frame19.frame0.frame2 \
    -background "$GuiColor(frame_bg)"

  # build widget $topwin(restore_name).info.frame20.frame19.frame0.frame2.label1
  label $topwin(restore_name).info.frame20.frame19.frame0.frame2.label1 \
    -background "$GuiColor(label_bg)" \
    -borderwidth {0} \
    -relief {sunken} \
    -text {Local gain min: }

  # build widget $topwin(restore_name).info.frame20.frame19.frame0.frame2.value
  entry $topwin(restore_name).info.frame20.frame19.frame0.frame2.value \
    -background "$GuiColor(entry_bg)" \
    -foreground "$GuiColor(entry_fg)" \
    -relief {sunken} \
    -textvariable {restore(adap_min)} \
    -width {4}
  endEntry $topwin(restore_name).info.frame20.frame19.frame0.frame2.value 0 \
  	 $topwin(restore_name).info.frame20.frame19.frame0.frame1.value \
  	 $topwin(restore_name).info.frame20.frame19.frame0.frame0.value 

  # build widget $topwin(restore_name).info.frame20.frame19.frame0.frame2.menubutton2
	menubutton $topwin(restore_name).info.frame20.frame19.frame0.frame2.menubutton2 -padx {1} -pady {1} -highlightthickness {0}  \
    -activebackground "$GuiColor(btn_act_bg)" \
    -background "$GuiColor(btn_bg)" \
    -font "$GuiMisc(pop_up_fn)" \
    -relief "$GuiMisc(pop_up_relief)" \
    -text "$GuiMisc(pop_up_text)" \
	 -width {2}
  # bindings
  bind $topwin(restore_name).info.frame20.frame19.frame0.frame2.menubutton2 <Button-1> {MenuPopupPost $topwin(restore_name).info.frame20.frame19.frame0.frame2.menubutton2.menu %X %Y}
  bind $topwin(restore_name).info.frame20.frame19.frame0.frame2.menubutton2 <ButtonRelease-1> {MenuPopupRelease $topwin(restore_name).info.frame20.frame19.frame0.frame2.menubutton2.menu %W}

  # build widget $topwin(restore_name).info.frame20.frame19.frame0.frame2.menubutton2.menu
  menu $topwin(restore_name).info.frame20.frame19.frame0.frame2.menubutton2.menu \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)"
  $topwin(restore_name).info.frame20.frame19.frame0.frame2.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -command {set restore(adap_min) 0.5} \
    -label {  0.5 }
  $topwin(restore_name).info.frame20.frame19.frame0.frame2.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -command {set restore(adap_min) 1.0} \
    -label {  1.0 }
  $topwin(restore_name).info.frame20.frame19.frame0.frame2.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -command {set restore(adap_min) 2.0} \
    -label {  2.0 }
  $topwin(restore_name).info.frame20.frame19.frame0.frame2.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -command {set restore(adap_min) 5.0} \
    -label {  5.0 }
  $topwin(restore_name).info.frame20.frame19.frame0.frame2.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -command {set restore(adap_min) 10.0} \
    -label { 10.0 }
  $topwin(restore_name).info.frame20.frame19.frame0.frame2.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -command {set restore(adap_min) 15.0} \
    -label { 15.0 }
  $topwin(restore_name).info.frame20.frame19.frame0.frame2.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -command {set restore(adap_min) 20.0} \
    -label { 20.0 }
  bindtags $topwin(restore_name).info.frame20.frame19.frame0.frame2.menubutton2.menu {Menu all}
  # bindings
  bind $topwin(restore_name).info.frame20.frame19.frame0.frame2.menubutton2.menu <B1-Motion> {MenuPopupMotion $topwin(restore_name).info.frame20.frame19.frame0.frame2.menubutton2.menu %W %X %Y}
  bind $topwin(restore_name).info.frame20.frame19.frame0.frame2.menubutton2.menu <ButtonRelease-1> {MenuPopupRelease $topwin(restore_name).info.frame20.frame19.frame0.frame2.menubutton2.menu %W}

  # pack widget $topwin(restore_name).info.frame20.frame19.frame0.frame2
  pack append $topwin(restore_name).info.frame20.frame19.frame0.frame2 \
    $topwin(restore_name).info.frame20.frame19.frame0.frame2.label1 {left frame center fill} \
    $topwin(restore_name).info.frame20.frame19.frame0.frame2.value {left frame center expand fill} \
    $topwin(restore_name).info.frame20.frame19.frame0.frame2.menubutton2 {right frame center fill}

  # pack widget $topwin(restore_name).info.frame20.frame19.frame0
  pack append $topwin(restore_name).info.frame20.frame19.frame0 \
    $topwin(restore_name).info.frame20.frame19.frame0.frame0 {left frame e padx 22} \
    $topwin(restore_name).info.frame20.frame19.frame0.frame2 {left frame center expand} \
    $topwin(restore_name).info.frame20.frame19.frame0.frame1 {left frame center expand}

  # build widget $topwin(restore_name).info.frame20.frame19.frame2
  frame $topwin(restore_name).info.frame20.frame19.frame2 \
    -background "$GuiColor(frame_bg)" \
    -borderwidth {1}

  # build widget $topwin(restore_name).info.frame20.frame19.frame2.frame0
  frame $topwin(restore_name).info.frame20.frame19.frame2.frame0 \
    -background "$GuiColor(frame_bg)"

  # build widget $topwin(restore_name).info.frame20.frame19.frame2.frame0.label1
  label $topwin(restore_name).info.frame20.frame19.frame2.frame0.label1 \
    -background "$GuiColor(label_bg)" \
    -borderwidth {0} \
    -text {Local mean factor: }

  # build widget $topwin(restore_name).info.frame20.frame19.frame2.frame0.value
  entry $topwin(restore_name).info.frame20.frame19.frame2.frame0.value \
    -background "$GuiColor(entry_bg)" \
    -foreground "$GuiColor(entry_fg)" \
    -relief {sunken} \
    -textvariable {restore(adap_k2)} \
    -width {5}
  endEntry $topwin(restore_name).info.frame20.frame19.frame2.frame0.value 0 \
  	 $topwin(restore_name).info.frame20.frame19.frame2.frame3.value \
  	 $topwin(restore_name).info.frame20.frame19.frame0.frame1.value 

  # build widget $topwin(restore_name).info.frame20.frame19.frame2.frame0.menubutton2
	menubutton $topwin(restore_name).info.frame20.frame19.frame2.frame0.menubutton2 -padx {1} -pady {1} -highlightthickness {0}  \
    -activebackground "$GuiColor(btn_act_bg)" \
    -background "$GuiColor(btn_bg)" \
    -font "$GuiMisc(pop_up_fn)" \
    -relief "$GuiMisc(pop_up_relief)" \
    -text "$GuiMisc(pop_up_text)" \
	 -width {2}
  # bindings
  bind $topwin(restore_name).info.frame20.frame19.frame2.frame0.menubutton2 <Button-1> {MenuPopupPost $topwin(restore_name).info.frame20.frame19.frame2.frame0.menubutton2.menu %X %Y}
  bind $topwin(restore_name).info.frame20.frame19.frame2.frame0.menubutton2 <ButtonRelease-1> {MenuPopupRelease $topwin(restore_name).info.frame20.frame19.frame2.frame0.menubutton2.menu %W}

  # build widget $topwin(restore_name).info.frame20.frame19.frame2.frame0.menubutton2.menu
  menu $topwin(restore_name).info.frame20.frame19.frame2.frame0.menubutton2.menu \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)"
  $topwin(restore_name).info.frame20.frame19.frame2.frame0.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -command {set restore(adap_k2) 0.5} \
    -label { 0.5 }
  $topwin(restore_name).info.frame20.frame19.frame2.frame0.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -command {set restore(adap_k2) 0.6} \
    -label { 0.6 }
  $topwin(restore_name).info.frame20.frame19.frame2.frame0.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -command {set restore(adap_k2) 0.7} \
    -label { 0.7 }
  $topwin(restore_name).info.frame20.frame19.frame2.frame0.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -command {set restore(adap_k2) 0.8} \
    -label { 0.8 }
  $topwin(restore_name).info.frame20.frame19.frame2.frame0.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -command {set restore(adap_k2) 0.9} \
    -label { 0.9 }
  $topwin(restore_name).info.frame20.frame19.frame2.frame0.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -command {set restore(adap_k2) 1.0} \
    -label { 1.0 }
  bindtags $topwin(restore_name).info.frame20.frame19.frame2.frame0.menubutton2.menu {Menu all}
  # bindings
  bind $topwin(restore_name).info.frame20.frame19.frame2.frame0.menubutton2.menu <B1-Motion> {MenuPopupMotion $topwin(restore_name).info.frame20.frame19.frame2.frame0.menubutton2.menu %W %X %Y}
  bind $topwin(restore_name).info.frame20.frame19.frame2.frame0.menubutton2.menu <ButtonRelease-1> {MenuPopupRelease $topwin(restore_name).info.frame20.frame19.frame2.frame0.menubutton2.menu %W}

  # pack widget $topwin(restore_name).info.frame20.frame19.frame2.frame0
  pack append $topwin(restore_name).info.frame20.frame19.frame2.frame0 \
    $topwin(restore_name).info.frame20.frame19.frame2.frame0.label1 {left frame center fill} \
    $topwin(restore_name).info.frame20.frame19.frame2.frame0.value {left frame center expand fill} \
    $topwin(restore_name).info.frame20.frame19.frame2.frame0.menubutton2 {right frame center fill}

  # build widget $topwin(restore_name).info.frame20.frame19.frame2.frame3
  frame $topwin(restore_name).info.frame20.frame19.frame2.frame3 \
    -background "$GuiColor(frame_bg)"

  # build widget $topwin(restore_name).info.frame20.frame19.frame2.frame3.label1
  label $topwin(restore_name).info.frame20.frame19.frame2.frame3.label1 \
    -background "$GuiColor(label_bg)" \
    -borderwidth {0} \
    -text {Kernel size: }

  # build widget $topwin(restore_name).info.frame20.frame19.frame2.frame3.value
  entry $topwin(restore_name).info.frame20.frame19.frame2.frame3.value \
    -background "$GuiColor(entry_bg)" \
    -foreground "$GuiColor(entry_fg)" \
    -relief {sunken} \
    -textvariable {restore(adap_kern)} \
    -width {3}
  endEntry $topwin(restore_name).info.frame20.frame19.frame2.frame3.value 0\
  	 $topwin(restore_name).info.frame20.frame19.frame0.frame0.value \
  	 $topwin(restore_name).info.frame20.frame19.frame2.frame0.value 

  # build widget $topwin(restore_name).info.frame20.frame19.frame2.frame3.menubutton2
	menubutton $topwin(restore_name).info.frame20.frame19.frame2.frame3.menubutton2 -padx {1} -pady {1} -highlightthickness {0}  \
    -activebackground "$GuiColor(btn_act_bg)" \
    -background "$GuiColor(btn_bg)" \
    -font "$GuiMisc(pop_up_fn)" \
    -relief "$GuiMisc(pop_up_relief)" \
    -text "$GuiMisc(pop_up_text)" \
	 -width {2}
  # bindings
  bind $topwin(restore_name).info.frame20.frame19.frame2.frame3.menubutton2 <Button-1> {MenuPopupPost $topwin(restore_name).info.frame20.frame19.frame2.frame3.menubutton2.menu %X %Y}
  bind $topwin(restore_name).info.frame20.frame19.frame2.frame3.menubutton2 <ButtonRelease-1> {MenuPopupRelease $topwin(restore_name).info.frame20.frame19.frame2.frame3.menubutton2.menu %W}

  # build widget $topwin(restore_name).info.frame20.frame19.frame2.frame3.menubutton2.menu
  menu $topwin(restore_name).info.frame20.frame19.frame2.frame3.menubutton2.menu \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)"
  $topwin(restore_name).info.frame20.frame19.frame2.frame3.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -command {set restore(adap_kern) 7} \
    -label {  7 }
  $topwin(restore_name).info.frame20.frame19.frame2.frame3.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -command {set restore(adap_kern) 9} \
    -label {  9 }
  $topwin(restore_name).info.frame20.frame19.frame2.frame3.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -command {set restore(adap_kern) 11} \
    -label { 11 }
  $topwin(restore_name).info.frame20.frame19.frame2.frame3.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -command {set restore(adap_kern) 13} \
    -label { 13 }
  $topwin(restore_name).info.frame20.frame19.frame2.frame3.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -command {set restore(adap_kern) 15} \
    -label { 15 }
  $topwin(restore_name).info.frame20.frame19.frame2.frame3.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
    -background "$GuiColor(menu_bg)" \
    -command {set restore(adap_kern) 21} \
    -label { 21 }
  bindtags $topwin(restore_name).info.frame20.frame19.frame2.frame3.menubutton2.menu {Menu all}
  # bindings
  bind $topwin(restore_name).info.frame20.frame19.frame2.frame3.menubutton2.menu <B1-Motion> {MenuPopupMotion $topwin(restore_name).info.frame20.frame19.frame2.frame3.menubutton2.menu %W %X %Y}
  bind $topwin(restore_name).info.frame20.frame19.frame2.frame3.menubutton2.menu <ButtonRelease-1> {MenuPopupRelease $topwin(restore_name).info.frame20.frame19.frame2.frame3.menubutton2.menu %W}

  # pack widget $topwin(restore_name).info.frame20.frame19.frame2.frame3
  pack append $topwin(restore_name).info.frame20.frame19.frame2.frame3 \
    $topwin(restore_name).info.frame20.frame19.frame2.frame3.label1 {left frame center fill} \
    $topwin(restore_name).info.frame20.frame19.frame2.frame3.value {left frame center expand fill} \
    $topwin(restore_name).info.frame20.frame19.frame2.frame3.menubutton2 {right frame center fill}

  # pack widget $topwin(restore_name).info.frame20.frame19.frame2
  pack append $topwin(restore_name).info.frame20.frame19.frame2 \
    $topwin(restore_name).info.frame20.frame19.frame2.frame0 {left frame e padx 22} \
    $topwin(restore_name).info.frame20.frame19.frame2.frame3 {left frame center expand}

  # pack widget $topwin(restore_name).info.frame20.frame19
  pack append $topwin(restore_name).info.frame20.frame19 \
    $topwin(restore_name).info.frame20.frame19.radiobutton1 {top frame nw} \
    $topwin(restore_name).info.frame20.frame19.frame0 {top frame center expand fillx} \
    $topwin(restore_name).info.frame20.frame19.frame2 {top frame center expand fillx}

  # pack widget $topwin(restore_name).info.frame20
  pack append $topwin(restore_name).info.frame20 \
    $topwin(restore_name).info.frame20.frame21 {top frame w fillx} \
    $topwin(restore_name).info.frame20.frame20 {top frame w} \
    $topwin(restore_name).info.frame20.frame19 {top frame center fillx}

  # pack widget $topwin(restore_name).info
  pack append $topwin(restore_name).info \
    $topwin(restore_name).info.frame11 {top frame center fillx} \
    $topwin(restore_name).info.frame13 {top frame center fillx} \
    $topwin(restore_name).info.frame20 {top frame center fillx}

  # build widget $topwin(restore_name).perform
  frame $topwin(restore_name).perform \
    -background "$GuiColor(frame_bg)" \
    -borderwidth {2} \
    -relief {raised}

  # build widget $topwin(restore_name).perform.button9
	button $topwin(restore_name).perform.button9 -padx {1} -pady {1} -highlightthickness {0}  \
    -activebackground "$GuiColor(dis_act_bg)" \
    -background "$GuiColor(dis_bg)" \
    -foreground "$GuiColor(dis_fg)" \
	 -command {destroy $topwin(restore_name); set topwin(restore_name) NONE} \
    -text {DISMISS}

  # build widget $topwin(restore_name).perform.button10
	button $topwin(restore_name).perform.button10 -padx {1} -pady {1} -highlightthickness {0}  \
    -activebackground "$GuiColor(perf_act_bg)" \
    -background "$GuiColor(perf_bg)" \
    -foreground "$GuiColor(perf_fg)" \
    -text {PERFORM} \
	 -command {
      $topwin(restore_name) configure -cursor watch; update
      if {$current_image == ""} {
         CvipAlert "Please select an image first."
         $topwin(restore_name) configure -cursor top_left_arrow; update
         return
      }  

		set temp [string trimright $restore(spatial_filter) filter]
		set temp1 [string trimright $restore(spatial_filter) _filter]
		append temp flt
		switch -exact -- $restore(spatial_filter) {
			median_filter -
			mean_filter -
			minimum_filter -
			midpoint_filter -
			maximum_filter -
			geometric_filter -
			harmonic_filter {
				set temp2 $current_image
				if [catch {expr $restore(spat_mask)}] {
               CvipAlert "Numerical values required for the Mask size: \n \
                  Mask size = $restore(spat_mask)."
               $topwin(restore_name) configure -cursor top_left_arrow; update
               return
            } 
				if {$restore(spat_mask) < "3" && $restore(spatial_filter) == "median_filter"} {
               CvipAlert "The mask size (=$restore(spat_mask)) should be \n\
               an odd number greater than or equal to 3."
               $topwin(restore_name) configure -cursor top_left_arrow; update
               return
            }
				if {$restore(spat_mask) < 3 || $restore(spat_mask) > 11} {
               CvipAlert "The mask size (=$restore(spat_mask)) should be \n\
               an odd number between 3 and 11."
               $topwin(restore_name) configure -cursor top_left_arrow; update
               return
				}
				if {$restore(spat_mask) == 2 * floor($restore(spat_mask)/2) + 1} {
					set restore(spat_mask) [expr int($restore(spat_mask))]
				} else {
					set restore(spat_mask) [expr int(2 * floor($restore(spat_mask)/2) - 1)]
               CvipAlert "The mask size ($restore(spat_mask))should be an odd number; \
					rounded to $restore(spat_mask)."
				}
            if [catch {set result [cvip $restore(spatial_filter) $current_image\
							$restore(spat_mask)]} cresult] {
               CvipAlert "$cresult."
               $topwin(restore_name) configure -cursor top_left_arrow; update
               return
            } else {
               set new_name [cvip rename $result ${current_image}_$temp]
               img_q insert end $new_name
               image_post $new_name
               cvip view $new_name
					CvipMessage "$temp1 spatial filter performed on image \"$temp2\""
            }
				if { $GUI_DEBUG == 1 } {
					puts stderr "cvip $restore(spatial_filter) $current_image $restore(spat_mask)" 
				}
			}

			alpha_filter {
				set temp2 $current_image
				if [catch {expr $restore(spat_mask) + $restore(spat_trim)}] {
               CvipAlert "Numerical values required for the Mask and Trim size: \n \
                  Mask size = $restore(spat_mask), Trim size = $restore(spat_trim)."
               $topwin(restore_name) configure -cursor top_left_arrow; update
               return
            } elseif {$restore(spat_mask) < 3 || $restore(spat_mask) > 11 } {
               CvipAlert "The mask size (=$restore(spat_mask)) should be \n\
               an odd number between 3 and 11."
               $topwin(restore_name) configure -cursor top_left_arrow; update
               return
				}
				if {$restore(spat_mask) == 2 * floor($restore(spat_mask)/2) + 1} {
					set restore(spat_mask) [expr int($restore(spat_mask))]
				} else {
					set restore(spat_mask) [expr int(2 * floor($restore(spat_mask)/2) - 1)]
               CvipAlert "The mask size ($restore(spat_mask)) should be an odd number; \
					rounded to $restore(spat_mask)."
				}
				if {$restore(spat_trim) < 0 || $restore(spat_trim) > $restore(spat_mask) } {
               CvipAlert "The trim size (=$restore(spat_trim)) should be \n\
               a number between 0 and the mask size ($restore(spat_mask))."
               $topwin(restore_name) configure -cursor top_left_arrow; update
               return
				}
            if [catch {set result [cvip $restore(spatial_filter) $current_image\
							$restore(spat_mask) $restore(spat_trim)]} cresult] {
               CvipAlert "$cresult."
               $topwin(restore_name) configure -cursor top_left_arrow; update
               return
            } else {
               set new_name [cvip rename $result ${current_image}_$temp]
               img_q insert end $new_name
               image_post $new_name
               cvip view $new_name
					CvipMessage "$temp1 filter performed on image \"$temp2\""
            }
				if { $GUI_DEBUG == 1 } {
					puts stderr "cvip $restore(spatial_filter) $current_image\
					$restore(spat_mask) $restore(spat_trim)"
				}
			}

			contra_filter -
			ypmean_filter {
				set temp2 $current_image
				if [catch {expr $restore(spat_mask)}] {
               CvipAlert "Numerical values required for the Mask size: \n \
                  Mask size = $restore(spat_mask)."
               $topwin(restore_name) configure -cursor top_left_arrow; update
               return
            } elseif {$restore(spat_mask) < 3 || $restore(spat_mask) > 11 } {
               CvipAlert "The mask size (=$restore(spat_mask)) should be \n\
               an odd number between 3 and 11."
               $topwin(restore_name) configure -cursor top_left_arrow; update
               return
				}
				if {$restore(spat_mask) == 2 * floor($restore(spat_mask)/2) + 1} {
					set restore(spat_mask) [expr int($restore(spat_mask))]
				} else {
					set restore(spat_mask) [expr int(2 * floor($restore(spat_mask)/2) - 1)]
               CvipAlert "The mask size ($restore(spat_mask)) should be an odd number; \
					rounded to $restore(spat_mask)."
				}
				if {$restore(spat_order) == 0 && $restore(spatial_filter) == "ypmean_filter" } {
               CvipAlert "Filter order (=0) not allowed on Yp mean filter due to divide by 0."
               $topwin(restore_name) configure -cursor top_left_arrow; update
               return
				}
            if [catch {set result [cvip $restore(spatial_filter) $current_image\
							$restore(spat_mask) $restore(spat_order)]} cresult] {
               CvipAlert "$cresult."
               $topwin(restore_name) configure -cursor top_left_arrow; update
               return
            } else {
               set new_name [cvip rename $result ${current_image}_$temp]
               img_q insert end $new_name
               image_post $new_name
               cvip view $new_name
					if { $restore(spatial_filter)  == "contra_filter" } {
						CvipMessage "contra-harmonic filter performed on image \"$temp2\""
					} else {
						CvipMessage "Yp-mean filter performed on image \"$temp2\""
					}
            }
				if { $GUI_DEBUG == 1 } {
					puts stderr "cvip $restore(spatial_filter) $current_image\
					$restore(spat_mask) $restore(spat_order)"
				}

			}

			mmse_filter {
				set temp2 $current_image
				if [catch {expr $restore(mmse_kern) + $restore(mmse_var)}] {
               CvipAlert "Numerical values required for the Kernel  size and Variance value: \n \
                  Kernel size = $restore(mmse_kern), Variance = $restore(mmse_var)."
               $topwin(restore_name) configure -cursor top_left_arrow; update
               return
            } elseif {$restore(mmse_var) < 0 } {
               CvipAlert "Positive value required for the variance value ($restore(mmse_var))."
               $topwin(restore_name) configure -cursor top_left_arrow; update
					return
				} elseif {$restore(mmse_kern) < 1 ||\
						$restore(mmse_kern) == 2 * floor($restore(mmse_kern) / 2)} {
               CvipAlert "Positive odd number required for the kernel size ($restore(mmse_kern))."
               $topwin(restore_name) configure -cursor top_left_arrow; update
               return
				}
            if [catch {set result [cvip $restore(spatial_filter) $current_image\
							$restore(mmse_var) $restore(mmse_kern)]} cresult] {
               CvipAlert "$cresult."
               $topwin(restore_name) configure -cursor top_left_arrow; update
               return
            } else {
               set new_name [cvip rename $result ${current_image}_$temp]
               img_q insert end $new_name
               image_post $new_name
               cvip view $new_name
					CvipMessage "$temp1 filter performed on image \"$temp2\""
            }

         $topwin(restore_name) configure -cursor top_left_arrow; update
         return
			}

			adaptive_contrast {
				set temp2 $current_image
				if [catch {expr $restore(adap_k1) + $restore(adap_k2) + $restore(adap_kern) + \
					$restore(adap_max) + $restore(adap_min) } ] {
               CvipAlert "Numerical parameters required : \n \
                  Local gain factor = $restore(adap_k1), Local gain max = $restore(adap_max), \
						Local gain min = $restore(adap_min),\n\
						Loacal mean factor = $restore(adap_k2), Kernel size = $restore(adap_kern)." 
               $topwin(restore_name) configure -cursor top_left_arrow; update
               return
					
				} elseif { $restore(adap_k1) < "0" || $restore(adap_k2) < "0" || \
							$restore(adap_max) < "0" || $restore(adap_min) < "0" || $restore(adap_kern) < "0" } {
               CvipAlert "Positive values  required : \n \
                  Local gain factor = $restore(adap_k1), Local gain max = $restore(adap_max),  \
						Local gain min = $restore(adap_min),\n\
						Loacal mean factor = $restore(adap_k2), Kernel size = $restore(adap_kern). "
               $topwin(restore_name) configure -cursor top_left_arrow; update
               return
				} elseif { floor($restore(adap_kern)) != $restore(adap_kern) || \
								floor($restore(adap_kern) / 2) * 2 == $restore(adap_kern) } {
               CvipAlert "Positive odd integer  required for the kernel size ($restore(adap_kern))."
               $topwin(restore_name) configure -cursor top_left_arrow; update
               return
				}
            if [catch {set result [cvip $restore(spatial_filter) $current_image\
							$restore(adap_k1) $restore(adap_k2) $restore(adap_kern)\
							$restore(adap_min) $restore(adap_max)]} cresult] {
               CvipAlert "$cresult."
               $topwin(restore_name) configure -cursor top_left_arrow; update
               return
            } else {
               set new_name [cvip rename $result ${current_image}_AdptContra]
               img_q insert end $new_name
               image_post $new_name
               cvip view $new_name
					CvipMessage "adaptive-contrast filter performed on image \"$temp2\""
            }
				if { $GUI_DEBUG == 1 } {
				puts stderr "cvip $restore(spatial_filter) $current_image\
						$restore(adap_k1) $restore(adap_k2) $restore(adap_kern)\
						$restore(adap_min) $restore(adap_max)"
				}
			}

		}
	 $topwin(restore_name) configure -cursor top_left_arrow; update
  }

  # pack widget $topwin(restore_name).perform
  pack append $topwin(restore_name).perform \
    $topwin(restore_name).perform.button9 {left frame center} \
    $topwin(restore_name).perform.button10 {right frame center}

  # build widget $topwin(restore_name).current_image
  frame $topwin(restore_name).current_image \
    -background "$GuiColor(frame_bg)" \
    -borderwidth {2} \
    -relief {ridge}

  # build widget $topwin(restore_name).current_image.label15
  label $topwin(restore_name).current_image.label15 \
    -background "$GuiColor(label_bg)" \
    -text {Current image: }

  # build widget $topwin(restore_name).current_image.label16
  label $topwin(restore_name).current_image.label16 \
    -background "$GuiColor(label_bg)" \
    -foreground {blue} \
    -text {label16} \
    -textvariable {current_image}

  # pack widget $topwin(restore_name).current_image
  pack append $topwin(restore_name).current_image \
    $topwin(restore_name).current_image.label15 {left frame center} \
    $topwin(restore_name).current_image.label16 {left frame center}

  # pack widget $topwin(restore_name)
  pack append $topwin(restore_name) \
    $topwin(restore_name).info {top frame center expand fill} \
    $topwin(restore_name).perform {bottom frame center fillx} \
    $topwin(restore_name).current_image {top frame center fillx}

  if {"[info procs XFEdit]" != ""} {
    catch "XFMiscBindWidgetTree ."
    after 2 "catch {XFEditSetShowWindows}"
  }
}
