# **********************************************************************
# Computer Vision/Image Processing Tool Project - Dr. Scott Umbaugh SIUE
# **********************************************************************
#
#             File Name: util_al.tcl
#           Description: 
#         Related Files: 
#   Initial Coding Date: Fri Aug  9 17:32:25 CDT 1996
#           Portability: TCL script file
#            References:
#             Author(s): Yansheng Wei
#                        Southern Illinois University @ Edwardsville
#
## Copyright (C) 1996 SIUE - by Scott Umbaugh and Yansheng Wei.
##
## Permission to use, copy, modify, and distribute this software and its
## documentation for any purpose and without fee is hereby granted, provided
## that the above copyright notice appear in all copies and that both that
## copyright notice and this permission notice appear in supporting
## documentation.  This software is provided "as is" without express or
## implied warranty.
##
# RCS (Revision Control System) Information
# ...Added automatically by RCS 
#
## $Log: util_al.tcl,v $
## Revision 1.14  1997/07/17 19:26:27  yawei
## initial position "wm geo" changed
##
## Revision 1.13  1997/07/16 17:28:37  yawei
## configuration perfomed
##
## Revision 1.12  1997/03/28 20:24:05  yawei
## removed image size check for division
##
## Revision 1.11  1997/03/12 17:07:40  yawei
## changed win size
##
## Revision 1.10  1997/03/12 15:37:12  yawei
## changed winsize, fixed arrow buttons
##
## Revision 1.9  1997/03/11 20:56:46  yawei
## Tcl/Tk script upgrading from tcl7.3/tk3.6 to tcl7.6/tk4.2
## compatible. This process is automated with tkboost perl
## script. @ Tue Mar 11 14:51:36 CST 1997
##
## Revision 1.8  1996/11/18 14:13:08  yawei
## Added the choice of BYTE clipping or not to multiply
##
# Revision 1.7  1996/10/22  18:12:14  yawei
# regular checkin
#
# Revision 1.6  1996/10/22  18:08:18  yawei
# in Multiply
# 1) Changed message from "by factor" to "by a constant (BYTE clipping)"
# 2) image is remapped to "BYTE" before the multiply by constant
#
# Revision 1.5  1996/10/18  02:04:37  yawei
# added option of multiplying by a factor or by an image in UTILITIES/AL
#
# Revision 1.4  1996/10/16  19:06:23  yawei
# general changes
#
# Revision 1.3  1996/08/15  11:10:00  mzuke
# corrected log message
#
# Revision 1.2  1996/08/15  11:06:55  mzuke
# removed toplevel_position from wm geometry to allow window
# window positioning by user; enabled resizing
# Revision 1.1  1996/08/09  22:36:19  yawei
# Initial revision
#
#
#****************************************************************************
# procedure to show window $topwin(util_name)
proc  util_arith { opclass } {# xf ignore me 7

  global {util}
  global GuiColor
  global GuiMisc
  set util(arith_log) $opclass
  # Window manager configurations
  global topwin
  global toplevel_position
  if [ winfo exists $topwin(util_name).info] {
     set tempname $topwin(util_name);\
destroy $topwin(util_name).info;\
set topwin(util_name) $tempname;}
  if [ winfo exists $topwin(util_name).current_image] {
     set tempname $topwin(util_name);\
destroy $topwin(util_name).current_image;\
set topwin(util_name) $tempname;}
  if [ winfo exists $topwin(util_name).perform] {
     set tempname $topwin(util_name);\
destroy $topwin(util_name).perform;\
set topwin(util_name) $tempname;}
  wm positionfrom $topwin(util_name) user

  wm geometry $topwin(util_name) $topwin(util_top)[get_pos $topwin(util_name)]
  wm maxsize $topwin(util_name) [lindex [split $topwin(util_top_max)] 0] \
  	[lindex [split $topwin(util_top_max)] 1]
  wm minsize $topwin(util_name) [lindex [split $topwin(util_top_min)] 0] \
  	[lindex [split $topwin(util_top_min)] 1]

  switch -exact  -- $opclass {
	add		{set temp "Add"}
	subtract	{set temp "Subtract"}
	multiply	{set temp "Multiply"}
	divide	{set temp "Divide"}
	and		{set temp "AND"}
	or			{set temp "OR"}
	not		{set temp "NOT"}
	xor		{set temp "XOR"}
  }
  wm title $topwin(util_name) "UTILITIES -> Arith/Logic -> $temp"

  # bindings
  bind $topwin(util_name) <Destroy> {set topwin(util_name) NONE}

  # build widget $topwin(util_name).info
  frame $topwin(util_name).info \
    -background "$GuiColor(frame_bg)" \
    -borderwidth {2}

  # build widget $topwin(util_name).info.current_image1
  frame $topwin(util_name).info.current_image1 \
    -background "$GuiColor(frame_bg)" \
    -borderwidth {2}

  # build widget $topwin(util_name).info.current_image1.frame
  frame $topwin(util_name).info.current_image1.frame \
    -background "$GuiColor(frame_bg)"

  # build widget $topwin(util_name).info.current_image1.frame.frame
  frame $topwin(util_name).info.current_image1.frame.frame \
    -background "$GuiColor(frame_bg)"

  # build widget $topwin(util_name).info.current_image1.frame.frame.scrollbar1
  scrollbar $topwin(util_name).info.current_image1.frame.frame.scrollbar1 \
    -activebackground {gray90} \
    -troughcolor {gray50} \
    -command "$topwin(util_name).info.current_image1.frame.frame.entry2 xview" \
    -background {gray90} \
    -orient {horizontal} \
    -width {11}

  # build widget $topwin(util_name).info.current_image1.frame.frame.entry2
  entry $topwin(util_name).info.current_image1.frame.frame.entry2 \
	 -background "$GuiColor(entry_bg)" \
	 -foreground "$GuiColor(entry_fg)" \
    -relief {sunken} \
 -xscrollcommand "$topwin(util_name).info.current_image1.frame.frame.scrollbar1 set" \
    -textvariable {second_image}
  endEntry $topwin(util_name).info.current_image1.frame.frame.entry2

  # pack widget $topwin(util_name).info.current_image1.frame.frame
  pack append $topwin(util_name).info.current_image1.frame.frame \
    $topwin(util_name).info.current_image1.frame.frame.entry2 {top frame center expand fill} \
    $topwin(util_name).info.current_image1.frame.frame.scrollbar1 {top frame center fillx}

  # build widget $topwin(util_name).info.current_image1.frame.label1
  label $topwin(util_name).info.current_image1.frame.label1 \
    -background "$GuiColor(label_bg)" \
    -borderwidth {0} \
    -text {Second image: }

  # pack widget $topwin(util_name).info.current_image1.frame
  pack append $topwin(util_name).info.current_image1.frame \
    $topwin(util_name).info.current_image1.frame.label1 {left frame center filly} \
    $topwin(util_name).info.current_image1.frame.frame {top frame center fillx}

  # pack widget $topwin(util_name).info.current_image1
  pack append $topwin(util_name).info.current_image1 \
    $topwin(util_name).info.current_image1.frame {top frame center fill}

  # build widget $topwin(util_name).info.current_image2
  frame $topwin(util_name).info.current_image2 \
    -background "$GuiColor(frame_bg)" \
    -borderwidth {2}

  # build widget $topwin(util_name).info.current_image2.label5
  switch -exact -- $opclass {
	add		{set temp " \x2b "}
	subtract	{set temp " \x2d "}
	multiply	{set temp " \xb4 "}
	divide	{set temp " \xb8 "}
	and		{set temp " \xb7 "}
	or			{set temp " \xc8 "}
	not		{set temp " \x21 "}
	xor		{set temp " \xc5 "}
  }
  label $topwin(util_name).info.current_image2.label5 \
    -background "$GuiColor(label_bg)" \
    -font {-adobe-symbol-medium-r-normal--14-*-*-*-*-*-adobe-fontspecific}\
    -relief {ridge} \
    -text $temp

  # pack widget $topwin(util_name).info.current_image2
  pack append $topwin(util_name).info.current_image2 \
    $topwin(util_name).info.current_image2.label5 {left frame center padx 50}

  # build widget $topwin(util_name).info.current_image4
  frame $topwin(util_name).info.current_image4 \
    -background "$GuiColor(frame_bg)" \
    -borderwidth {2}

  # build widget $topwin(util_name).info.current_image4.current
  label $topwin(util_name).info.current_image4.current \
    -background "$GuiColor(label_bg)" \
    -text {Current image:}

  # build widget $topwin(util_name).info.current_image4.name
  label $topwin(util_name).info.current_image4.name \
    -background "$GuiColor(label_bg)" \
    -foreground {Blue} \
    -text {} \
    -textvariable {current_image}

  # pack widget $topwin(util_name).info.current_image4
  pack append $topwin(util_name).info.current_image4 \
    $topwin(util_name).info.current_image4.current {left frame center filly} \
    $topwin(util_name).info.current_image4.name {left frame center filly}

  # pack widget $topwin(util_name).info
    pack append $topwin(util_name).info \
    $topwin(util_name).info.current_image1 {bottom frame center expand fill} \
    $topwin(util_name).info.current_image2 {bottom frame center expand fill} \
    $topwin(util_name).info.current_image4 {bottom frame center expand fill}

	if { $opclass == "not" } {
		pack forget $topwin(util_name).info.current_image4
  		$topwin(util_name).info.current_image1.frame.label1 configure -text "Current image: "
  		$topwin(util_name).info.current_image1.frame.frame.entry2 configure -textvariable current_image
	}
  # build widget $topwin(util_name).perform
  frame $topwin(util_name).perform \
    -background "$GuiColor(frame_bg)" \
    -borderwidth {2} \
    -relief {raised}

  # build widget $topwin(util_name).perform.perform1
	button $topwin(util_name).perform.perform1 -padx {1} -pady {1} -highlightthickness {0}  \
    -foreground "$GuiColor(perf_fg)" \
    -background "$GuiColor(perf_bg)" \
	 -activebackground "$GuiColor(perf_act_bg)" \
    -command { } \
    -foreground {white} \
	 -command {
		 $topwin(util_name) configure -cursor watch; update
		 if { $util(arith_log) == "not" } {set second_image $current_image}
		 if {$current_image == ""} {
			CvipAlert "Please select an image first using the mouse."
			$topwin(util_name) configure -cursor top_left_arrow; update
			return
		 } elseif {$second_image == ""} {
			CvipAlert "Please select a second image using Ctrl-button1 in the image queue or typing the image name."
			$topwin(util_name) configure -cursor top_left_arrow; update
			return
		 } elseif [catch {scan [cvip info $second_image] "%s%s%s%s%s%s%s" null null temp null null null null}] {
			CvipAlert "Inappropriate image format for \"$second_image\"."
			$topwin(util_name) configure -cursor top_left_arrow; update
			return
		 } elseif {$bands != $temp } {
			CvipAlert "\"$util(arith_log)\" can't work on two images with different number of bands \n\
						 bands of \"$current_image\" is: $bands;\n\
						 bands of \"$second_image\" is : $temp."
			$topwin(util_name) configure -cursor top_left_arrow; update
			return
		 } else {
			switch -exact -- $util(arith_log) {
				not {
					if [catch {set result [cvip $util(arith_log) $current_image]}] {
						CvipAlert "Image $util(arith_log) error!"
						$topwin(util_name) configure -cursor top_left_arrow; update
						return
					} else {
						set new_name [cvip rename $result not_${current_image}]
					}
					CvipMessage "\"not\" operation performed on image \"$current_image\""
				}
				divide {
#					if [catch {scan [cvip info $second_image] "%s%s%s%s%s%s%s" null null null temp null null null}] {
#						CvipAlert "Inappropriate image format for \"$second_image\"."
#						$topwin(util_name) configure -cursor top_left_arrow; update
#						return 
#					 } elseif { $temp != $rows } {
#						CvipAlert "You can't divide two images with different number of rows \n\
#									 bands of \"$current_image\" is: $rows;\n\
#						 		    bands of \"$second_image\" is : $temp."
#						$topwin(util_name) configure -cursor top_left_arrow; update
#						return  
#					 } 
#					if [catch {scan [cvip info $second_image] "%s%s%s%s%s%s%s" null null null null temp null null}] {
#						CvipAlert "Inappropriate image format for \"$second_image\"."
#						$topwin(util_name) configure -cursor top_left_arrow; update
#						return 
#					 } elseif { $temp != $cols } {
#						CvipAlert "You can't divide two images with different number of cols \n\
#									 bands of \"$current_image\" is: $rows;\n\
#						 		    bands of \"$second_image\" is : $temp."
#						$topwin(util_name) configure -cursor top_left_arrow; update
#						return  
#					 } 
					if [catch {set result [cvip $util(arith_log) $current_image $second_image]}] {
						CvipAlert "Image $util(arith_log) error!"
						$topwin(util_name) configure -cursor top_left_arrow; update
						return
					} else {
						set new_name [cvip rename $result ${current_image}_div_$second_image]
					}
					CvipMessage "image \"$current_image\" is divided by image \"$second_image\""
				}
				default {
					if [catch { set result [ cvip $util(arith_log) $current_image $second_image ]}] {
						CvipAlert "Image $util(arith_log) error!"
						$topwin(util_name) configure -cursor top_left_arrow; update
						return
					} else {
						switch -exact -- $util(arith_log) {
							subtract { set temp sub}
							multiply { set temp mult}
							default {set temp $util(arith_log) }
						}
						set new_name [cvip rename $result ${current_image}_${temp}_$second_image]
						CvipMessage "\"$util(arith_log)\" operation performed on image \"$current_image\" and \"$second_image\""
					}
				}
			}
			img_q insert end $new_name
			image_post $new_name
			cvip view $new_name
			}
	$topwin(util_name) configure -cursor top_left_arrow; update
	 } \
    -text {PERFORM}

  # build widget $topwin(util_name).perform.dismiss
	button $topwin(util_name).perform.dismiss -padx {1} -pady {1} -highlightthickness {0}  \
    -foreground "$GuiColor(dis_fg)" \
    -background "$GuiColor(dis_bg)" \
	 -activebackground "$GuiColor(dis_act_bg)" \
    -command {destroy $topwin(util_name); set topwin(util_name) NONE} \
    -text {DISMISS} \
    -width {10}

  # pack widget $topwin(util_name).perform
  pack append $topwin(util_name).perform \
    $topwin(util_name).perform.dismiss {left frame sw filly} \
    $topwin(util_name).perform.perform1 {right frame se filly}

  # pack widget $topwin(util_name)
  pack append $topwin(util_name) \
    $topwin(util_name).info {top frame center expand fill} \
    $topwin(util_name).perform {bottom frame center pady 5 fill}

  if {"[info procs XFEdit]" != ""} {
    catch "XFMiscBindWidgetTree $topwin(util_name)"
    after 2 "catch {XFEditSetShowWindows}"
  }

}

proc util_mult { } {

  global {util}
  global GuiColor
  global GuiMisc
  # Window manager configurations
  global topwin
  global toplevel_position
  if [ winfo exists $topwin(util_name).info] {
     set tempname $topwin(util_name);\
destroy $topwin(util_name).info;\
set topwin(util_name) $tempname;}
  if [ winfo exists $topwin(util_name).current_image] {
     set tempname $topwin(util_name);\
destroy $topwin(util_name).current_image;\
set topwin(util_name) $tempname;}
  if [ winfo exists $topwin(util_name).perform] {
     set tempname $topwin(util_name);\
destroy $topwin(util_name).perform;\
set topwin(util_name) $tempname;}
  wm positionfrom $topwin(util_name) user
  wm sizefrom $topwin(util_name) user
  wm geometry $topwin(util_name) $topwin(util_top)[get_pos $topwin(util_name)]
  wm maxsize $topwin(util_name) 600 270
  wm minsize $topwin(util_name) 500 180
  wm title $topwin(util_name) "UTILITIES -> Arith/Logic -> Multiply"

  # bindings
  bind $topwin(util_name) <Destroy> {set topwin(util_name) NONE}

  # build widget $topwin(util_name).info
  frame $topwin(util_name).info \
    -background "$GuiColor(frame_bg)" \
	 -highlightthickness {0} \
    -borderwidth {2}

  # build widget $topwin(util_name).info.current_image1
  frame $topwin(util_name).info.current_image1 \
    -background "$GuiColor(frame_bg)" \
    -borderwidth {2}

  # build widget $topwin(util_name).info.current_image1.frame
  frame $topwin(util_name).info.current_image1.frame \
    -background "$GuiColor(frame_bg)" 

  # build widget $topwin(util_name).info.current_image1.frame.frame
  frame $topwin(util_name).info.current_image1.frame.frame \
    -background "$GuiColor(frame_bg)" 

  # build widget $topwin(util_name).info.current_image1.frame.frame.scrollbar1
  scrollbar $topwin(util_name).info.current_image1.frame.frame.scrollbar1 \
    -activebackground {gray90} \
    -troughcolor {gray50} \
	 -highlightthickness {0} \
    -command {$topwin(util_name).info.current_image1.frame.frame.entry2 xview} \
    -background {gray90} \
    -orient {horizontal} \
    -width {11}

  # build widget $topwin(util_name).info.current_image1.frame.frame.entry2
  entry $topwin(util_name).info.current_image1.frame.frame.entry2 \
	 -background "$GuiColor(entry_bg)" \
	 -foreground "$GuiColor(entry_fg)" \
    -relief {sunken} \
 -xscrollcommand {$topwin(util_name).info.current_image1.frame.frame.scrollbar1 set} \
    -textvariable {second_image}
  # bindings
  endEntry $topwin(util_name).info.current_image1.frame.frame.entry2

  # pack widget $topwin(util_name).info.current_image1.frame.frame
  pack append $topwin(util_name).info.current_image1.frame.frame \
    $topwin(util_name).info.current_image1.frame.frame.entry2 {top frame center expand fill} \
    $topwin(util_name).info.current_image1.frame.frame.scrollbar1 {top frame center fillx}

  # build widget $topwin(util_name).info.current_image1.frame.label1
  label $topwin(util_name).info.current_image1.frame.label1 \
    -background "$GuiColor(label_bg)" \
    -borderwidth {0} \
    -text {Second image: }

  # pack widget $topwin(util_name).info.current_image1.frame
  pack append $topwin(util_name).info.current_image1.frame \
    $topwin(util_name).info.current_image1.frame.label1 {left frame center filly} \
    $topwin(util_name).info.current_image1.frame.frame {top frame center fillx}

  # pack widget $topwin(util_name).info.current_image1
  pack append $topwin(util_name).info.current_image1 \
    $topwin(util_name).info.current_image1.frame {top frame center fill}

  # build widget $topwin(util_name).info.current_image2
  frame $topwin(util_name).info.current_image2 \
    -background "$GuiColor(frame_bg)"  \
    -borderwidth {2}

  # build widget $topwin(util_name).info.current_image2.label5
  label $topwin(util_name).info.current_image2.label5 \
    -background "$GuiColor(label_bg)" \
    -relief {ridge} \
    -text {Multiply }

  set util(mult) img
  # build widget $topwin(util_name).info.current_image2.radiobutton0
	radiobutton $topwin(util_name).info.current_image2.radiobutton0 -padx {1} -pady {1} -highlightthickness {0}  \
    -background "$GuiColor(btn_bg)" \
	 -activebackground "$GuiColor(btn_act_bg)" \
    -relief {flat} \
    -text {with image} \
    -value {img} \
	 -command "\
	 pack forget $topwin(util_name).info.current_image2.frame0; \
    pack append $topwin(util_name).info \
       $topwin(util_name).info.current_image1 {bottom frame center expand fillx} 
	 " \
    -variable {util(mult)}

  frame $topwin(util_name).info.current_image2.frame1 \
    -background "$GuiColor(frame_bg)"  \
	-borderwidth {0}

	radiobutton $topwin(util_name).info.current_image2.frame1.radiobutton1 -padx {1} -pady {1} -highlightthickness {0}  \
    -background "$GuiColor(btn_bg)" \
	 -activebackground "$GuiColor(btn_act_bg)" \
    -relief {flat} \
    -text {by a constant } \
    -value {factor} \
	 -command "\
	 pack append  $topwin(util_name).info.current_image2 \
		$topwin(util_name).info.current_image2.frame0 {left frame center expand } 
	 pack forget $topwin(util_name).info.current_image1
	 " \
    -variable {util(mult)}

	radiobutton $topwin(util_name).info.current_image2.frame1.radiobutton2 -padx {1} -pady {1} -highlightthickness {0}  \
    -background "$GuiColor(btn_bg)" \
	 -activebackground "$GuiColor(btn_act_bg)" \
	-anchor {w} \
	-relief {flat} \
	-text {With} \
	-value {1} \
	-variable {util(mult_clip)}

	radiobutton $topwin(util_name).info.current_image2.frame1.radiobutton3 -padx {1} -pady {1} -highlightthickness {0}  \
    -background "$GuiColor(btn_bg)" \
	 -activebackground "$GuiColor(btn_act_bg)" \
	-anchor {w} \
	-relief {flat} \
	-text {Without} \
	-value {0} \
	-variable {util(mult_clip)}

  # build widget $topwin(util_name).info.current_image2.frame1.label1
  label $topwin(util_name).info.current_image2.frame1.label1 \
    -background "$GuiColor(label_bg)" \
    -anchor {e} \
    -borderwidth {0} \
    -text {BYTE clip}

  pack append $topwin(util_name).info.current_image2.frame1 \
    $topwin(util_name).info.current_image2.frame1.radiobutton1 {left frame center fill} \
    $topwin(util_name).info.current_image2.frame1.label1 {right frame center fill} \
    $topwin(util_name).info.current_image2.frame1.radiobutton2 {top frame w fill} \
    $topwin(util_name).info.current_image2.frame1.radiobutton3 {top frame w fill}

  # build widget $topwin(util_name).info.current_image2.frame0
  frame $topwin(util_name).info.current_image2.frame0 \
    -background "$GuiColor(frame_bg)" 

  # build widget $topwin(util_name).info.current_image2.frame0.label1
  label $topwin(util_name).info.current_image2.frame0.label1 \
    -background "$GuiColor(label_bg)" \
    -anchor {e} \
    -borderwidth {0} \
    -text {}

  # build widget $topwin(util_name).info.current_image2.frame0.value
  entry $topwin(util_name).info.current_image2.frame0.value \
	 -background "$GuiColor(entry_bg)" \
	 -foreground "$GuiColor(entry_fg)" \
    -relief {sunken} \
    -textvariable {util(mult_factor)} \
    -width {6}
  # bindings
  endEntry $topwin(util_name).info.current_image2.frame0.value

  # build widget $topwin(util_name).info.current_image2.frame0.menubutton2
	menubutton $topwin(util_name).info.current_image2.frame0.menubutton2 -padx {1} -pady {1} -highlightthickness {0}  \
    -background "$GuiColor(btn_bg)" \
	 -activebackground "$GuiColor(btn_act_bg)" \
	 -font "$GuiMisc(pop_up_fn)" \
	 -text "$GuiMisc(pop_up_text)" \
	 -relief "$GuiMisc(pop_up_relief)" \
	 -width {2}
    
  # bindings
  bind $topwin(util_name).info.current_image2.frame0.menubutton2 <Button-1> {MenuPopupPost $topwin(util_name).info.current_image2.frame0.menubutton2.menu %X %Y}
  bind $topwin(util_name).info.current_image2.frame0.menubutton2 <ButtonRelease-1> {MenuPopupRelease $topwin(util_name).info.current_image2.frame0.menubutton2.menu %W}

  # build widget $topwin(util_name).info.current_image2.frame0.menubutton2.menu
  menu $topwin(util_name).info.current_image2.frame0.menubutton2.menu  \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)"
    
  $topwin(util_name).info.current_image2.frame0.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set util(mult_factor) 0.2} \
    -label {  0.2}
  $topwin(util_name).info.current_image2.frame0.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set util(mult_factor) 0.5} \
    -label {  0.5}
  $topwin(util_name).info.current_image2.frame0.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set util(mult_factor) 0.8} \
    -label {  0.8}
  $topwin(util_name).info.current_image2.frame0.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set util(mult_factor) 1.2} \
    -label {  1.2}
  $topwin(util_name).info.current_image2.frame0.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set util(mult_factor) 1.5} \
    -label {  1.5}
  $topwin(util_name).info.current_image2.frame0.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set util(mult_factor) 1.8} \
    -label {  1.8}
  $topwin(util_name).info.current_image2.frame0.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set util(mult_factor) 2.0} \
    -label {  2.0}
  $topwin(util_name).info.current_image2.frame0.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set util(mult_factor) 2.5} \
    -label {  2.5}
  $topwin(util_name).info.current_image2.frame0.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set util(mult_factor) 3.0} \
    -label {  3.0}
  bindtags $topwin(util_name).info.current_image2.frame0.menubutton2.menu {Menu all}
  # bindings
  bind $topwin(util_name).info.current_image2.frame0.menubutton2.menu <B1-Motion> {MenuPopupMotion $topwin(util_name).info.current_image2.frame0.menubutton2.menu0 %W %X %Y}
  bind $topwin(util_name).info.current_image2.frame0.menubutton2.menu <ButtonRelease-1> {MenuPopupRelease $topwin(util_name).info.current_image2.frame0.menubutton2.menu0 %W}

  # pack widget $topwin(util_name).info.current_image2.frame0
  pack append $topwin(util_name).info.current_image2.frame0 \
    $topwin(util_name).info.current_image2.frame0.label1 {left frame center fill} \
    $topwin(util_name).info.current_image2.frame0.value {left frame center fill} \
    $topwin(util_name).info.current_image2.frame0.menubutton2 {right frame center fill}

  # pack widget $topwin(util_name).info.current_image2
  pack append $topwin(util_name).info.current_image2 \
    $topwin(util_name).info.current_image2.label5 {left frame center } \
    $topwin(util_name).info.current_image2.radiobutton0 {left frame center} \
    $topwin(util_name).info.current_image2.frame1 {left frame center } 
#    $topwin(util_name).info.current_image2.frame0 {left frame center padx 215}

  # build widget $topwin(util_name).info.current_image4
  frame $topwin(util_name).info.current_image4 \
    -background "$GuiColor(frame_bg)"  \
    -borderwidth {2}

  # build widget $topwin(util_name).info.current_image4.current
  label $topwin(util_name).info.current_image4.current \
    -background "$GuiColor(label_bg)" \
    -text {Current image:}

  # build widget $topwin(util_name).info.current_image4.name
  label $topwin(util_name).info.current_image4.name \
    -background "$GuiColor(label_bg)" \
    -foreground {Blue} \
    -text {cam.pgm} \
    -textvariable {current_image}

  # pack widget $topwin(util_name).info.current_image4
  pack append $topwin(util_name).info.current_image4 \
    $topwin(util_name).info.current_image4.current {left frame center filly} \
    $topwin(util_name).info.current_image4.name {left frame center filly}

  # pack widget $topwin(util_name).info
  pack append $topwin(util_name).info \
    $topwin(util_name).info.current_image4 {top frame center fillx} \
    $topwin(util_name).info.current_image2 {top frame center fillx} \
    $topwin(util_name).info.current_image1 {bottom frame center fillx} 

  # build widget $topwin(util_name).perform
  frame $topwin(util_name).perform \
    -background "$GuiColor(frame_bg)"  \
    -borderwidth {2} \
    -relief {raised}

  # build widget $topwin(util_name).perform.perform1
	button $topwin(util_name).perform.perform1 -padx {1} -pady {1} -highlightthickness {0}  \
    -foreground "$GuiColor(perf_fg)" \
    -background "$GuiColor(perf_bg)" \
	 -activebackground "$GuiColor(perf_act_bg)" \
    -command {
		 $topwin(util_name) configure -cursor watch; update
		 if { $util(mult) == "factor" } { set second_image $current_image}
		 if {$current_image == ""} {
			CvipAlert "Please select an image first using the mouse."
			$topwin(util_name) configure -cursor top_left_arrow; update
			return
		 } elseif {$second_image == ""} {
			CvipAlert "Please select a second image using Ctrl-button1 in the image queue or typing the image name."
			$topwin(util_name) configure -cursor top_left_arrow; update
			return
		 } elseif [catch {scan [cvip info $second_image] "%s%s%s%s%s%s%s" null null temp null null null null}] {
			CvipAlert "Inappropriate image format for \"$second_image\"."
			$topwin(util_name) configure -cursor top_left_arrow; update
			return
		 } elseif {$bands != $temp } {
			CvipAlert "\"Multiply\" can't work on two images with different number of bands \n bands of \"$current_image\" is: $bands;\n bands of \"$second_image\" is : $temp."
			$topwin(util_name) configure -cursor top_left_arrow; update
			return
		 }

		 if { $util(mult) == "factor" } {
			if [catch {expr $util(mult_factor) } ] {
				CvipAlert "Numerical value required for the multiplication factor:\n\
					Multiply factor = $util(mult_factor)."
				$topwin(util_name) configure -cursor top_left_arrow; update
				return
			} elseif { $util(mult_factor) < "0" } {
				CvipAlert "The multiplication factor ($util(mult_factor)) should be a positive number."
				$topwin(util_name) configure -cursor top_left_arrow; update
				return
			}
			if { $util(mult_clip) == "1" && $data_type != "BYTE" } {
				set temp [cvip data_remap $current_image 0]
			} else {
				set temp $current_image
			}
			if [catch {set result [cvip gray_multiply $temp $util(mult_factor) $util(mult_clip) ]}\
					cresult ] {
         	CvipAlert "$cresult"
         	$topwin(util_name) configure -cursor top_left_arrow; update
         	return
			}  
      	set new_name [cvip rename $result ${current_image}_x$util(mult_factor)]
      	img_q insert end $new_name
      	image_post $new_name
      	cvip view $new_name
			CvipMessage "image \"$current_image\" is multiplied by factor $util(mult_factor)"
			$topwin(util_name) configure -cursor top_left_arrow; update
			return
       }

		if [catch { set result [ cvip multiply $current_image $second_image ]}] {
			CvipAlert "Image multiplication error!"
			$topwin(util_name) configure -cursor top_left_arrow; update
			return
		} else {
			set new_name [cvip rename $result ${current_image}_multi_$second_image]
			CvipMessage "image multiplication performed on images \"$current_image\" and \"$second_image\""
		}
		img_q insert end $new_name
		image_post $new_name
		cvip view $new_name
		$topwin(util_name) configure -cursor top_left_arrow; update
	 } \
    -text {PERFORM}

  # build widget $topwin(util_name).perform.dismiss
	button $topwin(util_name).perform.dismiss -padx {1} -pady {1} -highlightthickness {0}  \
    -foreground "$GuiColor(dis_fg)" \
    -background "$GuiColor(dis_bg)" \
	 -activebackground "$GuiColor(dis_act_bg)" \
    -command {destroy $topwin(util_name); set topwin(util_name) NONE} \
    -text {DISMISS} \
    -width {10}

  # pack widget $topwin(util_name).perform
  pack append $topwin(util_name).perform \
    $topwin(util_name).perform.dismiss {left frame sw filly} \
    $topwin(util_name).perform.perform1 {right frame se filly}

  # pack widget $topwin(util_name)
  pack append $topwin(util_name) \
    $topwin(util_name).menu {top frame center fill} \
    $topwin(util_name).info {top frame center expand fill} \
    $topwin(util_name).perform {bottom frame center pady 5 fill}

  if {"[info procs XFEdit]" != ""} {
    catch "XFMiscBindWidgetTree $topwin(util_name)"
    after 2 "catch {XFEditSetShowWindows}"
  }
}
