# Computer Vision/Image Processing Tool Project - Dr. Scott Umbaugh SIUE
# **********************************************************************
#
#             File Name: util_conv.tcl
#           Description: 
#         Related Files: 
#   Initial Coding Date: Fri Aug  9 17:33:22 CDT 1996
#           Portability: TCL script file
#            References:
#             Author(s): Yansheng Wei
#                        Southern Illinois University @ Edwardsville
#
## Copyright (C) 1996 SIUE - by Scott Umbaugh and Yansheng Wei.
##
## Permission to use, copy, modify, and distribute this software and its
## documentation for any purpose and without fee is hereby granted, provided
## that the above copyright notice appear in all copies and that both that
## copyright notice and this permission notice appear in supporting
## documentation.  This software is provided "as is" without express or
## implied warranty.
##
# RCS (Revision Control System) Information
# ...Added automatically by RCS 
#
## $Log: util_conv.tcl,v $
## Revision 1.31  1997/07/28 21:46:08  wzheng
## Utilities->Create->color space disable
##
## Revision 1.30  1997/07/28 19:38:50  wzheng
## default color space setup
##
## Revision 1.29  1997/07/17 19:28:12  yawei
## changed "wm geometry"
##
## Revision 1.28  1997/07/16 18:47:28  yawei
## Gui configuration in place
##
## Revision 1.27  1997/07/09 18:54:31  yawei
## removed RGB
##
## Revision 1.26  1997/04/08 00:02:39  yawei
## fixed texts
##
## Revision 1.25  1997/03/27 02:00:26  yawei
## GUI ==> CVIPTCL/GUI_SCRIPTS/
##
## Revision 1.24  1997/03/12 17:08:23  yawei
## changed win size
##
## Revision 1.23  1997/03/12 15:43:42  yawei
## changed window size and arrow butons
## ,.
##
## Revision 1.22  1997/03/11 20:56:51  yawei
## Tcl/Tk script upgrading from tcl7.3/tk3.6 to tcl7.6/tk4.2
## compatible. This process is automated with tkboost perl
## script. @ Tue Mar 11 14:51:36 CST 1997
##
## Revision 1.21  1996/12/31 00:23:51  yawei
## set util(color) == XYZ
##
# Revision 1.20  1996/11/15  16:31:46  yawei
# Added IGS
#
# Revision 1.19  1996/11/15  02:19:25  yawei
# fixed a bug
#
# Revision 1.18  1996/11/15  02:11:53  yawei
# Changed binary thresholding so it takes another parameter,
# whether the threshval is on byte or on original data.
#
# Revision 1.17  1996/11/03  01:47:24  yawei
# Using "luminance" to handle color image in labeling
#
# Revision 1.16  1996/10/18  03:27:34  yawei
# switched the position of the Bray_bin radio buttons
#
# Revision 1.15  1996/10/17  03:13:51  yawei
# changed text
#
# Revision 1.14  1996/10/16  19:30:21  yawei
# general changes
#
# Revision 1.13  1996/10/10  20:26:00  yawei
# changed wrong nmae for "Gray level quantization".
#
# Revision 1.12  1996/10/08  02:44:17  yawei
# Added new functions:
# 1) Gray_binary
# 2) Gray level quantization
#
# Revision 1.11  1996/09/27  23:32:54  yawei
# changed float to integer on Frequency_domain_mapping
#
# Revision 1.10  1996/09/27  18:31:30  mzuke
# made window resizable
#
# Revision 1.9  1996/09/22  19:23:56  yawei
# changd color numbers to "R, G, B" in Frequency domain mapping
#
# Revision 1.8  1996/09/16  00:44:19  yawei
# unset "temp2" after done in gray level mapping
#
# Revision 1.7  1996/09/16  00:34:44  yawei
# changed to gray level mapping to make it work as expected.
#
# Revision 1.6  1996/09/11  22:36:05  yawei
# Changed to Gray Level Mapping.
#
# Revision 1.5  1996/09/11  20:46:01  yawei
# added gray level mapping.
#
# Revision 1.4  1996/08/15  16:31:51  mzuke
# corrected message for labeling function
#
# Revision 1.3  1996/08/15  16:22:48  mzuke
# added label image to convert menu
#
# Revision 1.2  1996/08/15  11:14:05  mzuke
# removed toplevel_position from wm geometry to allow window
# positioning by user
#
# Revision 1.1  1996/08/09  22:36:42  yawei
# Initial revision
#
#
#****************************************************************************
# procedure to show window $topwin(util_name)
proc util_thresh { } {# xf ignore me 7

  # Window manager configurations
  global tk_version
  global topwin
  global toplevel_position
  global GuiColor
  global GUI_DEBUG
  global GuiMisc
  global util
  if [ winfo exists $topwin(util_name).info] {
     set tempname $topwin(util_name);\
destroy $topwin(util_name).info;\
set topwin(util_name) $tempname;}
  if [ winfo exists $topwin(util_name).current_image] {
     set tempname $topwin(util_name);\
destroy $topwin(util_name).current_image;\
set topwin(util_name) $tempname;}
  if [ winfo exists $topwin(util_name).perform] {
     set tempname $topwin(util_name);\
destroy $topwin(util_name).perform;\
set topwin(util_name) $tempname;}
  wm positionfrom $topwin(util_name) user
  wm sizefrom $topwin(util_name) user
  wm geometry $topwin(util_name) $topwin(util_top)[get_pos $topwin(util_name)]
  wm maxsize $topwin(util_name) [lindex [split $topwin(util_top_max)] 0] \
  	[lindex [split $topwin(util_top_max)] 1]
  wm minsize $topwin(util_name) [lindex [split $topwin(util_top_min)] 0] \
  	[lindex [split $topwin(util_top_min)] 1]
  wm title $topwin(util_name) {UTILITIES -> Convert -> Binary threshold}
  # bindings
  bind $topwin(util_name) <Destroy> {set topwin(util_name) NONE}

  # build widget $topwin(util_name).info
  frame $topwin(util_name).info \
    -background "$GuiColor(frame_bg)" \
    -borderwidth {2}

  # build widget $topwin(util_name).info.frame0
  frame $topwin(util_name).info.frame0 \
    -background "$GuiColor(frame_bg)"

  # build widget $topwin(util_name).info.frame0.label1
  label $topwin(util_name).info.frame0.label1 \
    -anchor {e} \
    -background "$GuiColor(label_bg)" \
    -borderwidth {0} \
    -text {Binary threshold level } \
    -width {25}

  # build widget $topwin(util_name).info.frame0.frame1
  frame $topwin(util_name).info.frame0.frame1 \
    -background "$GuiColor(frame_bg)" \
    -borderwidth {2}
	set util(bin_thresh_data) 0
  # build widget $topwin(util_name).info.frame0.frame1.radiobutton1
	radiobutton $topwin(util_name).info.frame0.frame1.radiobutton1 -padx {1} -pady {1} -highlightthickness {0}  \
	 -background "$GuiColor(btn_bg)" \
	 -activebackground "$GuiColor(btn_act_bg)" \
    -relief {flat} \
    -text {in BYTE} \
    -value {1} \
    -command "pack append $topwin(util_name).info.frame0 \
    				$topwin(util_name).info.frame0.menubutton2 {right frame center fillx}" \
    -variable {util(bin_thresh_data)}

  # build widget $topwin(util_name).info.frame0.frame1.radiobutton2
	radiobutton $topwin(util_name).info.frame0.frame1.radiobutton2 -padx {1} -pady {1} -highlightthickness {0}  \
	 -background "$GuiColor(btn_bg)" \
	 -activebackground "$GuiColor(btn_act_bg)" \
    -relief {flat} \
    -text {on original data} \
    -value {0} \
    -command "pack forget $topwin(util_name).info.frame0.menubutton2" \
    -variable {util(bin_thresh_data)}

  # pack widget $topwin(util_name).info.frame0.frame1
  pack append $topwin(util_name).info.frame0.frame1 \
    $topwin(util_name).info.frame0.frame1.radiobutton1 {top frame nw} \
    $topwin(util_name).info.frame0.frame1.radiobutton2 {top frame center}

  # build widget $topwin(util_name).info.frame0.value
  entry $topwin(util_name).info.frame0.value \
    -background "$GuiColor(entry_bg)" \
	 -foreground "$GuiColor(entry_fg)" \
    -relief {sunken} \
    -textvariable {util(bin_thresh_level)} \
    -width {10}
  # bindings
  endEntry $topwin(util_name).info.frame0.value

  # build widget $topwin(util_name).info.frame0.menubutton2
	menubutton $topwin(util_name).info.frame0.menubutton2 -padx {1} -pady {5} -highlightthickness {0}  \
	 -background "$GuiColor(btn_bg)" \
	 -activebackground "$GuiColor(btn_act_bg)" \
    -font "$GuiMisc(pop_up_fn)" \
	 -text "$GuiMisc(pop_up_text)" \
	 -relief "$GuiMisc(pop_up_relief)" \
	 -width {2}

  # bindings
  bind $topwin(util_name).info.frame0.menubutton2 <Button-1> {MenuPopupPost $topwin(util_name).info.frame0.menubutton2.menu %X %Y}
  bind $topwin(util_name).info.frame0.menubutton2 <ButtonRelease-1> {MenuPopupRelease $topwin(util_name).info.frame0.menubutton2.menu %W}

  # build widget $topwin(util_name).info.frame0.menubutton2.menu
  menu $topwin(util_name).info.frame0.menubutton2.menu \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)"
  $topwin(util_name).info.frame0.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set util(bin_thresh_level) 0} \
    -label {  0}
  $topwin(util_name).info.frame0.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set util(bin_thresh_level) 1} \
    -label {  1}
  $topwin(util_name).info.frame0.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set util(bin_thresh_level) 10} \
    -label { 10}
  $topwin(util_name).info.frame0.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set util(bin_thresh_level) 50} \
    -label { 50}
  $topwin(util_name).info.frame0.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set util(bin_thresh_level) 80} \
    -label { 80}
  $topwin(util_name).info.frame0.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set util(bin_thresh_level) 128} \
    -label {128}
  $topwin(util_name).info.frame0.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set util(bin_thresh_level) 180} \
    -label {180}
  $topwin(util_name).info.frame0.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set util(bin_thresh_level) 200} \
    -label {200}
  $topwin(util_name).info.frame0.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set util(bin_thresh_level) 230} \
    -label {230}
  $topwin(util_name).info.frame0.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set util(bin_thresh_level) 256} \
    -label {256}
  bindtags $topwin(util_name).info.frame0.menubutton2.menu {Menu all}
  # bindings
  bind $topwin(util_name).info.frame0.menubutton2.menu <B1-Motion> {MenuPopupMotion $topwin(util_name).info.frame0.menubutton2.menu %W %X %Y}
  bind $topwin(util_name).info.frame0.menubutton2.menu <ButtonRelease-1> {MenuPopupRelease $topwin(util_name).info.frame0.menubutton2.menu %W}

  # pack widget $topwin(util_name).info.frame0
  pack append $topwin(util_name).info.frame0 \
    $topwin(util_name).info.frame0.label1 {left frame center fill} \
  	 $topwin(util_name).info.frame0.frame1 {left frame center fill} \
    $topwin(util_name).info.frame0.value {left frame center fillx} 
#    $topwin(util_name).info.frame0.menubutton2 {right frame center fillx}

  # pack widget $topwin(util_name).info
  pack append $topwin(util_name).info \
    $topwin(util_name).info.frame0 {left frame e padx 30}

  # build widget $topwin(util_name).perform
  frame $topwin(util_name).perform \
    -background "$GuiColor(frame_bg)" \
    -borderwidth {2} \
    -relief {raised}

  # build widget $topwin(util_name).perform.perform1
	button $topwin(util_name).perform.perform1 -padx {1} -pady {1} -highlightthickness {0}  \
    -activebackground "$GuiColor(perf_act_bg)" \
    -background "$GuiColor(perf_bg)" \
    -foreground "$GuiColor(perf_fg)" \
    -command {
		$topwin(util_name) configure -cursor watch; update
		if {$current_image == ""} {
			CvipAlert "Please select an image first."
			$topwin(util_name) configure -cursor top_left_arrow
			return
		} elseif [catch {expr $util(bin_thresh_level)} ] {
			CvipAlert "Numerical value required for threshold level.\n Threshold level = $util(bin_thresh_level)"
			$topwin(util_name) configure -cursor top_left_arrow
			return
		} elseif { $util(bin_thresh_level) < 0 && $util(bin_thresh_data) == 1} {
			CvipAlert "Threshold level should be a non-negative value. \n Threshold level = $Threshold level"
			$topwin(util_name) configure -cursor top_left_arrow
			return
		}
		if [catch {set result [cvip threshold $current_image $util(bin_thresh_level)\
		$util(bin_thresh_data)]} cresult ] {
			CvipAlert "$cresult"
			$topwin(util_name) configure -cursor top_left_arrow
			return
		}
		set new_name [cvip rename $result ${current_image}_thresh_$util(bin_thresh_level)]
		img_q insert end $new_name
		image_post $new_name
		cvip view $new_name
		CvipMessage "binary threshoding performed on image \"$current_image\""
	 $topwin(util_name) configure -cursor top_left_arrow
	 } \
    -foreground {white} \
    -text {PERFORM}

  # build widget $topwin(util_name).perform.dismiss
	button $topwin(util_name).perform.dismiss -padx {1} -pady {1} -highlightthickness {0}  \
    -activebackground "$GuiColor(dis_act_bg)" \
    -background "$GuiColor(dis_bg)" \
    -foreground "$GuiColor(dis_fg)" \
    -command {destroy $topwin(util_name); set topwin(util_name) NONE} \
    -text {DISMISS} \
    -width {10}

  # pack widget $topwin(util_name).perform
  pack append $topwin(util_name).perform \
    $topwin(util_name).perform.dismiss {left frame sw filly} \
    $topwin(util_name).perform.perform1 {right frame se filly}

  # build widget $topwin(util_name).current_image
  frame $topwin(util_name).current_image \
    -background "$GuiColor(frame_bg)" \
    -borderwidth {2} \
    -relief {ridge}

  # build widget $topwin(util_name).current_image.current
  label $topwin(util_name).current_image.current \
    -background "$GuiColor(label_bg)" \
    -text {Current image:}

  # build widget $topwin(util_name).current_image.name
  label $topwin(util_name).current_image.name \
    -background "$GuiColor(label_bg)" \
    -foreground {Blue} \
    -text {} \
    -textvariable {current_image}

  # pack widget $topwin(util_name).current_image
  pack append $topwin(util_name).current_image \
    $topwin(util_name).current_image.current {left frame center} \
    $topwin(util_name).current_image.name {left frame center filly}

  # pack widget $topwin(util_name)
  pack append $topwin(util_name) \
    $topwin(util_name).info {top frame center expand fill} \
    $topwin(util_name).perform {bottom frame center pady 5 fill} \
    $topwin(util_name).current_image {bottom frame center fill}

  if {"[info procs XFEdit]" != ""} {
    catch "XFMiscBindWidgetTree $topwin(util_name)"
    after 2 "catch {XFEditSetShowWindows}"
  }
}


# procedure to show window $topwin(util_name)
proc util_color { } {# xf ignore me 7

  global {util}
  # Window manager configurations
  global topwin
  global toplevel_position
  global GuiColor
  global GUI_DEBUG
  global GuiMisc
  if [ winfo exists $topwin(util_name).info] {
     set tempname $topwin(util_name);\
destroy $topwin(util_name).info;\
set topwin(util_name) $tempname;}
  if [ winfo exists $topwin(util_name).current_image] {
     set tempname $topwin(util_name);\
destroy $topwin(util_name).current_image;\
set topwin(util_name) $tempname;}
  if [ winfo exists $topwin(util_name).perform] {
     set tempname $topwin(util_name);\
destroy $topwin(util_name).perform;\
set topwin(util_name) $tempname;}
  wm positionfrom $topwin(util_name) user
  wm sizefrom $topwin(util_name) user
  wm geometry $topwin(util_name) $topwin(util_top)[get_pos $topwin(util_name)]
  wm maxsize $topwin(util_name) [lindex [split $topwin(util_top_max)] 0] \
  	[lindex [split $topwin(util_top_max)] 1]
  wm minsize $topwin(util_name) [lindex [split $topwin(util_top_min)] 0] \
  	[lindex [split $topwin(util_top_min)] 1]
  wm title $topwin(util_name) "UTILITIES -> Convert -> color space"


  # bindings
  bind $topwin(util_name) <Destroy> {set topwin(util_name) NONE}

  set util(color) HSL

  # build widget $topwin(util_name).info
  frame $topwin(util_name).info \
    -background "$GuiColor(frame_bg)" \
    -borderwidth {2}

  # build widget $topwin(util_name).info.frame0
  frame $topwin(util_name).info.frame0 \
    -background "$GuiColor(frame_bg)"

  # build widget $topwin(util_name).info.frame0.label1
  label $topwin(util_name).info.frame0.label1 \
    -anchor {e} \
    -background "$GuiColor(label_bg)" \
    -borderwidth {0} \
    -text {Convert image to : } \
    -width {20}

  # build widget $topwin(util_name).info.frame0.value
  entry $topwin(util_name).info.frame0.value \
    -background "$GuiColor(rentry_bg)" \
    -foreground "$GuiColor(rentry_fg)" \
    -relief {sunken} \
    -state {disabled} \
    -textvariable {util(color)} \
    -width {5}

  # build widget $topwin(util_name).info.frame0.menubutton2
	menubutton $topwin(util_name).info.frame0.menubutton2 -padx {1} -pady {1} -highlightthickness {0}  \
    -background "$GuiColor(btn_bg)" \
	 -activebackground "$GuiColor(btn_act_bg)" \
    -font "$GuiMisc(pop_up_fn)" \
	 -text "$GuiMisc(pop_up_text)" \
	 -relief "$GuiMisc(pop_up_relief)" \
	 -width {2}
  # bindings
  bind $topwin(util_name).info.frame0.menubutton2 <Button-1> {MenuPopupPost $topwin(util_name).info.frame0.menubutton2.menu %X %Y}
  bind $topwin(util_name).info.frame0.menubutton2 <ButtonRelease-1> {MenuPopupRelease $topwin(util_name).info.frame0.menubutton2.menu %W}

  # build widget $topwin(util_name).info.frame0.menubutton2.menu
  menu $topwin(util_name).info.frame0.menubutton2.menu \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" 

  $topwin(util_name).info.frame0.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)"  \
    -command "set util(color) XYZ
	 $topwin(util_name).info.checkbutton0 configure -offvalue 0
	 $topwin(util_name).info.checkbutton4 configure -state normal
	 $topwin(util_name).info.checkbutton5 configure -state normal
	 " \
    -label {Chromaticity}
  $topwin(util_name).info.frame0.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)"  \
    -command "set util(color) LAB
    $topwin(util_name).info.checkbutton0 configure -offvalue 0
    $topwin(util_name).info.checkbutton4 configure -state normal
    $topwin(util_name).info.checkbutton5 configure -state normal
	 " \
    -label {CIE L*a*b}
  $topwin(util_name).info.frame0.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)"  \
    -command "set util(color) LUV
    $topwin(util_name).info.checkbutton0 configure -offvalue 0 
    $topwin(util_name).info.checkbutton4 configure -state normal 
    $topwin(util_name).info.checkbutton5 configure -state normal" \
    -label {CIE L*u*v}
  $topwin(util_name).info.frame0.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)"  \
    -command "set util(color) CCT
    $topwin(util_name).info.checkbutton0 configure -offvalue 0 
    $topwin(util_name).info.checkbutton4 configure -state normal 
    $topwin(util_name).info.checkbutton5 configure -state normal" \
    -label {Cylindrical}
  $topwin(util_name).info.frame0.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)"  \
    -command "set util(color) HSL
    $topwin(util_name).info.checkbutton0 configure -offvalue 0 
    $topwin(util_name).info.checkbutton4 configure -state normal 
    $topwin(util_name).info.checkbutton5 configure -state normal" \
    -label {Hue/Saturation/Lightness}
  $topwin(util_name).info.frame0.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)"  \
    -command "set util(color) HSV
    $topwin(util_name).info.checkbutton0 configure -offvalue 0 
    $topwin(util_name).info.checkbutton4 configure -state normal 
    $topwin(util_name).info.checkbutton5 configure -state normal" \
    -label {Hue/Saturation/Value}
  $topwin(util_name).info.frame0.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)"  \
    -command "set util(color) PCT
	 $topwin(util_name).info.checkbutton0 configure -offvalue 2
	 $topwin(util_name).info.checkbutton4 configure -state disabled
	 $topwin(util_name).info.checkbutton5 configure -state disabled 
	 " \
    -label {PCT}
#  $topwin(util_name).info.frame0.menubutton2.menu add command \
#    -command "set util(color) RGB
#    $topwin(util_name).info.checkbutton0 configure -offvalue 0 
#    $topwin(util_name).info.checkbutton4 configure -state normal 
#    $topwin(util_name).info.checkbutton5 configure -state normal" \
#    -label {RGB}
  $topwin(util_name).info.frame0.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)"  \
    -command "set util(color) SCT
    $topwin(util_name).info.checkbutton0 configure -offvalue 0 
    $topwin(util_name).info.checkbutton4 configure -state normal 
    $topwin(util_name).info.checkbutton5 configure -state normal" \
    -label {Spherical coordinates}
  bindtags $topwin(util_name).info.frame0.menubutton2.menu  {Menu all}
  # bindings
  bind $topwin(util_name).info.frame0.menubutton2.menu <B1-Motion> {MenuPopupMotion $topwin(util_name).info.frame0.menubutton2.menu %W %X %Y}
  bind $topwin(util_name).info.frame0.menubutton2.menu <ButtonRelease-1> {MenuPopupRelease $topwin(util_name).info.frame0.menubutton2.menu %W}

  # pack widget $topwin(util_name).info.frame0
  pack append $topwin(util_name).info.frame0 \
    $topwin(util_name).info.frame0.label1 {left frame center fill} \
    $topwin(util_name).info.frame0.value {left frame center fill} \
    $topwin(util_name).info.frame0.menubutton2 {right frame center fill}

  # build widget $topwin(util_name).info.checkbutton0
	checkbutton $topwin(util_name).info.checkbutton0 -padx {1} -pady {1} -highlightthickness {0}  \
	 -background "$GuiColor(btn_bg)" \
	 -activebackground "$GuiColor(btn_act_bg)" \
    -text {Forward} \
    -variable {util(color_dir)}

  # build widget $topwin(util_name).info.checkbutton4
	checkbutton $topwin(util_name).info.checkbutton4 -padx {1} -pady {1} -highlightthickness {0}  \
	 -background "$GuiColor(btn_bg)" \
	 -activebackground "$GuiColor(btn_act_bg)" \
    -text {Normalize} \
    -variable {util(color_normal)}

  # build widget $topwin(util_name).info.checkbutton5
	checkbutton $topwin(util_name).info.checkbutton5 -padx {1} -pady {1} -highlightthickness {0}  \
	 -background "$GuiColor(btn_bg)" \
	 -activebackground "$GuiColor(btn_act_bg)" \
    -text {Remap} \
    -variable {util(color_remap)}

  # build widget $topwin(util_name).info.label6
  label $topwin(util_name).info.label6 \
    -background "$GuiColor(label_bg)" \
    -text {format, }

  # pack widget $topwin(util_name).info
  pack append $topwin(util_name).info \
    $topwin(util_name).info.frame0 {left frame center} \
    $topwin(util_name).info.label6 {left frame center} \
    $topwin(util_name).info.checkbutton0 {left frame center padx 16} \
    $topwin(util_name).info.checkbutton4 {left frame center padx 16} \
    $topwin(util_name).info.checkbutton5 {left frame center padx 16}

  # build widget $topwin(util_name).perform
  frame $topwin(util_name).perform \
    -background "$GuiColor(frame_bg)" \
    -borderwidth {2} \
    -relief {raised}

  # build widget $topwin(util_name).perform.perform1
	button $topwin(util_name).perform.perform1 -padx {1} -pady {1} -highlightthickness {0}  \
	 -background "$GuiColor(perf_bg)" \
	 -foreground "$GuiColor(perf_fg)" \
	 -activebackground "$GuiColor(perf_act_bg)" \
    -command {
		$topwin(util_name) configure -cursor watch; update
		if {$current_image == ""} {
			CvipAlert "Please select an image first."
			$topwin(util_name) configure -cursor top_left_arrow
			return
		} 

		if {$bands != "3"} {
			CvipAlert "$util(color) transform only applies to color image."
			$topwin(util_name) configure -cursor top_left_arrow
			return
		} 

		if {$util(color) == "PCT"} {
			if [catch {set result [cvip pct $current_image $util(color_dir)]} cresult] {
				CvipAlert "$cresult"
				$topwin(util_name) configure -cursor top_left_arrow
				return
			} else {
				set new_name [cvip rename $result ${current_image}_pct]
			}
		} else {
			if [catch {set result [cvip cxform $current_image $util(color) $util(color_dir) $util(color_normal) $util(color_remap)]} cresult] {
				CvipAlert "$cresult"
				$topwin(util_name) configure -cursor top_left_arrow
				return
			} else {
				set new_name [cvip rename $result ${current_image}_$util(color)]
			}
		}
		img_q insert end $new_name
		image_post $new_name
		cvip view $new_name
		CvipMessage "color transform performed on image \"$current_image\""
	 $topwin(util_name) configure -cursor top_left_arrow
	 } \
    -text {PERFORM}

  # build widget $topwin(util_name).perform.dismiss
	button $topwin(util_name).perform.dismiss -padx {1} -pady {1} -highlightthickness {0}  \
	 -background "$GuiColor(dis_bg)" \
	 -foreground "$GuiColor(dis_fg)" \
	 -activebackground "$GuiColor(dis_act_bg)" \
    -command {destroy $topwin(util_name); set topwin(util_name) NONE} \
    -text {DISMISS} \
    -width {10}

  # pack widget $topwin(util_name).perform
  pack append $topwin(util_name).perform \
    $topwin(util_name).perform.dismiss {left frame sw filly} \
    $topwin(util_name).perform.perform1 {right frame se filly}

  # build widget $topwin(util_name).current_image
  frame $topwin(util_name).current_image \
    -background "$GuiColor(frame_bg)" \
    -borderwidth {2} \
    -relief {ridge}

  # build widget $topwin(util_name).current_image.current
  label $topwin(util_name).current_image.current \
    -background "$GuiColor(label_bg)" \
    -text {Current image:}

  # build widget $topwin(util_name).current_image.name
  label $topwin(util_name).current_image.name \
    -background "$GuiColor(label_bg)" \
    -foreground {Blue} \
    -text {} \
    -textvariable {current_image}

  # pack widget $topwin(util_name).current_image
  pack append $topwin(util_name).current_image \
    $topwin(util_name).current_image.current {left frame center} \
    $topwin(util_name).current_image.name {left frame center filly}

  # pack widget $topwin(util_name)
  pack append $topwin(util_name) \
    $topwin(util_name).info {top frame center expand fill} \
    $topwin(util_name).perform {bottom frame center pady 5 fill} \
    $topwin(util_name).current_image {bottom frame center fill}

  if {"[info procs XFEdit]" != ""} {
    catch "XFMiscBindWidgetTree $topwin(util_name)"
    after 2 "catch {XFEditSetShowWindows}"
  }
}


# procedure to show window $topwin(util_name)
proc util_col_grey { } {# xf ignore me 7


  # Window manager configurations
  global tk_version
  global GuiColor
  global GUI_DEBUG
  global GuiMisc
  global topwin
  global toplevel_position
  global GuiColor
  global GUI_DEBUG
  global GuiMisc
  if [ winfo exists $topwin(util_name).info] {
     set tempname $topwin(util_name);\
destroy $topwin(util_name).info;\
set topwin(util_name) $tempname;}
  if [ winfo exists $topwin(util_name).current_image] {
     set tempname $topwin(util_name);\
destroy $topwin(util_name).current_image;\
set topwin(util_name) $tempname;}
  if [ winfo exists $topwin(util_name).perform] {
     set tempname $topwin(util_name);\
destroy $topwin(util_name).perform;\
set topwin(util_name) $tempname;}
  wm positionfrom $topwin(util_name) user
  wm sizefrom $topwin(util_name) user
  wm geometry $topwin(util_name) $topwin(util_top)[get_pos $topwin(util_name)]
  wm maxsize $topwin(util_name) [lindex [split $topwin(util_top_max)] 0] \
  	[lindex [split $topwin(util_top_max)] 1]
  wm minsize $topwin(util_name) [lindex [split $topwin(util_top_min)] 0] \
  	[lindex [split $topwin(util_top_min)] 1]
  wm title $topwin(util_name) {UTILITIES -> Convert -> Color to gray}

  # bindings
  bind $topwin(util_name) <Destroy> {set topwin(util_name) NONE}

  # build widget $topwin(util_name).info
  frame $topwin(util_name).info \
    -background "$GuiColor(frame_bg)" \
    -borderwidth {2}
  # bindings
  bind $topwin(util_name).info <Button-1> {MenuPopupPost $topwin(util_name).info.menu2 %X %Y}
  bind $topwin(util_name).info <ButtonRelease-1> {MenuPopupRelease $topwin(util_name).info.menu2 %W}

  # build widget $topwin(util_name).info.frame3
  frame $topwin(util_name).info.frame3 \
    -background "$GuiColor(frame_bg)"

  # build widget $topwin(util_name).info.frame3.label5
  label $topwin(util_name).info.frame3.label5 \
    -background "$GuiColor(label_bg)" \
    -text {Convert color image to gray level image using: }

  # pack widget $topwin(util_name).info.frame3
  pack append $topwin(util_name).info.frame3 \
    $topwin(util_name).info.frame3.label5 {left frame center padx 10}

  # build widget $topwin(util_name).info.frame9
  frame $topwin(util_name).info.frame9 \
    -background "$GuiColor(frame_bg)"

  # build widget $topwin(util_name).info.frame9.radiobutton10
	radiobutton $topwin(util_name).info.frame9.radiobutton10 -padx {1} -pady {1} -highlightthickness {0}  \
    -background "$GuiColor(btn_bg)" \
	 -activebackground "$GuiColor(btn_act_bg)" \
    -relief {flat} \
    -text { Luminance} \
    -value {luminance} \
    -variable {util(c_g)}

  # build widget $topwin(util_name).info.frame9.radiobutton14
	radiobutton $topwin(util_name).info.frame9.radiobutton14 -padx {1} -pady {1} -highlightthickness {0}  \
    -background "$GuiColor(btn_bg)" \
	 -activebackground "$GuiColor(btn_act_bg)" \
    -relief {flat} \
    -text {Average} \
    -value {lum_average} \
    -variable {util(c_g)}

  # pack widget $topwin(util_name).info.frame9
  pack append $topwin(util_name).info.frame9 \
    $topwin(util_name).info.frame9.radiobutton10 {left frame center expand} \
    $topwin(util_name).info.frame9.radiobutton14 {left frame center expand}

  # pack widget $topwin(util_name).info
  pack append $topwin(util_name).info \
    $topwin(util_name).info.frame3 {top frame center expand fill} \
    $topwin(util_name).info.frame9 {top frame center expand fill}

  # build widget $topwin(util_name).perform
  frame $topwin(util_name).perform \
    -background "$GuiColor(frame_bg)" \
    -borderwidth {2} \
    -relief {raised}

  # build widget $topwin(util_name).perform.perform1
	button $topwin(util_name).perform.perform1 -padx {1} -pady {1} -highlightthickness {0}  \
	 -background "$GuiColor(perf_bg)" \
	 -foreground "$GuiColor(perf_fg)" \
	 -activebackground "$GuiColor(perf_act_bg)" \
    -command {
		$topwin(util_name) configure -cursor watch; update
      if { $current_image == ""} {
         CvipAlert "Please select an image first."
	  		$topwin(util_name) configure -cursor top_left_arrow
         return
      } 

		if { $util(c_g) == "luminance" && $bands != "3" } {
         CvipAlert "Luminance applies to color image only."
	  		$topwin(util_name) configure -cursor top_left_arrow
         return
      } 

		if [catch {set result [cvip $util(c_g) $current_image]} cresult] {
        CvipAlert "$cresult."
	  		$topwin(util_name) configure -cursor top_left_arrow
        return
		}
	  if { $util(c_g) == "luminance" } {
     		set new_name [cvip rename $result ${current_image}_lum]
			CvipMessage "image \"$current_image\" is converted to gray level image\
				using luminance"
	  } else {
     		set new_name [cvip rename $result ${current_image}_lumAvg]
			CvipMessage "image \"$current_image\" is converted to gray level image\
				using luminance average"
	  }
     img_q insert end $new_name
     image_post $new_name
     cvip view $new_name
	  $topwin(util_name) configure -cursor top_left_arrow
	 } \
    -text {PERFORM}

  # build widget $topwin(util_name).perform.dismiss
	button $topwin(util_name).perform.dismiss -padx {1} -pady {1} -highlightthickness {0}  \
	 -background "$GuiColor(dis_bg)" \
	 -foreground "$GuiColor(dis_fg)" \
	 -activebackground "$GuiColor(dis_act_bg)" \
    -command {if [winfo exist .filter ] {destroy .filter}; destroy $topwin(util_name); set topwin(util_name) NONE} \
    -text {DISMISS} \
    -width {10}

  # pack widget $topwin(util_name).perform
  pack append $topwin(util_name).perform \
    $topwin(util_name).perform.dismiss {left frame center filly} \
    $topwin(util_name).perform.perform1 {right frame center filly}

  # build widget $topwin(util_name).current_image
  frame $topwin(util_name).current_image \
    -background "$GuiColor(frame_bg)" \
    -borderwidth {2} \
    -relief {ridge}

  # build widget $topwin(util_name).current_image.current
  label $topwin(util_name).current_image.current \
    -background "$GuiColor(label_bg)" \
    -text {Current image:}

  # build widget $topwin(util_name).current_image.name
  label $topwin(util_name).current_image.name \
    -background "$GuiColor(label_bg)" \
    -foreground {Blue} \
    -text {} \
    -textvariable {current_image}

  # pack widget $topwin(util_name).current_image
  pack append $topwin(util_name).current_image \
    $topwin(util_name).current_image.current {left frame center} \
    $topwin(util_name).current_image.name {left frame center filly}

  # pack widget $topwin(util_name)
  pack append $topwin(util_name) \
    $topwin(util_name).info {top frame center expand fill} \
    $topwin(util_name).perform {bottom frame center pady 5 fill} \
    $topwin(util_name).current_image {bottom frame center fill}

  if {"[info procs XFEdit]" != ""} {
    catch "XFMiscBindWidgetTree $topwin(util_name)"
    after 2 "catch {XFEditSetShowWindows}"
  }
}


# procedure to show window $topwin(util_name)
proc util_gray_col { } {# xf ignore me 7

  global {util}
  global tk_version
  global topwin
  global env
  global toplevel_position
  global GuiColor
  global GUI_DEBUG
  global GuiMisc
  if [ winfo exists $topwin(util_name).info] {
     set tempname $topwin(util_name);\
destroy $topwin(util_name).info;\
set topwin(util_name) $tempname;}
  if [ winfo exists $topwin(util_name).current_image] {
     set tempname $topwin(util_name);\
destroy $topwin(util_name).current_image;\
set topwin(util_name) $tempname;}
  if [ winfo exists $topwin(util_name).perform] {
     set tempname $topwin(util_name);\
destroy $topwin(util_name).perform;\
set topwin(util_name) $tempname;}
  wm positionfrom $topwin(util_name) user
  wm sizefrom $topwin(util_name) user
  wm geometry $topwin(util_name) $topwin(util_top)[get_pos $topwin(util_name)]
  wm maxsize $topwin(util_name) [lindex [split $topwin(util_top_max)] 0] \
  	[lindex [split $topwin(util_top_max)] 1]
  wm minsize $topwin(util_name) [lindex [split $topwin(util_top_min)] 0] \
  	[lindex [split $topwin(util_top_min)] 1]
  wm title $topwin(util_name) {UTILITIES -> Convert -> Gray to color}

  # bindings
  bind $topwin(util_name) <Destroy> {set topwin(util_name) NONE}

  # build widget $topwin(util_name).info
  frame $topwin(util_name).info \
    -background "$GuiColor(frame_bg)" \
    -borderwidth {2}
  # bindings
  bind $topwin(util_name).info <Button-1> {MenuPopupPost $topwin(util_name).info.menu2 %X %Y}
  bind $topwin(util_name).info <ButtonRelease-1> {MenuPopupRelease $topwin(util_name).info.menu2 %W}

  # build widget $topwin(util_name).info.frame4
  frame $topwin(util_name).info.frame4 \
    -relief {groove} \
    -border {2} \
    -background "$GuiColor(frame_bg)"

  # build widget $topwin(util_name).info.frame4.frame0
  frame $topwin(util_name).info.frame4.frame0 \
    -background "$GuiColor(frame_bg)" \
    -borderwidth {2}

  # build widget $topwin(util_name).info.frame4.frame0.label1
  label $topwin(util_name).info.frame4.frame0.label1 \
    -background "$GuiColor(label_bg)" \
    -borderwidth {0} \
    -text {Red: }

  # build widget $topwin(util_name).info.frame4.frame0.value
  label $topwin(util_name).info.frame4.frame0.value \
    -background {white} \
    -bitmap @$env(CVIPHOME)/CVIPTCL/GUI_SCRIPTS/bmp/red.bmp \
    -foreground {blue} \
    -relief {sunken} \
    -text {}

  # build widget $topwin(util_name).info.frame4.frame0.menubutton2
	menubutton $topwin(util_name).info.frame4.frame0.menubutton2 -padx {1} -pady {1} -highlightthickness {0}  \
    -background "$GuiColor(btn_bg)" \
	 -activebackground "$GuiColor(btn_act_bg)" \
    -font "$GuiMisc(pop_up_fn)" \
	 -text "$GuiMisc(pop_up_text)" \
	 -relief "$GuiMisc(pop_up_relief)" \
	 -width {2}
  # bindings
  bind $topwin(util_name).info.frame4.frame0.menubutton2 <Button-1> { MenuPopupPost $topwin(util_name).info.frame4.frame0.menubutton2.menu %X %Y}
  bind $topwin(util_name).info.frame4.frame0.menubutton2 <ButtonRelease-1> { MenuPopupRelease $topwin(util_name).info.frame4.frame0.menubutton2.menu %W}

  # build widget $topwin(util_name).info.frame4.frame0.menubutton2.menu
  menu $topwin(util_name).info.frame4.frame0.menubutton2.menu \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)"

  $topwin(util_name).info.frame4.frame0.menubutton2.menu add command \
    -bitmap @$env(CVIPHOME)/CVIPTCL/GUI_SCRIPTS/bmp/red.bmp \
    -command "$topwin(util_name).info.frame4.frame0.value configure -bitmap @$env(CVIPHOME)/CVIPTCL/GUI_SCRIPTS/bmp/red.bmp
set util(g_c_r) red"
  $topwin(util_name).info.frame4.frame0.menubutton2.menu add command \
    -bitmap @$env(CVIPHOME)/CVIPTCL/GUI_SCRIPTS/bmp/green.bmp \
    -command "$topwin(util_name).info.frame4.frame0.value configure -bitmap @$env(CVIPHOME)/CVIPTCL/GUI_SCRIPTS/bmp/green.bmp
set util(g_c_r) green"
  $topwin(util_name).info.frame4.frame0.menubutton2.menu add command \
    -bitmap @$env(CVIPHOME)/CVIPTCL/GUI_SCRIPTS/bmp/blue.bmp \
    -command "$topwin(util_name).info.frame4.frame0.value configure -bitmap @$env(CVIPHOME)/CVIPTCL/GUI_SCRIPTS/bmp/blue.bmp
set util(g_c_r) blue"
  bindtags $topwin(util_name).info.frame4.frame0.menubutton2.menu {Menu all}
  # bindings
  bind $topwin(util_name).info.frame4.frame0.menubutton2.menu <B1-Motion> { MenuPopupMotion $topwin(util_name).info.frame4.frame0.menubutton2.menu %W %X %Y}
  bind $topwin(util_name).info.frame4.frame0.menubutton2.menu <ButtonRelease-1> { MenuPopupRelease $topwin(util_name).info.frame4.frame0.menubutton2.menu %W}

  # pack widget $topwin(util_name).info.frame4.frame0
  pack append $topwin(util_name).info.frame4.frame0 \
    $topwin(util_name).info.frame4.frame0.label1 {left frame center fill} \
    $topwin(util_name).info.frame4.frame0.value {left frame center expand fill} \
    $topwin(util_name).info.frame4.frame0.menubutton2 {right frame center fill}

  # build widget $topwin(util_name).info.frame4.frame1
  frame $topwin(util_name).info.frame4.frame1 \
    -background "$GuiColor(frame_bg)" \
    -borderwidth {2}

  # build widget $topwin(util_name).info.frame4.frame1.label1
  label $topwin(util_name).info.frame4.frame1.label1 \
    -background "$GuiColor(label_bg)" \
    -borderwidth {0} \
    -text {Green: }

  # build widget $topwin(util_name).info.frame4.frame1.value
  label $topwin(util_name).info.frame4.frame1.value \
    -background {white} \
    -bitmap @$env(CVIPHOME)/CVIPTCL/GUI_SCRIPTS/bmp/green.bmp \
    -foreground {blue} \
    -relief {sunken} \
    -text {}

  # build widget $topwin(util_name).info.frame4.frame1.menubutton2
	menubutton $topwin(util_name).info.frame4.frame1.menubutton2 -padx {1} -pady {1} -highlightthickness {0}  \
    -background "$GuiColor(btn_bg)" \
	 -activebackground "$GuiColor(btn_act_bg)" \
    -font "$GuiMisc(pop_up_fn)" \
	 -text "$GuiMisc(pop_up_text)" \
	 -relief "$GuiMisc(pop_up_relief)" \
	 -width {2}
  # bindings
  bind $topwin(util_name).info.frame4.frame1.menubutton2 <Button-1> { MenuPopupPost $topwin(util_name).info.frame4.frame1.menubutton2.menu %X %Y}
  bind $topwin(util_name).info.frame4.frame1.menubutton2 <ButtonRelease-1> { MenuPopupRelease $topwin(util_name).info.frame4.frame1.menubutton2.menu %W}

  # build widget $topwin(util_name).info.frame4.frame1.menubutton2.menu
  menu $topwin(util_name).info.frame4.frame1.menubutton2.menu \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)"
  $topwin(util_name).info.frame4.frame1.menubutton2.menu add command \
    -bitmap @$env(CVIPHOME)/CVIPTCL/GUI_SCRIPTS/bmp/red.bmp \
    -command "$topwin(util_name).info.frame4.frame1.value configure -bitmap @$env(CVIPHOME)/CVIPTCL/GUI_SCRIPTS/bmp/red.bmp
set util(g_c_g) red"
  $topwin(util_name).info.frame4.frame1.menubutton2.menu add command \
    -bitmap @$env(CVIPHOME)/CVIPTCL/GUI_SCRIPTS/bmp/green.bmp \
    -command "$topwin(util_name).info.frame4.frame1.value configure -bitmap @$env(CVIPHOME)/CVIPTCL/GUI_SCRIPTS/bmp/green.bmp
set util(g_c_g) green"
  $topwin(util_name).info.frame4.frame1.menubutton2.menu add command \
    -bitmap @$env(CVIPHOME)/CVIPTCL/GUI_SCRIPTS/bmp/blue.bmp \
    -command "$topwin(util_name).info.frame4.frame1.value configure -bitmap @$env(CVIPHOME)/CVIPTCL/GUI_SCRIPTS/bmp/blue.bmp
set util(g_c_g) blue"
  bindtags $topwin(util_name).info.frame4.frame1.menubutton2.menu {Menu all}
  # bindings
  bind $topwin(util_name).info.frame4.frame1.menubutton2.menu <B1-Motion> { MenuPopupMotion $topwin(util_name).info.frame4.frame1.menubutton2.menu %W %X %Y}
  bind $topwin(util_name).info.frame4.frame1.menubutton2.menu <ButtonRelease-1> { MenuPopupRelease $topwin(util_name).info.frame4.frame1.menubutton2.menu %W}

  # pack widget $topwin(util_name).info.frame4.frame1
  pack append $topwin(util_name).info.frame4.frame1 \
    $topwin(util_name).info.frame4.frame1.label1 {left frame center fill} \
    $topwin(util_name).info.frame4.frame1.value {left frame center expand fill} \
    $topwin(util_name).info.frame4.frame1.menubutton2 {right frame center fill}

  # build widget $topwin(util_name).info.frame4.frame2
  frame $topwin(util_name).info.frame4.frame2 \
    -background "$GuiColor(frame_bg)" \
    -borderwidth {2}

  # build widget $topwin(util_name).info.frame4.frame2.label1
  label $topwin(util_name).info.frame4.frame2.label1 \
    -background "$GuiColor(label_bg)" \
    -borderwidth {0} \
    -text {Blue: }

  # build widget $topwin(util_name).info.frame4.frame2.value
  label $topwin(util_name).info.frame4.frame2.value \
    -background {white} \
    -bitmap @$env(CVIPHOME)/CVIPTCL/GUI_SCRIPTS/bmp/blue.bmp \
    -foreground {blue} \
    -relief {sunken} \
    -text {}

  # build widget $topwin(util_name).info.frame4.frame2.menubutton2
	menubutton $topwin(util_name).info.frame4.frame2.menubutton2 -padx {1} -pady {1} -highlightthickness {0}  \
    -background "$GuiColor(btn_bg)" \
	 -activebackground "$GuiColor(btn_act_bg)" \
    -font "$GuiMisc(pop_up_fn)" \
	 -text "$GuiMisc(pop_up_text)" \
	 -relief "$GuiMisc(pop_up_relief)" \
	 -width {2}
  # bindings
  bind $topwin(util_name).info.frame4.frame2.menubutton2 <Button-1> { MenuPopupPost $topwin(util_name).info.frame4.frame2.menubutton2.menu %X %Y}
  bind $topwin(util_name).info.frame4.frame2.menubutton2 <ButtonRelease-1> { MenuPopupRelease $topwin(util_name).info.frame4.frame2.menubutton2.menu %W}

  # build widget $topwin(util_name).info.frame4.frame2.menubutton2.menu
  menu $topwin(util_name).info.frame4.frame2.menubutton2.menu \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)"
  $topwin(util_name).info.frame4.frame2.menubutton2.menu add command \
    -bitmap @$env(CVIPHOME)/CVIPTCL/GUI_SCRIPTS/bmp/red.bmp \
    -command "$topwin(util_name).info.frame4.frame2.value configure -bitmap @$env(CVIPHOME)/CVIPTCL/GUI_SCRIPTS/bmp/red.bmp
set util(g_c_b) red"
  $topwin(util_name).info.frame4.frame2.menubutton2.menu add command \
    -bitmap @$env(CVIPHOME)/CVIPTCL/GUI_SCRIPTS/bmp/green.bmp \
    -command "$topwin(util_name).info.frame4.frame2.value configure -bitmap @$env(CVIPHOME)/CVIPTCL/GUI_SCRIPTS/bmp/green.bmp
set util(g_c_b) green"
  $topwin(util_name).info.frame4.frame2.menubutton2.menu add command \
    -bitmap @$env(CVIPHOME)/CVIPTCL/GUI_SCRIPTS/bmp/blue.bmp \
    -command "$topwin(util_name).info.frame4.frame2.value configure -bitmap @$env(CVIPHOME)/CVIPTCL/GUI_SCRIPTS/bmp/blue.bmp
set util(g_c_b) blue"
  bindtags $topwin(util_name).info.frame4.frame2.menubutton2.menu {Menu all}
  # bindings
  bind $topwin(util_name).info.frame4.frame2.menubutton2.menu <B1-Motion> { MenuPopupMotion $topwin(util_name).info.frame4.frame2.menubutton2.menu %W %X %Y}
  bind $topwin(util_name).info.frame4.frame2.menubutton2.menu <ButtonRelease-1> { MenuPopupRelease $topwin(util_name).info.frame4.frame2.menubutton2.menu %W}

  # pack widget $topwin(util_name).info.frame4.frame2
  pack append $topwin(util_name).info.frame4.frame2 \
    $topwin(util_name).info.frame4.frame2.label1 {left frame center fill} \
    $topwin(util_name).info.frame4.frame2.value {left frame center expand fill} \
    $topwin(util_name).info.frame4.frame2.menubutton2 {right frame center fill}

  # pack widget $topwin(util_name).info.frame4.
  pack append $topwin(util_name).info.frame4 \
    $topwin(util_name).info.frame4.frame0 {left frame center expand fillx} \
    $topwin(util_name).info.frame4.frame1 {left frame center expand fillx} \
    $topwin(util_name).info.frame4.frame2 {left frame center expand fillx}

  # build widget $topwin(util_name).info.frame3
  frame $topwin(util_name).info.frame3 \
    -relief {groove} \
    -border {2} \
    -background "$GuiColor(frame_bg)"

  # build widget $topwin(util_name).info.frame3.frame3
  frame $topwin(util_name).info.frame3.frame3 \
    -background "$GuiColor(frame_bg)"

  # build widget $topwin(util_name).info.frame3.frame3.frame0
  frame $topwin(util_name).info.frame3.frame3.frame0 \
    -background "$GuiColor(frame_bg)" \
    -relief {sunken}

  # build widget $topwin(util_name).info.frame3.frame3.frame0.label1
  label $topwin(util_name).info.frame3.frame3.frame0.label1 \
    -background "$GuiColor(label_bg)" \
    -borderwidth {0} \
    -text {Low cutoff frequency: }

  # build widget $topwin(util_name).info.frame3.frame3.frame0.value
  entry $topwin(util_name).info.frame3.frame3.frame0.value \
    -background "$GuiColor(entry_bg)" \
    -foreground "$GuiColor(entry_fg)" \
    -relief {sunken} \
    -textvariable {util(pseudo_lcf)} \
    -width {5}
  endEntry $topwin(util_name).info.frame3.frame3.frame0.value 0 \
  	 $topwin(util_name).info.frame3.frame3.frame6.value \
  	 $topwin(util_name).info.frame3.frame3.frame6.value 

  # build widget $topwin(util_name).info.frame3.frame3.frame0.menubutton2
	menubutton $topwin(util_name).info.frame3.frame3.frame0.menubutton2 -padx {1} -pady {1} -highlightthickness {0}  \
    -background "$GuiColor(btn_bg)" \
	 -activebackground "$GuiColor(btn_act_bg)" \
    -font "$GuiMisc(pop_up_fn)" \
	 -text "$GuiMisc(pop_up_text)" \
	 -relief "$GuiMisc(pop_up_relief)" \
	 -width {2}
  # bindings
  bind $topwin(util_name).info.frame3.frame3.frame0.menubutton2 <Button-1> {MenuPopupPost $topwin(util_name).info.frame3.frame3.frame0.menubutton2.menu %X %Y}
  bind $topwin(util_name).info.frame3.frame3.frame0.menubutton2 <ButtonRelease-1> {MenuPopupRelease $topwin(util_name).info.frame3.frame3.frame0.menubutton2.menu %W}

  # build widget $topwin(util_name).info.frame3.frame3.frame0.menubutton2.menu
  menu $topwin(util_name).info.frame3.frame3.frame0.menubutton2.menu \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)"
  $topwin(util_name).info.frame3.frame3.frame0.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set util(pseudo_lcf) 0} \
    -label {  0 }
  $topwin(util_name).info.frame3.frame3.frame0.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set util(pseudo_lcf) 10} \
    -label { 10}
  $topwin(util_name).info.frame3.frame3.frame0.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set util(pseudo_lcf) 30} \
    -label { 30}
  $topwin(util_name).info.frame3.frame3.frame0.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set util(pseudo_lcf) 50} \
    -label { 50}
  $topwin(util_name).info.frame3.frame3.frame0.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set util(pseudo_lcf) 100} \
    -label {100}
  $topwin(util_name).info.frame3.frame3.frame0.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set util(pseudo_lcf) 200} \
    -label {200}
  $topwin(util_name).info.frame3.frame3.frame0.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set util(pseudo_lcf) 500} \
    -label {500}
  bindtags $topwin(util_name).info.frame3.frame3.frame0.menubutton2.menu {Menu all}
  # bindings
  bind $topwin(util_name).info.frame3.frame3.frame0.menubutton2.menu <B1-Motion> {MenuPopupMotion $topwin(util_name).info.frame3.frame3.frame0.menubutton2.menu %W %X %Y}
  bind $topwin(util_name).info.frame3.frame3.frame0.menubutton2.menu <ButtonRelease-1> {MenuPopupRelease $topwin(util_name).info.frame3.frame3.frame0.menubutton2.menu %W}

  # pack widget $topwin(util_name).info.frame3.frame3.frame0
  pack append $topwin(util_name).info.frame3.frame3.frame0 \
    $topwin(util_name).info.frame3.frame3.frame0.label1 {left frame center fill} \
    $topwin(util_name).info.frame3.frame3.frame0.value {left frame center expand fill} \
    $topwin(util_name).info.frame3.frame3.frame0.menubutton2 {right frame center fill}

  # build widget $topwin(util_name).info.frame3.frame3.frame6
  frame $topwin(util_name).info.frame3.frame3.frame6 \
    -background "$GuiColor(frame_bg)" \
    -relief {sunken}

  # build widget $topwin(util_name).info.frame3.frame3.frame6.label1
  label $topwin(util_name).info.frame3.frame3.frame6.label1 \
    -background "$GuiColor(label_bg)" \
    -borderwidth {0} \
    -text {High cutoff frequency: }

  # build widget $topwin(util_name).info.frame3.frame3.frame6.value
  entry $topwin(util_name).info.frame3.frame3.frame6.value \
    -background "$GuiColor(entry_bg)" \
    -foreground "$GuiColor(entry_fg)" \
    -relief {sunken} \
    -textvariable {util(pseudo_hcf)} \
    -width {5}
  endEntry $topwin(util_name).info.frame3.frame3.frame6.value 0 \
  	 $topwin(util_name).info.frame3.frame3.frame0.value \
  	 $topwin(util_name).info.frame3.frame3.frame0.value 


  # build widget $topwin(util_name).info.frame3.frame3.frame6.menubutton2
	menubutton $topwin(util_name).info.frame3.frame3.frame6.menubutton2 -padx {1} -pady {1} -highlightthickness {0}  \
    -background "$GuiColor(btn_bg)" \
	 -activebackground "$GuiColor(btn_act_bg)" \
    -font "$GuiMisc(pop_up_fn)" \
	 -text "$GuiMisc(pop_up_text)" \
	 -relief "$GuiMisc(pop_up_relief)" \
	 -width {2}
  # bindings
  bind $topwin(util_name).info.frame3.frame3.frame6.menubutton2 <Button-1> {MenuPopupPost $topwin(util_name).info.frame3.frame3.frame6.menubutton2.menu %X %Y}
  bind $topwin(util_name).info.frame3.frame3.frame6.menubutton2 <ButtonRelease-1> {MenuPopupRelease $topwin(util_name).info.frame3.frame3.frame6.menubutton2.menu %W}

  # build widget $topwin(util_name).info.frame3.frame3.frame6.menubutton2.menu
  menu $topwin(util_name).info.frame3.frame3.frame6.menubutton2.menu \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)"
  $topwin(util_name).info.frame3.frame3.frame6.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set util(pseudo_hcf) 100} \
    -label { 100}
  $topwin(util_name).info.frame3.frame3.frame6.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set util(pseudo_hcf) 200} \
    -label { 200}
  $topwin(util_name).info.frame3.frame3.frame6.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set util(pseudo_hcf) 500} \
    -label { 500}
  $topwin(util_name).info.frame3.frame3.frame6.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set util(pseudo_hcf) 1000} \
    -label {1000}
  $topwin(util_name).info.frame3.frame3.frame6.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set util(pseudo_hcf) 2000} \
    -label {2000}
  bindtags $topwin(util_name).info.frame3.frame3.frame6.menubutton2.menu {Menu all}
  # bindings
  bind $topwin(util_name).info.frame3.frame3.frame6.menubutton2.menu <B1-Motion> {MenuPopupMotion $topwin(util_name).info.frame3.frame3.frame6.menubutton2.menu %W %X %Y}
  bind $topwin(util_name).info.frame3.frame3.frame6.menubutton2.menu <ButtonRelease-1> {MenuPopupRelease $topwin(util_name).info.frame3.frame3.frame6.menubutton2.menu %W}

  # pack widget $topwin(util_name).info.frame3.frame3.frame6
  pack append $topwin(util_name).info.frame3.frame3.frame6 \
    $topwin(util_name).info.frame3.frame3.frame6.label1 {left frame center fill} \
    $topwin(util_name).info.frame3.frame3.frame6.value {left frame center expand fill} \
    $topwin(util_name).info.frame3.frame3.frame6.menubutton2 {right frame center fill}

  # pack widget $topwin(util_name).info.frame3.frame3
  pack append $topwin(util_name).info.frame3.frame3 \
    $topwin(util_name).info.frame3.frame3.frame0 {left frame center padx 11} \
    $topwin(util_name).info.frame3.frame3.frame6 {left frame center padx 9}

  # build widget $topwin(util_name).info.frame3.frame7
  frame $topwin(util_name).info.frame3.frame7 \
    -background "$GuiColor(frame_bg)"

  # build widget $topwin(util_name).info.frame3.frame7.frame0
  frame $topwin(util_name).info.frame3.frame7.frame0 \
    -background "$GuiColor(frame_bg)" \
    -relief {sunken}

  # build widget $topwin(util_name).info.frame3.frame7.frame0.label1
  label $topwin(util_name).info.frame3.frame7.frame0.label1 \
    -background "$GuiColor(label_bg)" \
    -borderwidth {0} \
    -text {Low-pass color: }

  # build widget $topwin(util_name).info.frame3.frame7.frame0.value
  entry $topwin(util_name).info.frame3.frame7.frame0.value \
    -background "$GuiColor(rentry_bg)" \
    -foreground "$GuiColor(rentry_fg)" \
	 -state {disabled} \
    -relief {sunken} \
    -textvariable {util(pseudo_lpc)} \
    -width {3}
  endEntry $topwin(util_name).info.frame3.frame7.frame0.value 0 $topwin(util_name).info.frame3.frame7.frame8.value

  # build widget $topwin(util_name).info.frame3.frame7.frame0.menubutton2
	menubutton $topwin(util_name).info.frame3.frame7.frame0.menubutton2 -padx {1} -pady {1} -highlightthickness {0}  \
    -background "$GuiColor(btn_bg)" \
	 -activebackground "$GuiColor(btn_act_bg)" \
    -font "$GuiMisc(pop_up_fn)" \
	 -text "$GuiMisc(pop_up_text)" \
	 -relief "$GuiMisc(pop_up_relief)" \
	 -width {2}
  # bindings
  bind $topwin(util_name).info.frame3.frame7.frame0.menubutton2 <Button-1> {MenuPopupPost $topwin(util_name).info.frame3.frame7.frame0.menubutton2.menu %X %Y}
  bind $topwin(util_name).info.frame3.frame7.frame0.menubutton2 <ButtonRelease-1> {MenuPopupRelease $topwin(util_name).info.frame3.frame7.frame0.menubutton2.menu %W}

  # build widget $topwin(util_name).info.frame3.frame7.frame0.menubutton2.menu
  menu $topwin(util_name).info.frame3.frame7.frame0.menubutton2.menu \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)"
  $topwin(util_name).info.frame3.frame7.frame0.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set util(pseudo_lpc) R} \
    -label {  red }
  $topwin(util_name).info.frame3.frame7.frame0.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set util(pseudo_lpc) G} \
    -label { green}
  $topwin(util_name).info.frame3.frame7.frame0.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set util(pseudo_lpc) B} \
    -label {  blue}
  bindtags $topwin(util_name).info.frame3.frame7.frame0.menubutton2.menu {Menu all}
  # bindings
  bind $topwin(util_name).info.frame3.frame7.frame0.menubutton2.menu <B1-Motion> {MenuPopupMotion $topwin(util_name).info.frame3.frame7.frame0.menubutton2.menu %W %X %Y}
  bind $topwin(util_name).info.frame3.frame7.frame0.menubutton2.menu <ButtonRelease-1> {MenuPopupRelease $topwin(util_name).info.frame3.frame7.frame0.menubutton2.menu %W}

  # pack widget $topwin(util_name).info.frame3.frame7.frame0
  pack append $topwin(util_name).info.frame3.frame7.frame0 \
    $topwin(util_name).info.frame3.frame7.frame0.label1 {left frame center fill} \
    $topwin(util_name).info.frame3.frame7.frame0.value {left frame center expand fill} \
    $topwin(util_name).info.frame3.frame7.frame0.menubutton2 {right frame center fill}

  # build widget $topwin(util_name).info.frame3.frame7.frame8
  frame $topwin(util_name).info.frame3.frame7.frame8 \
    -background "$GuiColor(frame_bg)" \
    -relief {sunken}

  # build widget $topwin(util_name).info.frame3.frame7.frame8.label1
  label $topwin(util_name).info.frame3.frame7.frame8.label1 \
    -background "$GuiColor(label_bg)" \
    -borderwidth {0} \
    -text {Band-pass color: }

  # build widget $topwin(util_name).info.frame3.frame7.frame8.value
  entry $topwin(util_name).info.frame3.frame7.frame8.value \
    -background "$GuiColor(rentry_bg)" \
    -foreground "$GuiColor(rentry_fg)" \
    -state {disabled} \
    -relief {sunken} \
    -textvariable {util(pseudo_bpc)} \
    -width {3}
  endEntry $topwin(util_name).info.frame3.frame7.frame8.value 0 $topwin(util_name).info.frame3.frame7.frame9.value

  # build widget $topwin(util_name).info.frame3.frame7.frame8.menubutton2
	menubutton $topwin(util_name).info.frame3.frame7.frame8.menubutton2 -padx {1} -pady {1} -highlightthickness {0}  \
    -background "$GuiColor(btn_bg)" \
	 -activebackground "$GuiColor(btn_act_bg)" \
    -font "$GuiMisc(pop_up_fn)" \
	 -text "$GuiMisc(pop_up_text)" \
	 -relief "$GuiMisc(pop_up_relief)" \
	 -width {2}
  # bindings
  bind $topwin(util_name).info.frame3.frame7.frame8.menubutton2 <Button-1> {MenuPopupPost $topwin(util_name).info.frame3.frame7.frame8.menubutton2.menu %X %Y}
  bind $topwin(util_name).info.frame3.frame7.frame8.menubutton2 <ButtonRelease-1> {MenuPopupRelease $topwin(util_name).info.frame3.frame7.frame8.menubutton2.menu %W}

  # build widget $topwin(util_name).info.frame3.frame7.frame8.menubutton2.menu
  menu $topwin(util_name).info.frame3.frame7.frame8.menubutton2.menu \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)"
  $topwin(util_name).info.frame3.frame7.frame8.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set util(pseudo_bpc) R} \
    -label {  red }
  $topwin(util_name).info.frame3.frame7.frame8.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set util(pseudo_bpc) G} \
    -label { green}
  $topwin(util_name).info.frame3.frame7.frame8.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set util(pseudo_bpc) B} \
    -label {  blue}
  bindtags $topwin(util_name).info.frame3.frame7.frame8.menubutton2.menu {Menu all}
  # bindings
  bind $topwin(util_name).info.frame3.frame7.frame8.menubutton2.menu <B1-Motion> {MenuPopupMotion $topwin(util_name).info.frame3.frame7.frame8.menubutton2.menu %W %X %Y}
  bind $topwin(util_name).info.frame3.frame7.frame8.menubutton2.menu <ButtonRelease-1> {MenuPopupRelease $topwin(util_name).info.frame3.frame7.frame8.menubutton2.menu %W}

  # pack widget $topwin(util_name).info.frame3.frame7.frame8
  pack append $topwin(util_name).info.frame3.frame7.frame8 \
    $topwin(util_name).info.frame3.frame7.frame8.label1 {left frame center fill} \
    $topwin(util_name).info.frame3.frame7.frame8.value {left frame center expand fill} \
    $topwin(util_name).info.frame3.frame7.frame8.menubutton2 {right frame center fill}

  # build widget $topwin(util_name).info.frame3.frame7.frame9
  frame $topwin(util_name).info.frame3.frame7.frame9 \
    -background "$GuiColor(frame_bg)" \
    -relief {sunken}

  # build widget $topwin(util_name).info.frame3.frame7.frame9.label1
  label $topwin(util_name).info.frame3.frame7.frame9.label1 \
    -background "$GuiColor(label_bg)" \
    -borderwidth {0} \
    -text {High-pass color: }

  # build widget $topwin(util_name).info.frame3.frame7.frame9.value
  entry $topwin(util_name).info.frame3.frame7.frame9.value \
    -background "$GuiColor(rentry_bg)" \
    -foreground "$GuiColor(rentry_fg)" \
    -state {disabled} \
    -relief {sunken} \
    -textvariable {util(pseudo_hpc)} \
    -width {3}
  endEntry $topwin(util_name).info.frame3.frame7.frame9.value 0

  # build widget $topwin(util_name).info.frame3.frame7.frame9.menubutton2
	menubutton $topwin(util_name).info.frame3.frame7.frame9.menubutton2 -padx {1} -pady {1} -highlightthickness {0}  \
    -background "$GuiColor(btn_bg)" \
	 -activebackground "$GuiColor(btn_act_bg)" \
    -font "$GuiMisc(pop_up_fn)" \
	 -text "$GuiMisc(pop_up_text)" \
	 -relief "$GuiMisc(pop_up_relief)" \
	 -width {2}
  # bindings
  bind $topwin(util_name).info.frame3.frame7.frame9.menubutton2 <Button-1> {MenuPopupPost $topwin(util_name).info.frame3.frame7.frame9.menubutton2.menu %X %Y}
  bind $topwin(util_name).info.frame3.frame7.frame9.menubutton2 <ButtonRelease-1> {MenuPopupRelease $topwin(util_name).info.frame3.frame7.frame9.menubutton2.menu %W}

  # build widget $topwin(util_name).info.frame3.frame7.frame9.menubutton2.menu
  menu $topwin(util_name).info.frame3.frame7.frame9.menubutton2.menu \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)"
  $topwin(util_name).info.frame3.frame7.frame9.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set util(pseudo_hpc) R} \
    -label {  red }
  $topwin(util_name).info.frame3.frame7.frame9.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set util(pseudo_hpc) G} \
    -label { green}
  $topwin(util_name).info.frame3.frame7.frame9.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set util(pseudo_hpc) B} \
    -label {  blue}
  bindtags $topwin(util_name).info.frame3.frame7.frame9.menubutton2.menu  {Menu all}
  # bindings
  bind $topwin(util_name).info.frame3.frame7.frame9.menubutton2.menu <B1-Motion> {MenuPopupMotion $topwin(util_name).info.frame3.frame7.frame9.menubutton2.menu %W %X %Y}
  bind $topwin(util_name).info.frame3.frame7.frame9.menubutton2.menu <ButtonRelease-1> {MenuPopupRelease $topwin(util_name).info.frame3.frame7.frame9.menubutton2.menu %W}

  # pack widget $topwin(util_name).info.frame3.frame7.frame9
  pack append $topwin(util_name).info.frame3.frame7.frame9 \
    $topwin(util_name).info.frame3.frame7.frame9.label1 {left frame center fill} \
    $topwin(util_name).info.frame3.frame7.frame9.value {left frame center expand fill} \
    $topwin(util_name).info.frame3.frame7.frame9.menubutton2 {right frame center fill}

  # pack widget $topwin(util_name).info.frame3.frame7
  pack append $topwin(util_name).info.frame3.frame7 \
    $topwin(util_name).info.frame3.frame7.frame0 {left frame center padx 11} \
    $topwin(util_name).info.frame3.frame7.frame8 {left frame center padx 11} \
    $topwin(util_name).info.frame3.frame7.frame9 {left frame center padx 11}

  # pack widget $topwin(util_name).info.frame3
  pack append $topwin(util_name).info.frame3 \
    $topwin(util_name).info.frame3.frame3 {top frame center expand fill} \
    $topwin(util_name).info.frame3.frame7 {top frame center expand fill}

  # build widget $topwin(util_name).info.frame9
  frame $topwin(util_name).info.frame9 \
    -background "$GuiColor(frame_bg)"

	set util(g_c) pseudocol_freq
  # build widget $topwin(util_name).info.frame9.radiobutton10
	radiobutton $topwin(util_name).info.frame9.radiobutton10 -padx {1} -pady {1} -highlightthickness {0}  \
    -background "$GuiColor(btn_bg)" \
	 -activebackground "$GuiColor(btn_act_bg)" \
    -relief {flat} \
    -text { Frequency domain mapping} \
	 -command "
     pack append $topwin(util_name).info $topwin(util_name).info.frame3 {top frame center expand fill}
	  pack forget $topwin(util_name).info.frame4
	 " \
    -value {pseudocol_freq} \
    -variable {util(g_c)}

  # build widget $topwin(util_name).info.frame9.radiobutton14
	radiobutton $topwin(util_name).info.frame9.radiobutton14 -padx {1} -pady {1} -highlightthickness {0}  \
    -background "$GuiColor(btn_bg)" \
	 -activebackground "$GuiColor(btn_act_bg)" \
    -relief {flat} \
    -text { Gray level mapping} \
	 -command "
      pack append $topwin(util_name).info $topwin(util_name).info.frame4 {top frame center expand fill}
		pack forget $topwin(util_name).info.frame3 {top frame center expand fill}
	" \
    -value {bitplane} \
    -variable {util(g_c)}

  # pack widget $topwin(util_name).info.frame9
  pack append $topwin(util_name).info.frame9 \
    $topwin(util_name).info.frame9.radiobutton10 {left frame center padx 23} \
    $topwin(util_name).info.frame9.radiobutton14 {left frame center padx 3}

  # pack widget $topwin(util_name).info
  pack append $topwin(util_name).info \
    $topwin(util_name).info.frame9 {top frame center pady 3 fillx} \
    $topwin(util_name).info.frame3 {top frame center expand fill}

  # build widget $topwin(util_name).perform
  frame $topwin(util_name).perform \
    -background "$GuiColor(frame_bg)" \
    -borderwidth {2} \
    -relief {raised}

  # build widget $topwin(util_name).perform.perform1
	button $topwin(util_name).perform.perform1 -padx {1} -pady {1} -highlightthickness {0}  \
	 -background "$GuiColor(perf_bg)" \
	 -foreground "$GuiColor(perf_fg)" \
	 -activebackground "$GuiColor(perf_act_bg)" \
    -command {
		$topwin(util_name) configure -cursor watch; update
      if { $current_image == ""} {
         CvipAlert "Please select an image first."
			$topwin(util_name) configure -cursor top_left_arrow; update
         return
      } 

		if { $bands != "1" } {
     	    CvipAlert "Gray to color conversion applies to gray level image only."
			$topwin(util_name) configure -cursor top_left_arrow; update
        	 return
		} 

		switch -exact -- $util(g_c) {
			pseudocol_freq {

				if [catch {expr $util(pseudo_lcf) + $util(pseudo_hcf)} ] {
         		CvipAlert "Numerical values required for transform parameter:\n\
					Low cutoff frequency =$util(pseudo_lcf), High cutoff frequency= $util(pseudo_hcf)."
					$topwin(util_name) configure -cursor top_left_arrow; update
		         return
				}

				if {$util(pseudo_lcf) > $util(pseudo_hcf) } {
     		    CvipAlert "High cutoff frequency ( $util(pseudo_hcf) ) must be greater than low \
				 cutoff frequency ( $util(pseudo_lcf) )."
					$topwin(util_name) configure -cursor top_left_arrow; update
		         return
				}

				if {$util(pseudo_lpc) == $util(pseudo_bpc) || $util(pseudo_bpc) == $util(pseudo_hpc) ||\
						$util(pseudo_hpc) == $util(pseudo_lpc) } {
		         CvipAlert "Please use different colors for different bands:\n\
					Low pass color = $util(pseudo_lpc), Band pass color = $util(pseudo_bpc),\
							High pass color = $util(pseudo_hpc)."
					$topwin(util_name) configure -cursor top_left_arrow; update
					return
				}

         	if { $data_type == "FLOAT" } {
           	 set temp1 [cvip data_remap $current_image 2]
           	 set temp "cvip pseudocol_freq $temp1 $util(pseudo_lcf) $util(pseudo_hcf) "
         	} else {
					set temp "cvip pseudocol_freq $current_image $util(pseudo_lcf) $util(pseudo_hcf) "
         	}
				if { $util(pseudo_lpc) ==  "R" } {
					append temp "0 "
				} elseif { $util(pseudo_lpc) ==  "G" } {
					append temp "1 "
				} else {
					append temp "2 "
				}
				if { $util(pseudo_bpc) ==  "R" } {
					append temp "0 "
				} elseif { $util(pseudo_bpc) ==  "G" } {
					append temp "1 "
				} else {
					append temp "2 "
				}
				if { $util(pseudo_hpc) ==  "R" } {
					append temp "0"
				} elseif { $util(pseudo_hpc) ==  "G" } {
					append temp "1"
				} else {
					append temp "2"
				}

				if { $GUI_DEBUG == "1" } {
					puts stderr $temp
				}
				if [catch {set result [eval $temp]
                     if { $data_type == "FLOAT"} {
                        cvip dq $temp1
                     }
					} cresult] {
		        CvipAlert "$cresult."
				$topwin(util_name) configure -cursor top_left_arrow; update
     		   return
				}
     			set new_name [cvip rename $result ${current_image}_pseudo]       
     			img_q insert end $new_name
		  	   image_post $new_name
				CvipMessage "frequency domain pseudo-coloring performed on image \
					\"$current_image\""
		  	   cvip view $new_name
			}
         default {
				if [catch {
					set temp [cvip gray_linear $current_image 0 63 0 4 0]
					set temp1 [cvip gray_linear $current_image 64 191 255 0 0]
					set temp2 [cvip add $temp1 $temp]
					cvip dq $temp
					cvip dq $temp1
					set temp [cvip gray_linear $current_image 192 254 255 -4 0]
					set temp1 [cvip add $temp $temp2]
					cvip dq $temp
					cvip dq $temp2
					cvip rename $temp1 red

					set temp [cvip gray_linear $current_image 0 63 0 0 0]
					set temp1 [cvip gray_linear $current_image 64 127 0 0 0]
					set temp2 [cvip add $temp1 $temp]
					cvip dq $temp
					cvip dq $temp1
					set temp [cvip gray_linear $current_image 127 254 255 0 0]
					set temp1 [cvip add $temp $temp2]
					cvip dq $temp
					cvip dq $temp2
					cvip rename $temp1 green

					set temp [cvip gray_linear $current_image 0 127 255 0 0]
					set temp1 [cvip gray_linear $current_image 128 191 255 -4 0]
					set temp2 [cvip add $temp1 $temp]
					cvip dq $temp
					cvip dq $temp1
					set temp [cvip gray_linear $current_image 192 255 0 0 0]
					set temp1 [cvip add $temp $temp2]
					cvip dq $temp
					cvip dq $temp2
					cvip rename $temp1 blue

					unset temp2

				} cresult] {
     		    CvipAlert "$cresult ."
				 $topwin(util_name) configure -cursor top_left_arrow; update
				 return
				}
				if [catch {set result [cvip assemble_bands $util(g_c_r) $util(g_c_g) $util(g_c_b)]} cresult] {
     		   	CvipAlert "$cresult ."
					$topwin(util_name) configure -cursor top_left_arrow; update
					return
				}
				cvip dq red
				cvip dq blue
				cvip dq green
     			set new_name [cvip rename $result ${current_image}_grayMap]       
     			img_q insert end $new_name
		  	   image_post $new_name
				CvipMessage "gray level mapping pseudo-coloring performed on image \
					\"$current_image\""
		  	   cvip view $new_name
			}
	  }
	$topwin(util_name) configure -cursor top_left_arrow; update
	 } \
    -text {PERFORM}

  # build widget $topwin(util_name).perform.dismiss
	button $topwin(util_name).perform.dismiss -padx {1} -pady {1} -highlightthickness {0}  \
	 -background "$GuiColor(dis_bg)" \
	 -foreground "$GuiColor(dis_fg)" \
	 -activebackground "$GuiColor(dis_act_bg)" \
    -command {destroy $topwin(util_name); set topwin(util_name) NONE} \
    -text {DISMISS} \
    -width {10}

  # pack widget $topwin(util_name).perform
  pack append $topwin(util_name).perform \
    $topwin(util_name).perform.dismiss {left frame center filly} \
    $topwin(util_name).perform.perform1 {right frame center filly}

  # build widget $topwin(util_name).current_image
  frame $topwin(util_name).current_image \
    -background "$GuiColor(frame_bg)" \
    -borderwidth {2} \
    -relief {ridge}

  # build widget $topwin(util_name).current_image.current
  label $topwin(util_name).current_image.current \
    -background "$GuiColor(label_bg)" \
    -text {Current image:}

  # build widget $topwin(util_name).current_image.name
  label $topwin(util_name).current_image.name \
    -background "$GuiColor(label_bg)" \
    -foreground {Blue} \
    -text {} \
    -textvariable {current_image}

  # pack widget $topwin(util_name).current_image
  pack append $topwin(util_name).current_image \
    $topwin(util_name).current_image.current {left frame center} \
    $topwin(util_name).current_image.name {left frame center filly}

  # pack widget $topwin(util_name)
  pack append $topwin(util_name) \
    $topwin(util_name).info {top frame center expand fill} \
    $topwin(util_name).perform {bottom frame center pady 5 fill} \
    $topwin(util_name).current_image {bottom frame center fill}

  if {"[info procs XFEdit]" != ""} {
    catch "XFMiscBindWidgetTree $topwin(util_name)"
    after 2 "catch {XFEditSetShowWindows}"
  }
}


# procedure to show window $topwin(util_name)
proc util_dataremap { } {# xf ignore me 7

  # Window manager configurations
  global tk_version
  global GuiColor
  global GUI_DEBUG
  global GuiMisc
  global topwin
  global toplevel_position
  global GuiColor
  global GUI_DEBUG
  global GuiMisc
  if [ winfo exists $topwin(util_name).info] {
     set tempname $topwin(util_name);\
destroy $topwin(util_name).info;\
set topwin(util_name) $tempname;}
  if [ winfo exists $topwin(util_name).current_image] {
     set tempname $topwin(util_name);\
destroy $topwin(util_name).current_image;\
set topwin(util_name) $tempname;}
  if [ winfo exists $topwin(util_name).perform] {
     set tempname $topwin(util_name);\
destroy $topwin(util_name).perform;\
set topwin(util_name) $tempname;}
  wm positionfrom $topwin(util_name) user
  wm sizefrom $topwin(util_name) user
  wm geometry $topwin(util_name) $topwin(util_top)[get_pos $topwin(util_name)]
  wm maxsize $topwin(util_name) [lindex [split $topwin(util_top_max)] 0] \
  	[lindex [split $topwin(util_top_max)] 1]
  wm minsize $topwin(util_name) [lindex [split $topwin(util_top_min)] 0] \
  	[lindex [split $topwin(util_top_min)] 1]
  wm title $topwin(util_name) {UTILITIES -> Convert -> Data type }

  # bindings
  bind $topwin(util_name) <Destroy> {set topwin(util_name) NONE}

  # build widget $topwin(util_name).info
  frame $topwin(util_name).info \
    -background "$GuiColor(frame_bg)" \
    -borderwidth {2}
  # bindings
  bind $topwin(util_name).info <Button-1> {MenuPopupPost $topwin(util_name).info.menu2 %X %Y}
  bind $topwin(util_name).info <ButtonRelease-1> {MenuPopupRelease $topwin(util_name).info.menu2 %W}

  # build widget $topwin(util_name).info.frame3
  frame $topwin(util_name).info.frame3 \
    -background "$GuiColor(frame_bg)"

  # build widget $topwin(util_name).info.frame3.label5
  label $topwin(util_name).info.frame3.label5 \
    -background "$GuiColor(label_bg)" \
    -text {Convert image data from type:  }

  # build widget $topwin(util_name).info.frame3.label10
  label $topwin(util_name).info.frame3.label10 \
    -background "$GuiColor(label_bg)" \
    -foreground {blue} \
    -text {RGB} \
    -textvariable {data_type}

  # build widget $topwin(util_name).info.frame3.label12
  label $topwin(util_name).info.frame3.label12 \
    -background "$GuiColor(label_bg)" \
    -text {to: }

  # pack widget $topwin(util_name).info.frame3
  pack append $topwin(util_name).info.frame3 \
    $topwin(util_name).info.frame3.label5 {left frame center padx 10} \
    $topwin(util_name).info.frame3.label10 {left frame center} \
    $topwin(util_name).info.frame3.label12 {left frame center padx 10}

  # build widget $topwin(util_name).info.frame15
  frame $topwin(util_name).info.frame15 \
    -background "$GuiColor(frame_bg)"

  # build widget $topwin(util_name).info.frame15.radiobutton10
	radiobutton $topwin(util_name).info.frame15.radiobutton10 -padx {1} -pady {1} -highlightthickness {0}  \
    -background "$GuiColor(btn_bg)" \
	 -activebackground "$GuiColor(btn_act_bg)" \
    -relief {flat} \
    -text {BYTE} \
    -value {0} \
    -variable {util(data_remap)}

  # build widget $topwin(util_name).info.frame15.radiobutton16
	radiobutton $topwin(util_name).info.frame15.radiobutton16 -padx {1} -pady {1} -highlightthickness {0}  \
    -background "$GuiColor(btn_bg)" \
	 -activebackground "$GuiColor(btn_act_bg)" \
    -relief {flat} \
    -text {SHORT} \
    -value {1} \
    -variable {util(data_remap)}

  # build widget $topwin(util_name).info.frame15.radiobutton17
	radiobutton $topwin(util_name).info.frame15.radiobutton17 -padx {1} -pady {1} -highlightthickness {0}  \
    -background "$GuiColor(btn_bg)" \
	 -activebackground "$GuiColor(btn_act_bg)" \
    -relief {flat} \
    -text {INTEGER} \
    -value {2} \
    -variable {util(data_remap)}

  # build widget $topwin(util_name).info.frame15.radiobutton18
	radiobutton $topwin(util_name).info.frame15.radiobutton18 -padx {1} -pady {1} -highlightthickness {0}  \
    -background "$GuiColor(btn_bg)" \
	 -activebackground "$GuiColor(btn_act_bg)" \
    -relief {flat} \
    -text {FLOAT} \
    -value {3} \
    -variable {util(data_remap)}

  # pack widget $topwin(util_name).info.frame15
  pack append $topwin(util_name).info.frame15 \
    $topwin(util_name).info.frame15.radiobutton10 {left frame center expand} \
    $topwin(util_name).info.frame15.radiobutton16 {left frame center expand} \
    $topwin(util_name).info.frame15.radiobutton17 {left frame center expand} \
    $topwin(util_name).info.frame15.radiobutton18 {left frame center expand}

  # pack widget $topwin(util_name).info
  pack append $topwin(util_name).info \
    $topwin(util_name).info.frame3 {top frame center expand fill} \
    $topwin(util_name).info.frame15 {top frame center expand fill}

  # build widget $topwin(util_name).perform
  frame $topwin(util_name).perform \
    -background "$GuiColor(frame_bg)" \
    -borderwidth {2} \
    -relief {raised}

  # build widget $topwin(util_name).perform.perform1
	button $topwin(util_name).perform.perform1 -padx {1} -pady {1} -highlightthickness {0}  \
	 -background "$GuiColor(perf_bg)" \
	 -foreground "$GuiColor(perf_fg)" \
	 -activebackground "$GuiColor(perf_act_bg)" \
    -command {
		$topwin(util_name) configure -cursor watch; update
		switch -exact -- $util(data_remap) {
		0	{set temp BYTE}
		1	{set temp SHORT}
		2	{set temp INT}
		3	{set temp FLOAT}
		}
      if { $current_image == ""} {
         CvipAlert "Please select an image first."
			$topwin(util_name) configure -cursor top_left_arrow; update
         return
      } 

		if {$temp == $data_type} {
         CvipAlert "There is no necessity to convert the image data type from $temp to $temp."
			$topwin(util_name) configure -cursor top_left_arrow; update
         return
		}

		if [catch {set result [cvip data_remap $current_image $util(data_remap)]} cresult] {
        CvipAlert "$cresult."
			$topwin(util_name) configure -cursor top_left_arrow; update
        return
		}
     set new_name [cvip rename $result ${current_image}_$temp]       
     img_q insert end $new_name
     image_post $new_name
     cvip view $new_name
	  CvipMessage "image \"$current_image\" is converted to $temp image"
	 $topwin(util_name) configure -cursor top_left_arrow; update
	 } \
    -text {PERFORM}

  # build widget $topwin(util_name).perform.dismiss
	button $topwin(util_name).perform.dismiss -padx {1} -pady {1} -highlightthickness {0}  \
	 -background "$GuiColor(dis_bg)" \
	 -foreground "$GuiColor(dis_fg)" \
	 -activebackground "$GuiColor(dis_act_bg)" \
    -command {if [winfo exist .filter ] {destroy .filter}; destroy $topwin(util_name); set topwin(util_name) NONE} \
    -text {DISMISS} \
    -width {10}

  # pack widget $topwin(util_name).perform
  pack append $topwin(util_name).perform \
    $topwin(util_name).perform.dismiss {left frame center filly} \
    $topwin(util_name).perform.perform1 {right frame center filly}

  # build widget $topwin(util_name).current_image
  frame $topwin(util_name).current_image \
    -background "$GuiColor(frame_bg)" \
    -borderwidth {2} \
    -relief {ridge}

  # build widget $topwin(util_name).current_image.current
  label $topwin(util_name).current_image.current \
    -background "$GuiColor(label_bg)" \
    -text {Current image:}

  # build widget $topwin(util_name).current_image.name
  label $topwin(util_name).current_image.name \
    -background "$GuiColor(label_bg)" \
    -foreground {Blue} \
    -text {} \
    -textvariable {current_image}

  # pack widget $topwin(util_name).current_image
  pack append $topwin(util_name).current_image \
    $topwin(util_name).current_image.current {left frame center} \
    $topwin(util_name).current_image.name {left frame center filly}

  # pack widget $topwin(util_name)
  pack append $topwin(util_name) \
    $topwin(util_name).info {top frame center expand fill} \
    $topwin(util_name).perform {bottom frame center pady 5 fill} \
    $topwin(util_name).current_image {bottom frame center fill}

  if {"[info procs XFEdit]" != ""} {
    catch "XFMiscBindWidgetTree $topwin(util_name)"
    after 2 "catch {XFEditSetShowWindows}"
  }
}

# procedure to show window $topwin(util_name)
proc util_label { } {# xf ignore me 7

  global {util}
  # Window manager configurations
  global topwin
  global GuiColor
  global GUI_DEBUG
  global GuiMisc

  if [ winfo exists $topwin(util_name).info] {
     set tempname $topwin(util_name);\
destroy $topwin(util_name).info;\
set topwin(util_name) $tempname;}
  if [ winfo exists $topwin(util_name).current_image] {
     set tempname $topwin(util_name);\
destroy $topwin(util_name).current_image;\
set topwin(util_name) $tempname;}
  if [ winfo exists $topwin(util_name).perform] {
     set tempname $topwin(util_name);\
destroy $topwin(util_name).perform;\
set topwin(util_name) $tempname;}
  wm positionfrom $topwin(util_name) user
  wm sizefrom $topwin(util_name) user
  wm geometry $topwin(util_name) $topwin(util_top)[get_pos $topwin(util_name)]
  wm maxsize $topwin(util_name) [lindex [split $topwin(util_top_max)] 0] \
  	[lindex [split $topwin(util_top_max)] 1]
  wm minsize $topwin(util_name) [lindex [split $topwin(util_top_min)] 0] \
  	[lindex [split $topwin(util_top_min)] 1]
  wm title $topwin(util_name) "UTILITIES -> Convert -> Label a segmented image"


  # bindings
  bind $topwin(util_name) <Destroy> {set topwin(util_name) NONE}


  # build widget $topwin(util_name).info
  frame $topwin(util_name).info \
    -background "$GuiColor(frame_bg)" \
    -borderwidth {2}

  # build widget $topwin(util_name).info.frame0
  frame $topwin(util_name).info.frame0 \
    -background "$GuiColor(frame_bg)"

  # build widget $topwin(util_name).info.frame0.label1
  label $topwin(util_name).info.frame0.label1 \
    -anchor {w} \
    -background "$GuiColor(label_bg)" \
    -borderwidth {0} \
    -text {This function creates a labeled image from the current image.}

  # build widget $topwin(util_name).info.frame0.label2
  label $topwin(util_name).info.frame0.label2 \
    -anchor {w} \
    -background "$GuiColor(label_bg)" \
    -borderwidth {0} \
    -text { 1) For color images, it first converts the image to a grayscale image by}

  # build widget $topwin(util_name).info.frame0.label3
  label $topwin(util_name).info.frame0.label3 \
    -anchor {w} \
    -background "$GuiColor(label_bg)" \
    -borderwidth {0} \
    -text {     performing a luminance transform, and then it labels the grayscale image.}

  # build widget $topwin(util_name).info.frame0.label4
  label $topwin(util_name).info.frame0.label4 \
    -anchor {w} \
    -background "$GuiColor(label_bg)" \
    -borderwidth {0} \
    -text { 2) Typically used with images that have been segmented.}


  # pack widget $topwin(util_name).info.frame0
  pack append $topwin(util_name).info.frame0 \
    $topwin(util_name).info.frame0.label1 {padx 20 top frame w } \
    $topwin(util_name).info.frame0.label2 {padx 20 top frame w } \
    $topwin(util_name).info.frame0.label3 {padx 20 top frame w } \
    $topwin(util_name).info.frame0.label4 {padx 20 top frame w } 

  
  # pack widget $topwin(util_name).info
  pack append $topwin(util_name).info \
    $topwin(util_name).info.frame0 {padx 20 left frame center}

  # build widget $topwin(util_name).perform
  frame $topwin(util_name).perform \
    -background "$GuiColor(frame_bg)" \
    -borderwidth {2} \
    -relief {raised}

  # build widget $topwin(util_name).perform.perform1
	button $topwin(util_name).perform.perform1 -padx {1} -pady {1} -highlightthickness {0}  \
	 -background "$GuiColor(perf_bg)" \
	 -foreground "$GuiColor(perf_fg)" \
	 -activebackground "$GuiColor(perf_act_bg)" \
    -command {
		$topwin(util_name) configure -cursor watch; update
		if {$current_image == ""} {
			CvipAlert "Please select an image first."
			$topwin(util_name) configure -cursor top_left_arrow; update
			return
		} 

		if {$bands != "1"} {
			if [catch {set temp [cvip luminance $current_image] } cresult ] {
				CvipAlert "$cresult"
				$topwin(util_name) configure -cursor top_left_arrow; update
				return
			} 
			if { $GUI_DEBUG == "1" } {
				puts stderr "cvip luminance $current_image"
			}
		}  else {
			set temp $current_image
		}

		
		if [catch {set result [cvip label $temp]} cresult] {
				CvipAlert "$cresult"
				$topwin(util_name) configure -cursor top_left_arrow; update
				return
			} else {
				set new_name [cvip rename $result ${current_image}_labeled]
			}
		
		if { $GUI_DEBUG == "1" } {
			puts stderr "cvip label $temp"
		}
		img_q insert end $new_name
		image_post $new_name
		cvip view $new_name
		CvipMessage "label image created from image \"$current_image\""
	$topwin(util_name) configure -cursor top_left_arrow; update
	 } \
    -text {PERFORM}

  # build widget $topwin(util_name).perform.dismiss
	button $topwin(util_name).perform.dismiss -padx {1} -pady {1} -highlightthickness {0}  \
	 -background "$GuiColor(dis_bg)" \
	 -foreground "$GuiColor(dis_fg)" \
	 -activebackground "$GuiColor(dis_act_bg)" \
    -command {destroy $topwin(util_name); set topwin(util_name) NONE} \
    -text {DISMISS} \
    -width {10}

  # pack widget $topwin(util_name).perform
  pack append $topwin(util_name).perform \
    $topwin(util_name).perform.dismiss {left frame sw filly} \
    $topwin(util_name).perform.perform1 {right frame se filly}

  # build widget $topwin(util_name).current_image
  frame $topwin(util_name).current_image \
    -background "$GuiColor(frame_bg)" \
    -borderwidth {2} \
    -relief {ridge}

  # build widget $topwin(util_name).current_image.current
  label $topwin(util_name).current_image.current \
    -background "$GuiColor(label_bg)" \
    -text {Current image:}

  # build widget $topwin(util_name).current_image.name
  label $topwin(util_name).current_image.name \
    -background "$GuiColor(label_bg)" \
    -foreground {Blue} \
    -text {} \
    -textvariable {current_image}

  # pack widget $topwin(util_name).current_image
  pack append $topwin(util_name).current_image \
    $topwin(util_name).current_image.current {left frame center} \
    $topwin(util_name).current_image.name {left frame center filly}

  # pack widget $topwin(util_name)
  pack append $topwin(util_name) \
    $topwin(util_name).info {top frame center expand fill} \
    $topwin(util_name).perform {bottom frame center pady 5 fill} \
    $topwin(util_name).current_image {bottom frame center fill}

  if {"[info procs XFEdit]" != ""} {
    catch "XFMiscBindWidgetTree $topwin(util_name)"
    after 2 "catch {XFEditSetShowWindows}"
  }
}
# **********************************************************************


proc util_gray_bin { } {# xf ignore me 7


  # Window manager configurations
  global tk_version
  global GuiColor
  global GUI_DEBUG
  global GuiMisc
  global topwin
  global toplevel_position
  global GuiColor
  global GUI_DEBUG
  global GuiMisc
  if [ winfo exists $topwin(util_name).info] {
     set tempname $topwin(util_name);\
destroy $topwin(util_name).info;\
set topwin(util_name) $tempname;}
  if [ winfo exists $topwin(util_name).current_image] {
     set tempname $topwin(util_name);\
destroy $topwin(util_name).current_image;\
set topwin(util_name) $tempname;}
  if [ winfo exists $topwin(util_name).perform] {
     set tempname $topwin(util_name);\
destroy $topwin(util_name).perform;\
set topwin(util_name) $tempname;}
  wm positionfrom $topwin(util_name) user
  wm sizefrom $topwin(util_name) user
  wm geometry $topwin(util_name) $topwin(util_top)[get_pos $topwin(util_name)]
  wm maxsize $topwin(util_name) [lindex [split $topwin(util_top_max)] 0] \
  	[lindex [split $topwin(util_top_max)] 1]
  wm minsize $topwin(util_name) [lindex [split $topwin(util_top_min)] 0] \
  	[lindex [split $topwin(util_top_min)] 1]
  wm title $topwin(util_name) {UTILITIES -> Convert -> Gray code-Natural binary}

  # bindings
  bind $topwin(util_name) <Destroy> {set topwin(util_name) NONE}

  # build widget $topwin(util_name).info
  frame $topwin(util_name).info \
    -background "$GuiColor(frame_bg)" \
    -borderwidth {2}

  # build widget $topwin(util_name).info.frame3
  frame $topwin(util_name).info.frame3 \
    -background "$GuiColor(frame_bg)"

  # build widget $topwin(util_name).info.frame3.label5
  label $topwin(util_name).info.frame3.label5 \
    -background "$GuiColor(label_bg)" \
    -text {Convert between gray code and natural binary code: }

  # pack widget $topwin(util_name).info.frame3
  pack append $topwin(util_name).info.frame3 \
    $topwin(util_name).info.frame3.label5 {left frame center padx 10}

  # build widget $topwin(util_name).info.frame9
  frame $topwin(util_name).info.frame9 \
    -background "$GuiColor(frame_bg)"

  # build widget $topwin(util_name).info.frame9.radiobutton10
	radiobutton $topwin(util_name).info.frame9.radiobutton10 -padx {1} -pady {1} -highlightthickness {0}  \
    -background "$GuiColor(btn_bg)" \
	 -activebackground "$GuiColor(btn_act_bg)" \
    -relief {flat} \
    -text { Gray code to natural binary code} \
    -value {gray_bin} \
    -variable {util(g_b)}

  # build widget $topwin(util_name).info.frame9.radiobutton14
	radiobutton $topwin(util_name).info.frame9.radiobutton14 -padx {1} -pady {1} -highlightthickness {0}  \
    -background "$GuiColor(btn_bg)" \
	 -activebackground "$GuiColor(btn_act_bg)" \
    -relief {flat} \
    -text {Natural binary code to gray code} \
    -value {bin_gray} \
    -variable {util(g_b)}

  # pack widget $topwin(util_name).info.frame9
  pack append $topwin(util_name).info.frame9 \
    $topwin(util_name).info.frame9.radiobutton14 {left frame center expand} \
    $topwin(util_name).info.frame9.radiobutton10 {left frame center expand} 

  # pack widget $topwin(util_name).info
  pack append $topwin(util_name).info \
    $topwin(util_name).info.frame3 {top frame center expand fill} \
    $topwin(util_name).info.frame9 {top frame center expand fill}

  # build widget $topwin(util_name).perform
  frame $topwin(util_name).perform \
    -background "$GuiColor(frame_bg)" \
    -borderwidth {2} \
    -relief {raised}

  # build widget $topwin(util_name).perform.perform1
	button $topwin(util_name).perform.perform1 -padx {1} -pady {1} -highlightthickness {0}  \
	 -background "$GuiColor(perf_bg)" \
	 -foreground "$GuiColor(perf_fg)" \
	 -activebackground "$GuiColor(perf_act_bg)" \
    -command {
		$topwin(util_name) configure -cursor watch; update
      if { $current_image == ""} {
         CvipAlert "Please select an image first."
			$topwin(util_name) configure -cursor top_left_arrow; update
         return
      } 

		set gb_dir 0
		set gb_name bincode 
		if { $util(g_b) == "bin_gray" } {set gb_dir 1; set gb_name graycode}
		set result [cvip gray_binary $current_image $gb_dir]
		set new_name [cvip rename $result ${current_image}_$gb_name]
		$topwin(util_name) configure -cursor top_left_arrow; update
		img_q insert end $new_name
		image_post $new_name
		cvip view $new_name
		unset gb_dir
		unset gb_name
		if { $util(g_b) == "bin_gray" } {
			CvipMessage "binary to gray code conversion performed on image \"$current_image\""
		} else {
			CvipMessage "gray to binary code conversion performed on image \"$current_image\""
		}
	$topwin(util_name) configure -cursor top_left_arrow; update
	 } \
    -text {PERFORM}

  # build widget $topwin(util_name).perform.dismiss
	button $topwin(util_name).perform.dismiss -padx {1} -pady {1} -highlightthickness {0}  \
	 -background "$GuiColor(dis_bg)" \
	 -foreground "$GuiColor(dis_fg)" \
	 -activebackground "$GuiColor(dis_act_bg)" \
    -command {if [winfo exist .filter ] {destroy .filter}; destroy $topwin(util_name); set topwin(util_name) NONE} \
    -text {DISMISS} \
    -width {10}

  # pack widget $topwin(util_name).perform
  pack append $topwin(util_name).perform \
    $topwin(util_name).perform.dismiss {left frame center filly} \
    $topwin(util_name).perform.perform1 {right frame center filly}

  # build widget $topwin(util_name).current_image
  frame $topwin(util_name).current_image \
    -background "$GuiColor(frame_bg)" \
    -borderwidth {2} \
    -relief {ridge}

  # build widget $topwin(util_name).current_image.current
  label $topwin(util_name).current_image.current \
    -background "$GuiColor(label_bg)" \
    -text {Current image:}

  # build widget $topwin(util_name).current_image.name
  label $topwin(util_name).current_image.name \
    -background "$GuiColor(label_bg)" \
    -foreground {Blue} \
    -text {} \
    -textvariable {current_image}

  # pack widget $topwin(util_name).current_image
  pack append $topwin(util_name).current_image \
    $topwin(util_name).current_image.current {left frame center} \
    $topwin(util_name).current_image.name {left frame center filly}

  # pack widget $topwin(util_name)
  pack append $topwin(util_name) \
    $topwin(util_name).info {top frame center expand fill} \
    $topwin(util_name).perform {bottom frame center pady 5 fill} \
    $topwin(util_name).current_image {bottom frame center fill}

  if {"[info procs XFEdit]" != ""} {
    catch "XFMiscBindWidgetTree $topwin(util_name)"
    after 2 "catch {XFEditSetShowWindows}"
  }
}


proc util_gray_quant { } {# xf ignore me 7

  # Window manager configurations
  global tk_version
  global GuiColor
  global GUI_DEBUG
  global GuiMisc
  global topwin
  global toplevel_position
  global GuiColor
  global GUI_DEBUG
  global GuiMisc
  if [ winfo exists $topwin(util_name).info] {
     set tempname $topwin(util_name);\
destroy $topwin(util_name).info;\
set topwin(util_name) $tempname;}
  if [ winfo exists $topwin(util_name).current_image] {
     set tempname $topwin(util_name);\
destroy $topwin(util_name).current_image;\
set topwin(util_name) $tempname;}
  if [ winfo exists $topwin(util_name).perform] {
     set tempname $topwin(util_name);\
destroy $topwin(util_name).perform;\
set topwin(util_name) $tempname;}
  wm positionfrom $topwin(util_name) user
  wm sizefrom $topwin(util_name) user
  wm geometry $topwin(util_name) $topwin(util_top)[get_pos $topwin(util_name)]
  wm maxsize $topwin(util_name) [lindex [split $topwin(util_top_max)] 0] \
  	[lindex [split $topwin(util_top_max)] 1]
  wm minsize $topwin(util_name) [lindex [split $topwin(util_top_min)] 0] \
  	[lindex [split $topwin(util_top_min)] 1]
  wm title $topwin(util_name) {UTILITIES -> Convert -> Gray Level Quantization}
  # bindings
  bind $topwin(util_name) <Destroy> {set topwin(util_name) NONE}

  # build widget $topwin(util_name).info
  frame $topwin(util_name).info \
    -background "$GuiColor(frame_bg)" \
    -borderwidth {2}

  # build widget $topwin(util_name).info.frame0
  frame $topwin(util_name).info.frame0 \
    -background "$GuiColor(frame_bg)"

  # build widget $topwin(util_name).info.frame0.label1
  label $topwin(util_name).info.frame0.label1 \
    -anchor {e} \
    -background "$GuiColor(label_bg)" \
    -borderwidth {0} \
    -text {Number of gray levels: } \
    -width {23}

  # build widget $topwin(util_name).info.frame0.value
  entry $topwin(util_name).info.frame0.value \
    -background "$GuiColor(entry_bg)" \
	 -foreground "$GuiColor(entry_fg)" \
    -textvariable {util(gray_quant)} \
    -width {10}
  # bindings
  endEntry $topwin(util_name).info.frame0.value

  # build widget $topwin(util_name).info.frame0.menubutton2
	menubutton $topwin(util_name).info.frame0.menubutton2 -padx {1} -pady {5} -highlightthickness {0}  \
    -background "$GuiColor(btn_bg)" \
	 -activebackground "$GuiColor(btn_act_bg)" \
    -font "$GuiMisc(pop_up_fn)" \
	 -text "$GuiMisc(pop_up_text)" \
	 -relief "$GuiMisc(pop_up_relief)" \
	 -width {2}
  # bindings
  bind $topwin(util_name).info.frame0.menubutton2 <Button-1> {MenuPopupPost $topwin(util_name).info.frame0.menubutton2.menu %X %Y}
  bind $topwin(util_name).info.frame0.menubutton2 <ButtonRelease-1> {MenuPopupRelease $topwin(util_name).info.frame0.menubutton2.menu %W}

  # build widget $topwin(util_name).info.frame0.menubutton2.menu
  menu $topwin(util_name).info.frame0.menubutton2.menu \
     -activebackground "$GuiColor(menu_act_bg)" \
	  -background "$GuiColor(menu_bg)" 

  $topwin(util_name).info.frame0.menubutton2.menu add command \
     -activebackground "$GuiColor(menu_act_bg)" \
	  -background "$GuiColor(menu_bg)"  \
    -command {set util(gray_quant) 2} \
    -label {  2}
  $topwin(util_name).info.frame0.menubutton2.menu add command \
     -activebackground "$GuiColor(menu_act_bg)" \
	  -background "$GuiColor(menu_bg)"  \
    -command {set util(gray_quant) 4} \
    -label {  4}
  $topwin(util_name).info.frame0.menubutton2.menu add command \
     -activebackground "$GuiColor(menu_act_bg)" \
	  -background "$GuiColor(menu_bg)"  \
    -command {set util(gray_quant) 8} \
    -label {  8}
  $topwin(util_name).info.frame0.menubutton2.menu add command \
     -activebackground "$GuiColor(menu_act_bg)" \
	  -background "$GuiColor(menu_bg)"  \
    -command {set util(gray_quant) 16} \
    -label { 16}
  $topwin(util_name).info.frame0.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)"  \
    -command {set util(gray_quant) 32} \
    -label { 32}
  $topwin(util_name).info.frame0.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)"  \
    -command {set util(gray_quant) 64} \
    -label { 64}
  $topwin(util_name).info.frame0.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)"  \
    -command {set util(gray_quant) 128} \
    -label {128}
  $topwin(util_name).info.frame0.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)"  \
    -command {set util(gray_quant) 256} \
    -label {256}
  bindtags $topwin(util_name).info.frame0.menubutton2.menu  {Menu all}
  # bindings
  bind $topwin(util_name).info.frame0.menubutton2.menu <B1-Motion> {MenuPopupMotion $topwin(util_name).info.frame0.menubutton2.menu %W %X %Y}
  bind $topwin(util_name).info.frame0.menubutton2.menu <ButtonRelease-1> {MenuPopupRelease $topwin(util_name).info.frame0.menubutton2.menu %W}

	radiobutton $topwin(util_name).info.frame0.radiobutton1 -padx {1} -pady {1} -highlightthickness {0}  \
    -background "$GuiColor(btn_bg)" \
	 -activebackground "$GuiColor(btn_act_bg)" \
    -relief {flat} \
    -text {Standard } \
    -value {S} \
	 -anchor {w} \
    -variable {util(gray_qmethod)}

	radiobutton $topwin(util_name).info.frame0.radiobutton2 -padx {1} -pady {1} -highlightthickness {0}  \
    -background "$GuiColor(btn_bg)" \
	 -activebackground "$GuiColor(btn_act_bg)" \
    -relief {flat} \
    -text {IGS} \
    -value {I} \
	 -anchor {w} \
    -variable {util(gray_qmethod)}

  # pack widget $topwin(util_name).info.frame0
  pack append $topwin(util_name).info.frame0 \
    $topwin(util_name).info.frame0.label1 {left frame center fill} \
    $topwin(util_name).info.frame0.value {left frame center fillx} \
    $topwin(util_name).info.frame0.menubutton2 {left frame center fillx} \
    $topwin(util_name).info.frame0.radiobutton1 {top frame nw fill padx 10} \
    $topwin(util_name).info.frame0.radiobutton2 {top frame nw fill padx 10} 

  # pack widget $topwin(util_name).info
  pack append $topwin(util_name).info \
    $topwin(util_name).info.frame0 {left frame center padx 215}

  # build widget $topwin(util_name).perform
  frame $topwin(util_name).perform \
    -background "$GuiColor(frame_bg)" \
    -borderwidth {2} \
    -relief {raised}

  # build widget $topwin(util_name).perform.perform1
	button $topwin(util_name).perform.perform1 -padx {1} -pady {1} -highlightthickness {0}  \
	 -background "$GuiColor(perf_bg)" \
	 -foreground "$GuiColor(perf_fg)" \
	 -activebackground "$GuiColor(perf_act_bg)" \
    -command {
		$topwin(util_name) configure -cursor watch; update
		if {$current_image == ""} {
			CvipAlert "Please select an image first."
			$topwin(util_name) configure -cursor top_left_arrow; update
			return
		} elseif [catch {expr $util(gray_quant)} ] {
			CvipAlert "Numerical value required for number of gray levels.\n 
			Number of gray levels = $util(gray_quant)"
			$topwin(util_name) configure -cursor top_left_arrow; update
			return
		} elseif { $util(gray_quant) < 1 || $util(gray_quant) > 255} {
			CvipAlert "The number of gray levels ($util(gray_quant)) should be in the range \[1-255\]"
			$topwin(util_name) configure -cursor top_left_arrow; update
			return
		}
		if { $util(gray_qmethod)  == "S" } {
			if [catch {set result [cvip gray_quant $current_image $util(gray_quant)]} cresult ] {
				CvipAlert "$cresult"
				$topwin(util_name) configure -cursor top_left_arrow; update
				return
			}
			if { $GUI_DEBUG == "1" } {
				puts stderr "cvip gray_quant $current_image $util(gray_quant)"
			}
			CvipMessage "standard gray level quantization performed on image \"$current_image\""
		} else {
			if [catch {set result [cvip igs $current_image $util(gray_quant)]} cresult ] {
				CvipAlert "$cresult"
				$topwin(util_name) configure -cursor top_left_arrow; update
				return
			}
			if { $GUI_DEBUG == "1" } {
				puts stderr "cvip igs $current_image $util(gray_quant)"
			}
			CvipMessage "IGS quantization performed on image \"$current_image\""
		}
		set new_name [cvip rename $result ${current_image}_$util(gray_quant)]
		img_q insert end $new_name
		image_post $new_name
		cvip view $new_name
	$topwin(util_name) configure -cursor top_left_arrow; update
	 } \
    -text {PERFORM}

  # build widget $topwin(util_name).perform.dismiss
	button $topwin(util_name).perform.dismiss -padx {1} -pady {1} -highlightthickness {0}  \
	 -background "$GuiColor(dis_bg)" \
	 -foreground "$GuiColor(dis_fg)" \
	 -activebackground "$GuiColor(dis_act_bg)" \
    -command {destroy $topwin(util_name); set topwin(util_name) NONE} \
    -text {DISMISS} \
    -width {10}

  # pack widget $topwin(util_name).perform
  pack append $topwin(util_name).perform \
    $topwin(util_name).perform.dismiss {left frame sw filly} \
    $topwin(util_name).perform.perform1 {right frame se filly}

  # build widget $topwin(util_name).current_image
  frame $topwin(util_name).current_image \
    -background "$GuiColor(frame_bg)" \
    -borderwidth {2} \
    -relief {ridge}

  # build widget $topwin(util_name).current_image.current
  label $topwin(util_name).current_image.current \
    -background "$GuiColor(label_bg)" \
    -text {Current image:}

  # build widget $topwin(util_name).current_image.name
  label $topwin(util_name).current_image.name \
    -background "$GuiColor(label_bg)" \
    -foreground {Blue} \
    -text {} \
    -textvariable {current_image}

  # pack widget $topwin(util_name).current_image
  pack append $topwin(util_name).current_image \
    $topwin(util_name).current_image.current {left frame center} \
    $topwin(util_name).current_image.name {left frame center filly}

  # pack widget $topwin(util_name)
  pack append $topwin(util_name) \
    $topwin(util_name).info {top frame center expand fill} \
    $topwin(util_name).perform {bottom frame center pady 5 fill} \
    $topwin(util_name).current_image {bottom frame center fill}

  if {"[info procs XFEdit]" != ""} {
    catch "XFMiscBindWidgetTree $topwin(util_name)"
    after 2 "catch {XFEditSetShowWindows}"
  }
}
