# **********************************************************************
# Computer Vision/Image Processing Tool Project - Dr. Scott Umbaugh SIUE
# **********************************************************************
#
#             File Name: util_creat.tcl
#           Description: 
#         Related Files: 
#   Initial Coding Date: Fri Aug  9 17:33:36 CDT 1996
#           Portability: TCL script file
#            References:
#             Author(s): Yansheng Wei
#                        Southern Illinois University @ Edwardsville
#
## Copyright (C) 1996 SIUE - by Scott Umbaugh and Yansheng Wei.
##
## Permission to use, copy, modify, and distribute this software and its
## documentation for any purpose and without fee is hereby granted, provided
## that the above copyright notice appear in all copies and that both that
## copyright notice and this permission notice appear in supporting
## documentation.  This software is provided "as is" without express or
## implied warranty.
##
# RCS (Revision Control System) Information
# ...Added automatically by RCS 
#
## $Log: util_creat.tcl,v $
## Revision 1.20  1997/08/08 04:54:24  wzheng
## correct wrong title of the assemble and Extract band
##
## Revision 1.19  1997/07/17 21:21:21  yawei
## tested the configuration
##
## Revision 1.18  1997/07/17 19:24:47  yawei
## Gui configuraiton in place
##
## Revision 1.17  1997/06/24 19:37:31  yawei
## selection ==> temp
##
## Revision 1.16  1997/03/12 16:10:19  yawei
## fixed arrow buttons, and labels
##
## Revision 1.15  1997/03/11 20:56:57  yawei
## Tcl/Tk script upgrading from tcl7.3/tk3.6 to tcl7.6/tk4.2
## compatible. This process is automated with tkboost perl
## script. @ Tue Mar 11 14:51:36 CST 1997
##
## Revision 1.14  1996/12/31 00:22:57  yawei
## crop_Image ==> crop
##
# Revision 1.13  1996/12/30  20:06:10  yawei
# square ==> rectangle
#
# Revision 1.12  1996/12/13  18:28:29  akjoele
# changed crop_inner to crop_Image
#
# Revision 1.11  1996/11/07  22:38:41  yawei
# changed so the create "rectangle" will have correct size
#
# Revision 1.10  1996/10/16  19:40:27  yawei
# general_changes
#
# Revision 1.9  1996/10/10  21:40:38  yawei
# Changed default image name of black to black, instead of simple.
# ,.
#
# Revision 1.8  1996/10/10  03:57:39  yawei
# added black image
#
# Revision 1.7  1996/09/27  18:32:10  mzuke
#  made window resizable
#
# Revision 1.6  1996/09/21  21:15:51  mzuke
# changed 'To Row and Col" values from powers of 2
# to {(powers of 2) -1} so that created rectangles
# will have sides of length (powers of two)
#
# Revision 1.5  1996/09/09  14:55:42  mzuke
# fixed function 'square' so that it computes width and height
# of the desired rectangle, as required by cvip square
#
# Revision 1.4  1996/08/27  12:01:18  mzuke
# enabled selection of image queue highlighted item
# for assemble band window
#
# Revision 1.3  1996/08/20  18:18:17  mzuke
# completed extract band, began assemble bands
#
# Revision 1.2  1996/08/15  11:16:32  mzuke
# removed toplevel_position from wm geometry to allow window
# positioning by user
#
# Revision 1.1  1996/08/09  22:36:58  yawei
# Initial revision
#
#
#****************************************************************************
# procedure to show window $topwin(util_name)
proc util_circle { } {# xf ignore me 7
  global GuiColor
  global GuiMisc
  global GUI_DEBUG

  # Window manager configurations
  global tk_version
  global topwin
  global toplevel_position
  global {util}
  set util(img_name) "circle"
  if [ winfo exists $topwin(util_name).info] {
     set tempname $topwin(util_name);\
destroy $topwin(util_name).info;\
set topwin(util_name) $tempname;}
  if [ winfo exists $topwin(util_name).current_image] {
     set tempname $topwin(util_name);\
destroy $topwin(util_name).current_image;\
set topwin(util_name) $tempname;}
  if [ winfo exists $topwin(util_name).perform] {
     set tempname $topwin(util_name);\
destroy $topwin(util_name).perform;\
set topwin(util_name) $tempname;}
  wm positionfrom $topwin(util_name) user

  wm geometry $topwin(util_name) $topwin(util_top)[get_pos $topwin(util_name)]
  wm maxsize $topwin(util_name) [lindex [split $topwin(util_top_max)] 0] \
  	[lindex [split $topwin(util_top_max)] 1]
  wm minsize $topwin(util_name) [lindex [split $topwin(util_top_min)] 0] \
  	[lindex [split $topwin(util_top_min)] 1]
  wm title $topwin(util_name) {UTILITIES -> Create -> Circle}

  # bindings
  bind $topwin(util_name) <Destroy> {set topwin(util_name) NONE}

  # build widget $topwin(util_name).info
  frame $topwin(util_name).info \
    -background "$GuiColor(frame_bg)" \
    -borderwidth {2}

  # build widget $topwin(util_name).info.frame3
  frame $topwin(util_name).info.frame3 \
    -background "$GuiColor(frame_bg)" 

  # build widget $topwin(util_name).info.frame3.frame0
  frame $topwin(util_name).info.frame3.frame0 \
    -background "$GuiColor(frame_bg)"  \
    -borderwidth {2}

  # build widget $topwin(util_name).info.frame3.frame0.label1
  label $topwin(util_name).info.frame3.frame0.label1 \
    -background "$GuiColor(label_bg)" \
    -borderwidth {0} \
    -text {Image width: }

  # build widget $topwin(util_name).info.frame3.frame0.value
  entry $topwin(util_name).info.frame3.frame0.value \
    -background "$GuiColor(entry_bg)" \
	 -foreground "$GuiColor(entry_fg)" \
	 -highlightthickness {0} \
    -relief {sunken} \
    -textvariable {util(img_width)} \
    -width {5}
  # bindings
  endEntry $topwin(util_name).info.frame3.frame0.value 0\
    $topwin(util_name).info.frame0.frame1.value \
    $topwin(util_name).info.frame3.frame1.value

  # build widget $topwin(util_name).info.frame3.frame0.menubutton2
	menubutton $topwin(util_name).info.frame3.frame0.menubutton2 -padx {1} -pady {1} -highlightthickness {0}  \
    -background "$GuiColor(btn_bg)" \
	 -activebackground "$GuiColor(btn_act_bg)" \
    -font "$GuiMisc(pop_up_fn)" \
	 -text "$GuiMisc(pop_up_text)" \
	 -relief "$GuiMisc(pop_up_relief)" \
	 -width {2}

  # bindings
  bind $topwin(util_name).info.frame3.frame0.menubutton2 <Button-1> {MenuPopupPost $topwin(util_name).info.frame3.frame0.menubutton2.menu %X %Y}
  bind $topwin(util_name).info.frame3.frame0.menubutton2 <ButtonRelease-1> {MenuPopupRelease $topwin(util_name).info.frame3.frame0.menubutton2.menu %W}

  # build widget $topwin(util_name).info.frame3.frame0.menubutton2.menu
  menu $topwin(util_name).info.frame3.frame0.menubutton2.menu \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" 

  $topwin(util_name).info.frame3.frame0.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set util(img_width) 16} \
    -label {  16}
  $topwin(util_name).info.frame3.frame0.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set util(img_width) 32} \
    -label {  32}
  $topwin(util_name).info.frame3.frame0.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set util(img_width) 64} \
    -label {  64}
  $topwin(util_name).info.frame3.frame0.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set util(img_width) 128} \
    -label { 128}
  $topwin(util_name).info.frame3.frame0.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set util(img_width) 256} \
    -label { 256}
  $topwin(util_name).info.frame3.frame0.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set util(img_width) 512} \
    -label { 512}
  $topwin(util_name).info.frame3.frame0.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set util(img_width) 1024} \
    -label {1024}
  bindtags $topwin(util_name).info.frame3.frame0.menubutton2.menu {Menu all}
  # bindings
  bind $topwin(util_name).info.frame3.frame0.menubutton2.menu <Button-1> {MenuPopupPost $topwin(util_name).info.frame3.frame0.menubutton2.menu %X %Y}
  bind $topwin(util_name).info.frame3.frame0.menubutton2.menu <ButtonRelease-1> {MenuPopupRelease $topwin(util_name).info.frame3.frame0.menubutton2.menu %W}

  # pack widget $topwin(util_name).info.frame3.frame0
  pack append $topwin(util_name).info.frame3.frame0 \
    $topwin(util_name).info.frame3.frame0.label1 {left frame center fill} \
    $topwin(util_name).info.frame3.frame0.value {left frame center expand fill} \
    $topwin(util_name).info.frame3.frame0.menubutton2 {right frame center fill}

  # build widget $topwin(util_name).info.frame3.frame1
  frame $topwin(util_name).info.frame3.frame1 \
    -background "$GuiColor(frame_bg)"  \
    -borderwidth {2}

  # build widget $topwin(util_name).info.frame3.frame1.label1
  label $topwin(util_name).info.frame3.frame1.label1 \
    -background "$GuiColor(label_bg)" \
    -borderwidth {0} \
    -text {Image height: }

  # build widget $topwin(util_name).info.frame3.frame1.value
  entry $topwin(util_name).info.frame3.frame1.value \
    -background "$GuiColor(entry_bg)" \
	 -foreground "$GuiColor(entry_fg)" \
	 -highlightthickness {0} \
    -relief {sunken} \
    -textvariable {util(img_height)} \
    -width {5}
  # bindings
  endEntry $topwin(util_name).info.frame3.frame1.value 0 \
    $topwin(util_name).info.frame3.frame0.value \
    $topwin(util_name).current_image.frame.entry2 

  # build widget $topwin(util_name).info.frame3.frame1.menubutton2
	menubutton $topwin(util_name).info.frame3.frame1.menubutton2 -padx {1} -pady {1} -highlightthickness {0}  \
    -background "$GuiColor(btn_bg)" \
	 -activebackground "$GuiColor(btn_act_bg)" \
    -font "$GuiMisc(pop_up_fn)" \
	 -text "$GuiMisc(pop_up_text)" \
	 -relief "$GuiMisc(pop_up_relief)" \
	 -width {2}

  # bindings
  bind $topwin(util_name).info.frame3.frame1.menubutton2 <Button-1> {MenuPopupPost $topwin(util_name).info.frame3.frame1.menubutton2.menu %X %Y}
  bind $topwin(util_name).info.frame3.frame1.menubutton2 <ButtonRelease-1> {MenuPopupRelease $topwin(util_name).info.frame3.frame1.menubutton2.menu %W}

  # build widget $topwin(util_name).info.frame3.frame1.menubutton2.menu
  menu $topwin(util_name).info.frame3.frame1.menubutton2.menu \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)"

  $topwin(util_name).info.frame3.frame1.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set util(img_height) 16} \
    -label {  16}
  $topwin(util_name).info.frame3.frame1.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set util(img_height) 32} \
    -label {  32}
  $topwin(util_name).info.frame3.frame1.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set util(img_height) 64} \
    -label {  64}
  $topwin(util_name).info.frame3.frame1.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set util(img_height) 128} \
    -label { 128}
  $topwin(util_name).info.frame3.frame1.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set util(img_height) 256} \
    -label { 256}
  $topwin(util_name).info.frame3.frame1.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set util(img_height) 512} \
    -label { 512}
  $topwin(util_name).info.frame3.frame1.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set util(img_height) 1024} \
    -label {1024}
  bindtags $topwin(util_name).info.frame3.frame1.menubutton2.menu  {Menu all}
  # bindings
  bind $topwin(util_name).info.frame3.frame1.menubutton2.menu <Button-1> {MenuPopupPost $topwin(util_name).info.frame3.frame1.menubutton2.menu %X %Y}
  bind $topwin(util_name).info.frame3.frame1.menubutton2.menu <ButtonRelease-1> {MenuPopupRelease $topwin(util_name).info.frame3.frame1.menubutton2.menu %W}

  # pack widget $topwin(util_name).info.frame3.frame1
  pack append $topwin(util_name).info.frame3.frame1 \
    $topwin(util_name).info.frame3.frame1.label1 {left frame center fill} \
    $topwin(util_name).info.frame3.frame1.value {left frame center expand fill} \
    $topwin(util_name).info.frame3.frame1.menubutton2 {right frame center fill}

  # pack widget $topwin(util_name).info.frame3
  pack append $topwin(util_name).info.frame3 \
    $topwin(util_name).info.frame3.frame1 {left frame center padx 10} \
    $topwin(util_name).info.frame3.frame0 {left frame center padx 10}

  # build widget $topwin(util_name).info.frame0
  frame $topwin(util_name).info.frame0 \
    -background "$GuiColor(frame_bg)"  

  # build widget $topwin(util_name).info.frame0.frame0
  frame $topwin(util_name).info.frame0.frame0 \
    -background "$GuiColor(frame_bg)"   \
    -borderwidth {2}

  # build widget $topwin(util_name).info.frame0.frame0.label1
  label $topwin(util_name).info.frame0.frame0.label1 \
    -background "$GuiColor(label_bg)" \
    -borderwidth {0} \
    -text {Center Col: }

  # build widget $topwin(util_name).info.frame0.frame0.value
  entry $topwin(util_name).info.frame0.frame0.value \
    -background "$GuiColor(entry_bg)" \
	 -foreground "$GuiColor(entry_fg)" \
	 -highlightthickness {0} \
    -relief {sunken} \
    -textvariable {util(img_cenc)} \
    -width {5}
  # bindings
  endEntry $topwin(util_name).info.frame0.frame0.value 0\
    $topwin(util_name).info.frame0.frame2.value \
    $topwin(util_name).info.frame0.frame1.value 

  # build widget $topwin(util_name).info.frame0.frame0.menubutton2
	menubutton $topwin(util_name).info.frame0.frame0.menubutton2 -padx {1} -pady {1} -highlightthickness {0}  \
    -background "$GuiColor(btn_bg)" \
	 -activebackground "$GuiColor(btn_act_bg)" \
    -font "$GuiMisc(pop_up_fn)" \
	 -text "$GuiMisc(pop_up_text)" \
	 -relief "$GuiMisc(pop_up_relief)" \
	 -width {2}

  # bindings
  bind $topwin(util_name).info.frame0.frame0.menubutton2 <Button-1> {MenuPopupPost $topwin(util_name).info.frame0.frame0.menubutton2.menu %X %Y}
  bind $topwin(util_name).info.frame0.frame0.menubutton2 <ButtonRelease-1> {MenuPopupRelease $topwin(util_name).info.frame0.frame0.menubutton2.menu %W}

  # build widget $topwin(util_name).info.frame0.frame0.menubutton2.menu
  menu $topwin(util_name).info.frame0.frame0.menubutton2.menu \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" 
  $topwin(util_name).info.frame0.frame0.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set util(img_cenc) 8} \
    -label {   8}
  $topwin(util_name).info.frame0.frame0.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set util(img_cenc) 16} \
    -label {  16}
  $topwin(util_name).info.frame0.frame0.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set util(img_cenc) 32} \
    -label {  32}
  $topwin(util_name).info.frame0.frame0.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set util(img_cenc) 64} \
    -label {  64}
  $topwin(util_name).info.frame0.frame0.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set util(img_cenc) 128} \
    -label { 128}
  $topwin(util_name).info.frame0.frame0.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set util(img_cenc) 256} \
    -label { 256}
  $topwin(util_name).info.frame0.frame0.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set util(img_cenc) 512} \
    -label { 512}
  bindtags  $topwin(util_name).info.frame0.frame0.menubutton2.menu {Menu all}
  # bindings
  bind $topwin(util_name).info.frame0.frame0.menubutton2.menu <Button-1> {MenuPopupPost $topwin(util_name).info.frame0.frame0.menubutton2.menu %X %Y}
  bind $topwin(util_name).info.frame0.frame0.menubutton2.menu <ButtonRelease-1> {MenuPopupRelease $topwin(util_name).info.frame0.frame0.menubutton2.menu %W}

  # pack widget $topwin(util_name).info.frame0.frame0
  pack append $topwin(util_name).info.frame0.frame0 \
    $topwin(util_name).info.frame0.frame0.label1 {left frame center fill} \
    $topwin(util_name).info.frame0.frame0.value {left frame center expand fill} \
    $topwin(util_name).info.frame0.frame0.menubutton2 {right frame center fill}

  # build widget $topwin(util_name).info.frame0.frame1
  frame $topwin(util_name).info.frame0.frame1 \
    -background "$GuiColor(frame_bg)"   \
    -borderwidth {2}

  # build widget $topwin(util_name).info.frame0.frame1.label1
  label $topwin(util_name).info.frame0.frame1.label1 \
    -background "$GuiColor(label_bg)" \
    -borderwidth {0} \
    -text {Center Row: }

  # build widget $topwin(util_name).info.frame0.frame1.value
  entry $topwin(util_name).info.frame0.frame1.value \
    -background "$GuiColor(entry_bg)" \
	 -foreground "$GuiColor(entry_fg)" \
	 -highlightthickness {0} \
    -relief {sunken} \
    -textvariable {util(img_cenr)} \
    -width {5}
  # bindings
  endEntry $topwin(util_name).info.frame0.frame1.value 0\
    $topwin(util_name).info.frame0.frame0.value \
    $topwin(util_name).info.frame3.frame0.value 

  # build widget $topwin(util_name).info.frame0.frame1.menubutton2
	menubutton $topwin(util_name).info.frame0.frame1.menubutton2 -padx {1} -pady {1} -highlightthickness {0}  \
    -background "$GuiColor(btn_bg)" \
	 -activebackground "$GuiColor(btn_act_bg)" \
    -font "$GuiMisc(pop_up_fn)" \
	 -text "$GuiMisc(pop_up_text)" \
	 -relief "$GuiMisc(pop_up_relief)" \
	 -width {2}

  # bindings
  bind $topwin(util_name).info.frame0.frame1.menubutton2 <Button-1> {MenuPopupPost $topwin(util_name).info.frame0.frame1.menubutton2.menu %X %Y}
  bind $topwin(util_name).info.frame0.frame1.menubutton2 <ButtonRelease-1> {MenuPopupRelease $topwin(util_name).info.frame0.frame1.menubutton2.menu %W}

  # build widget $topwin(util_name).info.frame0.frame1.menubutton2.menu
  menu $topwin(util_name).info.frame0.frame1.menubutton2.menu \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" 
  $topwin(util_name).info.frame0.frame1.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set util(img_cenr) 8} \
    -label {   8}
  $topwin(util_name).info.frame0.frame1.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set util(img_cenr) 16} \
    -label {  16}
  $topwin(util_name).info.frame0.frame1.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set util(img_cenr) 32} \
    -label {  32}
  $topwin(util_name).info.frame0.frame1.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set util(img_cenr) 64} \
    -label {  64}
  $topwin(util_name).info.frame0.frame1.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set util(img_cenr) 128} \
    -label { 128}
  $topwin(util_name).info.frame0.frame1.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set util(img_cenr) 256} \
    -label { 256}
  $topwin(util_name).info.frame0.frame1.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set util(img_cenr) 512} \
    -label { 512}
  bindtags $topwin(util_name).info.frame0.frame1.menubutton2.menu {Menu all}
  # bindings
  bind $topwin(util_name).info.frame0.frame1.menubutton2.menu <Button-1> {MenuPopupPost $topwin(util_name).info.frame0.frame1.menubutton2.menu %X %Y}
  bind $topwin(util_name).info.frame0.frame1.menubutton2.menu <ButtonRelease-1> {MenuPopupRelease $topwin(util_name).info.frame0.frame1.menubutton2.menu %W}

  # pack widget $topwin(util_name).info.frame0.frame1
  pack append $topwin(util_name).info.frame0.frame1 \
    $topwin(util_name).info.frame0.frame1.label1 {left frame center fill} \
    $topwin(util_name).info.frame0.frame1.value {left frame center expand fill} \
    $topwin(util_name).info.frame0.frame1.menubutton2 {right frame center fill}

  # build widget $topwin(util_name).info.frame0.frame2
  frame $topwin(util_name).info.frame0.frame2 \
    -background "$GuiColor(frame_bg)"   \
    -borderwidth {2}

  # build widget $topwin(util_name).info.frame0.frame2.label1
  label $topwin(util_name).info.frame0.frame2.label1 \
    -background "$GuiColor(label_bg)" \
    -borderwidth {0} \
    -text {Radius: }

  # build widget $topwin(util_name).info.frame0.frame2.value
  entry $topwin(util_name).info.frame0.frame2.value \
    -background "$GuiColor(entry_bg)" \
	 -foreground "$GuiColor(entry_fg)" \
	 -highlightthickness {0} \
    -relief {sunken} \
    -textvariable {util(img_rad)} \
    -width {5}
  # bindings
  endEntry $topwin(util_name).info.frame0.frame2.value 0\
    $topwin(util_name).current_image.frame.entry2 \
    $topwin(util_name).info.frame0.frame0.value 

  # build widget $topwin(util_name).info.frame0.frame2.menubutton2
	menubutton $topwin(util_name).info.frame0.frame2.menubutton2 -padx {1} -pady {1} -highlightthickness {0}  \
    -background "$GuiColor(btn_bg)" \
	 -activebackground "$GuiColor(btn_act_bg)" \
    -font "$GuiMisc(pop_up_fn)" \
	 -text "$GuiMisc(pop_up_text)" \
	 -relief "$GuiMisc(pop_up_relief)" \
	 -width {2}

  # bindings
  bind $topwin(util_name).info.frame0.frame2.menubutton2 <Button-1> {MenuPopupPost $topwin(util_name).info.frame0.frame2.menubutton2.menu %X %Y}
  bind $topwin(util_name).info.frame0.frame2.menubutton2 <ButtonRelease-1> {MenuPopupRelease $topwin(util_name).info.frame0.frame2.menubutton2.menu %W}

  # build widget $topwin(util_name).info.frame0.frame2.menubutton2.menu
  menu $topwin(util_name).info.frame0.frame2.menubutton2.menu \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" 
  $topwin(util_name).info.frame0.frame2.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set util(img_rad) 8} \
    -label {   8}
  $topwin(util_name).info.frame0.frame2.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set util(img_rad) 16} \
    -label {  16}
  $topwin(util_name).info.frame0.frame2.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set util(img_rad) 32} \
    -label {  32}
  $topwin(util_name).info.frame0.frame2.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set util(img_rad) 64} \
    -label {  64}
  $topwin(util_name).info.frame0.frame2.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set util(img_rad) 128} \
    -label { 128}
  $topwin(util_name).info.frame0.frame2.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set util(img_rad) 256} \
    -label { 256}
  $topwin(util_name).info.frame0.frame2.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set util(img_rad) 512} \
    -label { 512}
  bindtags $topwin(util_name).info.frame0.frame2.menubutton2.menu {Menu all}
  # bindings
  bind $topwin(util_name).info.frame0.frame2.menubutton2.menu <Button-1> {MenuPopupPost $topwin(util_name).info.frame0.frame2.menubutton2.menu %X %Y}
  bind $topwin(util_name).info.frame0.frame2.menubutton2.menu <ButtonRelease-1> {MenuPopupRelease $topwin(util_name).info.frame0.frame2.menubutton2.menu %W}

  # pack widget $topwin(util_name).info.frame0.frame2
  pack append $topwin(util_name).info.frame0.frame2 \
    $topwin(util_name).info.frame0.frame2.label1 {left frame center fill} \
    $topwin(util_name).info.frame0.frame2.value {left frame center expand fill} \
    $topwin(util_name).info.frame0.frame2.menubutton2 {right frame center fill}

  # pack widget $topwin(util_name).info.frame0
  pack append $topwin(util_name).info.frame0 \
    $topwin(util_name).info.frame0.frame1 {left frame center padx 10} \
    $topwin(util_name).info.frame0.frame0 {left frame center padx 10} \
    $topwin(util_name).info.frame0.frame2 {left frame center padx 10}

  # pack widget $topwin(util_name).info
  pack append $topwin(util_name).info \
    $topwin(util_name).info.frame3 {top frame center expand fillx} \
    $topwin(util_name).info.frame0 {top frame center expand fillx}

  # build widget $topwin(util_name).perform
  frame $topwin(util_name).perform \
    -background "$GuiColor(frame_bg)"   \
    -borderwidth {2} \
    -relief {raised}

  # build widget $topwin(util_name).perform.perform1
	button $topwin(util_name).perform.perform1 -padx {1} -pady {1} -highlightthickness {0}  \
    -foreground "$GuiColor(perf_fg)" \
    -background "$GuiColor(perf_bg)" \
	 -activebackground "$GuiColor(perf_act_bg)" \
    -command {
		$topwin(util_name) configure -cursor watch; update
		if {$util(img_name) == ""} {
			CvipAlert "Please give a name to the resulting image first."
			$topwin(util_name) configure -cursor top_left_arrow; update
			return
		}
		if [catch {expr $util(img_width)+$util(img_height)+$util(img_cenc)+$util(img_cenr)+$util(img_rad)}] {
			CvipAlert "Numerical values required for image parameters: \n Image width = $util(img_width), Image height= $util(img_height),\n Center column = $util(img_cenc), Center row = $util(img_cenr), Radius = $util(img_rad)"
			$topwin(util_name) configure -cursor top_left_arrow; update
			return
		} elseif { $util(img_width) < 0 || $util(img_height) < 0 || $util(img_cenc) <0 ||
						$util(img_cenr) < 0 || $util(img_rad) < 0} {
			CvipAlert "Positive values required for image parameters: \n Image width = $util(img_width), Image height= $util(img_height),\n Center column = $util(img_cenc), Center row = $util(img_cenr), Radius = $util(img_rad)"
			$topwin(util_name) configure -cursor top_left_arrow; update
			return
		} 

		if [catch {set result [cvip circle $util(img_width) $util(img_height) $util(img_cenc) $util(img_cenr) $util(img_rad)]} cresult] {
			CvipAlert "$cresult."
			$topwin(util_name) configure -cursor top_left_arrow; update
			return
		}
		set new_name [cvip rename $result $util(img_name)]
		img_q insert end $new_name
		image_post $new_name
		cvip view $new_name
		CvipMessage "circle image created"
	$topwin(util_name) configure -cursor top_left_arrow; update
	 } \
    -foreground {white} \
    -text {PERFORM}

  # build widget $topwin(util_name).perform.dismiss
	button $topwin(util_name).perform.dismiss -padx {1} -pady {1} -highlightthickness {0}  \
    -foreground "$GuiColor(dis_fg)" \
    -background "$GuiColor(dis_bg)" \
	 -activebackground "$GuiColor(dis_act_bg)" \
    -command {destroy $topwin(util_name); set topwin(util_name) NONE} \
    -text {DISMISS} \
    -width {10}

  # pack widget $topwin(util_name).perform
  pack append $topwin(util_name).perform \
    $topwin(util_name).perform.dismiss {left frame sw filly} \
    $topwin(util_name).perform.perform1 {right frame se filly}

  # build widget $topwin(util_name).current_image
  frame $topwin(util_name).current_image \
    -background "$GuiColor(frame_bg)"   \
    -borderwidth {2}

  # build widget $topwin(util_name).current_image.frame
  frame $topwin(util_name).current_image.frame \
    -background "$GuiColor(frame_bg)" 

  # build widget $topwin(util_name).current_image.frame.scrollbar1
  scrollbar $topwin(util_name).current_image.frame.scrollbar1 \
	 -activebackground "$GuiColor(btn_act_bg)" \
    -troughcolor "$GuiColor(btn_act_bg)" \
    -background "$GuiColor(btn_bg)" \
	 -highlightthickness {0}  \
    -command "$topwin(util_name).current_image.frame.entry2 xview" \
    -orient {horizontal} \
    -width {11}

  # build widget $topwin(util_name).current_image.frame.entry2
  entry $topwin(util_name).current_image.frame.entry2 \
    -background "$GuiColor(entry_bg)" \
	 -foreground "$GuiColor(entry_fg)" \
	 -highlightthickness {0} \
    -relief {sunken} \
 -xscrollcommand "$topwin(util_name).current_image.frame.scrollbar1 set" \
    -textvariable {util(img_name)} \
    -width {52}
  # bindings
  endEntry $topwin(util_name).current_image.frame.entry2 0\
    $topwin(util_name).info.frame3.frame1.value \
    $topwin(util_name).info.frame0.frame2.value 

  # pack widget $topwin(util_name).current_image.frame
  pack append $topwin(util_name).current_image.frame \
    $topwin(util_name).current_image.frame.entry2 {top frame center expand filly} \
    $topwin(util_name).current_image.frame.scrollbar1 {top frame center fillx}

  # build widget $topwin(util_name).current_image.label1
  label $topwin(util_name).current_image.label1 \
    -background "$GuiColor(label_bg)" \
    -borderwidth {0} \
    -relief {ridge} \
    -text {New Image name: }

  # pack widget $topwin(util_name).current_image
  pack append $topwin(util_name).current_image \
    $topwin(util_name).current_image.label1 {left frame center filly} \
    $topwin(util_name).current_image.frame {top frame center fillx}

  # pack widget $topwin(util_name)
  pack append $topwin(util_name) \
    $topwin(util_name).info {top frame center expand fill} \
    $topwin(util_name).perform {bottom frame center pady 5 fill} \
    $topwin(util_name).current_image {left frame center padx 10 filly}

  if {"[info procs XFEdit]" != ""} {
    catch "XFMiscBindWidgetTree $topwin(util_name)"
    after 2 "catch {XFEditSetShowWindows}"
  }
}

# procedure to show window $topwin(util_name)
proc util_wave { wave } {# xf ignore me 7
  global GuiColor
  global GuiMisc
  global GUI_DEBUG

  # Window manager configurations
  global tk_version
  global {util}
  global topwin
  global {temp}
  global toplevel_position
  set util(img_name) $wave
  if [ winfo exists $topwin(util_name).info] {
     set tempname $topwin(util_name);\
destroy $topwin(util_name).info;\
set topwin(util_name) $tempname;}
  if [ winfo exists $topwin(util_name).current_image] {
     set tempname $topwin(util_name);\
destroy $topwin(util_name).current_image;\
set topwin(util_name) $tempname;}
  if [ winfo exists $topwin(util_name).perform] {
     set tempname $topwin(util_name);\
destroy $topwin(util_name).perform;\
set topwin(util_name) $tempname;}
  wm positionfrom $topwin(util_name) user
  wm sizefrom $topwin(util_name) user

  wm geometry $topwin(util_name) $topwin(util_top)[get_pos $topwin(util_name)]
  wm maxsize $topwin(util_name) [lindex [split $topwin(util_top_max)] 0] \
  	[lindex [split $topwin(util_top_max)] 1]
  wm minsize $topwin(util_name) [lindex [split $topwin(util_top_min)] 0] \
  	[lindex [split $topwin(util_top_min)] 1]
  wm title $topwin(util_name) "UTILITIES -> Create -> $wave"

  switch -exact -- $wave {
  "Square wave" {set util(img_wave) square_wave; set util(img_name) Square_wave}
  "Cosine wave" {set util(img_wave) cosine_wave; set util(img_name) Cosine_wave}
  "Sine wave" {set util(img_wave) sine_wave; set util(img_name) Sine_wave}
  }

  # bindings
  bind $topwin(util_name) <Destroy> {set topwin(util_name) NONE}

  # build widget $topwin(util_name).info
  frame $topwin(util_name).info \
    -background "$GuiColor(frame_bg)"  \
    -borderwidth {2}

  # build widget $topwin(util_name).info.frame3
  frame $topwin(util_name).info.frame3 \
    -background "$GuiColor(frame_bg)" 

  # build widget $topwin(util_name).info.frame3.frame0
  frame $topwin(util_name).info.frame3.frame0 \
    -background "$GuiColor(frame_bg)"  \
    -borderwidth {2}

  # build widget $topwin(util_name).info.frame3.frame0.label1
  label $topwin(util_name).info.frame3.frame0.label1 \
    -background "$GuiColor(label_bg)" \
	 -width {17} \
    -borderwidth {0} \
    -text {Image width: }

  # build widget $topwin(util_name).info.frame3.frame0.value
  entry $topwin(util_name).info.frame3.frame0.value \
    -background "$GuiColor(entry_bg)" \
	 -foreground "$GuiColor(entry_fg)" \
	 -highlightthickness {0} \
    -relief {sunken} \
    -textvariable {util(img_width)} \
    -width {5}
  # bindings
  endEntry $topwin(util_name).info.frame3.frame0.value 0 \
    $topwin(util_name).info.frame0.frame0.value \
    $topwin(util_name).info.frame3.frame1.value 

  # build widget $topwin(util_name).info.frame3.frame0.menubutton2
	menubutton $topwin(util_name).info.frame3.frame0.menubutton2 -padx {1} -pady {1} -highlightthickness {0}  \
    -background "$GuiColor(btn_bg)" \
	 -activebackground "$GuiColor(btn_act_bg)" \
    -font "$GuiMisc(pop_up_fn)" \
	 -text "$GuiMisc(pop_up_text)" \
	 -relief "$GuiMisc(pop_up_relief)" \
	 -width {2}

  # bindings
  bind $topwin(util_name).info.frame3.frame0.menubutton2 <Button-1> {MenuPopupPost $topwin(util_name).info.frame3.frame0.menubutton2.menu %X %Y}
  bind $topwin(util_name).info.frame3.frame0.menubutton2 <ButtonRelease-1> {MenuPopupRelease $topwin(util_name).info.frame3.frame0.menubutton2.menu %W}

  # build widget $topwin(util_name).info.frame3.frame0.menubutton2.menu
  menu $topwin(util_name).info.frame3.frame0.menubutton2.menu \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" 
  $topwin(util_name).info.frame3.frame0.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set util(img_width) 16} \
    -label {  16}
  $topwin(util_name).info.frame3.frame0.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set util(img_width) 32} \
    -label {  32}
  $topwin(util_name).info.frame3.frame0.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set util(img_width) 64} \
    -label {  64}
  $topwin(util_name).info.frame3.frame0.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set util(img_width) 128} \
    -label { 128}
  $topwin(util_name).info.frame3.frame0.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set util(img_width) 256} \
    -label { 256}
  $topwin(util_name).info.frame3.frame0.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set util(img_width) 512} \
    -label { 512}
  $topwin(util_name).info.frame3.frame0.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set util(img_width) 1024} \
    -label {1024}
  bindtags $topwin(util_name).info.frame3.frame0.menubutton2.menu {Menu all}
  # bindings
  bind $topwin(util_name).info.frame3.frame0.menubutton2.menu <Button-1> {MenuPopupPost $topwin(util_name).info.frame3.frame0.menubutton2.menu %X %Y}
  bind $topwin(util_name).info.frame3.frame0.menubutton2.menu <ButtonRelease-1> {MenuPopupRelease $topwin(util_name).info.frame3.frame0.menubutton2.menu %W}

  # pack widget $topwin(util_name).info.frame3.frame0
  pack append $topwin(util_name).info.frame3.frame0 \
    $topwin(util_name).info.frame3.frame0.label1 {left frame e fill} \
    $topwin(util_name).info.frame3.frame0.value {left frame center expand fill} \
    $topwin(util_name).info.frame3.frame0.menubutton2 {right frame center fill}

  # build widget $topwin(util_name).info.frame3.frame1
  frame $topwin(util_name).info.frame3.frame1 \
    -background "$GuiColor(frame_bg)"  \
    -borderwidth {2}

  # build widget $topwin(util_name).info.frame3.frame1.label1
  label $topwin(util_name).info.frame3.frame1.label1 \
    -background "$GuiColor(label_bg)" \
	 -width {17} \
    -borderwidth {0} \
    -text {Image height: }

  # build widget $topwin(util_name).info.frame3.frame1.value
  entry $topwin(util_name).info.frame3.frame1.value \
    -background "$GuiColor(entry_bg)" \
	 -foreground "$GuiColor(entry_fg)" \
	 -highlightthickness {0} \
    -relief {sunken} \
    -textvariable {util(img_height)} \
    -width {5}
  # bindings
  endEntry $topwin(util_name).info.frame3.frame1.value 0\
    $topwin(util_name).info.frame3.frame0.value \
    $topwin(util_name).current_image.frame.entry2 

  # build widget $topwin(util_name).info.frame3.frame1.menubutton2
	menubutton $topwin(util_name).info.frame3.frame1.menubutton2 -padx {1} -pady {1} -highlightthickness {0}  \
    -background "$GuiColor(btn_bg)" \
	 -activebackground "$GuiColor(btn_act_bg)" \
    -font "$GuiMisc(pop_up_fn)" \
	 -text "$GuiMisc(pop_up_text)" \
	 -relief "$GuiMisc(pop_up_relief)" \
	 -width {2}

  # bindings
  bind $topwin(util_name).info.frame3.frame1.menubutton2 <Button-1> {MenuPopupPost $topwin(util_name).info.frame3.frame1.menubutton2.menu %X %Y}
  bind $topwin(util_name).info.frame3.frame1.menubutton2 <ButtonRelease-1> {MenuPopupRelease $topwin(util_name).info.frame3.frame1.menubutton2.menu %W}

  # build widget $topwin(util_name).info.frame3.frame1.menubutton2.menu
  menu $topwin(util_name).info.frame3.frame1.menubutton2.menu \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" 
  $topwin(util_name).info.frame3.frame1.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set util(img_height) 16} \
    -label {  16}
  $topwin(util_name).info.frame3.frame1.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set util(img_height) 32} \
    -label {  32}
  $topwin(util_name).info.frame3.frame1.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set util(img_height) 64} \
    -label {  64}
  $topwin(util_name).info.frame3.frame1.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set util(img_height) 128} \
    -label { 128}
  $topwin(util_name).info.frame3.frame1.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set util(img_height) 256} \
    -label { 256}
  $topwin(util_name).info.frame3.frame1.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set util(img_height) 512} \
    -label { 512}
  $topwin(util_name).info.frame3.frame1.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set util(img_height) 1024} \
    -label {1024}
  bindtags $topwin(util_name).info.frame3.frame1.menubutton2.menu {Menu all}
  # bindings
  bind $topwin(util_name).info.frame3.frame1.menubutton2.menu <Button-1> {MenuPopupPost $topwin(util_name).info.frame3.frame1.menubutton2.menu %X %Y}
  bind $topwin(util_name).info.frame3.frame1.menubutton2.menu <ButtonRelease-1> {MenuPopupRelease $topwin(util_name).info.frame3.frame1.menubutton2.menu %W}

  # pack widget $topwin(util_name).info.frame3.frame1
  pack append $topwin(util_name).info.frame3.frame1 \
    $topwin(util_name).info.frame3.frame1.label1 {left frame e fill} \
    $topwin(util_name).info.frame3.frame1.value {left frame center expand fill} \
    $topwin(util_name).info.frame3.frame1.menubutton2 {right frame center fill}

  # pack widget $topwin(util_name).info.frame3
  pack append $topwin(util_name).info.frame3 \
    $topwin(util_name).info.frame3.frame1 {left frame center } \
    $topwin(util_name).info.frame3.frame0 {left frame center }

  # build widget $topwin(util_name).info.frame0
  frame $topwin(util_name).info.frame0 \
    -background "$GuiColor(frame_bg)"  

  # build widget $topwin(util_name).info.frame0.frame0
  frame $topwin(util_name).info.frame0.frame0 \
    -background "$GuiColor(frame_bg)"   \
    -borderwidth {2}

  # build widget $topwin(util_name).info.frame0.frame0.label1
  label $topwin(util_name).info.frame0.frame0.label1 \
    -background "$GuiColor(label_bg)" \
	 -width {17} \
    -borderwidth {0} \
    -text {Frequency: }

  # build widget $topwin(util_name).info.frame0.frame0.value
  entry $topwin(util_name).info.frame0.frame0.value \
    -background "$GuiColor(entry_bg)" \
	 -foreground "$GuiColor(entry_fg)" \
	 -highlightthickness {0} \
    -relief {sunken} \
    -textvariable {util(img_freq)} \
    -width {5}
  # bindings
  endEntry $topwin(util_name).info.frame0.frame0.value 0\
    $topwin(util_name).current_image.frame.entry2 \
    $topwin(util_name).info.frame3.frame0.value

  # build widget $topwin(util_name).info.frame0.frame0.menubutton2
	menubutton $topwin(util_name).info.frame0.frame0.menubutton2 -padx {1} -pady {1} -highlightthickness {0}  \
    -background "$GuiColor(btn_bg)" \
	 -activebackground "$GuiColor(btn_act_bg)" \
    -font "$GuiMisc(pop_up_fn)" \
	 -text "$GuiMisc(pop_up_text)" \
	 -relief "$GuiMisc(pop_up_relief)" \
	 -width {2}

  # bindings
  bind $topwin(util_name).info.frame0.frame0.menubutton2 <Button-1> {MenuPopupPost $topwin(util_name).info.frame0.frame0.menubutton2.menu %X %Y}
  bind $topwin(util_name).info.frame0.frame0.menubutton2 <ButtonRelease-1> {MenuPopupRelease $topwin(util_name).info.frame0.frame0.menubutton2.menu %W}

  # build widget $topwin(util_name).info.frame0.frame0.menubutton2.menu
  menu $topwin(util_name).info.frame0.frame0.menubutton2.menu \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" 
  $topwin(util_name).info.frame0.frame0.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set util(img_freq) 8} \
    -label {   8}
  $topwin(util_name).info.frame0.frame0.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set util(img_freq) 16} \
    -label {  16}
  $topwin(util_name).info.frame0.frame0.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set util(img_freq) 32} \
    -label {  32}
  $topwin(util_name).info.frame0.frame0.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set util(img_freq) 64} \
    -label {  64}
  $topwin(util_name).info.frame0.frame0.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set util(img_freq) 128} \
    -label { 128}
  $topwin(util_name).info.frame0.frame0.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set util(img_freq) 256} \
    -label { 256}
  bindtags $topwin(util_name).info.frame0.frame0.menubutton2.menu {Menu all}
  # bindings
  bind $topwin(util_name).info.frame0.frame0.menubutton2.menu <Button-1> {MenuPopupPost $topwin(util_name).info.frame0.frame0.menubutton2.menu %X %Y}
  bind $topwin(util_name).info.frame0.frame0.menubutton2.menu <ButtonRelease-1> {MenuPopupRelease $topwin(util_name).info.frame0.frame0.menubutton2.menu %W}

  # pack widget $topwin(util_name).info.frame0.frame0
  pack append $topwin(util_name).info.frame0.frame0 \
    $topwin(util_name).info.frame0.frame0.label1 {left frame e fill} \
    $topwin(util_name).info.frame0.frame0.value {left frame center expand fill} \
    $topwin(util_name).info.frame0.frame0.menubutton2 {right frame center fill}

  # build widget $topwin(util_name).info.frame0.frame1
  frame $topwin(util_name).info.frame0.frame1 \
    -background "$GuiColor(frame_bg)"   \
    -borderwidth {2}

  # build widget $topwin(util_name).info.frame0.frame1.label1
  label $topwin(util_name).info.frame0.frame1.label1 \
    -background "$GuiColor(label_bg)" \
	 -width {17} \
    -borderwidth {0} \
    -text {Direction: }

  # build widget $topwin(util_name).info.frame0.frame1.value
  entry $topwin(util_name).info.frame0.frame1.value \
    -background "$GuiColor(rentry_bg)" \
	 -foreground "$GuiColor(rentry_fg)" \
	 -highlightthickness {0} \
    -relief {sunken} \
    -textvariable {util(img_dir)} \
	 -state {disabled} \
    -width {5}
  # bindings
  endEntry $topwin(util_name).info.frame0.frame1.value 0 \
    $topwin(util_name).info.frame0.frame0.value \
    $topwin(util_name).info.frame3.frame0.value 

  # build widget $topwin(util_name).info.frame0.frame1.menubutton2
	menubutton $topwin(util_name).info.frame0.frame1.menubutton2 -padx {1} -pady {1} -highlightthickness {0}  \
    -background "$GuiColor(btn_bg)" \
	 -activebackground "$GuiColor(btn_act_bg)" \
    -font "$GuiMisc(pop_up_fn)" \
	 -text "$GuiMisc(pop_up_text)" \
	 -relief "$GuiMisc(pop_up_relief)" \
	 -width {2}

  # bindings
  bind $topwin(util_name).info.frame0.frame1.menubutton2 <Button-1> {MenuPopupPost $topwin(util_name).info.frame0.frame1.menubutton2.menu %X %Y}
  bind $topwin(util_name).info.frame0.frame1.menubutton2 <ButtonRelease-1> {MenuPopupRelease $topwin(util_name).info.frame0.frame1.menubutton2.menu %W}

  # build widget $topwin(util_name).info.frame0.frame1.menubutton2.menu
  menu $topwin(util_name).info.frame0.frame1.menubutton2.menu \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" 
  $topwin(util_name).info.frame0.frame1.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set util(img_dir) horz} \
    -label {Horizontal}
  $topwin(util_name).info.frame0.frame1.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set util(img_dir) vert} \
    -label {Vertical}
  bindtags $topwin(util_name).info.frame0.frame1.menubutton2.menu {Menu all}
  # bindings
  bind $topwin(util_name).info.frame0.frame1.menubutton2.menu <Button-1> {MenuPopupPost $topwin(util_name).info.frame0.frame1.menubutton2.menu %X %Y}
  bind $topwin(util_name).info.frame0.frame1.menubutton2.menu <ButtonRelease-1> {MenuPopupRelease $topwin(util_name).info.frame0.frame1.menubutton2.menu %W}

  # pack widget $topwin(util_name).info.frame0.frame1
  pack append $topwin(util_name).info.frame0.frame1 \
    $topwin(util_name).info.frame0.frame1.label1 {left frame e fill} \
    $topwin(util_name).info.frame0.frame1.value {left frame center expand fill} \
    $topwin(util_name).info.frame0.frame1.menubutton2 {right frame center fill}

  # pack widget $topwin(util_name).info.frame0
  pack append $topwin(util_name).info.frame0 \
    $topwin(util_name).info.frame0.frame0 {left frame center } \
    $topwin(util_name).info.frame0.frame1 {left frame center }

  # pack widget $topwin(util_name).info
  pack append $topwin(util_name).info \
    $topwin(util_name).info.frame3 {top frame center expand fillx} \
    $topwin(util_name).info.frame0 {top frame center expand fillx}

  # build widget $topwin(util_name).perform
  frame $topwin(util_name).perform \
    -background "$GuiColor(frame_bg)"   \
    -borderwidth {2} \
    -relief {raised}

  # build widget $topwin(util_name).perform.perform1
	button $topwin(util_name).perform.perform1 -padx {1} -pady {1} -highlightthickness {0}  \
    -foreground "$GuiColor(perf_fg)" \
    -background "$GuiColor(perf_bg)" \
	 -activebackground "$GuiColor(perf_act_bg)" \
    -command {
		$topwin(util_name) configure -cursor watch; update
		if {$util(img_name) == ""} {
			CvipAlert "Please give a name to the resulting image first."
			$topwin(util_name) configure -cursor top_left_arrow; update
			return
		}
		if [catch {expr $util(img_width)+$util(img_height)+$util(img_freq)}] {
			CvipAlert "Numerical values required for image parameters: \n Image width = $util(img_width), Image height= $util(img_height),\n Wave direction = $util(img_dir), Wave frequency = $util(img_freq)"
			$topwin(util_name) configure -cursor top_left_arrow; update
			return
		} elseif { $util(img_width) < 0 || $util(img_height) < 0 || $util(img_freq) <0 } {
			CvipAlert "Positive values required for image parameters: \n Image width = $util(img_width), Image height= $util(img_height), Frequency  = $util(img_freq)"
			$topwin(util_name) configure -cursor top_left_arrow; update
			return
		} 

		if {$util(img_width) > $util(img_height)} {
			set temp $util(img_width)
		} else {
			set temp $util(img_height)
		}
		if {$util(img_dir) == "horz"} {
			set temp1 "1"
		} else {
			set temp1 "2"
		}
		if [catch {set result [cvip $util(img_wave) $temp $temp1 $util(img_freq)]} cresult] {
			CvipAlert "$cresult."
			$topwin(util_name) configure -cursor top_left_arrow; update
			return
		}
		if {$util(img_width) != $util(img_height)} {
			set temp $result
			set result [cvip crop $temp 0 0 $util(img_height) $util(img_width)]
			cvip dq $temp
		}
		set new_name [cvip rename $result $util(img_name)]
		img_q insert end $new_name
		image_post $new_name
		cvip view $new_name
		CvipMessage "$util(img_wave) image created"
	$topwin(util_name) configure -cursor top_left_arrow; update
	 } \
    -text {PERFORM}

  # build widget $topwin(util_name).perform.dismiss
	button $topwin(util_name).perform.dismiss -padx {1} -pady {1} -highlightthickness {0}  \
    -foreground "$GuiColor(dis_fg)" \
    -background "$GuiColor(dis_bg)" \
	 -activebackground "$GuiColor(dis_act_bg)" \
    -command {destroy $topwin(util_name); set topwin(util_name) NONE} \
    -text {DISMISS} \
    -width {10}

  # pack widget $topwin(util_name).perform
  pack append $topwin(util_name).perform \
    $topwin(util_name).perform.dismiss {left frame sw filly} \
    $topwin(util_name).perform.perform1 {right frame se filly}

  # build widget $topwin(util_name).current_image
  frame $topwin(util_name).current_image \
    -background "$GuiColor(frame_bg)"  \
    -borderwidth {2}

  # build widget $topwin(util_name).current_image.frame
  frame $topwin(util_name).current_image.frame \
    -background "$GuiColor(frame_bg)"  

  # build widget $topwin(util_name).current_image.frame.scrollbar1
  scrollbar $topwin(util_name).current_image.frame.scrollbar1 \
	 -activebackground "$GuiColor(btn_act_bg)" \
    -troughcolor "$GuiColor(btn_act_bg)" \
    -background "$GuiColor(btn_bg)" \
	 -highlightthickness {0}  \
    -command "$topwin(util_name).current_image.frame.entry2 xview" \
    -orient {horizontal} \
    -width {11}

  # build widget $topwin(util_name).current_image.frame.entry2
  entry $topwin(util_name).current_image.frame.entry2 \
    -background "$GuiColor(entry_bg)" \
	 -foreground "$GuiColor(entry_fg)" \
	 -highlightthickness {0} \
    -relief {sunken} \
 -xscrollcommand "$topwin(util_name).current_image.frame.scrollbar1 set" \
    -textvariable {util(img_name)} \
    -width {52}
  # bindings
  endEntry $topwin(util_name).current_image.frame.entry2 0\
    $topwin(util_name).info.frame3.frame1.value \
    $topwin(util_name).info.frame0.frame0.value 

  # pack widget $topwin(util_name).current_image.frame
  pack append $topwin(util_name).current_image.frame \
    $topwin(util_name).current_image.frame.entry2 {top frame center expand filly} \
    $topwin(util_name).current_image.frame.scrollbar1 {top frame center fillx}

  # build widget $topwin(util_name).current_image.label1
  label $topwin(util_name).current_image.label1 \
    -background "$GuiColor(label_bg)" \
    -borderwidth {0} \
    -relief {ridge} \
    -text {New Image name: }

  # pack widget $topwin(util_name).current_image
  pack append $topwin(util_name).current_image \
    $topwin(util_name).current_image.label1 {left frame center filly} \
    $topwin(util_name).current_image.frame {top frame center fillx}

  # pack widget $topwin(util_name)
  pack append $topwin(util_name) \
    $topwin(util_name).info {top frame center expand fill} \
    $topwin(util_name).perform {bottom frame center pady 5 fill} \
    $topwin(util_name).current_image {left frame center padx 10 filly}

  if {"[info procs XFEdit]" != ""} {
    catch "XFMiscBindWidgetTree $topwin(util_name)"
    after 2 "catch {XFEditSetShowWindows}"
  }
}


# procedure to show window $topwin(util_name)
proc util_box { box } {# xf ignore me 7

  # Window manager configurations
  global tk_version
  global {util}
  global GuiColor
  global GuiMisc
  global GUI_DEBUG

  set util(img_name) $box
  global {topwin}
  global toplevel_position
  if [ winfo exists $topwin(util_name).info] {
     set tempname $topwin(util_name);\
destroy $topwin(util_name).info;\
set topwin(util_name) $tempname;}
  if [ winfo exists $topwin(util_name).current_image] {
     set tempname $topwin(util_name);\
destroy $topwin(util_name).current_image;\
set topwin(util_name) $tempname;}
  if [ winfo exists $topwin(util_name).perform] {
     set tempname $topwin(util_name);\
destroy $topwin(util_name).perform;\
set topwin(util_name) $tempname;}
  wm positionfrom $topwin(util_name) user
  wm sizefrom $topwin(util_name) user

  wm geometry $topwin(util_name) $topwin(util_top)[get_pos $topwin(util_name)]
  wm maxsize $topwin(util_name) [lindex [split $topwin(util_top_max)] 0] \
  	[lindex [split $topwin(util_top_max)] 1]
  wm minsize $topwin(util_name) [lindex [split $topwin(util_top_min)] 0] \
  	[lindex [split $topwin(util_top_min)] 1]
  wm title $topwin(util_name) "UTILITIES -> Create -> $box"

  switch -exact -- $box {
  Checkerboard	{set util(img_box) create_checkboard}
  Rectangle		{set util(img_box) rectangle}
  Line			{set util(img_box) line}
  }

  # bindings
  bind $topwin(util_name) <Destroy> {set topwin(util_name) NONE}

  # build widget $topwin(util_name).info
  frame $topwin(util_name).info \
  -highlightthickness {0}  \
    -background "$GuiColor(frame_bg)"  \
    -borderwidth {2}

  # build widget $topwin(util_name).info.frame3
  frame $topwin(util_name).info.frame3 \
  -highlightthickness {0}  \
    -background "$GuiColor(frame_bg)" 

  # build widget $topwin(util_name).info.frame3.frame0
  frame $topwin(util_name).info.frame3.frame0 \
  -highlightthickness {0}  \
    -background "$GuiColor(frame_bg)"  \
    -borderwidth {2}

  # build widget $topwin(util_name).info.frame3.frame0.label1
  label $topwin(util_name).info.frame3.frame0.label1 \
    -anchor {e} \
    -background "$GuiColor(label_bg)" \
    -borderwidth {0} \
    -text {Image width: } \
    -width {17}

  # build widget $topwin(util_name).info.frame3.frame0.value
  entry $topwin(util_name).info.frame3.frame0.value \
    -background "$GuiColor(entry_bg)" \
	 -foreground "$GuiColor(entry_fg)" \
    -highlightthickness {0} \
    -relief {sunken} \
    -textvariable {util(img_width)} \
    -width {5}
  # bindings
  endEntry $topwin(util_name).info.frame3.frame0.value 0\
    $topwin(util_name).info.frame0.frame1.value \
    $topwin(util_name).info.frame3.frame1.value 

  # build widget $topwin(util_name).info.frame3.frame0.menubutton2
	menubutton $topwin(util_name).info.frame3.frame0.menubutton2 -padx {1} -pady {1} -highlightthickness {0}  \
    -background "$GuiColor(btn_bg)" \
	 -activebackground "$GuiColor(btn_act_bg)" \
    -font "$GuiMisc(pop_up_fn)" \
	 -text "$GuiMisc(pop_up_text)" \
	 -relief "$GuiMisc(pop_up_relief)" \
	 -width {2}

  # bindings
  bind $topwin(util_name).info.frame3.frame0.menubutton2 <Button-1> {MenuPopupPost $topwin(util_name).info.frame3.frame0.menubutton2.menu %X %Y}
  bind $topwin(util_name).info.frame3.frame0.menubutton2 <ButtonRelease-1> {MenuPopupRelease $topwin(util_name).info.frame3.frame0.menubutton2.menu %W}

  # build widget $topwin(util_name).info.frame3.frame0.menubutton2.menu
  menu $topwin(util_name).info.frame3.frame0.menubutton2.menu \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" 
  $topwin(util_name).info.frame3.frame0.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set util(img_width) 16} \
    -label {  16}
  $topwin(util_name).info.frame3.frame0.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set util(img_width) 32} \
    -label {  32}
  $topwin(util_name).info.frame3.frame0.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set util(img_width) 64} \
    -label {  64}
  $topwin(util_name).info.frame3.frame0.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set util(img_width) 128} \
    -label { 128}
  $topwin(util_name).info.frame3.frame0.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set util(img_width) 256} \
    -label { 256}
  $topwin(util_name).info.frame3.frame0.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set util(img_width) 512} \
    -label { 512}
  $topwin(util_name).info.frame3.frame0.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set util(img_width) 1024} \
    -label {1024}
  bindtags $topwin(util_name).info.frame3.frame0.menubutton2.menu {Menu all}
  # bindings
  bind $topwin(util_name).info.frame3.frame0.menubutton2.menu <Button-1> {MenuPopupPost $topwin(util_name).info.frame3.frame0.menubutton2.menu %X %Y}
  bind $topwin(util_name).info.frame3.frame0.menubutton2.menu <ButtonRelease-1> {MenuPopupRelease $topwin(util_name).info.frame3.frame0.menubutton2.menu %W}

  # pack widget $topwin(util_name).info.frame3.frame0
  pack append $topwin(util_name).info.frame3.frame0 \
    $topwin(util_name).info.frame3.frame0.label1 {left frame center fill} \
    $topwin(util_name).info.frame3.frame0.value {left frame center expand fill} \
    $topwin(util_name).info.frame3.frame0.menubutton2 {right frame center fill}

  # build widget $topwin(util_name).info.frame3.frame1
  frame $topwin(util_name).info.frame3.frame1 \
  -highlightthickness {0}  \
    -background "$GuiColor(frame_bg)"  \
    -borderwidth {2}

  # build widget $topwin(util_name).info.frame3.frame1.label1
  label $topwin(util_name).info.frame3.frame1.label1 \
    -anchor {e} \
    -background "$GuiColor(label_bg)" \
    -borderwidth {0} \
    -text {Image height: } \
    -width {17}

  # build widget $topwin(util_name).info.frame3.frame1.value
  entry $topwin(util_name).info.frame3.frame1.value \
    -background "$GuiColor(entry_bg)" \
	 -foreground "$GuiColor(entry_fg)" \
	 -highlightthickness {0} \
    -relief {sunken} \
    -textvariable {util(img_height)} \
    -width {5}
  # bindings
  endEntry $topwin(util_name).info.frame3.frame1.value 0\
    $topwin(util_name).info.frame3.frame0.value \
    $topwin(util_name).current_image.frame.entry2 

  # build widget $topwin(util_name).info.frame3.frame1.menubutton2
	menubutton $topwin(util_name).info.frame3.frame1.menubutton2 -padx {1} -pady {1} -highlightthickness {0}  \
    -background "$GuiColor(btn_bg)" \
	 -activebackground "$GuiColor(btn_act_bg)" \
    -font "$GuiMisc(pop_up_fn)" \
	 -text "$GuiMisc(pop_up_text)" \
	 -relief "$GuiMisc(pop_up_relief)" \
	 -width {2}

  # bindings
  bind $topwin(util_name).info.frame3.frame1.menubutton2 <Button-1> {MenuPopupPost $topwin(util_name).info.frame3.frame1.menubutton2.menu %X %Y}
  bind $topwin(util_name).info.frame3.frame1.menubutton2 <ButtonRelease-1> {MenuPopupRelease $topwin(util_name).info.frame3.frame1.menubutton2.menu %W}

  # build widget $topwin(util_name).info.frame3.frame1.menubutton2.menu
  menu $topwin(util_name).info.frame3.frame1.menubutton2.menu \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" 
  $topwin(util_name).info.frame3.frame1.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set util(img_height) 16} \
    -label {  16}
  $topwin(util_name).info.frame3.frame1.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set util(img_height) 32} \
    -label {  32}
  $topwin(util_name).info.frame3.frame1.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set util(img_height) 64} \
    -label {  64}
  $topwin(util_name).info.frame3.frame1.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set util(img_height) 128} \
    -label { 128}
  $topwin(util_name).info.frame3.frame1.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set util(img_height) 256} \
    -label { 256}
  $topwin(util_name).info.frame3.frame1.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set util(img_height) 512} \
    -label { 512}
  $topwin(util_name).info.frame3.frame1.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set util(img_height) 1024} \
    -label {1024}
  bindtags $topwin(util_name).info.frame3.frame1.menubutton2.menu  {Menu all}
  # bindings
  bind $topwin(util_name).info.frame3.frame1.menubutton2.menu <Button-1> {MenuPopupPost $topwin(util_name).info.frame3.frame1.menubutton2.menu %X %Y}
  bind $topwin(util_name).info.frame3.frame1.menubutton2.menu <ButtonRelease-1> {MenuPopupRelease $topwin(util_name).info.frame3.frame1.menubutton2.menu %W}

  # pack widget $topwin(util_name).info.frame3.frame1
  pack append $topwin(util_name).info.frame3.frame1 \
    $topwin(util_name).info.frame3.frame1.label1 {left frame center fill} \
    $topwin(util_name).info.frame3.frame1.value {left frame center expand fill} \
    $topwin(util_name).info.frame3.frame1.menubutton2 {right frame center fill}

  # pack widget $topwin(util_name).info.frame3
  pack append $topwin(util_name).info.frame3 \
    $topwin(util_name).info.frame3.frame1 {left frame center padx 10} \
    $topwin(util_name).info.frame3.frame0 {left frame center padx 10}

  # build widget $topwin(util_name).info.frame0
  frame $topwin(util_name).info.frame0 \
  -highlightthickness {0}  \
    -background "$GuiColor(frame_bg)" 

  # build widget $topwin(util_name).info.frame0.frame0
  frame $topwin(util_name).info.frame0.frame0 \
  -highlightthickness {0}  \
    -background "$GuiColor(frame_bg)" \
    -borderwidth {2}

  # build widget $topwin(util_name).info.frame0.frame0.label1
  label $topwin(util_name).info.frame0.frame0.label1 \
    -anchor {e} \
    -background "$GuiColor(label_bg)" \
    -borderwidth {0} \
    -text { Col: } \
    -width {17}

  # build widget $topwin(util_name).info.frame0.frame0.value
  entry $topwin(util_name).info.frame0.frame0.value \
  -highlightthickness {0}  \
    -background "$GuiColor(entry_bg)" \
	 -foreground "$GuiColor(entry_fg)" \
    -relief {sunken} \
    -textvariable {util(img_strtc)} \
    -width {5}
  # bindings
  endEntry $topwin(util_name).info.frame0.frame0.value 0 \
  	 $topwin(util_name).info.frame4.frame1.value \
  	 $topwin(util_name).info.frame0.frame1.value 

  # build widget $topwin(util_name).info.frame0.frame0.menubutton2
	menubutton $topwin(util_name).info.frame0.frame0.menubutton2 -padx {1} -pady {1} -highlightthickness {0}  \
    -background "$GuiColor(btn_bg)" \
	 -activebackground "$GuiColor(btn_act_bg)" \
    -font "$GuiMisc(pop_up_fn)" \
	 -text "$GuiMisc(pop_up_text)" \
	 -relief "$GuiMisc(pop_up_relief)" \
	 -width {2}

  # bindings
  bind $topwin(util_name).info.frame0.frame0.menubutton2 <Button-1> {MenuPopupPost $topwin(util_name).info.frame0.frame0.menubutton2.menu %X %Y}
  bind $topwin(util_name).info.frame0.frame0.menubutton2 <ButtonRelease-1> {MenuPopupRelease $topwin(util_name).info.frame0.frame0.menubutton2.menu %W}

  # build widget $topwin(util_name).info.frame0.frame0.menubutton2.menu
  menu $topwin(util_name).info.frame0.frame0.menubutton2.menu \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" 
  $topwin(util_name).info.frame0.frame0.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set util(img_strtc) 0} \
    -label {   0}
  $topwin(util_name).info.frame0.frame0.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set util(img_strtc) 8} \
    -label {   8}
  $topwin(util_name).info.frame0.frame0.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set util(img_strtc) 16} \
    -label {  16}
  $topwin(util_name).info.frame0.frame0.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set util(img_strtc) 32} \
    -label {  32}
  $topwin(util_name).info.frame0.frame0.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set util(img_strtc) 64} \
    -label {  64}
  $topwin(util_name).info.frame0.frame0.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set util(img_strtc) 128} \
    -label { 128}
  $topwin(util_name).info.frame0.frame0.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set util(img_strtc) 256} \
    -label { 256}
  bindtags $topwin(util_name).info.frame0.frame0.menubutton2.menu  {Menu all}
  # bindings
  bind $topwin(util_name).info.frame0.frame0.menubutton2.menu <Button-1> {MenuPopupPost $topwin(util_name).info.frame0.frame0.menubutton2.menu %X %Y}
  bind $topwin(util_name).info.frame0.frame0.menubutton2.menu <ButtonRelease-1> {MenuPopupRelease $topwin(util_name).info.frame0.frame0.menubutton2.menu %W}

  # pack widget $topwin(util_name).info.frame0.frame0
  pack append $topwin(util_name).info.frame0.frame0 \
    $topwin(util_name).info.frame0.frame0.label1 {left frame center fill} \
    $topwin(util_name).info.frame0.frame0.value {left frame center expand fill} \
    $topwin(util_name).info.frame0.frame0.menubutton2 {right frame center fill}

  # build widget $topwin(util_name).info.frame0.frame1
  frame $topwin(util_name).info.frame0.frame1 \
  -highlightthickness {0}  \
    -background "$GuiColor(frame_bg)" \
    -borderwidth {2}

  # build widget $topwin(util_name).info.frame0.frame1.label1
  label $topwin(util_name).info.frame0.frame1.label1 \
    -anchor {e} \
    -background "$GuiColor(label_bg)" \
    -borderwidth {0} \
    -text {Starting from  Row: } \
    -width {17}

  # build widget $topwin(util_name).info.frame0.frame1.value
  entry $topwin(util_name).info.frame0.frame1.value \
  -highlightthickness {0}  \
    -background "$GuiColor(entry_bg)" \
	 -foreground "$GuiColor(entry_fg)" \
    -relief {sunken} \
    -textvariable {util(img_strtr)} \
    -width {5}
  # bindings
  endEntry $topwin(util_name).info.frame0.frame1.value 0\
    $topwin(util_name).info.frame0.frame0.value \
    $topwin(util_name).info.frame3.frame0.value 

  # build widget $topwin(util_name).info.frame0.frame1.menubutton2
	menubutton $topwin(util_name).info.frame0.frame1.menubutton2 -padx {1} -pady {1} -highlightthickness {0}  \
    -background "$GuiColor(btn_bg)" \
	 -activebackground "$GuiColor(btn_act_bg)" \
    -font "$GuiMisc(pop_up_fn)" \
	 -text "$GuiMisc(pop_up_text)" \
	 -relief "$GuiMisc(pop_up_relief)" \
	 -width {2}

  # bindings
  bind $topwin(util_name).info.frame0.frame1.menubutton2 <Button-1> {MenuPopupPost $topwin(util_name).info.frame0.frame1.menubutton2.menu %X %Y}
  bind $topwin(util_name).info.frame0.frame1.menubutton2 <ButtonRelease-1> {MenuPopupRelease $topwin(util_name).info.frame0.frame1.menubutton2.menu %W}

  # build widget $topwin(util_name).info.frame0.frame1.menubutton2.menu
  menu $topwin(util_name).info.frame0.frame1.menubutton2.menu \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" 
  $topwin(util_name).info.frame0.frame1.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set util(img_strtr) 0} \
    -label {   0}
  $topwin(util_name).info.frame0.frame1.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set util(img_strtr) 8} \
    -label {   8}
  $topwin(util_name).info.frame0.frame1.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set util(img_strtr) 16} \
    -label {  16}
  $topwin(util_name).info.frame0.frame1.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set util(img_strtr) 32} \
    -label {  32}
  $topwin(util_name).info.frame0.frame1.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set util(img_strtr) 64} \
    -label {  64}
  $topwin(util_name).info.frame0.frame1.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set util(img_strtr) 128} \
    -label { 128}
  $topwin(util_name).info.frame0.frame1.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set util(img_strtr) 256} \
    -label { 256}
  bindtags $topwin(util_name).info.frame0.frame1.menubutton2.menu {Menu all}
  # bindings
  bind $topwin(util_name).info.frame0.frame1.menubutton2.menu <Button-1> {MenuPopupPost $topwin(util_name).info.frame0.frame1.menubutton2.menu %X %Y}
  bind $topwin(util_name).info.frame0.frame1.menubutton2.menu <ButtonRelease-1> {MenuPopupRelease $topwin(util_name).info.frame0.frame1.menubutton2.menu %W}

  # pack widget $topwin(util_name).info.frame0.frame1
  pack append $topwin(util_name).info.frame0.frame1 \
    $topwin(util_name).info.frame0.frame1.label1 {left frame center fill} \
    $topwin(util_name).info.frame0.frame1.value {left frame center expand fill} \
    $topwin(util_name).info.frame0.frame1.menubutton2 {right frame center fill}

  # pack widget $topwin(util_name).info.frame0
  pack append $topwin(util_name).info.frame0 \
    $topwin(util_name).info.frame0.frame1 {left frame center padx 10} \
    $topwin(util_name).info.frame0.frame0 {left frame center padx 10}

  # build widget $topwin(util_name).info.frame4
  frame $topwin(util_name).info.frame4 \
  -highlightthickness {0}  \
    -background "$GuiColor(frame_bg)"

  # build widget $topwin(util_name).info.frame4.frame0
  frame $topwin(util_name).info.frame4.frame0 \
  -highlightthickness {0}  \
    -background "$GuiColor(frame_bg)"\
    -borderwidth {2}

  # build widget $topwin(util_name).info.frame4.frame0.label1
  label $topwin(util_name).info.frame4.frame0.label1 \
    -anchor {e} \
    -background "$GuiColor(label_bg)" \
    -borderwidth {0} \
    -text { Col: } \
    -width {17}
  if {$util(img_box) == "create_checkboard"} {
	  $topwin(util_name).info.frame4.frame0.label1 configure -text "Cell width: "
  } else {
	  $topwin(util_name).info.frame4.frame0.label1 configure -text "To Col: "
  }

  # build widget $topwin(util_name).info.frame4.frame0.value
  entry $topwin(util_name).info.frame4.frame0.value \
  -highlightthickness {0}  \
    -background "$GuiColor(entry_bg)" \
	 -foreground "$GuiColor(entry_fg)" \
    -relief {sunken} \
    -textvariable {util(img_endc)} \
    -width {5}
  # bindings
  endEntry $topwin(util_name).info.frame4.frame0.value 0\
    $topwin(util_name).current_image.frame.entry2 \
  	 $topwin(util_name).info.frame4.frame1.value

  if {$util(img_box) == "create_checkboard" } {
  $topwin(util_name).info.frame4.frame0.value configure -textvariable {util(img_celw)}
  }

  # build widget $topwin(util_name).info.frame4.frame0.menubutton2
	menubutton $topwin(util_name).info.frame4.frame0.menubutton2 -padx {1} -pady {1} -highlightthickness {0}  \
    -background "$GuiColor(btn_bg)" \
	 -activebackground "$GuiColor(btn_act_bg)" \
    -font "$GuiMisc(pop_up_fn)" \
	 -text "$GuiMisc(pop_up_text)" \
	 -relief "$GuiMisc(pop_up_relief)" \
	 -width {2}

  # bindings
  bind $topwin(util_name).info.frame4.frame0.menubutton2 <Button-1> {MenuPopupPost $topwin(util_name).info.frame4.frame0.menubutton2.menu %X %Y}
  bind $topwin(util_name).info.frame4.frame0.menubutton2 <ButtonRelease-1> {MenuPopupRelease $topwin(util_name).info.frame4.frame0.menubutton2.menu %W}

  # build widget $topwin(util_name).info.frame4.frame0.menubutton2.menu
  menu $topwin(util_name).info.frame4.frame0.menubutton2.menu \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" 
  if {$util(img_box) == "create_checkboard"} {
  $topwin(util_name).info.frame4.frame0.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set util(img_celw) 8} \
    -label {   8}
  $topwin(util_name).info.frame4.frame0.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set util(img_celw) 16} \
    -label {  16}
  $topwin(util_name).info.frame4.frame0.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set util(img_celw) 32} \
    -label {  32}
  $topwin(util_name).info.frame4.frame0.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set util(img_celw) 64} \
    -label {  64}
  $topwin(util_name).info.frame4.frame0.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set util(img_celw) 128} \
    -label { 128}
  $topwin(util_name).info.frame4.frame0.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set util(img_celw) 256} \
    -label { 256}
  $topwin(util_name).info.frame4.frame0.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set util(img_celw) 512} \
    -label { 512}
  } else {
  $topwin(util_name).info.frame4.frame0.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set util(img_endc) 7} \
    -label {   7}
  $topwin(util_name).info.frame4.frame0.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set util(img_endc) 15} \
    -label {  15}
  $topwin(util_name).info.frame4.frame0.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set util(img_endc) 31} \
    -label {  31}
  $topwin(util_name).info.frame4.frame0.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set util(img_endc) 63} \
    -label {  63}
  $topwin(util_name).info.frame4.frame0.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set util(img_endc) 127} \
    -label { 127}
  $topwin(util_name).info.frame4.frame0.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set util(img_endc) 255} \
    -label { 255}
  $topwin(util_name).info.frame4.frame0.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set util(img_endc) 511} \
    -label { 511}
  }
  bindtags $topwin(util_name).info.frame4.frame0.menubutton2.menu {Menu all}
  # bindings
  bind $topwin(util_name).info.frame4.frame0.menubutton2.menu <Button-1> {MenuPopupPost $topwin(util_name).info.frame4.frame0.menubutton2.menu %X %Y}
  bind $topwin(util_name).info.frame4.frame0.menubutton2.menu <ButtonRelease-1> {MenuPopupRelease $topwin(util_name).info.frame4.frame0.menubutton2.menu %W}

  # pack widget $topwin(util_name).info.frame4.frame0
  pack append $topwin(util_name).info.frame4.frame0 \
    $topwin(util_name).info.frame4.frame0.label1 {left frame center fill} \
    $topwin(util_name).info.frame4.frame0.value {left frame center expand fill} \
    $topwin(util_name).info.frame4.frame0.menubutton2 {right frame center fill}

  # build widget $topwin(util_name).info.frame4.frame1
  frame $topwin(util_name).info.frame4.frame1 \
  -highlightthickness {0}  \
    -background "$GuiColor(frame_bg)"\
    -borderwidth {2}

  # build widget $topwin(util_name).info.frame4.frame1.label1
  label $topwin(util_name).info.frame4.frame1.label1 \
    -anchor {e} \
    -background "$GuiColor(label_bg)" \
    -borderwidth {0} \
    -text {Cell height: } \
    -width {17}
  if {$util(img_box) == "create_checkboard"} {
  $topwin(util_name).info.frame4.frame1.label1 configure -text "Cell height: "
  } else {
  $topwin(util_name).info.frame4.frame1.label1 configure -text "To Row: "
  }

  # build widget $topwin(util_name).info.frame4.frame1.value
  entry $topwin(util_name).info.frame4.frame1.value \
  -highlightthickness {0}  \
    -background "$GuiColor(entry_bg)" \
	 -foreground "$GuiColor(entry_fg)" \
    -relief {sunken} \
    -textvariable {util(img_endr)} \
    -width {5}
  # bindings
  endEntry $topwin(util_name).info.frame4.frame1.value 0\
    $topwin(util_name).info.frame4.frame0.value \
    $topwin(util_name).info.frame0.frame0.value 

  if { $util(img_box) == "create_checkboard"} {
  $topwin(util_name).info.frame4.frame1.value configure -textvariable {util(img_celh)}
  }
  # build widget $topwin(util_name).info.frame4.frame1.menubutton2
	menubutton $topwin(util_name).info.frame4.frame1.menubutton2 -padx {1} -pady {1} -highlightthickness {0}  \
    -background "$GuiColor(btn_bg)" \
	 -activebackground "$GuiColor(btn_act_bg)" \
    -font "$GuiMisc(pop_up_fn)" \
	 -text "$GuiMisc(pop_up_text)" \
	 -relief "$GuiMisc(pop_up_relief)" \
	 -width {2}

  # bindings
  bind $topwin(util_name).info.frame4.frame1.menubutton2 <Button-1> {MenuPopupPost $topwin(util_name).info.frame4.frame1.menubutton2.menu %X %Y}
  bind $topwin(util_name).info.frame4.frame1.menubutton2 <ButtonRelease-1> {MenuPopupRelease $topwin(util_name).info.frame4.frame1.menubutton2.menu %W}

  # build widget $topwin(util_name).info.frame4.frame1.menubutton2.menu
  menu $topwin(util_name).info.frame4.frame1.menubutton2.menu \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" 
  if {$util(img_box) == "create_checkboard"} {
  $topwin(util_name).info.frame4.frame1.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set util(img_celh) 8} \
    -label {   8}
  $topwin(util_name).info.frame4.frame1.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set util(img_celh) 16} \
    -label {  16}
  $topwin(util_name).info.frame4.frame1.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set util(img_celh) 32} \
    -label {  32}
  $topwin(util_name).info.frame4.frame1.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set util(img_celh) 64} \
    -label {  64}
  $topwin(util_name).info.frame4.frame1.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set util(img_celh) 128} \
    -label { 128}
  $topwin(util_name).info.frame4.frame1.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set util(img_celh) 256} \
    -label { 256}
  $topwin(util_name).info.frame4.frame1.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set util(img_celh) 512} \
    -label { 512}
  } else {
  $topwin(util_name).info.frame4.frame1.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set util(img_endr) 7} \
    -label {   7}
  $topwin(util_name).info.frame4.frame1.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set util(img_endr) 15} \
    -label {  15}
  $topwin(util_name).info.frame4.frame1.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set util(img_endr) 31} \
    -label {  31}
  $topwin(util_name).info.frame4.frame1.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set util(img_endr) 63} \
    -label {  63}
  $topwin(util_name).info.frame4.frame1.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set util(img_endr) 127} \
    -label { 127}
  $topwin(util_name).info.frame4.frame1.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set util(img_endr) 255} \
    -label { 255}
  $topwin(util_name).info.frame4.frame1.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set util(img_endr) 511} \
    -label { 511}
  }
  bindtags $topwin(util_name).info.frame4.frame1.menubutton2.menu {Menu all}
  # bindings
  bind $topwin(util_name).info.frame4.frame1.menubutton2.menu <Button-1> {MenuPopupPost $topwin(util_name).info.frame4.frame1.menubutton2.menu %X %Y}
  bind $topwin(util_name).info.frame4.frame1.menubutton2.menu <ButtonRelease-1> {MenuPopupRelease $topwin(util_name).info.frame4.frame1.menubutton2.menu %W}

  # pack widget $topwin(util_name).info.frame4.frame1
  pack append $topwin(util_name).info.frame4.frame1 \
    $topwin(util_name).info.frame4.frame1.label1 {left frame center fill} \
    $topwin(util_name).info.frame4.frame1.value {left frame center expand fill} \
    $topwin(util_name).info.frame4.frame1.menubutton2 {right frame center fill}

  # pack widget $topwin(util_name).info.frame4
  pack append $topwin(util_name).info.frame4 \
    $topwin(util_name).info.frame4.frame1 {left frame center padx 10} \
    $topwin(util_name).info.frame4.frame0 {left frame center padx 10}

  # pack widget $topwin(util_name).info
  pack append $topwin(util_name).info \
    $topwin(util_name).info.frame3 {top frame center expand fillx} \
    $topwin(util_name).info.frame0 {top frame center expand fillx} \
    $topwin(util_name).info.frame4 {top frame center expand fillx}

  # build widget $topwin(util_name).perform
  frame $topwin(util_name).perform \
  -highlightthickness {0}  \
    -background "$GuiColor(frame_bg)"\
    -borderwidth {2} \
    -relief {raised}

  # build widget $topwin(util_name).perform.perform1
	button $topwin(util_name).perform.perform1 -padx {1} -pady {1} -highlightthickness {0}  \
    -foreground "$GuiColor(perf_fg)" \
    -background "$GuiColor(perf_bg)" \
	 -activebackground "$GuiColor(perf_act_bg)" \
    -command {
		$topwin(util_name) configure -cursor watch; update
		if {$util(img_name) == ""} {
			CvipAlert "Please give a name to the resulting image first."
			$topwin(util_name) configure -cursor top_left_arrow; update
			return
		}
		if {$util(img_box) == "create_checkboard"} {
		if [catch {expr $util(img_width)+$util(img_height)+$util(img_strtc)+ $util(img_strtr)+$util(img_celh) + $util(img_celw)}] {
			CvipAlert "Numerical values required for image parameters: \n \
						Image width = $util(img_width), Image height= $util(img_height),\n \
						Start column = $util(img_strtc), Start row = $util(img_strtr), \n \
						Cell height = $util(img_celh), Cell width = $util(img_celw)"
			$topwin(util_name) configure -cursor top_left_arrow; update
			return
		} elseif { $util(img_width) < 0 || $util(img_height) < 0 || $util(img_strtc) <0 ||
						$util(img_strtr) < 0 || $util(img_celh) < 0 || $util(img_celw) < 0} {
			CvipAlert "Positive values required for image parameters: 
						Image width = $util(img_width), Image height= $util(img_height),\n \
						Start column = $util(img_strtc), Start row = $util(img_strtr), \n \
						Cell height = $util(img_celh), Cell width = $util(img_celw)"
			$topwin(util_name) configure -cursor top_left_arrow; update
			return
		} 
		if [catch {set result [cvip create_checkboard $util(img_width) $util(img_height) $util(img_strtc) $util(img_strtr) $util(img_celw) $util(img_celh)]} cresult] {
			CvipAlert "$cresult."
			$topwin(util_name) configure -cursor top_left_arrow; update
			return
		}
		CvipMessage "checkerboard image created"
		} else {
		if [catch {expr $util(img_width)+$util(img_height)+$util(img_strtc)+ $util(img_strtr)+$util(img_endr) + $util(img_endc)}] {
			CvipAlert "Numerical values required for image parameters: \n \
						Image width = $util(img_width), Image height= $util(img_height),\n \
						Start column = $util(img_strtc), Start row = $util(img_strtr), \n \
						End row = $util(img_endr), End column = $util(img_endc)"
			$topwin(util_name) configure -cursor top_left_arrow; update
			return
		} elseif { $util(img_width) < 0 || $util(img_height) < 0 || $util(img_strtc) <0 ||
						$util(img_strtr) < 0 || $util(img_endr) < 0 || $util(img_endc) < 0} {
			CvipAlert "Positive values required for image parameters: 
						Image width = $util(img_width), Image height= $util(img_height),\n \
						Start column = $util(img_strtc), Start row = $util(img_strtr), \n \
						End column = $util(img_endc), End row = $util(img_endr)"
			$topwin(util_name) configure -cursor top_left_arrow; update
			return

		}
		if {$util(img_box) == "line"} {
		if [catch {set result [cvip $util(img_box) $util(img_width) $util(img_height) $util(img_strtc) $util(img_strtr) $util(img_endc) $util(img_endr)]} cresult] {
			CvipAlert "$cresult."
			$topwin(util_name) configure -cursor top_left_arrow; update
			return
		}
		CvipMessage "a single line image created"
		}

		if {$util(img_box) == "rectangle"} {
		if [catch {set result [cvip $util(img_box) $util(img_width) $util(img_height)\
				$util(img_strtc) $util(img_strtr)\
				[expr $util(img_endc) - $util(img_strtc)+1] [expr $util(img_endr) - $util(img_strtr)+1] ]}\
				cresult] {
			CvipAlert "$cresult."
			$topwin(util_name) configure -cursor top_left_arrow; update
			return
		}
		CvipMessage "rectangle image created"
		}

		}
		set new_name [cvip rename $result $util(img_name)]
		img_q insert end $new_name
		image_post $new_name
		cvip view $new_name
	$topwin(util_name) configure -cursor top_left_arrow; update
	 } \
    -text {PERFORM}

  # build widget $topwin(util_name).perform.dismiss
	button $topwin(util_name).perform.dismiss -padx {1} -pady {1} -highlightthickness {0}  \
    -foreground "$GuiColor(dis_fg)" \
    -background "$GuiColor(dis_bg)" \
	 -activebackground "$GuiColor(dis_act_bg)" \
    -command {destroy $topwin(util_name); set topwin(util_name) NONE} \
    -text {DISMISS} \
    -width {10}

  # pack widget $topwin(util_name).perform
  pack append $topwin(util_name).perform \
    $topwin(util_name).perform.dismiss {left frame sw filly} \
    $topwin(util_name).perform.perform1 {right frame se filly}

  # build widget $topwin(util_name).current_image
  frame $topwin(util_name).current_image \
    -background "$GuiColor(frame_bg)"\
    -borderwidth {2}

  # build widget $topwin(util_name).current_image.frame
  frame $topwin(util_name).current_image.frame \
    -background "$GuiColor(frame_bg)"

  # build widget $topwin(util_name).current_image.frame.scrollbar1
  scrollbar $topwin(util_name).current_image.frame.scrollbar1 \
	 -activebackground "$GuiColor(btn_act_bg)" \
    -troughcolor "$GuiColor(btn_act_bg)" \
    -background "$GuiColor(btn_bg)" \
	 -highlightthickness {0}  \
    -command {$topwin(util_name).current_image.frame.entry2 xview} \
    -orient {horizontal} \
    -width {11}

  # build widget $topwin(util_name).current_image.frame.entry2
  entry $topwin(util_name).current_image.frame.entry2 \
  -highlightthickness {0}  \
    -background "$GuiColor(entry_bg)" \
	 -foreground "$GuiColor(entry_fg)" \
    -relief {sunken} \
 -xscrollcommand {$topwin(util_name).current_image.frame.scrollbar1 set} \
    -textvariable {util(img_name)} \
    -width {52}
  endEntry $topwin(util_name).current_image.frame.entry2 0\
    $topwin(util_name).info.frame3.frame1.value \
    $topwin(util_name).info.frame4.frame0.value 

  # pack widget $topwin(util_name).current_image.frame
  pack append $topwin(util_name).current_image.frame \
    $topwin(util_name).current_image.frame.entry2 {top frame center expand filly} \
    $topwin(util_name).current_image.frame.scrollbar1 {top frame center fillx}

  # build widget $topwin(util_name).current_image.label1
  label $topwin(util_name).current_image.label1 \
    -background "$GuiColor(label_bg)" \
    -borderwidth {0} \
    -relief {ridge} \
    -text {New Image name: }

  # pack widget $topwin(util_name).current_image
  pack append $topwin(util_name).current_image \
    $topwin(util_name).current_image.label1 {left frame center filly} \
    $topwin(util_name).current_image.frame {top frame center fillx}

  # pack widget $topwin(util_name)
  pack append $topwin(util_name) \
    $topwin(util_name).info {top frame center expand fill} \
    $topwin(util_name).perform {bottom frame center pady 5 fill} \
    $topwin(util_name).current_image {left frame center padx 10 filly}

  if {"[info procs XFEdit]" != ""} {
    catch "XFMiscBindWidgetTree $topwin(util_name)"
    after 2 "catch {XFEditSetShowWindows}"
  }
}

# procedure to show window $topwin(util_name)
proc ext_band { } {# xf ignore me 7
  global GuiColor
  global GuiMisc
  global GUI_DEBUG


  # Window manager configurations
  global tk_version
  global topwin
  global toplevel_position
  if [ winfo exists $topwin(util_name).info] {
     set tempname $topwin(util_name);\
destroy $topwin(util_name).info;\
set topwin(util_name) $tempname;}
  if [ winfo exists $topwin(util_name).current_image] {
     set tempname $topwin(util_name);\
destroy $topwin(util_name).current_image;\
set topwin(util_name) $tempname;}
  if [ winfo exists $topwin(util_name).perform] {
     set tempname $topwin(util_name);\
destroy $topwin(util_name).perform;\
set topwin(util_name) $tempname;}
  wm positionfrom $topwin(util_name) user
  wm sizefrom $topwin(util_name) user
  wm geometry $topwin(util_name) $topwin(util_top)[get_pos $topwin(util_name)]
  wm maxsize $topwin(util_name) [lindex [split $topwin(util_top_max)] 0] \
  	[lindex [split $topwin(util_top_max)] 1]
  wm minsize $topwin(util_name) [lindex [split $topwin(util_top_min)] 0] \
  	[lindex [split $topwin(util_top_min)] 1]
  wm title $topwin(util_name) {UTILITIES -> Create -> Extract a band}

  # bindings
  bind $topwin(util_name) <Destroy> {set topwin(util_name) NONE}

  # build widget $topwin(util_name).info
  frame $topwin(util_name).info \
    -background "$GuiColor(frame_bg)" \
    -borderwidth {2}
  # bindings
  bind $topwin(util_name).info <Button-1> {MenuPopupPost $topwin(util_name).info.menu2 %X %Y}
  bind $topwin(util_name).info <ButtonRelease-1> {MenuPopupRelease $topwin(util_name).info.menu2 %W}

  # build widget $topwin(util_name).info.frame3
  frame $topwin(util_name).info.frame3 \
    -background "$GuiColor(frame_bg)"

  # build widget $topwin(util_name).info.frame3.label5
  label $topwin(util_name).info.frame3.label5 \
    -background "$GuiColor(label_bg)" \
    -text {Extract the following band from the current image:}

  # pack widget $topwin(util_name).info.frame3
  pack append $topwin(util_name).info.frame3 \
    $topwin(util_name).info.frame3.label5 {left frame center padx 10}

  # build widget $topwin(util_name).info.frame9
  frame $topwin(util_name).info.frame9 \
    -background "$GuiColor(frame_bg)"

  # build widget $topwin(util_name).info.frame9.radiobutton10
	radiobutton $topwin(util_name).info.frame9.radiobutton10 -padx {1} -pady {1} -highlightthickness {0}  \
    -background "$GuiColor(btn_bg)" \
	 -activebackground "$GuiColor(btn_act_bg)" \
    -relief {flat} \
    -text { Band 1} \
    -value {1} \
    -variable {util(extract_band)}

  # build widget $topwin(util_name).info.frame9.radiobutton14
	radiobutton $topwin(util_name).info.frame9.radiobutton14 -padx {1} -pady {1} -highlightthickness {0}  \
    -background "$GuiColor(btn_bg)" \
	 -activebackground "$GuiColor(btn_act_bg)" \
    -relief {flat} \
    -text { Band 2} \
    -value {2} \
    -variable {util(extract_band)}

  # build widget $topwin(util_name).info.frame9.radiobutton15
	radiobutton $topwin(util_name).info.frame9.radiobutton15 -padx {1} -pady {1} -highlightthickness {0}  \
    -background "$GuiColor(btn_bg)" \
	 -activebackground "$GuiColor(btn_act_bg)" \
    -relief {flat} \
    -text { Band 3} \
    -value {3} \
    -variable {util(extract_band)}

  # pack widget $topwin(util_name).info.frame9
  pack append $topwin(util_name).info.frame9 \
    $topwin(util_name).info.frame9.radiobutton10 {left frame center expand} \
    $topwin(util_name).info.frame9.radiobutton14 {left frame center expand} \
    $topwin(util_name).info.frame9.radiobutton15 {left frame center expand}

  # pack widget $topwin(util_name).info
  pack append $topwin(util_name).info \
    $topwin(util_name).info.frame3 {top frame center expand fill} \
    $topwin(util_name).info.frame9 {top frame center expand fill}

  # build widget $topwin(util_name).perform
  frame $topwin(util_name).perform \
    -background "$GuiColor(frame_bg)" \
    -borderwidth {2} \
    -relief {raised}

  # build widget $topwin(util_name).perform.perform1
	button $topwin(util_name).perform.perform1 -padx {1} -pady {1} -highlightthickness {0}  \
    -foreground "$GuiColor(perf_fg)" \
    -background "$GuiColor(perf_bg)" \
	 -activebackground "$GuiColor(perf_act_bg)" \
    -command {
		$topwin(util_name) configure -cursor watch; update
      if { $current_image == ""} {
         CvipAlert "Please select an image first."
			$topwin(util_name) configure -cursor top_left_arrow; update
         return
      } 

		if {$bands != "3" } {
         CvipAlert "Extraction applies to color images only. The image: \n$current_image\nhas only $bands band"
			$topwin(util_name) configure -cursor top_left_arrow; update
         return
      } 

		if [catch {set result [cvip extract_band $current_image $util(extract_band)]} cresult] {
        CvipAlert "$cresult."
		  $topwin(util_name) configure -cursor top_left_arrow; update
        return
		}
     set new_name [cvip rename $result ${current_image}_Band$util(extract_band)]       
     img_q insert end $new_name
     image_post $new_name
     cvip view $new_name
	  CvipMessage "band $util(extract_band) extracted from image \"$current_image\""
	  
	$topwin(util_name) configure -cursor top_left_arrow; update
	 } \
    -text {PERFORM}

  # build widget $topwin(util_name).perform.dismiss
	button $topwin(util_name).perform.dismiss -padx {1} -pady {1} -highlightthickness {0}  \
    -foreground "$GuiColor(dis_fg)" \
    -background "$GuiColor(dis_bg)" \
	 -activebackground "$GuiColor(dis_act_bg)" \
    -command {if [winfo exist .filter ] {destroy .filter}; destroy $topwin(util_name); set topwin(util_name) NONE} \
    -text {DISMISS} \
    -width {10}

  # pack widget $topwin(util_name).perform
  pack append $topwin(util_name).perform \
    $topwin(util_name).perform.dismiss {left frame center filly} \
    $topwin(util_name).perform.perform1 {right frame center filly}

  # build widget $topwin(util_name).current_image
  frame $topwin(util_name).current_image \
    -background "$GuiColor(frame_bg)" \
    -borderwidth {2} \
    -relief {ridge}

  # build widget $topwin(util_name).current_image.current
  label $topwin(util_name).current_image.current \
    -background "$GuiColor(label_bg)" \
    -text {Current image:}

  # build widget $topwin(util_name).current_image.name
  label $topwin(util_name).current_image.name \
    -background "$GuiColor(label_bg)" \
    -foreground {Blue} \
    -text {} \
    -textvariable {current_image}

  # pack widget $topwin(util_name).current_image
  pack append $topwin(util_name).current_image \
    $topwin(util_name).current_image.current {left frame center} \
    $topwin(util_name).current_image.name {left frame center filly}

  # pack widget $topwin(util_name)
  pack append $topwin(util_name) \
    $topwin(util_name).info {top frame center expand fill} \
    $topwin(util_name).perform {bottom frame center pady 5 fill} \
    $topwin(util_name).current_image {bottom frame center fill}

  if {"[info procs XFEdit]" != ""} {
    catch "XFMiscBindWidgetTree $topwin(util_name)"
    after 2 "catch {XFEditSetShowWindows}"
  }
}


# procedure to show window $topwin(util_name)
proc assemble_bands { } {# xf ignore me 7
  global GuiColor
  global GuiMisc
  global GUI_DEBUG


  # Window manager configurations
  global tk_version
  global topwin
  global toplevel_position

  if [ winfo exists $topwin(util_name).info] {
     set tempname $topwin(util_name);\
destroy $topwin(util_name).info;\
set topwin(util_name) $tempname;}
  if [ winfo exists $topwin(util_name).current_image] {
     set tempname $topwin(util_name);\
destroy $topwin(util_name).current_image;\
set topwin(util_name) $tempname;}
  if [ winfo exists $topwin(util_name).perform] {
     set tempname $topwin(util_name);\
destroy $topwin(util_name).perform;\
set topwin(util_name) $tempname;}
  wm positionfrom $topwin(util_name) user
  wm sizefrom $topwin(util_name) user
  wm geometry $topwin(util_name) $topwin(util_top)[get_pos $topwin(util_name)]
  wm maxsize $topwin(util_name) [lindex [split $topwin(util_top_max)] 0] \
  	[lindex [split $topwin(util_top_max)] 1]
  wm minsize $topwin(util_name) [lindex [split $topwin(util_top_min)] 0] \
  	[lindex [split $topwin(util_top_min)] 1]
  wm title $topwin(util_name) {UTILITIES -> Create -> Assemble an image}

  # bindings
  bind $topwin(util_name) <Destroy> {set topwin(util_name) NONE}
  global util
  set util(img_name) "color_"
 
  # build widget $topwin(util_name).info
  frame $topwin(util_name).info \
    -background "$GuiColor(frame_bg)" \
    -borderwidth {0}

  # build widget $topwin(util_name).info.frame1
  frame $topwin(util_name).info.frame1 \
    -background "$GuiColor(frame_bg)" \
    -borderwidth {0} \
    -relief {flat}

  # build widget $topwin(util_name).info.frame1.frame6
  frame $topwin(util_name).info.frame1.frame6 \
    -background "$GuiColor(frame_bg)" \
    -borderwidth {2} \
    -relief {ridge}

  # build widget $topwin(util_name).info.frame1.frame6.label10
  label $topwin(util_name).info.frame1.frame6.label10 \
    -background "$GuiColor(label_bg)" \
    -text {Red band image: } \
	 -width {17}

  # build widget $topwin(util_name).info.frame1.frame6.entry0
  entry $topwin(util_name).info.frame1.frame6.entry0 \
  -highlightthickness {0}  \
    -background "$GuiColor(entry_bg)" \
	 -foreground "$GuiColor(entry_fg)" \
    -relief {sunken} \
    -textvariable {util(red_src)} \
    -width {35}
  endEntry $topwin(util_name).info.frame1.frame6.entry0 0\
    $topwin(util_name).info.frame1.frame7.entry0 \
    $topwin(util_name).info.frame1.frame9.entry12 

  # build widget $topwin(util_name).info.frame1.frame6.button7
	button $topwin(util_name).info.frame1.frame6.button7 -padx {1} -pady {1} -highlightthickness {0}  \
    -background "$GuiColor(btn_bg)" \
	 -activebackground "$GuiColor(btn_act_bg)" \
    -command {set temp [img_q curselection]
     set util(red_src) [img_q get $temp]
     } \
    -text { use current image}

  # pack widget $topwin(util_name).info.frame1.frame6
  pack append $topwin(util_name).info.frame1.frame6 \
    $topwin(util_name).info.frame1.frame6.label10 {left frame center} \
    $topwin(util_name).info.frame1.frame6.entry0 {left frame center} \
    $topwin(util_name).info.frame1.frame6.button7 {left frame center padx 5}

  # build widget $topwin(util_name).info.frame1.frame7
  frame $topwin(util_name).info.frame1.frame7 \
    -background "$GuiColor(frame_bg)" \
    -borderwidth {2} \
    -relief {ridge}

  # build widget $topwin(util_name).info.frame1.frame7.label10
  label $topwin(util_name).info.frame1.frame7.label10 \
    -background "$GuiColor(label_bg)" \
    -text {Green band image:} \
	 -width {17}

  # build widget $topwin(util_name).info.frame1.frame7.entry0
  entry $topwin(util_name).info.frame1.frame7.entry0 \
  -highlightthickness {0}  \
    -background "$GuiColor(entry_bg)" \
	 -foreground "$GuiColor(entry_fg)" \
    -relief {sunken} \
    -textvariable {util(green_src)} \
    -width {35}
  endEntry $topwin(util_name).info.frame1.frame7.entry0 0\
    $topwin(util_name).info.frame1.frame8.entry0 \
    $topwin(util_name).info.frame1.frame6.entry0 

  # build widget $topwin(util_name).info.frame1.frame7.button7
	button $topwin(util_name).info.frame1.frame7.button7 -padx {1} -pady {1} -highlightthickness {0}  \
    -background "$GuiColor(btn_bg)" \
	 -activebackground "$GuiColor(btn_act_bg)" \
    -command {set temp [img_q curselection]
     set util(green_src) [img_q get $temp]
     } \
    -text { use current image}

  # pack widget $topwin(util_name).info.frame1.frame7
  pack append $topwin(util_name).info.frame1.frame7 \
    $topwin(util_name).info.frame1.frame7.label10 {left frame center} \
    $topwin(util_name).info.frame1.frame7.entry0 {left frame center} \
    $topwin(util_name).info.frame1.frame7.button7 {left frame center padx 5}

  # build widget $topwin(util_name).info.frame1.frame8
  frame $topwin(util_name).info.frame1.frame8 \
    -background "$GuiColor(frame_bg)" \
    -borderwidth {2} \
    -relief {ridge}

  # build widget $topwin(util_name).info.frame1.frame8.label10
  label $topwin(util_name).info.frame1.frame8.label10 \
    -background "$GuiColor(label_bg)" \
    -text {Blue band image: } \
	 -width {17}


  # build widget $topwin(util_name).info.frame1.frame8.entry0
  entry $topwin(util_name).info.frame1.frame8.entry0 \
  -highlightthickness {0}  \
    -background "$GuiColor(entry_bg)" \
	 -foreground "$GuiColor(entry_fg)" \
    -relief {sunken} \
    -textvariable {util(blue_src)} \
    -width {35}
  endEntry $topwin(util_name).info.frame1.frame8.entry0 0\
  	 $topwin(util_name).info.frame1.frame9.entry12 \
    $topwin(util_name).info.frame1.frame7.entry0 

  # build widget $topwin(util_name).info.frame1.frame8.button7
	button $topwin(util_name).info.frame1.frame8.button7 -padx {1} -pady {1} -highlightthickness {0}  \
    -background "$GuiColor(btn_bg)" \
	 -activebackground "$GuiColor(btn_act_bg)" \
    -command {set temp [img_q curselection]
     set util(blue_src) [img_q get $temp]
     } \
    -text { use current image}

  # pack widget $topwin(util_name).info.frame1.frame8
  pack append $topwin(util_name).info.frame1.frame8 \
    $topwin(util_name).info.frame1.frame8.label10 {left frame center} \
    $topwin(util_name).info.frame1.frame8.entry0 {left frame center} \
    $topwin(util_name).info.frame1.frame8.button7 {left frame center padx 5}

  # build widget $topwin(util_name).info.frame1.frame9
  frame $topwin(util_name).info.frame1.frame9 \
    -background "$GuiColor(frame_bg)" \
    -borderwidth {2} \
    -relief {ridge}

  # build widget $topwin(util_name).info.frame1.frame9.label10
  label $topwin(util_name).info.frame1.frame9.label10 \
    -background "$GuiColor(label_bg)" \
    -text {Result image name: } \
	 -width {17}

  # build widget $topwin(util_name).info.frame1.frame9.entry12
  entry $topwin(util_name).info.frame1.frame9.entry12 \
  -highlightthickness {0}  \
    -background "$GuiColor(entry_bg)" \
	 -foreground "$GuiColor(entry_fg)" \
    -relief {sunken} \
    -textvariable {util(img_name)} \
    -width {35}
  endEntry $topwin(util_name).info.frame1.frame9.entry12 0\
    $topwin(util_name).info.frame1.frame6.entry0 \
    $topwin(util_name).info.frame1.frame8.entry0 

  # pack widget $topwin(util_name).info.frame1.frame9
  pack append $topwin(util_name).info.frame1.frame9 \
    $topwin(util_name).info.frame1.frame9.label10 {left frame center} \
    $topwin(util_name).info.frame1.frame9.entry12 {left frame center}

  # pack widget $topwin(util_name).info.frame1
  pack append $topwin(util_name).info.frame1 \
    $topwin(util_name).info.frame1.frame6 {top frame center expand fill} \
    $topwin(util_name).info.frame1.frame7 {top frame center expand fill} \
    $topwin(util_name).info.frame1.frame8 {top frame center expand fill} \
    $topwin(util_name).info.frame1.frame9 {top frame center expand fill}


  # pack widget $topwin(util_name).info
  pack append $topwin(util_name).info \
    $topwin(util_name).info.frame1 {left frame center expand fill}

  # build widget $topwin(util_name).perform
  frame $topwin(util_name).perform \
    -background "$GuiColor(frame_bg)" \
    -borderwidth {2} \
    -relief {raised}

  # build widget $topwin(util_name).perform.perform1
	button $topwin(util_name).perform.perform1 -padx {1} -pady {1} -highlightthickness {0}  \
    -foreground "$GuiColor(perf_fg)" \
    -background "$GuiColor(perf_bg)" \
	 -activebackground "$GuiColor(perf_act_bg)" \
    -command {
		$topwin(util_name) configure -cursor watch; update
      if { $util(red_src) == "" || $util(green_src) == "" || $util(blue_src) == ""} {
         CvipAlert "Please select all source images first."
			$topwin(util_name) configure -cursor top_left_arrow; update
         return
      } 

		if {$util(img_name) == "" } {
         CvipAlert "Please enter a name for the new image."
			$topwin(util_name) configure -cursor top_left_arrow; update
         return
      } 

		if [catch {set result [cvip assemble_bands $util(red_src) $util(green_src) $util(blue_src)]} cresult] {
        CvipAlert "$cresult."
			$topwin(util_name) configure -cursor top_left_arrow; update
        return
		}
     set new_name [cvip rename $result $util(img_name)]       
     img_q insert end $new_name
     image_post $new_name
     cvip view $new_name
	  CvipMessage "assemble bands succeeds"
	$topwin(util_name) configure -cursor top_left_arrow; update
	 } \
    -text {PERFORM}

  # build widget $topwin(util_name).perform.dismiss
	button $topwin(util_name).perform.dismiss -padx {1} -pady {1} -highlightthickness {0}  \
    -foreground "$GuiColor(dis_fg)" \
    -background "$GuiColor(dis_bg)" \
	 -activebackground "$GuiColor(dis_act_bg)" \
    -command {if [winfo exist .filter ] {destroy .filter}; destroy $topwin(util_name); set topwin(util_name) NONE} \
    -text {DISMISS} \
    -width {10}

  # pack widget $topwin(util_name).perform
  pack append $topwin(util_name).perform \
    $topwin(util_name).perform.dismiss {left frame center filly} \
    $topwin(util_name).perform.perform1 {right frame center filly}
  # pack widget $topwin(util_name)
  pack append $topwin(util_name) \
    $topwin(util_name).info {top frame center expand fill} \
    $topwin(util_name).perform {bottom frame center fillx}


  if {"[info procs XFEdit]" != ""} {
    catch "XFMiscBindWidgetTree ."
    after 2 "catch {XFEditSetShowWindows}"
  }
}

# procedure to show window $topwin(util_name)
proc util_black { } {# xf ignore me 7
  global GuiColor
  global GuiMisc
  global GUI_DEBUG

  # Window manager configurations
  global tk_version
  global {util}
  global topwin
  global {temp}
  global toplevel_position
  if [ winfo exists $topwin(util_name).info] {
     set tempname $topwin(util_name);\
destroy $topwin(util_name).info;\
set topwin(util_name) $tempname;}
  if [ winfo exists $topwin(util_name).current_image] {
     set tempname $topwin(util_name);\
destroy $topwin(util_name).current_image;\
set topwin(util_name) $tempname;}
  if [ winfo exists $topwin(util_name).perform] {
     set tempname $topwin(util_name);\
destroy $topwin(util_name).perform;\
set topwin(util_name) $tempname;}
  wm positionfrom $topwin(util_name) user
  wm sizefrom $topwin(util_name) user
  wm geometry $topwin(util_name) $topwin(util_top)[get_pos $topwin(util_name)]
  wm maxsize $topwin(util_name) [lindex [split $topwin(util_top_max)] 0] \
  	[lindex [split $topwin(util_top_max)] 1]
  wm minsize $topwin(util_name) [lindex [split $topwin(util_top_min)] 0] \
  	[lindex [split $topwin(util_top_min)] 1]
  wm title $topwin(util_name) "UTILITIES -> Create -> Black image"

  # bindings
  bind $topwin(util_name) <Destroy> {set topwin(util_name) NONE}

  # build widget $topwin(util_name).info
  frame $topwin(util_name).info \
    -background "$GuiColor(frame_bg)" \
    -borderwidth {2}

  # build widget $topwin(util_name).info.frame3
  frame $topwin(util_name).info.frame3 \
    -background "$GuiColor(frame_bg)"

  # build widget $topwin(util_name).info.frame3.frame1
  frame $topwin(util_name).info.frame3.frame1 \
    -background "$GuiColor(frame_bg)" \
    -borderwidth {2}

  # build widget $topwin(util_name).info.frame3.frame1.label1
  label $topwin(util_name).info.frame3.frame1.label1 \
    -background "$GuiColor(label_bg)" \
	 -width {17} \
    -borderwidth {0} \
    -text {Image height: }

  # build widget $topwin(util_name).info.frame3.frame1.value
  entry $topwin(util_name).info.frame3.frame1.value \
  -highlightthickness {0}  \
    -background "$GuiColor(entry_bg)" \
	 -foreground "$GuiColor(entry_fg)" \
    -relief {sunken} \
    -textvariable {util(black_height)} \
    -width {5}
  # bindings
  endEntry $topwin(util_name).info.frame3.frame1.value 0\
    $topwin(util_name).info.frame3.frame2.value \
    $topwin(util_name).current_image.frame.entry2 

  # build widget $topwin(util_name).info.frame3.frame1.menubutton2
	menubutton $topwin(util_name).info.frame3.frame1.menubutton2 -padx {1} -pady {1} -highlightthickness {0}  \
    -background "$GuiColor(btn_bg)" \
	 -activebackground "$GuiColor(btn_act_bg)" \
    -font "$GuiMisc(pop_up_fn)" \
	 -text "$GuiMisc(pop_up_text)" \
	 -relief "$GuiMisc(pop_up_relief)" \
	 -width {2}

  # bindings
  bind $topwin(util_name).info.frame3.frame1.menubutton2 <Button-1> {MenuPopupPost $topwin(util_name).info.frame3.frame1.menubutton2.menu %X %Y}
  bind $topwin(util_name).info.frame3.frame1.menubutton2 <ButtonRelease-1> {MenuPopupRelease $topwin(util_name).info.frame3.frame1.menubutton2.menu %W}

  # build widget $topwin(util_name).info.frame3.frame1.menubutton2.menu
  menu $topwin(util_name).info.frame3.frame1.menubutton2.menu \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" 
  $topwin(util_name).info.frame3.frame1.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set util(black_height) 16} \
    -label {  16}
  $topwin(util_name).info.frame3.frame1.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set util(black_height) 32} \
    -label {  32}
  $topwin(util_name).info.frame3.frame1.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set util(black_height) 64} \
    -label {  64}
  $topwin(util_name).info.frame3.frame1.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set util(black_height) 128} \
    -label { 128}
  $topwin(util_name).info.frame3.frame1.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set util(black_height) 256} \
    -label { 256}
  $topwin(util_name).info.frame3.frame1.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set util(black_height) 512} \
    -label { 512}
  $topwin(util_name).info.frame3.frame1.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set util(black_height) 1024} \
    -label {1024}
  bindtags $topwin(util_name).info.frame3.frame1.menubutton2.menu {Menu all}
  # bindings
  bind $topwin(util_name).info.frame3.frame1.menubutton2.menu <Button-1> {MenuPopupPost $topwin(util_name).info.frame3.frame1.menubutton2.menu %X %Y}
  bind $topwin(util_name).info.frame3.frame1.menubutton2.menu <ButtonRelease-1> {MenuPopupRelease $topwin(util_name).info.frame3.frame1.menubutton2.menu %W}

  # pack widget $topwin(util_name).info.frame3.frame1
  pack append $topwin(util_name).info.frame3.frame1 \
    $topwin(util_name).info.frame3.frame1.label1 {left frame e fill} \
    $topwin(util_name).info.frame3.frame1.value {left frame center expand fill} \
    $topwin(util_name).info.frame3.frame1.menubutton2 {right frame center fill}

  frame $topwin(util_name).info.frame3.frame2 \
    -background "$GuiColor(frame_bg)" \
    -borderwidth {2}

  # build widget $topwin(util_name).info.frame3.frame2.label1
  label $topwin(util_name).info.frame3.frame2.label1 \
    -background "$GuiColor(label_bg)" \
	 -width {17} \
    -borderwidth {0} \
    -text {Image width: }

  # build widget $topwin(util_name).info.frame3.frame2.value
  entry $topwin(util_name).info.frame3.frame2.value \
  -highlightthickness {0}  \
    -background "$GuiColor(entry_bg)" \
	 -foreground "$GuiColor(entry_fg)" \
    -relief {sunken} \
    -textvariable {util(black_width)} \
    -width {5}
  # bindings
  endEntry $topwin(util_name).info.frame3.frame2.value 0\
    $topwin(util_name).current_image.frame.entry2 \
    $topwin(util_name).info.frame3.frame1.value 

  # build widget $topwin(util_name).info.frame3.frame2.menubutton2
	menubutton $topwin(util_name).info.frame3.frame2.menubutton2 -padx {1} -pady {1} -highlightthickness {0}  \
    -background "$GuiColor(btn_bg)" \
	 -activebackground "$GuiColor(btn_act_bg)" \
    -font "$GuiMisc(pop_up_fn)" \
	 -text "$GuiMisc(pop_up_text)" \
	 -relief "$GuiMisc(pop_up_relief)" \
	 -width {2}

  # bindings
  bind $topwin(util_name).info.frame3.frame2.menubutton2 <Button-1> {MenuPopupPost $topwin(util_name).info.frame3.frame2.menubutton2.menu %X %Y}
  bind $topwin(util_name).info.frame3.frame2.menubutton2 <ButtonRelease-1> {MenuPopupRelease $topwin(util_name).info.frame3.frame2.menubutton2.menu %W}

  # build widget $topwin(util_name).info.frame3.frame2.menubutton2.menu
  menu $topwin(util_name).info.frame3.frame2.menubutton2.menu \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" 
  $topwin(util_name).info.frame3.frame2.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set util(black_width) 16} \
    -label {  16}
  $topwin(util_name).info.frame3.frame2.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set util(black_width) 32} \
    -label {  32}
  $topwin(util_name).info.frame3.frame2.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set util(black_width) 64} \
    -label {  64}
  $topwin(util_name).info.frame3.frame2.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set util(black_width) 128} \
    -label { 128}
  $topwin(util_name).info.frame3.frame2.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set util(black_width) 256} \
    -label { 256}
  $topwin(util_name).info.frame3.frame2.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set util(black_width) 512} \
    -label { 512}
  $topwin(util_name).info.frame3.frame2.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set util(black_width) 1024} \
    -label {1024}
  bindtags  $topwin(util_name).info.frame3.frame2.menubutton2.menu  {Menu all}
  # bindings
  bind $topwin(util_name).info.frame3.frame2.menubutton2.menu <Button-1> {MenuPopupPost $topwin(util_name).info.frame3.frame2.menubutton2.menu %X %Y}
  bind $topwin(util_name).info.frame3.frame2.menubutton2.menu <ButtonRelease-1> {MenuPopupRelease $topwin(util_name).info.frame3.frame2.menubutton2.menu %W}

  # pack widget $topwin(util_name).info.frame3.frame2
  pack append $topwin(util_name).info.frame3.frame2 \
    $topwin(util_name).info.frame3.frame2.label1 {left frame e fill} \
    $topwin(util_name).info.frame3.frame2.value {left frame center expand fill} \
    $topwin(util_name).info.frame3.frame2.menubutton2 {right frame center fill}

  # pack widget $topwin(util_name).info.frame3
  pack append $topwin(util_name).info.frame3 \
    $topwin(util_name).info.frame3.frame1 {left frame center } \
    $topwin(util_name).info.frame3.frame2 {left frame center } 

  # pack widget $topwin(util_name).info
  pack append $topwin(util_name).info \
    $topwin(util_name).info.frame3 {top frame center expand fillx} 

  # build widget $topwin(util_name).perform
  frame $topwin(util_name).perform \
    -background "$GuiColor(frame_bg)" \
    -borderwidth {2} \
    -relief {raised}

  # build widget $topwin(util_name).perform.perform1
	button $topwin(util_name).perform.perform1 -padx {1} -pady {1} -highlightthickness {0}  \
    -foreground "$GuiColor(perf_fg)" \
    -background "$GuiColor(perf_bg)" \
	 -activebackground "$GuiColor(perf_act_bg)" \
    -command {
		$topwin(util_name) configure -cursor watch; update
		if {$util(img_name) == ""} {
			CvipAlert "Please give a name to the resulting image first."
			$topwin(util_name) configure -cursor top_left_arrow; update
			return
		}

		if [catch {expr $util(black_width) + $util(black_height)} ] {
			CvipAlert "Numerical values required for the black image size: \n \
			Height = $util(black_height), Width = $util(black_width)."
			$topwin(util_name) configure -cursor top_left_arrow; update
			return
		} elseif { $util(black_width) < 1 || $util(black_height) < 1 } {
			CvipAlert "The black image size should be positive integers: \n \
				Height = $util(black_height), Width = $util(black_width)."
			$topwin(util_name) configure -cursor top_left_arrow; update
			return
		}
		set util(black_height) [expr int(floor($util(black_height)))]
		set util(black_width) [expr int(floor($util(black_width)))]
		set result [cvip black $util(black_width) $util(black_height)]

		set new_name [cvip rename $result $util(img_name)]
		img_q insert end $new_name
		image_post $new_name
		cvip view $new_name
		CvipMessage "black image \"$new_name\" created"
	$topwin(util_name) configure -cursor top_left_arrow; update
	 } \
    -text {PERFORM}

  # build widget $topwin(util_name).perform.dismiss
	button $topwin(util_name).perform.dismiss -padx {1} -pady {1} -highlightthickness {0}  \
    -foreground "$GuiColor(dis_fg)" \
    -background "$GuiColor(dis_bg)" \
	 -activebackground "$GuiColor(dis_act_bg)" \
    -command {destroy $topwin(util_name); set topwin(util_name) NONE} \
    -text {DISMISS} \
    -width {10}

  # pack widget $topwin(util_name).perform
  pack append $topwin(util_name).perform \
    $topwin(util_name).perform.dismiss {left frame sw filly} \
    $topwin(util_name).perform.perform1 {right frame se filly}

  # build widget $topwin(util_name).current_image
  frame $topwin(util_name).current_image \
    -background "$GuiColor(frame_bg)" \
    -borderwidth {2}

  # build widget $topwin(util_name).current_image.frame
  frame $topwin(util_name).current_image.frame \
    -background "$GuiColor(frame_bg)"

  # build widget $topwin(util_name).current_image.frame.scrollbar1
  scrollbar $topwin(util_name).current_image.frame.scrollbar1 \
	 -activebackground "$GuiColor(btn_act_bg)" \
    -troughcolor "$GuiColor(btn_act_bg)" \
    -background "$GuiColor(btn_bg)" \
	 -highlightthickness {0}  \
    -command "$topwin(util_name).current_image.frame.entry2 xview" \
    -orient {horizontal} \
    -width {11}

  set util(img_name) black
  # build widget $topwin(util_name).current_image.frame.entry2
  entry $topwin(util_name).current_image.frame.entry2 \
  -highlightthickness {0}  \
    -background "$GuiColor(entry_bg)" \
	 -foreground "$GuiColor(entry_fg)" \
    -relief {sunken} \
 -xscrollcommand "$topwin(util_name).current_image.frame.scrollbar1 set" \
    -textvariable {util(img_name)} \
    -width {52}
  # bindings
  endEntry $topwin(util_name).current_image.frame.entry2 0\
    $topwin(util_name).info.frame3.frame1.value \
    $topwin(util_name).info.frame3.frame2.value 

  # pack widget $topwin(util_name).current_image.frame
  pack append $topwin(util_name).current_image.frame \
    $topwin(util_name).current_image.frame.entry2 {top frame center expand filly} \
    $topwin(util_name).current_image.frame.scrollbar1 {top frame center fillx}

  # build widget $topwin(util_name).current_image.label1
  label $topwin(util_name).current_image.label1 \
    -background "$GuiColor(label_bg)" \
    -borderwidth {0} \
    -relief {ridge} \
    -text {New Image name: }

  # pack widget $topwin(util_name).current_image
  pack append $topwin(util_name).current_image \
    $topwin(util_name).current_image.label1 {left frame center filly} \
    $topwin(util_name).current_image.frame {top frame center fillx}

  # pack widget $topwin(util_name)
  pack append $topwin(util_name) \
    $topwin(util_name).info {top frame center expand fill} \
    $topwin(util_name).perform {bottom frame center pady 5 fill} \
    $topwin(util_name).current_image {left frame center padx 10 filly}

  if {"[info procs XFEdit]" != ""} {
    catch "XFMiscBindWidgetTree $topwin(util_name)"
    after 2 "catch {XFEditSetShowWindows}"
  }
}
