# **********************************************************************
# Computer Vision/Image Processing Tool Project - Dr. Scott Umbaugh SIUE
# **********************************************************************
#
#             File Name: util_enhen.tcl
#           Description: 
#         Related Files: 
#   Initial Coding Date: Fri Aug  9 17:33:45 CDT 1996
#           Portability: TCL script file
#            References:
#             Author(s): Yansheng Wei
#                        Southern Illinois University @ Edwardsville
#
## Copyright (C) 1996 SIUE - by Scott Umbaugh and Yansheng Wei.
##
## Permission to use, copy, modify, and distribute this software and its
## documentation for any purpose and without fee is hereby granted, provided
## that the above copyright notice appear in all copies and that both that
## copyright notice and this permission notice appear in supporting
## documentation.  This software is provided "as is" without express or
## implied warranty.
##
# RCS (Revision Control System) Information
# ...Added automatically by RCS 
#
## $Log: util_enhen.tcl,v $
## Revision 1.18  1997/07/17 21:26:45  yawei
## gui configuration in place
##
## Revision 1.17  1997/03/20 18:50:30  yawei
## updated freq filters
##
## Revision 1.16  1997/03/12 16:25:05  yawei
## fixed arrow buttons and unsharp bug
##
## Revision 1.15  1997/03/11 20:57:02  yawei
## Tcl/Tk script upgrading from tcl7.3/tk3.6 to tcl7.6/tk4.2
## compatible. This process is automated with tkboost perl
## script. @ Tue Mar 11 14:51:36 CST 1997
##
## Revision 1.14  1997/01/09 21:19:18  mzuke
## added zero percent clip choices to histogram stretch
##
# Revision 1.13  1996/12/05  03:59:32  yawei
# Added util_stretch() procedure
#
# Revision 1.12  1996/11/12  15:47:45  yawei
# Changed default for hist_stretch to 0.025
#
# Revision 1.11  1996/11/08  17:49:53  yawei
#  added default "50 50" to hist_stretch
#
# Revision 1.10  1996/10/22  19:57:27  yawei
# Changed the "Edge enhancement"
#
# Revision 1.9  1996/10/18  14:54:43  yawei
# Added "Utilities | Edge Enhancement"
#
# Revision 1.8  1996/10/16  20:06:05  yawei
# general chagnes
#
# Revision 1.7  1996/09/27  18:33:00  mzuke
# made window resizable
#
# Revision 1.6  1996/09/25  20:52:23  yawei
# Removed the condition check for the pseudo color to be numbers
#
# Revision 1.5  1996/09/22  19:40:05  yawei
# Changed color form "0,1,2" to "R,G,B" in pseudo color
#
# Revision 1.4  1996/09/15  23:10:20  yawei
# added pseudo color under Utilities | enhance
#
# Revision 1.3  1996/08/15  11:18:42  mzuke
# removed toplevel_position from wm geometry to allow window
# positioning by user
#
# Revision 1.2  1996/08/13  22:50:26  yawei
# make changes so the label in Brighten/Darken show up completely
#
# Revision 1.1  1996/08/09  22:37:15  yawei
# Initial revision
#
#
#****************************************************************************
# procedure to show window $topwin(util_name)
proc util_histeq { } {# xf ignore me 7
  global GuiColor
  global GuiMisc
  global GUI_DEBUG

  global tk_version
  global topwin
  global toplevel_position
  if [ winfo exists $topwin(util_name).info] {
     set tempname $topwin(util_name);\
destroy $topwin(util_name).info;\
set topwin(util_name) $tempname;}
  if [ winfo exists $topwin(util_name).current_image] {
     set tempname $topwin(util_name);\
destroy $topwin(util_name).current_image;\
set topwin(util_name) $tempname;}
  if [ winfo exists $topwin(util_name).perform] {
     set tempname $topwin(util_name);\
destroy $topwin(util_name).perform;\
set topwin(util_name) $tempname;}
  wm positionfrom $topwin(util_name) user
  wm sizefrom $topwin(util_name) user
  wm geometry $topwin(util_name) $topwin(util_top)[get_pos $topwin(util_name)]
  wm maxsize $topwin(util_name) [lindex [split $topwin(util_top_max)] 0] \
  	[lindex [split $topwin(util_top_max)] 1]
  wm minsize $topwin(util_name) [lindex [split $topwin(util_top_min)] 0] \
  	[lindex [split $topwin(util_top_min)] 1]
  wm title $topwin(util_name) "UTILITIES -> Enhance -> Histogram equalization"

  # bindings
  bind $topwin(util_name) <Destroy> {set topwin(util_name) NONE}

  # build widget $topwin(util_name).info
  frame $topwin(util_name).info \
    -background "$GuiColor(frame_bg)" \
    -borderwidth {2}
  # bindings
  bind $topwin(util_name).info <Button-1> {MenuPopupPost $topwin(util_name).info.menu2 %X %Y}
  bind $topwin(util_name).info <ButtonRelease-1> {MenuPopupRelease $topwin(util_name).info.menu2 %W}

  # build widget $topwin(util_name).info.frame3
  frame $topwin(util_name).info.frame3 \
    -background "$GuiColor(frame_bg)"

  # build widget $topwin(util_name).info.frame3.label5
  label $topwin(util_name).info.frame3.label5 \
    -background "$GuiColor(label_bg)" \
    -text {Carry out histogram equalization on: }

  # pack widget $topwin(util_name).info.frame3
  pack append $topwin(util_name).info.frame3 \
    $topwin(util_name).info.frame3.label5 {left frame center padx 10}

  # build widget $topwin(util_name).info.frame9
  frame $topwin(util_name).info.frame9 \
    -background "$GuiColor(frame_bg)"

  # build widget $topwin(util_name).info.frame9.radiobutton10
	radiobutton $topwin(util_name).info.frame9.radiobutton10 -padx {1} -pady {1} -highlightthickness {0}  \
    -background "$GuiColor(btn_bg)" \
	 -activebackground "$GuiColor(btn_act_bg)" \
    -relief {flat} \
    -text {Value} \
    -value {3} \
    -variable {util(eq_band)}

  # build widget $topwin(util_name).info.frame9.radiobutton14
	radiobutton $topwin(util_name).info.frame9.radiobutton14 -padx {1} -pady {1} -highlightthickness {0}  \
    -background "$GuiColor(btn_bg)" \
	 -activebackground "$GuiColor(btn_act_bg)" \
    -relief {flat} \
    -text { Red} \
    -value {0} \
    -variable {util(eq_band)}

  # build widget $topwin(util_name).info.frame9.radiobutton15
	radiobutton $topwin(util_name).info.frame9.radiobutton15 -padx {1} -pady {1} -highlightthickness {0}  \
    -background "$GuiColor(btn_bg)" \
	 -activebackground "$GuiColor(btn_act_bg)" \
    -relief {flat} \
    -text { Green} \
    -value {1} \
    -variable {util(eq_band)}

  # build widget $topwin(util_name).info.frame9.radiobutton16
	radiobutton $topwin(util_name).info.frame9.radiobutton16 -padx {1} -pady {1} -highlightthickness {0}  \
    -background "$GuiColor(btn_bg)" \
	 -activebackground "$GuiColor(btn_act_bg)" \
    -relief {flat} \
    -text { Blue} \
    -value {2} \
    -variable {util(eq_band)}

  # pack widget $topwin(util_name).info.frame9
  pack append $topwin(util_name).info.frame9 \
    $topwin(util_name).info.frame9.radiobutton10 {left frame center expand} \
    $topwin(util_name).info.frame9.radiobutton14 {left frame center expand} \
    $topwin(util_name).info.frame9.radiobutton15 {left frame center expand} \
    $topwin(util_name).info.frame9.radiobutton16 {left frame center expand}

  # pack widget $topwin(util_name).info
  pack append $topwin(util_name).info \
    $topwin(util_name).info.frame3 {top frame center expand fill} \
    $topwin(util_name).info.frame9 {top frame center expand fill}

  # build widget $topwin(util_name).perform
  frame $topwin(util_name).perform \
    -background "$GuiColor(frame_bg)" \
    -borderwidth {2} \
    -relief {raised}

  # build widget $topwin(util_name).perform.perform1
	button $topwin(util_name).perform.perform1 -padx {1} -pady {1} -highlightthickness {0}  \
    -foreground "$GuiColor(perf_fg)" \
    -background "$GuiColor(perf_bg)" \
	 -activebackground "$GuiColor(perf_act_bg)" \
    -command {
		set new_name ""
		$topwin(util_name) configure -cursor watch; update
      if { $current_image == ""} {
         CvipAlert "Please select an image first."
			$topwin(util_name) configure -cursor top_left_arrow; update
         return
      } 
   	if {$bands == "1"} {
			if [catch {set result [cvip histeq $current_image]} cresult] {
         CvipAlert "$cresult."
			$topwin(util_name) configure -cursor top_left_arrow; update
         return
			}	
			set temp "cvip rename $result [append new_name $current_image _heq]"
			set new_name [eval $temp ]
			img_q insert end $new_name
			image_post $new_name
			cvip view $new_name
			CvipMessage "histogram equalization performed on image \"$current_image\""
			$topwin(util_name) configure -cursor top_left_arrow; update
			return
		}

		if {$bands == "3" && $util(eq_band) == "3"} {
			if [catch {set temp1 [cvip cxform $current_image HSL 1 1 1]} cresult] {
         CvipAlert "$cresult."
			$topwin(util_name) configure -cursor top_left_arrow; update
         return
			} elseif [catch { set temp2 [cvip histeq $temp1 2] } cresult] {
         CvipAlert "$cresult."
			$topwin(util_name) configure -cursor top_left_arrow; update
         return
			} elseif [catch { cvip dq $temp1 } cresult ] {
         CvipAlert "$cresult."
			$topwin(util_name) configure -cursor top_left_arrow; update
         return
			} elseif [catch {set result [cvip cxform $temp2 HSL 0 1 1]} cresult] {
         CvipAlert "$cresult."
			$topwin(util_name) configure -cursor top_left_arrow; update
         return
			} elseif [catch {cvip dq $temp2} cresult] {
         CvipAlert "$cresult."
			$topwin(util_name) configure -cursor top_left_arrow; update
         return
			}
			set temp "cvip rename $result [append new_name $current_image _heqVal]"
			set new_name [eval $temp]
			img_q insert end $new_name
			image_post $new_name
			cvip view $new_name
			CvipMessage "histogram equalization performed on image \"$current_image\""
			unset temp1
			unset temp2
			$topwin(util_name) configure -cursor top_left_arrow; update
			return
		}

		if {$bands == "3" && $util(eq_band) != "3"} {
			if [catch {set result [cvip histeq $current_image $util(eq_band)]} cresult] {
         CvipAlert "$cresult."
			$topwin(util_name) configure -cursor top_left_arrow; update
         return
			}
			switch -exact -- $util(eq_band) {
				0 {set eq_color red}
				1 {set eq_color green}
				2 {set eq_color blue}
   		}
			set temp "cvip rename $result [append new_name $current_image _heq_ $eq_color]"
			set new_name [eval $temp]
			img_q insert end $new_name
			image_post $new_name
			cvip view $new_name
			CvipMessage "histogram equalization performed on image \"$current_image\""
		}
	$topwin(util_name) configure -cursor top_left_arrow; update
	 } \
    -text {PERFORM}

  # build widget $topwin(util_name).perform.dismiss
	button $topwin(util_name).perform.dismiss -padx {1} -pady {1} -highlightthickness {0}  \
    -foreground "$GuiColor(dis_fg)" \
    -background "$GuiColor(dis_bg)" \
	 -activebackground "$GuiColor(dis_act_bg)" \
    -command {destroy $topwin(util_name); set topwin(util_name) NONE} \
    -text {DISMISS} \
    -width {10}

  # pack widget $topwin(util_name).perform
  pack append $topwin(util_name).perform \
    $topwin(util_name).perform.dismiss {left frame sw filly} \
    $topwin(util_name).perform.perform1 {right frame se filly}

  # build widget $topwin(util_name).current_image
  frame $topwin(util_name).current_image \
    -background "$GuiColor(frame_bg)" \
    -borderwidth {2} \
    -relief {ridge}

  # build widget $topwin(util_name).current_image.current
  label $topwin(util_name).current_image.current \
    -background "$GuiColor(label_bg)" \
    -text {Current image:}

  # build widget $topwin(util_name).current_image.name
  label $topwin(util_name).current_image.name \
    -background "$GuiColor(rlabel_bg)" \
    -foreground "$GuiColor(rlabel_fg)" \
    -text {} \
    -textvariable {current_image}

  # pack widget $topwin(util_name).current_image
  pack append $topwin(util_name).current_image \
    $topwin(util_name).current_image.current {left frame center} \
    $topwin(util_name).current_image.name {left frame center filly}

  # pack widget $topwin(util_name)
  pack append $topwin(util_name) \
    $topwin(util_name).info {top frame center expand fill} \
    $topwin(util_name).perform {bottom frame center pady 5 fill} \
    $topwin(util_name).current_image {bottom frame center fill}

  if {"[info procs XFEdit]" != ""} {
    catch "XFMiscBindWidgetTree $topwin(util_name)"
    after 2 "catch {XFEditSetShowWindows}"
  }
}


# procedure to show window $topwin(util_name)
proc util_gray_multi { } {# xf ignore me 7
  global GuiColor
  global GuiMisc
  global GUI_DEBUG

  # Window manager configurations
  global tk_version
  global topwin
  global toplevel_position
  if [ winfo exists $topwin(util_name).info] {
     set tempname $topwin(util_name);\
destroy $topwin(util_name).info;\
set topwin(util_name) $tempname;}
  if [ winfo exists $topwin(util_name).current_image] {
     set tempname $topwin(util_name);\
destroy $topwin(util_name).current_image;\
set topwin(util_name) $tempname;}
  if [ winfo exists $topwin(util_name).perform] {
     set tempname $topwin(util_name);\
destroy $topwin(util_name).perform;\
set topwin(util_name) $tempname;}
  wm positionfrom $topwin(util_name) user
  wm sizefrom $topwin(util_name) user
  wm geometry $topwin(util_name) $topwin(util_top)[get_pos $topwin(util_name)]
  wm maxsize $topwin(util_name) [lindex [split $topwin(util_top_max)] 0] \
  	[lindex [split $topwin(util_top_max)] 1]
  wm minsize $topwin(util_name) [lindex [split $topwin(util_top_min)] 0] \
  	[lindex [split $topwin(util_top_min)] 1]
  wm title $topwin(util_name) {UTILITIES -> Enhance -> Brighten/Darken}

  # bindings
  bind $topwin(util_name) <Destroy> {set topwin(util_name) NONE}

  # build widget $topwin(util_name).info
  frame $topwin(util_name).info \
    -background "$GuiColor(frame_bg)" \
    -borderwidth {2}

  # build widget $topwin(util_name).info.frame0
  frame $topwin(util_name).info.frame0 \
    -background "$GuiColor(frame_bg)"

  # build widget $topwin(util_name).info.frame0.label1
  label $topwin(util_name).info.frame0.label1 \
    -anchor {e} \
    -background "$GuiColor(label_bg)" \
    -borderwidth {0} \
    -text {Brightening/Darkening factor: } 

  # build widget $topwin(util_name).info.frame0.value
  entry $topwin(util_name).info.frame0.value \
    -background "$GuiColor(entry_bg)" \
	 -foreground "$GuiColor(entry_fg)" \
    -relief {sunken} \
    -textvariable {util(brighten)} \
    -width {10}
  # bindings
  endEntry $topwin(util_name).info.frame0.value

  # build widget $topwin(util_name).info.frame0.menubutton2
	menubutton $topwin(util_name).info.frame0.menubutton2 -padx {1} -pady {1} -highlightthickness {0}  \
    -background "$GuiColor(btn_bg)" \
	 -activebackground "$GuiColor(btn_act_bg)" \
    -font "$GuiMisc(pop_up_fn)" \
	 -text "$GuiMisc(pop_up_text)" \
	 -relief "$GuiMisc(pop_up_relief)" \
	 -width {2}
  # bindings
  bind $topwin(util_name).info.frame0.menubutton2 <Button-1> {MenuPopupPost $topwin(util_name).info.frame0.menubutton2.menu %X %Y}
  bind $topwin(util_name).info.frame0.menubutton2 <ButtonRelease-1> {MenuPopupRelease $topwin(util_name).info.frame0.menubutton2.menu %W}

  # build widget $topwin(util_name).info.frame0.menubutton2.menu
  menu $topwin(util_name).info.frame0.menubutton2.menu \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)"
  $topwin(util_name).info.frame0.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set util(brighten) 0.2} \
    -label {  0.2}
  $topwin(util_name).info.frame0.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set util(brighten) 0.5} \
    -label {  0.5}
  $topwin(util_name).info.frame0.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set util(brighten) 0.8} \
    -label {  0.8}
  $topwin(util_name).info.frame0.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set util(brighten) 1.2} \
    -label {  1.2}
  $topwin(util_name).info.frame0.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set util(brighten) 1.5} \
    -label {  1.5}
  $topwin(util_name).info.frame0.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set util(brighten) 1.8} \
    -label {  1.8}
  $topwin(util_name).info.frame0.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set util(brighten) 2.0} \
    -label {  2.0}
  $topwin(util_name).info.frame0.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set util(brighten) 2.5} \
    -label {  2.5}
  $topwin(util_name).info.frame0.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set util(brighten) 3.0} \
    -label {  3.0}
  bindtags $topwin(util_name).info.frame0.menubutton2.menu {Menu all}
  # bindings
  bind $topwin(util_name).info.frame0.menubutton2.menu <B1-Motion> {MenuPopupMotion $topwin(util_name).info.frame0.menubutton2.menu %W %X %Y}
  bind $topwin(util_name).info.frame0.menubutton2.menu <ButtonRelease-1> {MenuPopupRelease $topwin(util_name).info.frame0.menubutton2.menu %W}

  # pack widget $topwin(util_name).info.frame0
  pack append $topwin(util_name).info.frame0 \
    $topwin(util_name).info.frame0.label1 {left frame center fill} \
    $topwin(util_name).info.frame0.value {left frame center fill} \
    $topwin(util_name).info.frame0.menubutton2 {right frame center fill}

  # pack widget $topwin(util_name).info
  pack append $topwin(util_name).info \
    $topwin(util_name).info.frame0 {left frame center padx 215}

  # build widget $topwin(util_name).perform
  frame $topwin(util_name).perform \
    -background "$GuiColor(frame_bg)" \
    -borderwidth {2} \
    -relief {raised}

  # build widget $topwin(util_name).perform.perform1
	button $topwin(util_name).perform.perform1 -padx {1} -pady {1} -highlightthickness {0}  \
    -foreground "$GuiColor(perf_fg)" \
    -background "$GuiColor(perf_bg)" \
	 -activebackground "$GuiColor(perf_act_bg)" \
    -command {
		$topwin(util_name) configure -cursor watch; update
		if {$current_image == ""} {
			CvipAlert "Please select an image first."
			$topwin(util_name) configure -cursor top_left_arrow; update
			return
		} elseif [catch {expr $util(brighten)} ] {
			CvipAlert "Numerical value required for brightening/darkening factor.\n Brighten/Darken factor = $util(brighten)"
			$topwin(util_name) configure -cursor top_left_arrow; update
			return
		} elseif { $util(brighten) < 0 } {
			CvipAlert "Brightening/darkening factor should be a non-negative value. \n Brighten/Darken factor = $util(brighten)"
			$topwin(util_name) configure -cursor top_left_arrow; update
			return
		}
		if [catch {set result [cvip gray_multiply $current_image $util(brighten)]} cresult ] {
			CvipAlert "$cresult"
			$topwin(util_name) configure -cursor top_left_arrow; update
			return
		}
		set new_name [cvip rename $result ${current_image}_x$util(brighten)]
		img_q insert end $new_name
		image_post $new_name
		cvip view $new_name
		CvipMessage "image \"$current_image\" is brightened/darkened by factor $util(brighten)"
	$topwin(util_name) configure -cursor top_left_arrow; update
	 } \
    -text {PERFORM}

  # build widget $topwin(util_name).perform.dismiss
	button $topwin(util_name).perform.dismiss -padx {1} -pady {1} -highlightthickness {0}  \
    -foreground "$GuiColor(dis_fg)" \
    -background "$GuiColor(dis_bg)" \
	 -activebackground "$GuiColor(dis_act_bg)" \
    -command {destroy $topwin(util_name); set topwin(util_name) NONE} \
    -text {DISMISS} \
    -width {10}

  # pack widget $topwin(util_name).perform
  pack append $topwin(util_name).perform \
    $topwin(util_name).perform.dismiss {left frame sw filly} \
    $topwin(util_name).perform.perform1 {right frame se filly}

  # build widget $topwin(util_name).current_image
  frame $topwin(util_name).current_image \
    -background "$GuiColor(frame_bg)" \
    -borderwidth {2} \
    -relief {ridge}

  # build widget $topwin(util_name).current_image.current
  label $topwin(util_name).current_image.current \
    -background "$GuiColor(label_bg)" \
    -text {Current image:}

  # build widget $topwin(util_name).current_image.name
  label $topwin(util_name).current_image.name \
    -background "$GuiColor(rlabel_bg)" \
    -foreground "$GuiColor(rlabel_fg)" \
    -text {} \
    -textvariable {current_image}

  # pack widget $topwin(util_name).current_image
  pack append $topwin(util_name).current_image \
    $topwin(util_name).current_image.current {left frame center} \
    $topwin(util_name).current_image.name {left frame center filly}

  # pack widget $topwin(util_name)
  pack append $topwin(util_name) \
    $topwin(util_name).info {top frame center expand fill} \
    $topwin(util_name).perform {bottom frame center pady 5 fill} \
    $topwin(util_name).current_image {bottom frame center fill}

  if {"[info procs XFEdit]" != ""} {
    catch "XFMiscBindWidgetTree $topwin(util_name)"
    after 2 "catch {XFEditSetShowWindows}"
  }
}


# procedure to show window $topwin(util_name)
proc util_pseudo { } {# xf ignore me 7
  global GuiColor
  global GuiMisc
  global GUI_DEBUG

  global tk_version
  global topwin
  global toplevel_position
  if [ winfo exists $topwin(util_name).info] {
     set tempname $topwin(util_name);\
destroy $topwin(util_name).info;\
set topwin(util_name) $tempname;}
  if [ winfo exists $topwin(util_name).current_image] {
     set tempname $topwin(util_name);\
destroy $topwin(util_name).current_image;\
set topwin(util_name) $tempname;}
  if [ winfo exists $topwin(util_name).perform] {
     set tempname $topwin(util_name);\
destroy $topwin(util_name).perform;\
set topwin(util_name) $tempname;}
  wm positionfrom $topwin(util_name) user
  wm sizefrom $topwin(util_name) user
  wm geometry $topwin(util_name) $topwin(util_top)[get_pos $topwin(util_name)]
  wm maxsize $topwin(util_name) [lindex [split $topwin(util_top_max)] 0] \
  	[lindex [split $topwin(util_top_max)] 1]
  wm minsize $topwin(util_name) [lindex [split $topwin(util_top_min)] 0] \
  	[lindex [split $topwin(util_top_min)] 1]
  wm title $topwin(util_name) "UTILITIES -> Enhance -> Pseudo color"


  # bindings
  bind $topwin(util_name) <Destroy> {set topwin(util_name) NONE}

  # build widget $topwin(util_name).info
  frame $topwin(util_name).info \
    -background "$GuiColor(frame_bg)" \
    -borderwidth {2}

  # build widget $topwin(util_name).info.frame3
  frame $topwin(util_name).info.frame3 \
    -background "$GuiColor(frame_bg)" \
    -borderwidth {2} \
    -relief {groove}

  # build widget $topwin(util_name).info.frame3.frame3
  frame $topwin(util_name).info.frame3.frame3 \
    -background "$GuiColor(frame_bg)"

  # build widget $topwin(util_name).info.frame3.frame3.frame0
  frame $topwin(util_name).info.frame3.frame3.frame0 \
    -background "$GuiColor(frame_bg)" \
    -relief {sunken}

  # build widget $topwin(util_name).info.frame3.frame3.frame0.label1
  label $topwin(util_name).info.frame3.frame3.frame0.label1 \
    -background "$GuiColor(label_bg)" \
    -borderwidth {0} \
    -text {Low cutoff frequency: }

  # build widget $topwin(util_name).info.frame3.frame3.frame0.value
  entry $topwin(util_name).info.frame3.frame3.frame0.value \
    -background "$GuiColor(entry_bg)" \
	 -foreground "$GuiColor(entry_fg)" \
    -relief {sunken} \
    -textvariable {util(pseudo_lcf)} \
    -width {5}
  # bindings
  endEntry $topwin(util_name).info.frame3.frame3.frame0.value 0\
    $topwin(util_name).info.frame3.frame3.frame6.value \
    $topwin(util_name).info.frame3.frame3.frame6.value 

  # build widget $topwin(util_name).info.frame3.frame3.frame0.menubutton2
	menubutton $topwin(util_name).info.frame3.frame3.frame0.menubutton2 -padx {1} -pady {1} -highlightthickness {0}  \
    -background "$GuiColor(btn_bg)" \
	 -activebackground "$GuiColor(btn_act_bg)" \
    -font "$GuiMisc(pop_up_fn)" \
	 -text "$GuiMisc(pop_up_text)" \
	 -relief "$GuiMisc(pop_up_relief)" \
	 -width {2}
  # bindings
  bind $topwin(util_name).info.frame3.frame3.frame0.menubutton2 <Button-1> {MenuPopupPost $topwin(util_name).info.frame3.frame3.frame0.menubutton2.menu %X %Y}
  bind $topwin(util_name).info.frame3.frame3.frame0.menubutton2 <ButtonRelease-1> {MenuPopupRelease $topwin(util_name).info.frame3.frame3.frame0.menubutton2.menu %W}

  # build widget $topwin(util_name).info.frame3.frame3.frame0.menubutton2.menu
  menu $topwin(util_name).info.frame3.frame3.frame0.menubutton2.menu \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)"
  $topwin(util_name).info.frame3.frame3.frame0.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set util(pseudo_lcf) 0} \
    -label {  0 }
  $topwin(util_name).info.frame3.frame3.frame0.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set util(pseudo_lcf) 10} \
    -label { 10}
  $topwin(util_name).info.frame3.frame3.frame0.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set util(pseudo_lcf) 30} \
    -label { 30}
  $topwin(util_name).info.frame3.frame3.frame0.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set util(pseudo_lcf) 50} \
    -label { 50}
  $topwin(util_name).info.frame3.frame3.frame0.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set util(pseudo_lcf) 100} \
    -label {100}
  $topwin(util_name).info.frame3.frame3.frame0.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set util(pseudo_lcf) 200} \
    -label {200}
  $topwin(util_name).info.frame3.frame3.frame0.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set util(pseudo_lcf) 500} \
    -label {500}
  bindtags $topwin(util_name).info.frame3.frame3.frame0.menubutton2.menu {Menu all}
  # bindings
  bind $topwin(util_name).info.frame3.frame3.frame0.menubutton2.menu <B1-Motion> {MenuPopupMotion $topwin(util_name).info.frame3.frame3.frame0.menubutton2.menu %W %X %Y}
  bind $topwin(util_name).info.frame3.frame3.frame0.menubutton2.menu <ButtonRelease-1> {MenuPopupRelease $topwin(util_name).info.frame3.frame3.frame0.menubutton2.menu %W}

  # pack widget $topwin(util_name).info.frame3.frame3.frame0
  pack append $topwin(util_name).info.frame3.frame3.frame0 \
    $topwin(util_name).info.frame3.frame3.frame0.label1 {left frame center fill} \
    $topwin(util_name).info.frame3.frame3.frame0.value {left frame center expand fill} \
    $topwin(util_name).info.frame3.frame3.frame0.menubutton2 {right frame center fill}

  # build widget $topwin(util_name).info.frame3.frame3.frame6
  frame $topwin(util_name).info.frame3.frame3.frame6 \
    -background "$GuiColor(frame_bg)" \
    -relief {sunken}

  # build widget $topwin(util_name).info.frame3.frame3.frame6.label1
  label $topwin(util_name).info.frame3.frame3.frame6.label1 \
    -background "$GuiColor(label_bg)" \
    -borderwidth {0} \
    -text {High cutoff frequency: }

  # build widget $topwin(util_name).info.frame3.frame3.frame6.value
  entry $topwin(util_name).info.frame3.frame3.frame6.value \
    -background "$GuiColor(entry_bg)" \
	 -foreground "$GuiColor(entry_fg)" \
    -relief {sunken} \
    -textvariable {util(pseudo_hcf)} \
    -width {5}
  # bindings
  endEntry $topwin(util_name).info.frame3.frame3.frame6.value 0\
    $topwin(util_name).info.frame3.frame3.frame0.value \
    $topwin(util_name).info.frame3.frame3.frame0.value 

  # build widget $topwin(util_name).info.frame3.frame3.frame6.menubutton2
	menubutton $topwin(util_name).info.frame3.frame3.frame6.menubutton2 -padx {1} -pady {1} -highlightthickness {0}  \
    -background "$GuiColor(btn_bg)" \
	 -activebackground "$GuiColor(btn_act_bg)" \
    -font "$GuiMisc(pop_up_fn)" \
	 -text "$GuiMisc(pop_up_text)" \
	 -relief "$GuiMisc(pop_up_relief)" \
	 -width {2}
  # bindings
  bind $topwin(util_name).info.frame3.frame3.frame6.menubutton2 <Button-1> {MenuPopupPost $topwin(util_name).info.frame3.frame3.frame6.menubutton2.menu %X %Y}
  bind $topwin(util_name).info.frame3.frame3.frame6.menubutton2 <ButtonRelease-1> {MenuPopupRelease $topwin(util_name).info.frame3.frame3.frame6.menubutton2.menu %W}

  # build widget $topwin(util_name).info.frame3.frame3.frame6.menubutton2.menu
  menu $topwin(util_name).info.frame3.frame3.frame6.menubutton2.menu \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)"
  $topwin(util_name).info.frame3.frame3.frame6.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set util(pseudo_hcf) 100} \
    -label { 100}
  $topwin(util_name).info.frame3.frame3.frame6.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set util(pseudo_hcf) 200} \
    -label { 200}
  $topwin(util_name).info.frame3.frame3.frame6.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set util(pseudo_hcf) 500} \
    -label { 500}
  $topwin(util_name).info.frame3.frame3.frame6.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set util(pseudo_hcf) 1000} \
    -label {1000}
  $topwin(util_name).info.frame3.frame3.frame6.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set util(pseudo_hcf) 2000} \
    -label {2000}
  bindtags $topwin(util_name).info.frame3.frame3.frame6.menubutton2.menu  {Menu all}
  # bindings
  bind $topwin(util_name).info.frame3.frame3.frame6.menubutton2.menu <B1-Motion> {MenuPopupMotion $topwin(util_name).info.frame3.frame3.frame6.menubutton2.menu %W %X %Y}
  bind $topwin(util_name).info.frame3.frame3.frame6.menubutton2.menu <ButtonRelease-1> {MenuPopupRelease $topwin(util_name).info.frame3.frame3.frame6.menubutton2.menu %W}

  # pack widget $topwin(util_name).info.frame3.frame3.frame6
  pack append $topwin(util_name).info.frame3.frame3.frame6 \
    $topwin(util_name).info.frame3.frame3.frame6.label1 {left frame center fill} \
    $topwin(util_name).info.frame3.frame3.frame6.value {left frame center expand fill} \
    $topwin(util_name).info.frame3.frame3.frame6.menubutton2 {right frame center fill}

  # pack widget $topwin(util_name).info.frame3.frame3
  pack append $topwin(util_name).info.frame3.frame3 \
    $topwin(util_name).info.frame3.frame3.frame0 {left frame center padx 11} \
    $topwin(util_name).info.frame3.frame3.frame6 {left frame center padx 9}

  # build widget $topwin(util_name).info.frame3.frame7
  frame $topwin(util_name).info.frame3.frame7 \
    -background "$GuiColor(frame_bg)"

  # build widget $topwin(util_name).info.frame3.frame7.frame0
  frame $topwin(util_name).info.frame3.frame7.frame0 \
    -background "$GuiColor(frame_bg)" \
    -relief {sunken}

  # build widget $topwin(util_name).info.frame3.frame7.frame0.label1
  label $topwin(util_name).info.frame3.frame7.frame0.label1 \
    -background "$GuiColor(label_bg)" \
    -borderwidth {0} \
    -text {Low-pass color: }

  # build widget $topwin(util_name).info.frame3.frame7.frame0.value
  entry $topwin(util_name).info.frame3.frame7.frame0.value \
    -background "$GuiColor(rentry_bg)" \
	 -foreground "$GuiColor(rentry_fg)" \
	 -state {disabled }\
    -relief {sunken} \
    -textvariable {util(pseudo_lpc)} \
    -width {3}
  # bindings
  bind $topwin(util_name).info.frame3.frame7.frame0.value <Key-Return> { focus $topwin(util_name).info.frame3.frame7.frame8.value }

  # build widget $topwin(util_name).info.frame3.frame7.frame0.menubutton2
	menubutton $topwin(util_name).info.frame3.frame7.frame0.menubutton2 -padx {1} -pady {1} -highlightthickness {0}  \
    -background "$GuiColor(btn_bg)" \
	 -activebackground "$GuiColor(btn_act_bg)" \
    -font "$GuiMisc(pop_up_fn)" \
	 -text "$GuiMisc(pop_up_text)" \
	 -relief "$GuiMisc(pop_up_relief)" \
	 -width {2}
  # bindings
  bind $topwin(util_name).info.frame3.frame7.frame0.menubutton2 <Button-1> {MenuPopupPost $topwin(util_name).info.frame3.frame7.frame0.menubutton2.menu %X %Y}
  bind $topwin(util_name).info.frame3.frame7.frame0.menubutton2 <ButtonRelease-1> {MenuPopupRelease $topwin(util_name).info.frame3.frame7.frame0.menubutton2.menu %W}

  # build widget $topwin(util_name).info.frame3.frame7.frame0.menubutton2.menu
  menu $topwin(util_name).info.frame3.frame7.frame0.menubutton2.menu \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)"
  $topwin(util_name).info.frame3.frame7.frame0.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set util(pseudo_lpc) R} \
    -label {  red }
  $topwin(util_name).info.frame3.frame7.frame0.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set util(pseudo_lpc) G} \
    -label { green}
  $topwin(util_name).info.frame3.frame7.frame0.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set util(pseudo_lpc) B} \
    -label {  blue}
  bindtags $topwin(util_name).info.frame3.frame7.frame0.menubutton2.menu {Menu all}
  # bindings
  bind $topwin(util_name).info.frame3.frame7.frame0.menubutton2.menu <B1-Motion> {MenuPopupMotion $topwin(util_name).info.frame3.frame7.frame0.menubutton2.menu %W %X %Y}
  bind $topwin(util_name).info.frame3.frame7.frame0.menubutton2.menu <ButtonRelease-1> {MenuPopupRelease $topwin(util_name).info.frame3.frame7.frame0.menubutton2.menu %W}

  # pack widget $topwin(util_name).info.frame3.frame7.frame0
  pack append $topwin(util_name).info.frame3.frame7.frame0 \
    $topwin(util_name).info.frame3.frame7.frame0.label1 {left frame center fill} \
    $topwin(util_name).info.frame3.frame7.frame0.value {left frame center expand fill} \
    $topwin(util_name).info.frame3.frame7.frame0.menubutton2 {right frame center fill}

  # build widget $topwin(util_name).info.frame3.frame7.frame8
  frame $topwin(util_name).info.frame3.frame7.frame8 \
    -background "$GuiColor(frame_bg)" \
    -relief {sunken}

  # build widget $topwin(util_name).info.frame3.frame7.frame8.label1
  label $topwin(util_name).info.frame3.frame7.frame8.label1 \
    -background "$GuiColor(label_bg)" \
    -borderwidth {0} \
    -text {Band-pass color: }

  # build widget $topwin(util_name).info.frame3.frame7.frame8.value
  entry $topwin(util_name).info.frame3.frame7.frame8.value \
    -background "$GuiColor(rentry_bg)" \
	 -foreground "$GuiColor(rentry_fg)" \
	 -state {disabled }\
    -relief {sunken} \
    -textvariable {util(pseudo_bpc)} \
    -width {3}
  # bindings
  bind $topwin(util_name).info.frame3.frame7.frame8.value <Key-Return> { focus $topwin(util_name).info.frame3.frame7.frame9.value }

  # build widget $topwin(util_name).info.frame3.frame7.frame8.menubutton2
	menubutton $topwin(util_name).info.frame3.frame7.frame8.menubutton2 -padx {1} -pady {1} -highlightthickness {0}  \
    -background "$GuiColor(btn_bg)" \
	 -activebackground "$GuiColor(btn_act_bg)" \
    -font "$GuiMisc(pop_up_fn)" \
	 -text "$GuiMisc(pop_up_text)" \
	 -relief "$GuiMisc(pop_up_relief)" \
	 -width {2}
  # bindings
  bind $topwin(util_name).info.frame3.frame7.frame8.menubutton2 <Button-1> {MenuPopupPost $topwin(util_name).info.frame3.frame7.frame8.menubutton2.menu %X %Y}
  bind $topwin(util_name).info.frame3.frame7.frame8.menubutton2 <ButtonRelease-1> {MenuPopupRelease $topwin(util_name).info.frame3.frame7.frame8.menubutton2.menu %W}

  # build widget $topwin(util_name).info.frame3.frame7.frame8.menubutton2.menu
  menu $topwin(util_name).info.frame3.frame7.frame8.menubutton2.menu \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)"
  $topwin(util_name).info.frame3.frame7.frame8.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set util(pseudo_bpc) R} \
    -label {  red }
  $topwin(util_name).info.frame3.frame7.frame8.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set util(pseudo_bpc) G} \
    -label { green}
  $topwin(util_name).info.frame3.frame7.frame8.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set util(pseudo_bpc) B} \
    -label {  blue}
  bindtags $topwin(util_name).info.frame3.frame7.frame8.menubutton2.menu {Menu all}
  # bindings
  bind $topwin(util_name).info.frame3.frame7.frame8.menubutton2.menu <B1-Motion> {MenuPopupMotion $topwin(util_name).info.frame3.frame7.frame8.menubutton2.menu %W %X %Y}
  bind $topwin(util_name).info.frame3.frame7.frame8.menubutton2.menu <ButtonRelease-1> {MenuPopupRelease $topwin(util_name).info.frame3.frame7.frame8.menubutton2.menu %W}

  # pack widget $topwin(util_name).info.frame3.frame7.frame8
  pack append $topwin(util_name).info.frame3.frame7.frame8 \
    $topwin(util_name).info.frame3.frame7.frame8.label1 {left frame center fill} \
    $topwin(util_name).info.frame3.frame7.frame8.value {left frame center expand fill} \
    $topwin(util_name).info.frame3.frame7.frame8.menubutton2 {right frame center fill}

  # build widget $topwin(util_name).info.frame3.frame7.frame9
  frame $topwin(util_name).info.frame3.frame7.frame9 \
    -background "$GuiColor(frame_bg)" \
    -relief {sunken}

  # build widget $topwin(util_name).info.frame3.frame7.frame9.label1
  label $topwin(util_name).info.frame3.frame7.frame9.label1 \
    -background "$GuiColor(label_bg)" \
    -borderwidth {0} \
    -text {High-pass color: }

  # build widget $topwin(util_name).info.frame3.frame7.frame9.value
  entry $topwin(util_name).info.frame3.frame7.frame9.value \
    -background "$GuiColor(rentry_bg)" \
	 -foreground "$GuiColor(rentry_fg)" \
	 -state {disabled }\
    -relief {sunken} \
    -textvariable {util(pseudo_hpc)} \
    -width {3}
  # bindings
  bind $topwin(util_name).info.frame3.frame7.frame9.value <Key-Return> { 
	  set temp [%W get]
	  %W delete 0 end
	  %W insert 0 $temp
	  }

  # build widget $topwin(util_name).info.frame3.frame7.frame9.menubutton2
	menubutton $topwin(util_name).info.frame3.frame7.frame9.menubutton2 -padx {1} -pady {1} -highlightthickness {0}  \
    -background "$GuiColor(btn_bg)" \
	 -activebackground "$GuiColor(btn_act_bg)" \
    -font "$GuiMisc(pop_up_fn)" \
	 -text "$GuiMisc(pop_up_text)" \
	 -relief "$GuiMisc(pop_up_relief)" \
	 -width {2}
  # bindings
  bind $topwin(util_name).info.frame3.frame7.frame9.menubutton2 <Button-1> {MenuPopupPost $topwin(util_name).info.frame3.frame7.frame9.menubutton2.menu %X %Y}
  bind $topwin(util_name).info.frame3.frame7.frame9.menubutton2 <ButtonRelease-1> {MenuPopupRelease $topwin(util_name).info.frame3.frame7.frame9.menubutton2.menu %W}

  # build widget $topwin(util_name).info.frame3.frame7.frame9.menubutton2.menu
  menu $topwin(util_name).info.frame3.frame7.frame9.menubutton2.menu \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)"
  $topwin(util_name).info.frame3.frame7.frame9.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set util(pseudo_hpc) R} \
    -label {  red }
  $topwin(util_name).info.frame3.frame7.frame9.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set util(pseudo_hpc) G} \
    -label { green}
  $topwin(util_name).info.frame3.frame7.frame9.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set util(pseudo_hpc) B} \
    -label {  blue}
  bindtags $topwin(util_name).info.frame3.frame7.frame9.menubutton2.menu  {Menu all}
  # bindings
  bind $topwin(util_name).info.frame3.frame7.frame9.menubutton2.menu <B1-Motion> {MenuPopupMotion $topwin(util_name).info.frame3.frame7.frame9.menubutton2.menu %W %X %Y}
  bind $topwin(util_name).info.frame3.frame7.frame9.menubutton2.menu <ButtonRelease-1> {MenuPopupRelease $topwin(util_name).info.frame3.frame7.frame9.menubutton2.menu %W}

  # pack widget $topwin(util_name).info.frame3.frame7.frame9
  pack append $topwin(util_name).info.frame3.frame7.frame9 \
    $topwin(util_name).info.frame3.frame7.frame9.label1 {left frame center fill} \
    $topwin(util_name).info.frame3.frame7.frame9.value {left frame center expand fill} \
    $topwin(util_name).info.frame3.frame7.frame9.menubutton2 {right frame center fill}

  # pack widget $topwin(util_name).info.frame3.frame7
  pack append $topwin(util_name).info.frame3.frame7 \
    $topwin(util_name).info.frame3.frame7.frame0 {left frame center padx 11} \
    $topwin(util_name).info.frame3.frame7.frame8 {left frame center padx 11} \
    $topwin(util_name).info.frame3.frame7.frame9 {left frame center padx 11}

  # pack widget $topwin(util_name).info.frame3
  pack append $topwin(util_name).info.frame3 \
    $topwin(util_name).info.frame3.frame3 {top frame center expand fill} \
    $topwin(util_name).info.frame3.frame7 {top frame center expand fill}

  # pack widget $topwin(util_name).info
  pack append $topwin(util_name).info \
    $topwin(util_name).info.frame3 {top frame center expand fill}

  # build widget $topwin(util_name).perform
  frame $topwin(util_name).perform \
    -background "$GuiColor(frame_bg)" \
    -borderwidth {2} \
    -relief {raised}

  # build widget $topwin(util_name).perform.perform1
	button $topwin(util_name).perform.perform1 -padx {1} -pady {1} -highlightthickness {0}  \
    -foreground "$GuiColor(perf_fg)" \
    -background "$GuiColor(perf_bg)" \
	 -activebackground "$GuiColor(perf_act_bg)" \
    -command {
		$topwin(util_name) configure -cursor watch; update
      if { $current_image == ""} {
         CvipAlert "Please select an image first."
			$topwin(util_name) configure -cursor top_left_arrow; update
         return
      } 

		if { $bands != "1" } {
     	    CvipAlert "Pseudo color  applies to gray level image only."
			$topwin(util_name) configure -cursor top_left_arrow; update
        	 return
		} 

		if [catch {expr $util(pseudo_lcf) + $util(pseudo_hcf)} ] {
			CvipAlert "Numerical values required for conversion parameters:\n \
				Low cutoff frequency =$util(pseudo_lcf), High cutoff frequency= $util(pseudo_hcf)."
				$topwin(util_name) configure -cursor top_left_arrow; update
				return
		}

		if {$util(pseudo_lcf) > $util(pseudo_hcf) } {
     	   CvipAlert "High cutoff frequency ( $util(pseudo_hcf) ) must be greater\
			than low  cutoff frequency ( $util(pseudo_lcf) )."
			$topwin(util_name) configure -cursor top_left_arrow; update
		   return
		}

		if {$util(pseudo_lpc) == $util(pseudo_bpc) || $util(pseudo_bpc) == $util(pseudo_hpc)\
			|| $util(pseudo_hpc) == $util(pseudo_lpc) } {
	       CvipAlert "Please use different colors for different bands:\n\
			 Low pass color = $util(pseudo_lpc), Band pass color = $util(pseudo_bpc),\
			 High pass color = $util(pseudo_hpc)."
			$topwin(util_name) configure -cursor top_left_arrow; update
			 return
		}

      set temp "cvip pseudocol_freq $current_image $util(pseudo_lcf) $util(pseudo_hcf) "
      if { $util(pseudo_lpc) ==  "R" } {
         append temp "0 "
      } elseif { $util(pseudo_lpc) ==  "G" } {
         append temp "1 "
      } else {
         append temp "2 "
      }
      if { $util(pseudo_bpc) ==  "R" } {
         append temp "0 "
      } elseif { $util(pseudo_bpc) ==  "G" } {
         append temp "1 "
      } else {
         append temp "2 "
      }
      if { $util(pseudo_hpc) ==  "R" } {
         append temp "0"
      } elseif { $util(pseudo_hpc) ==  "G" } {
         append temp "1"
      } else {
         append temp "2"
      }

		if { $GUI_DEBUG == "1" } {
      	puts stderr $temp
		}

		if [catch {set result [eval $temp]} cresult] {
		   CvipAlert "$cresult."
			$topwin(util_name) configure -cursor top_left_arrow; update
     	   return
		}
     	set new_name [cvip rename $result ${current_image}_pseudo]       
     	img_q insert end $new_name
		image_post $new_name
		CvipMessage "pseudo-coloring performed on image \"$current_image\""
		cvip view $new_name
	$topwin(util_name) configure -cursor top_left_arrow; update
	 } \
    -text {PERFORM}

  # build widget $topwin(util_name).perform.dismiss
	button $topwin(util_name).perform.dismiss -padx {1} -pady {1} -highlightthickness {0}  \
    -foreground "$GuiColor(dis_fg)" \
    -background "$GuiColor(dis_bg)" \
	 -activebackground "$GuiColor(dis_act_bg)" \
    -command {destroy $topwin(util_name); set topwin(util_name) NONE} \
    -text {DISMISS} \
    -width {10}

  # pack widget $topwin(util_name).perform
  pack append $topwin(util_name).perform \
    $topwin(util_name).perform.dismiss {left frame center filly} \
    $topwin(util_name).perform.perform1 {right frame center filly}

  # build widget $topwin(util_name).current_image
  frame $topwin(util_name).current_image \
    -background "$GuiColor(frame_bg)" \
    -borderwidth {2} \
    -relief {ridge}

  # build widget $topwin(util_name).current_image.current
  label $topwin(util_name).current_image.current \
    -background "$GuiColor(label_bg)" \
    -text {Current image:}

  # build widget $topwin(util_name).current_image.name
  label $topwin(util_name).current_image.name \
    -background "$GuiColor(rlabel_bg)" \
    -foreground "$GuiColor(rlabel_fg)" \
    -text {} \
    -textvariable {current_image}

  # pack widget $topwin(util_name).current_image
  pack append $topwin(util_name).current_image \
    $topwin(util_name).current_image.current {left frame center} \
    $topwin(util_name).current_image.name {left frame center filly}

  # pack widget $topwin(util_name)
  pack append $topwin(util_name) \
    $topwin(util_name).info {top frame center expand fill} \
    $topwin(util_name).perform {bottom frame center pady 5 fill} \
    $topwin(util_name).current_image {bottom frame center fill}

  if {"[info procs XFEdit]" != ""} {
    catch "XFMiscBindWidgetTree $topwin(util_name)"
    after 2 "catch {XFEditSetShowWindows}"
  }
}


proc util_edge { } {# xf ignore me 7
  global GuiColor
  global GuiMisc
  global GUI_DEBUG

  global tk_version
  global topwin
  global toplevel_position
  if [ winfo exists $topwin(util_name).info] {
     set tempname $topwin(util_name);\
destroy $topwin(util_name).info;\
set topwin(util_name) $tempname;}
  if [ winfo exists $topwin(util_name).current_image] {
     set tempname $topwin(util_name);\
destroy $topwin(util_name).current_image;\
set topwin(util_name) $tempname;}
  if [ winfo exists $topwin(util_name).perform] {
     set tempname $topwin(util_name);\
destroy $topwin(util_name).perform;\
set topwin(util_name) $tempname;}
  wm positionfrom $topwin(util_name) user
  wm sizefrom $topwin(util_name) user
  wm geometry $topwin(util_name) $topwin(util_top)[get_pos $topwin(util_name)]
  wm maxsize $topwin(util_name) [lindex [split $topwin(util_top_max)] 0] \
  	[lindex [split $topwin(util_top_max)] 1]
  wm minsize $topwin(util_name) [lindex [split $topwin(util_top_min)] 0] \
  	[lindex [split $topwin(util_top_min)] 1]
  wm title $topwin(util_name) "UTILITIES -> Enhance -> Edge enhancement"

  # bindings
  bind $topwin(util_name) <Destroy> {set topwin(util_name) NONE}

  # build widget $topwin(util_name).info
  frame $topwin(util_name).info \
    -background "$GuiColor(frame_bg)" \
    -borderwidth {2}

  # build widget $topwin(util_name).info.frame0
  frame $topwin(util_name).info.frame0 \
    -background "$GuiColor(frame_bg)" \
    -borderwidth {2}

  # build widget $topwin(util_name).info.frame0.frame1
  frame $topwin(util_name).info.frame0.frame1 \
    -background "$GuiColor(frame_bg)" \
    -borderwidth {2}

  # build widget $topwin(util_name).info.frame0.frame1.label1
  label $topwin(util_name).info.frame0.frame1.label1 \
    -background "$GuiColor(label_bg)" \
    -borderwidth {0} \
    -relief {sunken} \
    -text {Transform: }

  # build widget $topwin(util_name).info.frame0.frame1.value
  entry $topwin(util_name).info.frame0.frame1.value \
    -background "$GuiColor(rentry_bg)" \
	 -foreground "$GuiColor(rentry_fg)" \
    -relief {sunken} \
    -state {disabled} \
    -textvariable {util(transform)} \
    -width {8}

  # build widget $topwin(util_name).info.frame0.frame1.menubutton2
	menubutton $topwin(util_name).info.frame0.frame1.menubutton2 -padx {1} -pady {1} -highlightthickness {0}  \
    -background "$GuiColor(btn_bg)" \
	 -activebackground "$GuiColor(btn_act_bg)" \
    -font "$GuiMisc(pop_up_fn)" \
	 -text "$GuiMisc(pop_up_text)" \
	 -relief "$GuiMisc(pop_up_relief)" \
	 -width {2}
  # bindings
  bind $topwin(util_name).info.frame0.frame1.menubutton2 <Button-1> {MenuPopupPost $topwin(util_name).info.frame0.frame1.menubutton2.menu %X %Y}
  bind $topwin(util_name).info.frame0.frame1.menubutton2 <ButtonRelease-1> {MenuPopupRelease $topwin(util_name).info.frame0.frame1.menubutton2.menu %W}

  # build widget $topwin(util_name).info.frame0.frame1.menubutton2.menu
  menu $topwin(util_name).info.frame0.frame1.menubutton2.menu \
    -activebackground {gray70} \
    -background {gray90}
  $topwin(util_name).info.frame0.frame1.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set util(transform) fft} \
    -label {fft }
  $topwin(util_name).info.frame0.frame1.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set util(transform) dct} \
    -label {dct }
  $topwin(util_name).info.frame0.frame1.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set util(transform) haar} \
    -label {haar }
  $topwin(util_name).info.frame0.frame1.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set util(transform) walsh} \
    -label {walsh }
  $topwin(util_name).info.frame0.frame1.menubutton2.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set util(transform) hadamard} \
    -label {hadamard}
  bindtags $topwin(util_name).info.frame0.frame1.menubutton2.menu {Menu all}
  # bindings
  bind $topwin(util_name).info.frame0.frame1.menubutton2.menu <B1-Motion> {MenuPopupMotion $topwin(util_name).info.frame0.frame1.menubutton2.menu %W %X %Y}
  bind $topwin(util_name).info.frame0.frame1.menubutton2.menu <ButtonRelease-1> {MenuPopupRelease $topwin(util_name).info.frame0.frame1.menubutton2.menu %W}

  # pack widget $topwin(util_name).info.frame0.frame1
  pack append $topwin(util_name).info.frame0.frame1 \
    $topwin(util_name).info.frame0.frame1.label1 {left frame center fill} \
    $topwin(util_name).info.frame0.frame1.value {left frame center expand fill} \
    $topwin(util_name).info.frame0.frame1.menubutton2 {right frame center fill}

  # build widget $topwin(util_name).info.frame0.radiobutton18
	radiobutton $topwin(util_name).info.frame0.radiobutton18 -padx {1} -pady {1} -highlightthickness {0}  \
    -background "$GuiColor(btn_bg)" \
	 -activebackground "$GuiColor(btn_act_bg)" \
    -relief {flat} \
    -text {High frequency emphasize} \
    -value {hfe_filter} \
    -variable {util(sharp)} \
    -width {22}

  # pack widget $topwin(util_name).info.frame0
  pack append $topwin(util_name).info.frame0 \
    $topwin(util_name).info.frame0.radiobutton18 {left frame center} \
    $topwin(util_name).info.frame0.frame1 {left frame center padx 26}

  # build widget $topwin(util_name).info.radiobutton5
	radiobutton $topwin(util_name).info.radiobutton5 -padx {1} -pady {1} -highlightthickness {0}  \
    -background "$GuiColor(btn_bg)" \
	 -activebackground "$GuiColor(btn_act_bg)" \
    -relief {flat} \
    -text {Unsharp masking} \
    -value {unsharp} \
    -variable {util(sharp)}

  # build widget $topwin(util_name).info.radiobutton7
	radiobutton $topwin(util_name).info.radiobutton7 -padx {1} -pady {1} -highlightthickness {0}  \
    -background "$GuiColor(btn_bg)" \
	 -activebackground "$GuiColor(btn_act_bg)" \
    -relief {flat} \
    -text {FFT sharpening} \
    -value {fft} \
    -variable {util(sharp)}

  # build widget $topwin(util_name).info.radiobutton9
	radiobutton $topwin(util_name).info.radiobutton9 -padx {1} -pady {1} -highlightthickness {0}  \
    -background "$GuiColor(btn_bg)" \
	 -activebackground "$GuiColor(btn_act_bg)" \
    -relief {flat} \
    -text {DCT sharpening} \
    -value {dct} \
    -variable {util(sharp)}

  # pack widget $topwin(util_name).info
  pack append $topwin(util_name).info \
    $topwin(util_name).info.frame0 {top frame center expand fill} \
    $topwin(util_name).info.radiobutton5 {left frame center} \
    $topwin(util_name).info.radiobutton7 {left frame center expand} \
    $topwin(util_name).info.radiobutton9 {left frame center expand}

  # build widget $topwin(util_name).current_image
  frame $topwin(util_name).current_image \
    -background "$GuiColor(frame_bg)" \
    -borderwidth {2} \
    -relief {ridge}

  # build widget $topwin(util_name).current_image.label0
  label $topwin(util_name).current_image.label0 \
    -background "$GuiColor(label_bg)" \
    -text {Current image: }

  # build widget $topwin(util_name).current_image.label1
  label $topwin(util_name).current_image.label1 \
    -background "$GuiColor(rlabel_bg)" \
    -foreground "$GuiColor(rlabel_fg)" \
    -text {cam.pgm} \
    -textvariable {current_image}

  # pack widget $topwin(util_name).current_image
  pack append $topwin(util_name).current_image \
    $topwin(util_name).current_image.label0 {left frame center} \
    $topwin(util_name).current_image.label1 {left frame center}

  # build widget $topwin(util_name).perform
  frame $topwin(util_name).perform \
    -background "$GuiColor(frame_bg)" \
    -borderwidth {2} \
    -relief {raised}

  # build widget $topwin(util_name).perform.button2
	button $topwin(util_name).perform.button2 -padx {1} -pady {1} -highlightthickness {0}  \
    -foreground "$GuiColor(dis_fg)" \
    -background "$GuiColor(dis_bg)" \
	 -activebackground "$GuiColor(dis_act_bg)" \
    -command {destroy $topwin(util_name)} \
    -text {DISMISS}

  # build widget $topwin(util_name).perform.button3
	button $topwin(util_name).perform.button3 -padx {1} -pady {1} -highlightthickness {0}  \
    -foreground "$GuiColor(perf_fg)" \
    -background "$GuiColor(perf_bg)" \
	 -activebackground "$GuiColor(perf_act_bg)" \
    -command {
		set new_name ""
      $topwin(util_name) configure -cursor watch; update
      if {$current_image == ""} {
         CvipAlert "Please select an image first."
         $topwin(util_name) configure -cursor top_left_arrow; update
         return
      }  

      switch -exact  -- $util(sharp) {
			unsharp {
				if [catch {
						set result [cvip unsharp $current_image 0 255 0.025 0.025]
						if { $GUI_DEBUG == "1" } {
							puts stderr "cvip unsharp $current_image 0 255"
						}
					} cresult ] {
         		CvipAlert "$cresult."
					$topwin(util_name) configure -cursor top_left_arrow; update
					return
				}
				set temp [cvip add $result $current_image]
#				set temp1 [cvip hist_stretch $temp 0 255 0.025 0.025]; cvip dq $temp
#				set new_name [cvip rename $temp1 [append new_name $current_image _unsharp]]
				set new_name [cvip rename $temp [append new_name $current_image _unsharp]]
				img_q insert end $new_name
				image_post $new_name
				CvipMessage "unsharp masking performed on image \"$current_image\""
				cvip view $new_name
			}
	
			fft -
			dct {
				if [catch {expr $rows + $cols} ] {
         		CvipAlert "Inappropriate image size:\n Height = $rows, Width = $cols."
					$topwin(util_name) configure -cursor top_left_arrow; update
					return
				}
				set temp [expr { $rows < $cols} ? $cols : $rows ]
				set temp [expr int(pow(2, ceil(log($temp) / log(2.0))))]
				if [catch {
						set temp1 [expr $temp / 16]
						set temp [cvip $util(sharp) $current_image 1 $temp];
						if { $GUI_DEBUG == "1" } {
							puts stderr "cvip $util(sharp) $current_image 1 $temp"
						}
						set temp1 [cvip hpf_filter $temp y BUTTER_HIGH $temp1 1]; cvip dq $temp
						if { $GUI_DEBUG == "1" } {
							puts stderr "cvip hpf_filter $temp y BUTTER_HIGH $temp1 1"
						}
						set result [cvip $util(sharp) $temp1 0 -1]; cvip dq $temp1
						if { $GUI_DEBUG == "1" } {
							puts stderr "cvip $util(sharp) $temp1 0 -1"
						}
					} cresult ] {
         		CvipAlert "$cresult."
					$topwin(util_name) configure -cursor top_left_arrow; update
					return
				}
				set temp [cvip add $result $current_image]
				set new_name [cvip rename $temp [append new_name $current_image _$util(sharp)sharp]]
				img_q insert end $new_name
				image_post $new_name
				cvip view $new_name
				CvipMessage "$util(sharp) sharpening performed on image \"$current_image\""
			}
	
			hfe_filter {
				if [catch {expr $rows + $cols} ] {
         		CvipAlert "Inappropriate image size:\n Height = $rows, Width = $cols."
					$topwin(util_name) configure -cursor top_left_arrow; update
					return
				}
				set temp [expr { $rows < $cols} ? $cols : $rows ]
				set temp [expr int(pow(2, ceil(log($temp) / log(2.0))))]
				if [catch {set temp1 [cvip $util(transform) $current_image 1 $temp]} cresult] {
         		CvipAlert "$cresult."
					$topwin(util_name) configure -cursor top_left_arrow; update
					return
				}
				if { $GUI_DEBUG == "1" } {
					puts stderr "cvip $util(transform) $current_image 1 $temp"
				}

				set temp [expr $temp / 16]
            if [catch {set result [cvip $util(sharp) $temp1 y  $temp 1.5 1];
						if { $GUI_DEBUG == "1" } {
							puts stderr "cvip $util(sharp) $temp1 y  $temp 1.5 1"
						}
						cvip dq $temp1
					} cresult] {
               CvipAlert "$cresult"
					$topwin(util_name) configure -cursor top_left_arrow; update
               return
            } 

            if [catch {
						set temp [cvip $util(transform) $result 0 -1]
						if { $GUI_DEBUG == "1" } {
							puts stderr "cvip $util(transform) $result 0 -1"
						}
						cvip dq $result
					} cresult] {
					CvipAlert "$cresult"
					$topwin(util_name) configure -cursor top_left_arrow; update
					return
	         } else {
					set new_name [cvip rename $temp ${current_image}_hfe]
					img_q insert end $new_name
					image_post $new_name
					cvip view $new_name
					CvipMessage "high-frequency emphasis performed on image \"$current_image\""
  	         }

			}

		}

		$topwin(util_name) configure -cursor top_left_arrow; update
	 } \
    -text {PERFORM}

  # pack widget $topwin(util_name).perform
  pack append $topwin(util_name).perform \
    $topwin(util_name).perform.button2 {left frame center} \
    $topwin(util_name).perform.button3 {right frame center}

  # pack widget $topwin(util_name)
  pack append $topwin(util_name) \
    $topwin(util_name).info {top frame center expand fill} \
    $topwin(util_name).current_image {top frame center fillx} \
    $topwin(util_name).perform {bottom frame center fillx}

}

proc util_stretch { } {
  global GuiColor
  global GuiMisc
  global GUI_DEBUG
  # Window manager configurations
  global tk_version
  global topwin
  global toplevel_position
  if [ winfo exists $topwin(util_name).info] {
     set tempname $topwin(util_name);\
destroy $topwin(util_name).info;\
set topwin(util_name) $tempname;}
  if [ winfo exists $topwin(util_name).current_image] {
     set tempname $topwin(util_name);\
destroy $topwin(util_name).current_image;\
set topwin(util_name) $tempname;}
  if [ winfo exists $topwin(util_name).perform] {
     set tempname $topwin(util_name);\
destroy $topwin(util_name).perform;\
set topwin(util_name) $tempname;}
  wm positionfrom $topwin(util_name) user
  wm sizefrom $topwin(util_name) user
  wm geometry $topwin(util_name) $topwin(util_top)[get_pos $topwin(util_name)]
  wm maxsize $topwin(util_name) [lindex [split $topwin(util_top_max)] 0] \
  	[lindex [split $topwin(util_top_max)] 1]
  wm minsize $topwin(util_name) [lindex [split $topwin(util_top_min)] 0] \
  	[lindex [split $topwin(util_top_min)] 1]
  wm title $topwin(util_name) {UTILITIES -> Enhance -> Histogram Stretch}

  # bindings
  bind $topwin(util_name) <Destroy> {set topwin(util_name) NONE}

  # build widget $topwin(util_name).info
 frame $topwin(util_name).info \
    -background "$GuiColor(frame_bg)" \
	-borderwidth {2}

  # build widget $topwin(util_name).info.frame0
  frame $topwin(util_name).info.frame0 \
    -background "$GuiColor(frame_bg)" \
    -borderwidth {2}

  # build widget $topwin(util_name).info.frame0.frame0
  frame $topwin(util_name).info.frame0.frame0 \
    -background "$GuiColor(frame_bg)" \
    -borderwidth {2}

  # build widget $topwin(util_name).info.frame0.frame0.label1
  label $topwin(util_name).info.frame0.frame0.label1 \
    -background "$GuiColor(label_bg)" \
    -text {To a lower limit:}

  # build widget $topwin(util_name).info.frame0.frame0.entry2
  entry $topwin(util_name).info.frame0.frame0.entry2 \
    -background "$GuiColor(entry_bg)" \
	 -foreground "$GuiColor(entry_fg)" \
    -relief {sunken} \
    -textvariable {util(enhan_stretch_ll)} \
    -width {6}
  endEntry $topwin(util_name).info.frame0.frame0.entry2 0\
    $topwin(util_name).info.frame0.frame4.entry2 \
    $topwin(util_name).info.frame5.frame4.entry2 

  # build widget $topwin(util_name).info.frame0.frame0.menubutton3
	menubutton $topwin(util_name).info.frame0.frame0.menubutton3 -padx {1} -pady {1} -highlightthickness {0}  \
    -background "$GuiColor(btn_bg)" \
	 -activebackground "$GuiColor(btn_act_bg)" \
    -font "$GuiMisc(pop_up_fn)" \
	 -text "$GuiMisc(pop_up_text)" \
	 -relief "$GuiMisc(pop_up_relief)" \
	 -width {2}
  # bindings
  bind $topwin(util_name).info.frame0.frame0.menubutton3 <Button-1> {MenuPopupPost $topwin(util_name).info.frame0.frame0.menubutton3.menu %X %Y}
  bind $topwin(util_name).info.frame0.frame0.menubutton3 <ButtonRelease-1> {MenuPopupRelease $topwin(util_name).info.frame0.frame0.menubutton3.menu %W}

  # build widget $topwin(util_name).info.frame0.frame0.menubutton3.menu
  menu $topwin(util_name).info.frame0.frame0.menubutton3.menu \
    -activebackground {gray70} \
    -background {gray90}
  $topwin(util_name).info.frame0.frame0.menubutton3.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set util(enhan_stretch_ll) 0} \
    -label {  0 }
  $topwin(util_name).info.frame0.frame0.menubutton3.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set util(enhan_stretch_ll) 1} \
    -label {  1 }
  $topwin(util_name).info.frame0.frame0.menubutton3.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set util(enhan_stretch_ll) 10} \
    -label { 10 }
  $topwin(util_name).info.frame0.frame0.menubutton3.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set util(enhan_stretch_ll) 20} \
    -label { 20 }
  $topwin(util_name).info.frame0.frame0.menubutton3.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set util(enhan_stretch_ll) 30} \
    -label { 30 }
  $topwin(util_name).info.frame0.frame0.menubutton3.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set util(enhan_stretch_ll) 40} \
    -label { 40 }
  $topwin(util_name).info.frame0.frame0.menubutton3.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set util(enhan_stretch_ll) 50} \
    -label { 50 }
  $topwin(util_name).info.frame0.frame0.menubutton3.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set util(enhan_stretch_ll) 75} \
    -label { 75 }
  $topwin(util_name).info.frame0.frame0.menubutton3.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set util(enhan_stretch_ll) 100} \
    -label {100 }
  bindtags $topwin(util_name).info.frame0.frame0.menubutton3.menu {Menu all}
  # bindings
  bind $topwin(util_name).info.frame0.frame0.menubutton3.menu <B1-Motion> {MenuPopupMotion $topwin(util_name).info.frame0.frame0.menubutton3.menu %W %X %Y}
  bind $topwin(util_name).info.frame0.frame0.menubutton3.menu <ButtonRelease-1> {MenuPopupRelease $topwin(util_name).info.frame0.frame0.menubutton3.menu %W}

  # pack widget $topwin(util_name).info.frame0.frame0
  pack append $topwin(util_name).info.frame0.frame0 \
    $topwin(util_name).info.frame0.frame0.label1 {left frame center} \
    $topwin(util_name).info.frame0.frame0.entry2 {left frame center} \
    $topwin(util_name).info.frame0.frame0.menubutton3 {right frame center filly}

  # build widget $topwin(util_name).info.frame0.frame4
  frame $topwin(util_name).info.frame0.frame4 \
    -background "$GuiColor(frame_bg)" \
    -borderwidth {2}

  # build widget $topwin(util_name).info.frame0.frame4.label1
  label $topwin(util_name).info.frame0.frame4.label1 \
    -background "$GuiColor(label_bg)" \
    -text {  and a  higher limit:}

  # build widget $topwin(util_name).info.frame0.frame4.entry2
  entry $topwin(util_name).info.frame0.frame4.entry2 \
    -background "$GuiColor(entry_bg)" \
	 -foreground "$GuiColor(entry_fg)" \
    -relief {sunken} \
    -textvariable {util(enhan_stretch_hl)} \
    -width {6}
  endEntry $topwin(util_name).info.frame0.frame4.entry2 0\
    $topwin(util_name).info.frame5.frame0.entry2 \
    $topwin(util_name).info.frame0.frame0.entry2 

  # build widget $topwin(util_name).info.frame0.frame4.menubutton3
	menubutton $topwin(util_name).info.frame0.frame4.menubutton3 -padx {1} -pady {1} -highlightthickness {0}  \
    -background "$GuiColor(btn_bg)" \
	 -activebackground "$GuiColor(btn_act_bg)" \
    -font "$GuiMisc(pop_up_fn)" \
	 -text "$GuiMisc(pop_up_text)" \
	 -relief "$GuiMisc(pop_up_relief)" \
	 -width {2}
  # bindings
  bind $topwin(util_name).info.frame0.frame4.menubutton3 <Button-1> {MenuPopupPost $topwin(util_name).info.frame0.frame4.menubutton3.menu %X %Y}
  bind $topwin(util_name).info.frame0.frame4.menubutton3 <ButtonRelease-1> {MenuPopupRelease $topwin(util_name).info.frame0.frame4.menubutton3.menu %W}

  # build widget $topwin(util_name).info.frame0.frame4.menubutton3.menu
  menu $topwin(util_name).info.frame0.frame4.menubutton3.menu \
    -activebackground {gray70} \
    -background {gray90}
  $topwin(util_name).info.frame0.frame4.menubutton3.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set util(enhan_stretch_hl) 10} \
    -label {  10 }
  $topwin(util_name).info.frame0.frame4.menubutton3.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set util(enhan_stretch_hl) 20} \
    -label {  20 }
  $topwin(util_name).info.frame0.frame4.menubutton3.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set util(enhan_stretch_hl) 30} \
    -label {  30 }
  $topwin(util_name).info.frame0.frame4.menubutton3.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set util(enhan_stretch_hl) 40} \
    -label {  40 }
  $topwin(util_name).info.frame0.frame4.menubutton3.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set util(enhan_stretch_hl) 50} \
    -label {  50 }
  $topwin(util_name).info.frame0.frame4.menubutton3.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set util(enhan_stretch_ll) 75} \
    -label {  75 }
  $topwin(util_name).info.frame0.frame4.menubutton3.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set util(enhan_stretch_hl) 100} \
    -label { 100 }
  $topwin(util_name).info.frame0.frame4.menubutton3.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set util(enhan_stretch_hl) 200} \
    -label { 200 }
  $topwin(util_name).info.frame0.frame4.menubutton3.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set util(enhan_stretch_hl) 254} \
    -label { 254 }
  $topwin(util_name).info.frame0.frame4.menubutton3.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set util(enhan_stretch_hl) 255} \
    -label { 255 }
  bindtags $topwin(util_name).info.frame0.frame4.menubutton3.menu {Menu all}
  # bindings
  bind $topwin(util_name).info.frame0.frame4.menubutton3.menu <B1-Motion> {MenuPopupMotion $topwin(util_name).info.frame0.frame4.menubutton3.menu %W %X %Y}
  bind $topwin(util_name).info.frame0.frame4.menubutton3.menu <ButtonRelease-1> {MenuPopupRelease $topwin(util_name).info.frame0.frame4.menubutton3.menu %W}

  # pack widget $topwin(util_name).info.frame0.frame4
  pack append $topwin(util_name).info.frame0.frame4 \
    $topwin(util_name).info.frame0.frame4.label1 {left frame center} \
    $topwin(util_name).info.frame0.frame4.entry2 {left frame center} \
    $topwin(util_name).info.frame0.frame4.menubutton3 {right frame center filly}

  # pack widget $topwin(util_name).info.frame0
  pack append $topwin(util_name).info.frame0 \
    $topwin(util_name).info.frame0.frame0 {left frame center expand} \
    $topwin(util_name).info.frame0.frame4 {right frame center expand}

  # build widget $topwin(util_name).info.frame5
  frame $topwin(util_name).info.frame5 \
    -background "$GuiColor(frame_bg)" \
    -borderwidth {2}

  # build widget $topwin(util_name).info.frame5.frame0
  frame $topwin(util_name).info.frame5.frame0 \
    -background "$GuiColor(frame_bg)" \
    -borderwidth {2}

  # build widget $topwin(util_name).info.frame5.frame0.label1
  label $topwin(util_name).info.frame5.frame0.label1 \
    -background "$GuiColor(label_bg)" \
    -text {Low clip percent:}

  # build widget $topwin(util_name).info.frame5.frame0.entry2
  entry $topwin(util_name).info.frame5.frame0.entry2 \
    -background "$GuiColor(entry_bg)" \
	 -foreground "$GuiColor(entry_fg)" \
    -relief {sunken} \
    -textvariable {util(enhan_stretch_lc)} \
    -width {6}
  endEntry $topwin(util_name).info.frame5.frame0.entry2 0\
    $topwin(util_name).info.frame5.frame4.entry2 \
    $topwin(util_name).info.frame0.frame4.entry2 

  # build widget $topwin(util_name).info.frame5.frame0.menubutton3
	menubutton $topwin(util_name).info.frame5.frame0.menubutton3 -padx {1} -pady {1} -highlightthickness {0}  \
    -background "$GuiColor(btn_bg)" \
	 -activebackground "$GuiColor(btn_act_bg)" \
    -font "$GuiMisc(pop_up_fn)" \
	 -text "$GuiMisc(pop_up_text)" \
	 -relief "$GuiMisc(pop_up_relief)" \
	 -width {2}
  # bindings
  bind $topwin(util_name).info.frame5.frame0.menubutton3 <Button-1> {MenuPopupPost $topwin(util_name).info.frame5.frame0.menubutton3.menu %X %Y}
  bind $topwin(util_name).info.frame5.frame0.menubutton3 <ButtonRelease-1> {MenuPopupRelease $topwin(util_name).info.frame5.frame0.menubutton3.menu %W}

  # build widget $topwin(util_name).info.frame5.frame0.menubutton3.menu
  menu $topwin(util_name).info.frame5.frame0.menubutton3.menu \
    -activebackground {gray70} \
    -background {gray90}
  $topwin(util_name).info.frame5.frame0.menubutton3.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set util(enhan_stretch_lc) 0.0} \
    -label { 0.0 }
  $topwin(util_name).info.frame5.frame0.menubutton3.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set util(enhan_stretch_lc) 0.01} \
    -label { 0.01 }
  $topwin(util_name).info.frame5.frame0.menubutton3.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set util(enhan_stretch_lc) 0.02} \
    -label { 0.02 }
  $topwin(util_name).info.frame5.frame0.menubutton3.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set util(enhan_stretch_lc) 0.03} \
    -label { 0.03 }
  $topwin(util_name).info.frame5.frame0.menubutton3.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set util(enhan_stretch_lc) 0.04} \
    -label { 0.04 }
  $topwin(util_name).info.frame5.frame0.menubutton3.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set util(enhan_stretch_lc) 0.05} \
    -label { 0.05 }
  $topwin(util_name).info.frame5.frame0.menubutton3.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set util(enhan_stretch_lc) 0.075} \
    -label { 0.075}
  $topwin(util_name).info.frame5.frame0.menubutton3.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set util(enhan_stretch_lc) 0.10} \
    -label { 0.10 }
  $topwin(util_name).info.frame5.frame0.menubutton3.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set util(enhan_stretch_lc) 0.20} \
    -label { 0.20 }
  bindtags $topwin(util_name).info.frame5.frame0.menubutton3.menu {Menu all}
  # bindings
  bind $topwin(util_name).info.frame5.frame0.menubutton3.menu <B1-Motion> {MenuPopupMotion $topwin(util_name).info.frame5.frame0.menubutton3.menu %W %X %Y}
  bind $topwin(util_name).info.frame5.frame0.menubutton3.menu <ButtonRelease-1> {MenuPopupRelease $topwin(util_name).info.frame5.frame0.menubutton3.menu %W}

  # pack widget $topwin(util_name).info.frame5.frame0
  pack append $topwin(util_name).info.frame5.frame0 \
    $topwin(util_name).info.frame5.frame0.label1 {left frame center} \
    $topwin(util_name).info.frame5.frame0.entry2 {left frame center} \
    $topwin(util_name).info.frame5.frame0.menubutton3 {right frame center filly}

  # build widget $topwin(util_name).info.frame5.frame4
  frame $topwin(util_name).info.frame5.frame4 \
    -background "$GuiColor(frame_bg)" \
    -borderwidth {2}

  # build widget $topwin(util_name).info.frame5.frame4.label1
  label $topwin(util_name).info.frame5.frame4.label1 \
    -background "$GuiColor(label_bg)" \
    -text {  high clip percent:}

  # build widget $topwin(util_name).info.frame5.frame4.entry2
  entry $topwin(util_name).info.frame5.frame4.entry2 \
    -background "$GuiColor(entry_bg)" \
	 -foreground "$GuiColor(entry_fg)" \
    -relief {sunken} \
    -textvariable {util(enhan_stretch_hc)} \
    -width {6}
  endEntry $topwin(util_name).info.frame5.frame4.entry2 0\
    $topwin(util_name).info.frame0.frame0.entry2 \
    $topwin(util_name).info.frame5.frame0.entry2 

  # build widget $topwin(util_name).info.frame5.frame4.menubutton3
	menubutton $topwin(util_name).info.frame5.frame4.menubutton3 -padx {1} -pady {1} -highlightthickness {0}  \
    -background "$GuiColor(btn_bg)" \
	 -activebackground "$GuiColor(btn_act_bg)" \
    -font "$GuiMisc(pop_up_fn)" \
	 -text "$GuiMisc(pop_up_text)" \
	 -relief "$GuiMisc(pop_up_relief)" \
	 -width {2}
  # bindings
  bind $topwin(util_name).info.frame5.frame4.menubutton3 <Button-1> {MenuPopupPost $topwin(util_name).info.frame5.frame4.menubutton3.menu %X %Y}
  bind $topwin(util_name).info.frame5.frame4.menubutton3 <ButtonRelease-1> {MenuPopupRelease $topwin(util_name).info.frame5.frame4.menubutton3.menu %W}

  # build widget $topwin(util_name).info.frame5.frame4.menubutton3.menu
  menu $topwin(util_name).info.frame5.frame4.menubutton3.menu \
    -activebackground {gray70} \
    -background {gray90}
  $topwin(util_name).info.frame5.frame4.menubutton3.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set util(enhan_stretch_hc) 0.0} \
    -label { 0.0 }
  $topwin(util_name).info.frame5.frame4.menubutton3.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set util(enhan_stretch_hc) 0.01} \
    -label { 0.01 }
  $topwin(util_name).info.frame5.frame4.menubutton3.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set util(enhan_stretch_hc) 0.02} \
    -label { 0.02 }
  $topwin(util_name).info.frame5.frame4.menubutton3.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set util(enhan_stretch_hc) 0.03} \
    -label { 0.03 }
  $topwin(util_name).info.frame5.frame4.menubutton3.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set util(enhan_stretch_hc) 0.04} \
    -label { 0.04 }
  $topwin(util_name).info.frame5.frame4.menubutton3.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set util(enhan_stretch_hc) 0.05} \
    -label { 0.05 }
  $topwin(util_name).info.frame5.frame4.menubutton3.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set util(enhan_stretch_hc) 0.075} \
    -label { 0.075}
  $topwin(util_name).info.frame5.frame4.menubutton3.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set util(enhan_stretch_hc) 0.10} \
    -label { 0.10 }
  $topwin(util_name).info.frame5.frame4.menubutton3.menu add command \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set util(enhan_stretch_hc) 0.20} \
    -label { 0.20 }
  bindtags $topwin(util_name).info.frame5.frame4.menubutton3.menu {Menu all}
  # bindings
  bind $topwin(util_name).info.frame5.frame4.menubutton3.menu <B1-Motion> {MenuPopupMotion $topwin(util_name).info.frame5.frame4.menubutton3.menu %W %X %Y}
  bind $topwin(util_name).info.frame5.frame4.menubutton3.menu <ButtonRelease-1> {MenuPopupRelease $topwin(util_name).info.frame5.frame4.menubutton3.menu %W}

  # pack widget $topwin(util_name).info.frame5.frame4
  pack append $topwin(util_name).info.frame5.frame4 \
    $topwin(util_name).info.frame5.frame4.label1 {left frame center} \
    $topwin(util_name).info.frame5.frame4.entry2 {left frame center} \
    $topwin(util_name).info.frame5.frame4.menubutton3 {right frame center filly}

  # pack widget $topwin(util_name).info.frame5
  pack append $topwin(util_name).info.frame5 \
    $topwin(util_name).info.frame5.frame0 {left frame center expand} \
    $topwin(util_name).info.frame5.frame4 {right frame center expand}

  # pack widget $topwin(util_name).info
  pack append $topwin(util_name).info \
    $topwin(util_name).info.frame0 {top frame center expand fill} \
    $topwin(util_name).info.frame5 {top frame center expand fill}

  frame $topwin(util_name).perform \
    -background "$GuiColor(frame_bg)" \
    -borderwidth {2} \
    -relief {raised}

  # build widget $topwin(util_name).perform.perform1
	button $topwin(util_name).perform.perform1 -padx {1} -pady {1} -highlightthickness {0}  \
    -foreground "$GuiColor(perf_fg)" \
    -background "$GuiColor(perf_bg)" \
	 -activebackground "$GuiColor(perf_act_bg)" \
    -command {
		if [catch {expr $util(enhan_stretch_ll) + $util(enhan_stretch_hl)}] {
         CvipAlert "Numerical value required for the stretch upper and lower limit:\n\
			Lower limit = $util(enhan_stretch_ll), Upper limit = $util(enhan_stretch_hl)."
			$topwin(util_name) configure -cursor top_left_arrow; update
         return
		} elseif {$util(enhan_stretch_ll) < 0 || $util(enhan_stretch_ll) > 254} {
         CvipAlert "The stretch lower limit should be in the range (0-254):\n\
			Lower limit = $util(enhan_stretch_ll)."
			$topwin(util_name) configure -cursor top_left_arrow; update
         return
		} elseif {$util(enhan_stretch_hl) < 1 || $util(enhan_stretch_hl) > 255} {
         CvipAlert "The stretch upper limit should be in the range (1-255):\n\
			Upper limit = $util(enhan_stretch_hl)."
			$topwin(util_name) configure -cursor top_left_arrow; update
         return
		}
		set temp "cvip hist_stretch  $current_image $util(enhan_stretch_ll) $util(enhan_stretch_hl)"
		if [catch { expr  $util(enhan_stretch_hc) + $util(enhan_stretch_lc) } ] {
         CvipAlert "Numerical values required for high and low clip percentage:\n\
			Low clip  = $util(enhan_stretch_lc), High clip = $util(enhan_stretch_hc)."
			$topwin(util_name) configure -cursor top_left_arrow; update
         return
		} elseif { $util(enhan_stretch_hc) < 0 || $util(enhan_stretch_hc) > 1 ||
					  $util(enhan_stretch_lc) < 0 || $util(enhan_stretch_lc) > 1 } {
        	CvipAlert "The high and low clip percentage should be in the range \[0, 1\]:\n\
			Low clip  = [expr 100*$util(enhan_stretch_lc)]%, \
			High clip = [expr 100*$util(enhan_stretch_hc)]%."
			$topwin(util_name) configure -cursor top_left_arrow; update
        	return

		}
		append temp "  $util(enhan_stretch_lc) $util(enhan_stretch_hc)"
		if [catch {set result [eval $temp ] } cresult] {
        CvipAlert "$cresult."
			$topwin(util_name) configure -cursor top_left_arrow; update
        return
		}
		if { $GUI_DEBUG == "1" } {
			puts stderr $temp
		}
		set new_name [cvip rename $result "${current_image}_hist_stretch"]
		img_q insert end $new_name
		image_post $new_name
		cvip view $new_name
		CvipMessage "histogram stretch  performed on image \"$current_image\""
	$topwin(util_name) configure -cursor top_left_arrow; update
	 } \
    -text {PERFORM}

  # build widget $topwin(util_name).perform.dismiss
	button $topwin(util_name).perform.dismiss -padx {1} -pady {1} -highlightthickness {0}  \
    -foreground "$GuiColor(dis_fg)" \
    -background "$GuiColor(dis_bg)" \
	 -activebackground "$GuiColor(dis_act_bg)" \
    -command {destroy $topwin(util_name); set topwin(util_name) NONE} \
    -text {DISMISS} \
    -width {10}

  # pack widget $topwin(util_name).perform
  pack append $topwin(util_name).perform \
    $topwin(util_name).perform.dismiss {left frame sw filly} \
    $topwin(util_name).perform.perform1 {right frame se filly}

  # build widget $topwin(util_name).current_image
  frame $topwin(util_name).current_image \
    -background "$GuiColor(frame_bg)" \
    -borderwidth {2} \
    -relief {ridge}

  # build widget $topwin(util_name).current_image.current
  label $topwin(util_name).current_image.current \
    -background "$GuiColor(label_bg)" \
    -text {Current image:}

  # build widget $topwin(util_name).current_image.name
  label $topwin(util_name).current_image.name \
    -background "$GuiColor(rlabel_bg)" \
    -foreground "$GuiColor(rlabel_fg)" \
    -text {} \
    -textvariable {current_image}

  # pack widget $topwin(util_name).current_image
  pack append $topwin(util_name).current_image \
    $topwin(util_name).current_image.current {left frame center} \
    $topwin(util_name).current_image.name {left frame center filly}

  # pack widget $topwin(util_name)
  pack append $topwin(util_name) \
    $topwin(util_name).info {top frame center expand fill} \
    $topwin(util_name).perform {bottom frame center pady 5 fill} \
    $topwin(util_name).current_image {bottom frame center fill}

  if {"[info procs XFEdit]" != ""} {
    catch "XFMiscBindWidgetTree $topwin(util_name)"
    after 2 "catch {XFEditSetShowWindows}"
  }
}

