# **********************************************************************
# Computer Vision/Image Processing Tool Project - Dr. Scott Umbaugh SIUE
# **********************************************************************
#
#             File Name: util_misc.tcl
#           Description: 
#         Related Files: 
#   Initial Coding Date: Fri Aug  9 17:34:18 CDT 1996
#           Portability: TCL script file
#            References:
#             Author(s): Yansheng Wei
#                        Southern Illinois University @ Edwardsville
#
## Copyright (C) 1996 SIUE - by Scott Umbaugh and Yansheng Wei.
##
## Permission to use, copy, modify, and distribute this software and its
## documentation for any purpose and without fee is hereby granted, provided
## that the above copyright notice appear in all copies and that both that
## copyright notice and this permission notice appear in supporting
## documentation.  This software is provided "as is" without express or
## implied warranty.
##
# RCS (Revision Control System) Information
# ...Added automatically by RCS 
#
## $Log: util_misc.tcl,v $
## Revision 1.14  1997/07/17 23:25:30  yawei
## Gui configuration finished
##
## Revision 1.13  1997/03/12 17:17:45  yawei
## fixed datarange bug
##
## Revision 1.12  1997/03/12 16:29:04  yawei
## changed window size
##
## Revision 1.11  1997/03/11 20:57:10  yawei
## Tcl/Tk script upgrading from tcl7.3/tk3.6 to tcl7.6/tk4.2
## compatible. This process is automated with tkboost perl
## script. @ Tue Mar 11 14:51:36 CST 1997
##
## Revision 1.10  1996/12/17 00:12:26  yawei
## Changed popup position of the snr and smr popup windows.
##
# Revision 1.9  1996/12/14  00:23:36  yawei
# Changed msr to MSR_ERROR
#
# Revision 1.8  1996/12/14  00:15:25  yawei
# Added snr and smr_error methods
#
# Revision 1.7  1996/10/16  20:18:55  yawei
# general chagnes
#
# Revision 1.6  1996/10/07  17:26:51  mzuke
# replaced 'compare two images' symbols with text
#
# Revision 1.5  1996/10/04  14:57:30  yawei
# Added datarange function
#
# Revision 1.4  1996/09/27  18:35:18  mzuke
# made window resizable
#
# Revision 1.3  1996/08/28  15:36:39  mzuke
# corrected misspelling 'Miscc' to 'Misc'
#
# Revision 1.2  1996/08/15  11:20:45  mzuke
# removed toplevel_position from wm geometry to allow window
# positioning by user
#
# Revision 1.1  1996/08/09  22:37:52  yawei
# Initial revision
#
#
#****************************************************************************
proc add_path1 {} {
   global GuiColor
	global GuiMisc
	global GUI_DEBUG

  global tk_version
  global topwin
  global toplevel_position
  global message
  if [ winfo exists $topwin(util_name).info] {
     set tempname $topwin(util_name);\
destroy $topwin(util_name).info;\
set topwin(util_name) $tempname;}
  if [ winfo exists $topwin(util_name).current_image] {
     set tempname $topwin(util_name);\
destroy $topwin(util_name).current_image;\
set topwin(util_name) $tempname;}
  if [ winfo exists $topwin(util_name).perform] {
     set tempname $topwin(util_name);\
destroy $topwin(util_name).perform;\
set topwin(util_name) $tempname;}
  wm positionfrom $topwin(util_name) user
  wm sizefrom $topwin(util_name) user
  wm geometry $topwin(util_name) $topwin(util_top)[get_pos $topwin(util_name)]
  wm maxsize $topwin(util_name) [lindex [split $topwin(util_top_max)] 0] \
  	[lindex [split $topwin(util_top_max)] 1]
  wm minsize $topwin(util_name) [lindex [split $topwin(util_top_min)] 0] \
  	[lindex [split $topwin(util_top_min)] 1]
  wm title $topwin(util_name) {UTILITIES -> Misc -> Add temporary image path}

  # build widget $topwin(util_name).current_image
  frame $topwin(util_name).current_image  -background "$GuiColor(frame_bg)"  -borderwidth {2}

  # build widget $topwin(util_name).current_image.new_path
  frame $topwin(util_name).current_image.new_path  -background "$GuiColor(frame_bg)"

  # build widget $topwin(util_name).current_image.new_path.scrollbar7
  scrollbar $topwin(util_name).current_image.new_path.scrollbar7  \
    -background "$GuiColor(btn_bg)" \
	 -activebackground "$GuiColor(btn_act_bg)" \
  -command "$topwin(util_name).current_image.new_path.frame3.entry5 xview" \
  -orient {horizontal} \
  -relief {raised} \
  -width {11}

  # build widget $topwin(util_name).current_image.new_path.frame3
  frame $topwin(util_name).current_image.new_path.frame3  -background "$GuiColor(frame_bg)"

  # build widget $topwin(util_name).current_image.new_path.frame3.entry5
  entry $topwin(util_name).current_image.new_path.frame3.entry5 \
  -background "$GuiColor(entry_bg)" \
  -foreground "$GuiColor(entry_fg)" \
  -relief {sunken} \
 -xscrollcommand "$topwin(util_name).current_image.new_path.scrollbar7 set" \
  -textvariable {pathname}
  endEntry $topwin(util_name).current_image.new_path.frame3.entry5

  # build widget $topwin(util_name).current_image.new_path.frame3.label4
  label $topwin(util_name).current_image.new_path.frame3.label4 \
  -background "$GuiColor(label_bg)" \
  -padx {2} \
  -relief {raised}  \
  -text {New path:}

  # pack widget $topwin(util_name).current_image.new_path.frame3
  pack append $topwin(util_name).current_image.new_path.frame3 \
  $topwin(util_name).current_image.new_path.frame3.label4 {left frame center}\
  $topwin(util_name).current_image.new_path.frame3.entry5 {top frame center expand fill}

  # pack widget $topwin(util_name).current_image.new_path
  pack append $topwin(util_name).current_image.new_path  \
  $topwin(util_name).current_image.new_path.frame3 {top frame center fillx}\
  $topwin(util_name).current_image.new_path.scrollbar7 {top frame center fillx}

  # pack widget $topwin(util_name).current_image
  pack append $topwin(util_name).current_image  \
  $topwin(util_name).current_image.new_path {top frame center fill}

  # build widget $topwin(util_name).perform
  frame $topwin(util_name).perform  \
  -relief {raised} \
  -background "$GuiColor(frame_bg)" \
  -borderwidth {2}

  # build widget $topwin(util_name).perform.perform
	button $topwin(util_name).perform.perform -padx {1} -pady {1} -highlightthickness {0}   \
  -foreground "$GuiColor(perf_fg)" \
  -background "$GuiColor(perf_bg)" \
  -activebackground "$GuiColor(perf_act_bg)" \
  -command {
	if {$pathname != ""} {
		cvip add_path $pathname;
		CvipMessage "\"$pathname\" is added to the image path"}
	if {$pathname == ""} {CvipMessage "You MUST enter a path name first."}
  }  \
  -text {PERFORM}

  # build widget $topwin(util_name).perform.dismiss
	button $topwin(util_name).perform.dismiss -padx {1} -pady {1} -highlightthickness {0}   \
  -foreground "$GuiColor(dis_fg)" \
  -background "$GuiColor(dis_bg)" \
  -activebackground "$GuiColor(dis_act_bg)" \
  -command {destroy $topwin(util_name)}  -text {DISMISS}  -width {10}

  # pack widget $topwin(util_name).perform
  pack append $topwin(util_name).perform  \
  $topwin(util_name).perform.dismiss {left frame center filly} \
  $topwin(util_name).perform.perform {right frame center filly}

  # build widget $topwin(util_name).info
  frame $topwin(util_name).info  \
  -background "$GuiColor(frame_bg)" \
  -borderwidth {2}

  # build widget $topwin(util_name).info.path_message
  label $topwin(util_name).info.path_message  \
  -background "$GuiColor(label_bg)" \
  -text {Enter  image path below}

  # pack widget $topwin(util_name).info
  pack append $topwin(util_name).info  \
  $topwin(util_name).info.path_message {top frame center expand}

  # pack widget $topwin(util_name)
  pack append $topwin(util_name)  \
  $topwin(util_name).info {top frame center expand fill}  \
  $topwin(util_name).current_image {top frame center expand fill} \
  $topwin(util_name).perform {bottom frame center fill}

  if {"[info procs XFEdit]" != ""} {
    catch "XFMiscBindWidgetTree $topwin(util_name)"
    after 2 "catch {XFEditSetShowWindows}"
  }
}


# procedure to show window $topwin(util_name)
proc  util_compare { } {# xf ignore me 7
   global GuiColor
	global GuiMisc
	global GUI_DEBUG

  global {util}
  global topwin
  global toplevel_position
  if [ winfo exists $topwin(util_name).info] {
     set tempname $topwin(util_name);\
destroy $topwin(util_name).info;\
set topwin(util_name) $tempname;}
  if [ winfo exists $topwin(util_name).current_image] {
     set tempname $topwin(util_name);\
destroy $topwin(util_name).current_image;\
set topwin(util_name) $tempname;}
  if [ winfo exists $topwin(util_name).perform] {
     set tempname $topwin(util_name);\
destroy $topwin(util_name).perform;\
set topwin(util_name) $tempname;}
  wm positionfrom $topwin(util_name) user
  wm sizefrom $topwin(util_name) user
  wm geometry $topwin(util_name) $topwin(util_top)[get_pos $topwin(util_name)]
  wm maxsize $topwin(util_name) [lindex [split $topwin(util_top_max)] 0] \
  	[lindex [split $topwin(util_top_max)] 1]
  wm minsize $topwin(util_name) [lindex [split $topwin(util_top_min)] 0] \
  	[lindex [split $topwin(util_top_min)] 1]
  wm title $topwin(util_name) "UTILITIES -> Misc -> Compare two images"

  # bindings
  bind $topwin(util_name) <Destroy> {set topwin(util_name) NONE}

  # build widget $topwin(util_name).info
  frame $topwin(util_name).info \
  -background "$GuiColor(frame_bg)" \
    -borderwidth {2}

  # build widget $topwin(util_name).info.current_image1
  frame $topwin(util_name).info.current_image1 \
    -background "$GuiColor(frame_bg)" \
    -borderwidth {2}

  # build widget $topwin(util_name).info.current_image1.frame
  frame $topwin(util_name).info.current_image1.frame \
    -background "$GuiColor(frame_bg)"

  # build widget $topwin(util_name).info.current_image1.frame.frame
  frame $topwin(util_name).info.current_image1.frame.frame \
    -background "$GuiColor(frame_bg)"

  # build widget $topwin(util_name).info.current_image1.frame.frame.scrollbar1
  scrollbar $topwin(util_name).info.current_image1.frame.frame.scrollbar1 \
    -background "$GuiColor(btn_bg)" \
	 -activebackground "$GuiColor(btn_act_bg)" \
    -command "$topwin(util_name).info.current_image1.frame.frame.entry2 xview" \
    -orient {horizontal} \
    -width {11}

  # build widget $topwin(util_name).info.current_image1.frame.frame.entry2
  entry $topwin(util_name).info.current_image1.frame.frame.entry2 \
    -background "$GuiColor(entry_bg)" \
	 -foreground "$GuiColor(entry_fg)" \
    -relief {sunken} \
 -xscrollcommand "$topwin(util_name).info.current_image1.frame.frame.scrollbar1 set" \
    -textvariable {second_image}
  endEntry $topwin(util_name).info.current_image1.frame.frame.entry2

  # pack widget $topwin(util_name).info.current_image1.frame.frame
  pack append $topwin(util_name).info.current_image1.frame.frame \
    $topwin(util_name).info.current_image1.frame.frame.entry2 {top frame center expand fill} \
    $topwin(util_name).info.current_image1.frame.frame.scrollbar1 {top frame center fillx}

  # build widget $topwin(util_name).info.current_image1.frame.label1
  label $topwin(util_name).info.current_image1.frame.label1 \
  -background "$GuiColor(label_bg)" \
    -borderwidth {0} \
    -text {with second image: }

  # pack widget $topwin(util_name).info.current_image1.frame
  pack append $topwin(util_name).info.current_image1.frame \
    $topwin(util_name).info.current_image1.frame.label1 {left frame center filly} \
    $topwin(util_name).info.current_image1.frame.frame {top frame center fillx}

  # pack widget $topwin(util_name).info.current_image1
  pack append $topwin(util_name).info.current_image1 \
    $topwin(util_name).info.current_image1.frame {top frame center fill}

  # build widget $topwin(util_name).info.current_image2
  frame $topwin(util_name).info.current_image2 \
    -background "$GuiColor(frame_bg)" \
    -borderwidth {2}

	radiobutton $topwin(util_name).info.current_image2.radiobutton1 -padx {1} -pady {1} -highlightthickness {0}  \
    -background "$GuiColor(btn_bg)" \
	 -activebackground "$GuiColor(btn_act_bg)" \
    -relief {ridge} \
    -value {subtract} \
    -text {by subtraction} \
    -variable {util(compare)}

	radiobutton $topwin(util_name).info.current_image2.radiobutton2 -padx {1} -pady {1} -highlightthickness {0}  \
    -background "$GuiColor(btn_bg)" \
	 -activebackground "$GuiColor(btn_act_bg)" \
    -relief {ridge} \
    -value {xor} \
    -text {by XOR} \
    -variable {util(compare)}

	radiobutton $topwin(util_name).info.current_image2.radiobutton3 -padx {1} -pady {1} -highlightthickness {0}  \
    -background "$GuiColor(btn_bg)" \
	 -activebackground "$GuiColor(btn_act_bg)" \
    -relief {ridge} \
    -value {snr} \
    -text {by SNR} \
    -variable {util(compare)}

	radiobutton $topwin(util_name).info.current_image2.radiobutton4 -padx {1} -pady {1} -highlightthickness {0}  \
    -background "$GuiColor(btn_bg)" \
	 -activebackground "$GuiColor(btn_act_bg)" \
    -relief {ridge} \
    -value {rms_error} \
    -text {by RMS error} \
    -variable {util(compare)}

  # pack widget $topwin(util_name).info.current_image2
  pack append $topwin(util_name).info.current_image2 \
    $topwin(util_name).info.current_image2.radiobutton1 {left frame center expand} \
    $topwin(util_name).info.current_image2.radiobutton2 {left frame center expand} \
    $topwin(util_name).info.current_image2.radiobutton3 {left frame center expand} \
    $topwin(util_name).info.current_image2.radiobutton4 {left frame center expand}

  # build widget $topwin(util_name).info.current_image4
  frame $topwin(util_name).info.current_image4 \
    -background "$GuiColor(frame_bg)" \
    -borderwidth {2}

  # build widget $topwin(util_name).info.current_image4.current
  label $topwin(util_name).info.current_image4.current \
  -background "$GuiColor(label_bg)" \
    -text {Compare current image:}

  # build widget $topwin(util_name).info.current_image4.name
  label $topwin(util_name).info.current_image4.name \
     -background "$GuiColor(rlabel_bg)" \
     -foreground "$GuiColor(rlabel_fg)" \
    -text {} \
    -textvariable {current_image}

  # pack widget $topwin(util_name).info.current_image4
  pack append $topwin(util_name).info.current_image4 \
    $topwin(util_name).info.current_image4.current {left frame center filly} \
    $topwin(util_name).info.current_image4.name {left frame center filly}

  # pack widget $topwin(util_name).info
    pack append $topwin(util_name).info \
      $topwin(util_name).info.current_image2 {bottom frame center expand fill} \
      $topwin(util_name).info.current_image1 {bottom frame center expand fill} \
      $topwin(util_name).info.current_image4 {bottom frame center expand fill}

	if { $util(compare) == "not" } {
		pack forget $topwin(util_name).info.current_image4
  		$topwin(util_name).info.current_image1.frame.label1 configure -text "Current image: "
  		$topwin(util_name).info.current_image1.frame.frame.entry2 configure -textvariable current_image
	}
  # build widget $topwin(util_name).perform
  frame $topwin(util_name).perform \
    -background "$GuiColor(frame_bg)" \
    -borderwidth {2} \
    -relief {raised}

  # build widget $topwin(util_name).perform.perform1
	button $topwin(util_name).perform.perform1 -padx {1} -pady {1} -highlightthickness {0}  \
     -foreground "$GuiColor(perf_fg)" \
     -background "$GuiColor(perf_bg)" \
     -activebackground "$GuiColor(perf_act_bg)" \
	 -command {
		 $topwin(util_name) configure -cursor watch; update
		 if {$current_image == ""} {
			CvipAlert "Please select an image first using the mouse."
	 		$topwin(util_name) configure -cursor top_left_arrow; update
			return
		 } elseif {$second_image == ""} {
			CvipAlert "Please select a second image using Ctrl-button1 in the image queue or typing the image name."
	 		$topwin(util_name) configure -cursor top_left_arrow; update
			return
		 } elseif [catch {scan [cvip info $second_image] "%s%s%s%s%s%s%s" null null temp null null null null}] {
			CvipAlert "Inappropriate image format for \"$second_image\"."
	 		$topwin(util_name) configure -cursor top_left_arrow; update
			return
		 } elseif {$bands != $temp } {
			CvipAlert "\"$util(compare)\" can't work on two images with different number of bands \n\
						 bands of \"$current_image\" is: $bands;\n\
						 bands of \"$second_image\" is : $temp."
	 		$topwin(util_name) configure -cursor top_left_arrow; update
			return
		 } else {
			if [catch {set result [cvip $util(compare) $current_image $second_image]}] {
				CvipAlert "Image $util(compare) error!"
	 			$topwin(util_name) configure -cursor top_left_arrow; update
				return
			} elseif { $util(compare) == "snr" } {
				set temp [wm geometry $topwin(util_name)]
				set a1 [string first "x" $temp]
				set a1 [expr $a1 - 1]
				set temp1 [string range $temp 0 $a1]; incr a1
				set temp1 [expr $temp1 / 2]
				append temp1 [string range $temp $a1 end]
				set a1 [string last "+" $temp1]; set a2 [string last "-" $temp1]
				set temp [expr { $a1 > $a2 } ? $a1 : $a2]
				incr temp
				set temp2 [string range $temp1 $temp end]; set temp2 [expr $temp2 + 200]
				incr temp -1
				set temp1 [string range $temp1 0 $temp];
				append temp1 $temp2
				TextBox $result "" $temp1 "Signal-to-noise Ratio"	
			} elseif { $util(compare) == "rms_error" } {
				set temp [wm geometry $topwin(util_name)]
				set a1 [string first "x" $temp]
				set a1 [expr $a1 - 1]
				set temp1 [string range $temp 0 $a1]; incr a1
				set temp1 [expr $temp1 / 2]
				append temp1 [string range $temp $a1 end]
				set a1 [string last "+" $temp1]; set a2 [string last "-" $temp1]
				set temp [expr { $a1 > $a2 } ? $a1 : $a2]
				incr temp
				set temp2 [string range $temp1 $temp end]; set temp2 [expr $temp2 + 200]
				incr temp -1
				set temp1 [string range $temp1 0 $temp];
				append temp1 $temp2
				TextBox $result "" $temp1 "Root-mean-square Error"	
			} elseif { $util(compare) == "subtract" } {
				set new_name [cvip rename $result ${current_image}_sub_$second_image]
				img_q insert end $new_name
				image_post $new_name
				cvip view $new_name
			} elseif { $util(compare) == "xor" } {
				set new_name [cvip rename $result ${current_image}_xor_$second_image]
				img_q insert end $new_name
				image_post $new_name
				cvip view $new_name
			}
		}
	 $topwin(util_name) configure -cursor top_left_arrow; update
	 } \
    -text {PERFORM}

  # build widget $topwin(util_name).perform.dismiss
	button $topwin(util_name).perform.dismiss -padx {1} -pady {1} -highlightthickness {0}  \
    -foreground "$GuiColor(dis_fg)" \
    -background "$GuiColor(dis_bg)" \
    -activebackground "$GuiColor(dis_act_bg)" \
    -command {destroy $topwin(util_name); set topwin(util_name) NONE} \
    -text {DISMISS} \
    -width {10}

  # pack widget $topwin(util_name).perform
  pack append $topwin(util_name).perform \
    $topwin(util_name).perform.dismiss {left frame sw filly} \
    $topwin(util_name).perform.perform1 {right frame se filly}

  # pack widget $topwin(util_name)
  pack append $topwin(util_name) \
    $topwin(util_name).info {top frame center expand fill} \
    $topwin(util_name).perform {bottom frame center pady 5 fill}

  if {"[info procs XFEdit]" != ""} {
    catch "XFMiscBindWidgetTree $topwin(util_name)"
    after 2 "catch {XFEditSetShowWindows}"
  }

}

#***********************************
# purely hand written code, similar to C style,
# cool code :-)
#***********************************

proc util_datarange { } {

	global bands
	global data_fmt
	global current_image
	global temp2
   global GuiColor
	global GuiMisc
	global GUI_DEBUG

	global {util}
	if { $current_image == "" } {
		CvipAlert "Please select an image first."
		return
	} else {
		scan [cvip info $current_image] {%s %s %d %d %d %s %s} \
		img_fmt color_fmt bands rows cols data_type data_fmt
	}
	if { $data_fmt == "REAL" } {
		set temp1 {scan $temp }; append temp1 "{"
		for {set temp2 0} { $temp2 < $bands * 2 } {incr temp2 } {
			append temp1 " %d"
		}
		append temp1 "} "
		for {set temp2 0} { $temp2 < $bands } {incr temp2 } {
			append temp1 { util(} "dr_${temp2}_min_Real)"
			append temp1 { util(} "dr_${temp2}_max_Real)"
		}
	} else {
		set temp1 {scan $temp }; append temp1 "{"
		for {set temp2 0} { $temp2 < $bands * 4 } {incr temp2 } {
			append temp1 " %d"
		}
		append temp1 "} "
		for {set temp2 0} { $temp2 < $bands } {incr temp2 } {
			append temp1 { util(} "dr_${temp2}_min_Real)"
			append temp1 { util(} "dr_${temp2}_max_Real)"
			append temp1 { util(} "dr_${temp2}_min_Imag)"
			append temp1 { util(} "dr_${temp2}_max_Imag)"
		}
	}
	
	set temp [cvip datarange $current_image]
	if [catch {eval $temp1} cresult ] {
		CvipAlert "$cresult."
		return
	}

	
	global tk_version
	global topwin
	global toplevel_position
	if [ winfo exists $topwin(util_name).info] {
		 set tempname $topwin(util_name);\
		 destroy $topwin(util_name).info;\
		 set topwin(util_name) $tempname;}
	if [ winfo exists $topwin(util_name).current_image] {
		 set tempname $topwin(util_name);\
		 destroy $topwin(util_name).current_image;\
		 set topwin(util_name) $tempname;}
	if [ winfo exists $topwin(util_name).perform] {
		 set tempname $topwin(util_name);\
		 destroy $topwin(util_name).perform;\
		 set topwin(util_name) $tempname;}
	wm positionfrom $topwin(util_name) user
	wm sizefrom $topwin(util_name) user
	wm geometry $topwin(util_name) 500x[expr $bands * 20 + 120]
	wm maxsize $topwin(util_name) 700 [expr $bands * 20 + 180]
	wm minsize $topwin(util_name) 500 [expr $bands * 20 + 120]
	wm title $topwin(util_name) {UTILITIES -> Misc -> Datarange}

	bind $topwin(util_name) <Destroy> {set topwin(util_name) NONE}

	# build widget $topwin(util_name).info
	frame $topwin(util_name).info \
    -background "$GuiColor(frame_bg)" \
		-relief {flat} \
		-borderwidth {2}

	frame $topwin(util_name).info.title \
      -background "$GuiColor(frame_bg)" \
		-borderwidth {2}

	label $topwin(util_name).info.title.lab1 \
  		-background "$GuiColor(label_bg)" \
		-text "Data range for image: "
	label $topwin(util_name).info.title.lab2 \
     -background "$GuiColor(rlabel_bg)" \
     -foreground "$GuiColor(rlabel_fg)" \
	  -text $current_image

	pack append $topwin(util_name).info.title \
		$topwin(util_name).info.title.lab1 {left frame center} \
		$topwin(util_name).info.title.lab2 {left frame center}

	pack append $topwin(util_name).info\
		$topwin(util_name).info.title {top frame center}

	frame $topwin(util_name).info.frame0 \
      -background "$GuiColor(frame_bg)" \
		-borderwidth {2}

	label $topwin(util_name).info.frame0.$temp2 \
  -background "$GuiColor(label_bg)" \
		-width {10} \
		-text "   "
	pack append $topwin(util_name).info.frame0 \
		$topwin(util_name).info.frame0.$temp2 {top frame center}
	for { set temp2 0 } { $temp2 < $bands } { incr temp2} {
		label $topwin(util_name).info.frame0.$temp2 \
  -background "$GuiColor(label_bg)" \
			-width {10} \
			-text "Band $temp2"
		pack append $topwin(util_name).info.frame0 \
			$topwin(util_name).info.frame0.$temp2 {top frame center}
	}

	pack append $topwin(util_name).info \
		$topwin(util_name).info.frame0 {left frame center}

	if { $data_fmt == "REAL" } {
		set temp3 [list min_Real max_Real]
	} else {
		set temp3 [list min_Real max_Real min_Imag max_Imag]
	}

	foreach i $temp3 {
		frame $topwin(util_name).info.$i \
		         -background "$GuiColor(frame_bg)" \
			-borderwidth {2}

		label $topwin(util_name).info.$i.title \
			-background "$GuiColor(label_bg)" \
			-width {10} \
			-text $i
		pack append $topwin(util_name).info.$i \
			$topwin(util_name).info.$i.title {top frame center}

		for { set temp2 0 } { $temp2 < $bands } { incr temp2} {
			label $topwin(util_name).info.$i.$temp2 \
			   -background {white} \
			   -foreground {blue} \
				-relief {sunken} \
				-width {10} \
				-text "$util(dr_${temp2}_$i)"
			pack append $topwin(util_name).info.$i \
				$topwin(util_name).info.$i.$temp2 {top frame center}
		}

		pack append $topwin(util_name).info \
			$topwin(util_name).info.$i {left frame center expand}
	}

	# build widget $topwin(util_name).perform
	frame $topwin(util_name).perform \
         -background "$GuiColor(frame_bg)" \
		-relief {raised}\
		-borderwidth {2}
	
	# build widget $topwin(util_name).perform.button4
	button $topwin(util_name).perform.button4 -padx {1} -pady {1} -highlightthickness {0}  \
       -foreground "$GuiColor(dis_fg)" \
       -background "$GuiColor(dis_bg)" \
       -activebackground "$GuiColor(dis_act_bg)" \
		-command {destroy $topwin(util_name); set topwin(util_name) NONE} \
		-text {DISMISS}
	pack append $topwin(util_name).perform \
		$topwin(util_name).perform.button4 {left frame center}
	pack append $topwin(util_name) \
		$topwin(util_name).info {top frame center expand fill} \
		$topwin(util_name).perform {bottom frame center fillx}

}
