# **********************************************************************
# Computer Vision/Image Processing Tool Project - Dr. Scott Umbaugh SIUE
# **********************************************************************
#
#             File Name: util_noise.tcl
#           Description: 
#         Related Files: 
#   Initial Coding Date: Wed Oct  9 22:30:31 CDT 1996
#           Portability: TCL script file
#            References:
#             Author(s): Yansheng Wei
#                        Southern Illinois University @ Edwardsville
#
## Copyright (C) 1996 SIUE - by Scott Umbaugh and Yansheng Wei.
##
## Permission to use, copy, modify, and distribute this software and its
## documentation for any purpose and without fee is hereby granted, provided
## that the above copyright notice appear in all copies and that both that
## copyright notice and this permission notice appear in supporting
## documentation.  This software is provided "as is" without express or
## implied warranty.
##
# RCS (Revision Control System) Information
# ...Added automatically by RCS 
#
## $Log: util_noise.tcl,v $
## Revision 1.7  1997/07/17 20:33:10  yawei
## Gui configuration in place
##
## Revision 1.6  1997/03/12 16:32:15  yawei
## fixed arrow buttons, and changed size
##
## Revision 1.5  1997/03/11 20:57:18  yawei
## Tcl/Tk script upgrading from tcl7.3/tk3.6 to tcl7.6/tk4.2
## compatible. This process is automated with tkboost perl
## script. @ Tue Mar 11 14:51:36 CST 1997
##
## Revision 1.4  1996/10/16 19:45:33  yawei
## general changes
##
# Revision 1.3  1996/10/10  21:55:08  yawei
# Changed drawdown menu to popup
#
# Revision 1.2  1996/10/10  21:43:28  yawei
# changed Activebackground of Black image size in noise to gray70.
#
# Revision 1.1  1996/10/10  03:32:23  yawei
# Initial revision
#
#
#****************************************************************************
# procedure to show window $topwin(util_name)
proc util_noise { } {# xf ignore me 7

  # Window manager configurations
  global tk_version
  global topwin
  global toplevel_position
  global GuiColor
  global GuiMisc
  global GUI_DEBUG

  if [ winfo exists  $topwin(util_name).info] {
     set tempname $topwin(util_name);\
destroy $topwin(util_name).info;\
set topwin(util_name) $tempname;}
  if [ winfo exists  $topwin(util_name).current_image] {
     set tempname $topwin(util_name);\
destroy $topwin(util_name).current_image;\
set topwin(util_name) $tempname;}
  if [ winfo exists  $topwin(util_name).perform] {
     set tempname $topwin(util_name);\
destroy $topwin(util_name).perform;\
set topwin(util_name) $tempname;}
  wm positionfrom  $topwin(util_name) user
  wm sizefrom  $topwin(util_name) user

  wm geometry $topwin(util_name) $topwin(util_noise)[get_pos $topwin(util_name)]
  wm maxsize $topwin(util_name) [lindex $topwin(util_noise_max) 0] \
  	[lindex $topwin(util_noise_max) 1]
  wm minsize $topwin(util_name) [lindex $topwin(util_noise_min) 0] \
  	[lindex $topwin(util_noise_min) 1]

  wm title $topwin(util_name) {UTILITIES -> Create ->Noise}

  bind $topwin(util_name) <Destroy> {set topwin(util_name) NONE}

  # build widget $topwin(util_name).info
  frame $topwin(util_name).info \
    -background "$GuiColor(frame_bg)" \
    -borderwidth {0}

  # build widget $topwin(util_name).info.frame14
  frame $topwin(util_name).info.frame14 \
    -background "$GuiColor(frame_bg)" \
    -borderwidth {2} \
    -relief {ridge}

  # build widget $topwin(util_name).info.frame14.radiobutton18
	radiobutton $topwin(util_name).info.frame14.radiobutton18 -padx {1} -pady {1} -highlightthickness {0}  \
    -background "$GuiColor(btn_bg)" \
	 -activebackground "$GuiColor(btn_act_bg)" \
    -relief {flat} \
	 -anchor {w} \
    -text {Negative exponential} \
	 -width {20} \
    -value {negative_exp_noise} \
    -variable {util(noise)}

  # build widget $topwin(util_name).info.frame14.radiobutton19
	radiobutton $topwin(util_name).info.frame14.radiobutton19 -padx {1} -pady {1} -highlightthickness {0}  \
    -background "$GuiColor(btn_bg)" \
	 -activebackground "$GuiColor(btn_act_bg)" \
    -relief {flat} \
    -text {Rayleigh} \
	 -anchor {w} \
	 -width {9} \
    -value {rayleigh_noise} \
    -variable {util(noise)}

  # build widget $topwin(util_name).info.frame14.special
  frame $topwin(util_name).info.frame14.special \
    -background "$GuiColor(frame_bg)" \
    -borderwidth {2}

  # build widget $topwin(util_name).info.frame14.special.label1
  label $topwin(util_name).info.frame14.special.label1 \
    -background "$GuiColor(label_bg)" \
    -borderwidth {0} \
	 -width {10} \
    -text {Variance:}

  # build widget $topwin(util_name).info.frame14.special.value
  entry $topwin(util_name).info.frame14.special.value \
    -background "$GuiColor(entry_bg)" \
	 -foreground "$GuiColor(entry_fg)" \
    -relief {sunken} \
    -textvariable {util(ns_var)} \
    -width {5}
  endEntry $topwin(util_name).info.frame14.special.value 

  # build widget $topwin(util_name).info.frame14.special.menubutton2
	menubutton $topwin(util_name).info.frame14.special.menubutton2 -padx {1} -pady {1} -highlightthickness {0}  \
    -background "$GuiColor(btn_bg)" \
	 -activebackground "$GuiColor(btn_act_bg)" \
    -font "$GuiMisc(pop_up_fn)" \
	 -text "$GuiMisc(pop_up_text)" \
	 -relief "$GuiMisc(pop_up_relief)" \
	 -width {2}

  bind $topwin(util_name).info.frame14.special.menubutton2 <Button-1> {
	MenuPopupPost $topwin(util_name).info.frame14.special.menubutton2.menu %X %Y
  }
  bind $topwin(util_name).info.frame14.special.menubutton2 <ButtonRelease-1> {
	MenuPopupRelease $topwin(util_name).info.frame14.special.menubutton2.menu %W
  }
  # build widget $topwin(util_name).info.frame14.special.menubutton2.menu
  menu $topwin(util_name).info.frame14.special.menubutton2.menu \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)"
  $topwin(util_name).info.frame14.special.menubutton2.menu add command \
	 -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set util(ns_var) 100} \
    -label {100}
  $topwin(util_name).info.frame14.special.menubutton2.menu add command \
	 -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set util(ns_var) 200} \
    -label {200}
  $topwin(util_name).info.frame14.special.menubutton2.menu add command \
	 -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set util(ns_var) 300} \
    -label {300}
  $topwin(util_name).info.frame14.special.menubutton2.menu add command \
	 -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set util(ns_var) 400} \
    -label {400}
  $topwin(util_name).info.frame14.special.menubutton2.menu add command \
	 -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set util(ns_var) 600} \
    -label {600}
  $topwin(util_name).info.frame14.special.menubutton2.menu add command \
	 -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set util(ns_var) 800} \
    -label {800}
  bindtags $topwin(util_name).info.frame14.special.menubutton2.menu {Menu all}
  bind $topwin(util_name).info.frame14.special.menubutton2.menu <B1-Motion> {
	MenuPopupMotion $topwin(util_name).info.frame14.special.menubutton2.menu %W %X %Y
  }
  bind $topwin(util_name).info.frame14.special.menubutton2.menu <ButtonRelease-1> {
	MenuPopupRelease $topwin(util_name).info.frame14.special.menubutton2.menu %W
  }

  # pack widget $topwin(util_name).info.frame14.special
  pack append $topwin(util_name).info.frame14.special \
    $topwin(util_name).info.frame14.special.label1 {left frame center fill} \
    $topwin(util_name).info.frame14.special.value {left frame center expand fill} \
    $topwin(util_name).info.frame14.special.menubutton2 {right frame center fill}

  # pack widget $topwin(util_name).info.frame14
  pack append $topwin(util_name).info.frame14 \
    $topwin(util_name).info.frame14.radiobutton18 {left frame center} \
    $topwin(util_name).info.frame14.radiobutton19 {left frame center} \
    $topwin(util_name).info.frame14.special {left frame center fillx}

  # build widget $topwin(util_name).info.frame15
  frame $topwin(util_name).info.frame15 \
    -background "$GuiColor(frame_bg)" \
    -borderwidth {2} \
    -relief {ridge}

  # build widget $topwin(util_name).info.frame15.radiobutton18
	radiobutton $topwin(util_name).info.frame15.radiobutton18 -padx {1} -pady {1} -highlightthickness {0}  \
    -background "$GuiColor(btn_bg)" \
	 -activebackground "$GuiColor(btn_act_bg)" \
    -relief {flat} \
    -text {Gaussian} \
	 -anchor {w} \
	 -width {20} \
    -value {gaussian_noise} \
    -variable {util(noise)}

  # build widget $topwin(util_name).info.frame15.radiobutton19
	radiobutton $topwin(util_name).info.frame15.radiobutton19 -padx {1} -pady {1} -highlightthickness {0}  \
    -background "$GuiColor(btn_bg)" \
	 -activebackground "$GuiColor(btn_act_bg)" \
    -relief {flat} \
    -text {Uniform } \
	 -anchor {w} \
	 -width {9} \
    -value {uniform_noise} \
    -variable {util(noise)}

  # build widget $topwin(util_name).info.frame15.special
  frame $topwin(util_name).info.frame15.special \
    -background "$GuiColor(frame_bg)" \
    -borderwidth {2}

  # build widget $topwin(util_name).info.frame15.special.label1
  label $topwin(util_name).info.frame15.special.label1 \
    -background "$GuiColor(label_bg)" \
    -borderwidth {0} \
	 -width {10} \
    -text {Variance:}

  # build widget $topwin(util_name).info.frame15.special.value
  entry $topwin(util_name).info.frame15.special.value \
    -background "$GuiColor(entry_bg)" \
	 -foreground "$GuiColor(entry_fg)" \
    -relief {sunken} \
    -textvariable {util(ns_var)} \
    -width {5}
  endEntry $topwin(util_name).info.frame15.special.value 0\
    $topwin(util_name).info.frame15.frame20.value \
    $topwin(util_name).info.frame15.frame20.value 

  # build widget $topwin(util_name).info.frame15.special.menubutton2
	menubutton $topwin(util_name).info.frame15.special.menubutton2 -padx {1} -pady {1} -highlightthickness {0}  \
    -background "$GuiColor(btn_bg)" \
	 -activebackground "$GuiColor(btn_act_bg)" \
    -font "$GuiMisc(pop_up_fn)" \
	 -text "$GuiMisc(pop_up_text)" \
	 -relief "$GuiMisc(pop_up_relief)" \
	 -width {2}

  bind $topwin(util_name).info.frame15.special.menubutton2 <Button-1> {
	MenuPopupPost $topwin(util_name).info.frame15.special.menubutton2.menu %X %Y
  }
  bind $topwin(util_name).info.frame15.special.menubutton2 <ButtonRelease-1> {
	MenuPopupRelease $topwin(util_name).info.frame15.special.menubutton2.menu %W
  }

  # build widget $topwin(util_name).info.frame15.special.menubutton2.menu
  menu $topwin(util_name).info.frame15.special.menubutton2.menu \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)"
  $topwin(util_name).info.frame15.special.menubutton2.menu add command \
	 -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set util(ns_var) 100} \
    -label {100}
  $topwin(util_name).info.frame15.special.menubutton2.menu add command \
	 -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set util(ns_var) 200} \
    -label {200}
  $topwin(util_name).info.frame15.special.menubutton2.menu add command \
	 -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set util(ns_var) 300} \
    -label {300}
  $topwin(util_name).info.frame15.special.menubutton2.menu add command \
	 -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set util(ns_var) 400} \
    -label {400}
  $topwin(util_name).info.frame15.special.menubutton2.menu add command \
	 -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set util(ns_var) 600} \
    -label {600}
  $topwin(util_name).info.frame15.special.menubutton2.menu add command \
	 -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set util(ns_var) 800} \
    -label {800}
  bindtags $topwin(util_name).info.frame15.special.menubutton2.menu {Menu all}
  bind $topwin(util_name).info.frame15.special.menubutton2.menu <B1-Motion> {
	MenuPopupMotion $topwin(util_name).info.frame15.special.menubutton2.menu %W %X %Y
  }
  bind $topwin(util_name).info.frame15.special.menubutton2.menu <ButtonRelease-1> {
	MenuPopupRelease $topwin(util_name).info.frame15.special.menubutton2.menu %W
  }

  # pack widget $topwin(util_name).info.frame15.special
  pack append $topwin(util_name).info.frame15.special \
    $topwin(util_name).info.frame15.special.label1 {left frame center fill} \
    $topwin(util_name).info.frame15.special.value {left frame center expand fill} \
    $topwin(util_name).info.frame15.special.menubutton2 {right frame center fill}

  # build widget $topwin(util_name).info.frame15.frame20
  frame $topwin(util_name).info.frame15.frame20 \
    -background "$GuiColor(frame_bg)" \
    -borderwidth {2}

  # build widget $topwin(util_name).info.frame15.frame20.label1
  label $topwin(util_name).info.frame15.frame20.label1 \
    -background "$GuiColor(label_bg)" \
    -borderwidth {0} \
	 -width {9} \
	 -anchor {e} \
    -text {Mean:}

  # build widget $topwin(util_name).info.frame15.frame20.value
  entry $topwin(util_name).info.frame15.frame20.value \
    -background "$GuiColor(entry_bg)" \
	 -foreground "$GuiColor(entry_fg)" \
    -relief {sunken} \
    -textvariable {util(ns_mean)} \
    -width {5}
  endEntry $topwin(util_name).info.frame15.frame20.value 0\
    $topwin(util_name).info.frame15.special.value \
    $topwin(util_name).info.frame15.special.value 

  # build widget $topwin(util_name).info.frame15.frame20.menubutton2
	menubutton $topwin(util_name).info.frame15.frame20.menubutton2 -padx {1} -pady {1} -highlightthickness {0}  \
    -background "$GuiColor(btn_bg)" \
	 -activebackground "$GuiColor(btn_act_bg)" \
    -font "$GuiMisc(pop_up_fn)" \
	 -text "$GuiMisc(pop_up_text)" \
	 -relief "$GuiMisc(pop_up_relief)" \
	 -width {2}


  bind $topwin(util_name).info.frame15.frame20.menubutton2 <Button-1> {
	MenuPopupPost $topwin(util_name).info.frame15.frame20.menubutton2.menu %X %Y
  }
  bind $topwin(util_name).info.frame15.frame20.menubutton2 <ButtonRelease-1> {
	MenuPopupRelease $topwin(util_name).info.frame15.frame20.menubutton2.menu %W
  }

  # build widget $topwin(util_name).info.frame15.frame20.menubutton2.menu
  menu $topwin(util_name).info.frame15.frame20.menubutton2.menu \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)"
  $topwin(util_name).info.frame15.frame20.menubutton2.menu add command \
	 -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set util(ns_mean) -20} \
    -label {-20}
  $topwin(util_name).info.frame15.frame20.menubutton2.menu add command \
	 -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set util(ns_mean) -10} \
    -label {-10}
  $topwin(util_name).info.frame15.frame20.menubutton2.menu add command \
	 -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set util(ns_mean) 0} \
    -label {   0}
  $topwin(util_name).info.frame15.frame20.menubutton2.menu add command \
	 -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set util(ns_mean) 10} \
    -label {  10}
  $topwin(util_name).info.frame15.frame20.menubutton2.menu add command \
	 -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set util(ns_mean) 20} \
    -label {  20}
  bindtags $topwin(util_name).info.frame15.frame20.menubutton2.menu {Menu all}
  bind $topwin(util_name).info.frame15.frame20.menubutton2.menu <B1-Motion> {
	MenuPopupMotion $topwin(util_name).info.frame15.frame20.menubutton2.menu %W %X %Y
  }
  bind $topwin(util_name).info.frame15.frame20.menubutton2.menu <ButtonRelease-1> {
	MenuPopupRelease $topwin(util_name).info.frame15.frame20.menubutton2.menu %W
  }

  # pack widget $topwin(util_name).info.frame15.frame20
  pack append $topwin(util_name).info.frame15.frame20 \
    $topwin(util_name).info.frame15.frame20.label1 {left frame center fill} \
    $topwin(util_name).info.frame15.frame20.value {left frame center expand fill} \
    $topwin(util_name).info.frame15.frame20.menubutton2 {right frame center fill}

  # pack widget $topwin(util_name).info.frame15
  pack append $topwin(util_name).info.frame15 \
    $topwin(util_name).info.frame15.radiobutton18 {left frame center} \
    $topwin(util_name).info.frame15.radiobutton19 {left frame center} \
    $topwin(util_name).info.frame15.special {left frame center fillx} \
    $topwin(util_name).info.frame15.frame20 {left frame center fillx}

  # build widget $topwin(util_name).info.frame16
  frame $topwin(util_name).info.frame16 \
    -background "$GuiColor(frame_bg)" \
    -borderwidth {2} \
    -relief {ridge}

  # build widget $topwin(util_name).info.frame16.radiobutton18
	radiobutton $topwin(util_name).info.frame16.radiobutton18 -padx {1} -pady {1} -highlightthickness {0}  \
    -background "$GuiColor(btn_bg)" \
	 -activebackground "$GuiColor(btn_act_bg)" \
    -relief {flat} \
    -text {Gamma} \
	 -anchor {w} \
	 -width {33} \
    -value {gamma_noise} \
    -variable {util(noise)}

  # build widget $topwin(util_name).info.frame16.special
  frame $topwin(util_name).info.frame16.special \
    -background "$GuiColor(frame_bg)" \
    -borderwidth {2}

  # build widget $topwin(util_name).info.frame16.special.label1
  label $topwin(util_name).info.frame16.special.label1 \
    -background "$GuiColor(label_bg)" \
    -borderwidth {0} \
	 -width {10} \
    -text {Variance:}

  # build widget $topwin(util_name).info.frame16.special.value
  entry $topwin(util_name).info.frame16.special.value \
    -background "$GuiColor(entry_bg)" \
	 -foreground "$GuiColor(entry_fg)" \
    -relief {sunken} \
    -textvariable {util(ns_var)} \
    -width {5}
  endEntry $topwin(util_name).info.frame16.special.value 0\
    $topwin(util_name).info.frame16.frame20.value \
    $topwin(util_name).info.frame16.frame20.value 

  # build widget $topwin(util_name).info.frame16.special.menubutton2
	menubutton $topwin(util_name).info.frame16.special.menubutton2 -padx {1} -pady {1} -highlightthickness {0}  \
    -background "$GuiColor(btn_bg)" \
	 -activebackground "$GuiColor(btn_act_bg)" \
    -font "$GuiMisc(pop_up_fn)" \
	 -text "$GuiMisc(pop_up_text)" \
	 -relief "$GuiMisc(pop_up_relief)" \
	 -width {2}

  bind $topwin(util_name).info.frame16.special.menubutton2 <Button-1> {
	MenuPopupPost $topwin(util_name).info.frame16.special.menubutton2.menu %X %Y
  }
  bind $topwin(util_name).info.frame16.special.menubutton2 <ButtonRelease-1> {
	MenuPopupRelease $topwin(util_name).info.frame16.special.menubutton2.menu %W
  }

  # build widget $topwin(util_name).info.frame16.special.menubutton2.menu
  menu $topwin(util_name).info.frame16.special.menubutton2.menu \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)"
  $topwin(util_name).info.frame16.special.menubutton2.menu add command \
	 -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set util(ns_var) 100} \
    -label {100}
  $topwin(util_name).info.frame16.special.menubutton2.menu add command \
	 -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set util(ns_var) 200} \
    -label {200}
  $topwin(util_name).info.frame16.special.menubutton2.menu add command \
	 -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set util(ns_var) 300} \
    -label {300}
  $topwin(util_name).info.frame16.special.menubutton2.menu add command \
	 -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set util(ns_var) 400} \
    -label {400}
  $topwin(util_name).info.frame16.special.menubutton2.menu add command \
	 -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set util(ns_var) 600} \
    -label {600}
  $topwin(util_name).info.frame16.special.menubutton2.menu add command \
	 -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set util(ns_var) 800} \
    -label {800}
  bindtags $topwin(util_name).info.frame16.special.menubutton2.menu {Menu all}
  bind $topwin(util_name).info.frame16.special.menubutton2.menu <B1-Motion> {
	MenuPopupMotion $topwin(util_name).info.frame16.special.menubutton2.menu %W %X %Y
  }
  bind $topwin(util_name).info.frame16.special.menubutton2.menu <ButtonRelease-1> {
	MenuPopupRelease $topwin(util_name).info.frame16.special.menubutton2.menu %W
  }

  # pack widget $topwin(util_name).info.frame16.special
  pack append $topwin(util_name).info.frame16.special \
    $topwin(util_name).info.frame16.special.label1 {left frame center fill} \
    $topwin(util_name).info.frame16.special.value {left frame center expand fill} \
    $topwin(util_name).info.frame16.special.menubutton2 {right frame center fill}

  # build widget $topwin(util_name).info.frame16.frame20
  frame $topwin(util_name).info.frame16.frame20 \
    -background "$GuiColor(frame_bg)" \
    -borderwidth {2}

  # build widget $topwin(util_name).info.frame16.frame20.label1
  label $topwin(util_name).info.frame16.frame20.label1 \
    -background "$GuiColor(label_bg)" \
    -borderwidth {0} \
	 -width {9} \
	 -anchor {e} \
    -text {Alpha:}

  # build widget $topwin(util_name).info.frame16.frame20.value
  entry $topwin(util_name).info.frame16.frame20.value \
    -background "$GuiColor(entry_bg)" \
	 -foreground "$GuiColor(entry_fg)" \
    -relief {sunken} \
    -textvariable {util(ns_alpha)} \
    -width {5}
  endEntry $topwin(util_name).info.frame16.frame20.value 0\
    $topwin(util_name).info.frame16.special.value \
    $topwin(util_name).info.frame16.special.value 

  # build widget $topwin(util_name).info.frame16.frame20.menubutton2
	menubutton $topwin(util_name).info.frame16.frame20.menubutton2 -padx {1} -pady {1} -highlightthickness {0}  \
    -background "$GuiColor(btn_bg)" \
	 -activebackground "$GuiColor(btn_act_bg)" \
    -font "$GuiMisc(pop_up_fn)" \
	 -text "$GuiMisc(pop_up_text)" \
	 -relief "$GuiMisc(pop_up_relief)" \
	 -width {2}

  bind $topwin(util_name).info.frame16.frame20.menubutton2 <Button-1> {
	MenuPopupPost $topwin(util_name).info.frame16.frame20.menubutton2.menu %X %Y
  }
  bind $topwin(util_name).info.frame16.frame20.menubutton2 <ButtonRelease-1> {
	MenuPopupRelease $topwin(util_name).info.frame16.frame20.menubutton2.menu %W
  }

  # build widget $topwin(util_name).info.frame16.frame20.menubutton2.menu
  menu $topwin(util_name).info.frame16.frame20.menubutton2.menu \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)"
  $topwin(util_name).info.frame16.frame20.menubutton2.menu add command \
	 -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set util(ns_alpha) 1.0} \
    -label { 1.0 }
  $topwin(util_name).info.frame16.frame20.menubutton2.menu add command \
	 -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set util(ns_alpha) 2.0} \
    -label { 2.0 }
  $topwin(util_name).info.frame16.frame20.menubutton2.menu add command \
	 -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set util(ns_alpha) 3.0} \
    -label { 3.0 }
  $topwin(util_name).info.frame16.frame20.menubutton2.menu add command \
	 -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set util(ns_alpha) 4.0} \
    -label { 4.0 }
  $topwin(util_name).info.frame16.frame20.menubutton2.menu add command \
	 -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set util(ns_alpha) 5.0} \
    -label { 5.0 }
  bindtags $topwin(util_name).info.frame16.frame20.menubutton2.menu {Menu all}
  bind $topwin(util_name).info.frame16.frame20.menubutton2.menu <B1-Motion> {
	MenuPopupMotion $topwin(util_name).info.frame16.frame20.menubutton2.menu %W %X %Y
  }
  bind $topwin(util_name).info.frame16.frame20.menubutton2.menu <ButtonRelease-1> {
	MenuPopupRelease $topwin(util_name).info.frame16.frame20.menubutton2.menu %W
  }

  # pack widget $topwin(util_name).info.frame16.frame20
  pack append $topwin(util_name).info.frame16.frame20 \
    $topwin(util_name).info.frame16.frame20.label1 {left frame center fill} \
    $topwin(util_name).info.frame16.frame20.value {left frame center expand fill} \
    $topwin(util_name).info.frame16.frame20.menubutton2 {right frame center fill}

  # pack widget $topwin(util_name).info.frame16
  pack append $topwin(util_name).info.frame16 \
    $topwin(util_name).info.frame16.radiobutton18 {left frame center} \
    $topwin(util_name).info.frame16.special {left frame center fillx} \
    $topwin(util_name).info.frame16.frame20 {left frame center fillx}

  # build widget $topwin(util_name).info.frame17
  frame $topwin(util_name).info.frame17 \
    -background "$GuiColor(frame_bg)" \
    -borderwidth {2} \
    -relief {ridge}

  # build widget $topwin(util_name).info.frame17.radiobutton18
	radiobutton $topwin(util_name).info.frame17.radiobutton18 -padx {1} -pady {1} -highlightthickness {0}  \
    -background "$GuiColor(btn_bg)" \
	 -activebackground "$GuiColor(btn_act_bg)" \
    -relief {flat} \
    -text {Salt and Pepper} \
	 -anchor {w} \
	 -width {20} \
    -value {speckle_noise} \
    -variable {util(noise)}

  # build widget $topwin(util_name).info.frame17.frame20
  frame $topwin(util_name).info.frame17.frame20 \
    -background "$GuiColor(frame_bg)" \
    -borderwidth {2}

  # build widget $topwin(util_name).info.frame17.frame20.label1
  label $topwin(util_name).info.frame17.frame20.label1 \
    -background "$GuiColor(label_bg)" \
    -borderwidth {0} \
	 -width {23} \
	 -anchor {w} \
    -text {Probabilities:   of pepper:}

  # build widget $topwin(util_name).info.frame17.frame20.value
  entry $topwin(util_name).info.frame17.frame20.value \
    -background "$GuiColor(entry_bg)" \
	 -foreground "$GuiColor(entry_fg)" \
    -relief {sunken} \
    -textvariable {util(ns_pepper)} \
    -width {5}
  endEntry $topwin(util_name).info.frame17.frame20.value 0\
    $topwin(util_name).info.frame17.frame22.value \
    $topwin(util_name).info.frame17.frame22.value 

  # build widget $topwin(util_name).info.frame17.frame20.menubutton2
	menubutton $topwin(util_name).info.frame17.frame20.menubutton2 -padx {1} -pady {1} -highlightthickness {0}  \
    -background "$GuiColor(btn_bg)" \
	 -activebackground "$GuiColor(btn_act_bg)" \
    -font "$GuiMisc(pop_up_fn)" \
	 -text "$GuiMisc(pop_up_text)" \
	 -relief "$GuiMisc(pop_up_relief)" \
	 -width {2}

  bind $topwin(util_name).info.frame17.frame20.menubutton2 <Button-1> {
	MenuPopupPost $topwin(util_name).info.frame17.frame20.menubutton2.menu %X %Y
  }
  bind $topwin(util_name).info.frame17.frame20.menubutton2 <ButtonRelease-1> {
	MenuPopupRelease $topwin(util_name).info.frame17.frame20.menubutton2.menu %W
  }

  # build widget $topwin(util_name).info.frame17.frame20.menubutton2.menu
  menu $topwin(util_name).info.frame17.frame20.menubutton2.menu \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)"
  $topwin(util_name).info.frame17.frame20.menubutton2.menu add command \
	 -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set util(ns_pepper) 0.02} \
    -label {0.02}
  $topwin(util_name).info.frame17.frame20.menubutton2.menu add command \
	 -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set util(ns_pepper) 0.05} \
    -label {0.05}
  $topwin(util_name).info.frame17.frame20.menubutton2.menu add command \
	 -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set util(ns_pepper) 0.08} \
    -label {0.08}
  $topwin(util_name).info.frame17.frame20.menubutton2.menu add command \
	 -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set util(ns_pepper) 0.10} \
    -label {0.10}
  $topwin(util_name).info.frame17.frame20.menubutton2.menu add command \
	 -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set util(ns_pepper) 0.15} \
    -label {0.15}
  $topwin(util_name).info.frame17.frame20.menubutton2.menu add command \
	 -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set util(ns_pepper) 0.20} \
    -label {0.20}
  bindtags $topwin(util_name).info.frame17.frame20.menubutton2.menu {Menu all}
  bind $topwin(util_name).info.frame17.frame20.menubutton2.menu <B1-Motion> {
	MenuPopupMotion $topwin(util_name).info.frame17.frame20.menubutton2.menu %W %X %Y
  }
  bind $topwin(util_name).info.frame17.frame20.menubutton2.menu <ButtonRelease-1> {
	MenuPopupRelease $topwin(util_name).info.frame17.frame20.menubutton2.menu %W
  }

  # pack widget $topwin(util_name).info.frame17.frame20
  pack append $topwin(util_name).info.frame17.frame20 \
    $topwin(util_name).info.frame17.frame20.label1 {left frame center fill} \
    $topwin(util_name).info.frame17.frame20.value {left frame center expand fill} \
    $topwin(util_name).info.frame17.frame20.menubutton2 {right frame center fill}

  # build widget $topwin(util_name).info.frame17.frame22
  frame $topwin(util_name).info.frame17.frame22 \
    -background "$GuiColor(frame_bg)" \
    -borderwidth {2}

  # build widget $topwin(util_name).info.frame17.frame22.label1
  label $topwin(util_name).info.frame17.frame22.label1 \
    -background "$GuiColor(label_bg)" \
    -borderwidth {0} \
	 -anchor {e} \
	 -width {9} \
    -text {of salt:}

  # build widget $topwin(util_name).info.frame17.frame22.value
  entry $topwin(util_name).info.frame17.frame22.value \
    -background "$GuiColor(entry_bg)" \
	 -foreground "$GuiColor(entry_fg)" \
    -relief {sunken} \
    -textvariable {util(ns_salt)} \
    -width {5}
  endEntry $topwin(util_name).info.frame17.frame22.value 0\
    $topwin(util_name).info.frame17.frame20.value \
    $topwin(util_name).info.frame17.frame20.value 

  # build widget $topwin(util_name).info.frame17.frame22.menubutton2
	menubutton $topwin(util_name).info.frame17.frame22.menubutton2 -padx {1} -pady {1} -highlightthickness {0}  \
    -background "$GuiColor(btn_bg)" \
	 -activebackground "$GuiColor(btn_act_bg)" \
    -font "$GuiMisc(pop_up_fn)" \
	 -text "$GuiMisc(pop_up_text)" \
	 -relief "$GuiMisc(pop_up_relief)" \
	 -width {2}

  bind $topwin(util_name).info.frame17.frame22.menubutton2 <Button-1> {
	MenuPopupPost $topwin(util_name).info.frame17.frame22.menubutton2.menu %X %Y
  }
  bind $topwin(util_name).info.frame17.frame22.menubutton2 <ButtonRelease-1> {
	MenuPopupRelease $topwin(util_name).info.frame17.frame22.menubutton2.menu %W
  }

  # build widget $topwin(util_name).info.frame17.frame22.menubutton2.menu
  menu $topwin(util_name).info.frame17.frame22.menubutton2.menu \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)"
  $topwin(util_name).info.frame17.frame22.menubutton2.menu add command \
	 -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set util(ns_salt) 0.02} \
    -label {0.02}
  $topwin(util_name).info.frame17.frame22.menubutton2.menu add command \
	 -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set util(ns_salt) 0.05} \
    -label {0.05}
  $topwin(util_name).info.frame17.frame22.menubutton2.menu add command \
	 -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set util(ns_salt) 0.08} \
    -label {0.08}
  $topwin(util_name).info.frame17.frame22.menubutton2.menu add command \
	 -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set util(ns_salt) 0.10} \
    -label {0.10}
  $topwin(util_name).info.frame17.frame22.menubutton2.menu add command \
	 -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set util(ns_salt) 0.15} \
    -label {0.15}
  $topwin(util_name).info.frame17.frame22.menubutton2.menu add command \
	 -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set util(ns_salt) 0.20} \
    -label {0.20}
  bindtags $topwin(util_name).info.frame17.frame22.menubutton2.menu {Menu all}
  bind $topwin(util_name).info.frame17.frame22.menubutton2.menu <B1-Motion> {
	MenuPopupMotion $topwin(util_name).info.frame17.frame22.menubutton2.menu %W %X %Y
  }
  bind $topwin(util_name).info.frame17.frame22.menubutton2.menu <ButtonRelease-1> {
	MenuPopupRelease $topwin(util_name).info.frame17.frame22.menubutton2.menu %W
  }

  # pack widget $topwin(util_name).info.frame17.frame22
  pack append $topwin(util_name).info.frame17.frame22 \
    $topwin(util_name).info.frame17.frame22.label1 {left frame center fill} \
    $topwin(util_name).info.frame17.frame22.value {left frame center expand fill} \
    $topwin(util_name).info.frame17.frame22.menubutton2 {right frame center fill}

  # pack widget $topwin(util_name).info.frame17
  pack append $topwin(util_name).info.frame17 \
    $topwin(util_name).info.frame17.radiobutton18 {left frame center} \
    $topwin(util_name).info.frame17.frame20 {left frame center fillx} \
    $topwin(util_name).info.frame17.frame22 {left frame center fillx}

  # pack widget $topwin(util_name).info
  pack append $topwin(util_name).info \
    $topwin(util_name).info.frame14 {top frame center expand fill} \
    $topwin(util_name).info.frame15 {top frame center expand fill} \
    $topwin(util_name).info.frame16 {top frame center expand fill} \
    $topwin(util_name).info.frame17 {top frame center expand fill}


  # build widget $topwin(util_name).current_image
  frame $topwin(util_name).current_image \
    -background "$GuiColor(frame_bg)" \
    -borderwidth {2} \
    -relief {ridge}

  # build widget $topwin(util_name).current_image.frame1
  frame $topwin(util_name).current_image.frame1 \
    -background "$GuiColor(frame_bg)" \
    -borderwidth {2}

  # build widget $topwin(util_name).current_image.frame1.radiobutton4
	radiobutton $topwin(util_name).current_image.frame1.radiobutton4 -padx {1} -pady {1} -highlightthickness {0}  \
    -background "$GuiColor(btn_bg)" \
	 -activebackground "$GuiColor(btn_act_bg)" \
	 -relief {flat}\
	 -command {
		pack append $topwin(util_name).current_image.frame1 \
			  $topwin(util_name).current_image.frame1.label6 {left frame center fill}
		pack forget $topwin(util_name).current_image.frame2.frame9
	 } \
    -text {Use current image: } \
    -value {current} \
    -variable {util(noise_img)}

  # build widget $topwin(util_name).current_image.frame1.label6
  label $topwin(util_name).current_image.frame1.label6 \
    -background "$GuiColor(label_bg)" \
    -foreground {blue} \
    -text {test_image} \
    -textvariable {current_image}

  # pack widget $topwin(util_name).current_image.frame1
  pack append $topwin(util_name).current_image.frame1 \
    $topwin(util_name).current_image.frame1.radiobutton4 {left frame center padx 30} \
    $topwin(util_name).current_image.frame1.label6 {left frame center fill}

  # build widget $topwin(util_name).current_image.frame2
  frame $topwin(util_name).current_image.frame2 \
    -background "$GuiColor(frame_bg)" \
    -borderwidth {2}

  # build widget $topwin(util_name).current_image.frame2.radiobutton5
	radiobutton $topwin(util_name).current_image.frame2.radiobutton5 -padx {1} -pady {4} -highlightthickness {0}  \
    -background "$GuiColor(btn_bg)" \
	 -activebackground "$GuiColor(btn_act_bg)" \
	 -relief {flat}\
	 -command {
		pack append $topwin(util_name).current_image.frame2 \
			  $topwin(util_name).current_image.frame2.frame9 {left frame center}
		pack forget $topwin(util_name).current_image.frame1.label6
	 } \
    -text {Use black image: } \
    -value {black} \
    -variable {util(noise_img)}

  # build widget $topwin(util_name).current_image.frame2.frame9
  frame $topwin(util_name).current_image.frame2.frame9 \
    -background "$GuiColor(frame_bg)" \
    -borderwidth {0}

  # build widget $topwin(util_name).current_image.frame2.frame9.frame7
  frame $topwin(util_name).current_image.frame2.frame9.frame7 \
    -background "$GuiColor(frame_bg)" \
    -borderwidth {0}

  # build widget $topwin(util_name).current_image.frame2.frame9.frame7.frame0
  frame $topwin(util_name).current_image.frame2.frame9.frame7.frame0 \
    -background "$GuiColor(frame_bg)" \
    -borderwidth {0}

  # build widget $topwin(util_name).current_image.frame2.frame9.frame7.frame0.label1
  label $topwin(util_name).current_image.frame2.frame9.frame7.frame0.label1 \
    -background "$GuiColor(label_bg)" \
    -borderwidth {0} \
    -text {Height: }

  # build widget $topwin(util_name).current_image.frame2.frame9.frame7.frame0.value
  entry $topwin(util_name).current_image.frame2.frame9.frame7.frame0.value \
    -background "$GuiColor(entry_bg)" \
	 -foreground "$GuiColor(entry_fg)" \
    -relief {sunken} \
    -textvariable {util(black_height)} \
    -width {10}
  endEntry $topwin(util_name).current_image.frame2.frame9.frame7.frame0.value 0\
    $topwin(util_name).current_image.frame2.frame9.frame8.frame0.value \
    $topwin(util_name).current_image.frame2.frame9.frame8.frame0.value 

  # build widget $topwin(util_name).current_image.frame2.frame9.frame7.frame0.menubutton2
	menubutton $topwin(util_name).current_image.frame2.frame9.frame7.frame0.menubutton2 -padx {1} -pady {1} -highlightthickness {0}  \
    -background "$GuiColor(btn_bg)" \
	 -activebackground "$GuiColor(btn_act_bg)" \
    -font "$GuiMisc(pop_up_fn)" \
	 -text "$GuiMisc(pop_up_text)" \
	 -relief "$GuiMisc(pop_up_relief)" \
	 -width {2}


  bind $topwin(util_name).current_image.frame2.frame9.frame7.frame0.menubutton2 <Button-1> {
	MenuPopupPost $topwin(util_name).current_image.frame2.frame9.frame7.frame0.menubutton2.menu %X %Y
  }
  bind $topwin(util_name).current_image.frame2.frame9.frame7.frame0.menubutton2 <ButtonRelease-1> {
	MenuPopupRelease $topwin(util_name).current_image.frame2.frame9.frame7.frame0.menubutton2.menu %W
  }

  # build widget $topwin(util_name).current_image.frame2.frame9.frame7.frame0.menubutton2.menu
  menu $topwin(util_name).current_image.frame2.frame9.frame7.frame0.menubutton2.menu \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)"
  $topwin(util_name).current_image.frame2.frame9.frame7.frame0.menubutton2.menu add command \
	 -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set util(black_height) 32} \
    -label { 32}
  $topwin(util_name).current_image.frame2.frame9.frame7.frame0.menubutton2.menu add command \
	 -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set util(black_height) 64} \
    -label { 64}
  $topwin(util_name).current_image.frame2.frame9.frame7.frame0.menubutton2.menu add command \
	 -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set util(black_height) 128} \
    -label {128}
  $topwin(util_name).current_image.frame2.frame9.frame7.frame0.menubutton2.menu add command \
	 -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set util(black_height) 256} \
    -label {256}
  $topwin(util_name).current_image.frame2.frame9.frame7.frame0.menubutton2.menu add command \
	 -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set util(black_height) 512} \
    -label {512}

  bindtags $topwin(util_name).current_image.frame2.frame9.frame7.frame0.menubutton2.menu {Menu all}
  bind $topwin(util_name).current_image.frame2.frame9.frame7.frame0.menubutton2.menu <B1-Motion> {
	MenuPopupMotion $topwin(util_name).current_image.frame2.frame9.frame7.frame0.menubutton2.menu %W %X %Y
  }
  bind $topwin(util_name).current_image.frame2.frame9.frame7.frame0.menubutton2.menu <ButtonRelease-1> {
	MenuPopupRelease $topwin(util_name).current_image.frame2.frame9.frame7.frame0.menubutton2.menu %W
  }

  # pack widget $topwin(util_name).current_image.frame2.frame9.frame7.frame0
  pack append $topwin(util_name).current_image.frame2.frame9.frame7.frame0 \
    $topwin(util_name).current_image.frame2.frame9.frame7.frame0.label1 {left frame center fill} \
    $topwin(util_name).current_image.frame2.frame9.frame7.frame0.value {left frame center expand fill} \
    $topwin(util_name).current_image.frame2.frame9.frame7.frame0.menubutton2 {right frame center fill}

  # pack widget $topwin(util_name).current_image.frame2.frame9.frame7
  pack append $topwin(util_name).current_image.frame2.frame9.frame7 \
    $topwin(util_name).current_image.frame2.frame9.frame7.frame0 {top frame center fillx}

  # build widget $topwin(util_name).current_image.frame2.frame9.frame8
  frame $topwin(util_name).current_image.frame2.frame9.frame8 \
    -background "$GuiColor(frame_bg)" \
    -borderwidth {0}

  # build widget $topwin(util_name).current_image.frame2.frame9.frame8.frame0
  frame $topwin(util_name).current_image.frame2.frame9.frame8.frame0 \
    -background "$GuiColor(frame_bg)" \
    -borderwidth {0}

  # build widget $topwin(util_name).current_image.frame2.frame9.frame8.frame0.label1
  label $topwin(util_name).current_image.frame2.frame9.frame8.frame0.label1 \
    -background "$GuiColor(label_bg)" \
    -borderwidth {0} \
    -text {Width: }

  # build widget $topwin(util_name).current_image.frame2.frame9.frame8.frame0.value
  entry $topwin(util_name).current_image.frame2.frame9.frame8.frame0.value \
    -background "$GuiColor(entry_bg)" \
	 -foreground "$GuiColor(entry_fg)" \
    -relief {sunken} \
    -textvariable {util(black_width)} \
    -width {10}
  endEntry $topwin(util_name).current_image.frame2.frame9.frame8.frame0.value 0\
    $topwin(util_name).current_image.frame2.frame9.frame7.frame0.value \
    $topwin(util_name).current_image.frame2.frame9.frame7.frame0.value 

  # build widget $topwin(util_name).current_image.frame2.frame9.frame8.frame0.menubutton2
	menubutton $topwin(util_name).current_image.frame2.frame9.frame8.frame0.menubutton2 -padx {1} -pady {1} -highlightthickness {0}  \
    -background "$GuiColor(btn_bg)" \
	 -activebackground "$GuiColor(btn_act_bg)" \
    -font "$GuiMisc(pop_up_fn)" \
	 -text "$GuiMisc(pop_up_text)" \
	 -relief "$GuiMisc(pop_up_relief)" \
	 -width {2}

  bind $topwin(util_name).current_image.frame2.frame9.frame8.frame0.menubutton2 <Button-1> {
	MenuPopupPost $topwin(util_name).current_image.frame2.frame9.frame8.frame0.menubutton2.menu %X %Y
  }
  bind $topwin(util_name).current_image.frame2.frame9.frame8.frame0.menubutton2 <ButtonRelease-1> {
	MenuPopupRelease $topwin(util_name).current_image.frame2.frame9.frame8.frame0.menubutton2.menu %W
  }

  # build widget $topwin(util_name).current_image.frame2.frame9.frame8.frame0.menubutton2.menu
  menu $topwin(util_name).current_image.frame2.frame9.frame8.frame0.menubutton2.menu \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)"
  $topwin(util_name).current_image.frame2.frame9.frame8.frame0.menubutton2.menu add command \
	 -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set util(black_width) 32} \
    -label { 32}
  $topwin(util_name).current_image.frame2.frame9.frame8.frame0.menubutton2.menu add command \
	 -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set util(black_width) 64} \
    -label { 64}
  $topwin(util_name).current_image.frame2.frame9.frame8.frame0.menubutton2.menu add command \
	 -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set util(black_width) 128} \
    -label {128}
  $topwin(util_name).current_image.frame2.frame9.frame8.frame0.menubutton2.menu add command \
	 -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set util(black_width) 256} \
    -label {256}
  $topwin(util_name).current_image.frame2.frame9.frame8.frame0.menubutton2.menu add command \
	 -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set util(black_width) 512} \
    -label {512}
  bindtags $topwin(util_name).current_image.frame2.frame9.frame8.frame0.menubutton2.menu  {Menu all}

  bind $topwin(util_name).current_image.frame2.frame9.frame8.frame0.menubutton2.menu <B1-Motion> {
	MenuPopupMotion $topwin(util_name).current_image.frame2.frame9.frame8.frame0.menubutton2.menu %W %X %Y
  }
  bind $topwin(util_name).current_image.frame2.frame9.frame8.frame0.menubutton2.menu <ButtonRelease-1> {
	MenuPopupRelease $topwin(util_name).current_image.frame2.frame9.frame8.frame0.menubutton2.menu %W
  }
  
  # pack widget $topwin(util_name).current_image.frame2.frame9.frame8.frame0
  pack append $topwin(util_name).current_image.frame2.frame9.frame8.frame0 \
    $topwin(util_name).current_image.frame2.frame9.frame8.frame0.label1 {left frame center fill} \
    $topwin(util_name).current_image.frame2.frame9.frame8.frame0.value {left frame center expand fill} \
    $topwin(util_name).current_image.frame2.frame9.frame8.frame0.menubutton2 {right frame center fill}

  # pack widget $topwin(util_name).current_image.frame2.frame9.frame8
  pack append $topwin(util_name).current_image.frame2.frame9.frame8 \
    $topwin(util_name).current_image.frame2.frame9.frame8.frame0 {top frame center fillx}

  # pack widget $topwin(util_name).current_image.frame2.frame9
  pack append $topwin(util_name).current_image.frame2.frame9 \
    $topwin(util_name).current_image.frame2.frame9.frame7 {left frame center expand} \
    $topwin(util_name).current_image.frame2.frame9.frame8 {left frame center expand}

  # pack widget $topwin(util_name).current_image.frame2
  pack append $topwin(util_name).current_image.frame2 \
    $topwin(util_name).current_image.frame2.radiobutton5 {left frame center padx 30} 
#    $topwin(util_name).current_image.frame2.frame9 {left frame center}

  # pack widget $topwin(util_name).current_image
  pack append $topwin(util_name).current_image \
    $topwin(util_name).current_image.frame1 {top frame center expand fill} \
    $topwin(util_name).current_image.frame2 {top frame center expand fill}
  # build widget $topwin(util_name).perform
  frame $topwin(util_name).perform \
    -background "$GuiColor(frame_bg)" \
    -borderwidth {2} \
    -relief {raised}

  # build widget $topwin(util_name).perform.button25
	button $topwin(util_name).perform.button25 -padx {1} -pady {1} -highlightthickness {0}  \
	 -foreground "$GuiColor(dis_fg)" \
    -background "$GuiColor(dis_bg)" \
	 -activebackground "$GuiColor(dis_act_bg)" \
	 -command {destroy $topwin(util_name); set topwin(util_name) NONE } \
    -text {DISMISS}

  # build widget $topwin(util_name).perform.button26
	button $topwin(util_name).perform.button26 -padx {1} -pady {1} -highlightthickness {0}  \
	 -foreground "$GuiColor(perf_fg)" \
    -background "$GuiColor(perf_bg)" \
	 -activebackground "$GuiColor(perf_act_bg)" \
	 -command {
		if { $util(noise_img) == "current" } {
		$topwin(util_name) configure -cursor watch; update
	      if {$current_image == ""} {
  	       CvipAlert "Please select an image first."
				$topwin(util_name) configure -cursor top_left_arrow; update
  	       return
  	    }  
		 set temp $current_image
		} else {
			if [catch {expr $util(black_width) + $util(black_height)} ] {
               CvipAlert "Numerical values required for the black image size: \n \
                  Height = $util(black_height), Width = $util(black_width)."
					$topwin(util_name) configure -cursor top_left_arrow; update
					return
			} elseif { $util(black_width) < 1 || $util(black_height) < 1 } {
               CvipAlert "The black image size should be positive integers: \n \
                  Height = $util(black_height), Width = $util(black_width)."
					$topwin(util_name) configure -cursor top_left_arrow; update
					return
			}
			set util(black_height) [expr int(floor($util(black_height)))]
			set util(black_width) [expr int(floor($util(black_width)))]
			set temp [cvip black $util(black_width) $util(black_height)]

		}

		set temp1 [string trimright $util(noise) _noise]
		switch -exact -- $util(noise) {
			rayleigh_noise -
			negative_exp_noise {
            if [catch {expr $util(ns_var)}] {
               CvipAlert "Numerical values required for the Variance value: \n \
                  Variance = $util(ns_var)."
					$topwin(util_name) configure -cursor top_left_arrow; update
               return
            } elseif {$util(ns_var) < 0 || $util(ns_var) > 65535} {
               CvipAlert "The Variance value (=$util(ns_var)) should be \n\
               in the range (0--65530)."
					$topwin(util_name) configure -cursor top_left_arrow; update
               return
            }
            if [catch {set result [cvip $util(noise) $temp $util(ns_var)]} cresult] {
               CvipAlert "$cresult."
					$topwin(util_name) configure -cursor top_left_arrow; update
               return
            } else {
               set new_name [cvip rename $result ${temp}_$temp1]
               img_q insert end $new_name
               image_post $new_name
               cvip view $new_name
            }
				if { $util(noise) == "rayleigh_noise" } {
					CvipMessage "Rayleigh noise added"
				} else {
					CvipMessage "Negative exponential noise added"
				}
				if { $GUI_DEBUG == "1" } {
            	puts stderr "cvip $util(noise) $temp $util(ns_var)]"
				}
			}
			gaussian_noise -
			uniform_noise {
            if [catch {expr $util(ns_var) + $util(ns_mean)}] {
               CvipAlert "Numerical values required for the Variance  and Mean value: \n \
                  Variance = $util(ns_var), Mean = $util(ns_mean)."
					$topwin(util_name) configure -cursor top_left_arrow; update
               return
            } elseif {$util(ns_var) < 0 || $util(ns_var) > 65535} {
               CvipAlert "The Variance value (=$util(ns_var)) should be \n\
               in the range (0--65535)."
					$topwin(util_name) configure -cursor top_left_arrow; update
               return
            } elseif {$util(ns_mean) < -128 || $util(ns_mean) > 128 } {
               CvipAlert "The Mean value (=$util(ns_mean)) should be \n\
               in the range (-128 -- 128)."
					$topwin(util_name) configure -cursor top_left_arrow; update
               return
				}
            if [catch {set result [cvip $util(noise) $temp $util(ns_var)\
							$util(ns_mean)]} cresult] {
               CvipAlert "$cresult."
					$topwin(util_name) configure -cursor top_left_arrow; update
               return
            } else {
               set new_name [cvip rename $result ${temp}_$temp1]
               img_q insert end $new_name
               image_post $new_name
               cvip view $new_name
            }
				if { $util(noise) == "gaussian_noise" } {
					CvipMessage "Gaussian noise added"
				} else {
					CvipMessage "Uniform noise added"
				}
				if { $GUI_DEBUG == "1" } {
            	puts stderr "cvip $util(noise) $temp $util(ns_var) $util(ns_mean)]"
				}
			}

			gamma_noise {
            if [catch {expr $util(ns_var) + $util(ns_alpha)}] {
               CvipAlert "Numerical values required for the Variance  and Alpha value: \n \
                  Variance = $util(ns_var), Alpha = $util(ns_alpha)."
					$topwin(util_name) configure -cursor top_left_arrow; update
               return
            } elseif {$util(ns_var) < 0 || $util(ns_var) > 65535} {
               CvipAlert "The Variance value (=$util(ns_var)) should be \n\
               in the range (0--65535)."
					$topwin(util_name) configure -cursor top_left_arrow; update
               return
            } elseif {$util(ns_alpha) < 1} {
               CvipAlert "The Alpha value (=$util(ns_alpha)) should be \n\
               greater than or equal to 1."
					$topwin(util_name) configure -cursor top_left_arrow; update
               return
				}
            if [catch {set result [cvip $util(noise) $temp $util(ns_var)\
							$util(ns_alpha)]} cresult] {
               CvipAlert "$cresult."
					$topwin(util_name) configure -cursor top_left_arrow; update
               return
            } else {
               set new_name [cvip rename $result ${temp}_$temp1]
               img_q insert end $new_name
               image_post $new_name
               cvip view $new_name
            }
				CvipMessage "Uniform noise added"
				if { $GUI_DEBUG == "1" } {
            	puts stderr "cvip $util(noise) $temp $util(ns_var) $util(ns_alpha)"
				}
			}

			speckle_noise {
            if [catch {expr $util(ns_pepper) + $util(ns_salt)}] {
               CvipAlert "Numerical values required for the probability of salt and pepper: \n \
                  Pepper = $util(ns_pepper), Salt = $util(ns_salt)."
					$topwin(util_name) configure -cursor top_left_arrow; update
               return
            } elseif {$util(ns_pepper) < 0 || $util(ns_salt) < 0} {
               CvipAlert "Positive values required for the probability of salt and pepper: \n \
                  Pepper = $util(ns_pepper), Salt = $util(ns_salt)."
					$topwin(util_name) configure -cursor top_left_arrow; update
               return
            } elseif { $util(ns_pepper) + $util(ns_salt) > 1} {
               CvipAlert "The total probability of salt and pepper ($util(ns_pepper) +\
					$util(ns_salt) = [expr $util(ns_pepper) + $util(ns_salt)]) \
               should be less than or equal to 1."
					$topwin(util_name) configure -cursor top_left_arrow; update
               return
				}
            if [catch {set result [cvip $util(noise) $temp $util(ns_salt)\
							$util(ns_pepper)]} cresult] {
               CvipAlert "$cresult."
					$topwin(util_name) configure -cursor top_left_arrow; update
               return
            } else {
               set new_name [cvip rename $result ${temp}_$temp1]
               img_q insert end $new_name
               image_post $new_name
               cvip view $new_name
            }
				CvipMessage "Salt and pepper noise added"
				if { $GUI_DEBUG == "1" } {
            	puts stderr "cvip $util(noise) $temp $util(ns_salt) $util(ns_pepper)"
				}
			}
		}
		$topwin(util_name) configure -cursor top_left_arrow; update
	 } \
    -text {PERFORM}

  # pack widget $topwin(util_name).perform
  pack append $topwin(util_name).perform \
    $topwin(util_name).perform.button25 {left frame center} \
    $topwin(util_name).perform.button26 {right frame center}

  # pack widget $topwin(util_name)
  pack append $topwin(util_name) \
    $topwin(util_name).info {top frame center expand fill} \
    $topwin(util_name).current_image {top frame center fillx} \
    $topwin(util_name).perform {bottom frame center fillx}

  if {"[info procs XFEdit]" != ""} {
    catch "XFMiscBindWidgetTree ."
    after 2 "catch {XFEditSetShowWindows}"
  }
}

