# **********************************************************************
# Computer Vision/Image Processing Tool Project - Dr. Scott Umbaugh SIUE
# **********************************************************************
#
#             File Name: util_size.tcl
#           Description: 
#         Related Files: 
#   Initial Coding Date: Fri Aug  9 17:34:26 CDT 1996
#           Portability: TCL script file
#            References:
#             Author(s): Yansheng Wei
#                        Southern Illinois University @ Edwardsville
#
## Copyright (C) 1996 SIUE - by Scott Umbaugh and Yansheng Wei.
##
## Permission to use, copy, modify, and distribute this software and its
## documentation for any purpose and without fee is hereby granted, provided
## that the above copyright notice appear in all copies and that both that
## copyright notice and this permission notice appear in supporting
## documentation.  This software is provided "as is" without express or
## implied warranty.
##
# RCS (Revision Control System) Information
# ...Added automatically by RCS 
#
## $Log: util_size.tcl,v $
## Revision 1.18  1997/07/17 23:03:13  yawei
## Gui configuration done
##
## Revision 1.17  1997/06/09 20:11:16  yawei
## changed variable variables
##
## Revision 1.16  1997/06/02 16:47:10  wzheng
## using  Average parameter on spatial_quant
##
## Revision 1.15  1997/05/28 02:38:05  wzheng
## *** empty log message ***
##
## Revision 1.14  1997/05/27 18:18:20  wzheng
## add the biliear_interp choice for resize
##
## Revision 1.13  1997/03/22 00:08:46  yawei
## Added copy paste
##
## Revision 1.12  1997/03/12 17:06:26  yawei
## added arrow buttons
##
## Revision 1.11  1997/03/12 16:35:44  yawei
## fixed arrow boxes,
##
## Revision 1.10  1997/03/11 20:57:22  yawei
## Tcl/Tk script upgrading from tcl7.3/tk3.6 to tcl7.6/tk4.2
## compatible. This process is automated with tkboost perl
## script. @ Tue Mar 11 14:51:36 CST 1997
##
## Revision 1.9  1996/12/31 00:23:36  yawei
## crop_Image ==> crop
##
# Revision 1.8  1996/12/13  18:29:08  akjoele
# Changed crop_inner to crop_image
#
# Revision 1.7  1996/10/17  03:21:55  yawei
# Changed order to "height, width, row, column"
#
# Revision 1.6  1996/10/16  20:22:58  yawei
# general chagnes
#
# Revision 1.5  1996/10/08  02:11:23  yawei
# Added spatial-quantization
#
# Revision 1.4  1996/09/27  18:34:33  mzuke
# made window resizable
#
# Revision 1.3  1996/08/15  11:21:39  mzuke
# removed toplevel_position from wm geometry to allow window
# positioning by user
#
# Revision 1.2  1996/08/13  19:59:53  yawei
# corrected bugs in crop and resize
#
# Revision 1.1  1996/08/09  22:38:12  yawei
# Initial revision
#
#
#****************************************************************************
# procedure to show window $topwin(util_name)
proc util_crop { } {# xf ignore me 7
  global GuiColor
  global GuiMisc
  global GUI_DEBUG

  # Window manager configurations
  global tk_version
  global topwin
  global toplevel_position
  if [ winfo exists $topwin(util_name).info] {
     set tempname $topwin(util_name);\
destroy $topwin(util_name).info;\
set topwin(util_name) $tempname;}
  if [ winfo exists $topwin(util_name).current_image] {
     set tempname $topwin(util_name);\
destroy $topwin(util_name).current_image;\
set topwin(util_name) $tempname;}
  if [ winfo exists $topwin(util_name).perform] {
     set tempname $topwin(util_name);\
destroy $topwin(util_name).perform;\
set topwin(util_name) $tempname;}
  wm positionfrom $topwin(util_name) user
  wm sizefrom $topwin(util_name) user
  wm geometry $topwin(util_name) $topwin(util_top)[get_pos $topwin(util_name)]
  wm maxsize $topwin(util_name) [lindex [split $topwin(util_top_max)] 0] \
  	[lindex [split $topwin(util_top_max)] 1]
  wm minsize $topwin(util_name) [lindex [split $topwin(util_top_min)] 0] \
  	[lindex [split $topwin(util_top_min)] 1]
  wm title $topwin(util_name) {UTILITIES -> Size -> Crop}

  # bindings
  bind $topwin(util_name) <Destroy> {set topwin(util_name) NONE}

  # build widget $topwin(util_name).info
  frame $topwin(util_name).info \
    -background "$GuiColor(frame_bg)" \
    -borderwidth {2}

  # build widget $topwin(util_name).info.frame7
  frame $topwin(util_name).info.frame7 \
    -background "$GuiColor(frame_bg)"

  # build widget $topwin(util_name).info.frame7.util_crop_width
  entry $topwin(util_name).info.frame7.util_crop_width \
    -background "$GuiColor(entry_bg)" \
	 -foreground "$GuiColor(entry_fg)" \
    -relief {sunken} \
    -textvariable {util(util_crop_width)} \
    -width {5}
  # bindings
  endEntry $topwin(util_name).info.frame7.util_crop_width 1\
    $topwin(util_name).info.frame8.crop_ul_col \
    $topwin(util_name).info.frame7.util_crop_height 

  # build widget $topwin(util_name).info.frame7.menubutton0
  menubutton $topwin(util_name).info.frame7.menubutton0 \
    -background "$GuiColor(btn_bg)" \
	 -activebackground "$GuiColor(btn_act_bg)" \
    -padx {1}  -pady {1} -highlightthickness {0} \
	 -font "$GuiMisc(pop_up_fn)" \
	 -text "$GuiMisc(pop_up_text)" \
	 -relief "$GuiMisc(pop_up_relief)" \
	 -width {2}
  # bindings
   bind $topwin(util_name).info.frame7.menubutton0 <Button-1> {MenuPopupPost $topwin(util_name).info.frame7.menubutton0.menu %X %Y}
   bind $topwin(util_name).info.frame7.menubutton0 <ButtonRelease-1> {MenuPopupRelease $topwin(util_name).info.frame7.menubutton0.menu %W}

  # build widget $topwin(util_name).info.frame7.menubutton0.menu
  menu $topwin(util_name).info.frame7.menubutton0.menu \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)"
  $topwin(util_name).info.frame7.menubutton0.menu add command \
	 -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
	 -command {set util(util_crop_width) 8} \
    -label {  8}
  $topwin(util_name).info.frame7.menubutton0.menu add command \
	 -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
	 -command {set util(util_crop_width) 16} \
    -label { 16}
  $topwin(util_name).info.frame7.menubutton0.menu add command \
	 -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
	 -command {set util(util_crop_width) 32} \
    -label { 32}
  $topwin(util_name).info.frame7.menubutton0.menu add command \
	 -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
	 -command {set util(util_crop_width) 64} \
    -label { 64}
  $topwin(util_name).info.frame7.menubutton0.menu add command \
	 -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
	 -command {set util(util_crop_width) 128} \
    -label {128}
  $topwin(util_name).info.frame7.menubutton0.menu add command \
	 -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
	 -command {set util(util_crop_width) 256} \
    -label {256}
  $topwin(util_name).info.frame7.menubutton0.menu add command \
	 -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
	 -command {set util(util_crop_width) 512} \
    -label {512}

  bindtags $topwin(util_name).info.frame7.menubutton0.menu {Menu all}
# bindings
  bind $topwin(util_name).info.frame7.menubutton0.menu <B1-Motion> {
  MenuPopupMotion $topwin(util_name).info.frame7.menubutton0.menu %W %X %Y}
  bind $topwin(util_name).info.frame7.menubutton0.menu <ButtonRelease-1> {
  MenuPopupRelease $topwin(util_name).info.frame7.menubutton0.menu %W}

  # build widget $topwin(util_name).info.frame7.label1
  label $topwin(util_name).info.frame7.label1 \
    -background "$GuiColor(label_bg)" \
    -text {rows and width}

  # build widget $topwin(util_name).info.frame7.util_crop_height
  entry $topwin(util_name).info.frame7.util_crop_height \
    -background "$GuiColor(entry_bg)" \
	 -foreground "$GuiColor(entry_fg)" \
    -relief {sunken} \
    -textvariable {util(util_crop_height)} \
    -width {5}
  # bindings
  endEntry $topwin(util_name).info.frame7.util_crop_height 1\
    $topwin(util_name).info.frame7.util_crop_width \
    $topwin(util_name).info.frame8.crop_ul_row 

  # build widget  $topwin(util_name).info.frame7.menubutton1
  menubutton  $topwin(util_name).info.frame7.menubutton1 \
    -background "$GuiColor(btn_bg)" \
	 -activebackground "$GuiColor(btn_act_bg)" \
    -padx {1}  -pady {1} -highlightthickness {0} \
	 -font "$GuiMisc(pop_up_fn)" \
	 -text "$GuiMisc(pop_up_text)" \
	 -relief "$GuiMisc(pop_up_relief)" \
	 -width {2}
  # bindings
   bind  $topwin(util_name).info.frame7.menubutton1 <Button-1> {MenuPopupPost  $topwin(util_name).info.frame7.menubutton1.menu %X %Y}
   bind  $topwin(util_name).info.frame7.menubutton1 <ButtonRelease-1> {MenuPopupRelease  $topwin(util_name).info.frame7.menubutton1.menu %W}

  # build widget  $topwin(util_name).info.frame7.menubutton1.menu
  menu  $topwin(util_name).info.frame7.menubutton1.menu \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)"
   $topwin(util_name).info.frame7.menubutton1.menu add command \
	 -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
	 -command {set util(util_crop_height) 8} \
    -label {  8}
   $topwin(util_name).info.frame7.menubutton1.menu add command \
	 -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
	 -command {set util(util_crop_height) 16} \
    -label { 16}
   $topwin(util_name).info.frame7.menubutton1.menu add command \
	 -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
	 -command {set util(util_crop_height) 32} \
    -label { 32}
   $topwin(util_name).info.frame7.menubutton1.menu add command \
	 -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
	 -command {set util(util_crop_height) 64} \
    -label { 64}
   $topwin(util_name).info.frame7.menubutton1.menu add command \
	 -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
	 -command {set util(util_crop_height) 128} \
    -label {128}
   $topwin(util_name).info.frame7.menubutton1.menu add command \
	 -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
	 -command {set util(util_crop_height) 256} \
    -label {256}
   $topwin(util_name).info.frame7.menubutton1.menu add command \
	 -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
	 -command {set util(util_crop_height) 512} \
    -label {512}

  bindtags  $topwin(util_name).info.frame7.menubutton1.menu {Menu all}
# bindings
  bind  $topwin(util_name).info.frame7.menubutton1.menu <B1-Motion> {
  MenuPopupMotion  $topwin(util_name).info.frame7.menubutton1.menu %W %X %Y}
  bind  $topwin(util_name).info.frame7.menubutton1.menu <ButtonRelease-1> {
  MenuPopupRelease  $topwin(util_name).info.frame7.menubutton1.menu %W}

  # build widget $topwin(util_name).info.frame7.label3
  label $topwin(util_name).info.frame7.label3 \
    -background "$GuiColor(label_bg)" \
    -text {columns}

  # build widget $topwin(util_name).info.frame7.label4
  label $topwin(util_name).info.frame7.label4 \
    -background "$GuiColor(label_bg)" \
    -text { with a  height }

  # pack widget $topwin(util_name).info.frame7
  pack append $topwin(util_name).info.frame7 \
    $topwin(util_name).info.frame7.label4 {left frame center} \
    $topwin(util_name).info.frame7.util_crop_height {left frame nw} \
    $topwin(util_name).info.frame7.menubutton1 {left frame center filly} \
    $topwin(util_name).info.frame7.label1 {left frame nw} \
    $topwin(util_name).info.frame7.util_crop_width {left frame nw} \
    $topwin(util_name).info.frame7.menubutton0 {left frame center filly} \
    $topwin(util_name).info.frame7.label3 {left frame nw}

  # build widget $topwin(util_name).info.frame8
  frame $topwin(util_name).info.frame8 \
    -background "$GuiColor(frame_bg)"

  # build widget $topwin(util_name).info.frame8.label9
  label $topwin(util_name).info.frame8.label9 \
    -background "$GuiColor(label_bg)" \
    -text { Crop from the upper left corner at row}

  # build widget $topwin(util_name).info.frame8.crop_ul_col
  entry $topwin(util_name).info.frame8.crop_ul_col \
    -background "$GuiColor(entry_bg)" \
	 -foreground "$GuiColor(entry_fg)" \
    -relief {sunken} \
    -textvariable {util(crop_ul_row)} \
    -width {5}
  # bindings
  endEntry $topwin(util_name).info.frame8.crop_ul_col 1\
    $topwin(util_name).info.frame8.crop_ul_row \
    $topwin(util_name).info.frame7.util_crop_width 

  # build widget $topwin(util_name).info.frame8.menubutton0
  menubutton $topwin(util_name).info.frame8.menubutton0 \
    -background "$GuiColor(btn_bg)" \
	 -activebackground "$GuiColor(btn_act_bg)" \
    -padx {1}  -pady {1} -highlightthickness {0} \
	 -font "$GuiMisc(pop_up_fn)" \
	 -text "$GuiMisc(pop_up_text)" \
	 -relief "$GuiMisc(pop_up_relief)" \
	 -width {2}
  # bindings
   bind $topwin(util_name).info.frame8.menubutton0 <Button-1> {MenuPopupPost $topwin(util_name).info.frame8.menubutton0.menu %X %Y}
   bind $topwin(util_name).info.frame8.menubutton0 <ButtonRelease-1> {MenuPopupRelease $topwin(util_name).info.frame8.menubutton0.menu %W}

  # build widget $topwin(util_name).info.frame8.menubutton0.menu
  menu $topwin(util_name).info.frame8.menubutton0.menu \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)"
  $topwin(util_name).info.frame8.menubutton0.menu add command \
	 -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
	 -command {set util(crop_ul_row) 8} \
    -label {  8}
  $topwin(util_name).info.frame8.menubutton0.menu add command \
	 -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
	 -command {set util(crop_ul_row) 16} \
    -label { 16}
  $topwin(util_name).info.frame8.menubutton0.menu add command \
	 -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
	 -command {set util(crop_ul_row) 32} \
    -label { 32}
  $topwin(util_name).info.frame8.menubutton0.menu add command \
	 -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
	 -command {set util(crop_ul_row) 64} \
    -label { 64}
  $topwin(util_name).info.frame8.menubutton0.menu add command \
	 -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
	 -command {set util(crop_ul_row) 128} \
    -label {128}
  $topwin(util_name).info.frame8.menubutton0.menu add command \
	 -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
	 -command {set util(crop_ul_row) 256} \
    -label {256}
  $topwin(util_name).info.frame8.menubutton0.menu add command \
	 -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
	 -command {set util(crop_ul_row) 512} \
    -label {512}

  bindtags $topwin(util_name).info.frame8.menubutton0.menu {Menu all}
# bindings
  bind $topwin(util_name).info.frame8.menubutton0.menu <B1-Motion> {
  MenuPopupMotion TOP.menubutton0.menu %W %X %Y}
  bind TOP.menubutton0.menu <ButtonRelease-1> {
  MenuPopupRelease TOP.menubutton0.menu %W}

  # build widget $topwin(util_name).info.frame8.label14
  label $topwin(util_name).info.frame8.label14 \
    -background "$GuiColor(label_bg)" \
    -text {and column}

  # build widget $topwin(util_name).info.frame8.crop_ul_row
  entry $topwin(util_name).info.frame8.crop_ul_row \
    -background "$GuiColor(entry_bg)" \
	 -foreground "$GuiColor(entry_fg)" \
    -relief {sunken} \
    -textvariable {util(crop_ul_col)} \
    -width {5}
  # bindings
  endEntry $topwin(util_name).info.frame8.crop_ul_row 1\
    $topwin(util_name).info.frame7.util_crop_height \
    $topwin(util_name).info.frame8.crop_ul_col 

  # build widget $topwin(util_name).info.frame8.menubutton1
  menubutton $topwin(util_name).info.frame8.menubutton1 \
    -background "$GuiColor(btn_bg)" \
	 -activebackground "$GuiColor(btn_act_bg)" \
    -padx {1}  -pady {1} -highlightthickness {0} \
	 -font "$GuiMisc(pop_up_fn)" \
	 -text "$GuiMisc(pop_up_text)" \
	 -relief "$GuiMisc(pop_up_relief)" \
	 -width {2}
  # bindings
   bind $topwin(util_name).info.frame8.menubutton1 <Button-1> {MenuPopupPost $topwin(util_name).info.frame8.menubutton1.menu %X %Y}
   bind $topwin(util_name).info.frame8.menubutton1 <ButtonRelease-1> {MenuPopupRelease $topwin(util_name).info.frame8.menubutton1.menu %W}

  # build widget $topwin(util_name).info.frame8.menubutton1.menu
  menu $topwin(util_name).info.frame8.menubutton1.menu \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)"
  $topwin(util_name).info.frame8.menubutton1.menu add command \
	 -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
	 -command {set util(crop_ul_col) 8} \
    -label {  8}
  $topwin(util_name).info.frame8.menubutton1.menu add command \
	 -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
	 -command {set util(crop_ul_col) 16} \
    -label { 16}
  $topwin(util_name).info.frame8.menubutton1.menu add command \
	 -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
	 -command {set util(crop_ul_col) 32} \
    -label { 32}
  $topwin(util_name).info.frame8.menubutton1.menu add command \
	 -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
	 -command {set util(crop_ul_col) 64} \
    -label { 64}
  $topwin(util_name).info.frame8.menubutton1.menu add command \
	 -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
	 -command {set util(crop_ul_col) 128} \
    -label {128}
  $topwin(util_name).info.frame8.menubutton1.menu add command \
	 -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
	 -command {set util(crop_ul_col) 256} \
    -label {256}
  $topwin(util_name).info.frame8.menubutton1.menu add command \
	 -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
	 -command {set util(crop_ul_col) 512} \
    -label {512}

  bindtags $topwin(util_name).info.frame8.menubutton1.menu {Menu all}
# bindings
  bind $topwin(util_name).info.frame8.menubutton1.menu <B1-Motion> {
  MenuPopupMotion $topwin(util_name).info.frame8.menubutton1.menu %W %X %Y}
  bind $topwin(util_name).info.frame8.menubutton1.menu <ButtonRelease-1> {
  MenuPopupRelease $topwin(util_name).info.frame8.menubutton1.menu %W}

  # pack widget $topwin(util_name).info.frame8
  pack append $topwin(util_name).info.frame8 \
    $topwin(util_name).info.frame8.label9 {left frame center} \
    $topwin(util_name).info.frame8.crop_ul_col {left frame center} \
    $topwin(util_name).info.frame8.menubutton0 {left frame center filly} \
    $topwin(util_name).info.frame8.label14 {left frame center} \
    $topwin(util_name).info.frame8.crop_ul_row {left frame center}  \
    $topwin(util_name).info.frame8.menubutton1 {left frame center filly} 

  # pack widget $topwin(util_name).info
  pack append $topwin(util_name).info \
    $topwin(util_name).info.frame8 {top frame center expand fillx} \
    $topwin(util_name).info.frame7 {top frame center expand fillx} 

  # build widget $topwin(util_name).perform
  frame $topwin(util_name).perform \
    -background "$GuiColor(frame_bg)" \
    -borderwidth {2} \
    -relief {raised}

  # build widget $topwin(util_name).perform.perform1
	button $topwin(util_name).perform.perform1 -padx {1} -pady {1} -highlightthickness {0}  \
    -foreground "$GuiColor(perf_fg)" \
    -background "$GuiColor(perf_bg)" \
	 -activebackground "$GuiColor(perf_act_bg)" \
    -command {
		$topwin(util_name) configure -cursor watch; update
		if {$current_image == ""} {
			CvipAlert "Please select an image first."
	 		$topwin(util_name) configure -cursor top_left_arrow; update
			return
		}
		if {[get_coord] == 0} {
			set null2  0
		} else { 
			if { $null2 == "MOUSE_COORDS" } {
				set null2 1
			   selection clear .
			} else {set null2 0}
		}
		if {$null2 == 1} {
			if {$cname != $current_image} {
				CvipAlert "Please select a subimage on the CURRENT image."
	 			$topwin(util_name) configure -cursor top_left_arrow; update
				return
			}   
			if [catch { set result [cvip crop $current_image $row_coord $col_coord $d_row $d_col] } cresult ] {
				CvipAlert "$cresult."
	 			$topwin(util_name) configure -cursor top_left_arrow; update
				return
			}
			set util(crop_ul_row) $row_coord; set util(crop_ul_col) $col_coord
			set  util(util_crop_height) $d_row; set util(util_crop_width) $d_col
		} else {
			if {[check_coord $util(crop_ul_row) $util(crop_ul_col) $util(util_crop_height) $util(util_crop_width)] != 1} {
	 			$topwin(util_name) configure -cursor top_left_arrow; update
				return
			} else  {
				if [catch { set result [cvip crop $current_image $util(crop_ul_row) $util(crop_ul_col)\
							$util(util_crop_height) $util(util_crop_width)] } cresult ] {
					CvipAlert "$cresult."
		 			$topwin(util_name) configure -cursor top_left_arrow; update
					return
				}
			}
		}
		set second_image $current_image
		set new_name [cvip rename $result ${current_image}_subImg]
		img_q insert end $new_name
		image_post $new_name
		cvip view $new_name
		CvipMessage "subimage cropped from image \"$current_image\""
	 $topwin(util_name) configure -cursor top_left_arrow; update
	 } \
    -text {PERFORM}

  # build widget $topwin(util_name).perform.dismiss
	button $topwin(util_name).perform.dismiss -padx {1} -pady {1} -highlightthickness {0}  \
    -foreground "$GuiColor(dis_fg)" \
    -background "$GuiColor(dis_bg)" \
	 -activebackground "$GuiColor(dis_act_bg)" \
    -command {destroy $topwin(util_name); set topwin(util_name) NONE} \
    -text {DISMISS} \
    -width {10}

  # pack widget $topwin(util_name).perform
  pack append $topwin(util_name).perform \
    $topwin(util_name).perform.dismiss {left frame sw filly} \
    $topwin(util_name).perform.perform1 {right frame se filly}

  # build widget $topwin(util_name).current_image
  frame $topwin(util_name).current_image \
    -background "$GuiColor(frame_bg)" \
    -borderwidth {2} \
    -relief {ridge}

  # build widget $topwin(util_name).current_image.current
  label $topwin(util_name).current_image.current \
    -background "$GuiColor(label_bg)" \
    -text {Current image:}

  # build widget $topwin(util_name).current_image.name
  label $topwin(util_name).current_image.name \
    -background "$GuiColor(rlabel_bg)" \
    -foreground "$GuiColor(rlabel_fg)" \
    -text {} \
    -textvariable {current_image}

  # pack widget $topwin(util_name).current_image
  pack append $topwin(util_name).current_image \
    $topwin(util_name).current_image.current {left frame center} \
    $topwin(util_name).current_image.name {left frame center filly}

  # pack widget $topwin(util_name)
  pack append $topwin(util_name) \
    $topwin(util_name).info {top frame center expand fill} \
    $topwin(util_name).perform {bottom frame center pady 5 fill} \
    $topwin(util_name).current_image {bottom frame center fill}

  if {"[info procs XFEdit]" != ""} {
    catch "XFMiscBindWidgetTree $topwin(util_name)"
    after 2 "catch {XFEditSetShowWindows}"
  }
}


# procedure to show window $topwin(util_name)
proc util_resize { } {# xf ignore me 7
  global GuiColor
  global GuiMisc
  global GUI_DEBUG

  # Window manager configurations
  global tk_version
  global topwin
  global toplevel_position
  if [ winfo exists $topwin(util_name).info] {
     set tempname $topwin(util_name);\
destroy $topwin(util_name).info;\
set topwin(util_name) $tempname;}
  if [ winfo exists $topwin(util_name).current_image] {
     set tempname $topwin(util_name);\
destroy $topwin(util_name).current_image;\
set topwin(util_name) $tempname;}
  if [ winfo exists $topwin(util_name).perform] {
     set tempname $topwin(util_name);\
destroy $topwin(util_name).perform;\
set topwin(util_name) $tempname;}
  
  wm positionfrom $topwin(util_name) user
  wm sizefrom $topwin(util_name) user
  wm geometry $topwin(util_name) $topwin(util_top)[get_pos $topwin(util_name)]
  wm maxsize $topwin(util_name) [lindex [split $topwin(util_top_max)] 0] \
  	[lindex [split $topwin(util_top_max)] 1]
  wm minsize $topwin(util_name) [lindex [split $topwin(util_top_min)] 0] \
  	[lindex [split $topwin(util_top_min)] 1]
  wm title $topwin(util_name) {UTILITIES -> Size -> Resize}

  # bindings
  bind $topwin(util_name) <Destroy> {set topwin(util_name) NONE}

  # build widget $topwin(util_name).info
  frame $topwin(util_name).info \
    -background "$GuiColor(frame_bg)" \
    -borderwidth {2}
    
  # build widget $topwin(util_name).info.frame7
  frame $topwin(util_name).info.frame7 \
    -background "$GuiColor(frame_bg)"

  # build widget $topwin(util_name).info.frame7.left
  frame $topwin(util_name).info.frame7.left \
    -background "$GuiColor(frame_bg)"

  # build widget $topwin(util_name).info.frame7.left.util_crop_width
  entry $topwin(util_name).info.frame7.left.util_crop_width \
    -background "$GuiColor(entry_bg)" \
	 -foreground "$GuiColor(entry_fg)" \
    -relief {sunken} \
    -textvariable {util(resize_width)} \
    -width {5}
  # bindings
  endEntry $topwin(util_name).info.frame7.left.util_crop_width 0\
    $topwin(util_name).info.frame7.left.util_crop_height \
    $topwin(util_name).info.frame7.left.util_crop_height 

  # build widget $topwin(util_name).info.frame7.left.menubutton1
  menubutton $topwin(util_name).info.frame7.left.menubutton1 \
    -background "$GuiColor(btn_bg)" \
	 -activebackground "$GuiColor(btn_act_bg)" \
    -padx {1}  -pady {1} -highlightthickness {0} \
	 -font "$GuiMisc(pop_up_fn)" \
	 -text "$GuiMisc(pop_up_text)" \
	 -relief "$GuiMisc(pop_up_relief)" \
	 -width {2}
  # bindings
   bind $topwin(util_name).info.frame7.left.menubutton1 <Button-1> {MenuPopupPost $topwin(util_name).info.frame7.left.menubutton1.menu %X %Y}
   bind $topwin(util_name).info.frame7.left.menubutton1 <ButtonRelease-1> {MenuPopupRelease $topwin(util_name).info.frame7.left.menubutton1.menu %W}

  # build widget $topwin(util_name).info.frame7.left.menubutton1.menu
  menu $topwin(util_name).info.frame7.left.menubutton1.menu \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)"
  $topwin(util_name).info.frame7.left.menubutton1.menu add command \
	 -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
	 -command {set util(resize_width) 8} \
    -label {  8}
  $topwin(util_name).info.frame7.left.menubutton1.menu add command \
	 -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
	 -command {set util(resize_width) 16} \
    -label { 16}
  $topwin(util_name).info.frame7.left.menubutton1.menu add command \
	 -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
	 -command {set util(resize_width) 32} \
    -label { 32}
  $topwin(util_name).info.frame7.left.menubutton1.menu add command \
	 -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
	 -command {set util(resize_width) 64} \
    -label { 64}
  $topwin(util_name).info.frame7.left.menubutton1.menu add command \
	 -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
	 -command {set util(resize_width) 128} \
    -label {128}
  $topwin(util_name).info.frame7.left.menubutton1.menu add command \
	 -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
	 -command {set util(resize_width) 256} \
    -label {256}
  $topwin(util_name).info.frame7.left.menubutton1.menu add command \
	 -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
	 -command {set util(resize_width) 512} \
    -label {512}

  bindtags $topwin(util_name).info.frame7.left.menubutton1.menu {Menu all}
# bindings
  bind $topwin(util_name).info.frame7.left.menubutton1.menu <B1-Motion> {
  MenuPopupMotion $topwin(util_name).info.frame7.left.menubutton1.menu %W %X %Y}
  bind $topwin(util_name).info.frame7.left.menubutton1.menu <ButtonRelease-1> {
  MenuPopupRelease $topwin(util_name).info.frame7.left.menubutton1.menu %W}

  # build widget $topwin(util_name).info.frame7.left.label1
  label $topwin(util_name).info.frame7.left.label1 \
    -background "$GuiColor(label_bg)" \
    -text {rows and width}

  # build widget $topwin(util_name).info.frame7.left.util_crop_height
  entry $topwin(util_name).info.frame7.left.util_crop_height \
    -background "$GuiColor(entry_bg)" \
	 -foreground "$GuiColor(entry_fg)" \
    -relief {sunken} \
    -textvariable {util(resize_height)} \
    -width {5}
  # bindings
  endEntry $topwin(util_name).info.frame7.left.util_crop_height 0\
    $topwin(util_name).info.frame7.left.util_crop_width \
    $topwin(util_name).info.frame7.left.util_crop_width 

  # build widget $topwin(util_name).info.frame7.left.menubutton0
  menubutton $topwin(util_name).info.frame7.left.menubutton0 \
    -background "$GuiColor(btn_bg)" \
	 -activebackground "$GuiColor(btn_act_bg)" \
    -padx {1}  -pady {1} -highlightthickness {0} \
	 -font "$GuiMisc(pop_up_fn)" \
	 -text "$GuiMisc(pop_up_text)" \
	 -relief "$GuiMisc(pop_up_relief)" \
	 -width {2}
  # bindings
   bind $topwin(util_name).info.frame7.left.menubutton0 <Button-1> {MenuPopupPost $topwin(util_name).info.frame7.left.menubutton0.menu %X %Y}
   bind $topwin(util_name).info.frame7.left.menubutton0 <ButtonRelease-1> {MenuPopupRelease $topwin(util_name).info.frame7.left.menubutton0.menu %W}

  # build widget $topwin(util_name).info.frame7.left.menubutton0.menu
  menu $topwin(util_name).info.frame7.left.menubutton0.menu \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)"
  $topwin(util_name).info.frame7.left.menubutton0.menu add command \
	 -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
	 -command {set util(resize_height) 8} \
    -label {  8}
  $topwin(util_name).info.frame7.left.menubutton0.menu add command \
	 -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
	 -command {set util(resize_height) 16} \
    -label { 16}
  $topwin(util_name).info.frame7.left.menubutton0.menu add command \
	 -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
	 -command {set util(resize_height) 32} \
    -label { 32}
  $topwin(util_name).info.frame7.left.menubutton0.menu add command \
	 -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
	 -command {set util(resize_height) 64} \
    -label { 64}
  $topwin(util_name).info.frame7.left.menubutton0.menu add command \
	 -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
	 -command {set util(resize_height) 128} \
    -label {128}
  $topwin(util_name).info.frame7.left.menubutton0.menu add command \
	 -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
	 -command {set util(resize_height) 256} \
    -label {256}
  $topwin(util_name).info.frame7.left.menubutton0.menu add command \
	 -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
	 -command {set util(resize_height) 512} \
    -label {512}

  bindtags $topwin(util_name).info.frame7.left.menubutton0.menu {Menu all}  
  
# bindings
  bind $topwin(util_name).info.frame7.left.menubutton0.menu <B1-Motion> {
  MenuPopupMotion $topwin(util_name).info.frame7.left.menubutton0.menu %W %X %Y}
  bind $topwin(util_name).info.frame7.left.menubutton0.menu <ButtonRelease-1> {
  MenuPopupRelease $topwin(util_name).info.frame7.left.menubutton0.menu %W}

  # build widget $topwin(util_name).info.frame7.left.label3
  label $topwin(util_name).info.frame7.left.label3 \
    -background "$GuiColor(label_bg)" \
    -text {columns }

  # build widget $topwin(util_name).info.frame7.left.label4
  label $topwin(util_name).info.frame7.left.label4 \
    -background "$GuiColor(label_bg)" \
    -text {Resize image to height: }
    
  # pack widget $topwin(util_name).info.frame7.left
  pack append $topwin(util_name).info.frame7.left \
    $topwin(util_name).info.frame7.left.label4 {left frame center} \
    $topwin(util_name).info.frame7.left.util_crop_height {left frame w} \
    $topwin(util_name).info.frame7.left.menubutton0 {left frame center } \
    $topwin(util_name).info.frame7.left.label1 {left frame w} \
    $topwin(util_name).info.frame7.left.util_crop_width {left frame w} \
    $topwin(util_name).info.frame7.left.menubutton1 {left frame center } \
    $topwin(util_name).info.frame7.left.label3 {left frame w}
    
  # build widget $topwin(util_name).info.frame7.right
  frame $topwin(util_name).info.frame7.right \
    -background "$GuiColor(frame_bg)"

  label $topwin(util_name).info.frame7.right.label \
    -background "$GuiColor(label_bg)" \
	 -text {using}
  # build widget $topwin(util_name).info.frame7.right.radiobutton1
        radiobutton $topwin(util_name).info.frame7.right.radiobutton1 -padx {1} -pady {1} -highlightthickness {0}  \
    -background "$GuiColor(btn_bg)" \
	 -activebackground "$GuiColor(btn_act_bg)" \
    -relief {flat} \
    -text {Zero order hold} \
    -value {0} \
    -variable {util(linear)}   
     
  # build widget $topwin(util_name).info.frame7.right.radiobutton2
        radiobutton $topwin(util_name).info.frame7.right.radiobutton2 -padx {1} -pady {1} -highlightthickness {0}  \
    -background "$GuiColor(btn_bg)" \
	 -activebackground "$GuiColor(btn_act_bg)" \
    -relief {flat} \
    -text {linear interpolation} \
    -value {1} \
    -variable {util(linear)}   
   
    
  # pack widget $topwin(util_name).info.frame7.right
  pack append $topwin(util_name).info.frame7.right \
    $topwin(util_name).info.frame7.right.label {left frame center} \
    $topwin(util_name).info.frame7.right.radiobutton1 {left frame center} \
    $topwin(util_name).info.frame7.right.radiobutton2 {left frame center} 
    
  # pack widget $topwin(util_name).info.frame7
  pack append $topwin(util_name).info.frame7 \
    $topwin(util_name).info.frame7.left {top frame center expand fill} \
    $topwin(util_name).info.frame7.right {top frame center expand fill}
  
  # pack widget $topwin(util_name).info
  pack append $topwin(util_name).info \
    $topwin(util_name).info.frame7 {top frame center expand fill}
      

  # build widget $topwin(util_name).perform
  frame $topwin(util_name).perform \
    -background "$GuiColor(frame_bg)" \
    -borderwidth {2} \
    -relief {raised}

  # build widget $topwin(util_name).perform.perform1
	button $topwin(util_name).perform.perform1 -padx {1} -pady {1} -highlightthickness {0}  \
    -foreground "$GuiColor(perf_fg)" \
    -background "$GuiColor(perf_bg)" \
	 -activebackground "$GuiColor(perf_act_bg)" \
    -command {
		$topwin(util_name) configure -cursor watch; update
		if {$current_image == ""} {
			CvipAlert "Please select an image first."
			$topwin(util_name) configure -cursor top_left_arrow; update
			return
		}
   if [catch {expr $util(resize_width) + $util(resize_height)} temp] {
      CvipAlert "Numerical values required for resizing: \n\
      height = $util(resize_height) width = $util(resize_width)"
		$topwin(util_name) configure -cursor top_left_arrow; update
      return
   }
 
   if {$util(resize_width) < 0 || $util(resize_height) < 0} {
      CvipAlert "No negative values allowed for resizing: \n\
      height = $util(resize_height) width = $util(resize_width)"
		$topwin(util_name) configure -cursor top_left_arrow; update
      return
   }
 
	if {($util(resize_width) >= $cols && $util(resize_height) > $rows && $util(linear) == "0") ||
	        ($util(resize_width) > $cols && $util(resize_height) >= $rows && $util(linear) == "0")} {
		if [catch {set result [cvip enlarge $current_image $util(resize_height) $util(resize_width)] } cresult] {
		   CvipAlert "$cresult."
			$topwin(util_name) configure -cursor top_left_arrow; update
			return
		}
		set new_name [cvip rename $result ${current_image}_$util(resize_width)x$util(resize_height)]
		img_q insert end $new_name
		image_post $new_name
		cvip view $new_name
	}
	if {($util(resize_width) < $cols && $util(resize_height) < $rows && $util(linear) == "0") || 
	        ($util(resize_width) == $cols && $util(resize_height) < $rows && $util(linear) == "0") || 
	        ($util(resize_width) < $cols && $util(resize_height) == $rows && $util(linear) == "0")} {
		if [ catch { set result [cvip spatial_quant $current_image 1  $util(resize_height) $util(resize_width)] } cresult ] {
		   CvipAlert "$cresult."
			$topwin(util_name) configure -cursor top_left_arrow; update
			return
		}
		set new_name [cvip rename $result ${current_image}_$util(resize_width)x$util(resize_height)]
		img_q insert end $new_name
		image_post $new_name
		cvip view $new_name
	}

	if {($util(resize_width) < $cols && $util(resize_height) > $rows) && $util(linear) == "0"} {
		if [catch {set result [cvip enlarge $current_image $util(resize_height) $cols]} cresult] {
		   CvipAlert  "$cresult."
			$topwin(util_name) configure -cursor top_left_arrow; update
			return
		}
		
		set result [cvip spatial_quant $result 1  $util(resize_height) $util(resize_width)]
		set new_name [cvip rename $result ${current_image}_$util(resize_width)x$util(resize_height)]
		img_q insert end $new_name
		image_post $new_name
		cvip view $new_name		
	}

	if {($util(resize_width) > $cols && $util(resize_height) < $rows) && $util(linear) == "0"} {
		if [catch {set result [cvip enlarge $current_image $rows $util(resize_width)]} cresult] {
		   CvipAlert  "$cresult."
			$topwin(util_name) configure -cursor top_left_arrow; update
			return
		}
		
		if [ catch {set result [cvip spatial_quant $result 1  $util(resize_height) $util(resize_width)]} cresult ] {
		   CvipAlert  "$cresult."
			$topwin(util_name) configure -cursor top_left_arrow; update
			return
		}
		set new_name [cvip rename $result ${current_image}_$util(resize_width)x$util(resize_height)]
		img_q insert end $new_name
		image_post $new_name
		cvip view $new_name		
	}	

    if { $util(linear) == "1"} {

        if {[expr 1.0*$util(resize_width) / $cols] > [expr 1.0*$util(resize_height) / $rows]} {
        	if [catch {set result0 [cvip bilinear_interp $current_image [expr 1.0*$util(resize_width) / $cols]]} cresult] {
		   CvipAlert "$cresult." 
			$topwin(util_name) configure -cursor top_left_arrow; update
			return
		}
        }

        if {[expr 1.0*$util(resize_width) / $cols] < [expr 1.0*$util(resize_height) / $rows]} {
        	if [catch {set result0 [cvip bilinear_interp $current_image [expr 1.0*$util(resize_height) / $rows]]} cresult] {
		   CvipAlert "$cresult." 
			$topwin(util_name) configure -cursor top_left_arrow; update
			return
		}
        }
       
        if {[expr 1.0*$util(resize_width) / $cols] != [expr 1.0*$util(resize_height) / $rows]} {
		set result [cvip spatial_quant $result0 1  $util(resize_height) $util(resize_width)]
		set new_name [cvip rename $result ${current_image}_$util(resize_width)x$util(resize_height)]
		img_q insert end $new_name
		image_post $new_name
		cvip view $new_name
	}
	
	if {([expr 1.0*$util(resize_width) / $cols] == [expr 1.0*$util(resize_height) / $rows]) && 
		($util(resize_width) != $cols)} {
        	if [catch {set result [cvip bilinear_interp $current_image [expr 1.0*$util(resize_width) / $cols]]} cresult] {
		   CvipAlert "$cresult." 
			$topwin(util_name) configure -cursor top_left_arrow; update
			return
		}
		
		set new_name [cvip rename $result ${current_image}_$util(resize_width)x$util(resize_height)]
		img_q insert end $new_name
		image_post $new_name
		cvip view $new_name	
		
	}
    }

	if {$util(resize_width) == $cols && $util(resize_height) == $rows} {
		CvipAlert "You requested a new image of equal size to the current image.\
			Either the new width or new height must be different."
	}
	CvipMessage "image \"$current_image\" is resized to $util(resize_height) rows and \
	$util(resize_width) columns"
	$topwin(util_name) configure -cursor top_left_arrow; update
	} \
    -text {PERFORM}

  # build widget $topwin(util_name).perform.dismiss
	button $topwin(util_name).perform.dismiss -padx {1} -pady {1} -highlightthickness {0}  \
    -foreground "$GuiColor(dis_fg)" \
    -background "$GuiColor(dis_bg)" \
	 -activebackground "$GuiColor(dis_act_bg)" \
    -command {destroy $topwin(util_name); set topwin(util_name) NONE} \
    -text {DISMISS} \
    -width {10}

  # pack widget $topwin(util_name).perform
  pack append $topwin(util_name).perform \
    $topwin(util_name).perform.dismiss {left frame sw filly} \
    $topwin(util_name).perform.perform1 {right frame se filly}

  # build widget $topwin(util_name).current_image
  frame $topwin(util_name).current_image \
    -background "$GuiColor(frame_bg)" \
    -borderwidth {2} \
    -relief {ridge}

  # build widget $topwin(util_name).current_image.current
  label $topwin(util_name).current_image.current \
    -background "$GuiColor(label_bg)" \
    -text {Current image:}

  # build widget $topwin(util_name).current_image.name
  label $topwin(util_name).current_image.name \
    -background "$GuiColor(rlabel_bg)" \
    -foreground "$GuiColor(rlabel_bg)" \
    -text {} \
    -textvariable {current_image}

  # pack widget $topwin(util_name).current_image
  pack append $topwin(util_name).current_image \
    $topwin(util_name).current_image.current {left frame center} \
    $topwin(util_name).current_image.name {left frame center filly}

  # pack widget $topwin(util_name)
  pack append $topwin(util_name) \
    $topwin(util_name).info {top frame center expand fill} \
    $topwin(util_name).perform {bottom frame center pady 5 fill} \
    $topwin(util_name).current_image {bottom frame center fill}

  if {"[info procs XFEdit]" != ""} {
    catch "XFMiscBindWidgetTree $topwin(util_name)"
    after 2 "catch {XFEditSetShowWindows}"
  }
}


proc util_spa_quant { } {# xf ignore me 7
  global GuiColor
  global GuiMisc
  global GUI_DEBUG

  # Window manager configurations
  global tk_version
  global topwin
  global toplevel_position
  if [ winfo exists $topwin(util_name).info] {
     set tempname $topwin(util_name);\
destroy $topwin(util_name).info;\
set topwin(util_name) $tempname;}
  if [ winfo exists $topwin(util_name).current_image] {
     set tempname $topwin(util_name);\
destroy $topwin(util_name).current_image;\
set topwin(util_name) $tempname;}
  if [ winfo exists $topwin(util_name).perform] {
     set tempname $topwin(util_name);\
destroy $topwin(util_name).perform;\
set topwin(util_name) $tempname;}
  wm positionfrom $topwin(util_name) user
  wm sizefrom $topwin(util_name) user
  wm geometry $topwin(util_name) $topwin(util_top)[get_pos $topwin(util_name)]
  wm maxsize $topwin(util_name) [lindex [split $topwin(util_top_max)] 0] \
  	[lindex [split $topwin(util_top_max)] 1]
  wm minsize $topwin(util_name) [lindex [split $topwin(util_top_min)] 0] \
  	[lindex [split $topwin(util_top_min)] 1]
  wm title $topwin(util_name) {UTILITIES -> Size -> Spatial quantization}

  # bindings
  bind $topwin(util_name) <Destroy> {set topwin(util_name) NONE}

  # build widget $topwin(util_name).info
  frame $topwin(util_name).info \
    -background "$GuiColor(frame_bg)" \
    -borderwidth {0} \
    -relief {flat}

  # build widget $topwin(util_name).info.frame1
  frame $topwin(util_name).info.frame1 \
    -background "$GuiColor(frame_bg)" \
    -borderwidth {2} \
    -relief {ridge}

  # build widget $topwin(util_name).info.frame9
  frame $topwin(util_name).info.frame9 \
    -background "$GuiColor(frame_bg)" \
    -borderwidth {2}

  # build widget $topwin(util_name).info.frame9.label6
  label $topwin(util_name).info.frame9.label6 \
    -background "$GuiColor(label_bg)" \
    -text {To height:}

  # build widget $topwin(util_name).info.frame9.entry7
  entry $topwin(util_name).info.frame9.entry7 \
    -background "$GuiColor(entry_bg)" \
	 -foreground "$GuiColor(entry_fg)" \
    -relief {sunken} \
    -textvariable {util(quant_ht)} \
    -width {5}
  # bindings
  endEntry $topwin(util_name).info.frame9.entry7 0\
    $topwin(util_name).info.frame10.entry7 \
    $topwin(util_name).info.frame10.entry7 
  

  # build widget $topwin(util_name).info.frame9.button8
	menubutton $topwin(util_name).info.frame9.button8 -padx {1} -pady {1} -highlightthickness {0}  \
    -background "$GuiColor(btn_bg)" \
	 -activebackground "$GuiColor(btn_act_bg)" \
	 -relief {raised} \
    -font "$GuiMisc(pop_up_fn)" \
	 -text "$GuiMisc(pop_up_text)" \
	 -relief "$GuiMisc(pop_up_relief)" \
	 -width {2}
  bind $topwin(util_name).info.frame9.button8 <Button-1> {MenuPopupPost $topwin(util_name).info.frame9.button8.menu %X %Y}
  bind $topwin(util_name).info.frame9.button8 <ButtonRelease-1> {MenuPopupRelease $topwin(util_name).info.frame9.button8.menu %W}

  # build widget $topwin(util_name).info.frame9.button8.menu
  menu $topwin(util_name).info.frame9.button8.menu \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)"
  $topwin(util_name).info.frame9.button8.menu add command \
	 -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set util(quant_ht) 32} \
    -label {32}
  $topwin(util_name).info.frame9.button8.menu add command \
	 -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set util(quant_ht) 64} \
    -label {64}
  $topwin(util_name).info.frame9.button8.menu add command \
	 -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set util(quant_ht) 128} \
    -label {128}
  $topwin(util_name).info.frame9.button8.menu add command \
	 -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set util(quant_ht) 256} \
    -label {256}
  bindtags $topwin(util_name).info.frame9.button8.menu {Menu all}
  # bindings
  bind $topwin(util_name).info.frame9.button8.menu <B1-Motion> {MenuPopupMotion $topwin(util_name).info.frame9.button8.menu %W %X %Y}
  bind $topwin(util_name).info.frame9.button8.menu <ButtonRelease-1> {MenuPopupRelease $topwin(util_name).info.frame9.button8.menu %W}

  # pack widget $topwin(util_name).info.frame9
  pack append $topwin(util_name).info.frame9 \
    $topwin(util_name).info.frame9.label6 {left frame center} \
    $topwin(util_name).info.frame9.entry7 {left frame center} \
    $topwin(util_name).info.frame9.button8 {left frame center}

  # build widget $topwin(util_name).info.frame10
  frame $topwin(util_name).info.frame10 \
    -background "$GuiColor(frame_bg)" \
    -borderwidth {2}

  # build widget $topwin(util_name).info.frame10.label6
  label $topwin(util_name).info.frame10.label6 \
    -background "$GuiColor(label_bg)" \
    -text {To width:}

  # build widget $topwin(util_name).info.frame10.entry7
  entry $topwin(util_name).info.frame10.entry7 \
    -background "$GuiColor(entry_bg)" \
	 -foreground "$GuiColor(entry_fg)" \
    -relief {sunken} \
    -textvariable {util(quant_wd)} \
    -width {5}
  # bindings
  endEntry $topwin(util_name).info.frame10.entry7 0\
    $topwin(util_name).info.frame9.entry7 \
    $topwin(util_name).info.frame9.entry7 

  # build widget $topwin(util_name).info.frame10.button8
	menubutton $topwin(util_name).info.frame10.button8 -padx {1} -pady {1} -highlightthickness {0}  \
    -background "$GuiColor(btn_bg)" \
	 -activebackground "$GuiColor(btn_act_bg)" \
	 -relief {raised} \
    -font "$GuiMisc(pop_up_fn)" \
	 -text "$GuiMisc(pop_up_text)" \
	 -relief "$GuiMisc(pop_up_relief)" \
	 -width {2}
  bind $topwin(util_name).info.frame10.button8 <Button-1> {MenuPopupPost $topwin(util_name).info.frame10.button8.menu %X %Y}
  bind $topwin(util_name).info.frame10.button8 <ButtonRelease-1> {MenuPopupRelease $topwin(util_name).info.frame10.button8.menu %W}

  # build widget $topwin(util_name).info.frame10.button8.menu
  menu $topwin(util_name).info.frame10.button8.menu \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)"
  $topwin(util_name).info.frame10.button8.menu add command \
	 -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set util(quant_wd) 32} \
    -label {32}
  $topwin(util_name).info.frame10.button8.menu add command \
	 -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set util(quant_wd) 64} \
    -label {64}
  $topwin(util_name).info.frame10.button8.menu add command \
	 -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set util(quant_wd) 128} \
    -label {128}
  $topwin(util_name).info.frame10.button8.menu add command \
	 -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)" \
    -command {set util(quant_wd) 256} \
    -label {256}
  bindtags $topwin(util_name).info.frame10.button8.menu {Menu all}
  # bindings
  bind $topwin(util_name).info.frame10.button8.menu <B1-Motion> {MenuPopupMotion $topwin(util_name).info.frame10.button8.menu %W %X %Y}
  bind $topwin(util_name).info.frame10.button8.menu <ButtonRelease-1> {MenuPopupRelease $topwin(util_name).info.frame10.button8.menu %W}

  # pack widget $topwin(util_name).info.frame10
  pack append $topwin(util_name).info.frame10 \
    $topwin(util_name).info.frame10.label6 {left frame center} \
    $topwin(util_name).info.frame10.entry7 {left frame center} \
    $topwin(util_name).info.frame10.button8 {left frame center}

  # build widget $topwin(util_name).info.frame11
  frame $topwin(util_name).info.frame11 \
    -background "$GuiColor(frame_bg)" \
    -borderwidth {2}

  # build widget $topwin(util_name).info.frame11.label6
  label $topwin(util_name).info.frame11.label6 \
    -background "$GuiColor(label_bg)" \
    -text {Method:}

  # build widget $topwin(util_name).info.frame11.entry7
  entry $topwin(util_name).info.frame11.entry7 \
    -background "$GuiColor(rentry_bg)" \
	 -foreground "$GuiColor(rentry_fg)" \
    -relief {sunken} \
    -state {disabled} \
    -textvariable {util(quant_meth)} \
    -width {9}

  # build widget $topwin(util_name).info.frame11.button8
	menubutton $topwin(util_name).info.frame11.button8 -padx {1} -pady {1} -highlightthickness {0}  \
    -background "$GuiColor(btn_bg)" \
	 -activebackground "$GuiColor(btn_act_bg)" \
	 -relief {raised} \
    -font "$GuiMisc(pop_up_fn)" \
	 -text "$GuiMisc(pop_up_text)" \
	 -relief "$GuiMisc(pop_up_relief)" \
	 -width {2}
  # bindings
  bind $topwin(util_name).info.frame11.button8 <Button-1> {MenuPopupPost $topwin(util_name).info.frame11.button8.menu %X %Y}
  bind $topwin(util_name).info.frame11.button8 <ButtonRelease-1> {MenuPopupRelease $topwin(util_name).info.frame11.button8.menu %W}

  # build widget $topwin(util_name).info.frame11.button8.menu
  menu $topwin(util_name).info.frame11.button8.menu \
    -activebackground "$GuiColor(menu_act_bg)" \
	 -background "$GuiColor(menu_bg)"
  $topwin(util_name).info.frame11.button8.menu add command \
    -command {set util(quant_meth) average
set util(quant_method) 1} \
    -label {average value}
  $topwin(util_name).info.frame11.button8.menu add command \
    -command {set util(quant_meth) median
set util(quant_method) 2} \
    -label {median value}
  $topwin(util_name).info.frame11.button8.menu add command \
    -command {set util(quant_meth) decimation
set util(quant_method) 3} \
    -label {decimation}
  bindtags $topwin(util_name).info.frame11.button8.menu {Menu all}
  # bindings
  bind $topwin(util_name).info.frame11.button8.menu <B1-Motion> {MenuPopupMotion $topwin(util_name).info.frame11.button8.menu %W %X %Y}
  bind $topwin(util_name).info.frame11.button8.menu <ButtonRelease-1> {MenuPopupRelease $topwin(util_name).info.frame11.button8.menu %W}

  # pack widget $topwin(util_name).info.frame11
  pack append $topwin(util_name).info.frame11 \
    $topwin(util_name).info.frame11.label6 {left frame center} \
    $topwin(util_name).info.frame11.entry7 {left frame center} \
    $topwin(util_name).info.frame11.button8 {left frame center}

  # pack widget $topwin(util_name).info
  pack append $topwin(util_name).info \
    $topwin(util_name).info.frame9 {left frame e padx 20} \
    $topwin(util_name).info.frame10 {left frame center} \
    $topwin(util_name).info.frame11 {left frame center}

  # build widget $topwin(util_name).current_image
  frame $topwin(util_name).current_image \
    -background "$GuiColor(frame_bg)" \
    -borderwidth {2} \
    -relief {ridge}

  # build widget $topwin(util_name).current_image.current
  label $topwin(util_name).current_image.current \
    -background "$GuiColor(label_bg)" \
    -text {Current image:}

  # build widget $topwin(util_name).current_image.name
  label $topwin(util_name).current_image.name \
    -background "$GuiColor(rlabel_bg)" \
    -foreground "$GuiColor(rlabel_bg)" \
    -text {} \
    -textvariable {current_image}

  # pack widget $topwin(util_name).current_image
  pack append $topwin(util_name).current_image \
    $topwin(util_name).current_image.current {left frame center} \
    $topwin(util_name).current_image.name {left frame center filly}

  # build widget $topwin(util_name).perform
  frame $topwin(util_name).perform \
    -background "$GuiColor(frame_bg)" \
    -borderwidth {2} \
    -relief {raised}

  # build widget $topwin(util_name).perform.perform1
	button $topwin(util_name).perform.perform1 -padx {1} -pady {1} -highlightthickness {0}  \
    -foreground "$GuiColor(perf_fg)" \
    -background "$GuiColor(perf_bg)" \
	 -activebackground "$GuiColor(perf_act_bg)" \
    -command {
		$topwin(util_name) configure -cursor watch; update
		if {$current_image == ""} {
			CvipAlert "Please select an image first."
			$topwin(util_name) configure -cursor top_left_arrow; update
			return
		}
		if [catch {expr $util(quant_ht) + $util(quant_wd)} ] {
			CvipAlert "Numerical values required for the width and height:\n\
			Width = $util(quant_wd), Height = $util(quant_ht)."
			$topwin(util_name) configure -cursor top_left_arrow; update
			return
		}
		if {$util(quant_ht) > $rows || $util(quant_ht) < 1} { 
			CvipAlert "The new height ($util(quant_ht)) must be in the range \[1, $rows\]."
			$topwin(util_name) configure -cursor top_left_arrow; update
			return
		}
		if {$util(quant_wd) > $cols || $util(quant_wd) < 1} { 
			CvipAlert "The new width ($util(quant_wd)) must be \[1, $cols\]."
			$topwin(util_name) configure -cursor top_left_arrow; update
			return
		}
		if [ catch {set result [cvip spatial_quant $current_image $util(quant_method) $util(quant_ht) $util(quant_wd)] } \
					cresult ] {
		   CvipAlert  "$cresult."
			$topwin(util_name) configure -cursor top_left_arrow; update
			return
		}
		$topwin(util_name) configure -cursor top_left_arrow; update
		set new_name [cvip rename $result ${current_image}_$util(quant_ht)x$util(quant_wd)]
		img_q insert end $new_name
		image_post $new_name
		cvip view $new_name
		CvipMessage "spatial quantization performed on image \"$current_image\" to $util(quant_ht) rows and \
			$util(quant_wd) columns"
		$topwin(util_name) configure -cursor top_left_arrow; update
	 } \
    -text {PERFORM}

  # build widget $topwin(util_name).perform.dismiss
	button $topwin(util_name).perform.dismiss -padx {1} -pady {1} -highlightthickness {0}  \
    -foreground "$GuiColor(dis_fg)" \
    -background "$GuiColor(dis_bg)" \
	 -activebackground "$GuiColor(dis_act_bg)" \
    -command {destroy $topwin(util_name); set topwin(util_name) NONE} \
    -text {DISMISS} \
    -width {10}

  # pack widget $topwin(util_name).perform
  pack append $topwin(util_name).perform \
    $topwin(util_name).perform.dismiss {left frame sw filly} \
    $topwin(util_name).perform.perform1 {right frame se filly}

  # pack widget $topwin(util_name)
  pack append $topwin(util_name) \
    $topwin(util_name).info {top frame center expand fill} \
    $topwin(util_name).perform {bottom frame center pady 5 fill} \
    $topwin(util_name).current_image {bottom frame center fill}
}
