/***************************************************************************
* **********************************************************************
* Computer Vision/Image Processing Tool Project - Dr. Scott Umbaugh SIUE
* **********************************************************************
*
*             File Name: picture.c
*           Description: 
*         Related Files: 
*   Initial Coding Date: Sat Sep  7 16:46:37 CDT 1996
*           Portability: Standard (ANSI) C
*            References:
*             Author(s): Kun Luo and Yansheng Wei
*                        Southern Illinois University @ Edwardsville
*
** Copyright (C) 1996 SIUE - by Scott Umbaugh, Kun Luo  and Yansheng Wei.
**
** Permission to use, copy, modify, and distribute this software and its
** documentation for any purpose and without fee is hereby granted, provided
** that the above copyright notice appear in all copies and that both that
** copyright notice and this permission notice appear in supporting
** documentation.  This software is provided "as is" without express or
** implied warranty.
**
* RCS (Revision Control System) Information
* ...Added automatically by RCS 
*
** $Log: picture.c,v $
** Revision 1.15  1997/05/18 07:30:06  yawei
** *** empty log message ***
**
** Revision 1.14  1997/05/18 07:15:34  yawei
** *** empty log message ***
**
** Revision 1.13  1997/05/18 07:07:30  yawei
** print out error message for non-unix systems
**
** Revision 1.12  1997/05/09 15:59:44  yawei
** *** empty log message ***
**
** Revision 1.11  1997/05/09 15:29:27  yawei
** checked the read image status
**
** Revision 1.10  1997/04/14 23:43:30  yawei
** removed second parameter in  read_Image
**
** Revision 1.9  1997/03/08 17:06:57  yawei
** Swaped CVIP_YES and CVIP_NO
**
** Revision 1.8  1997/03/08 01:01:02  yawei
** Name Changes:
** 	BOOLEAN ==> CVIP_BOOLEAN
** 	FALSE ==> CVIP_YES
** 	TRUE ==> CVIP_NO
** 	BYTE ==> CVIP_BYTE
** 	SHORT ==> CVIP_SHORT
** 	INTEGER ==> CVIP_INTEGER
** 	FLOAT ==> CVIP_FLOAT
** 	DOUBLE ==> CVIP_DOUBLE
** 	TYPE ==> CVIP_TYPE
**
** Revision 1.7  1997/01/16 21:31:04  yawei
** Global Change:  Image_FORMAT ==> IMAGE_FORMAT
**
 * Revision 1.6  1997/01/15  17:19:11  yawei
 * Global Change:  IMAGE ==> Image
 *
 * Revision 1.5  1997/01/15  16:36:28  yawei
 * updated changes
 *
 * Revision 1.4  1996/09/07  21:48:25  yawei
 * added the header
 *
 * Revision 1.4  1996/09/07  21:48:25  yawei
 * added the header
 *
*
****************************************************************************/
#include "CVIPtools.h"
#include "CVIPtoolkit.h"
#include "CVIPconvert.h"
#include "CVIPdef.h"
#include "CVIPerror.h"
#include "CVIPimage.h"
#include "CVIPfs.h"
#include "CVIPhisto.h"
#include "CVIPmatrix.h"
#include "CVIPview.h"

Image *get_Image(char *filename, IMAGE_FORMAT* format){
   Image* cvipImage;
   *format = getFormat_CVIP(filename);
   quiet_CVIP();
   cvipImage = read_Image(filename, 0);
   return cvipImage;
}


void main(int argc, char *argv[])
{
    IMAGE_FORMAT 	format,format1;     	/* the input image format */
    Image		*cvipImage,*cvipImage1;             
    char		 *inputfile = NULL,*outputfile = NULL;
    char 		reason;		
    int		 count1, done = CVIP_NO,count2,cols,rows;
    Matrix		*outM;
    unsigned int value;
    
    if(argc == 1){
	printf("Usage:%s image_file_name",argv[0]);
	exit(1);
    }
    else{
	inputfile = argv[1];
    }

    #ifndef WIN32
    cvipImage = get_Image(inputfile,&format);
    if (!cvipImage) {
    	error_CVIP("main", "Read image failed.\n");
		exit(1);
    }
	 count1 = (int) strlen(inputfile) - 1;
	 while (count1 >= 0) {
		if (inputfile[count1] != '/') count1 --;
		else {
			count1++;
			break;
		}
	 }
	 if (count1 != -1) {
		 count2 = 0;
		 while (inputfile[count1+count2] != '\0') {
			inputfile[count2] = inputfile[count1+count2];
			count2++;
		 }
		 inputfile[count2] = '\0';
	 }
    cols =  getNoOfCols_Image(cvipImage);
    rows =  getNoOfRows_Image(cvipImage);
    display_RAMImage(cvipImage,inputfile);
    if(argc == 1)
        free(inputfile);
    delete_Image(cvipImage);
    #else
    fprintf(stderr, "%s\n%s\%s\n", argv[0],
    	" is an X11 based image viewer working on UNIX systems only,",
	" please use your own image viewer by setting setDisplay_Image().");
    #endif
    
} 
/* 
** end of the function main 
*/
  
             
