#!/bin/csh -f
# ======================================================================
# Computer Vision/Image Processing Tool Project - Dr. Scott Umbaugh SIUE
# ======================================================================
#
#             File Name: addlog.csh
#           Description: This tricky little script will extract the description
#			 part of a CVIPtools standard header and place it in an
#                        RCS file.
#   Initial Coding Date: Sun Apr 25 22:51:42 CDT 1993
#           Portability: C Shell script
#             Credit(s): Gregory Hance
#                        Southern Illinois University @ Edwardsville
#
## Copyright (C) 1993 SIUE - by Gregory Hance.
##
## Permission to use, copy, modify, and distribute this software and its
## documentation for any purpose and without fee is hereby granted, provided
## that the above copyright notice appear in all copies and that both that
## copyright notice and this permission notice appear in supporting
## documentation.  This software is provided "as is" without express or
## implied warranty.
##
# RCS (Revision Control System) Information
# ...Added automatically by RCS 
#
## $Log$
#

set prog = $0
set comment = "*"

if( $#argv != 2 ) then
	echo "usage: $prog:t -c|-s <RCS file>"
	echo "where..."
	echo "c - C style comment leads (*)"
        echo "s - Script style comment leads (#)"
	exit 1
endif

#
# loop through optional argument
#
set option = "TRUE"
while("$option" == "TRUE")
   switch("$1")
   case "-c":
      shift
   breaksw
   case "-s":
      set comment = "#"
      shift
   breaksw
   default:
      set option = FALSE
   endsw
end

if( $#argv != 1 ) then
   echo "bad argument\!"
   exit 1
endif

# initialize some shell variables
set sedscript = /tmp/$$AL
set dbegin = "File Name:"
set dend = "Related Files:"

# write out a script to be used w/ sed that will isolate
# the appropriate pattern space
cat << EOT > $sedscript
\?$dbegin?,\?$dend?{
s/$comment//;
s/$dbegin//;
s/$dend//;
s/Description://;
p
}
EOT

set noglob
# have at it... yeesh!
cat $1 | sed -n -f $sedscript | sed '$D' | sed '1D' | expand | \
tr -s '\040' '\040' | rcs -a$user -c$comment -i -t $1

# remove temporary files
rm -f $sedscript

exit 0
