#!/bin/csh -f
# **********************************************************************
# Computer Vision/Image Processing Tool Project - Dr. Scott Umbaugh SIUE
# **********************************************************************
#
#             File Name: cathlp.csh
#           Description: Generating GUI help files from nroff files
#         Related Files: 
#   Initial Coding Date: Wed Apr 23 23:58:06 CDT 1997
#           Portability: C Shell script
#            References:
#             Author(s): Yansheng Wei
#                        Southern Illinois University @ Edwardsville
#
## Copyright (C) 1997 SIUE - by Scott Umbaugh and Yansheng Wei.
##
## Permission to use, copy, modify, and distribute this software and its
## documentation for any purpose and without fee is hereby granted, provided
## that the above copyright notice appear in all copies and that both that
## copyright notice and this permission notice appear in supporting
## documentation.  This software is provided "as is" without express or
## implied warranty.
##
# RCS (Revision Control System) Information
# ...Added automatically by RCS 
#
## $Log: cathlp.csh,v $
## Revision 1.4  1997/04/25 16:31:14  yawei
## remove old formatted pages before copying the new ones
##
## Revision 1.3  1997/04/24 20:47:36  yawei
## fixed long file name problem
##
## Revision 1.2  1997/04/24 05:09:39  yawei
## added wait message
##
## Revision 1.1  1997/04/24 04:59:52  yawei
## Initial revision
##
#

#!/bin/csh -f
set orid=`pwd`
set nroffd = "nf_help"
set txtd = "tcl_help"
if ($#argv > 0) then
	echo "${0}: too many arguments on command line"
	echo "       just run ${0} in the intended directory, exit..."
	exit
endif

if (-d $nroffd && -r $nroffd && -x $nroffd) then
	if ( !(-d $txtd && -r $txtd && -x $txtd) ) then
		mkdir $txtd
	endif
	if ( !(-d /tmp/man1 && -r /tmp/man1  && -x /tmp/man1) ) then
		mkdir /tmp/man1
	endif
	echo "Generating formatted help pages, please wait...."
	cp $nroffd/*.nf /tmp/man1/
	cd /tmp
	catman -M ./
	cd /tmp/cat1
	\rm -f  $orid/$txtd/*
	foreach i (`\ls`)
		set j = "$i:r"
		echo "generating $j.hlp.."
		set k = `echo "$j" | sed 's/\(..............\).*/\1/g'`
		sed -e "/^$k/d" -e "/^SunOS/d" < $i|uniq |tail +2l > $orid/$txtd/$j.hlp
		chmod 664 $orid/$txtd/$j.hlp
	end
	cd ..
	\rm -rf cat1 man1
else
 	echo "Direcotry: $nroffd doesnot exist, exit..."
	exit
endif
#ALHHA, we are done
