#!/bin/csh -f
unset noclobber

set cvip = "$CVIPHOME"
set lcf = "$cvip/docs/Scripts/cviplinecount.txt"
set tf = "/tmp/tempfile$$"
set awkfile = "/tmp/awk1"

find $cvip \( -name '*.h' -o -name '*.c' \)  -exec wc -l {} \; \
| tr -s '\011' '\040' | cut -f2 -d" " > $tf

cat << EOF > $awkfile
BEGIN {
      total = 0
      }

      { total += \$1 }
 
END   {
      print "CVIPtools source code tally:"
      print "Total number of source code files (*.c and *.h) --", NR
      print "Total number of source lines --", total
      }
EOF

echo "saving source code tally to -- $lcf"
cat $tf | awk -f $awkfile > $lcf
cat $lcf

rm $awkfile
rm $tf


