#!/bin/sh
# **********************************************************************
# Computer Vision/Image Processing Tool Project - Dr. Scott Umbaugh SIUE
# **********************************************************************
#
#             File Name: mirror.sh
#           Description: Bourne shell script running on the cron daemon
#                        to update the files on cvip-pc everyday
#                        midnight
#         Related Files: NONE
#   Initial Coding Date: Fri Jul 25 10:30:13 CDT 1997
#           Portability: Bourne Shell scipt
#            References: NONE
#             Author(s): Yansheng Wei
#                        Southern Illinois University @ Edwardsville
#
## Copyright (C) 1996 SIUE - by Scott Umbaugh and Yansheng Wei.
##
## Permission to use, copy, modify, and distribute this software and its
## documentation for any purpose and without fee is hereby granted, provided
## that the above copyright notice appear in all copies and that both that
## copyright notice and this permission notice appear in supporting
## documentation.  This software is provided "as is" without express or
## implied warranty.
##
# RCS (Revision Control System) Information
# ...Added automatically by RCS 
#
## $Log: mirror.sh,v $
## Revision 1.8  1997/08/07 13:53:28  yawei
## added user's write permission
##
## Revision 1.7  1997/08/06 13:26:08  yawei
## added group write permission after mirror
##
## Revision 1.6  1997/08/05 15:49:45  yawei
## added README files
##
## Revision 1.5  1997/08/05 15:38:51  yawei
## modified cp -rf
##
## Revision 1.4  1997/08/05 14:59:36  yawei
## updated changes
##
## Revision 1.8  1997/08/01 22:25:04  yawei
## added force
##
## Revision 1.7  1997/08/01 22:19:27  yawei
## typo corrected
##
## Revision 1.6  1997/08/01 21:50:45  yawei
## remove *.o file for copying
##
## Revision 1.5  1997/08/01 21:43:29  yawei
## added man
##
## Revision 1.4  1997/08/01 19:31:02  yawei
## added missed files
##
## Revision 1.3  1997/07/25 17:29:00  yawei
## minor change
##
## Revision 1.2  1997/07/25 16:18:41  yawei
## filter out RCS
##
## Revision 1.1  1997/07/25 15:31:34  yawei
## Initial revision
##
#

#!/bin/sh
srcdir=/home/cvip/cvipapps/CVIPtools3.6
targetdir=/net/cvip-pc/usr/cvipapps/CVIPtools
tempfile=/tmp/filelist$$
cd $srcdir

find . -type d | sed '/RCS/d' > $tempfile
for i in `cat $tempfile`
do
      if /bin/test ! -d $targetdir/$i;
      then
         mkdir $targetdir/$i;
		fi
done
\rm -f $tempfile

find . \( -name "CVIP*" -o -name "*.[ch]" -o -name "*.tcl" \
			 -o -name "*.bmp" -o -name "*.xbm" -o -name configure \
			 -o -name "*.in" -o -name "*.sh" -o -name "*make*" \
			 -o -name "*cur" -o -name "*.rc" -o -name "*.ico" \
			 -o -name tclIndex -o -name "*[Rr][Ee][Aa][Dd][Mm][Ee]*" -o \
			 -name "*install*" -o -name "mkLinks" \) -a -type f \
		-print | sed -e '/RCS/d' -e '/\.o/d' > $tempfile
for i in `cat $tempfile`
do
      if /bin/test ! -f $targetdir/$i;
      then
         cp $i $targetdir/$i;
      elif /bin/test  $targetdir/$i -ot $i;
		then
			\rm -f $targetdir/$i; cp $i $targetdir/$i;
		fi
done
\rm -f $tempfile
cp -r $srcdir/man $targetdir
cp -r $srcdir/docs $targetdir
cp -r $srcdir/CVIPTCL/tcl7.6/doc $targetdir/CVIPTCL/tcl7.6
cp -r $srcdir/CVIPTCL/tk4.2/doc $targetdir/CVIPTCL/tk4.2
chmod -R g+w $targetdir/*
chmod -R u+w $targetdir/*

