#!/bin/csh -f
# ======================================================================
# Computer Vision/Image Processing Tool Project - Dr. Scott Umbaugh SIUE
# ======================================================================
#
#             File Name: sedsub.csh
#           Description: 
#         Related Files: 
#   Initial Coding Date: Sun Aug 29 15:33:50 CDT 1993
#           Portability: C Shell script
#            References:
#             Author(s): Gregory Hance
#                        Southern Illinois University @ Edwardsville
#
## Copyright (C) 1993 SIUE - by Gregory Hance.
##
## Permission to use, copy, modify, and distribute this software and its
## documentation for any purpose and without fee is hereby granted, provided
## that the above copyright notice appear in all copies and that both that
## copyright notice and this permission notice appear in supporting
## documentation.  This software is provided "as is" without express or
## implied warranty.
##
# RCS (Revision Control System) Information
# ...Added automatically by RCS 
#
## $Log$
#
set noclobber

if( $#argv < 2 ) then
   echo "usage: $0 <sub_list_file> <file_name>"
   exit 1
endif

if( ! -e $argv[1] ) then
   echo "error: $argv[1] does not exist -- terminating script."
   exit 1
endif

if( ! -e $argv[2] ) then
   echo "error: $argv[2] does not exist -- terminating script."
   exit 1
endif

#
# check to see if the user has a preferred temporary
# directory... and if not use the standard "/tmp"
#
if (! $?TMPDIR) set TMPDIR = /tmp

set sedscript = $TMPDIR/$$SS
set file = $argv[2]

awk '{print "s/"$1"/"$2"/g"}' $argv[1] > $sedscript

mv -f $file ${file}%

sed -f $sedscript ${file}% > $file

rm $sedscript

exit 0

