/***************************************************************************
* ======================================================================
* Computer Vision/Image Processing Tool Project - Dr. Scott Umbaugh SIUE
* ======================================================================
*
*
*
*
*             File Name: tp.c
*           Description: test program for CLI Utility functions -- libcli.a
*         Related Files: Imakefile, libband.a
*   Initial Coding Date: Sun May  2 22:49:23 CDT 1993
*           Portability: Standard (ANSI) C
*             Credit(s): Gregory Hance
*                        Southern Illinois University @ Edwardsville
*
** Copyright (C) 1993 SIUE - by Gregory Hance.
**
** Permission to use, copy, modify, and distribute this software and its
** documentation for any purpose and without fee is hereby granted, provided
** that the above copyright notice appear in all copies and that both that
** copyright notice and this permission notice appear in supporting
** documentation.  This software is provided "as is" without express or
** implied warranty.
**
* RCS (Revision Control System) Information
* ...Added automatically by RCS 
*
* $Log: tp.c,v $
* Revision 1.4  1997/03/08 17:05:47  yawei
* Swaped CVIP_YES and CVIP_NO
*
* Revision 1.3  1997/03/08 00:58:18  yawei
* Name Changes:
* 	BOOLEAN ==> CVIP_BOOLEAN
* 	FALSE ==> CVIP_NO
* 	TRUE ==> CVIP_YES
* 	BYTE ==> CVIP_BYTE
* 	SHORT ==> CVIP_SHORT
* 	INTEGER ==> CVIP_INTEGER
* 	FLOAT ==> CVIP_FLOAT
* 	DOUBLE ==> CVIP_DOUBLE
* 	TYPE ==> CVIP_TYPE
*
* Revision 1.2  1997/01/16 21:23:00  yawei
* updated changes
*
 * Revision 1.1  1993/05/03  22:37:21  hanceg
 * Initial revision
 *
*
*
****************************************************************************/

 
/* Define Preprocessor statements */
#include <stdio.h>
#include <string.h>
#include "CVIPimage.h"
#include "CVIPerror.h"
#include "CVIPget.h"

main(argc,argv)
int argc;
char *argv[];
{
/* Declare variables local to main() */
const char *usage = "<do this> [and maybe this]";
const char *fn = argv[0], *merilee = "Babe";
char *str, file_r[80], file_w[80], text[80], buf[80], name[80];
float fvalue, val2, val4;
int ivalue, argn =1, val1, val3;
unsigned int uivalue;
CVIP_BOOLEAN display=CVIP_NO, read = CVIP_NO, write = CVIP_NO, environment=CVIP_NO;
FILE *file_rP, *file_wP;

init_CVIP( &argc, argv);


/* process command line options */
while ( argn < argc && argv[argn][0] == '-' && argv[argn][1] != '\0' ) {
   if ( keyMatch_CVIP( argv[argn], "-display", 2 ) )
      display = CVIP_YES;
   else if( cvip_keymatch( argv[argn], "-read", 2 ) ) {
      ++argn;
      read = CVIP_YES;
      if ( argn == argc || sscanf( argv[argn], "%s", file_r ) != 1 )
         usage_CVIP( fn, usage );
   }
   else if( cvip_keymatch( argv[argn], "-environment", 2 ) ) {
      ++argn;
      environment = CVIP_YES;
      if ( argn == argc || sscanf( argv[argn], "%s", name ) != 1 )
         usage_CVIP( fn, usage );
   }
   else if( cvip_keymatch( argv[argn], "-write", 2 ) ) {
      ++argn;
      write = CVIP_YES;
      if ( argn == argc || sscanf( argv[argn], "%s", file_w ) != 1 )
         usage_CVIP( fn, usage );
   }
   else
      usage_CVIP( fn, usage );
   argn++;
}

if(environment) {
	str =  getEnv_CVIP(name);
	printf("str = %s.\n", str);
	exit(0);
}


if(read) {
	file_rP = openRead_CVIP(file_r);
	file_wP = openWrite_CVIP(file_w, CVIP_YES);
	fSkipLines_CVIP(file_rP, 2);
	fGetString_CVIP(file_rP, text, 2, ":");
	val1 = fGetInt_CVIP(file_rP, &ivalue, 2, ":");
	val2 = fGetFloat_CVIP(file_rP, &ivalue, 2, ":");
	val3 = fGetInt_CVIP(file_rP, &ivalue, 2, ":");
	val4 = fGetFloat_CVIP(file_rP, &ivalue, 2, ":");
	fprintf(file_wP, "string = %s\n", text);
	fprintf(file_wP, "val1 = %d\n", val1);
	fprintf(file_wP, "val2 = %.6f\n", val2);
	fprintf(file_wP, "val3 = %d\n", val3);
	fprintf(file_wP, "val4 = %.6f\n", val4);
	close_CVIP(file_rP);
	close_CVIP(file_wP);
	exit(0);
}

msg_CVIP(fn, "what's up! Merilee is a %s.\n", merilee);
error_CVIP(fn, "ooops! an error has occured %s.!\n", merilee);

msg_CVIP(fn, "Enter a string: ");
str = getString_CVIP();
msg_CVIP(fn, "String = %s.\n", str);
msg_CVIP(fn, "[Press ENTER to continue]");
getchar();
msg_CVIP(fn, "Enter an integer number: ");
ivalue = getInt_CVIP(10, 0, 255);
msg_CVIP(fn, "Integer value is = %ld.\n", ivalue);
msg_CVIP(fn, "[Press ENTER to continue]");
getchar();
msg_CVIP(fn, "Enter an unsigned integer number: ");
uivalue = getUInt_CVIP(10, 0, 255);
msg_CVIP(fn, "Unsigned integer value is = %u.\n", uivalue);
msg_CVIP(fn, "[Press ENTER to continue]");
getchar();
msg_CVIP(fn, "Enter a floating pt. number: ");
fvalue = (float) getFloat_CVIP(-125.0, 125.0);
msg_CVIP(fn, " value is = %f.\n", fvalue);
msg_CVIP(fn, "[Press ENTER to continue]");
getchar();


usage_CVIP(fn, usage);
} /* End Main */

     
         





   
      
