.TH cvip_ana_edgeline
.SH wm geometry .help $help_long    
.SH help_message delete 1.0 end
.SH help_message insert 1.0  {
.SH Analysis: Edge/Line Detection

.SS FOR ALL FUNCTIONS:
After setting the desired parameters, press the 'PERFORM' 
button at lower right to perform the operation. Currently, these functions
return an image which contains the magnitude information only.

The use of a 'Pre-filter' will cause the current image
to be processed with the chosen filter before edge
detection takes place. This is typically some form of
a smoothing filter that is used to smear out high-frequency
noise, thereby helping to eliminate false edges caused by 
noise.

The use of a 'Post-threshold' value will cause the image
that results from the edge detector to have binary 
thresholding performed on it. If you use the default 'none', 
you can manually apply thresholding to the
resultant image with the Threshold button at the bottom
of the window or from the 'UTILITIES -> Convert' window.

Note that the output image from an edge detection operator
is of SHORT data type, so may exceed the 0-255 BYTE range.
If you use the histogram to select a threshold value, be
aware that the histogram is linearly remapped to BYTE for
display. When using the CVIPtools image viewer the actual data 
range of the image is shown in the information window that 
appears when you click the middle mouse button on the image itself.
Alternately, the image data range can be found by 
using the 'UTILTIES->Misc->Image data range' selection. 
A good method for threshold selection is to start with the midpoint of this 
range, and then decrease it until desired results are obtained.

.SS Kirsch, Pyramid, Robinson:
Select a Pre-filter, if desired, from the pop-up
menu. Select or enter a Post-threshold value, if
desired. The Kirsch and Robinson use 8 masks and will provide similar 
results, since
the Robinson uses a simplified version of the Kirsch masks. As a result 
of the specific mask coefficients, the Robinson returns an image with a 
smaller data range. 
The Pyramid operator uses 2 masks and will return wider edges, since 
this implementation is based on 7x7 masks, and the Kirsch and Robinson 
are based on 3x3 masks.

.SS Sobel, Prewitt:
Enter or select from the pop-up menu a kernel size; in general the
larger the kernel size, the wider the resulting edges. That is, the edges
appear more smeared out in the resulting image.
Select a Pre-filter, if desired, from the pop-up
menu. Select or enter a Post-threshold value, if
desired. Finally, choose whether or not to keep dc. If 
the 'keep dc' option is selected, the output image will 
retain more of the original image, not just the edges. 

.SS Roberts, Laplacian:
Select which type/mask to use, select the 'Show Types/Masks' button to 
see them.
Select a Pre-filter, if desired, from the pop-up
menu. Select or enter a Post-threshold value, if
desired. Finally, choose whether or not to keep dc.
If the 'keep dc' option is selected, the output image will 
retain more of the original image, not just the edges. Note that the 
Roberts Type 2 is probably the fastest edge detector. 
The Laplacian, unlike the others, retains the sign of the result
with the output image (the sign corresponds to the "direction" of the edge).

.SS Frei-Chen:
First select the Frei-Chen subspace desired: line, edge, max, or min angle.
The line and edge subspace selections use the corresponding four line or edge
masks as the subspace of interest.
The max selection will select the maximum of the edge or line subspace 
projections. The 'min angle' returns the result from the edge and line
projection that has the minimum angle between that particular 
vector (corresponding to the current pixel) and these two subspaces.
The minimum angle corresponds to the closest fit, without consideration 
of magnitude.
.TP 4
edge subspace:
If you want to set a threshold on the edge
projection, select 'Threshold angle:yes',
then enter or select a value in radians.
   
If you don't want to set a threshold on the
edge projection, select 'Threshold angle:no'

.TP 4
line subspace:
If you want to set a threshold on the line
projection, select 'Threshold angle:yes',
then enter or select a value in radians.

If you don't want to set a threshold on the
line projection, select 'Threshold angle:no'

.TP 4
max\[edge,line\] or min angle\[edge,line\]:
Angle threshold does not apply.

After selecting the projection,  select a Pre-filter
and/or Post-threshold if desired, and choose whether
or not to keep dc.

.SS Hough:
When Hough is selected, an Alert Box appears. If you 
want to use the angles listed in the 'Line angles:'
entry box, press the 'DO NOT Clear' button. If you
want to enter new values, press 'Clear'.

The 'Line angles:' entry refers to the angle a desired
line makes with the positive horizontal axis in the 
current image, in a clockwise direction. For example,
to find a line that runs from the upper-left to the
lower-right corner, enter {45} as the line angle.
To find a line that runs from the lower-left to the
upper-right, enter {135} as the line angle.

Enter line angles with curly braces before the first
and after the last value. You may specify ranges of
angles with a dash, such as {45-55}, and you must
use a blank space as a separator, as in {0 45-50 90}.

After entering the line angles, select or enter both 
the minimum number of pixels that define a line and the
maximum connect distance. Note that the "number of  pixels per line" 
applies to all pixels on a given line, so they are not 
necessarily connected. 
Also, the connect distance applies
to all lines, so this will tend to fill in open places if too
large a number is selected (see 'Edge link' below).

Note: the Hough transform is typically applied to an
image after edge detection and thresholding have been
performed.

.SS Edge link: 
Select or enter the maximum connect distance, this corresponds to
the maximum "open" area between points that will be filled in.
Edge linking is normally 
performed on an image after edge detection AND thresholding has been
performed. Note that this edge linker tends to fill in small open areas,
this is due to the fact that it considers ALL lines, not just the ones you 
think appear in the image.

.SH }
      
