.TH cvip_ana_geometry
.SH wm geometry .help $help_long    
.SH help_message delete 1.0 end
.SH help_message insert 1.0  {
.SH Analysis: Geometry

.SS FOR ALL FUNCTIONS:
After setting the desired parameters, press the 'PERFORM' 
button at lower right to perform the operation.

For all of the following functions, the current image 
is automatically selected, and can be changed by clicking 
mouse button 1 on an image in the main window's image 
queue. 

.SS Crop:
The crop function allows you cut a subimage out of the current image
and put it in the IMAGE QUEUE. This may be done to select a
region of interest (ROI), or to paste a part of one image into another
with the following 'Paste' function.

To crop an image, the size and upper left coordinates of the subimage can
be entered directly in the entry boxes.

Alternately, with the CVIPtools image viewer, you can select the crop 
area by dragging with mouse 
button 1 on the current image. If you don't like 
the size of the rectangle, you can erase it by 
clicking outside the rectangle. You can move the 
rectangle by pointing within its borders, and 
sliding the rectangle while holding down button 1.
Note that, although the coordinates are used 
automatically when you press 'PERFORM', they will not
appear in the window until AFTER the 'PERFORM' button
has been pressed. 

Once the parameters are set as desired, press 'PERFORM' in the lower right
corner.

.SS Paste:
This function allows you to paste an image, or subimage, onto another image. 
The standard method will replace the underlying pixel values in the 
original image with the pasted image. Alternately, this can be done 
transparently, which adds the two together so that the 
original image is still visible under the pasted image. 

To select an image to be 
pasted into the current image you can type the name in
the entry box, or hold the 'control' key on the keyboard
while clicking the mouse on the name in the IMAGE QUEUE. Next, type in the
row and column coordinate of the upper left corner of location in the
current image where you desire to paste the image. Or, with the CVIPtools
image viewer, you can click the second mouse button on the upper left corner 
of the desired location. Finally, a transparent paste can be selected, if
desired.

Once the parameters are set as desired, press 'PERFORM' in the lower right 
corner. 

.SS Resize:
With the resize function you can enlarge or shrink an image.
Additionally, you can spatially distort an image by
enlarging it in one dimension and shrinking it 
in the other dimension.
The desired new dimensions in height and width are entered into the
entry boxes. 
Once the parameters are set as desired, press 'PERFORM' in the lower right 
corner. 

.SS Rotate:
This function will rotate an image and place the result
within a black rectangle large enough to contain the entire
rotated image.

To perform a rotation, enter a float or integer value for the number
of degrees of rotation.
A postive number will rotate the image clockwise, and a negative
number will rotate counterclockwise.
Once the parameters are set as desired, press 'PERFORM' in the lower right 
corner. 

Note that this function will handle complex images, for example,
an fft spectrum.
.SS Translate:
This function will shift an image left or right, and up or down. It allows
for wrapping the shifted areas onto the opposite side of the image or to
let the portions shifted out be filled with specific gray level values.

To perform a translation, select the directions and enter
the desired amounts. Then select the method of dealing
with parts of the image uncovered by the translation. 'Wrap the image...' 
will cause those parts of the image 
that move beyond an edge to reappear at the opposite 
edge; the entire image will still be present, but will 
be rearranged. 'Fill the area...' will cause areas left 
behind by moving the image to be filled with a uniform  
gray value you enter.
Once the parameters are set as desired, press 'PERFORM' in the lower right 
corner. 

.SS Zoom:
This function performs a zoom, and can also be used to enlarge an image
by zooming the entire image.
Two methods are available for the zooming: zero-order or linear interpolation.
In general, the linear interpolation method will provide more visually 
pleasing results, but will take longer to perform. The zero-order method 
will result
in blocky effects, but is faster and does not "create data" - the
linear interpolation method "creates data" via interpolation, which
is undesirable in some applications.

To zoom in on an image quadrant, choose the quadrant of the image 
to expand, then enter a
factor by which to expand the quadrant. If you want to 
zoom an area other than a fixed quadrant, first select 'the area from 
upper left corner...' button. You then 
choose the area to zoom by entering the upper left row and column
coordinates and the height and width values into the entry boxes.

Alternately, with the CVIPtools image viewer, you can
select the area to zoom by dragging with mouse button 1 
on the current image. If you don't like the size of the 
rectangle, you can erase it by clicking outside its 
borders. You can move the rectangle by pointing within
its borders, and sliding the rectangle while holding 
down button 1. Note that, although the coordinates are used
automatically when you press 'PERFORM', they will not
appear in the window until AFTER the 'PERFORM' button
has been pressed.

Next, enter the factor by which you want want to 
expand the image in the window labeled 'by'.
Next, select '0 order' or 'Linear interpolation' for the method in
the window labeled 'use'.
Once the parameters are set as desired, press 'PERFORM' in the lower right 
corner. 

.SH }
      
