.TH cvip_cmprs_lossless
.SH wm geometry .help $help_medium    
.SH help_message delete 1.0 end
.SH help_message insert 1.0  {
.SH Compression: Lossless
Lossless compression must be used when you cannot afford to lose
any of the original data. The decompressed image and the original
image will be identical. Typically, compression ratios are small (two to three 
at the most), and often less than one (no compression, the file got bigger).
The algorithms here are often used as the final step in a more complex
compression algorithm.

.SS FOR ALL FUNCTIONS:
After setting the desired parameters, press the 'PERFORM' 
button at lower right to perform the operation.

The current image is automatically selected, and can be 
changed by clicking mouse button 1 on an image in the 
main window's image queue.

After compression, you may save either the decompressed image or the
compressed data file by pressing the appropriate button.
If the compressed file is saved, it will automatically
be decompressed when loaded back into CVIPtools.
 
.SS Bit-plane RLC:
Performs run length coding on each bit plane individually.
Preprocessing with binary to gray code will improve 
compression; remember to postprocess with
gray to binary code to recover the image after 
decompression. Although you can select to retain only certain bits,
keep in mind if you do not keep them all the result is actually
lossy compression.

.SS Huffman, Ziv-Lempel:
These are both standard lossless compression methods. Typically resulting in
about 10% compression, that is a compression ratio of about 1.1.

.SS DPC:
Differential predictive coding takes advantage of the fact
that adjacent pixels in an image are highly correlated (have similar values).
Thus, we can predict the next value based on the previous value(s), and then
all we need to compress is the error signal. The error signal is the
difference between the predicted value and the actual value.
The prediction equation used is based on a weighted sum of the previous
value and the global mean for the image. The correlation coefficient provides
the weighting for the previous value, and (1 minus the correlation coefficient)
is the weight for the global mean. Values around 0.9 are typical
correlation coefficients for images.

To use, enter or select from the pop-up menu the 'Correlation,' (coefficient) 
and select from pop-up menus the scan direction and number of bits. The
scan direction determines if the prediction will be done along the horizontal
or vertical direction, and the number of bits determines how many bits
are used in the error signal encoding. For lossless compression, a shift
code is used.

.SH }
