.TH cvip_cmprs_lossy
.SH wm geometry .help $help_medium    
.SH help_message delete 1.0 end
.SH help_message insert 1.0  {
.SH Compression: Lossy
Lossy compression methods work by eliminating information in an image
that is not visually necessary. The original image cannot be EXACTLY
recovered from the compressed image, although with a good method the results
will look very much like the original. There will be a tradeoff
between the amount of compression and the resultant image quality.

.SS FOR ALL FUNCTIONS:
After setting the desired parameters, press the 'PERFORM' 
button at lower right to perform the operation.

The current image is automatically selected, and can be 
changed by clicking mouse button 1 on an image in the 
main window's image queue.

After compression, you may save either the decompressed image or the
compressed data file by pressing the appropriate button.
If the compressed file is saved, it will automatically
be decompressed when loaded back into CVIPtools. Compressed files are
saved in CVIPtools VIP format, except JPEG which has its own 
standard file format.
 
.SS BTC:
Block truncation coding works by replacing a subimage (block) with 
two gray values (two-level block truncation) 
and a bitstring to identify which pixel in each block gets which gray level.
To use, select the desired block size. In general, the larger the block size
the higher the compression ratio and the lower the image quality.

.SS Multilevel BTC, Predictive Multilevel BTC:
These both use a four-level block coding method, but the predictive algorithm
adds another level of complexity. Algorithmic details can be found in:

"Multilevel Block Truncation Coding Using a Minimax Error Criterion 
for High-Fidelity Compression of Digital Images.", Yiyan Wu and David C. Coll, IEEE TRANSACTIONS ON COMMUNICATIONS. Vol.41, No.8, AUGUST 1993

To use, enter or select from the pop-up menu the blocksize. 

.SS JPEG
JPEG stands for Joint Photographic Experts Group and is a standard
method for image compression. This code is based on the Independent 
JPEG Groups software. The 'Quality' controls the amount of 
compression as well as the quailty of the decompressed image. If 'Smooth'
is selected, this will be applied when the image is decompressed to help
mitigate the blocky effects that occur with this algorithm at low 
quality settings. If 'Grayscale' is selected with a color image, the 
resulting image will be gray, not color. The quantization table(s) can be
selected with the popup menu, and can be modified with the 'View...Table'
buttons. The default tables are the standard tables, and the 'Nonquant'
selection will result in nearly lossless compression.

Note that for JPEG compression, if you save the decompressed data 
it will be saved in VIP format - readable by CVIPtools only. This is
done so the data is not compressed again, which is what happens if you
save it in JPEG format.
If you want to save in JPEG file format, save the compressed data or
use the 'Save as' button on the main window. Note that these methods
will use the default JPEG parameters for compression.

.SS Dynamic Window-Based Run Length Coding:
To use, enter or select from the pop-up menu the window size, which
determines the gray level range considered "constant"
for the run length coding. Algorithmic details can be found in:

"A Dynamic  Window-Based Runlength Coding Algorithm Applied to 
Gray-Level Images", M. Kumaran, S.E Umbaugh, GRAPHICAL MODELS AND 
IMAGE PROCESSING, Vol. 57, No. 4, July 1995, pp. 267-282.

.SS DPC:
Differential predictive coding takes advantage of the fact 
that adjacent pixels in an image are highly correlated (have similar values).
Thus, we can predict the next value based on the previous value(s), and then
all we need to compress is the error signal. The error signal is the 
difference between the predicted value and the actual value.
The prediction equation used is based on a weighted sum of the previous
value and the global mean for the image. The correlation coefficient provides
the weighting for the previous value, and (1 minus the correlation coefficient)
is the weight for the global mean. Values around 0.9 are typical 
correlation coefficients for images.

To use, enter or select from the pop-up menu the 'Correlation' (coefficient), 
and select from the pop-up menus the scan direction and number of bits. Since
a one-dimensional predictor is used, it can be done in either  the
horizontal or vertical direction. 
The number of bits determines how many bits are used for the encoding.
Select the encoding method from the pop-up menu; 'Reconstr. with Lloyd-Max 
quantizers' needs a standard deviation to be entered or selected from
the pop-up menu. In general, the best results will be obtained with this method
by selecting the largest standard deviation possible that does not cause 
artifacts to appear in the resultant image.

.SS Zonal:
Zonal compression is transform domain based compression. After the 
transform is performed, only selected "zones" in the transform domain are
selected for compression, and the other transform coefficients are eliminated.
The retained coefficients are linearly quantized to byte-sized data 
(0-255), and the linear mapping values for each block are retained for
the decompression process.

To use, enter or select from pop-up menus 
the 'Compress ratio', 'Transform', 'Mask' (type) and 'Blocksize'. 
The compression ratio in conjunction with the mask
type are used to determine which transform coefficients are retained. With a
relatively large blocksize, the compression ratio you set will be close to what
you actually get. With a small blocksize the actual compression ratio will
be smaller than the setting, due to the overhead involved with each block.
Selection of 'DC quantize' will include
the DC term with the linear remapping to BYTE of all 
retained frequency terms; deselection of DC quantize
will retain the DC-coefficient as a FLOAT, and only 
remap the other retained frequency terms to BYTE types.	 

.SH }
