.TH cvip_enhan_sharp
.SH wm geometry .help $help_long    
.SH help_message delete 1.0 end
.SH help_message insert 1.0  {
.SH Enhancement: Sharpening
Image sharpening is done to enhance details in an image. This is done
by boosting the edge, or high frequency, information in an image.
In the spatial domain this can be done by adding the result from a highpass
spatial mask, such as an edge detector, to the original image, or by 
using special algorithms such as unsharp masking. 
In the frequency domain this is done by boosting the high frequency 
information.

.SS FOR ALL FUNCTIONS:
After setting the desired parameters, press the 'PERFORM' 
button at lower right to perform the operation.

The current image is automatically selected, and can be 
changed by clicking mouse button 1 on an image in the 
main window's image queue.


SPATIAL DOMAIN SHARPENING
	
.SS Sharpening algorithm, Highpass spatial filter:
The sharpening algorithm first performs 
a histogram shrink to the range \[10,100\], then sharpens
using the Roberts gradient method to improve edges.
Finally, the image is histogram equalized. With both of these you can 
choose to add the result to the original image or not with the 
button in the upper right corner.
	
.TP 4
For the highpass filter, the mask used is:
.SS "         0  -1   0"
.SS "        -1   4  -1"
.SS "         0  -1   0"
.SS "  "
.SS High boost:
To use, select mask size from the pop-up menu. In general, a larger mask
will result in wider-looking enhanced edges.

.TP 4
The default mask is:
.SS "        -1   -1   -1"
.SS "        -1    9   -1"
.SS "        -1   -1   -1"
.SS "  " 

Next, enter or select a center value for the mask. Normally you want the 
center value for an NxN mask to be (NxN). A higher value will retain more
of the original image, while a number less than NxN will result in a negative
of the original image. If you do not add the result to the original image the
result will often look black, but the image can be made visible with a
histogram stretch or equalization (note: a histogram equalization can be 
performed on the displayed image with the UNIX CVIPtools image viewer
by putting the cursor on the image and
pressing an 'e' on the keyboard. When done in this manner, however, the result
is not put in the image queue).

The 'Add result to the original image' button in the upper right applies to
this function as well as the ones above.

.SS Unsharp masking:
The unsharp masking algorithm used here (there are others) works by
first using a lowpass spatial filter on the image, then a histogram shrink
on this lowpassed image. This result is then subtracted from the original 
image, and then a histogram stretch is performed to improve contrast.
(Note that subtracting a lowpassed image from an original image is similar
to adding a highpassed image.)

To use, select or enter lower and upper limits for the histogram
shrink, and the percent to clip at the low and high ends for the final
histogram stretch.


FREQUENCY DOMAIN SHARPENING

The frequency domain sharpening algorithms perform highpass or highboost
filtering using Butterworth filters, and then add the result to 
the original image. This is followed by a histogram stretch 
to improve contrast.
	
.SS FFT, DCT sharpening:
To use, enter cutoff frequency for the highpass filter and select the
Butterworth filter order.

.SS High frequency emphasis:
To use, select transform type, filter order and emphasis offset
from the pop-up menus. Next enter the cutoff frequency, and select or 
deselect 'Keep DC', as desired.

.SS Homomorphic:
The homomorphic filtering process uses a highfrequency emphasis filter 
where you control both the high and low frequency gain. 
This process also includes a log mapping
before filtering and an inverse log after the filtering. The idea for the
log mapping is to decouple the lighting conditions from the reflectance
properties of the objects in the image.

To use, enter or select from pop-up menus the cutoff frequency,
and lower and higher frequency gains. If you select 'Add result to the 
original', the algorithm will do this AND will perform a histogram stretch to
improve contrast.
.SH }
