.TH cvip_feature
.SH wm geometry .help $help_long    
.SH help_message delete 1.0 end
.SH help_message insert 1.0  {
.SH Analysis: Features


The feature extraction window requires five parameters: 
the original image, a segmented image, a feature file 
name (new or existing), and the row and column coordinates
of a point on the object of interest. The user may also 
provide a class descriptor of the object.

The 'Original image' entry box will be filled in with the 
current image selection. You can change the images by
typing new image names in replacement of the existing 
names, or by using the mouse to select images from the 
Image Queue on the root window. To use the mouse to select 
an image as the original image, click mouse button 1 on 
a desired name in the main window's image queue. To choose
an image as a segmented image, press the 'Control' key on
the keyboard while clicking on an image name in the Image Queue.

You need to type in the path and name of a feature file.
If you name an existing file, you may view the file by 
pressing the 'View Feature File' button. If the file name
is new, it will be created as you run the program.

The row and column coordinates of the object of interest
can be entered manually or, with the CVIPtools image viewer
under UNIX, can be selected with the mouse.
When the mouse pointer is above an image being displayed
by CVIPtools, the center mouse button will provide the row
and column coordinates of the cursor to the program when
you release the button, although the entry boxes are not
updated until 'PERFORM' is pressed. If a choice has been 
made with the mouse on either the original or segmented image, 
those coordinates will be used by the program in calculating 
the object features. Under Windows NT/95, the coordinates should
be obtained with the viewer, but must be entered manually into the
CVIPtools window.

Select features to be extracted by clicking on individual
checkbuttons within any of the five categories. If all 
features in a category are desired, press the 'Select All'
button, which activates the selection indicator for each 
of the buttons it controls. You can deselect all features
at one one time by pressing 'Deselect All'.

The BINARY OBJECT and the RST-INVARIANT MOMENT FEATURES
operate on the binary object from the segmented image.
The HISTOGRAM and SPECTRAL FEATURES operate on the original 
image data using the segmented image to define the object. 
They operate on each band of any multi-band image separately. 
With the SPECTRAL FEATURES, a bounding box is found around 
the object before the FFT is performed.

The TEXTURE features operate on the original image data, but
perform a luminance transform on any color image, before 
extracting the features.  The features are calculated
for four orientations: 0, 45, 90 and 135 degrees; and then the average
of these four and the range are returned.
The textural features are defined in
Pattern Recognition Engineering, Nadler and Smith, Wiley, 1993, p.266.

.SS "Three of the features require additional parameters:"
BINARY OBJECT FEATURES/Projections needs values
for height and  width of a normalizing box. The
object of interest will be resized to fit against
the upper and left sides of the normalizing box
before the projections are calculated. 

TEXTURE FEATURES requires a value for pixel distance.
This is the distance that is used in calculating the 
co-occurence matrix (similar to 2nd-order or joint 
histogram, which approximates the joint probability 
distribution). This distance defines which pairs of 
pixels are used to determine the co-occurence matrix.
A larger distance will define a coarser texture, while
a smaller distance will define a finer texture. 

SPECTRAL FEATURES requires values for numbers of
rings and sectors to use. The spectral features 
use the Fourier transform.

After providing all required parameters and selecting the
features to extract, press 'PERFORM'. If the feature file
name you provide is that of an existing file, the header
information in that file will be checked to insure you 
have selected the same features for the new object as for
objects already listed in the file. If you have not made
the same selections, a warning box will pop up. Once you 
create a feature file, all additions to it must be for 
images with the same number of bands, and must have the 
same features selected. Either change your selections for
which features to extract to agree with those listed in
the file header, or enter a new name for the feature file.


.SH }

