.TH cvip_histograms
.SH wm geometry .help $help_long    
.SH help_message delete 1.0 end
.SH help_message insert 1.0  {
.SH Enhancement: Histograms
These functions modify the distribution of gray levels in an image,
thereby changing the brightness and contrast. They do this by controlling the
shape or distribution of the output image histogram.  In addition to the 
histogram modification functions, the gray level mapping functions are 
included here, since they also have the end result of modifying the histogram.

.SS FOR ALL FUNCTIONS:

After setting the desired parameters, press the 'PERFORM' 
button at lower right to perform the operation.

The current image is automatically selected, and can be 
changed by clicking mouse button 1 on an image in the 
main window's image queue.

Note that this window has a 'View histogram' button at the 
bottom center of the window.

.SS Histogram equalization:
Histogram equalization is a standard method to improve the contrast in an image.
If the original image has very poor contrast, you will see dramatic results.

To use the function:

For gray-scale images, no parameters are needed.

For color images, select the band to use as a
basis for equalization from 'on band' buttons.
Selection of 'Value' will result in the image being
transformed to the HSL colorspace, equalization 
of the brightness ('Lightness'), and inverse transform to an 
RGB image.

Note that histogram equalization can be done with the CVIPtools UNIX
image viewer by pointing at the image with the mouse
and pressing 'e' on the keyboard. However, when done in the viewer,
the equalized image is NOT put into the image queue.

.SS Histogram slide:

Sliding the histogram up will brighten the image and sliding it down will
darken the image.

To use, select slide direction, and enter or select from 
pop-up menu the amount of slide.

.SS Histogram shrink:
This will reduce the contrast in an image. It may be a useful preprocessing
step in a compression algorithm (followed by a stretch after decompression).

To use, enter or select from pop-up menus the lower and upper values.

.SS Histogram stretch:
This will improve the contrast in an image. By clipping a small percentage 
at the ends, you can avoid the possibility of a few high or low pixel 
values compromising the stretch effect.

To use, enter or select from pop-up menus the lower and 
upper values, and the percent to clip from low and high ends.

.SS Local equalization:
This performs histogram equalization on small blocks throughout the image.
This will let you see more local detail, often in areas that may appear
constant.

To use:

For gray-scale images, set the desired blocksize.

For color images, select the band to use as a
basis for equalization from 'on band' buttons,
then set the desired blocksize. A black border
will appear on the output image as a result of
the selected blocksize.
	   	
.SS Adaptive-contrast:
Enter or select from pop-up menus the local gain
factor, min, max, local mean factor, and the kernel
size. Based on the equation:
.TP4

.SS "   
.SS"              M{I(r,c)}"
.SS"output =  k1*----------- * [I(r,c) - m_l(r,c)] + k2*m_l(r,c)"
.SS"             sigma_l(r,c)"
.SS "  "  
 where M{I(r,c)} = the mean for the entire image I(r,c)
 sigma_l = the local standard deviation
 m_l = the local mean
 k1 = Local gain factor (multiplier), between 0 and 1
 k2 = Local mean factor (multiplier), between 0 and 1
 kernel size = size of local window
 min and max set limits on the gain from the local gain term

.SS Histogram specification:
You will specify the histogram modification equation 
for each band in the image separately. The equation 
can include algebraic operators (+,-,*,/,^), and any 
.TP 4
of the following functions:

 sin(arg)		sinh(arg)		imp(arg)		sqrt(arg)
 cos(arg)		cosh(arg)		floor(arg)	abs(arg)
 tan(arg)		tanh(arg)		step(arg)		ceil(arg)
 asin(arg)	exp(arg)		u(arg)		deg(arg)
 acos(arg)	ramp(arg)		rad(arg)	
 atan(arg)	r(arg)		log(arg)	

For gray-scale images, type the desired equation
into the 'red band' equation box or select an
equation from the pop-up menu to the right of the
box. The following equations are included in the
pop-up menu as examples:

 sin(0.025*x)	ramp(2.0*x+5)
 x+25		exp(0.025*x)
 x*2.0		log(0.5*x+2)

For example, to specify a tangent, enter: tan(100*x);
to use sqrt, you may enter: sqrt(x+10).

For color images, type equations for each band or
select equations from pop-up menus.

Each 'Clear Function' button will clear the box
to its left.

.SS Linear modify:
Enter integers for the starting and ending gray
values to change, and a new initial gray level.
Then enter a number for the slope of the line
to be used to modify the gray levels within the 
specified range. The slope may be positive, 
negative, or zero. A zero slope will cause all 
values in the given range to be mapped to the
'Initial value' gray level. Finally, you may either
retain values outside the specified range or set
them to zero.

This function can be used in conjunction with 
UTILITIES->Create->Extract bands and UTILITIES->
Create->Assemble bands to customize a gray level 
mapping pseudocolor image.

.SS Gray level multiplication:
Select 'With' or 'Without' BYTE clipping, then 
enter the multiplication factor or select it from
the pop-up menu. If you choose 'With', the image 
is first remapped to BYTE, then is multiplied by 
the factor and truncated to BYTE. If you choose 
'Without' BYTE clipping, data is converted to float,
multiplied by the factor, and a float image is put 
into the image queue. The returned image is remapped
to BYTE for display only.

Note that another multiplication option is available
with UTILITIES->Arith/Logic->Multiply. There you can multiply two images.
.SH }
