.TH cvip_start
.SH wm geometry .help $help_long
.SH help_message delete 1.0 end
.SH help_message insert 1.0  {
.SH Getting Started

Welcome to CVIPtools. This program allows you apply various computer imaging 
techniques to digital images, and compare results from different algorithms.

To start, you must first load an image. The 'Load image' button is located
in the lower left of the main window.
Two methods are available for loading images: 

1) Press the 'Load image' button, then select an
image from the File Select Box that appears.

2) Type the image name into the box to the right 
of the 'Load image' button, then press Enter (Return) 
on your keyboard. With this method CVIPtools will
automatically search the image path(s), as defined by your
environment variable CVIP_IMGPATH, for the image file.

After loading an image, the image will be displayed and its name
will appear in the image queue (see below) in the center of the main window.

Next, click the mouse on one of the selections across the top
of the main window: Analysis, Restoration, Enhancement, Compression, or 
Utilties, and the corresponding selection bar will appear. 
Select the category of operations desired from the selection bar and it 
will expand into a window that contains all the functions for that category. 
In general, a specific function is selected by the radiobuttons on the 
left of the window, and the 'PERFORM' button in the lower right will 
perform the operation.
The 'DISMISS' button in the lower left will remove the window from the
screen.

See the help pages on the individual functions to learn about them.

.SS The Image Queue
The image queue, displayed in the center of the main window, is the place
to select images for processing. This is done by clicking on the name in the
queue with the left mouse button. When this is done, you will see its
name displayed as the current image selection in the message area at the 
lower central part of the main window. 
If another window is open, the image name will also be displayed
as the current image selection in the lower left part of that window. Note
that the image queue is RAM-based and contains the images in the form of
CVIPtools image structures, which will be remapped for display purposes,
if needed. 

.SS Function Parameter Entry

All CVIPtools functions have default parameter values that will provide
reasonable and useful results. Additionally, the pop-up menus have lists
of values that are typical and/or useful for most parameters. 
If you are unfamiliar with a function, 
try the default values first. If you don't get what you want
then try the pop-up selections. However, do not feel limited to these
values - most parameters allow entry of any value you like and will
not allow entry of values that will bomb the program. Also, in computer
imaging applications, the results you get are image and application
dependent, so our list of typical values may not work for your
particular application. In some cases you may want to get "nonstandard"
results. So, live dangerously, explore, enter your own values.

There are many methods used for data entry:

- An entry box with an arrow button to its right allows you to click 
on the arrow with the mouse and drag the mouse over the desired value on
the list. The selected value will appear in the entry box when you 
release the mouse button.
 
- An entry box with black characters allows you to enter values
directly from the keyboard.

- An entry box with blue characters has a fixed set of values to 
choose from. You must select a value from the list provided when 
you use the arrow button.

- With functions that need two images, the second image name can be typed
directly into the entry box, or you can hold down the Control key on 
the keyboard and click the mouse on the name in the image queue. 
For examples see arithmetic operations under Utilities->Arith/Logic.

- In some cases the image name can be entered by selecting the image in the
queue and then clicking the button next to the entry box. For example, see
Restoration->Frequency Filters/Wiener, the 'Noise image' and 'Original
image' entry boxes.

- Up/down scroller arrows change the value in an entry box by one 
unit with a single mouse click, or the value scrolls rapidly if 
the up or down arrow is held in. For example, see Analysis->Transforms, the
Notch filter, 'Row', 'Column' and 'Size' entry boxes.

See specific help pages for the functions you want to use
for help with required parameters.

.SS CVIPtools Preferences
When you click the mouse on the 'File' selection in the upper left,
one of the selections is 'Preferences'. The Preferences window contains
various choices for run-time setup. For example, you can select the
image viewer and default positions for new windows. Another selection 
under 'File' allows you to add a temporary image path. 
Any paths that you add will be added to the image search path. 
This search path is used to automatically find images without the need 
to type in the path name. 
Note that these paths are valid only with the current session of CVIPtools.
If you want to permanently add an image search path, you will need to 
modify the environment variable CVIP_IMGPATH.

For more information on 'Preferences', see the Help page under
File->Preferences.

.SS Quitting CVIPtools

In the main window, select File->Exit. This will bring up an Alert box,
which will ask you if you really want to exit. If you select 'yes', be
aware that all images in the queue that have not been written to disk will
be lost. Note: images are written to disk with a Save or Save as operation.

.SH }
