.TH cvip_transform
.SH wm geometry .help $help_long    
.SH help_message delete 1.0 end
.SH help_message insert 1.0  {
.SH Analysis: Transforms

.SS FOR ALL FUNCTIONS:
After setting the desired parameters, press the 'PERFORM' 
button at lower right to perform the operation.

The current image is automatically selected, and can be 
changed by clicking mouse button 1 on an image in the 
main window's image queue.

Note that using any of the filters requires a transform to be performed first.
Then select the transform image in the queue for filtering.
The inverse transform will be performed automatically.

.SS DCT, FFT, HAAR, WALSH, HADAMARD:
Select Forward or Inverse for the direction of the
transform. For a forward transform, select the blocksize
from the menu. All of the transform algorithms used in
CVIPtools are fast algorithms, which require power-of-2
blocksizes. Any image that has non-power-of-2 dimensions
will be padded with zeros as required.

The inverse transform will only succeed on an image
that previously had a forward transform performed upon
it. The blocksize used during the forward transform is
automatically found and used for the inverse operation.

Note that Walsh and Hadamard use the same transform 
kernels, or basis images, but with different ordering.
The Walsh is sequency-ordered;  Hadamard uses natural
ordering. Thus, any filtering performed on a Hadamard
spectrum will yield interesting, but probably not
useful, results.
	

.SS WAVELET:
Select Forward or Inverse for the direction of the
transform. For the forward transform, select the Basis
functions to use and the number of decompositions to
perform. One decompostion will yield a 4-band result,
two will yield a 7-band result, according to:

	# of bands in result = \{3*(# of decompositions) + 1\}

The inverse transform will only succeed on an image
that previously had the forward transform performed 
upon it. The number of decompositions used during the forward 
transform is automatically used for the inverse 
operation.

.SS FILTERS
The following functions are transform-domain filters which
operate on a frequency, sequency or wavelet images (transform output). 
When used, the resulting filtered spectrum is displayed, and the 
inverse transform is performed on the filtered spectrum to 
display the resultant image. Note that the filters assume DCT-type
symmetry on wavelet transform images; this may not yield the expected results.

.SS Low pass, High pass:
Lowpass filtering will tend to blur an image, and highpass filtering will
tend to extract details and edges.
Enter a cutoff frequency for the filter, from 1 to
(blocksize - 1). You will keep the dc component
during filtering if the square on the left side of 
the 'Keep DC' button is dark; you will discard dc
if the square is light. You toggle between the two
choices by pressing the 'Keep DC' button with a
mouse click. Finally, select a filter type. If your 
choice is Butterworth, select a filter order from 
the menu.

.SS Band pass, Band reject:
These filters will have varying results based on the selection of the
cutoff frequencies. To use them, enter low and high cutoff frequencies
for the filter, from 1 to (blocksize - 1). The value for high cutoff
must be larger than the low cutoff frequency. You will
keep the dc component during filtering if the square
on the left side of the 'Keep DC' button is dark;
you will discard dc if the square is light. You toggle
between the two choices by pressing the 'Keep DC'
button with a mouse click.
Finally, select a filter type. If your choice is
Butterworth, select a filter order from the menu.

.SS High frequency emphasis:
This filter is used to enhance image details by boosting high frequency
information. The 'Cutoff Frequency' is the cutoff for the highpass filter
and the 'Emphasis offset' determines the amount of the original
image that is retained by setting the gain for the low frequencies in the
cutoff region.
To use, enter a cutoff frequency for the filter, from 1 to
(blocksize - 1).  You will keep the dc component
during filtering if the square on the left side of 
the 'Keep DC' button is dark; you will discard dc
if the square is light. You toggle between the two
choices by pressing the 'Keep DC' button with a
mouse click. 
Enter an emphasis offset value or select one from 
the menu. Finally, select a filter order from the menu.

.SS Notch:
Notch is a function to perform selective filtering on
a user-defined area of an image or spectrum. It is
often applied to frequency domain (FFT) images to eliminate
regular sinusoidal interference.

This filter cuts out a square with side length entered
as the notch 'Size:', centered at coordinates listed as 'Row:' 
and 'Column:'.

.SS "Enter the row and column coordinates and size for the filter by one of five ways:"

1) Use the mouse to draw a box. The GUI will use the shortest side of the
box for the 'Size' parameter, and the center for the (r,c) coordinate.

2) Use the middle mouse button to select (r,c), then set the 'Size'.

3) Backspace over the existing value and enter a new value from the keyboard.

4) Use the up/down arrows to select a value.

5) Select a value from the pop-up menu.

Note that the entry boxes in the GUI will not be updated with the coordinates 
until PERFORM is pressed.

For notching multiple spectral areas, use the notch
filter in RESTORATION->Frequency filters. 

.SS Extract Phase:
Select a complex image, such as an FFT spectral image. This button will
set the magnitude equal to a constant, retaining the phase information, and
then perform the inverse FFT transform. This allows you to see the information
contained in phase-only. Note that this can also be performed in the main 
window with the 'View spectrum->FFT Phase' selection.
.SH }
