.TH cvip_utilcreate
.SH wm geometry .help $help_long    
.SH help_message delete 1.0 end
.SH help_message insert 1.0  {
.SH Utilities: Create
These utilities allow you to create simple images: geometric shapes and
sinusoids. They also allow you to add noise to an image, or to create
a noise only image. With the 'Extract band' and 'Assemble bands' functions
you can put together color images from single band images.

When used in conjunction with the arithmetic/logic operations images
can be created that are useful for many experimental applications. Note that
an image with a point in it can be created by creating a circle 
with radius of zero - this is useful for generating point spread 
function (PSF) images when used with the 'Filter' options (to convolve
the point with a specific filter mask).
      
.SS FOR ALL FUNCTIONS:
After setting the desired parameters, press the 'PERFORM' 
button at lower right to perform the operation.

.SS Checkerboard:
All of the numeric parameters can be selected from the 
pop-up menus, or you enter them directly from your keyboard. 

The image height and width are the overall image 
dimensions. The starting row and column define the 
upper-left corner of a white cell. You can use the default new image name 
or enter one from your keyboard.

.SS Circle:
Creates a white circle on a black background.

All of the numeric parameters can be selected from the 
pop-up menus, or you can type in new values. 

The image height and width are the overall image 
dimensions. Select the center and radius of the circle.
Note that a radius of zero actually creates an image 
with a single point in it.

.SS Line:
Creates a white one-pixel wide line on a black background (if
you want a wider line use 'Create->Rectangle').

All of the numeric parameters can be selected from the
pop-up menus, or you enter them directly from your keyboard. 
 
The image height and width are the overall image 
dimensions. Select the starting and ending coordinates
for the line. 

.SS Rectangle:
Creates a white rectangle on a black background.

All of the numeric parameters can be selected from the
pop-up menus, or you enter them directly from your keyboard. 
 
The image height and width are the overall image 
dimensions. The starting coordinates are the upper-
left corner of the rectangle; the 'To' coordinates
define the height (To Row:) and width (To Col:) of
the rectangle. 

.SS Cosine, Sine and Square wave:
Creates a BYTE image of the selected function.

The image height, width, frequency, and direction can be selected.

.SS Extract band:
Creates a grayscale image from one band of a multi-band image.

To use, select the band to extract with mouse button 1.

.SS Assemble bands:
Creates a multi-band image from three grayscale images
of the same size.

To select the source image for a color band, first 
click on the desired image in the main window's
image queue, then press the 'Select highlighted image'
button to the right of the source image entry box.
You must provide a source image for each band, as
well as a name for the assembled image.

.SS Black image:
Enter or select from pop-up menus the image height
and width. You may accept the default image name or type in a new name.

.SS Add noise:

You may choose to add the noise to the current image
or you can create a noise-only image ('Use black image') 
by pressing the appropriate button above 'DISMISS'.
If you use a black image, enter or select from pop-up
menus the height and width of the black image to be
created. To see what the noise distribution looks like,
view the histogram of the noise added to a black image.

The output images are always of FLOAT data type, but can be 
converted to any data type with the 'Utilities->Convert->Data type' option.
.TP4
Negative exponential, Rayleigh:
Select or enter a variance value. Typical variance is from 100 to 400.

.TP4 
Gaussian, Uniform:
Select or enter a variance value. Typical variance is 100 to 400. 
Select or enter a mean value. Mean values less than 
zero will darken the resultant image; those greater 
than zero will brighten the result.
.TP4
Gamma:
Select or enter a variance value. Typical variance is 100 to 400.
Select or enter a value for alpha. Values over 1.3 can be very slow to process.
.TP4
Salt and Pepper:
Select or enter desired values for the probability
of pepper (black spots) and salt (white spots) in
the image. The probabilities must sum to 1.0 or less.
For BYTE images this function uses 0 and 255 for pepper and salt.
For images of non-BYTE data types, the function uses the minimum and maximum
values in the image for the values of pepper and salt.


.SH }
