.TH cvip_utilconvert
.SH wm geometry .help $help_long    
.SH help_message delete 1.0 end
.SH help_message insert 1.0  {
.SH Utilities: Convert
This selection contains common functions that will convert one type of
image into another. It includes conversions between binary, gray and color
images; data type conversion; color space conversion; gray code conversion; 
bit reduction (gray level quantization); and a labeling function. 
      
.SS FOR ALL FUNCTIONS:
After setting the desired parameters, press the 'PERFORM' 
button at lower right to perform the operation.

The current image is automatically selected, and can be 
changed by clicking mouse button 1 on an image in the 
main window's image queue. These functions all operate on a single
image and output a single image.

.SS Binary threshold:
To use, set the desired threshold in the entry box. You have the choice
of thresholding 'in BYTE' or 'on original data'. If you select 'in BYTE',
the value entered is mapped to the same relative point in input image
data range.
For example, if you choose 255, the original image will
be thresholded at the maximum value in the image; if you choose 128 the
image will be thresholded at (MAX-MIN)/2.
This is useful when viewing a histogram, which always appears with 
a 0-255 scale for the column coordinates.

.SS Color space:
Requires a color image. To use, select the new color space
from the pop-up menu. Direction (forward), normalization, and 
remapping of values (off) are the defaults. The defaults can be changed by 
clicking mouse button 1 on the button.

The normalize button will modify image data so the 
maximum value equals one. The remap button determines
what image is placed into the image queue. If remap
is selected, the image remapped to BYTE (as displayed)
is put in the queue; otherwise, the FLOAT output data is used.
In general, to avoid information loss or if an
inverse transform is desired later, be sure remap is off.
Note that the Chromaticity (XYZ) inverse is not defined.

.SS Gray Level Quantization:
To use, enter or select from pop-up menu the number of gray
levels, which must be a power of 2. Select Standard 
or IGS quantization. IGS minimizes false contouring 
that can occur in areas that appear to be uniform.

.SS Gray code-Natural binary:
To use, select natural binary to gray code or gray to natural
binary code. Often used as a preprocessing for run-length coding.

.SS Gray to color:
This is a commonly used subset of what is available 
under 'Enhancement->Pseudocolor'.
To use, select the desired method of conversion.

.TP 4
For Frequency domain mapping:
Pseudocolor conversion is performed by transforming
an image into the frequency domain with an FFT, then
assigning colors to bands defined by your inputs, and
finally performing an inverse FFT.

To use, select the low and high cutoff frequencies; high
must be greater than low, and high should be less
than the smaller of the image's number of rows or
columns. Next, select the colors for each of the 
three bands created by your selection of frequencies.
Each color must be used once; no two bands can have
the same color.

.TP 4
For Gray level mapping:
To use, select a shape for each band from its pop-up menu.
Note: more extensive gray to color options can be 
found in 'Enhancement->Pseudocolor'.

.SS Color to gray:
To use, select the desired method with mouse button 1. The 
luminance is a linear RGB transform based on the
human visual system's response; average is the simple mean of
the R, G, and B values.

.SS Data type:
This will allow you to convert one data type to another. It
handles: FLOAT, INTEGER, SHORT, and BYTE.
It comes in handy if a certain function insists on a specific data type.
To use, select the desired data type with mouse button 1. When
changing from a higher to a lower data type, the data
is linearly remapped to fit into the range of the new data type.	   

.SS Label image:
This function will label an input image by assigning connected components
the same gray level.
.SH }
