/***************************************************************************
* ======================================================================
* Computer Vision/Image Processing Tool Project - Dr. Scott Umbaugh SIUE
* ======================================================================
*
*             File Name: tbu.c
*           Description: test program for Data Mapping functions -- 
*		         libmap.a
*         Related Files: Imakefile, libdataserv.a
*   Initial Coding Date: Sun May  2 22:49:23 CDT 1993
*           Portability: Standard (ANSI) C
*             Credit(s): Gregory Hance
*                        Southern Illinois University @ Edwardsville
*
** Copyright (C) 1993 SIUE - by Gregory Hance.
**
** Permission to use, copy, modify, and distribute this software and its
** documentation for any purpose and without fee is hereby granted, provided
** that the above copyright notice appear in all copies and that both that
** copyright notice and this permission notice appear in supporting
** documentation.  This software is provided "as is" without express or
** implied warranty.
**
* RCS (Revision Control System) Information
* ...Added automatically by RCS 
*
* $Log: tdm.c,v $
* Revision 1.6  1997/03/08 17:07:00  yawei
* Swaped CVIP_YES and CVIP_NO
*
* Revision 1.5  1997/03/08 01:01:08  yawei
* Name Changes:
* 	BOOLEAN ==> CVIP_BOOLEAN
* 	FALSE ==> CVIP_NO
* 	TRUE ==> CVIP_YES
* 	BYTE ==> CVIP_BYTE
* 	SHORT ==> CVIP_SHORT
* 	INTEGER ==> CVIP_INTEGER
* 	FLOAT ==> CVIP_FLOAT
* 	DOUBLE ==> CVIP_DOUBLE
* 	TYPE ==> CVIP_TYPE
*
* Revision 1.4  1997/01/16 21:31:12  yawei
* Global Change:  Image_FORMAT ==> IMAGE_FORMAT
*
 * Revision 1.3  1997/01/15  17:19:20  yawei
 * Global Change:  IMAGE ==> Image
 *
 * Revision 1.2  1997/01/15  16:37:16  yawei
 * updated changes
 *
 * Revision 1.1  1993/05/11  00:35:17  hanceg
 * Initial revision
 *
*
****************************************************************************/

/* Define Preprocessor statements */
#include "CVIPtoolkit.h"
#include "CVIPconvert.h"

main(argc,argv)
int argc;
char *argv[];
{
/* Declare variables local to main() */
Image *cvipImage;
IMAGE_FORMAT format;
char inputfile[50], outputfile[50];
const char *usage = "[infile] [outfile]", *fn = argv[0];
int argn=1;
double min, max;
CVIP_BOOLEAN display = CVIP_NO;

cvip_init( &argc, argv );

while ( argn < argc && argv[argn][0] == '-' && argv[argn][1] != '\0' ) {
   if ( cvip_keymatch( argv[argn], "-display", 2 ) )
      display = CVIP_YES;
   else
      cvip_usage( fn, usage );
   argn++;
}

if(argc > argn) {
   if ( (argv[argn][0] == '-' && argv[argn][1] != '\0') || sscanf( argv[argn], "%s", inputfile ) != 1 )
      cvip_usage( fn, usage );
   argn++;
   if ( argc > argn ) {
      if ( (argv[argn][0] == '-' && argv[argn][1] != '\0') || sscanf( argv[argn], "%s", outputfile ) != 1 )
         cvip_usage( fn, usage );
      argn++;
   }
   else
      (void) strcpy(outputfile, "-");
   if( argc != argn )
      cvip_usage( fn, usage );
}
else {
   (void) strcpy(inputfile, "-");
   (void) strcpy(outputfile, "-");
}

format = CVIPgetformat(inputfile);
cvipImage = CVIPreadimage(inputfile, format, 1);

cvipImage = condRemap_Image(cvipImage, CVIP_BYTE, 8.0, 255.0);

findMinVal_Image(cvipImage, &min);
findMaxVal_Image(cvipImage, &max);

fprintf(stderr,"min = %f\n", min);
fprintf(stderr,"max = %f\n", max);

setFileFormat_Image(cvipImage,PGM);

CVIPwriteimage(cvipImage, outputfile, CVIP_NO, CVIP_NO, format, 1);

if( display && strcmp(outputfile,"-") )
   cvip_display( outputfile, format );
else if( display )
   cvip_error(fn, "can not display an image directed to \"stdout\".");

image_free(cvipImage);
exit(0);
} /* End Main */

     
         





   
      
