/*****************************************************************************
Author: Kun Luo, John Creight
$log:$
*****************************************************************************/
#include "CVIPnoise.h"
#include <float.h>

/*we need to declare drand48 by ourselves when -Xc option is used*/
extern double drand48();

int gamma_noise_setup(Image *imageP)
	{
	float var;
	int alpha;
 
      	printf("Enter variance [typically 100 to 400] : ");
	scanf("%f",&var);
	printf("\nEnter alpha [typically 1 to 6; values > 1.3 are very slow] : ");
	scanf("%d",&alpha);
	printf("\n");
	return gamma_noise(imageP,&var,&alpha);
	}

int gamma_noise(Image *imageP,float *var,int *alpha)
	{
	byte *bP;
	int a,pix,x,y,z;
	unsigned bands,rows,cols;
	float theta,noise,pixf,Rx,Ry,A;
	float *fP;
	float fpix;

	bands=getNoOfBands_Image(imageP);
	rows=getNoOfRows_Image(imageP);
	cols=getNoOfCols_Image(imageP);

	A=sqrt((double)*var/(double)*alpha)/2;

       if(imageP->bandP[0]->data_type != CVIP_BYTE ){
	   if(imageP->bandP[0]->data_type != CVIP_FLOAT && cast_Image(imageP,CVIP_FLOAT)){
		fprintf(stderr,"Image is cast into float \n");
	   }
	   else if(imageP->bandP[0]->data_type != CVIP_FLOAT ){
		fprintf(stderr,"cast_Image failed..\n");
		return 0;
	   }
	   for(z=0;z<bands;z++)
		for(y=0;y<rows;y++)
			{
			fP=(float*)getRow_Image(imageP,y,z);
			for(x=0;x<cols;x++,fP++)
				{
				pixf=0.0;
				for(a=0;a<*alpha;a++)
					{
					noise=sqrt(-2*A*log(1.0-(float)drand48()));
					theta=(float)(drand48() * 6.28318530718 - 3.14159265359);
					Rx=noise*cos(theta);
					Ry=noise*sin(theta);
					noise=Rx*Rx+Ry*Ry;
					pixf=pixf+noise;
					}
                                 fpix=*fP+pixf+0.5;
  				*fP = fpix;

                               
				}
			}
	}
	else{
	for(z=0;z<bands;z++)
		for(y=0;y<rows;y++)
			{
			bP=(byte*)getRow_Image(imageP,y,z);
			for(x=0;x<cols;x++,bP++)
				{
				pixf=0.0;
				for(a=0;a<*alpha;a++)
					{
					noise=sqrt(-2*A*log(1.0-(float)drand48()));
					theta=(float)(drand48() * 6.28318530718 - 3.14159265359);
					Rx=noise*cos(theta);
					Ry=noise*sin(theta);
					noise=Rx*Rx+Ry*Ry;
					pixf=pixf+noise;
					}
                                 pix=(int)*bP+pixf+0.5;
  				*bP=(byte)trunc(pix);

                               
				}
			}
		}
	return 1;
	}


int gaussian_noise_setup(Image *imageP)
	{
        int V;
	float var,mean;

        printf("\n");
	printf("Enter variance [typically 100 to 400] : ");
	scanf("%f",&var);
	printf("\nEnter mean [mean > 0 will brighten, mean < 0 will darken image] : ");
	scanf("%f",&mean);
	printf("\n");
	return gaussian_noise(imageP,&var,&mean);
	}

int gaussian_noise(Image *imageP,float *var,float *mean)
	{
	byte *bP;
	int pix,x,y,z;
	unsigned bands,rows,cols;
	float noise,theta;
	float *fP;
	float fpix;

	bands=getNoOfBands_Image(imageP);
	rows=getNoOfRows_Image(imageP);
	cols=getNoOfCols_Image(imageP);

       if(imageP->bandP[0]->data_type != CVIP_BYTE ){
	   if(imageP->bandP[0]->data_type != CVIP_FLOAT && cast_Image(imageP,CVIP_FLOAT)){
		fprintf(stderr,"Image is cast into float \n");
	   }
	   else if(imageP->bandP[0]->data_type != CVIP_FLOAT ){
		fprintf(stderr,"cast_Image failed..\n");
		return 0;
	   }
	   for(z=0;z<bands;z++)
		for(y=0;y<rows;y++)
			{
			fP=(float*)getRow_Image(imageP,y,z);
			for(x=0;x<cols;x++,fP++)
				{
				noise=sqrt(-2*(*var)*log(1.0-(float)drand48()));
				theta=(float)(drand48() * 6.28318530718 - 3.14159265359);
				noise=noise*cos(theta);
				noise=noise+(*mean);
                 		fpix=*fP+noise+0.5;
                                *fP=fpix;
				}
			}

	}
	else{
	   for(z=0;z<bands;z++)
		for(y=0;y<rows;y++)
			{
			bP=(byte*)getRow_Image(imageP,y,z);
			for(x=0;x<cols;x++,bP++)
				{
				noise=sqrt(-2*(*var)*log(1.0-(float)drand48()));
				theta=(float)(drand48() * 6.28318530718 - 3.14159265359);
				noise=noise*cos(theta);
				noise=noise+(*mean);
                 		pix=(int)*bP+noise+0.5;
                                *bP=(byte)trunc(pix);
				}
			}
		}
	return 1;
	}


int neg_exp_noise_setup(Image *imageP)
	{
	float var;
	printf("Enter variance [typically 100 to 400] : ");
	scanf("%f",&var);
	printf("\n");
	return neg_exp_noise(imageP,&var);
	}

int neg_exp_noise(Image *imageP,float *var)
	{
	byte *bP;
	int a,pix,x,y,z;
	unsigned bands,rows,cols;
	float theta,noise,Rx,Ry,A;
	float *fP;
	float fpix;

bands=getNoOfBands_Image(imageP);
	rows=getNoOfRows_Image(imageP);
	cols=getNoOfCols_Image(imageP);

	A=(float)sqrt(*var)/2;

       if(imageP->bandP[0]->data_type != CVIP_BYTE ){
	   if(imageP->bandP[0]->data_type != CVIP_FLOAT && cast_Image(imageP,CVIP_FLOAT)){
		fprintf(stderr,"Image is cast into float \n");
	   }
	   else if(imageP->bandP[0]->data_type != CVIP_FLOAT ){
		fprintf(stderr,"cast_Image failed..\n");
		return 0;
	   }
	    for(z=0;z<bands;z++)
		for(y=0;y<rows;y++)
			{
			fP=(float*)getRow_Image(imageP,y,z);
			for(x=0;x<cols;x++,bP++)
				{
				noise=sqrt(-2*A*log(1.0-(float)drand48()));
				theta=(float)(drand48()*6.28318530718-3.14159365359);
				Rx=noise*cos(theta);
				Ry=noise*sin(theta);
				noise=Rx*Rx+Ry*Ry;
				fpix=*fP+noise+0.5;
				*fP=fpix;
				}
			}
	}
	else{
	    for(z=0;z<bands;z++)
		for(y=0;y<rows;y++)
			{
			bP=(byte*)getRow_Image(imageP,y,z);
			for(x=0;x<cols;x++,bP++)
				{
				noise=sqrt(-2*A*log(1.0-(float)drand48()));
				theta=(float)(drand48()*6.28318530718-3.14159365359);
				Rx=noise*cos(theta);
				Ry=noise*sin(theta);
				noise=Rx*Rx+Ry*Ry;
				pix=(int)*bP+noise+0.5;
				*bP=(byte)trunc(pix);
				}
			}
		}
	return 1;
	}

int rayleigh_noise_setup(Image *imageP)
	{
	float var;
	printf("Enter variance [typically 100 to 400] : ");
	scanf("%f",&var);
	printf("\n");
	return rayleigh_noise(imageP,&var);
	}

int rayleigh_noise(Image *imageP,float *var)
	{
	byte *bP;
	int a,pix,x,y,z;
	unsigned bands,rows,cols;
	float noise,pixf,A;
	float *fP;
	float fpix;

	bands=getNoOfBands_Image(imageP);
	rows=getNoOfRows_Image(imageP);
	cols=getNoOfCols_Image(imageP);

	A=2.3299*(*var);

       if(imageP->bandP[0]->data_type != CVIP_BYTE ){
	   if(imageP->bandP[0]->data_type != CVIP_FLOAT && cast_Image(imageP,CVIP_FLOAT)){
		fprintf(stderr,"Image is cast into float \n");
	   }
	   else if(imageP->bandP[0]->data_type != CVIP_FLOAT ){
		fprintf(stderr,"cast_Image failed..\n");
		return 0;
	   }
	    for(z=0;z<bands;z++)
		for(y=0;y<rows;y++)
			{
			fP=(float*)getRow_Image(imageP,y,z);
			for(x=0;x<cols;x++,fP++)
				{
				pixf=0.0;
				noise=sqrt(-2*A*log(1.0-(float)drand48()));
				pixf=pixf+noise;
				fpix=*fP+pixf+0.5;
				*fP=fpix;
				}
			}
	}
	else{
	    for(z=0;z<bands;z++)
		for(y=0;y<rows;y++)
			{
			bP=(byte*)getRow_Image(imageP,y,z);
			for(x=0;x<cols;x++,bP++)
				{
				pixf=0.0;
				noise=sqrt(-2*A*log(1.0-(float)drand48()));
				pixf=pixf+noise;
				pix=(int)*bP+pixf+0.5;
				*bP=(byte)trunc(pix);
				}
			}
		}
	return 1;
	}

int speckle_noise_setup(Image *imageP)
	{
	float ps,pp;
       	printf("Enter probabililty of high grey levels [typically .01 to .05] : ");
	scanf("%f",&ps);
	printf("\nEnter probability of low grey levels [typically .01 to .05] : ");
	scanf("%f",&pp);
	printf("\n");
	return speckle_noise(imageP,&ps,&pp);
	}

int speckle_noise(Image *imageP,float *psalt,float *ppepper)
	{
	byte *bP;
	int pix,x,y,z;
	unsigned bands,rows,cols;
	float noise,p,ps,pp;
	float *fP;
	float fpix;

	if(*psalt + *ppepper > 1.0){
		printf("Invalid probability values\n");
		return 0;
	}
	else
		{
		bands=getNoOfBands_Image(imageP);
		rows=getNoOfRows_Image(imageP);
		cols=getNoOfCols_Image(imageP);
		ps = 1 - *psalt;
		pp = *ppepper;
       if(imageP->bandP[0]->data_type != CVIP_BYTE ){
	   if(imageP->bandP[0]->data_type != CVIP_FLOAT && cast_Image(imageP,CVIP_FLOAT)){
		fprintf(stderr,"Image is cast into float \n");
	   }
	   else if(imageP->bandP[0]->data_type != CVIP_FLOAT ){
		fprintf(stderr,"cast_Image failed..\n");
		return 0;
	   }
		for(z=0;z<bands;z++)
			for(y=0;y<rows;y++)
				{
				fP=(float*)getRow_Image(imageP,y,z);
				for(x=0;x<cols;x++,fP++)
					{
					p=drand48();
					if(p>=ps) {*fP=FLT_MAX;}
					else{
						if(p<pp) *fP=FLT_MIN;
					}
				}
			}
	}
	else{
		for(z=0;z<bands;z++)
			for(y=0;y<rows;y++)
				{
				bP=(byte*)getRow_Image(imageP,y,z);
				for(x=0;x<cols;x++,bP++)
					{
					p=drand48();
					if(p>=ps) {*bP=255;}
					else{
						if(p<pp) *bP=0;}
					}
				}
			}
		}
	return 1;
	}




int uniform_noise_setup(Image *imageP)
	{
	float var,mean; 
      	printf("Enter variance [typically 100 to 400] : ");
	scanf("%f",&var);
	printf("\nEnter mean [mean > 0 will brighten, mean < 0 will darken image] : ");
	scanf("%f",&mean);
	printf("\n");
	return uniform_noise(imageP,&var,&mean);
	}


int uniform_noise(Image *imageP,float *var,float *mean)
	{
	byte *bP;
	int pix,x,y,z;
	unsigned bands,rows,cols;
	float noise;
	float *fP;
	float fpix;

	bands=getNoOfBands_Image(imageP);
	rows=getNoOfRows_Image(imageP);
	cols=getNoOfCols_Image(imageP);

       if(imageP->bandP[0]->data_type != CVIP_BYTE ){
	   if(imageP->bandP[0]->data_type != CVIP_FLOAT && cast_Image(imageP,CVIP_FLOAT)){
		fprintf(stderr,"Image is cast into float \n");
	   }
	   else if(imageP->bandP[0]->data_type != CVIP_FLOAT ){
		fprintf(stderr,"cast_Image failed..\n");
		return 0;
	   }
	    for(z=0;z<bands;z++)
		for(y=0;y<rows;y++)
			{
			fP=(float*)getRow_Image(imageP,y,z);
			for(x=0;x<cols;x++,fP++)
				{
				noise=sqrt((double)(*var))*(1.057192E-4*(float)rand()-1.7320508)+(*mean);

                                 fpix=*fP+noise+0.5;
				 *fP=fpix;

				}
			}
	}
	else{
	    for(z=0;z<bands;z++)
		for(y=0;y<rows;y++)
			{
			bP=(byte*)getRow_Image(imageP,y,z);
			for(x=0;x<cols;x++,bP++)
				{
				noise=sqrt((double)(*var))*(1.057192E-4*(float)rand()-1.7320508)+(*mean);

                                 pix=(int)*bP+noise+0.5;
				*bP=(byte)trunc(pix);

				}
			}
		}
	return 1;
	}



 
